/*
Analysis module.
*/var exports, misc, util, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).analysis || (_base.analysis = {}), exports = window.lastName.analysis, misc = window.lastName.misc, util = window.lastName.util) : (exports = module.exports, misc = require("./misc"), util = require("./util")), function(exports, misc, util) {
  return exports.analyse = function(text, plugins) {
    var f, postFilter, preFilters, result, _i, _j, _len, _len2;
    plugins == null && (plugins = []), result = {}, misc.preFilter(text, result), preFilters = plugins.filter(function(plugin) {
      return "function" == typeof plugin.preFilter;
    }), postFilter = plugins.filter(function(plugin) {
      return "function" == typeof plugin.postFilter;
    });
    for (_i = 0, _len = preFilters.length; _i < _len; _i++) f = preFilters[_i], f.preFilter(text, result);
    for (_j = 0, _len2 = postFilter.length; _j < _len2; _j++) f = postFilter[_j], f.postFilter(text, result);
    return result.version = util.version, result;
  };
}(exports, misc, util);

var __slice = Array.prototype.slice;

(function(lastname) {
  return lastname.version = "0.3.5", lastname.findProperName = function() {
    var args, inclines, lang;
    return lang = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [], inclines = lastname.plugins["" + lang].inclines, inclines.findProperName.apply(this, args);
  };
})(window.lastName || (window.lastName = {}));

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).misc || (_base.misc = {}), exports = window.lastName.misc) : exports = module.exports, function(exports) {
  return exports.preFilter = function(text, result) {
    var chars_total, emo, emoticons, findEmo, ind, punctuationRe, sentences, signs, signs_total, spaces_total, tempTxt, word_length_mid, words_total, _i, _len;
    signs = text.match(/[-\+=\/\.,\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]{1}/g), signs_total = signs && signs.length || 0, spaces_total = /\s/.test(text) ? text.match(/\s/g).length : 0, chars_total = text.length, words_total = text.split(/\s/).filter(function(wrd) {
      return wrd.length > 0 && !/^[-\+=\/\.\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]+$/.test(wrd);
    }).length, word_length_mid = words_total ? (chars_total - spaces_total - signs_total) / words_total : 0, emoticons = [ ":-)", "(-:", ":o)", ":)", "(:", ":->", ":-}", ":-t", ":*)", ":-)))", ":-D", "(-D", ":'-)", "%-)", ":-/", ":-I", ":~)", "(:-(", ":-(", ":-c", ":-(((", ":-<", ">:-(", ":-[", "(:-&", "%-(", ">:-<", "~ :-(", "%-(", ":/)", ":-|", ":-e", ":-X", ":-v", ":-I", ":-8(", ":-O", ":-@", ":,-(", ":'-(", "~:-o", "]:-)>", "):-)", ";->", ":-x", ":-*", "8-]", ":-J", ":-&", ":-p", ":-P", ";-)", ";)", "'-)", ":-7", "?-(", "B-D", ":-B", ":-*)", ":-9", "|-p", ":-b", "-]:-)[-", "8-I", "8-|", "|:-|", ":-]", "|-)", "|-I", "I^o", "|-O", ':-"', ":-s", ":-#", ":-!", ":-()", ":-D", "(:-$", ":-(*)", ":-')", ":-R", "%+|", "%+{", "X-(", "<:-)", "*:o)", "@;-)", "X:-)", ":>)", "&:-)", "#:-)", "8-)", "8:-)", "B-)", "B-]", "O:-)", "&8-|", ":-{", ":-)}", ":-)#", ":-Q", ":-I", ":-d~", ":-?", ":-/I", ":-) X", "{(:-)", ":-{}", "[:-)", "d :-o", "~:-(", "~~:-(", "))", "(:-I", "3:-o", "[: |]", "M-)", ":X)", ":-M", "*8((:", "O+", "O->", "||*(", "||*)", "<{:-)}", "(-: :-)", "@->-", "@==", "<')))))- <" ], emoticons.sort(function(a, b) {
      return b.length - a.length;
    }), tempTxt = text.slice(0), findEmo = [];
    for (_i = 0, _len = emoticons.length; _i < _len; _i++) {
      emo = emoticons[_i], ind = 0;
      while (ind >= 0) ind = tempTxt.indexOf(emo, ind), ind !== -1 && (findEmo.push(emo), tempTxt = tempTxt.replace(emo, ""), ind -= emo.length + 2);
    }
    return punctuationRe = /(https?\:\/\/.*[\s$])|(\.\s)|(,\s)|(\s\:)|(:\s)|(\s\/)|(\/\s)|(\s\\)(\\\s)|\?|!|\+|\'|\"|«|»|\*|\(|\)|\[|\]|\&|\№|“|”|\—/g, tempTxt = text.replace(punctuationRe, " $& ").replace(/\s+/g, " "), /[\?\!\.]\s{0,}$/.test(tempTxt) || (tempTxt += " . "), sentences = tempTxt.replace(/\s\?\s/gm, " ?? ").replace(/\s\!\s/gm, " !! ").replace(/\s\.\s/gm, " .. ").split(/[\?\!\.](\s+|$)/gm).filter(function(s) {
      return !/^\s{0,}$/.test(s);
    }), result.misc = {
      digits: util.arrayToDict(text.match(/-?((\d+[\.,]\d+)|(\d+))/ig) || []),
      emoticons: util.arrayToDict(findEmo),
      sentences: sentences
    }, result.counters = {
      chars_total: chars_total,
      words_total: words_total,
      signs_total: signs_total,
      spaces_total: spaces_total,
      word_length_mid: word_length_mid,
      words_in_sentence_mid: sentences.length ? words_total / sentences.length : 0
    }, result;
  };
}(exports);

var exports, _base, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).util || (_base.util = {}), exports = window.lastName.util) : exports = module.exports, function(exports) {
  var capitalize, dictKeys, intersection, isCapitalized, isLowerCase, isUpperCase, merge, unique;
  return exports.version = "0.3.17", exports.capitalize = capitalize = function(s) {
    if (s) return "" + s[0].toUpperCase() + s.slice(1).toLowerCase();
  }, exports.dictKeys = dictKeys = function(dict) {
    var k, keys, v;
    keys = [];
    for (k in dict) v = dict[k], keys.push(k);
    return keys;
  }, exports.isCapitalized = isCapitalized = function(word) {
    var cap;
    return 0 <= word.indexOf("-") ? (cap = !0, word.split("-").map(function(wrd) {
      return cap && (cap = isCapitalized(wrd));
    }), cap) : word && word === capitalize(word) || !1;
  }, exports.isUpperCase = isUpperCase = function(word) {
    return word === word.toUpperCase();
  }, exports.isLowerCase = isLowerCase = function(word) {
    return word === word.toLowerCase();
  }, exports.unique = unique = function(array) {
    var key, output, value, _ref, _results;
    output = {};
    for (key = 0, _ref = array.length; 0 <= _ref ? key < _ref : key > _ref; 0 <= _ref ? key++ : key--) output[array[key]] = array[key];
    _results = [];
    for (key in output) value = output[key], _results.push(value);
    return _results;
  }, exports.merge = merge = function(l1, l2) {
    var l;
    return l = [], l1.map(function(x) {
      return l.push(x);
    }), l2.map(function(x) {
      return l.push(x);
    }), unique(l);
  }, exports.intersection = intersection = function(l1, l2) {
    var i, _i, _len;
    for (_i = 0, _len = l1.length; _i < _len; _i++) {
      i = l1[_i];
      if (__indexOf.call(l2, i) >= 0) return i;
    }
    return null;
  }, exports.arrayToDict = function(arr) {
    var d, i, _i, _len;
    d = {};
    for (_i = 0, _len = arr.length; _i < _len; _i++) i = arr[_i], d[i] ? d[i]++ : d[i] = 1;
    return d;
  };
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.ref = {}, exports = window.lastName.plugins.ru.ref) : exports = module.exports, function(exports) {
  return exports.ruFemaleNamesDict = {
    "альвина": 1,
    "анелия": 1,
    "августа": 1,
    "августина": 1,
    "авдотья": 1,
    "авелина": 1,
    "аврелия": 1,
    "аврора": 1,
    "агапия": 1,
    "агата": 1,
    "агафья": 1,
    "агафия": 1,
    "аглаида": 1,
    "аглая": 1,
    "агнеса": 1,
    "агнесса": 1,
    "агния": 1,
    "агриппмеа": 1,
    "агрефена": 1,
    "ада": 1,
    "адина": 1,
    "адель": 1,
    "аделия": 1,
    "аделаида": 1,
    "аза": 1,
    "азалия": 1,
    "аида": 1,
    "айседора": 1,
    "айсылу": 1,
    "акилина": 1,
    "акулина": 1,
    "аксинья": 1,
    "алевтина": 1,
    "александра": 1,
    "алеся": 1,
    "алена": 1,
    "алина": 1,
    "алиса": 1,
    "алия": 1,
    "алла": 1,
    "алика": 1,
    "альбина": 1,
    "альмир": 1,
    "альфия": 1,
    "амина": 1,
    "анастасия": 1,
    "анатолия": 1,
    "ангелина": 1,
    "анжела": 1,
    "анимаиса": 1,
    "анисия": 1,
    "анисья": 1,
    "анна": 1,
    "анита": 1,
    "антонина": 1,
    "антонида": 1,
    "антония": 1,
    "анфиса": 1,
    "анфуса": 1,
    "анфия": 1,
    "амира": 1,
    "аполлинария": 1,
    "аревик": 1,
    "ариадна": 1,
    "арина": 1,
    "аркадия": 1,
    "арсения": 1,
    "арсиана": 1,
    "артемия": 1,
    "асель": 1,
    "аста": 1,
    "астра": 1,
    "астрид": 1,
    "афанасия": 1,
    "афродита": 1,
    "аэлита": 1,
    "аэлла": 1,
    "амалия": 1,
    "бажена": 1,
    "беата": 1,
    "беатриса": 1,
    "бела": 1,
    "белла": 1,
    "беллатриса": 1,
    "берта": 1,
    "богдана": 1,
    "божена": 1,
    "болеслава": 1,
    "борислава": 1,
    "бриджет": 1,
    "бронислава": 1,
    "валентина": 1,
    "валерия": 1,
    "ванда": 1,
    "варвара": 1,
    "василина": 1,
    "василиса": 1,
    "васса": 1,
    "вацлава": 1,
    "вевея": 1,
    "велора": 1,
    "велория": 1,
    "венера": 1,
    "вера": 1,
    "вероника": 1,
    "веселина": 1,
    "веста": 1,
    "видана": 1,
    "викторина": 1,
    "виктория": 1,
    "вилена": 1,
    "виола": 1,
    "виолетта": 1,
    "виоланта": 1,
    "виринея": 1,
    "вита": 1,
    "виталия": 1,
    "виталина": 1,
    "виулена": 1,
    "влада": 1,
    "владилена": 1,
    "владимира": 1,
    "владислава": 1,
    "владлена": 1,
    "власта": 1,
    "воля": 1,
    "всеслава": 1,
    "гайя": 1,
    "гали": 1,
    "галина": 1,
    "ганна": 1,
    "гаяна": 1,
    "гаяния": 1,
    "гвинет": 1,
    "гелена": 1,
    "гелия": 1,
    "гелла": 1,
    "генриетта": 1,
    "гертруда": 1,
    "глафира": 1,
    "гликерия": 1,
    "глория": 1,
    "голуба": 1,
    "горислава": 1,
    "гюльанэ": 1,
    "гюльнара": 1,
    "гюльчитай": 1,
    "даздраперма": 1,
    "дайна": 1,
    "дана": 1,
    "дарья": 1,
    "дария": 1,
    "дарина": 1,
    "дарьяна": 1,
    "декабрина": 1,
    "дея": 1,
    "дия": 1,
    "джиневра": 1,
    "дженнифер": 1,
    "джульета": 1,
    "дианна": 1,
    "дилия": 1,
    "диля": 1,
    "дильфуза": 1,
    "дина": 1,
    "диния": 1,
    "диодора": 1,
    "дионисия": 1,
    "добрава": 1,
    "домна": 1,
    "домина": 1,
    "домника": 1,
    "доминика": 1,
    "донара": 1,
    "дорофея": 1,
    "доротея": 1,
    "ева": 1,
    "евгения": 1,
    "евдокия": 1,
    "евлалия": 1,
    "евлампия": 1,
    "евпраксия": 1,
    "евстолия": 1,
    "евфалия": 1,
    "евфросиния": 1,
    "екатерина": 1,
    "елена": 1,
    "елизавета": 1,
    "еликонида": 1,
    "ермиония": 1,
    "есения": 1,
    "ефимия": 1,
    "евфремия": 1,
    "жанна": 1,
    "ждана": 1,
    "жаннэ": 1,
    "жасмина": 1,
    "забава": 1,
    "заира": 1,
    "зара": 1,
    "зарема": 1,
    "зарина": 1,
    "зорина": 1,
    "заряна": 1,
    "зауре": 1,
    "звенислава": 1,
    "земфира": 1,
    "зиля": 1,
    "зинаида": 1,
    "зиновия": 1,
    "злата": 1,
    "зозан": 1,
    "зоя": 1,
    "зульфия": 1,
    "иванна": 1,
    "ида": 1,
    "илария": 1,
    "илиана": 1,
    "илона": 1,
    "ильмира": 1,
    "инга": 1,
    "индира": 1,
    "инесса": 1,
    "инна": 1,
    "иоанна": 1,
    "иона": 1,
    "ипатия": 1,
    "ипполита": 1,
    "ирада": 1,
    "ираида": 1,
    "ирена": 1,
    "ироида": 1,
    "ираклия": 1,
    "ирина": 1,
    "исидора": 1,
    "искра": 1,
    "ифигения": 1,
    "ия": 1,
    "кадрия": 1,
    "кермен": 1,
    "калиса": 1,
    "каллиста": 1,
    "камилла": 1,
    "камила": 1,
    "капитолина": 1,
    "карина": 1,
    "каролина": 1,
    "катерина": 1,
    "кира": 1,
    "кирилла": 1,
    "клавдия": 1,
    "клара": 1,
    "клариса": 1,
    "кларисса": 1,
    "клеопатра": 1,
    "клио": 1,
    "клер": 1,
    "конкордия": 1,
    "констанция": 1,
    "кристина": 1,
    "ксения": 1,
    "лавиния": 1,
    "лада": 1,
    "лана": 1,
    "лариса": 1,
    "лаура": 1,
    "лейла": 1,
    "лема": 1,
    "лена": 1,
    "лениана": 1,
    "ленина": 1,
    "леонида": 1,
    "леонила": 1,
    "леонтия": 1,
    "леся": 1,
    "ливия": 1,
    "лидия": 1,
    "лилиана": 1,
    "лилия": 1,
    "лилит": 1,
    "лина": 1,
    "лира": 1,
    "лия": 1,
    "лея": 1,
    "лора": 1,
    "луиза": 1,
    "лукерия": 1,
    "лукиана": 1,
    "лукина": 1,
    "люцина": 1,
    "лусинэ": 1,
    "любава": 1,
    "любовь": 1,
    "любомира": 1,
    "людмила": 1,
    "ляля": 1,
    "мавра": 1,
    "магда": 1,
    "магдалина": 1,
    "мадлен": 1,
    "майя": 1,
    "мая": 1,
    "мальвина": 1,
    "маргарита": 1,
    "мариана": 1,
    "марьяна": 1,
    "марианна": 1,
    "мариетта": 1,
    "мариэтта": 1,
    "марика": 1,
    "марина": 1,
    "мария": 1,
    "марья": 1,
    "мари": 1,
    "марлен": 1,
    "марлена": 1,
    "марта": 1,
    "марфа": 1,
    "матильда": 1,
    "матрена": 1,
    "матрёна": 1,
    "матрона": 1,
    "мелания": 1,
    "меланья": 1,
    "мелитина": 1,
    "милада": 1,
    "милана": 1,
    "милен": 1,
    "милица": 1,
    "милия": 1,
    "милослава": 1,
    "мира": 1,
    "мирра": 1,
    "мирослава": 1,
    "митродора": 1,
    "млада": 1,
    "мстислава": 1,
    "нада": 1,
    "надежда": 1,
    "надия": 1,
    "наина": 1,
    "наира": 1,
    "нана": 1,
    "настасья": 1,
    "наталья": 1,
    "наталия": 1,
    "нелли": 1,
    "неонила": 1,
    "ника": 1,
    "нина": 1,
    "нинелла": 1,
    "нинель": 1,
    "новелла": 1,
    "нонна": 1,
    "нора": 1,
    "нуркыз": 1,
    "насиба": 1,
    "оксана": 1,
    "октавия": 1,
    "октябрина": 1,
    "олеся": 1,
    "оливия": 1,
    "олимпиада": 1,
    "олимпия": 1,
    "ольга": 1,
    "офелия": 1,
    "павла": 1,
    "павлина": 1,
    "патриция": 1,
    "пелагея": 1,
    "платонида": 1,
    "поликсена": 1,
    "полина": 1,
    "правдина": 1,
    "прасковья": 1,
    "пенелопа": 1,
    "полислава": 1,
    "рада": 1,
    "радмила": 1,
    "раиса": 1,
    "раймонда": 1,
    "раялла": 1,
    "ревмира": 1,
    "регина": 1,
    "рената": 1,
    "римма": 1,
    "рогнеда": 1,
    "роза": 1,
    "розалина": 1,
    "розалия": 1,
    "розана": 1,
    "роксан": 1,
    "ростислава": 1,
    "руслана": 1,
    "руфина": 1,
    "руфь": 1,
    "раида": 1,
    "сабина": 1,
    "сабрина": 1,
    "саломея": 1,
    "соломея": 1,
    "самира": 1,
    "светлана": 1,
    "светозара": 1,
    "светослава": 1,
    "свобода": 1,
    "святослава": 1,
    "севастьяна": 1,
    "северина": 1,
    "селена": 1,
    "селина": 1,
    "селестина": 1,
    "серафима": 1,
    "сергияна": 1,
    "сильва": 1,
    "агриппина": 1,
    "алёна": 1,
    "вилора": 1,
    "вилория": 1,
    "джульетта": 1,
    "диана": 1,
    "евфимия": 1,
    "ефросиния": 1,
    "калерия": 1,
    "милена": 1,
    "муза": 1,
    "савина": 1,
    "сильвия": 1,
    "симона": 1,
    "слава": 1,
    "славяна": 1,
    "снежана": 1,
    "софья": 1,
    "софия": 1,
    "станислава": 1,
    "стелла": 1,
    "степанида": 1,
    "стефанида": 1,
    "стефания": 1,
    "сусанна": 1,
    "сосанна": 1,
    "сюзанна": 1,
    "таира": 1,
    "таисия": 1,
    "тальяна": 1,
    "тамара": 1,
    "тамила": 1,
    "томила": 1,
    "татьяна": 1,
    "текуса": 1,
    "тереза": 1,
    "улита": 1,
    "ульяна": 1,
    "услада": 1,
    "устинья": 1,
    "фаина": 1,
    "февронья": 1,
    "феликсана": 1,
    "фелицата": 1,
    "фелицитата": 1,
    "фелиция": 1,
    "федора": 1,
    "феодора": 1,
    "феодосия": 1,
    "феодосья": 1,
    "феоктиста": 1,
    "феофания": 1,
    "феона": 1,
    "флавия": 1,
    "флора": 1,
    "флория": 1,
    "флорентина": 1,
    "флоренция": 1,
    "флориана": 1,
    "фотина": 1,
    "харита": 1,
    "харитина": 1,
    "хиония": 1,
    "христина": 1,
    "цецилия": 1,
    "чеслава": 1,
    "эвелина": 1,
    "эвридика": 1,
    "эдда": 1,
    "элеонора": 1,
    "элина": 1,
    "эльвира": 1,
    "эльмира": 1,
    "эльза": 1,
    "эмилия": 1,
    "эмма": 1,
    "эрика": 1,
    "эсфирь": 1,
    "юдифь": 1,
    "юзефа": 1,
    "юлиана": 1,
    "юлитта": 1,
    "юлия": 1,
    "юманита": 1,
    "юния": 1,
    "юнона": 1,
    "юстина": 1,
    "ядвига": 1,
    "яна": 1,
    "янина": 1,
    "яромира": 1,
    "ярослава": 1
  }, exports.ruMaleNamesDict = {
    "ааран": 1,
    "аарен": 1,
    "ааррон": 1,
    "аб": 1,
    "аббат": 1,
    "абботт": 1,
    "абей": 1,
    "абелл": 1,
    "абель": 1,
    "абнар": 1,
    "абнер": 1,
    "абнор": 1,
    "абот": 1,
    "аботт": 1,
    "абрам": 1,
    "абран": 1,
    "абрахам": 1,
    "абсалон": 1,
    "авангард": 1,
    "август": 1,
    "августин": 1,
    "авдей": 1,
    "авдий": 1,
    "авенир": 1,
    "аверилл": 1,
    "аверкий": 1,
    "авксентий": 1,
    "аврам": 1,
    "аврор": 1,
    "аврорий": 1,
    "агап": 1,
    "аггей": 1,
    "агей": 1,
    "адам": 1,
    "аддам": 1,
    "аддисон": 1,
    "аден": 1,
    "адий": 1,
    "адисон": 1,
    "адиссон": 1,
    "адлэй": 1,
    "адней": 1,
    "адольф": 1,
    "адонис": 1,
    "адриан": 1,
    "адэйр": 1,
    "адэр": 1,
    "азия": 1,
    "азэлстан": 1,
    "айбл": 1,
    "айзек": 1,
    "айк": 1,
    "ак": 1,
    "акей": 1,
    "акерлеа": 1,
    "акерлей": 1,
    "акерли": 1,
    "аки": 1,
    "аким": 1,
    "аклеа": 1,
    "аклей": 1,
    "акли": 1,
    "аксён": 1,
    "актон": 1,
    "акэль": 1,
    "алан": 1,
    "аластеир": 1,
    "аластэйр": 1,
    "алвар": 1,
    "алвен": 1,
    "алви": 1,
    "алвин": 1,
    "алвис": 1,
    "алгар": 1,
    "алджернон": 1,
    "алевтин": 1,
    "алеистер": 1,
    "алек": 1,
    "алекс": 1,
    "александр": 1,
    "алексей": 1,
    "ален": 1,
    "алестер": 1,
    "алжир": 1,
    "алик": 1,
    "аликс": 1,
    "алим": 1,
    "алисандр": 1,
    "алисдэйр": 1,
    "алиссандр": 1,
    "алистер": 1,
    "алистэйр": 1,
    "аллан": 1,
    "аллен": 1,
    "аллин": 1,
    "аллистер": 1,
    "аллистир": 1,
    "аллистэйр": 1,
    "алтон": 1,
    "алф": 1,
    "алфонзо": 1,
    "алфорд": 1,
    "алфрид": 1,
    "альберт": 1,
    "альбин": 1,
    "альвиан": 1,
    "альвин": 1,
    "альдина": 1,
    "альпин": 1,
    "альтаир": 1,
    "альфа": 1,
    "альфи": 1,
    "альфред": 1,
    "алэйстер": 1,
    "алэйстэйр": 1,
    "амби": 1,
    "амброуз": 1,
    "амедеус": 1,
    "амиас": 1,
    "амори": 1,
    "амос": 1,
    "амьяс": 1,
    "анакин": 1,
    "ананий": 1,
    "анастасий": 1,
    "анатолий": 1,
    "анвар": 1,
    "ангел": 1,
    "ангес": 1,
    "андерсон": 1,
    "анджелл": 1,
    "андрей": 1,
    "андреян": 1,
    "андриан": 1,
    "андрон": 1,
    "анж": 1,
    "анис": 1,
    "анисий": 1,
    "анисим": 1,
    "анри": 1,
    "анском": 1,
    "анскомб": 1,
    "ансон": 1,
    "антван": 1,
    "антип": 1,
    "антон": 1,
    "антоний": 1,
    "антонин": 1,
    "антуан": 1,
    "аполлинарий": 1,
    "аполлон": 1,
    "арам": 1,
    "арвид": 1,
    "аргент": 1,
    "арден": 1,
    "арефий": 1,
    "арий": 1,
    "арик": 1,
    "арил": 1,
    "арин": 1,
    "аристарх": 1,
    "аркадий": 1,
    "аркелл": 1,
    "арлен": 1,
    "арли": 1,
    "арман": 1,
    "армен": 1,
    "арн": 1,
    "арне": 1,
    "арни": 1,
    "арнольд": 1,
    "арран": 1,
    "аррин": 1,
    "аррон": 1,
    "арсен": 1,
    "арсений": 1,
    "арт": 1,
    "артамон": 1,
    "артемий": 1,
    "арти": 1,
    "артур": 1,
    "артём": 1,
    "архип": 1,
    "арчи": 1,
    "арчибальд": 1,
    "аселет": 1,
    "аселин": 1,
    "асер": 1,
    "аскольд": 1,
    "астон": 1,
    "атеист": 1,
    "афанасий": 1,
    "афиноген": 1,
    "афтон": 1,
    "аффтон": 1,
    "ахмат": 1,
    "ахмет": 1,
    "ачилл": 1,
    "аш": 1,
    "ашер": 1,
    "ашот": 1,
    "аштон": 1,
    "баграт": 1,
    "бад": 1,
    "бадди": 1,
    "бажен": 1,
    "баз": 1,
    "базилик": 1,
    "байрон": 1,
    "байярд": 1,
    "бак": 1,
    "бакстер": 1,
    "балдер": 1,
    "балдрик": 1,
    "бамби": 1,
    "баптист": 1,
    "бардолф": 1,
    "барии": 1,
    "барклей": 1,
    "барнабас": 1,
    "барни": 1,
    "барнэби": 1,
    "барретт": 1,
    "барри": 1,
    "барт": 1,
    "бартоломей": 1,
    "бассетт": 1,
    "бастер": 1,
    "бастиан": 1,
    "батч": 1,
    "баян": 1,
    "беван": 1,
    "беверли": 1,
    "бевис": 1,
    "бедивир": 1,
    "бейб": 1,
    "бейлей": 1,
    "бейлие": 1,
    "бен": 1,
    "бенджамин": 1,
    "бенджи": 1,
    "бенедикт": 1,
    "бенет": 1,
    "беннетт": 1,
    "бенни": 1,
    "бенние": 1,
    "бенсон": 1,
    "бентлей": 1,
    "бентон": 1,
    "беорегард": 1,
    "бердт": 1,
    "беренгар": 1,
    "беренджер": 1,
    "берет": 1,
    "бернард": 1,
    "берни": 1,
    "берри": 1,
    "берт": 1,
    "берти": 1,
    "бертольд": 1,
    "бертон": 1,
    "бертрам": 1,
    "бертран": 1,
    "бивис": 1,
    "билл": 1,
    "билли": 1,
    "бисш": 1,
    "биф": 1,
    "блейн": 1,
    "близэ": 1,
    "блисс": 1,
    "блэйз": 1,
    "блэйк": 1,
    "блэйн": 1,
    "блэр": 1,
    "боб": 1,
    "бобби": 1,
    "богдан": 1,
    "боеслав": 1,
    "болдуин": 1,
    "болеслав": 1,
    "боллард": 1,
    "бомонт": 1,
    "бонифэйс": 1,
    "боримир": 1,
    "борис": 1,
    "борислав": 1,
    "боян": 1,
    "брадлей": 1,
    "браеден": 1,
    "брайен": 1,
    "брайон": 1,
    "бранден": 1,
    "брандон": 1,
    "браннон": 1,
    "брейден": 1,
    "брейдн": 1,
    "брендан": 1,
    "бренден": 1,
    "брендон": 1,
    "бреннан": 1,
    "брент": 1,
    "брентон": 1,
    "брет": 1,
    "бретт": 1,
    "бриар": 1,
    "брион": 1,
    "брис": 1,
    "бриско": 1,
    "бриттон": 1,
    "бриэм": 1,
    "бродерик": 1,
    "броди": 1,
    "броз": 1,
    "брок": 1,
    "бронислав": 1,
    "бронт": 1,
    "броуди": 1,
    "броук": 1,
    "брук": 1,
    "брукс": 1,
    "бруно": 1,
    "брутус": 1,
    "брьянт": 1,
    "брэд": 1,
    "брэди": 1,
    "брэдфорд": 1,
    "брэйден": 1,
    "брэйди": 1,
    "брэм": 1,
    "брэн": 1,
    "брюс": 1,
    "брююс": 1,
    "будимир": 1,
    "буз": 1,
    "букер": 1,
    "булат": 1,
    "бью": 1,
    "бэйли": 1,
    "вавила": 1,
    "вадим": 1,
    "вал": 1,
    "валентайн": 1,
    "валентин": 1,
    "валериан": 1,
    "валерий": 1,
    "валерьян": 1,
    "вальдемар": 1,
    "вальтер": 1,
    "ванадий": 1,
    "вард": 1,
    "варлаам": 1,
    "варлам": 1,
    "варлен": 1,
    "вартан": 1,
    "варфоломей": 1,
    "василий": 1,
    "василько": 1,
    "ваухан": 1,
    "вахтанг": 1,
    "вацлав": 1,
    "вашингтон": 1,
    "вебстер": 1,
    "велдон": 1,
    "велимир": 1,
    "велислав": 1,
    "велор": 1,
    "велорий": 1,
    "венедикт": 1,
    "вениамин": 1,
    "вер": 1,
    "вергилий": 1,
    "верджил": 1,
    "верн": 1,
    "вернон": 1,
    "вестер": 1,
    "вестлей": 1,
    "вестон": 1,
    "вик": 1,
    "викентий": 1,
    "виктор": 1,
    "вил": 1,
    "вилберн": 1,
    "вилей": 1,
    "вилен": 1,
    "вилий": 1,
    "вилиор": 1,
    "вилки": 1,
    "вилл": 1,
    "вилли": 1,
    "виллоби": 1,
    "вилмар": 1,
    "вилмер": 1,
    "вилмот": 1,
    "вилор": 1,
    "вилорг": 1,
    "вилорий": 1,
    "вилсон": 1,
    "вилф": 1,
    "вилфорд": 1,
    "виль": 1,
    "вильгельм": 1,
    "вильтон": 1,
    "вильям": 1,
    "вин": 1,
    "виндзор": 1,
    "винни": 1,
    "винс": 1,
    "винсент": 1,
    "винслоу": 1,
    "винтроп": 1,
    "винцент": 1,
    "виолен": 1,
    "вирджиль": 1,
    "виссарион": 1,
    "вистан": 1,
    "виталий": 1,
    "витейкр": 1,
    "витней": 1,
    "витольд": 1,
    "влад": 1,
    "владелин": 1,
    "владилен": 1,
    "владимир": 1,
    "владислав": 1,
    "владлен": 1,
    "влас": 1,
    "власий": 1,
    "воган": 1,
    "вогн": 1,
    "воин": 1,
    "воислав": 1,
    "волдо": 1,
    "волемир": 1,
    "волкер": 1,
    "воллис": 1,
    "володар": 1,
    "вольдемар": 1,
    "вольмир": 1,
    "вольт": 1,
    "вольф": 1,
    "вольфрам": 1,
    "воспой": 1,
    "всеволод": 1,
    "всемил": 1,
    "вуди": 1,
    "вудроу": 1,
    "вулф": 1,
    "вьятт": 1,
    "вэйд": 1,
    "вэйланд": 1,
    "вэнс": 1,
    "вячеслав": 1,
    "габби": 1,
    "габриель": 1,
    "габриэль": 1,
    "гавриил": 1,
    "гаврил": 1,
    "гаврила": 1,
    "гаврило": 1,
    "гай": 1,
    "гайдар": 1,
    "гайлс": 1,
    "галактион": 1,
    "гален": 1,
    "галий": 1,
    "гамильтон": 1,
    "гамлет": 1,
    "гантэр": 1,
    "гаральд": 1,
    "гарван": 1,
    "гарей": 1,
    "гарибальди": 1,
    "гарланд": 1,
    "гарнет": 1,
    "гарольд": 1,
    "гарри": 1,
    "гаррий": 1,
    "гарс": 1,
    "гарфилд": 1,
    "гас": 1,
    "гаспар": 1,
    "гваделупа": 1,
    "гвидон": 1,
    "гейб": 1,
    "гейл": 1,
    "гейр": 1,
    "гектор": 1,
    "гелеон": 1,
    "гелиан": 1,
    "гелий": 1,
    "ген": 1,
    "гений": 1,
    "геннадий": 1,
    "генри": 1,
    "генрих": 1,
    "геодар": 1,
    "георгий": 1,
    "геральд": 1,
    "герасим": 1,
    "герберт": 1,
    "герман": 1,
    "гермоген": 1,
    "герольд": 1,
    "геронт": 1,
    "геронтий": 1,
    "герт": 1,
    "гертруд": 1,
    "гидеон": 1,
    "гильберт": 1,
    "гисберт": 1,
    "гладвин": 1,
    "гланвилл": 1,
    "глеб": 1,
    "глендауэр": 1,
    "гленн": 1,
    "глэн": 1,
    "говард": 1,
    "годвин": 1,
    "годфри": 1,
    "голлагэр": 1,
    "голладжер": 1,
    "гомер": 1,
    "горазд": 1,
    "гораций": 1,
    "горд": 1,
    "гордей": 1,
    "горден": 1,
    "гордий": 1,
    "гордон": 1,
    "горимир": 1,
    "горислав": 1,
    "горн": 1,
    "граем": 1,
    "грай": 1,
    "гранвилл": 1,
    "гранд": 1,
    "гранит": 1,
    "грахэйм": 1,
    "грег": 1,
    "грей": 1,
    "гренвилл": 1,
    "григорий": 1,
    "гриир": 1,
    "грир": 1,
    "гриффин": 1,
    "гриффит": 1,
    "гровер": 1,
    "грэг": 1,
    "грэгори": 1,
    "грэди": 1,
    "грэм": 1,
    "гудвин": 1,
    "гудзон": 1,
    "гурий": 1,
    "густав": 1,
    "гэй": 1,
    "гэйбл": 1,
    "гэйг": 1,
    "гэйдж": 1,
    "гэйелорд": 1,
    "гэйл": 1,
    "гэйлон": 1,
    "гэйлорд": 1,
    "гэйр": 1,
    "гэлл": 1,
    "гэри": 1,
    "давей": 1,
    "дави": 1,
    "давид": 1,
    "давыд": 1,
    "дад": 1,
    "дадда": 1,
    "дадли": 1,
    "даймонд": 1,
    "дакей": 1,
    "дакота": 1,
    "дакс": 1,
    "далтон": 1,
    "дамайон": 1,
    "дамиан": 1,
    "дамир": 1,
    "дан": 1,
    "дана": 1,
    "дани": 1,
    "даниар": 1,
    "даниил": 1,
    "данил": 1,
    "данила": 1,
    "данило": 1,
    "даниэль": 1,
    "данки": 1,
    "данни": 1,
    "дар": 1,
    "дарби": 1,
    "дарвин": 1,
    "дарден": 1,
    "дарен": 1,
    "дариан": 1,
    "дарил": 1,
    "дарин": 1,
    "дарки": 1,
    "дарнелл": 1,
    "даррел": 1,
    "даррен": 1,
    "даррил": 1,
    "даррин": 1,
    "даррэль": 1,
    "дасти": 1,
    "дастин": 1,
    "дау": 1,
    "дафф": 1,
    "даффи": 1,
    "дашилл": 1,
    "дван": 1,
    "двэйн": 1,
    "деай": 1,
    "деван": 1,
    "девен": 1,
    "девереукс": 1,
    "девин": 1,
    "девон": 1,
    "дейв": 1,
    "дейл": 1,
    "дейрлл": 1,
    "дейрн": 1,
    "декабрий": 1,
    "деклан": 1,
    "декстер": 1,
    "делберт": 1,
    "делл": 1,
    "делмар": 1,
    "делрой": 1,
    "дементий": 1,
    "деметриус": 1,
    "демид": 1,
    "демократ": 1,
    "демон": 1,
    "демьян": 1,
    "ден": 1,
    "денвер": 1,
    "денеб": 1,
    "дензэль": 1,
    "дени": 1,
    "денил": 1,
    "денис": 1,
    "деннис": 1,
    "дентон": 1,
    "деон": 1,
    "деонн": 1,
    "деонт": 1,
    "дерби": 1,
    "дерек": 1,
    "дерик": 1,
    "дермот": 1,
    "дерок": 1,
    "деррен": 1,
    "дерри": 1,
    "деррил": 1,
    "дефорест": 1,
    "дефоррест": 1,
    "дешон": 1,
    "джадд": 1,
    "джадин": 1,
    "джай": 1,
    "джайлс": 1,
    "джак": 1,
    "джамар": 1,
    "джамей": 1,
    "джамисон": 1,
    "джарвис": 1,
    "джаред": 1,
    "джарод": 1,
    "джарред": 1,
    "джарретт": 1,
    "джаррод": 1,
    "джаспер": 1,
    "джасти": 1,
    "джастин": 1,
    "джеб": 1,
    "джед": 1,
    "джедидиа": 1,
    "джейдн": 1,
    "джейк": 1,
    "джейлн": 1,
    "джейми": 1,
    "джеймс": 1,
    "джейрт": 1,
    "джейсон": 1,
    "джекки": 1,
    "джекоб": 1,
    "джем": 1,
    "дженкин": 1,
    "джеп": 1,
    "джер": 1,
    "джералд": 1,
    "джеральд": 1,
    "джерард": 1,
    "джерваз": 1,
    "джервис": 1,
    "джереми": 1,
    "джери": 1,
    "джермэйн": 1,
    "джеролд": 1,
    "джером": 1,
    "джеррард": 1,
    "джерред": 1,
    "джерри": 1,
    "джеррод": 1,
    "джерролд": 1,
    "джес": 1,
    "джесси": 1,
    "джетро": 1,
    "джетт": 1,
    "джеф": 1,
    "джеффери": 1,
    "джефферсон": 1,
    "джеффрей": 1,
    "джеффри": 1,
    "джиб": 1,
    "джид": 1,
    "джиди": 1,
    "джил": 1,
    "джим": 1,
    "джими": 1,
    "джимми": 1,
    "джисберт": 1,
    "джиффард": 1,
    "джо": 1,
    "джоб": 1,
    "джоби": 1,
    "джоджо": 1,
    "джоди": 1,
    "джозеф": 1,
    "джой": 1,
    "джойс": 1,
    "джон": 1,
    "джоназан": 1,
    "джоназон": 1,
    "джонасон": 1,
    "джонатан": 1,
    "джоней": 1,
    "джони": 1,
    "джонни": 1,
    "джонти": 1,
    "джорги": 1,
    "джордан": 1,
    "джордж": 1,
    "джорди": 1,
    "джордон": 1,
    "джосс": 1,
    "джоул": 1,
    "джош": 1,
    "джошоа": 1,
    "джошуа": 1,
    "джулс": 1,
    "джульян": 1,
    "джустис": 1,
    "джьюд": 1,
    "джэй": 1,
    "джэйд": 1,
    "джэйда": 1,
    "джэйден": 1,
    "джэйдон": 1,
    "джэйкоб": 1,
    "джэйлен": 1,
    "джэйлин": 1,
    "джэйлон": 1,
    "джэймес": 1,
    "джэйсон": 1,
    "джэксон": 1,
    "джэмини": 1,
    "джэмми": 1,
    "джэн": 1,
    "ди": 1,
    "диакон": 1,
    "дигби": 1,
    "диггори": 1,
    "дигори": 1,
    "дидим": 1,
    "дизон": 1,
    "дик": 1,
    "дики": 1,
    "дикки": 1,
    "дил": 1,
    "дилан": 1,
    "дилберт": 1,
    "димер": 1,
    "димитрий": 1,
    "дин": 1,
    "диндр": 1,
    "дионис": 1,
    "дионисий": 1,
    "дирк": 1,
    "дмитрий": 1,
    "доб": 1,
    "добрыня": 1,
    "додж": 1,
    "дольф": 1,
    "дом": 1,
    "доменик": 1,
    "доминик": 1,
    "дон": 1,
    "дональд": 1,
    "дональт": 1,
    "донат": 1,
    "донни": 1,
    "донован": 1,
    "дор": 1,
    "дориан": 1,
    "дорофей": 1,
    "доусон": 1,
    "драйк": 1,
    "древ": 1,
    "дрейвн": 1,
    "дуайт": 1,
    "дуан": 1,
    "дуг": 1,
    "дуги": 1,
    "дуглас": 1,
    "дункан": 1,
    "дунстан": 1,
    "дью": 1,
    "дьюей": 1,
    "дьюэйн": 1,
    "дэвид": 1,
    "дэвис": 1,
    "дэй": 1,
    "дэйви": 1,
    "дэйн": 1,
    "дэйтон": 1,
    "дэн": 1,
    "дэни": 1,
    "дэниел": 1,
    "дэнни": 1,
    "дэррик": 1,
    "дэшон": 1,
    "дюк": 1,
    "евгений": 1,
    "евграф": 1,
    "евдоким": 1,
    "евлампий": 1,
    "евлогий": 1,
    "евсей": 1,
    "евстафий": 1,
    "егор": 1,
    "елеазар": 1,
    "елизар": 1,
    "елисей": 1,
    "емельян": 1,
    "епифан": 1,
    "еремей": 1,
    "ермак": 1,
    "ермил": 1,
    "ермолай": 1,
    "ерофей": 1,
    "еруслан": 1,
    "ефим": 1,
    "ефрем": 1,
    "ждан": 1,
    "жерар": 1,
    "жозеф": 1,
    "жорес": 1,
    "жюль": 1,
    "завир": 1,
    "зак": 1,
    "закери": 1,
    "зандер": 1,
    "захар": 1,
    "захарий": 1,
    "зачариа": 1,
    "зачэри": 1,
    "зед": 1,
    "зедекиа": 1,
    "зек": 1,
    "зигмунд": 1,
    "зигфрид": 1,
    "зиновий": 1,
    "зорий": 1,
    "зосим": 1,
    "зосима": 1,
    "зот": 1,
    "зубин": 1,
    "зэофилус": 1,
    "иб": 1,
    "ибрагим": 1,
    "иван": 1,
    "игнат": 1,
    "игнатий": 1,
    "игнатиус": 1,
    "игорь": 1,
    "ид": 1,
    "иероним": 1,
    "иззи": 1,
    "изидор": 1,
    "измаил": 1,
    "измайло": 1,
    "изяслав": 1,
    "ий": 1,
    "икар": 1,
    "илар": 1,
    "иларий": 1,
    "иларион": 1,
    "илий": 1,
    "илиодор": 1,
    "илларион": 1,
    "илья": 1,
    "имон": 1,
    "инглеберт": 1,
    "инграм": 1,
    "инди": 1,
    "индиана": 1,
    "индиго": 1,
    "инесент": 1,
    "иниго": 1,
    "иннокентий": 1,
    "иоанн": 1,
    "иорик": 1,
    "иосиф": 1,
    "ипат": 1,
    "ипатий": 1,
    "ипполит": 1,
    "ираклий": 1,
    "ирвайн": 1,
    "ирвин": 1,
    "ирвинг": 1,
    "ириней": 1,
    "ириний": 1,
    "ирл": 1,
    "ирм": 1,
    "ирнест": 1,
    "исай": 1,
    "исайя": 1,
    "исак": 1,
    "исакий": 1,
    "исей": 1,
    "исидор": 1,
    "иссак": 1,
    "исси": 1,
    "истер": 1,
    "июлий": 1,
    "йорк": 1,
    "ка": 1,
    "кадмус": 1,
    "казимир": 1,
    "каин": 1,
    "каир": 1,
    "кайд": 1,
    "кайл": 1,
    "кал": 1,
    "калин": 1,
    "калина": 1,
    "каллен": 1,
    "кам": 1,
    "камден": 1,
    "камиль": 1,
    "камрон": 1,
    "капитон": 1,
    "карбрей": 1,
    "карбри": 1,
    "карвер": 1,
    "карей": 1,
    "карен": 1,
    "карл": 1,
    "карлайл": 1,
    "карлейл": 1,
    "карлин": 1,
    "карлтон": 1,
    "карм": 1,
    "кармий": 1,
    "карп": 1,
    "каррол": 1,
    "картер": 1,
    "касиди": 1,
    "каспар": 1,
    "каспер": 1,
    "кассиди": 1,
    "касьян": 1,
    "квентин": 1,
    "квинтин": 1,
    "кеван": 1,
    "кевин": 1,
    "кей": 1,
    "кейденс": 1,
    "кейдн": 1,
    "кейлб": 1,
    "кеймрон": 1,
    "кейси": 1,
    "келвин": 1,
    "келкей": 1,
    "келл": 1,
    "келли": 1,
    "келсей": 1,
    "кемп": 1,
    "кен": 1,
    "кендал": 1,
    "кендол": 1,
    "кендрик": 1,
    "кенелм": 1,
    "кензи": 1,
    "кенит": 1,
    "кеннеди": 1,
    "кеннет": 1,
    "кенни": 1,
    "кеннит": 1,
    "кенрик": 1,
    "кент": 1,
    "кентиджерн": 1,
    "кентон": 1,
    "кермит": 1,
    "керней": 1,
    "керр": 1,
    "керри": 1,
    "керт": 1,
    "кертис": 1,
    "кешон": 1,
    "ки": 1,
    "киаран": 1,
    "килан": 1,
    "килер": 1,
    "килиан": 1,
    "киллиан": 1,
    "ким": 1,
    "кимбелайн": 1,
    "кимберли": 1,
    "кимбол": 1,
    "кимбэль": 1,
    "кин": 1,
    "кинан": 1,
    "кинастон": 1,
    "кинг": 1,
    "кингслей": 1,
    "кип": 1,
    "киприан": 1,
    "кир": 1,
    "киран": 1,
    "кирби": 1,
    "кирилл": 1,
    "кирк": 1,
    "кирон": 1,
    "кирус": 1,
    "кит": 1,
    "китон": 1,
    "киф": 1,
    "клавдий": 1,
    "клайв": 1,
    "клайд": 1,
    "кланкей": 1,
    "кланки": 1,
    "кларенс": 1,
    "кларк": 1,
    "клев": 1,
    "клей": 1,
    "клейтон": 1,
    "клем": 1,
    "клемент": 1,
    "клементий": 1,
    "клемми": 1,
    "клетис": 1,
    "клетус": 1,
    "кливленд": 1,
    "клим": 1,
    "климент": 1,
    "климентий": 1,
    "клинт": 1,
    "клинтон": 1,
    "клифтон": 1,
    "клифф": 1,
    "клиффорд": 1,
    "клод": 1,
    "клэйрк": 1,
    "клэр": 1,
    "кодей": 1,
    "коди": 1,
    "коертней": 1,
    "козьма": 1,
    "кола": 1,
    "коламбан": 1,
    "колберт": 1,
    "колби": 1,
    "колдер": 1,
    "колин": 1,
    "коллахан": 1,
    "коллин": 1,
    "коллум": 1,
    "колтен": 1,
    "колтон": 1,
    "колумбий": 1,
    "кольт": 1,
    "конан": 1,
    "конвей": 1,
    "кондрат": 1,
    "кондратий": 1,
    "конлей": 1,
    "коннелл": 1,
    "коннер": 1,
    "коннор": 1,
    "конон": 1,
    "конор": 1,
    "конрад": 1,
    "константин": 1,
    "конфуций": 1,
    "корбин": 1,
    "корделл": 1,
    "корей": 1,
    "кори": 1,
    "корней": 1,
    "корнелий": 1,
    "корнелиус": 1,
    "корнил": 1,
    "кортней": 1,
    "кортни": 1,
    "корэй": 1,
    "коти": 1,
    "коул": 1,
    "коулман": 1,
    "краснослав": 1,
    "крис": 1,
    "криспиан": 1,
    "криспин": 1,
    "кристи": 1,
    "кристиан": 1,
    "кристопэр": 1,
    "кристоф": 1,
    "кристофер": 1,
    "крофорд": 1,
    "крофтон": 1,
    "крэйг": 1,
    "ксавайор": 1,
    "ксавьер": 1,
    "ксан": 1,
    "ксенофонт": 1,
    "ксзавир": 1,
    "кузьма": 1,
    "куин": 1,
    "куинкей": 1,
    "куинси": 1,
    "куинтон": 1,
    "купер": 1,
    "куприян": 1,
    "курт": 1,
    "куртис": 1,
    "кэйд": 1,
    "кэйдн": 1,
    "кэйл": 1,
    "кэйлб": 1,
    "кэймрон": 1,
    "кэйн": 1,
    "кэйси": 1,
    "кэлвин": 1,
    "кэм": 1,
    "кэмп": 1,
    "кэмпбэл": 1,
    "кэри": 1,
    "кюри": 1,
    "лаверн": 1,
    "лавлл": 1,
    "лавр": 1,
    "лаврентий": 1,
    "лаз": 1,
    "лазарь": 1,
    "лайл": 1,
    "лайонел": 1,
    "лаки": 1,
    "ланни": 1,
    "ланфорд": 1,
    "ларион": 1,
    "ларк": 1,
    "ларкин": 1,
    "ларри": 1,
    "лаэрт": 1,
    "лев": 1,
    "леви": 1,
    "левкий": 1,
    "лейврн": 1,
    "лейн": 1,
    "лейтон": 1,
    "лекс": 1,
    "леланд": 1,
    "лель": 1,
    "лем": 1,
    "лемми": 1,
    "лемюэль": 1,
    "лен": 1,
    "ленар": 1,
    "ленард": 1,
    "лени": 1,
    "лениан": 1,
    "леннард": 1,
    "ленни": 1,
    "лео": 1,
    "леон": 1,
    "леонард": 1,
    "леонид": 1,
    "леонтий": 1,
    "леопольд": 1,
    "лермонт": 1,
    "лерой": 1,
    "лес": 1,
    "лесли": 1,
    "лестер": 1,
    "ли": 1,
    "либерт": 1,
    "ливадий": 1,
    "лии": 1,
    "лин": 1,
    "линдон": 1,
    "линдсей": 1,
    "линдси": 1,
    "линкольн": 1,
    "линн": 1,
    "линсей": 1,
    "линтон": 1,
    "линус": 1,
    "линфорд": 1,
    "лионель": 1,
    "лир": 1,
    "лирой": 1,
    "лисандр": 1,
    "литон": 1,
    "лихнис": 1,
    "ллойд": 1,
    "ллью": 1,
    "лльюелин": 1,
    "лльюеллин": 1,
    "ло": 1,
    "ловэль": 1,
    "лойд": 1,
    "лон": 1,
    "лондон": 1,
    "лонни": 1,
    "лонс": 1,
    "лор": 1,
    "лорен": 1,
    "лоренс": 1,
    "лори": 1,
    "лорин": 1,
    "лорис": 1,
    "лорни": 1,
    "лоррин": 1,
    "лосон": 1,
    "лоуэлл": 1,
    "лоэнгрин": 1,
    "лу": 1,
    "лудо": 1,
    "луи": 1,
    "лука": 1,
    "лукиан": 1,
    "лукьян": 1,
    "льюин": 1,
    "льюис": 1,
    "лэйк": 1,
    "лэйн": 1,
    "лэйтон": 1,
    "лэндон": 1,
    "лэнс": 1,
    "лэрри": 1,
    "любим": 1,
    "любомир": 1,
    "людвиг": 1,
    "людовик": 1,
    "люк": 1,
    "люкс": 1,
    "люксен": 1,
    "люсьен": 1,
    "лютер": 1,
    "люциан": 1,
    "маверик": 1,
    "маврикий": 1,
    "мадисон": 1,
    "маеслав": 1,
    "май": 1,
    "майк": 1,
    "майкл": 1,
    "майлз": 1,
    "майрон": 1,
    "майслав": 1,
    "макар": 1,
    "макарий": 1,
    "макей": 1,
    "макензи": 1,
    "маки": 1,
    "макинтош": 1,
    "маккензи": 1,
    "макс": 1,
    "максвелл": 1,
    "максим": 1,
    "максимилиан": 1,
    "максимиллиан": 1,
    "максимильян": 1,
    "малачи": 1,
    "малком": 1,
    "малоун": 1,
    "манлей": 1,
    "манни": 1,
    "манникс": 1,
    "мануил": 1,
    "мануйло": 1,
    "манфред": 1,
    "марат": 1,
    "марвин": 1,
    "мариан": 1,
    "марин": 1,
    "мариус": 1,
    "марк": 1,
    "марка": 1,
    "маркел": 1,
    "маркиан": 1,
    "марко": 1,
    "маркус": 1,
    "марлен": 1,
    "марлин": 1,
    "марлон": 1,
    "марлоу": 1,
    "мармадьюк": 1,
    "марри": 1,
    "марс": 1,
    "марсен": 1,
    "марти": 1,
    "мартиал": 1,
    "мартин": 1,
    "мартын": 1,
    "маршал": 1,
    "маршалл": 1,
    "марьян": 1,
    "масон": 1,
    "мастерман": 1,
    "матвей": 1,
    "матти": 1,
    "мед": 1,
    "мелвилль": 1,
    "мелвин": 1,
    "мельбурн": 1,
    "мерв": 1,
    "мервин": 1,
    "мерди": 1,
    "мердо": 1,
    "мердок": 1,
    "мередит": 1,
    "мерит": 1,
    "меркурий": 1,
    "мерл": 1,
    "мерлин": 1,
    "меррилл": 1,
    "мерритт": 1,
    "мертон": 1,
    "мерфи": 1,
    "мефодий": 1,
    "мечеслав": 1,
    "мечислав": 1,
    "мид": 1,
    "миид": 1,
    "мик": 1,
    "мика": 1,
    "мики": 1,
    "микки": 1,
    "милад": 1,
    "милан": 1,
    "милберн": 1,
    "милен": 1,
    "милий": 1,
    "миллард": 1,
    "мило": 1,
    "милонег": 1,
    "милослав": 1,
    "милтон": 1,
    "милфорд": 1,
    "мир": 1,
    "мирон": 1,
    "мирослав": 1,
    "митчелл": 1,
    "михаил": 1,
    "михайло": 1,
    "мич": 1,
    "мича": 1,
    "мичил": 1,
    "мо": 1,
    "модест": 1,
    "моз": 1,
    "моисей": 1,
    "молком": 1,
    "монолит": 1,
    "монро": 1,
    "монтагью": 1,
    "монтгомери": 1,
    "монте": 1,
    "монти": 1,
    "монтморенки": 1,
    "морган": 1,
    "морген": 1,
    "мордекэй": 1,
    "морис": 1,
    "морлей": 1,
    "моррис": 1,
    "морт": 1,
    "морти": 1,
    "мортимер": 1,
    "мортон": 1,
    "мосс": 1,
    "моэ": 1,
    "мстислав": 1,
    "мулава": 1,
    "мурат": 1,
    "мэйнард": 1,
    "мэйнерд": 1,
    "мэйор": 1,
    "мэйсон": 1,
    "мэйтланд": 1,
    "мэлори": 1,
    "мэль": 1,
    "мэриан": 1,
    "мэрион": 1,
    "мэт": 1,
    "мэтт": 1,
    "мэтти": 1,
    "мэтью": 1,
    "мюд": 1,
    "надир": 1,
    "назаниль": 1,
    "назар": 1,
    "назарий": 1,
    "назим": 1,
    "найджел": 1,
    "найлс": 1,
    "наль": 1,
    "нанди": 1,
    "нат": 1,
    "натан": 1,
    "наум": 1,
    "науэлл": 1,
    "наш": 1,
    "невада": 1,
    "неван": 1,
    "невил": 1,
    "невилл": 1,
    "нед": 1,
    "нейл": 1,
    "нейлл": 1,
    "нейт": 1,
    "нельсон": 1,
    "нео": 1,
    "неон": 1,
    "неонил": 1,
    "нестер": 1,
    "нестор": 1,
    "нивек": 1,
    "нивен": 1,
    "ник": 1,
    "никандр": 1,
    "никанор": 1,
    "никита": 1,
    "никифор": 1,
    "никк": 1,
    "никки": 1,
    "никодим": 1,
    "никола": 1,
    "николай": 1,
    "николас": 1,
    "никон": 1,
    "нил": 1,
    "нили": 1,
    "нимбус": 1,
    "нинел": 1,
    "нинель": 1,
    "нисон": 1,
    "нифонт": 1,
    "ноа": 1,
    "новомир": 1,
    "нодар": 1,
    "ной": 1,
    "нолан": 1,
    "нолл": 1,
    "норберт": 1,
    "норвуд": 1,
    "норд": 1,
    "норм": 1,
    "норман": 1,
    "норманд": 1,
    "норрис": 1,
    "нортон": 1,
    "ноубль": 1,
    "ноэль": 1,
    "ньют": 1,
    "ньютон": 1,
    "оберон": 1,
    "обин": 1,
    "обри": 1,
    "овидий": 1,
    "огастин": 1,
    "огден": 1,
    "огэст": 1,
    "оделл": 1,
    "одиссей": 1,
    "одлей": 1,
    "одран": 1,
    "оз": 1,
    "оззи": 1,
    "океан": 1,
    "оксар": 1,
    "октавиан": 1,
    "октябрин": 1,
    "октябрь": 1,
    "олби": 1,
    "олбэйн": 1,
    "олдвен": 1,
    "олдвин": 1,
    "олден": 1,
    "олдин": 1,
    "олдис": 1,
    "олдон": 1,
    "олдос": 1,
    "олдред": 1,
    "олдус": 1,
    "олдфорд": 1,
    "олег": 1,
    "олей": 1,
    "оли": 1,
    "оливер": 1,
    "олимпий": 1,
    "олластер": 1,
    "олластир": 1,
    "оллгар": 1,
    "оллджер": 1,
    "олли": 1,
    "оллин": 1,
    "оллисдэйр": 1,
    "оллистер": 1,
    "оллистэйр": 1,
    "оллон": 1,
    "оллэйстар": 1,
    "ольгерд": 1,
    "омар": 1,
    "омега": 1,
    "онисим": 1,
    "ора": 1,
    "оран": 1,
    "орвал": 1,
    "орвилл": 1,
    "орест": 1,
    "ориан": 1,
    "ормерод": 1,
    "оррелл": 1,
    "оррин": 1,
    "орсон": 1,
    "осберт": 1,
    "осбоерн": 1,
    "осборн": 1,
    "освальд": 1,
    "осень": 1,
    "осип": 1,
    "оскар": 1,
    "остап": 1,
    "остен": 1,
    "остин": 1,
    "остромир": 1,
    "отис": 1,
    "оттис": 1,
    "отто": 1,
    "оттон": 1,
    "оуин": 1,
    "оуэн": 1,
    "ошин": 1,
    "павел": 1,
    "пайс": 1,
    "палладий": 1,
    "палмер": 1,
    "панкрас": 1,
    "пантелей": 1,
    "пантелеймон": 1,
    "панфил": 1,
    "парамон": 1,
    "паркер": 1,
    "паррис": 1,
    "партизан": 1,
    "пат": 1,
    "патрик": 1,
    "патси": 1,
    "пахом": 1,
    "пеитон": 1,
    "пепин": 1,
    "пересвет": 1,
    "перри": 1,
    "перс": 1,
    "перси": 1,
    "персиваль": 1,
    "петеркин": 1,
    "пимен": 1,
    "пип": 1,
    "пипер": 1,
    "пирр": 1,
    "пирс": 1,
    "пит": 1,
    "питер": 1,
    "платон": 1,
    "пол": 1,
    "поли": 1,
    "поликарп": 1,
    "помпей": 1,
    "портер": 1,
    "порфирий": 1,
    "потап": 1,
    "престон": 1,
    "приам": 1,
    "принц": 1,
    "пров": 1,
    "прозор": 1,
    "прокопий": 1,
    "прокофий": 1,
    "проспер": 1,
    "протас": 1,
    "прохор": 1,
    "пэйс": 1,
    "пэйси": 1,
    "пэйтон": 1,
    "пётр": 1,
    "петр": 1,
    "равель": 1,
    "равен": 1,
    "равиль": 1,
    "радамес": 1,
    "радий": 1,
    "радим": 1,
    "радислав": 1,
    "радомир": 1,
    "раз": 1,
    "раймонд": 1,
    "раймунд": 1,
    "райордан": 1,
    "райт": 1,
    "ралф": 1,
    "ралфи": 1,
    "ральф": 1,
    "ранделл": 1,
    "ранди": 1,
    "рандолф": 1,
    "рандольф": 1,
    "расс": 1,
    "рассел": 1,
    "рассэль": 1,
    "расти": 1,
    "растус": 1,
    "ратмир": 1,
    "рауль": 1,
    "рафаил": 1,
    "рафаэль": 1,
    "рашид": 1,
    "раян": 1,
    "реарден": 1,
    "ревмир": 1,
    "реган": 1,
    "редд": 1,
    "редж": 1,
    "реджи": 1,
    "реджинальд": 1,
    "редклиф": 1,
    "редклифф": 1,
    "редлей": 1,
    "редманд": 1,
    "редмонд": 1,
    "реид": 1,
    "рей": 1,
    "рейли": 1,
    "рейнард": 1,
    "рейнольд": 1,
    "рекс": 1,
    "рем": 1,
    "ренальд": 1,
    "ренат": 1,
    "риган": 1,
    "ригби": 1,
    "рид": 1,
    "ридлей": 1,
    "риель": 1,
    "рик": 1,
    "рикей": 1,
    "рики": 1,
    "рилан": 1,
    "рилей": 1,
    "рили": 1,
    "ринат": 1,
    "рио": 1,
    "риплей": 1,
    "рис": 1,
    "рихард": 1,
    "рич": 1,
    "ричард": 1,
    "ричи": 1,
    "роальд": 1,
    "роб": 1,
    "робби": 1,
    "роберт": 1,
    "робеспьер": 1,
    "роби": 1,
    "робин": 1,
    "робинзон": 1,
    "рован": 1,
    "род": 1,
    "роддж": 1,
    "родджер": 1,
    "родди": 1,
    "родерик": 1,
    "роджер": 1,
    "родион": 1,
    "родни": 1,
    "родолф": 1,
    "рождеро": 1,
    "рой": 1,
    "ройл": 1,
    "ройс": 1,
    "ройстон": 1,
    "роки": 1,
    "ролан": 1,
    "роланд": 1,
    "роли": 1,
    "ролланд": 1,
    "ролли": 1,
    "роман": 1,
    "ромен": 1,
    "ромуальд": 1,
    "рон": 1,
    "рональд": 1,
    "ронни": 1,
    "рори": 1,
    "роско": 1,
    "росс": 1,
    "ростислав": 1,
    "роуланд": 1,
    "роулей": 1,
    "роял": 1,
    "рубен": 1,
    "рубин": 1,
    "руди": 1,
    "рудольф": 1,
    "рудьярд": 1,
    "рунар": 1,
    "руслан": 1,
    "руссо": 1,
    "рустам": 1,
    "рустем": 1,
    "рхетт": 1,
    "рьюб": 1,
    "рэд": 1,
    "рэй": 1,
    "рэйнард": 1,
    "рэйнер": 1,
    "рэйф": 1,
    "рэм": 1,
    "рэндал": 1,
    "рэндалл": 1,
    "рюрик": 1,
    "сава": 1,
    "савва": 1,
    "савелий": 1,
    "савьер": 1,
    "сайг": 1,
    "саймон": 1,
    "салал": 1,
    "салливан": 1,
    "самми": 1,
    "самойло": 1,
    "самсон": 1,
    "самуил": 1,
    "сандфорд": 1,
    "санни": 1,
    "санфорд": 1,
    "свет": 1,
    "светлан": 1,
    "светозар": 1,
    "светослав": 1,
    "свизин": 1,
    "свизун": 1,
    "свиней": 1,
    "святогор": 1,
    "святополк": 1,
    "святослав": 1,
    "себастьян": 1,
    "севард": 1,
    "севастиан": 1,
    "севастьян": 1,
    "север": 1,
    "севериан": 1,
    "северин": 1,
    "северьян": 1,
    "северян": 1,
    "седрик": 1,
    "сеймур": 1,
    "селби": 1,
    "семён": 1,
    "септембер": 1,
    "серапион": 1,
    "серафим": 1,
    "сергей": 1,
    "сесил": 1,
    "сет": 1,
    "сефтон": 1,
    "сивард": 1,
    "сигизмунд": 1,
    "сигманд": 1,
    "сид": 1,
    "сидней": 1,
    "сидор": 1,
    "сила": 1,
    "силас": 1,
    "силвестр": 1,
    "сильвер": 1,
    "сильвест": 1,
    "сильвестр": 1,
    "симеон": 1,
    "симон": 1,
    "синклэйр": 1,
    "сирил": 1,
    "сисар": 1,
    "скай": 1,
    "скилар": 1,
    "скилер": 1,
    "скот": 1,
    "скотти": 1,
    "скуилер": 1,
    "слава": 1,
    "слай": 1,
    "слэйд": 1,
    "совет": 1,
    "сократ": 1,
    "соломон": 1,
    "сони": 1,
    "сонни": 1,
    "софокл": 1,
    "софон": 1,
    "спайк": 1,
    "спарроу": 1,
    "спартак": 1,
    "спенсер": 1,
    "спиридон": 1,
    "спиро": 1,
    "стакей": 1,
    "сталий": 1,
    "сталь": 1,
    "станислав": 1,
    "стаффорд": 1,
    "степан": 1,
    "стерлинг": 1,
    "стеф": 1,
    "стефан": 1,
    "сти": 1,
    "стив": 1,
    "стивен": 1,
    "стиви": 1,
    "стиу": 1,
    "сторм": 1,
    "стратон": 1,
    "сту": 1,
    "стэки": 1,
    "стэн": 1,
    "стэнли": 1,
    "стэнфорд": 1,
    "стюарт": 1,
    "сурен": 1,
    "сэм": 1,
    "сэмюэль": 1,
    "сэнди": 1,
    "тад": 1,
    "таддеус": 1,
    "таир": 1,
    "тай": 1,
    "такер": 1,
    "тал": 1,
    "талбот": 1,
    "таннер": 1,
    "тарас": 1,
    "таскилл": 1,
    "таффи": 1,
    "тед": 1,
    "тейгу": 1,
    "тейдж": 1,
    "теймураз": 1,
    "тейрк": 1,
    "текс": 1,
    "тельнан": 1,
    "тенгиз": 1,
    "тенней": 1,
    "теннизон": 1,
    "тео": 1,
    "теобальд": 1,
    "теодор": 1,
    "теранс": 1,
    "теренс": 1,
    "терентий": 1,
    "терло": 1,
    "терранс": 1,
    "террелл": 1,
    "терренс": 1,
    "терстон": 1,
    "ти": 1,
    "тиарнак": 1,
    "тиарнан": 1,
    "тибалт": 1,
    "тибби": 1,
    "тигран": 1,
    "тигу": 1,
    "тизон": 1,
    "тилар": 1,
    "тилер": 1,
    "тилор": 1,
    "тим": 1,
    "тимми": 1,
    "тимоти": 1,
    "тимофей": 1,
    "тимур": 1,
    "тирелл": 1,
    "тирнан": 1,
    "тирней": 1,
    "тирон": 1,
    "тироун": 1,
    "тиррелл": 1,
    "тит": 1,
    "тихомир": 1,
    "тихон": 1,
    "тоал": 1,
    "тоби": 1,
    "тобиас": 1,
    "тобин": 1,
    "товий": 1,
    "тод": 1,
    "тодд": 1,
    "толли": 1,
    "том": 1,
    "томас": 1,
    "томми": 1,
    "тон": 1,
    "тони": 1,
    "топэр": 1,
    "торез": 1,
    "торий": 1,
    "торлей": 1,
    "торнтон": 1,
    "травис": 1,
    "тракей": 1,
    "трантер": 1,
    "траффорд": 1,
    "траэрн": 1,
    "трев": 1,
    "тревельян": 1,
    "тревор": 1,
    "трейврс": 1,
    "трейс": 1,
    "трейси": 1,
    "трент": 1,
    "трентон": 1,
    "тристан": 1,
    "тристрам": 1,
    "трифон": 1,
    "трой": 1,
    "трофим": 1,
    "труман": 1,
    "туллий": 1,
    "тусон": 1,
    "тэдди": 1,
    "тэди": 1,
    "тэйлер": 1,
    "тэйлор": 1,
    "тэйн": 1,
    "тэйт": 1,
    "тэл": 1,
    "тэмпл": 1,
    "тэрри": 1,
    "уилбер": 1,
    "уиллард": 1,
    "уиллис": 1,
    "уилфред": 1,
    "уилфрид": 1,
    "уильям": 1,
    "уинстон": 1,
    "уинфред": 1,
    "уисдом": 1,
    "улайксс": 1,
    "улиссес": 1,
    "ульяна": 1,
    "уолли": 1,
    "уоллис": 1,
    "уолт": 1,
    "уолтер": 1,
    "уолтон": 1,
    "уорик": 1,
    "уорнер": 1,
    "уоррен": 1,
    "уот": 1,
    "уоткин": 1,
    "уптон": 1,
    "урбан": 1,
    "уриах": 1,
    "устин": 1,
    "уэйн": 1,
    "уэсли": 1,
    "фабиан": 1,
    "фаддей": 1,
    "фадей": 1,
    "фалк": 1,
    "фарид": 1,
    "фарлей": 1,
    "фарон": 1,
    "фарран": 1,
    "февралин": 1,
    "федор": 1,
    "федосий": 1,
    "фелан": 1,
    "фелиз": 1,
    "феликс": 1,
    "фелим": 1,
    "фелис": 1,
    "фентон": 1,
    "феодосий": 1,
    "феофан": 1,
    "ферги": 1,
    "фергус": 1,
    "ферд": 1,
    "ферди": 1,
    "фердинанд": 1,
    "фернан": 1,
    "фернанд": 1,
    "фестер": 1,
    "фестус": 1,
    "фидель": 1,
    "фидо": 1,
    "фил": 1,
    "филайп": 1,
    "филандр": 1,
    "филарет": 1,
    "филат": 1,
    "филберт": 1,
    "филимон": 1,
    "филип": 1,
    "филипп": 1,
    "фило": 1,
    "финикс": 1,
    "финис": 1,
    "флегонт": 1,
    "флемминг": 1,
    "флечер": 1,
    "флинн": 1,
    "флинт": 1,
    "флойд": 1,
    "флорентий": 1,
    "флоренц": 1,
    "флорин": 1,
    "флорри": 1,
    "флурри": 1,
    "фок": 1,
    "фокс": 1,
    "фома": 1,
    "фонз": 1,
    "фонзи": 1,
    "форбес": 1,
    "форд": 1,
    "форест": 1,
    "форрест": 1,
    "фостер": 1,
    "фот": 1,
    "фотий": 1,
    "фоук": 1,
    "фразир": 1,
    "франклин": 1,
    "франц": 1,
    "фред": 1,
    "фредди": 1,
    "фредерик": 1,
    "фредрик": 1,
    "фрейзер": 1,
    "фрейзр": 1,
    "фридрих": 1,
    "фримэн": 1,
    "фритс": 1,
    "фродо": 1,
    "фрол": 1,
    "фрэнк": 1,
    "фрэнки": 1,
    "фрэнклин": 1,
    "фрэнс": 1,
    "фрэнсис": 1,
    "фёдор": 1,
    "хавелок": 1,
    "хадвин": 1,
    "хадлей": 1,
    "хал": 1,
    "хам": 1,
    "хамиш": 1,
    "хамлет": 1,
    "хаммонд": 1,
    "ханк": 1,
    "ханлей": 1,
    "хантер": 1,
    "харв": 1,
    "харви": 1,
    "харди": 1,
    "хардинг": 1,
    "харитон": 1,
    "харкоерт": 1,
    "харлан": 1,
    "харланд": 1,
    "харлей": 1,
    "харлин": 1,
    "хармон": 1,
    "харпер": 1,
    "харрис": 1,
    "харрисон": 1,
    "хартлей": 1,
    "хауелл": 1,
    "хедлей": 1,
    "хек": 1,
    "хендерсон": 1,
    "хендрик": 1,
    "хенрай": 1,
    "хенри": 1,
    "херб": 1,
    "херби": 1,
    "хервей": 1,
    "херлей": 1,
    "хиацинт": 1,
    "хилари": 1,
    "хиллэри": 1,
    "хирам": 1,
    "хис": 1,
    "хитклифф": 1,
    "хию": 1,
    "хоард": 1,
    "хоб": 1,
    "ходдж": 1,
    "хойт": 1,
    "холден": 1,
    "холл": 1,
    "холлис": 1,
    "хомер": 1,
    "хопкин": 1,
    "хорас": 1,
    "хоратайо": 1,
    "хоуи": 1,
    "храбр": 1,
    "христоф": 1,
    "христофор": 1,
    "худд": 1,
    "хуей": 1,
    "хует": 1,
    "хукк": 1,
    "хукслей": 1,
    "хумберт": 1,
    "хунтлей": 1,
    "хуффи": 1,
    "хью": 1,
    "хьюберт": 1,
    "хьюго": 1,
    "хьюи": 1,
    "хэвен": 1,
    "хэдлей": 1,
    "хэйвуд": 1,
    "хэйден": 1,
    "хэйл": 1,
    "хэмфри": 1,
    "хэппи": 1,
    "хюи": 1,
    "цезарь": 1,
    "чад": 1,
    "чадвик": 1,
    "чаз": 1,
    "чак": 1,
    "чакки": 1,
    "чарлз": 1,
    "чарли": 1,
    "чарлтон": 1,
    "чарльз": 1,
    "час": 1,
    "чейз": 1,
    "чендлер": 1,
    "ченс": 1,
    "черокез": 1,
    "чеслав": 1,
    "честер": 1,
    "чеьянн": 1,
    "чип": 1,
    "чонки": 1,
    "чонси": 1,
    "ша": 1,
    "шад": 1,
    "шаи": 1,
    "шайенн": 1,
    "шакуилл": 1,
    "шамиль": 1,
    "шамус": 1,
    "шан": 1,
    "шаннен": 1,
    "шаннон": 1,
    "шау": 1,
    "шеврон": 1,
    "шелби": 1,
    "шелдон": 1,
    "шеллей": 1,
    "шелтон": 1,
    "шем": 1,
    "шервуд": 1,
    "шеридан": 1,
    "шерлок": 1,
    "шерман": 1,
    "ши": 1,
    "шилох": 1,
    "шимус": 1,
    "шмидт": 1,
    "шолто": 1,
    "шон": 1,
    "шэй": 1,
    "шэйн": 1,
    "эбби": 1,
    "эбен": 1,
    "эбенезер": 1,
    "эвальд": 1,
    "эван": 1,
    "эвелин": 1,
    "эверард": 1,
    "эверетт": 1,
    "эверитт": 1,
    "эвот": 1,
    "эгберт": 1,
    "эд": 1,
    "эдан": 1,
    "эдвард": 1,
    "эдвин": 1,
    "эдгар": 1,
    "эдди": 1,
    "эдип": 1,
    "эдисон": 1,
    "эдмонд": 1,
    "эдмунд": 1,
    "эдон": 1,
    "эдуард": 1,
    "эдун": 1,
    "эзраа": 1,
    "эзэлстан": 1,
    "эзэлуолф": 1,
    "эйб": 1,
    "эйби": 1,
    "эйвери": 1,
    "эйден": 1,
    "эйлберт": 1,
    "эйлвард": 1,
    "эймерей": 1,
    "эймери": 1,
    "эйнар": 1,
    "эйнслей": 1,
    "эйнсли": 1,
    "эйс": 1,
    "элайотт": 1,
    "элбан": 1,
    "элвин": 1,
    "элвис": 1,
    "элвуд": 1,
    "элгар": 1,
    "элдвен": 1,
    "элдвин": 1,
    "элден": 1,
    "элджер": 1,
    "элдин": 1,
    "элдис": 1,
    "элдон": 1,
    "элдред": 1,
    "элдус": 1,
    "электрон": 1,
    "эли": 1,
    "элиас": 1,
    "элиджа": 1,
    "элиот": 1,
    "элла": 1,
    "эллгар": 1,
    "эллджер": 1,
    "эллери": 1,
    "эллиот": 1,
    "эллис": 1,
    "элмер": 1,
    "элрик": 1,
    "элрой": 1,
    "элсдон": 1,
    "эль": 1,
    "эльберт": 1,
    "эльбрус": 1,
    "эльдар": 1,
    "эльмар": 1,
    "эльмир": 1,
    "эльтон": 1,
    "эмерсон": 1,
    "эмилиан": 1,
    "эмилий": 1,
    "эмиль": 1,
    "эммануель": 1,
    "эммануил": 1,
    "эммерсон": 1,
    "эммет": 1,
    "эмметт": 1,
    "эмори": 1,
    "эмэри": 1,
    "энвер": 1,
    "энгель": 1,
    "энджелберт": 1,
    "энди": 1,
    "эндрю": 1,
    "энергий": 1,
    "энтони": 1,
    "эразм": 1,
    "эраст": 1,
    "эрван": 1,
    "эрвин": 1,
    "эрг": 1,
    "эрек": 1,
    "эрий": 1,
    "эрик": 1,
    "эрих": 1,
    "эрл": 1,
    "эрлен": 1,
    "эрн": 1,
    "эрнест": 1,
    "эрни": 1,
    "эрнст": 1,
    "эрон": 1,
    "эррол": 1,
    "эрролл": 1,
    "этан": 1,
    "этелберт": 1,
    "этелред": 1,
    "этелрик": 1,
    "этелхард": 1,
    "эшли": 1,
    "эюзби": 1,
    "ювеналий": 1,
    "юджин": 1,
    "юлиан": 1,
    "юлий": 1,
    "юлиус": 1,
    "юм": 1,
    "юниор": 1,
    "юпитер": 1,
    "юрий": 1,
    "юстас": 1,
    "юстин": 1,
    "яков": 1,
    "ян": 1,
    "янкей": 1,
    "янки": 1,
    "януарий": 1,
    "ярвуд": 1,
    "яромир": 1,
    "ярополк": 1,
    "ярослав": 1
  }, exports.ruBindingWords = [ "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "пота", "потому", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "тож", "только", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы", "а-ля", "без", "безо", "благодаря", "близ", "в", "ввиду", "вглубь", "вдоль", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "во", "возле", "вокруг", "вопреки", "впереди", "вразрез", "вроде", "вслед", "вследствие", "для", "до", "за", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "к", "ко", "кроме", "кругом", "меж", "между", "мимо", "на", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду", "насупротив", "насчёт", "не", "ниже", "о", "об", "обо", "обок", "около", "окромя", "округ", "от", "относительно", "ото", "перед", "передо", "по", "по-за", "по-над", "поверх", "под", "подле", "подо", "подобно", "позади", "помимо", "поперёк", "порядка", "посередине", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "применительно", "про", "против", "путём", "ради", "с", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "со", "согласно", "спустя", "среди", "средь", "сродни", "судя", "супротив", "у", "через", "чрез", "иже", "какой-либо", "какой-то", "кое-кто", "кой", "кто", "кто-либо", "многий", "мя", "насколько", "немногий", "нещечко", "никой", "ничегошеньки", "се", "сё", "такой-то", "тот-то", "чё", "чево", "чей-либо", "чей-нибудь", "чей-то", "шо", "эта", "кем", "ком", "кому", "нахуя", "чей", "чему", "вам", "вами", "вас", "вы", "Вы", "ее", "её", "его", "ей", "ему", "ею", "им", "ими", "их", "меня", "мне", "мной", "мною", "мы", "нём", "нем", "нам", "нами", "неё", "него", "ней", "нему", "нею", "ним", "ними", "них", "он", "она", "оне", "они", "оно", "тебе", "тебя", "тобой", "тобою", "ты", "я", "иной", "кое-какой", "кое-чей", "кое-что", "кой-какой", "кой-кто", "кто-нибудь", "кто-то", "куда-нибудь", "некто", "нечто", "что-либо", "что-нибудь", "что-то", "весь", "всякий", "любой", "сам", "самый", "таков", "этакий", "другой", "некем", "некому", "нечего", "нечем", "нечему", "никакой", "никто", "ничего", "ничей", "ничем", "ничему", "ничто", "ваш", "ихний", "моё", "мой", "моя", "наш", "свой", "твой", "оный", "сей", "сие", "сии", "сия", "та", "такой", "тот", "ту", "эдакий", "эти", "это", "этот", "ась", "аюшки", "таки", "а", "авось-либо", "ага", "аминь", "б", "бишь", "буквально", "бы", "было", "вишь", "вон", "вот", "вот-вот", "вряд", "всего", "давай", "де", "действительно", "дескать", "добро", "довольно", "ещё", "исключительно", "ить", "ишь", "ка", "кажется", "конечно", "ладно", "лих", "лучше", "мол", "навряд", "наоборот", "небось", "нет", "неужели", "нехай", "никак", "ну", "ну-с", "по-видимому", "пожалуй", "пожалуйста", "полно", "положительно", "предовольно", "простите", "просто-напросто", "пускай", "разумеется", "сём-ка", "сем", "скорее", "спасибо", "так", "то-то", "тоже", "уж", "уже", "ужели", "ужли", "фон", "хорошо", "эдак", "эк", "этак" ];
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.words = {}, exports = window.lastName.plugins.ru.words) : exports = module.exports, function(exports) {
  return exports.adverbs = [ "абсолютно", "адски", "азартно", "активно", "аспидно", "баснословно", "бдительно", "безапелляционно", "безбожно", "безвозвратно", "безгранично", "безжалостно", "беззаветно", "беззастенчиво", "безмерно", "безмятежно", "безнадежно", "безоговорочно", "безраздельно", "безропотно", "безудержно", "безукоризненно", "безумно", "безупречно", "безусловно", "безустанно", "безутешно", "бескомпромиссно", "бесконечно", "беспардонно", "бесповоротно", "беспощадно", "беспредельно", "беспрекословно", "бесследно", "бессовестно", "бесстыдно", "бесчеловечно", "бешено", "бурно", "вдребезги", "вконец", "вовсю", "всемерно", "всесторонне", "всецело", "всячески", "высоко", "глубоко", "горько", "горячо", "грубо", "густо", "диаметрально", "дико", "досконально", "досыта", "дотошно", "дьявольски", "жарко", "жгуче", "железно", "жестко", "жестоко", "живо", "жизненно", "жутко", "запоем", "запредельно", "зверски", "здорово", "злостно", "идеально", "излишне", "изрядно", "изумительно", "исключительно", "исступленно", "истово", "истошно", "исчерпывающе", "кардинально", "катастрофически", "категорически", "клятвенно", "колоссально", "крайне", "крепко", "кристально", "кровно", "крупно", "круто", "люто", "максимально", "мертвецки", "мучительно", "навзрыд", "нагло", "наглухо", "наглядно", "наголову", "надежно", "надрывно", "назубок", "намертво", "наотрез", "напрочь", "нарочито", "насквозь", "настоятельно", "насущно", "начисто", "небывало", "невероятно", "невиданно", "невообразимо", "невыносимо", "невыразимо", "недопустимо", "неизмеримо", "неимоверно", "неистово", "немилосердно", "немыслимо", "необыкновенно", "необычайно", "неописуемо", "неопровержимо", "непомерно", "непоправимо", "непостижимо", "непримиримо", "непробудно", "непроходимо", "неразрывно", "несказанно", "неслыханно", "несметно", "несравненно", "нестерпимо", "неудержимо", "неузнаваемо", "неуклонно", "неукоснительно", "неустанно", "неусыпно", "неутешно", "неутомимо", "нещадно", "оглушительно", "ожесточенно", "ослепительно", "основательно", "остро", "откровенно", "открыто", "отлично", "отменно", "отчаянно", "очень", "панически", "патологически", "пламенно", "плотно", "по-настоящему", "по-собачьи", "подлинно", "подчеркнуто", "позарез", "поистине", "полностью", "поразительно", "порядком", "порядочно", "потрясающе", "предельно", "прекрасно", "преступно", "прилично", "примитивно", "принципиально", "приторно", "пронзительно", "радикально", "разительно", "редкостно", "резко", "рекордно", "свято", "серьезно", "сильно", "слепо", "смертельно", "совершенно", "совсем", "страстно", "страшно", "строго", "строго-настрого", "существенно", "твердо", "тяжело", "тяжко", "убийственно", "удивительно", "ужасающе", "ужасно", "фанатически", "фанатично", "фантастически", "феноменально", "хорошенько", "хорошо", "чертовски", "чрезвычайно", "чрезмерно", "чудовищно", "широко", "шумно", "щедро", "ярко", "яростно" ], exports.unions = [ "а", "а именно", "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "все-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как бы", "как то", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "после того как", "пота", "потому", "потому как", "потому что", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "то есть", "тож", "только", "только что", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы" ], exports.prepositionAll = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо", "включая", "невзирая на", "несмотря на", "по", "по-за", "про", "с", "сквозь", "со", "спустя", "через", "чрез", "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по", "при", "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "среди", "средь", "супротив", "у", "в связи с", "в соответствии с", "вслед за", "лицом к лицу с", "над", "надо", "наряду с", "перед", "передо", "по сравнению с", "по-над", "пред", "предо", "рядом с", "следом за" ], exports.prepositionSimple = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionAcusative = [ "в", "включая", "во", "за", "на", "не в", "не за", "невзирая на", "несмотря на", "о", "об", "обо", "по", "по-за", "под", "подо", "про", "с", "сквозь", "со", "спустя", "через", "чрез" ], exports.prepositionDative = [ "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по" ], exports.prepositionPrepositional = [ "в", "во", "на", "не в", "о", "об", "обо", "по", "при" ], exports.prepositionGenetive = [ "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "меж", "между", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "со", "среди", "средь", "супротив", "у" ], exports.prepositionInstrumental = [ "в связи с", "в соответствии с", "вслед за", "за", "лицом к лицу с", "меж", "между", "над", "надо", "наряду с", "не за", "перед", "передо", "по сравнению с", "по-над", "под", "подо", "пред", "предо", "рядом с", "с", "следом за", "со" ], exports.prepositionWithSingleCase = [ "без", "без ведома", "безо", "благодаря", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в связи с", "в силу", "в соответствии с", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "вдоль по", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "вопреки", "впереди", "впредь до", "вроде", "вслед", "вслед за", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "к", "ко", "кроме", "кругом", "лицом к", "лицом к лицу с", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду с", "насупротив", "насчёт", "начиная с", "не без", "не считая", "невзирая на", "недалеко от", "независимо от", "несмотря на", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "перед", "передо", "по линии", "по мере", "по направлению к", "по отношению к", "по поводу", "по причине", "по случаю", "по сравнению с", "по-за", "по-над", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "подобно", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "при помощи", "применительно к", "про", "против", "путём", "ради", "рядом с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "согласно", "спустя", "среди", "средь", "сродни", "судя по", "супротив", "у", "через", "чрез" ], exports.prepositionWith2Cases = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionWith3Cases = [ "по", "с", "со" ];
}(exports);

var exports, ref, util, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.dates = {}, exports = window.lastName.plugins.ru.dates, ref = window.lastName.plugins.ru.ref, util = window.lastName.util) : (exports = module.exports, ref = require("./ref"), util = require("../../util")), function(exports, util, ref) {
  var dateObjectToString, extractDates, getRuMonthIndex, getValidDate, packDates, packIntervals, ruMonthInDates;
  return ruMonthInDates = [ "января", "февраля", "марта", "аперля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря" ], dateObjectToString = function(dateObj) {
    var d, m, y, _ref;
    return y = ((_ref = typeof dateObj.y) === "number" || _ref === "string") && dateObj.y || "", m = dateObj.m + 1, m = m > 9 && m || "0" + m, d = dateObj.d > 9 && dateObj.d || "0" + dateObj.d, "" + d + "." + m + "." + y;
  }, getValidDate = function(dateObj) {
    var defaultYear, dt;
    defaultYear = dateObj.y;
    if (void 0 === dateObj.y || dateObj.y < 1970 || dateObj.y > 2038) dateObj.y = 2e3;
    return dt = new Date(Date.UTC(dateObj.y, dateObj.m, dateObj.d)), dt.getMonth() === dateObj.m && dt.getDate() === dateObj.d ? (dateObj.y = defaultYear, dateObj) : null;
  }, getRuMonthIndex = function(str) {
    var m;
    return m = str.toLowerCase().match(/(\s|^)(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s|$)/g), m ? ruMonthInDates.indexOf(m[0].replace(/\s/g, "")) : -1;
  }, exports.extractDates = extractDates = function(strArr) {
    var dates, intervals, sources;
    return dates = {}, sources = [], intervals = {}, strArr instanceof Array || (strArr = [ strArr ]), strArr.map(function(str) {
      var dStr, date, found, from, fromDate, fromMonth, fromYear, id, intObject, mIndex, sourceStr, to, toDate, toYear, verboseMatch, wordsArr, _ref, _results;
      verboseMatch = str.match(/\s+\d{1,2}\s+((января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)\s+|)(\d{2,4}(\s+года|)\s+|)по\s+\d{1,2}\s+(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s+\d{2,4}|)(\s+|$)/mig);
      if (!verboseMatch) {
        wordsArr = str.split(" "), found = !1, _results = [];
        while (wordsArr.length > 2 && !found) /^\d[\d]$/.test(wordsArr[0]) && (mIndex = ruMonthInDates.indexOf(wordsArr[1].toLowerCase()), mIndex >= 0 ? (date = {
          d: parseInt(wordsArr[0], 10),
          m: mIndex
        }, /^\d{2,4}$/.test(wordsArr[2]) ? (date.y = parseInt(wordsArr[2], 10), sourceStr = wordsArr.slice(0, 3).join(" ")) : sourceStr = wordsArr.slice(0, 2).join(" ")) : /^\d\d\.\d\d.\d{2,4}$/.test(wordsArr[0] || /^\d\d\.\d\d$/.test(wordsArr[0])) ? (date = {
          d: parseInt(wordsArr[0].slice(0, 3), 10),
          m: parseInt(wordsArr[0].slice(3, 6), 10),
          y: parseInt(wordsArr[0].slice(6), 10) || void 0
        }, sourceStr = wordsArr[0]) : date = {}, date = getValidDate(date), date && (found = !0, sources.push(sourceStr), dStr = dateObjectToString(date), dates[dStr] ? dates[dStr].count++ : dates[dStr] = {
          count: 1,
          value: date
        })), _results.push(wordsArr.shift());
        return _results;
      }
      _ref = verboseMatch[0].toLowerCase().split("по"), from = _ref[0], to = _ref[1], toYear = to.replace(/\d{1,2}/, "").match(/\d+/g), toYear ? toYear = parseInt(toYear[0], 10) : toYear = void 0, toDate = {
        d: parseInt(to.match(/\d{1,2}/g)[0], 10),
        m: getRuMonthIndex(to),
        y: toYear
      }, fromYear = from.replace(/\d{1,2}/, "").match(/\d+/g), fromMonth = getRuMonthIndex(from), fromYear ? fromYear = parseInt(fromYear[0], 10) : fromYear = toYear, fromMonth === -1 && (fromMonth = toDate.m), fromDate = {
        d: parseInt(from.match(/\d{1,2}/g)[0], 10),
        m: fromMonth,
        y: fromYear
      }, toDate = getValidDate(toDate), fromDate = getValidDate(fromDate);
      if (toDate && fromDate) return intObject = {
        from: dateObjectToString(fromDate),
        from_value: fromDate,
        to: dateObjectToString(toDate),
        to_value: toDate
      }, id = "" + intObject.from + "-" + intObject.to, intervals[id] ? intervals[id].count++ : (intObject.count = 1, intervals[id] = intObject), sources.push(verboseMatch[0]);
    }), {
      dates: dates,
      sources: sources,
      intervals: intervals
    };
  }, exports.packDates = packDates = function(dates, defaultYear) {
    var dateObj, id, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in dates) dateObj = dates[id], "undefined" != typeof dateObj.value.y && years.push(dateObj.value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in dates) dateObj = dates[id], "undefined" == typeof dateObj.value.y && (dateObj.value.y = defaultYear), out["" + dateObjectToString(dateObj.value)] = dateObj.count;
    return out;
  }, exports.packIntervals = packIntervals = function(intervals, defaultYear) {
    var id, interval, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in intervals) interval = intervals[id], "undefined" != typeof interval.from_value.y && years.push(interval.from_value.y), "undefined" != typeof interval.to_value.y && years.push(interval.to_value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in intervals) interval = intervals[id], "undefined" == typeof interval.from_value.y && (interval.from_value.y = defaultYear), "undefined" == typeof interval.to_value.y && (interval.to_value.y = defaultYear), out["" + dateObjectToString(interval.from_value) + "-" + dateObjectToString(interval.to_value)] = interval.count;
    return out;
  }, exports.preFilter = function(text, result) {
    var dates, numRe;
    numRe = /((([а-яё]+)\s+){0,1}\d[\.\d]{0,}(\s+(([a-яё]+)|([\.\d]+))){1,6})|([12]\d\d\d)/mig, dates = extractDates(util.unique(text.match(numRe) || [])), util.dictKeys(dates.dates).length > 0 && (result.dates = packDates(dates.dates)), util.dictKeys(dates.intervals).length > 0 && (result.intervals = packIntervals(dates.intervals));
    if (dates.sources.length > 0) return result.date_sources = dates.sources;
  };
}(exports, util, ref);

var exports, ref, util, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.inclines = {}, exports = window.lastName.plugins.ru.inclines, util = window.lastName.util, ref = window.lastName.plugins.ru.ref) : (exports = module.exports, util = require("../../util"), ref = require("./ref")), function(exports, util, ref) {
  var cases, doInclineFemaleName, doInclineMaleName, findProperName, genderMatch, getNominative, inclineAndGetResult, inclineFemMiddleName, inclineFemaleName, inclineFemaleNameAndGetResult, inclineFemaleSurname, inclineMaleMiddleName, inclineMaleName, inclineMaleNameAndGetResult, inclineMaleSurname, inclineMiddleName, inclineMiddleNameOrSurname, inclineName, inclinePersonSurname, inclineSurname, matchCase, matchNameAndSurname, matchNameParts;
  return cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ], exports.doInclineFemaleName = doInclineFemaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, aUnstressedRe, name2;
    return aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, aUnstressedRe = /ца$/g, name2 = name.slice(0, -1), aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aUnstressedRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ей", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /ия$/g.test(name) && name.length > 3 ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "и" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ь", "" + name2 + "ью", "" + name2 + "и" ] : /[жшщцч]$/g.test(name) ? [ "" + name, "" + name + "и", "" + name + "и", "" + name, "" + name + "ью", "" + name + "и" ] : [ name, name, name, name, name, name ];
  }, exports.doInclineMaleName = doInclineMaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, hardConsonants, hissingAndChe, ishortRe, name2;
    return hardConsonants = /[бвгдзклмнпрстфх]$/g, hissingAndChe = /[жшщцч]$/g, ishortRe = /((ай)|(ей)|(ой)|(уй)|(яй)|(юй)|(ий))$/g, aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, name2 = name.slice(0, -1), name === "Лев" ? [ "Лев", "Льва", "Льву", "Льва", "Львом", "Льве" ] : name === "Павел" ? [ "Павел", "Павла", "Павлу", "Павла", "Павлом", "Павле" ] : /и$/g.test(name) ? [ name, name, name, name, name, name ] : hissingAndChe.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ем", "" + name + "е" ] : hardConsonants.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ом", "" + name + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : ishortRe.test(name) ? [ "" + name2 + "й", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ко$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /о$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : null;
  }, inclineAndGetResult = function(fn, args) {
    var i, name, r;
    r = null;
    for (i in args) {
      name = args[i], r = fn(name, !0);
      if (r.found) break;
    }
    return r;
  }, inclineFemaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineFemaleName, arguments);
  }, inclineMaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineMaleName, arguments);
  }, exports.inclineFemaleName = inclineFemaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name3, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), nl = name.toLowerCase(), nominativeRe = /[адежзийклмнорстуьэя]$/g, canInclineRe = /[жшщцчаяь]$/g, genitiveRe = /[иы]$/g, dativeRe = /[еи]$/g, accusativeRe = /[жшщцчьую]$/g, instrumentalRe = /((ой)|(ей)|(еи)|(ью))$/g, prepositionalRe = /[еи]$/g, result = r = null, nominativeRe.test(nl) && ref.ruFemaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineFemaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "female",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name2 = name.slice(0, -1), name_cases = [], genitiveRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("dative"))), prepositionalRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("prepositional"))), accusativeRe.test(nl) && (/[ую]$/g.test(nl) ? r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а") : r = inclineFemaleNameAndGetResult(name), r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (name3 = name.slice(0, -2), r = inclineFemaleNameAndGetResult("" + name3 + "я", "" + name3 + "а", "" + name3 + "ь", "" + name3), r && r.found && (result = r, name_cases.push("instrumental"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineMaleName = inclineMaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), name === "Льв" && (name = "Лев"), name === "Павл" && (name = "Павел"), nl = name.toLowerCase(), nominativeRe = /([вгдзклмнпрстфхжшцьй]|(ба)|(ва)|(да)|(за)|(ла)|(ма)|(на)|(па)|(ра)|(са)|(та)|(фа)|(га)|(ка)|(ха)|(жа)|(ша)|(ща)|(ца)|(ча)|(я)|(ло)|(ко))$/g, canInclineRe = /([бвгдзклмнпрстфхжшцьая]|(ия)|(ья)|(ея)|(ий)|(ей))$/g, genitiveRe = /[аяыи]$/g, dativeRe = /(([еую])|(ии))$/g, accusativeRe = /[аяую]$/g, instrumentalRe = /((ом)|(ем)|(ой)|(ей)|(ёй))$/g, prepositionalRe = /((е)|(ии))$/g, name2 = name.slice(0, -1), result = r = null, nominativeRe.test(nl) && ref.ruMaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineMaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "male",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name_cases = [], genitiveRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /ы$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "о", "" + name2 + "а") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "а", "" + name.slice(0, -1) + "я", "" + name.slice(0, -1) + "о") : r = null, r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (/у$/g.test(nl) ? r = inclineMaleName(name2) : /[аеиоуя]ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "й") : /ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "ь") : /е$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "и", "" + name2 + "я", "" + name2 + "o") : /ии$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я") : r = null, r && r.found && (result = r, name_cases.push("dative"))), accusativeRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /у$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а") : /[ую]$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : r = null, r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (/ом$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2)) : /ем$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2), "" + name.slice(0, -2) + "ь", "" + name.slice(0, -2) + "й") : /ой$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "а", "" + name.slice(0, -2) + "о") : /((ей)|(ёй))$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "я", "" + name.slice(0, -2) + "а") : r = null, r && r.found && (result = r, name_cases.push("instrumental"))), prepositionalRe.test(nl) && (/е$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2, "" + name2 + "ь", "" + name2 + "й", "" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я", "" + name2 + "й") : r = null, r && r.found && (result = r, name_cases.push("prepositional"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineName = inclineName = function(name) {
    var fn, mn, result;
    return fn = inclineFemaleName(name), mn = inclineMaleName(name), fn.found ? result = {
      found: !0,
      src: name,
      gender: "female",
      guess_case: fn.guess_case,
      female_cases: fn.cases,
      possible_cases: fn.possible_cases,
      nominative: fn.nominative
    } : mn.found ? result = {
      found: !0,
      src: name,
      gender: "male",
      guess_case: mn.guess_case,
      male_cases: mn.cases,
      possible_cases: mn.possible_cases,
      nominative: mn.nominative
    } : fn.possible_yes && mn.possible_yes ? (result = {
      found: "maybe",
      src: name,
      gender: [ "male", "female" ],
      female_cases: fn.cases,
      male_cases: mn.cases,
      possible_cases: util.merge(fn.possible_cases, mn.possible_cases)
    }, result.guess_case = fn.guess_case_index <= mn.guess_case_index ? fn.guess_case : mn.guess_case) : fn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "female",
      female_cases: fn.cases,
      guess_case: fn.cases,
      possible_cases: fn.possible_cases
    } : mn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "male",
      male_cases: mn.cases,
      guess_case: mn.cases,
      possible_cases: mn.possible_cases
    } : result = {
      found: !1,
      src: name
    }, result;
  }, inclineSurname = function(surname, noInclinesRe, inclineRe, casesRe) {
    var c, cases_index, check, i, result, surname_cases, _i, _j, _len, _len2;
    result = {
      found: null,
      src: surname,
      cases: null,
      cases_index: null
    };
    if (noInclinesRe && noInclinesRe.test(surname)) result = {
      found: surname,
      src: surname,
      cases: [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ],
      cases_index: [ 0, 1, 2, 3, 4, 5 ]
    }; else for (_i = 0, _len = inclineRe.length; _i < _len; _i++) {
      check = inclineRe[_i];
      if (check[0].test(surname)) {
        result = {
          found: surname.replace(check[0], check[1]),
          src: surname
        }, cases_index = [], surname_cases = [], i = 0;
        for (_j = 0, _len2 = casesRe.length; _j < _len2; _j++) c = casesRe[_j], c.test(surname) && (cases_index.push(i), surname_cases.push(cases[i])), i++;
        surname_cases.length === 0 ? (result.found = null, result.cases = null) : result.cases = surname_cases, result.cases_index = cases_index;
        break;
      }
    }
    return result.surname_cases && (result.guess_case = result.surname_cases[0]), result;
  }, exports.inclineFemaleSurname = inclineFemaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(е)|(о)|(э)|(и)|(ы)|(^[нв]у)|(^ую)|(уа)|(иа)|(ман)|(вич)|(ян))$/g, inclineRe = [ [ /((ова)|(овой)|(ову))$/g, "ова" ], [ /((ева)|(евой)|(еву))$/g, "ева" ], [ /((ёва)|(ёвой)|(ёву))$/g, "ёва" ], [ /((ина)|(иной)|(ину))$/g, "ина" ], [ /((ая)|(ой)|(ую))$/g, "ая" ] ], casesRe = [ /((ова)|(ева)|(ёва)|(ина)|(ая))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((ову)|(еву)|(ёву)|(ину)|(ую))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, exports.inclineMaleSurname = inclineMaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(^ве)|(^го)|(э)|(и)|(ы)|(^му)|(ю)|(уа)|(иа))$/g, inclineRe = [ [ /((ов)|(ова)|(ову)|(овым)|(ове))$/g, "ов" ], [ /((ев)|(ева)|(еву)|(евым)|(еве))$/g, "ев" ], [ /((ёв)|(ёва)|(ёву)|(ёвым)|(ёве))$/g, "ёв" ], [ /((ин)|(ина)|(ину)|(иным)|(ине))$/g, "ин" ], [ /((ский)|(ского)|(скому)|(ским)|(ском))$/g, "ский" ], [ /((ской)|(ского)|(скому)|(ским)|(ском))$/g, "ской" ], [ /((ман)|(мана)|(ману)|(маном)|(мане))$/g, "ман" ], [ /((ой)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ой" ], [ /((ий)|(ого)|(ому)|(ого)|(им)|(ом))$/g, "ий" ], [ /((ый)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ый" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ], [ /((ян)|(яна)|(яну)|(яна)|(яном)|(яне))$/g, "ян" ] ], casesRe = [ /((ов)|(ев)|(ёв)|(ин)|(ский)|(ской)|(ой)|(ий)|(ый)|(ман)|(ич)|(ян))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((ову)|(еву)|(ёву)|(ину)|(скому)|(ому)|(ману)|(ичу)|(яну))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((овым)|(евым)|(ёвым)|(иным)|(ским)|(им)|(ым)|(маном)|(ичем)|(яном))$/g, /((ове)|(еве)|(ёве)|(ине)|(ском)|(ом)|(мане)|(иче)|(яне))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, inclineMiddleNameOrSurname = function(src, fem, male) {
    var result, _ref;
    return fem.found === (_ref = male.found) && _ref === null ? result = {
      found: !1,
      src: src,
      value: null,
      gender: null
    } : fem.found && male.found ? (result = {
      found: !0,
      src: src,
      gender: [ "male", "female" ]
    }, result.nominative_male = male.found, result.nominative_female = fem.found, result.female_cases = fem.cases, result.male_cases = male.cases, fem.cases.length === 6 ? male.cases.length === 6 ? (result.guess_sex = "unknown", result.possible_cases = util.merge(fem.cases, male.cases)) : (result.guess_sex = "male", result.nominative = male.found, result.possible_cases = male.cases) : fem.cases.length === 1 && male.cases.length > 1 ? (result.guess_sex = "female", result.nominative = fem.found, result.possible_cases = fem.cases) : result.possible_cases = util.merge(fem.cases, male.cases)) : fem.found ? male.found || (result = {
      found: !0,
      src: src,
      gender: "female",
      female_cases: fem.cases,
      guess_case: fem.guess_case,
      nominative: fem.found,
      possible_cases: fem.cases
    }) : result = {
      found: !0,
      src: src,
      gender: "male",
      male_cases: male.cases,
      guess_case: male.guess_case,
      nominative: male.found,
      possible_cases: male.cases
    }, result;
  }, exports.inclineSurname = inclinePersonSurname = function(surname) {
    return inclineMiddleNameOrSurname(surname, inclineFemaleSurname(surname), inclineMaleSurname(surname));
  }, exports.inclineMaleMiddleName = inclineMaleMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((евич)|(евича)|(евичу)|(евича)|(евичем)|(евиче))$/g, "евич" ], [ /((ович)|(овича)|(овичу)|(овича)|(овичем)|(овиче))$/g, "ович" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ] ], casesRe = [ /((евич)|(ович)|(ич))$/g, /((евича)|(овича)|(ича))$/g, /((евичу)|(овичу)|(ичу))$/g, /((евича)|(овича)|(ича))$/g, /((евичем)|(овичем)|(ичем))$/g, /((евиче)|(овиче)|(иче))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineFemMiddleName = inclineFemMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((вна)|(вны)|(вне)|(вну)|(вной)|(вне))$/g, "вна" ], [ /((чна)|(чны)|(чне)|(чну)|(чной)|(чне))$/g, "чна" ] ], casesRe = [ /((вна)|(чна))$/g, /((вны)|(чны))$/g, /((вне)|(чне))$/g, /((вну)|(чну))$/g, /((вной)|(чной))$/g, /((вне)|(чне))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineMiddleName = inclineMiddleName = function(mname) {
    return inclineMiddleNameOrSurname(mname, inclineFemMiddleName(mname), inclineMaleMiddleName(mname));
  }, genderMatch = function(g1, g2) {
    return g1 === g2 || __indexOf.call(g2, g1) >= 0 ? g1 : __indexOf.call(g1, g2) >= 0 ? g2 : null;
  }, matchNameParts = function(fn, mn, sn) {
    var overallGender, surname, theCase;
    return theCase = util.intersection(fn.possible_cases, mn.possible_cases), overallGender = genderMatch(genderMatch(fn.gender, mn.gender), sn.gender), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: mn.nominative,
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchNameAndSurname = function(fn, sn) {
    var overallGender, surname, theCase;
    return overallGender = genderMatch(fn.gender, sn.gender), theCase = util.intersection(fn.possible_cases, sn.possible_cases), theCase || (sn.possible_cases = sn["" + overallGender + "_cases"], sn.nominative = sn["nominative_" + overallGender], theCase = util.intersection(fn.possible_cases, sn.possible_cases)), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: "",
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchCase = function(pObj, target_case, gender) {
    return __indexOf.call(pObj["" + gender + "_cases"], target_case) >= 0;
  }, getNominative = function(pObj, gender) {
    var gnstr, nom;
    return gnstr = "nominative_" + gender, nom = pObj.nominative && pObj.nominative || pObj[gnstr], nom;
  }, exports.findProperName = findProperName = function(listOfWords, opts) {
    var mnr2, mnr3, nr1, nr2, nr3, result, sr1, sr2, sr3;
    opts == null && (opts = {}), result = {
      found: !1
    };
    switch (listOfWords.length) {
     case 1:
      result = inclineName(listOfWords[0]), result.found ? result.first_name = result.nominative : (result = inclinePersonSurname(listOfWords[0]), result.found && (result.surname = result.nominative));
      break;
     case 2:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr1.found && sr2.found && (result = matchNameAndSurname(nr1, sr2)), !result.found && sr1.found && nr2.found && (result = matchNameAndSurname(sr1, nr2));
      break;
     case 3:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), sr3 = inclinePersonSurname(listOfWords[2]), mnr2 = inclineMiddleName(listOfWords[1]), mnr3 = inclineMiddleName(listOfWords[2]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr3 = inclineName(listOfWords[2]), nr3.found ? result = {
        found: !1,
        error: "name at the end of 3-component proper name"
      } : nr1.found ? (mnr2.found && sr3.found && (result = matchNameParts(nr1, mnr2, sr3)), !result.found && sr2.found && (result = matchNameAndSurname(nr1, sr2))) : sr1.found && nr2.found && mnr3.found ? result = matchNameParts(nr2, mnr3, sr1) : nr2.found && sr3.found && (result = matchNameAndSurname(nr2, sr3));
    }
    return result.first_name || (result.first_name = ""), result.middle_name || (result.middle_name = ""), result.surname || (result.surname = ""), result.first_name || result.middle_name || result.surname || (result = {
      found: !1,
      error: "person not found"
    }), result.src = listOfWords.join(" "), result;
  }, exports.getInitialFormOfAdjective = function(adj) {
    var base;
    return adj = adj.toLowerCase(), /^[а-яё]{2,}(ая|ее|ие|ий|им|ими|их|ого|его|ое|ой|ом|ому|ою|ую|ые|ый|ым|ыми|ых|юю|яя)$/.test(adj) ? (/^[а-яё]{2,}(ими|ого|его|ому|ыми)$/gi.test(adj) ? base = adj.slice(0, -3) : base = adj.slice(0, -2), [ "" + base + "ый", "" + base + "ий", "" + base + "ой" ]) : null;
  }, exports.getVerbInfinitive = function(verb) {
    var pastTime, result, verbEnd;
    return verb = verb.toLowerCase(), /^[а-яё]{3,}(ать|аться|ить|иться|еть|еться|оть|оться|уть|утся|ются|ть|ться)$/.test(verb) ? verb : (/^[а-яё]{3,}(сь|ся)$/.test(verb) ? (verbEnd = verb.slice(-2), verb = verb.slice(0, -2)) : verbEnd = "", pastTime = verb.match(/^[а-яё]{3,}(л|ла|ло|ли)$/), pastTime ? result = verb.slice(0, -(1 + pastTime[1].length) + 1 || 9e9) + "ть" : /[а-яё]{3,}(у|ю|ем|ешь|ете|ет|ут|ют|им|ишь|ите|ит|ат|ят)$/.test(verb) && (/[а-яё]{3,}(ишь|ит|им|ите|ат|ят)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd ] : /[а-яё]{3,}(у|ю|ешь|ет|ем|ете|ут|ют)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd, "" + verb + "оть" + verbEnd, "" + verb + "уть" + verbEnd, "" + verb + "ть" + verbEnd ] : result = null), result);
  };
}(exports, util, ref);

var exports, ruWords, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.morpho = {}, exports = window.lastName.plugins.ru.morpho, ruWords = window.lastName.plugins.ru.words) : (exports = module.exports, ruWords = require("./words")), function(exports, ruWords) {
  var exceptions, getRulesAdjective, getRulesVerb, morphoRu;
  return exports.getWordRe = function() {
    return /^[а-я\-ё\d]+$/ig;
  }, exports.getAdjectiveEnds = function() {
    return {
      feminine: {
        ends: /((ая)|(ой)|(ую)|(яя)|(ей)|(юю))$/g,
        hard: /((ая)|(ой)|(ую))$/g,
        sort: /((яя)|(ей)|(юю))$/g,
        hardNominativeEnd: "ая",
        softNominativeEnd: "яя",
        gender: "feminine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ая" ? [ "" + word + "ая", "" + word + "ой", "" + word + "ой", "" + word + "ую", "" + word + "ой", "" + word + "ой" ] : [ "" + word + "яя", "" + word + "ей", "" + word + "ей", "" + word + "юю", "" + word + "ей", "" + word + "ей" ];
        }
      },
      masculine: {
        ends: /((ый)|(ого)|(ому)|(ым)|(ом)|(ий)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ый)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ий)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ый",
        softNominativeEnd: "ий",
        gender: "masculine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ый" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ий", "" + word + "ого", "" + word + "ому", "" + word + "ий", "" + word + "им", "" + word + "ом" ] : [ "" + word + "ый", "" + word + "ого", "" + word + "ому", "" + word + "ый", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ий", "" + word + "его", "" + word + "ему", "" + word + "ий", "" + word + "им", "" + word + "ем" ];
        }
      },
      neuter: {
        ends: /((ое)|(ого)|(ому)|(ым)|(ом)|(ее)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ое)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ее)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ое",
        softNominativeEnd: "ее",
        gender: "neuter",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ое" ? [ "" + word + "ое", "" + word + "ого", "" + word + "ому", "" + word + "ое", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ее", "" + word + "его", "" + word + "ему", "" + word + "ее", "" + word + "им", "" + word + "ем" ];
        }
      },
      plural: {
        ends: /((ые)|(ых)|(ым)|(ыми)|(ых)|(ие)|(их)|(им)|(ими)|(их))$/g,
        hard: /((ые)|(ых)|(ым)|(ыми)|(ых))$/g,
        soft: /((ие)|(их)|(им)|(ими)|(их))$/g,
        hardNominativeEnd: "ые",
        softNominativeEnd: "ие",
        gender: "unknown",
        singular: !1,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ые" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ] : [ "" + word + "ые", "" + word + "ых", "" + word + "ым", "" + word + "ые", "" + word + "ыми", "" + word + "ых" ] : [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ];
        }
      }
    };
  }, exceptions = function(word) {}, getRulesVerb = function() {
    return [ [ /нул[aи]{0,1}$/g, "ать" ], [ /еть$/g, "ать" ], [ /(ает)|(ают)$/g, "ать" ], [ /ал[aи]{0,1}$/g, "ать" ], [ /ул[aи]{0,1}$/g, "ать" ], [ /((ить)|(ать))$/g, "ать" ], [ /ая$/g, "ать" ], [ /((ил)|(или)|(ила)|(ило))$/g, "лять" ], [ /(ятся)|(ится)|(ился)|(илась)|(илось)$/g, "ится" ], [ /(яться)|(иться)$/g, "иться" ] ];
  }, getRulesAdjective = function() {
    return [ [ /в((ая)|(ые)|(ый)|(ое))$/, "вый" ], [ /((ая)|(ой)|(ие)|(ые)|(ый)|(ую))$/, "ый" ], [ /((яя)|(ее)|(ий)|(юю))$/, "ий" ] ];
  }, exports.morpho = morphoRu = function(word) {
    var adj, adjective, result, rule, verb, _i, _j, _len, _len2, _ref, _ref2;
    if (__indexOf.call(ruWords.adverbs, word) >= 0) return {
      type: "abverb",
      value: word
    };
    if (__indexOf.call(ruWords.prepositionAll, word) >= 0) return {
      type: "preposition",
      value: word
    };
    if (__indexOf.call(ruWords.unions, word) >= 0) return {
      type: "union",
      value: word
    };
    result = {
      type: "",
      value: ""
    }, verb = null, adjective = null, _ref = getRulesVerb();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      rule = _ref[_i];
      if (rule[0].test(word)) {
        result = {
          type: verb,
          value: word.replace(rule[0], rule[1])
        };
        break;
      }
    }
    _ref2 = getRulesAdjective();
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      rule = _ref2[_j];
      if (rule[0].test(word)) {
        adj = word.replace(rule[0], rule[1]), result.type ? (result.type += " adjective", result.value = [ result.value, adj ]) : result = {
          type: "adjective",
          value: adj
        };
        break;
      }
    }
    return result;
  }, exports.analyseText = function(text) {
    var doubleSpaceRe, enRe, punctuationRe, r, result, ruRe, t, wordRe, _i, _len, _ref;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&№“”\—]/g, doubleSpaceRe = /\s+/g, text = text.replace(punctuationRe, " $& ").replace(doubleSpaceRe, " ") + " .", result = [], _ref = text.split(" ");
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      t = _ref[_i], ruRe = /^[а-я\-ё]+$/ig, enRe = /^[a-z\-]+$/ig, wordRe = /^[а-яё\-\da-z]+$/ig, r = morphoRu(t.toLowerCase());
      switch (r.type) {
       case "adverb":
        result.push("[ADV " + t + "]");
        break;
       case "verb":
       case "adjective":
        result.push("[ " + r.value + " ]");
        break;
       case "verb adjective":
        result.push("[#VA " + r.value[0] + "]");
        break;
       case "union":
        result.push("[U " + t + "]");
        break;
       case "preposition":
        result.push("[PP " + t + "]");
        break;
       default:
        result.push(t);
      }
      t === "." && result.push("\n");
    }
    return result;
  }, exports.parseRuSentence = function(sentences) {
    var abbrevs, common_used_words, digits, regular_words, special_words, total_words;
    return sentences instanceof Array || (sentences = [ sentences ]), abbrevs = {}, special_words = {}, digits = {}, common_used_words = {}, regular_words = {}, total_words = 0, sentences.map(function(sent) {
      var i, result, w, word, words, _len, _ref, _results;
      words = sent.split(" "), _results = [];
      for (i = 0, _len = words.length; i < _len; i++) word = words[i], /^[[,:\/\\\?!\+\-\*\(\)\[\]\&\№\—]]+$/.test(words) || total_words++, /^(\d+(|(\.(|\d+))))$/.test(word) ? digits[word] ? _results.push(digits[word]++) : _results.push(digits[word] = 1) : isUpperCase(word) && /^[а-яё\-]{2,}$/i.test(word) ? abbrevs[word] ? _results.push(abbrevs[word]++) : _results.push(abbrevs[word] = 1) : i > 0 && isCapitalized(word) && /^[а-яё\-]{2,}$/i.test(word) ? special_words[word] ? _results.push(special_words[word]++) : _results.push(special_words[word] = 1) : /^[а-яё\-]+$/i.test(word) && !/^\-+$/.test(word) ? (w = word.toLowerCase(), result = morphoRu(w), (_ref = result.type) !== "adverb" && _ref !== "preposition" && _ref !== "union" ? regular_words[w] ? _results.push(regular_words[w]++) : _results.push(regular_words[w] = 1) : common_used_words[w] ? _results.push(common_used_words[w]++) : _results.push(common_used_words[w] = 1)) : _results.push(void 0);
      return _results;
    }), {
      abbrevs: abbrevs,
      common_used_words: common_used_words,
      special_words: special_words,
      regular_words: regular_words,
      digits: digits,
      total_words: total_words
    };
  };
}(exports, ruWords);

var exports, inclines, morpho, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.propernames = {}, exports = window.lastName.plugins.ru.propernames, morpho = window.lastName.plugins.ru.morpho, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, morpho = require("./morpho"), inclines = require("./inclines")), function(exports, morpho, inclines) {
  return exports.postFilter = function(text, result) {
    var curProperName, id, p, pn, pnDict, properNames, properNamesRe, punctuationRe, _i, _j, _len, _len2, _ref, _ref2;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&\№“”\—]/g, properNames = [], curProperName = [], properNamesRe = /[А-Я][а-яё]+(\s+[А-Я][а-яё]+){0,2}/gm, _ref = text.match(properNamesRe);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) pn = _ref[_i], curProperName = pn.replace(/\s+/g, " ").split(" "), curProperName && (pn = inclines.findProperName(curProperName), pn && pn.found && properNames.push(pn));
    pnDict = {};
    for (_j = 0, _len2 = properNames.length; _j < _len2; _j++) p = properNames[_j], id = "" + (p.first_name || "") + "-" + (p.middle_name || "") + "-" + (p.surname || ""), pnDict[id] ? (pnDict[id].count += 1, (_ref2 = p.src, __indexOf.call(pnDict[id].src, _ref2) < 0) && pnDict[id].src.push(p.src)) : (pnDict[id] = p, pnDict[id].src = [ p.src ], pnDict[id].count = 1);
    return result.propernames = pnDict;
  };
}(exports, morpho, inclines);

var exports, inclines, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName.plugins.ru.feelings = {}, exports = window.lastName.plugins.ru.feelings, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, inclines = require("./inclines")), function(exports, inclines) {
  var evaluateSentenceNeutrality, getNegativePhrasesRe, negativeAdjectives, negativeVerbs, negativeWordsIncline;
  return exports.positive = [], negativeAdjectives = {
    "агрессивный": 3,
    "атакованный": 2,
    "бедный": 2,
    "беззащитный": 2,
    "безнадежный": 3,
    "безрадостный": 2,
    "бесплодный": 3,
    "беспомощный": 3,
    "бесправный": 2,
    "бессердечный": 1,
    "бессильный": 1,
    "бесцельный": 2,
    "бесчестный": 2,
    "вздорный": 1,
    "виновный": 1,
    "ворчливый": 1,
    "враждебный": 2,
    "вспыльчивый": 1,
    "выпученный": 1,
    "выселенный": 3,
    "высмеянный": 2,
    "выхолощенный": 1,
    "глубокий": 1,
    "глупый": 2,
    "горький": 2,
    "готический": 2,
    "гротескный": 1,
    "грустный": 1,
    "грязный": 1,
    "девальвированный": 2,
    "деградировавший": 2,
    "дегуманизированный": 2,
    "дезорганизованный": 2,
    "дезориентированный": 2,
    "деморализованный": 3,
    "дерзкий": 1,
    "дерьмовый": 3,
    "дефектный": 3,
    "драматический": 3,
    "жалкий": 3,
    "жесткий": 2,
    "жестокосердный": 2,
    "заброшенный": 1,
    "забываемый": 1,
    "забывчивый": 1,
    "забытый": 2,
    "зависимый": 1,
    "заинтересованный": 1,
    "запрещенный": 3,
    "запутанный": 2,
    "застенчивый": 1,
    "застрявший": 1,
    "затравленный": 2,
    "зверский": 3,
    "злобный": 2,
    "идиотский": 3,
    "измельченный": 2,
    "измученный": 2,
    "изнасилованный": 3,
    "изолированный": 3,
    "изумленный": 1,
    "интенсивный": 1,
    "иррациональный": 2,
    "исключенный": 2,
    "искусственный": 2,
    "испуганный": 2,
    "истерический": 3,
    "исчерпанный": 2,
    "капризный": 2,
    "контролируемый": 1,
    "критический": 1,
    "ленивый": 2,
    "лишенный": 2,
    "ложный": 2,
    "мазохистский": 1,
    "мертвый": 3,
    "меченый": 2,
    "мрачный": 2,
    "мстительный": 2,
    "навязчивый": 2,
    "надоедливый": 2,
    "наказанный": 2,
    "нарушенный": 2,
    "натянутый": 2,
    "неадекватный": 2,
    "неактивный": 1,
    "небезопасный": 2,
    "небрежный": 1,
    "невежественный": 1,
    "невидимый": 1,
    "невротический": 2,
    "негуманный": 2,
    "недействительный": 1,
    "недовольный": 2,
    "недостаточный": 1,
    "недоуменный": 1,
    "незаземленный": 1,
    "незначительный": 1,
    "неискренний": 1,
    "некомпетентный": 2,
    "ненавистный": 3,
    "необщительный": 2,
    "неполный": 2,
    "неправильный": 2,
    "неприятный": 2,
    "нервный": 2,
    "нерешительный": 1,
    "несбалансированный": 1,
    "несовместимый": 2,
    "несоответствующий": 2,
    "неспособный": 3,
    "несчастный": 2,
    "неуклюжий": 2,
    "неуловимый": 1,
    "неуместный": 2,
    "нечестный": 2,
    "неэффективный": 2,
    "низкий": 1,
    "обвиняемый": 3,
    "обедненный": 1,
    "обезумевший": 3,
    "обиженный": 2,
    "обманутый": 2,
    "обозленный": 2,
    "оборонительный": 1,
    "обремененный": 1,
    "обременительный": 1,
    "обреченный": 2,
    "ограниченный": 1,
    "одержимый": 3,
    "одинокий": 2,
    "одноразовый": 1,
    "озабоченный": 2,
    "окаменелый": 1,
    "онемелый": 1,
    "опальный": 2,
    "опасный": 3,
    "опустошенный": 1,
    "опущенный": 2,
    "опьяненный": 1,
    "оскорбленный": 2,
    "осмеянный": 2,
    "острый": 1,
    "осужденный": 3,
    "осушенный": 2,
    "ответственный": 2,
    "отвратительный": 3,
    "отдаленный": 1,
    "отдельный": 1,
    "отрицательный": 2,
    "отсталый": 2,
    "отчаянный": 1,
    "ошибочный": 1,
    "параноидальный": 2,
    "паршивый": 2,
    "пассивный": 1,
    "переполненный": 2,
    "пессимистический": 2,
    "печальный": 2,
    "побежденный": 3,
    "поверхностный": 2,
    "поврежденный": 3,
    "подавленный": 2,
    "поддельный": 3,
    "покинутый": 2,
    "покорный": 1,
    "порабощенный": 3,
    "потерянный": 2,
    "потерпевший": 2,
    "потребленный": 1,
    "презираемый": 2,
    "презренный": 3,
    "презрительный": 2,
    "прерванный": 1,
    "принудительный": 2,
    "психотический": 2,
    "пустынный": 1,
    "пьяный": 2,
    "равнодушный": 1,
    "развращенный": 3,
    "раздраженный": 2,
    "раздражительный": 2,
    "разочарованный": 2,
    "разочаровывающий": 3,
    "разрушенный": 3,
    "разрушительный": 2,
    "разъяренный": 3,
    "раненый": 2,
    "ревнивый": 2,
    "садистский": 2,
    "самоубийственный": 3,
    "саркастический": 1,
    "сварливый": 1,
    "сгоревший": 3,
    "сердитый": 2,
    "серый": 1,
    "скучающий": 1,
    "скучный": 1,
    "сломанный": 2,
    "смущенный": 1,
    "созерцательный": 1,
    "сомнительный": 2,
    "спорный": 2,
    "спровоцированный": 2,
    "спутанный": 2,
    "спущенный": 2,
    "стереотипный": 1,
    "стесненный": 1,
    "странный": 1,
    "страшный": 2,
    "сумасшедший": 2,
    "тихий": 1,
    "тормозящий": 2,
    "торопливый": 2,
    "тоскливый": 3,
    "требовательный": 2,
    "тревожный": 2,
    "трудный": 2,
    "трусливый": 2,
    "тупой": 1,
    "тщеславный": 2,
    "угнетенный": 2,
    "угрюмый": 2,
    "удаляемый": 2,
    "удрученный": 2,
    "ужасный": 3,
    "уклончивый": 2,
    "униженный": 3,
    "унылый": 3,
    "урезанный": 2,
    "фальшивый": 3,
    "хаотический": 2,
    "холодный": 1,
    "хрупкий": 1,
    "цепкий": 2,
    "циничный": 2,
    "чертовский": 2,
    "чрезмерный": 2,
    "чувствительный": 2,
    "эгоистичный": 2,
    "эгоцентричный": 3,
    "эксплуатируемый": 2,
    "эмансипированный": 2,
    "эмоциональный": 1,
    "яростный": 3
  }, negativeVerbs = {
    "беспокоить": 2,
    "бить": 2,
    "внушать": 2,
    "волноваться": 2,
    "высмеивать": 2,
    "грызть": 1,
    "диктовать": 2,
    "дребезжать": 1,
    "дрожать": 1,
    "дрогнуть": 2,
    "загнать": 2,
    "запугивать": 3,
    "запутаться": 2,
    "злоупотреблять": 2,
    "игнорировать": 1,
    "избегать": 1,
    "издеваться": 3,
    "изменять": 2,
    "командовать": 1,
    "лгать": 2,
    "лишить": 2,
    "манипулировать": 2,
    "молчать": 1,
    "надувать": 1,
    "ненавидеть": 3,
    "обвинять": 2,
    "обидеть": 2,
    "опорочить": 3,
    "освистать": 3,
    "отбрасывать": 1,
    "отвлекаться": 2,
    "отклонить": 2,
    "отрекаться": 3,
    "оттолкнуть": 2,
    "паниковать": 2,
    "перепутаться": 2,
    "подавить": 3,
    "подвергаться": 2,
    "пострадать": 2,
    "предавать": 3,
    "пренебрегать": 2,
    "препятствовать": 2,
    "преследовать": 2,
    "принижаться": 2,
    "приставать": 2,
    "прослушивать": 2,
    "разгромить": 2,
    "раздражаться": 2,
    "растаскивать": 2,
    "рисковать": 2,
    "ругать": 2,
    "сдуваться": 1,
    "смолчать": 2,
    "снизиться": 1,
    "сорвать": 1,
    "сожалеть": 2,
    "соизволить": 2,
    "солгать": 2,
    "сомневаться": 2,
    "споткнуться": 1,
    "столкнуться": 2,
    "страдать": 2,
    "стрелять": 3,
    "судить": 2,
    "толкнуть": 1,
    "убить": 3,
    "убивать": 3,
    "уговаривать": 1,
    "удалять": 2,
    "уклоняться": 2,
    "унижать": 3,
    "шантажировать": 2
  }, negativeWordsIncline = {
    "боль": 2,
    "вниз": 1,
    "горе": 3,
    "дно": 2,
    "мало": 1,
    "мучение": 2,
    "недовольство": 2,
    "плохо": 2,
    "противно": 3,
    "совестно": 2,
    "только": 1,
    "ужас": 3,
    "смерть": 3,
    "неодобрительно": 2,
    "разгром": 2,
    "отчаяние": 3
  }, exports.getNegativePhrasesRe = getNegativePhrasesRe = function() {
    return [ [ /[^а-яё]при\sотягчающих\sобстоятельствах[^а-яё]/ig, 2 ], [ /[^а-яё]ненависть\sк[^а-яё]/ig, 3 ], [ /[^а-яё]в\sубыток[^а-яё]/ig, 2 ], [ /[^а-яё]сыт[аы]?\sпо\sгорло[^а-яё]/ig, 3 ], [ /[^а-яё]заслужива[ею]т\sнаказания[^а-яё]/ig, 2 ], [ /[^а-яё]находящ(егося|ейся|емся|ихся)\sпод\sугрозой\sисчезновения[^а-яё]/ig, 3 ], [ /[^а-яё]в\sзаблуждение[^а-яё]/ig, 2 ], [ /[^а-яё]сбит[аы]?\sс\sтолку[^а-яё]/ig, 2 ], [ /[^а-яё]в\sужасе[^а-яё]/ig, 3 ], [ /[^а-яё]не\sрекоменд(ую|уем|уется|овал|овала|овали)[^а-яё]/ig, 2 ], [ /[^а-яё]не\sодобря(ю|ем|л|ла|ли|ется)[^а-яё]/ig, 2 ], [ /[^а-яё]пятно\sна[^а-яё]/ig, 2 ], [ /[^а-яё]в\sклетке[^а-яё]/ig, 1 ], [ /[^а-яё]неправильно\sпонял[аи]?[^а-яё]/ig, 2 ], [ /[^а-яё]вне\sпределов\sдосягаемости[^а-яё]/ig, 1 ], [ /[^а-яё]взял[аи]?\sна[^а-яё]/ig, 2 ], [ /[^а-яё]играл[аи]?\sс[^а-яё]/ig, 2 ], [ /[^а-яё]черный\sсписок[^а-яё]/ig, 3 ], [ /[^а-яё]возбужден[оы]\sуголовн(ое|ые)\sдел[оа][^а-яё]/ig, 8 ], [ /[^а-яё]жертв(|а|ы|ам|ами)[^а-яё]/ig, 3 ] ];
  }, exports.evaluateSentenceNeutrality = evaluateSentenceNeutrality = function(sentence) {
    var adj, adjArray, adjIndex, curWords, cur_index, ind, index, m, nr, resetCurIndex, vIndex, verb, words, wrd, _i, _j, _k, _len, _len2, _len3, _ref, _ref2;
    index = 0, cur_index = 0, words = [], curWords = [], _ref = getNegativePhrasesRe();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) nr = _ref[_i], m = sentence.match(nr[0]), m && (m.map(function(wordsSequence) {
      return words.push(wordsSequence);
    }), index -= nr[1] * m.length);
    resetCurIndex = function() {
      if (cur_index) return index += cur_index, words.push(curWords), curWords = [], cur_index = 0;
    }, _ref2 = sentence.split(/\s/);
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      wrd = _ref2[_j];
      if (__indexOf.call(".,-—!?()[]", wrd) >= 0) {
        cur_index = -cur_index, resetCurIndex();
        continue;
      }
      ind = negativeWordsIncline[wrd.toLowerCase()];
      if (ind) curWords.push(wrd), cur_index = cur_index * ind || ind; else {
        adjArray = inclines.getInitialFormOfAdjective(wrd);
        if (!adjArray) verb = inclines.getVerbInfinitive(wrd), vIndex = negativeVerbs[verb], vIndex ? (curWords.push(wrd), cur_index = cur_index * vIndex || vIndex) : (cur_index = -cur_index, resetCurIndex()); else for (_k = 0, _len3 = adjArray.length; _k < _len3; _k++) {
          adj = adjArray[_k], adjIndex = negativeAdjectives[adj];
          if (adjIndex) {
            curWords.push(wrd), cur_index = cur_index * adjIndex || adjIndex;
            break;
          }
        }
      }
    }
    return resetCurIndex(-cur_index), [ index, words ];
  }, exports.postFilter = function(text, result) {
    var emoIndex, emoWords, i, index, overallIndex, s, _len, _ref, _ref2;
    emoIndex = [], overallIndex = 0, _ref = result.misc.sentences;
    for (i = 0, _len = _ref.length; i < _len; i++) s = _ref[i], _ref2 = evaluateSentenceNeutrality(s), index = _ref2[0], emoWords = _ref2[1], emoIndex.push([ index, emoWords ]), overallIndex += index;
    return result.feelings = {
      emoIndex: emoIndex,
      overallIndex: overallIndex,
      emoScore: overallIndex / result.counters.words_total || 1
    };
  };
}(exports, inclines);

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).analysis || (_base.analysis = {}), exports = window.lastName.analysis) : exports = module.exports, function(exports) {
  return exports.analyse = function(text, plugins) {
    var f, misc, postFilter, preFilters, result, util, _i, _j, _len, _len2;
    plugins == null && (plugins = []), "undefined" == typeof global ? (misc = window.lastName.misc, util = window.lastName.util) : (misc = require("./misc"), util = require("./util")), result = {}, misc.preFilter(text, result), preFilters = plugins.filter(function(plugin) {
      return "function" == typeof plugin.preFilter;
    }), postFilter = plugins.filter(function(plugin) {
      return "function" == typeof plugin.postFilter;
    });
    for (_i = 0, _len = preFilters.length; _i < _len; _i++) f = preFilters[_i], f.preFilter(text, result);
    for (_j = 0, _len2 = postFilter.length; _j < _len2; _j++) f = postFilter[_j], f.postFilter(text, result);
    return result.version = util.version, result;
  };
}(exports);

var __slice = Array.prototype.slice;

(function(lastname) {
  return lastname.version = "0.3.5", lastname.findProperName = function() {
    var args, inclines, lang;
    return lang = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [], inclines = lastname.plugins["" + lang].inclines, inclines.findProperName.apply(this, args);
  };
})(window.lastName || (window.lastName = {}));

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).misc || (_base.misc = {}), exports = window.lastName.misc) : exports = module.exports, function(exports) {
  return exports.preFilter = function(text, result) {
    var chars_total, emo, emoticons, findEmo, ind, punctuationRe, sentences, signs, signs_total, spaces_total, tempTxt, word_length_mid, words_total, _i, _len;
    signs = text.match(/[-\+=\/\.,\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]{1}/g), signs_total = signs && signs.length || 0, spaces_total = /\s/.test(text) ? text.match(/\s/g).length : 0, chars_total = text.length, words_total = text.split(/\s/).filter(function(wrd) {
      return wrd.length > 0 && !/^[-\+=\/\.\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]+$/.test(wrd);
    }).length, word_length_mid = words_total ? (chars_total - spaces_total - signs_total) / words_total : 0, emoticons = [ ":-)", "(-:", ":o)", ":)", "(:", ":->", ":-}", ":-t", ":*)", ":-)))", ":-D", "(-D", ":'-)", "%-)", ":-/", ":-I", ":~)", "(:-(", ":-(", ":-c", ":-(((", ":-<", ">:-(", ":-[", "(:-&", "%-(", ">:-<", "~ :-(", "%-(", ":/)", ":-|", ":-e", ":-X", ":-v", ":-I", ":-8(", ":-O", ":-@", ":,-(", ":'-(", "~:-o", "]:-)>", "):-)", ";->", ":-x", ":-*", "8-]", ":-J", ":-&", ":-p", ":-P", ";-)", ";)", "'-)", ":-7", "?-(", "B-D", ":-B", ":-*)", ":-9", "|-p", ":-b", "-]:-)[-", "8-I", "8-|", "|:-|", ":-]", "|-)", "|-I", "I^o", "|-O", ':-"', ":-s", ":-#", ":-!", ":-()", ":-D", "(:-$", ":-(*)", ":-')", ":-R", "%+|", "%+{", "X-(", "<:-)", "*:o)", "@;-)", "X:-)", ":>)", "&:-)", "#:-)", "8-)", "8:-)", "B-)", "B-]", "O:-)", "&8-|", ":-{", ":-)}", ":-)#", ":-Q", ":-I", ":-d~", ":-?", ":-/I", ":-) X", "{(:-)", ":-{}", "[:-)", "d :-o", "~:-(", "~~:-(", "))", "(:-I", "3:-o", "[: |]", "M-)", ":X)", ":-M", "*8((:", "O+", "O->", "||*(", "||*)", "<{:-)}", "(-: :-)", "@->-", "@==", "<')))))- <" ], emoticons.sort(function(a, b) {
      return b.length - a.length;
    }), tempTxt = text.slice(0), findEmo = [];
    for (_i = 0, _len = emoticons.length; _i < _len; _i++) {
      emo = emoticons[_i], ind = 0;
      while (ind >= 0) ind = tempTxt.indexOf(emo, ind), ind !== -1 && (findEmo.push(emo), tempTxt = tempTxt.replace(emo, ""), ind -= emo.length + 2);
    }
    return punctuationRe = /(https?\:\/\/.*[\s$])|(\.\s)|(,\s)|(\s\:)|(:\s)|(\s\/)|(\/\s)|(\s\\)(\\\s)|\?|!|\+|\'|\"|«|»|\*|\(|\)|\[|\]|\&|\№|“|”|\—/g, tempTxt = text.replace(punctuationRe, " $& ").replace(/\s+/g, " "), /[\?\!\.]\s{0,}$/.test(tempTxt) || (tempTxt += " . "), sentences = tempTxt.replace(/\s\?\s/gm, " ?? ").replace(/\s\!\s/gm, " !! ").replace(/\s\.\s/gm, " .. ").split(/[\?\!\.](\s+|$)/gm).filter(function(s) {
      return !/^\s{0,}$/.test(s);
    }), result.misc = {
      digits: util.arrayToDict(text.match(/-?((\d+[\.,]\d+)|(\d+))/ig) || []),
      emoticons: util.arrayToDict(findEmo),
      sentences: sentences
    }, result.counters = {
      chars_total: chars_total,
      words_total: words_total,
      signs_total: signs_total,
      spaces_total: spaces_total,
      word_length_mid: word_length_mid,
      words_in_sentence_mid: sentences.length ? words_total / sentences.length : 0
    }, result;
  };
}(exports);

var exports, _base, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).util || (_base.util = {}), exports = window.lastName.util) : exports = module.exports, function(exports) {
  var capitalize, dictKeys, intersection, isCapitalized, isLowerCase, isUpperCase, merge, unique;
  return exports.version = "0.3.17", exports.capitalize = capitalize = function(s) {
    if (s) return "" + s[0].toUpperCase() + s.slice(1).toLowerCase();
  }, exports.dictKeys = dictKeys = function(dict) {
    var k, keys, v;
    keys = [];
    for (k in dict) v = dict[k], keys.push(k);
    return keys;
  }, exports.isCapitalized = isCapitalized = function(word) {
    var cap;
    return 0 <= word.indexOf("-") ? (cap = !0, word.split("-").map(function(wrd) {
      return cap && (cap = isCapitalized(wrd));
    }), cap) : word && word === capitalize(word) || !1;
  }, exports.isUpperCase = isUpperCase = function(word) {
    return word === word.toUpperCase();
  }, exports.isLowerCase = isLowerCase = function(word) {
    return word === word.toLowerCase();
  }, exports.unique = unique = function(array) {
    var key, output, value, _ref, _results;
    output = {};
    for (key = 0, _ref = array.length; 0 <= _ref ? key < _ref : key > _ref; 0 <= _ref ? key++ : key--) output[array[key]] = array[key];
    _results = [];
    for (key in output) value = output[key], _results.push(value);
    return _results;
  }, exports.merge = merge = function(l1, l2) {
    var l;
    return l = [], l1.map(function(x) {
      return l.push(x);
    }), l2.map(function(x) {
      return l.push(x);
    }), unique(l);
  }, exports.intersection = intersection = function(l1, l2) {
    var i, _i, _len;
    for (_i = 0, _len = l1.length; _i < _len; _i++) {
      i = l1[_i];
      if (__indexOf.call(l2, i) >= 0) return i;
    }
    return null;
  }, exports.arrayToDict = function(arr) {
    var d, i, _i, _len;
    d = {};
    for (_i = 0, _len = arr.length; _i < _len; _i++) i = arr[_i], d[i] ? d[i]++ : d[i] = 1;
    return d;
  };
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.ref = {}, exports = window.lastName.plugins.ru.ref) : exports = module.exports, function(exports) {
  return exports.ruFemaleNamesDict = {
    "альвина": 1,
    "анелия": 1,
    "августа": 1,
    "августина": 1,
    "авдотья": 1,
    "авелина": 1,
    "аврелия": 1,
    "аврора": 1,
    "агапия": 1,
    "агата": 1,
    "агафья": 1,
    "агафия": 1,
    "аглаида": 1,
    "аглая": 1,
    "агнеса": 1,
    "агнесса": 1,
    "агния": 1,
    "агриппмеа": 1,
    "агрефена": 1,
    "ада": 1,
    "адина": 1,
    "адель": 1,
    "аделия": 1,
    "аделаида": 1,
    "аза": 1,
    "азалия": 1,
    "аида": 1,
    "айседора": 1,
    "айсылу": 1,
    "акилина": 1,
    "акулина": 1,
    "аксинья": 1,
    "алевтина": 1,
    "александра": 1,
    "алеся": 1,
    "алена": 1,
    "алина": 1,
    "алиса": 1,
    "алия": 1,
    "алла": 1,
    "алика": 1,
    "альбина": 1,
    "альмир": 1,
    "альфия": 1,
    "амина": 1,
    "анастасия": 1,
    "анатолия": 1,
    "ангелина": 1,
    "анжела": 1,
    "анимаиса": 1,
    "анисия": 1,
    "анисья": 1,
    "анна": 1,
    "анита": 1,
    "антонина": 1,
    "антонида": 1,
    "антония": 1,
    "анфиса": 1,
    "анфуса": 1,
    "анфия": 1,
    "амира": 1,
    "аполлинария": 1,
    "аревик": 1,
    "ариадна": 1,
    "арина": 1,
    "аркадия": 1,
    "арсения": 1,
    "арсиана": 1,
    "артемия": 1,
    "асель": 1,
    "аста": 1,
    "астра": 1,
    "астрид": 1,
    "афанасия": 1,
    "афродита": 1,
    "аэлита": 1,
    "аэлла": 1,
    "амалия": 1,
    "бажена": 1,
    "беата": 1,
    "беатриса": 1,
    "бела": 1,
    "белла": 1,
    "беллатриса": 1,
    "берта": 1,
    "богдана": 1,
    "божена": 1,
    "болеслава": 1,
    "борислава": 1,
    "бриджет": 1,
    "бронислава": 1,
    "валентина": 1,
    "валерия": 1,
    "ванда": 1,
    "варвара": 1,
    "василина": 1,
    "василиса": 1,
    "васса": 1,
    "вацлава": 1,
    "вевея": 1,
    "велора": 1,
    "велория": 1,
    "венера": 1,
    "вера": 1,
    "вероника": 1,
    "веселина": 1,
    "веста": 1,
    "видана": 1,
    "викторина": 1,
    "виктория": 1,
    "вилена": 1,
    "виола": 1,
    "виолетта": 1,
    "виоланта": 1,
    "виринея": 1,
    "вита": 1,
    "виталия": 1,
    "виталина": 1,
    "виулена": 1,
    "влада": 1,
    "владилена": 1,
    "владимира": 1,
    "владислава": 1,
    "владлена": 1,
    "власта": 1,
    "воля": 1,
    "всеслава": 1,
    "гайя": 1,
    "гали": 1,
    "галина": 1,
    "ганна": 1,
    "гаяна": 1,
    "гаяния": 1,
    "гвинет": 1,
    "гелена": 1,
    "гелия": 1,
    "гелла": 1,
    "генриетта": 1,
    "гертруда": 1,
    "глафира": 1,
    "гликерия": 1,
    "глория": 1,
    "голуба": 1,
    "горислава": 1,
    "гюльанэ": 1,
    "гюльнара": 1,
    "гюльчитай": 1,
    "даздраперма": 1,
    "дайна": 1,
    "дана": 1,
    "дарья": 1,
    "дария": 1,
    "дарина": 1,
    "дарьяна": 1,
    "декабрина": 1,
    "дея": 1,
    "дия": 1,
    "джиневра": 1,
    "дженнифер": 1,
    "джульета": 1,
    "дианна": 1,
    "дилия": 1,
    "диля": 1,
    "дильфуза": 1,
    "дина": 1,
    "диния": 1,
    "диодора": 1,
    "дионисия": 1,
    "добрава": 1,
    "домна": 1,
    "домина": 1,
    "домника": 1,
    "доминика": 1,
    "донара": 1,
    "дорофея": 1,
    "доротея": 1,
    "ева": 1,
    "евгения": 1,
    "евдокия": 1,
    "евлалия": 1,
    "евлампия": 1,
    "евпраксия": 1,
    "евстолия": 1,
    "евфалия": 1,
    "евфросиния": 1,
    "екатерина": 1,
    "елена": 1,
    "елизавета": 1,
    "еликонида": 1,
    "ермиония": 1,
    "есения": 1,
    "ефимия": 1,
    "евфремия": 1,
    "жанна": 1,
    "ждана": 1,
    "жаннэ": 1,
    "жасмина": 1,
    "забава": 1,
    "заира": 1,
    "зара": 1,
    "зарема": 1,
    "зарина": 1,
    "зорина": 1,
    "заряна": 1,
    "зауре": 1,
    "звенислава": 1,
    "земфира": 1,
    "зиля": 1,
    "зинаида": 1,
    "зиновия": 1,
    "злата": 1,
    "зозан": 1,
    "зоя": 1,
    "зульфия": 1,
    "иванна": 1,
    "ида": 1,
    "илария": 1,
    "илиана": 1,
    "илона": 1,
    "ильмира": 1,
    "инга": 1,
    "индира": 1,
    "инесса": 1,
    "инна": 1,
    "иоанна": 1,
    "иона": 1,
    "ипатия": 1,
    "ипполита": 1,
    "ирада": 1,
    "ираида": 1,
    "ирена": 1,
    "ироида": 1,
    "ираклия": 1,
    "ирина": 1,
    "исидора": 1,
    "искра": 1,
    "ифигения": 1,
    "ия": 1,
    "кадрия": 1,
    "кермен": 1,
    "калиса": 1,
    "каллиста": 1,
    "камилла": 1,
    "камила": 1,
    "капитолина": 1,
    "карина": 1,
    "каролина": 1,
    "катерина": 1,
    "кира": 1,
    "кирилла": 1,
    "клавдия": 1,
    "клара": 1,
    "клариса": 1,
    "кларисса": 1,
    "клеопатра": 1,
    "клио": 1,
    "клер": 1,
    "конкордия": 1,
    "констанция": 1,
    "кристина": 1,
    "ксения": 1,
    "лавиния": 1,
    "лада": 1,
    "лана": 1,
    "лариса": 1,
    "лаура": 1,
    "лейла": 1,
    "лема": 1,
    "лена": 1,
    "лениана": 1,
    "ленина": 1,
    "леонида": 1,
    "леонила": 1,
    "леонтия": 1,
    "леся": 1,
    "ливия": 1,
    "лидия": 1,
    "лилиана": 1,
    "лилия": 1,
    "лилит": 1,
    "лина": 1,
    "лира": 1,
    "лия": 1,
    "лея": 1,
    "лора": 1,
    "луиза": 1,
    "лукерия": 1,
    "лукиана": 1,
    "лукина": 1,
    "люцина": 1,
    "лусинэ": 1,
    "любава": 1,
    "любовь": 1,
    "любомира": 1,
    "людмила": 1,
    "ляля": 1,
    "мавра": 1,
    "магда": 1,
    "магдалина": 1,
    "мадлен": 1,
    "майя": 1,
    "мая": 1,
    "мальвина": 1,
    "маргарита": 1,
    "мариана": 1,
    "марьяна": 1,
    "марианна": 1,
    "мариетта": 1,
    "мариэтта": 1,
    "марика": 1,
    "марина": 1,
    "мария": 1,
    "марья": 1,
    "мари": 1,
    "марлен": 1,
    "марлена": 1,
    "марта": 1,
    "марфа": 1,
    "матильда": 1,
    "матрена": 1,
    "матрёна": 1,
    "матрона": 1,
    "мелания": 1,
    "меланья": 1,
    "мелитина": 1,
    "милада": 1,
    "милана": 1,
    "милен": 1,
    "милица": 1,
    "милия": 1,
    "милослава": 1,
    "мира": 1,
    "мирра": 1,
    "мирослава": 1,
    "митродора": 1,
    "млада": 1,
    "мстислава": 1,
    "нада": 1,
    "надежда": 1,
    "надия": 1,
    "наина": 1,
    "наира": 1,
    "нана": 1,
    "настасья": 1,
    "наталья": 1,
    "наталия": 1,
    "нелли": 1,
    "неонила": 1,
    "ника": 1,
    "нина": 1,
    "нинелла": 1,
    "нинель": 1,
    "новелла": 1,
    "нонна": 1,
    "нора": 1,
    "нуркыз": 1,
    "насиба": 1,
    "оксана": 1,
    "октавия": 1,
    "октябрина": 1,
    "олеся": 1,
    "оливия": 1,
    "олимпиада": 1,
    "олимпия": 1,
    "ольга": 1,
    "офелия": 1,
    "павла": 1,
    "павлина": 1,
    "патриция": 1,
    "пелагея": 1,
    "платонида": 1,
    "поликсена": 1,
    "полина": 1,
    "правдина": 1,
    "прасковья": 1,
    "пенелопа": 1,
    "полислава": 1,
    "рада": 1,
    "радмила": 1,
    "раиса": 1,
    "раймонда": 1,
    "раялла": 1,
    "ревмира": 1,
    "регина": 1,
    "рената": 1,
    "римма": 1,
    "рогнеда": 1,
    "роза": 1,
    "розалина": 1,
    "розалия": 1,
    "розана": 1,
    "роксан": 1,
    "ростислава": 1,
    "руслана": 1,
    "руфина": 1,
    "руфь": 1,
    "раида": 1,
    "сабина": 1,
    "сабрина": 1,
    "саломея": 1,
    "соломея": 1,
    "самира": 1,
    "светлана": 1,
    "светозара": 1,
    "светослава": 1,
    "свобода": 1,
    "святослава": 1,
    "севастьяна": 1,
    "северина": 1,
    "селена": 1,
    "селина": 1,
    "селестина": 1,
    "серафима": 1,
    "сергияна": 1,
    "сильва": 1,
    "агриппина": 1,
    "алёна": 1,
    "вилора": 1,
    "вилория": 1,
    "джульетта": 1,
    "диана": 1,
    "евфимия": 1,
    "ефросиния": 1,
    "калерия": 1,
    "милена": 1,
    "муза": 1,
    "савина": 1,
    "сильвия": 1,
    "симона": 1,
    "слава": 1,
    "славяна": 1,
    "снежана": 1,
    "софья": 1,
    "софия": 1,
    "станислава": 1,
    "стелла": 1,
    "степанида": 1,
    "стефанида": 1,
    "стефания": 1,
    "сусанна": 1,
    "сосанна": 1,
    "сюзанна": 1,
    "таира": 1,
    "таисия": 1,
    "тальяна": 1,
    "тамара": 1,
    "тамила": 1,
    "томила": 1,
    "татьяна": 1,
    "текуса": 1,
    "тереза": 1,
    "улита": 1,
    "ульяна": 1,
    "услада": 1,
    "устинья": 1,
    "фаина": 1,
    "февронья": 1,
    "феликсана": 1,
    "фелицата": 1,
    "фелицитата": 1,
    "фелиция": 1,
    "федора": 1,
    "феодора": 1,
    "феодосия": 1,
    "феодосья": 1,
    "феоктиста": 1,
    "феофания": 1,
    "феона": 1,
    "флавия": 1,
    "флора": 1,
    "флория": 1,
    "флорентина": 1,
    "флоренция": 1,
    "флориана": 1,
    "фотина": 1,
    "харита": 1,
    "харитина": 1,
    "хиония": 1,
    "христина": 1,
    "цецилия": 1,
    "чеслава": 1,
    "эвелина": 1,
    "эвридика": 1,
    "эдда": 1,
    "элеонора": 1,
    "элина": 1,
    "эльвира": 1,
    "эльмира": 1,
    "эльза": 1,
    "эмилия": 1,
    "эмма": 1,
    "эрика": 1,
    "эсфирь": 1,
    "юдифь": 1,
    "юзефа": 1,
    "юлиана": 1,
    "юлитта": 1,
    "юлия": 1,
    "юманита": 1,
    "юния": 1,
    "юнона": 1,
    "юстина": 1,
    "ядвига": 1,
    "яна": 1,
    "янина": 1,
    "яромира": 1,
    "ярослава": 1
  }, exports.ruMaleNamesDict = {
    "ааран": 1,
    "аарен": 1,
    "ааррон": 1,
    "аб": 1,
    "аббат": 1,
    "абботт": 1,
    "абей": 1,
    "абелл": 1,
    "абель": 1,
    "абнар": 1,
    "абнер": 1,
    "абнор": 1,
    "абот": 1,
    "аботт": 1,
    "абрам": 1,
    "абран": 1,
    "абрахам": 1,
    "абсалон": 1,
    "авангард": 1,
    "август": 1,
    "августин": 1,
    "авдей": 1,
    "авдий": 1,
    "авенир": 1,
    "аверилл": 1,
    "аверкий": 1,
    "авксентий": 1,
    "аврам": 1,
    "аврор": 1,
    "аврорий": 1,
    "агап": 1,
    "аггей": 1,
    "агей": 1,
    "адам": 1,
    "аддам": 1,
    "аддисон": 1,
    "аден": 1,
    "адий": 1,
    "адисон": 1,
    "адиссон": 1,
    "адлэй": 1,
    "адней": 1,
    "адольф": 1,
    "адонис": 1,
    "адриан": 1,
    "адэйр": 1,
    "адэр": 1,
    "азия": 1,
    "азэлстан": 1,
    "айбл": 1,
    "айзек": 1,
    "айк": 1,
    "ак": 1,
    "акей": 1,
    "акерлеа": 1,
    "акерлей": 1,
    "акерли": 1,
    "аки": 1,
    "аким": 1,
    "аклеа": 1,
    "аклей": 1,
    "акли": 1,
    "аксён": 1,
    "актон": 1,
    "акэль": 1,
    "алан": 1,
    "аластеир": 1,
    "аластэйр": 1,
    "алвар": 1,
    "алвен": 1,
    "алви": 1,
    "алвин": 1,
    "алвис": 1,
    "алгар": 1,
    "алджернон": 1,
    "алевтин": 1,
    "алеистер": 1,
    "алек": 1,
    "алекс": 1,
    "александр": 1,
    "алексей": 1,
    "ален": 1,
    "алестер": 1,
    "алжир": 1,
    "алик": 1,
    "аликс": 1,
    "алим": 1,
    "алисандр": 1,
    "алисдэйр": 1,
    "алиссандр": 1,
    "алистер": 1,
    "алистэйр": 1,
    "аллан": 1,
    "аллен": 1,
    "аллин": 1,
    "аллистер": 1,
    "аллистир": 1,
    "аллистэйр": 1,
    "алтон": 1,
    "алф": 1,
    "алфонзо": 1,
    "алфорд": 1,
    "алфрид": 1,
    "альберт": 1,
    "альбин": 1,
    "альвиан": 1,
    "альвин": 1,
    "альдина": 1,
    "альпин": 1,
    "альтаир": 1,
    "альфа": 1,
    "альфи": 1,
    "альфред": 1,
    "алэйстер": 1,
    "алэйстэйр": 1,
    "амби": 1,
    "амброуз": 1,
    "амедеус": 1,
    "амиас": 1,
    "амори": 1,
    "амос": 1,
    "амьяс": 1,
    "анакин": 1,
    "ананий": 1,
    "анастасий": 1,
    "анатолий": 1,
    "анвар": 1,
    "ангел": 1,
    "ангес": 1,
    "андерсон": 1,
    "анджелл": 1,
    "андрей": 1,
    "андреян": 1,
    "андриан": 1,
    "андрон": 1,
    "анж": 1,
    "анис": 1,
    "анисий": 1,
    "анисим": 1,
    "анри": 1,
    "анском": 1,
    "анскомб": 1,
    "ансон": 1,
    "антван": 1,
    "антип": 1,
    "антон": 1,
    "антоний": 1,
    "антонин": 1,
    "антуан": 1,
    "аполлинарий": 1,
    "аполлон": 1,
    "арам": 1,
    "арвид": 1,
    "аргент": 1,
    "арден": 1,
    "арефий": 1,
    "арий": 1,
    "арик": 1,
    "арил": 1,
    "арин": 1,
    "аристарх": 1,
    "аркадий": 1,
    "аркелл": 1,
    "арлен": 1,
    "арли": 1,
    "арман": 1,
    "армен": 1,
    "арн": 1,
    "арне": 1,
    "арни": 1,
    "арнольд": 1,
    "арран": 1,
    "аррин": 1,
    "аррон": 1,
    "арсен": 1,
    "арсений": 1,
    "арт": 1,
    "артамон": 1,
    "артемий": 1,
    "арти": 1,
    "артур": 1,
    "артём": 1,
    "архип": 1,
    "арчи": 1,
    "арчибальд": 1,
    "аселет": 1,
    "аселин": 1,
    "асер": 1,
    "аскольд": 1,
    "астон": 1,
    "атеист": 1,
    "афанасий": 1,
    "афиноген": 1,
    "афтон": 1,
    "аффтон": 1,
    "ахмат": 1,
    "ахмет": 1,
    "ачилл": 1,
    "аш": 1,
    "ашер": 1,
    "ашот": 1,
    "аштон": 1,
    "баграт": 1,
    "бад": 1,
    "бадди": 1,
    "бажен": 1,
    "баз": 1,
    "базилик": 1,
    "байрон": 1,
    "байярд": 1,
    "бак": 1,
    "бакстер": 1,
    "балдер": 1,
    "балдрик": 1,
    "бамби": 1,
    "баптист": 1,
    "бардолф": 1,
    "барии": 1,
    "барклей": 1,
    "барнабас": 1,
    "барни": 1,
    "барнэби": 1,
    "барретт": 1,
    "барри": 1,
    "барт": 1,
    "бартоломей": 1,
    "бассетт": 1,
    "бастер": 1,
    "бастиан": 1,
    "батч": 1,
    "баян": 1,
    "беван": 1,
    "беверли": 1,
    "бевис": 1,
    "бедивир": 1,
    "бейб": 1,
    "бейлей": 1,
    "бейлие": 1,
    "бен": 1,
    "бенджамин": 1,
    "бенджи": 1,
    "бенедикт": 1,
    "бенет": 1,
    "беннетт": 1,
    "бенни": 1,
    "бенние": 1,
    "бенсон": 1,
    "бентлей": 1,
    "бентон": 1,
    "беорегард": 1,
    "бердт": 1,
    "беренгар": 1,
    "беренджер": 1,
    "берет": 1,
    "бернард": 1,
    "берни": 1,
    "берри": 1,
    "берт": 1,
    "берти": 1,
    "бертольд": 1,
    "бертон": 1,
    "бертрам": 1,
    "бертран": 1,
    "бивис": 1,
    "билл": 1,
    "билли": 1,
    "бисш": 1,
    "биф": 1,
    "блейн": 1,
    "близэ": 1,
    "блисс": 1,
    "блэйз": 1,
    "блэйк": 1,
    "блэйн": 1,
    "блэр": 1,
    "боб": 1,
    "бобби": 1,
    "богдан": 1,
    "боеслав": 1,
    "болдуин": 1,
    "болеслав": 1,
    "боллард": 1,
    "бомонт": 1,
    "бонифэйс": 1,
    "боримир": 1,
    "борис": 1,
    "борислав": 1,
    "боян": 1,
    "брадлей": 1,
    "браеден": 1,
    "брайен": 1,
    "брайон": 1,
    "бранден": 1,
    "брандон": 1,
    "браннон": 1,
    "брейден": 1,
    "брейдн": 1,
    "брендан": 1,
    "бренден": 1,
    "брендон": 1,
    "бреннан": 1,
    "брент": 1,
    "брентон": 1,
    "брет": 1,
    "бретт": 1,
    "бриар": 1,
    "брион": 1,
    "брис": 1,
    "бриско": 1,
    "бриттон": 1,
    "бриэм": 1,
    "бродерик": 1,
    "броди": 1,
    "броз": 1,
    "брок": 1,
    "бронислав": 1,
    "бронт": 1,
    "броуди": 1,
    "броук": 1,
    "брук": 1,
    "брукс": 1,
    "бруно": 1,
    "брутус": 1,
    "брьянт": 1,
    "брэд": 1,
    "брэди": 1,
    "брэдфорд": 1,
    "брэйден": 1,
    "брэйди": 1,
    "брэм": 1,
    "брэн": 1,
    "брюс": 1,
    "брююс": 1,
    "будимир": 1,
    "буз": 1,
    "букер": 1,
    "булат": 1,
    "бью": 1,
    "бэйли": 1,
    "вавила": 1,
    "вадим": 1,
    "вал": 1,
    "валентайн": 1,
    "валентин": 1,
    "валериан": 1,
    "валерий": 1,
    "валерьян": 1,
    "вальдемар": 1,
    "вальтер": 1,
    "ванадий": 1,
    "вард": 1,
    "варлаам": 1,
    "варлам": 1,
    "варлен": 1,
    "вартан": 1,
    "варфоломей": 1,
    "василий": 1,
    "василько": 1,
    "ваухан": 1,
    "вахтанг": 1,
    "вацлав": 1,
    "вашингтон": 1,
    "вебстер": 1,
    "велдон": 1,
    "велимир": 1,
    "велислав": 1,
    "велор": 1,
    "велорий": 1,
    "венедикт": 1,
    "вениамин": 1,
    "вер": 1,
    "вергилий": 1,
    "верджил": 1,
    "верн": 1,
    "вернон": 1,
    "вестер": 1,
    "вестлей": 1,
    "вестон": 1,
    "вик": 1,
    "викентий": 1,
    "виктор": 1,
    "вил": 1,
    "вилберн": 1,
    "вилей": 1,
    "вилен": 1,
    "вилий": 1,
    "вилиор": 1,
    "вилки": 1,
    "вилл": 1,
    "вилли": 1,
    "виллоби": 1,
    "вилмар": 1,
    "вилмер": 1,
    "вилмот": 1,
    "вилор": 1,
    "вилорг": 1,
    "вилорий": 1,
    "вилсон": 1,
    "вилф": 1,
    "вилфорд": 1,
    "виль": 1,
    "вильгельм": 1,
    "вильтон": 1,
    "вильям": 1,
    "вин": 1,
    "виндзор": 1,
    "винни": 1,
    "винс": 1,
    "винсент": 1,
    "винслоу": 1,
    "винтроп": 1,
    "винцент": 1,
    "виолен": 1,
    "вирджиль": 1,
    "виссарион": 1,
    "вистан": 1,
    "виталий": 1,
    "витейкр": 1,
    "витней": 1,
    "витольд": 1,
    "влад": 1,
    "владелин": 1,
    "владилен": 1,
    "владимир": 1,
    "владислав": 1,
    "владлен": 1,
    "влас": 1,
    "власий": 1,
    "воган": 1,
    "вогн": 1,
    "воин": 1,
    "воислав": 1,
    "волдо": 1,
    "волемир": 1,
    "волкер": 1,
    "воллис": 1,
    "володар": 1,
    "вольдемар": 1,
    "вольмир": 1,
    "вольт": 1,
    "вольф": 1,
    "вольфрам": 1,
    "воспой": 1,
    "всеволод": 1,
    "всемил": 1,
    "вуди": 1,
    "вудроу": 1,
    "вулф": 1,
    "вьятт": 1,
    "вэйд": 1,
    "вэйланд": 1,
    "вэнс": 1,
    "вячеслав": 1,
    "габби": 1,
    "габриель": 1,
    "габриэль": 1,
    "гавриил": 1,
    "гаврил": 1,
    "гаврила": 1,
    "гаврило": 1,
    "гай": 1,
    "гайдар": 1,
    "гайлс": 1,
    "галактион": 1,
    "гален": 1,
    "галий": 1,
    "гамильтон": 1,
    "гамлет": 1,
    "гантэр": 1,
    "гаральд": 1,
    "гарван": 1,
    "гарей": 1,
    "гарибальди": 1,
    "гарланд": 1,
    "гарнет": 1,
    "гарольд": 1,
    "гарри": 1,
    "гаррий": 1,
    "гарс": 1,
    "гарфилд": 1,
    "гас": 1,
    "гаспар": 1,
    "гваделупа": 1,
    "гвидон": 1,
    "гейб": 1,
    "гейл": 1,
    "гейр": 1,
    "гектор": 1,
    "гелеон": 1,
    "гелиан": 1,
    "гелий": 1,
    "ген": 1,
    "гений": 1,
    "геннадий": 1,
    "генри": 1,
    "генрих": 1,
    "геодар": 1,
    "георгий": 1,
    "геральд": 1,
    "герасим": 1,
    "герберт": 1,
    "герман": 1,
    "гермоген": 1,
    "герольд": 1,
    "геронт": 1,
    "геронтий": 1,
    "герт": 1,
    "гертруд": 1,
    "гидеон": 1,
    "гильберт": 1,
    "гисберт": 1,
    "гладвин": 1,
    "гланвилл": 1,
    "глеб": 1,
    "глендауэр": 1,
    "гленн": 1,
    "глэн": 1,
    "говард": 1,
    "годвин": 1,
    "годфри": 1,
    "голлагэр": 1,
    "голладжер": 1,
    "гомер": 1,
    "горазд": 1,
    "гораций": 1,
    "горд": 1,
    "гордей": 1,
    "горден": 1,
    "гордий": 1,
    "гордон": 1,
    "горимир": 1,
    "горислав": 1,
    "горн": 1,
    "граем": 1,
    "грай": 1,
    "гранвилл": 1,
    "гранд": 1,
    "гранит": 1,
    "грахэйм": 1,
    "грег": 1,
    "грей": 1,
    "гренвилл": 1,
    "григорий": 1,
    "гриир": 1,
    "грир": 1,
    "гриффин": 1,
    "гриффит": 1,
    "гровер": 1,
    "грэг": 1,
    "грэгори": 1,
    "грэди": 1,
    "грэм": 1,
    "гудвин": 1,
    "гудзон": 1,
    "гурий": 1,
    "густав": 1,
    "гэй": 1,
    "гэйбл": 1,
    "гэйг": 1,
    "гэйдж": 1,
    "гэйелорд": 1,
    "гэйл": 1,
    "гэйлон": 1,
    "гэйлорд": 1,
    "гэйр": 1,
    "гэлл": 1,
    "гэри": 1,
    "давей": 1,
    "дави": 1,
    "давид": 1,
    "давыд": 1,
    "дад": 1,
    "дадда": 1,
    "дадли": 1,
    "даймонд": 1,
    "дакей": 1,
    "дакота": 1,
    "дакс": 1,
    "далтон": 1,
    "дамайон": 1,
    "дамиан": 1,
    "дамир": 1,
    "дан": 1,
    "дана": 1,
    "дани": 1,
    "даниар": 1,
    "даниил": 1,
    "данил": 1,
    "данила": 1,
    "данило": 1,
    "даниэль": 1,
    "данки": 1,
    "данни": 1,
    "дар": 1,
    "дарби": 1,
    "дарвин": 1,
    "дарден": 1,
    "дарен": 1,
    "дариан": 1,
    "дарил": 1,
    "дарин": 1,
    "дарки": 1,
    "дарнелл": 1,
    "даррел": 1,
    "даррен": 1,
    "даррил": 1,
    "даррин": 1,
    "даррэль": 1,
    "дасти": 1,
    "дастин": 1,
    "дау": 1,
    "дафф": 1,
    "даффи": 1,
    "дашилл": 1,
    "дван": 1,
    "двэйн": 1,
    "деай": 1,
    "деван": 1,
    "девен": 1,
    "девереукс": 1,
    "девин": 1,
    "девон": 1,
    "дейв": 1,
    "дейл": 1,
    "дейрлл": 1,
    "дейрн": 1,
    "декабрий": 1,
    "деклан": 1,
    "декстер": 1,
    "делберт": 1,
    "делл": 1,
    "делмар": 1,
    "делрой": 1,
    "дементий": 1,
    "деметриус": 1,
    "демид": 1,
    "демократ": 1,
    "демон": 1,
    "демьян": 1,
    "ден": 1,
    "денвер": 1,
    "денеб": 1,
    "дензэль": 1,
    "дени": 1,
    "денил": 1,
    "денис": 1,
    "деннис": 1,
    "дентон": 1,
    "деон": 1,
    "деонн": 1,
    "деонт": 1,
    "дерби": 1,
    "дерек": 1,
    "дерик": 1,
    "дермот": 1,
    "дерок": 1,
    "деррен": 1,
    "дерри": 1,
    "деррил": 1,
    "дефорест": 1,
    "дефоррест": 1,
    "дешон": 1,
    "джадд": 1,
    "джадин": 1,
    "джай": 1,
    "джайлс": 1,
    "джак": 1,
    "джамар": 1,
    "джамей": 1,
    "джамисон": 1,
    "джарвис": 1,
    "джаред": 1,
    "джарод": 1,
    "джарред": 1,
    "джарретт": 1,
    "джаррод": 1,
    "джаспер": 1,
    "джасти": 1,
    "джастин": 1,
    "джеб": 1,
    "джед": 1,
    "джедидиа": 1,
    "джейдн": 1,
    "джейк": 1,
    "джейлн": 1,
    "джейми": 1,
    "джеймс": 1,
    "джейрт": 1,
    "джейсон": 1,
    "джекки": 1,
    "джекоб": 1,
    "джем": 1,
    "дженкин": 1,
    "джеп": 1,
    "джер": 1,
    "джералд": 1,
    "джеральд": 1,
    "джерард": 1,
    "джерваз": 1,
    "джервис": 1,
    "джереми": 1,
    "джери": 1,
    "джермэйн": 1,
    "джеролд": 1,
    "джером": 1,
    "джеррард": 1,
    "джерред": 1,
    "джерри": 1,
    "джеррод": 1,
    "джерролд": 1,
    "джес": 1,
    "джесси": 1,
    "джетро": 1,
    "джетт": 1,
    "джеф": 1,
    "джеффери": 1,
    "джефферсон": 1,
    "джеффрей": 1,
    "джеффри": 1,
    "джиб": 1,
    "джид": 1,
    "джиди": 1,
    "джил": 1,
    "джим": 1,
    "джими": 1,
    "джимми": 1,
    "джисберт": 1,
    "джиффард": 1,
    "джо": 1,
    "джоб": 1,
    "джоби": 1,
    "джоджо": 1,
    "джоди": 1,
    "джозеф": 1,
    "джой": 1,
    "джойс": 1,
    "джон": 1,
    "джоназан": 1,
    "джоназон": 1,
    "джонасон": 1,
    "джонатан": 1,
    "джоней": 1,
    "джони": 1,
    "джонни": 1,
    "джонти": 1,
    "джорги": 1,
    "джордан": 1,
    "джордж": 1,
    "джорди": 1,
    "джордон": 1,
    "джосс": 1,
    "джоул": 1,
    "джош": 1,
    "джошоа": 1,
    "джошуа": 1,
    "джулс": 1,
    "джульян": 1,
    "джустис": 1,
    "джьюд": 1,
    "джэй": 1,
    "джэйд": 1,
    "джэйда": 1,
    "джэйден": 1,
    "джэйдон": 1,
    "джэйкоб": 1,
    "джэйлен": 1,
    "джэйлин": 1,
    "джэйлон": 1,
    "джэймес": 1,
    "джэйсон": 1,
    "джэксон": 1,
    "джэмини": 1,
    "джэмми": 1,
    "джэн": 1,
    "ди": 1,
    "диакон": 1,
    "дигби": 1,
    "диггори": 1,
    "дигори": 1,
    "дидим": 1,
    "дизон": 1,
    "дик": 1,
    "дики": 1,
    "дикки": 1,
    "дил": 1,
    "дилан": 1,
    "дилберт": 1,
    "димер": 1,
    "димитрий": 1,
    "дин": 1,
    "диндр": 1,
    "дионис": 1,
    "дионисий": 1,
    "дирк": 1,
    "дмитрий": 1,
    "доб": 1,
    "добрыня": 1,
    "додж": 1,
    "дольф": 1,
    "дом": 1,
    "доменик": 1,
    "доминик": 1,
    "дон": 1,
    "дональд": 1,
    "дональт": 1,
    "донат": 1,
    "донни": 1,
    "донован": 1,
    "дор": 1,
    "дориан": 1,
    "дорофей": 1,
    "доусон": 1,
    "драйк": 1,
    "древ": 1,
    "дрейвн": 1,
    "дуайт": 1,
    "дуан": 1,
    "дуг": 1,
    "дуги": 1,
    "дуглас": 1,
    "дункан": 1,
    "дунстан": 1,
    "дью": 1,
    "дьюей": 1,
    "дьюэйн": 1,
    "дэвид": 1,
    "дэвис": 1,
    "дэй": 1,
    "дэйви": 1,
    "дэйн": 1,
    "дэйтон": 1,
    "дэн": 1,
    "дэни": 1,
    "дэниел": 1,
    "дэнни": 1,
    "дэррик": 1,
    "дэшон": 1,
    "дюк": 1,
    "евгений": 1,
    "евграф": 1,
    "евдоким": 1,
    "евлампий": 1,
    "евлогий": 1,
    "евсей": 1,
    "евстафий": 1,
    "егор": 1,
    "елеазар": 1,
    "елизар": 1,
    "елисей": 1,
    "емельян": 1,
    "епифан": 1,
    "еремей": 1,
    "ермак": 1,
    "ермил": 1,
    "ермолай": 1,
    "ерофей": 1,
    "еруслан": 1,
    "ефим": 1,
    "ефрем": 1,
    "ждан": 1,
    "жерар": 1,
    "жозеф": 1,
    "жорес": 1,
    "жюль": 1,
    "завир": 1,
    "зак": 1,
    "закери": 1,
    "зандер": 1,
    "захар": 1,
    "захарий": 1,
    "зачариа": 1,
    "зачэри": 1,
    "зед": 1,
    "зедекиа": 1,
    "зек": 1,
    "зигмунд": 1,
    "зигфрид": 1,
    "зиновий": 1,
    "зорий": 1,
    "зосим": 1,
    "зосима": 1,
    "зот": 1,
    "зубин": 1,
    "зэофилус": 1,
    "иб": 1,
    "ибрагим": 1,
    "иван": 1,
    "игнат": 1,
    "игнатий": 1,
    "игнатиус": 1,
    "игорь": 1,
    "ид": 1,
    "иероним": 1,
    "иззи": 1,
    "изидор": 1,
    "измаил": 1,
    "измайло": 1,
    "изяслав": 1,
    "ий": 1,
    "икар": 1,
    "илар": 1,
    "иларий": 1,
    "иларион": 1,
    "илий": 1,
    "илиодор": 1,
    "илларион": 1,
    "илья": 1,
    "имон": 1,
    "инглеберт": 1,
    "инграм": 1,
    "инди": 1,
    "индиана": 1,
    "индиго": 1,
    "инесент": 1,
    "иниго": 1,
    "иннокентий": 1,
    "иоанн": 1,
    "иорик": 1,
    "иосиф": 1,
    "ипат": 1,
    "ипатий": 1,
    "ипполит": 1,
    "ираклий": 1,
    "ирвайн": 1,
    "ирвин": 1,
    "ирвинг": 1,
    "ириней": 1,
    "ириний": 1,
    "ирл": 1,
    "ирм": 1,
    "ирнест": 1,
    "исай": 1,
    "исайя": 1,
    "исак": 1,
    "исакий": 1,
    "исей": 1,
    "исидор": 1,
    "иссак": 1,
    "исси": 1,
    "истер": 1,
    "июлий": 1,
    "йорк": 1,
    "ка": 1,
    "кадмус": 1,
    "казимир": 1,
    "каин": 1,
    "каир": 1,
    "кайд": 1,
    "кайл": 1,
    "кал": 1,
    "калин": 1,
    "калина": 1,
    "каллен": 1,
    "кам": 1,
    "камден": 1,
    "камиль": 1,
    "камрон": 1,
    "капитон": 1,
    "карбрей": 1,
    "карбри": 1,
    "карвер": 1,
    "карей": 1,
    "карен": 1,
    "карл": 1,
    "карлайл": 1,
    "карлейл": 1,
    "карлин": 1,
    "карлтон": 1,
    "карм": 1,
    "кармий": 1,
    "карп": 1,
    "каррол": 1,
    "картер": 1,
    "касиди": 1,
    "каспар": 1,
    "каспер": 1,
    "кассиди": 1,
    "касьян": 1,
    "квентин": 1,
    "квинтин": 1,
    "кеван": 1,
    "кевин": 1,
    "кей": 1,
    "кейденс": 1,
    "кейдн": 1,
    "кейлб": 1,
    "кеймрон": 1,
    "кейси": 1,
    "келвин": 1,
    "келкей": 1,
    "келл": 1,
    "келли": 1,
    "келсей": 1,
    "кемп": 1,
    "кен": 1,
    "кендал": 1,
    "кендол": 1,
    "кендрик": 1,
    "кенелм": 1,
    "кензи": 1,
    "кенит": 1,
    "кеннеди": 1,
    "кеннет": 1,
    "кенни": 1,
    "кеннит": 1,
    "кенрик": 1,
    "кент": 1,
    "кентиджерн": 1,
    "кентон": 1,
    "кермит": 1,
    "керней": 1,
    "керр": 1,
    "керри": 1,
    "керт": 1,
    "кертис": 1,
    "кешон": 1,
    "ки": 1,
    "киаран": 1,
    "килан": 1,
    "килер": 1,
    "килиан": 1,
    "киллиан": 1,
    "ким": 1,
    "кимбелайн": 1,
    "кимберли": 1,
    "кимбол": 1,
    "кимбэль": 1,
    "кин": 1,
    "кинан": 1,
    "кинастон": 1,
    "кинг": 1,
    "кингслей": 1,
    "кип": 1,
    "киприан": 1,
    "кир": 1,
    "киран": 1,
    "кирби": 1,
    "кирилл": 1,
    "кирк": 1,
    "кирон": 1,
    "кирус": 1,
    "кит": 1,
    "китон": 1,
    "киф": 1,
    "клавдий": 1,
    "клайв": 1,
    "клайд": 1,
    "кланкей": 1,
    "кланки": 1,
    "кларенс": 1,
    "кларк": 1,
    "клев": 1,
    "клей": 1,
    "клейтон": 1,
    "клем": 1,
    "клемент": 1,
    "клементий": 1,
    "клемми": 1,
    "клетис": 1,
    "клетус": 1,
    "кливленд": 1,
    "клим": 1,
    "климент": 1,
    "климентий": 1,
    "клинт": 1,
    "клинтон": 1,
    "клифтон": 1,
    "клифф": 1,
    "клиффорд": 1,
    "клод": 1,
    "клэйрк": 1,
    "клэр": 1,
    "кодей": 1,
    "коди": 1,
    "коертней": 1,
    "козьма": 1,
    "кола": 1,
    "коламбан": 1,
    "колберт": 1,
    "колби": 1,
    "колдер": 1,
    "колин": 1,
    "коллахан": 1,
    "коллин": 1,
    "коллум": 1,
    "колтен": 1,
    "колтон": 1,
    "колумбий": 1,
    "кольт": 1,
    "конан": 1,
    "конвей": 1,
    "кондрат": 1,
    "кондратий": 1,
    "конлей": 1,
    "коннелл": 1,
    "коннер": 1,
    "коннор": 1,
    "конон": 1,
    "конор": 1,
    "конрад": 1,
    "константин": 1,
    "конфуций": 1,
    "корбин": 1,
    "корделл": 1,
    "корей": 1,
    "кори": 1,
    "корней": 1,
    "корнелий": 1,
    "корнелиус": 1,
    "корнил": 1,
    "кортней": 1,
    "кортни": 1,
    "корэй": 1,
    "коти": 1,
    "коул": 1,
    "коулман": 1,
    "краснослав": 1,
    "крис": 1,
    "криспиан": 1,
    "криспин": 1,
    "кристи": 1,
    "кристиан": 1,
    "кристопэр": 1,
    "кристоф": 1,
    "кристофер": 1,
    "крофорд": 1,
    "крофтон": 1,
    "крэйг": 1,
    "ксавайор": 1,
    "ксавьер": 1,
    "ксан": 1,
    "ксенофонт": 1,
    "ксзавир": 1,
    "кузьма": 1,
    "куин": 1,
    "куинкей": 1,
    "куинси": 1,
    "куинтон": 1,
    "купер": 1,
    "куприян": 1,
    "курт": 1,
    "куртис": 1,
    "кэйд": 1,
    "кэйдн": 1,
    "кэйл": 1,
    "кэйлб": 1,
    "кэймрон": 1,
    "кэйн": 1,
    "кэйси": 1,
    "кэлвин": 1,
    "кэм": 1,
    "кэмп": 1,
    "кэмпбэл": 1,
    "кэри": 1,
    "кюри": 1,
    "лаверн": 1,
    "лавлл": 1,
    "лавр": 1,
    "лаврентий": 1,
    "лаз": 1,
    "лазарь": 1,
    "лайл": 1,
    "лайонел": 1,
    "лаки": 1,
    "ланни": 1,
    "ланфорд": 1,
    "ларион": 1,
    "ларк": 1,
    "ларкин": 1,
    "ларри": 1,
    "лаэрт": 1,
    "лев": 1,
    "леви": 1,
    "левкий": 1,
    "лейврн": 1,
    "лейн": 1,
    "лейтон": 1,
    "лекс": 1,
    "леланд": 1,
    "лель": 1,
    "лем": 1,
    "лемми": 1,
    "лемюэль": 1,
    "лен": 1,
    "ленар": 1,
    "ленард": 1,
    "лени": 1,
    "лениан": 1,
    "леннард": 1,
    "ленни": 1,
    "лео": 1,
    "леон": 1,
    "леонард": 1,
    "леонид": 1,
    "леонтий": 1,
    "леопольд": 1,
    "лермонт": 1,
    "лерой": 1,
    "лес": 1,
    "лесли": 1,
    "лестер": 1,
    "ли": 1,
    "либерт": 1,
    "ливадий": 1,
    "лии": 1,
    "лин": 1,
    "линдон": 1,
    "линдсей": 1,
    "линдси": 1,
    "линкольн": 1,
    "линн": 1,
    "линсей": 1,
    "линтон": 1,
    "линус": 1,
    "линфорд": 1,
    "лионель": 1,
    "лир": 1,
    "лирой": 1,
    "лисандр": 1,
    "литон": 1,
    "лихнис": 1,
    "ллойд": 1,
    "ллью": 1,
    "лльюелин": 1,
    "лльюеллин": 1,
    "ло": 1,
    "ловэль": 1,
    "лойд": 1,
    "лон": 1,
    "лондон": 1,
    "лонни": 1,
    "лонс": 1,
    "лор": 1,
    "лорен": 1,
    "лоренс": 1,
    "лори": 1,
    "лорин": 1,
    "лорис": 1,
    "лорни": 1,
    "лоррин": 1,
    "лосон": 1,
    "лоуэлл": 1,
    "лоэнгрин": 1,
    "лу": 1,
    "лудо": 1,
    "луи": 1,
    "лука": 1,
    "лукиан": 1,
    "лукьян": 1,
    "льюин": 1,
    "льюис": 1,
    "лэйк": 1,
    "лэйн": 1,
    "лэйтон": 1,
    "лэндон": 1,
    "лэнс": 1,
    "лэрри": 1,
    "любим": 1,
    "любомир": 1,
    "людвиг": 1,
    "людовик": 1,
    "люк": 1,
    "люкс": 1,
    "люксен": 1,
    "люсьен": 1,
    "лютер": 1,
    "люциан": 1,
    "маверик": 1,
    "маврикий": 1,
    "мадисон": 1,
    "маеслав": 1,
    "май": 1,
    "майк": 1,
    "майкл": 1,
    "майлз": 1,
    "майрон": 1,
    "майслав": 1,
    "макар": 1,
    "макарий": 1,
    "макей": 1,
    "макензи": 1,
    "маки": 1,
    "макинтош": 1,
    "маккензи": 1,
    "макс": 1,
    "максвелл": 1,
    "максим": 1,
    "максимилиан": 1,
    "максимиллиан": 1,
    "максимильян": 1,
    "малачи": 1,
    "малком": 1,
    "малоун": 1,
    "манлей": 1,
    "манни": 1,
    "манникс": 1,
    "мануил": 1,
    "мануйло": 1,
    "манфред": 1,
    "марат": 1,
    "марвин": 1,
    "мариан": 1,
    "марин": 1,
    "мариус": 1,
    "марк": 1,
    "марка": 1,
    "маркел": 1,
    "маркиан": 1,
    "марко": 1,
    "маркус": 1,
    "марлен": 1,
    "марлин": 1,
    "марлон": 1,
    "марлоу": 1,
    "мармадьюк": 1,
    "марри": 1,
    "марс": 1,
    "марсен": 1,
    "марти": 1,
    "мартиал": 1,
    "мартин": 1,
    "мартын": 1,
    "маршал": 1,
    "маршалл": 1,
    "марьян": 1,
    "масон": 1,
    "мастерман": 1,
    "матвей": 1,
    "матти": 1,
    "мед": 1,
    "мелвилль": 1,
    "мелвин": 1,
    "мельбурн": 1,
    "мерв": 1,
    "мервин": 1,
    "мерди": 1,
    "мердо": 1,
    "мердок": 1,
    "мередит": 1,
    "мерит": 1,
    "меркурий": 1,
    "мерл": 1,
    "мерлин": 1,
    "меррилл": 1,
    "мерритт": 1,
    "мертон": 1,
    "мерфи": 1,
    "мефодий": 1,
    "мечеслав": 1,
    "мечислав": 1,
    "мид": 1,
    "миид": 1,
    "мик": 1,
    "мика": 1,
    "мики": 1,
    "микки": 1,
    "милад": 1,
    "милан": 1,
    "милберн": 1,
    "милен": 1,
    "милий": 1,
    "миллард": 1,
    "мило": 1,
    "милонег": 1,
    "милослав": 1,
    "милтон": 1,
    "милфорд": 1,
    "мир": 1,
    "мирон": 1,
    "мирослав": 1,
    "митчелл": 1,
    "михаил": 1,
    "михайло": 1,
    "мич": 1,
    "мича": 1,
    "мичил": 1,
    "мо": 1,
    "модест": 1,
    "моз": 1,
    "моисей": 1,
    "молком": 1,
    "монолит": 1,
    "монро": 1,
    "монтагью": 1,
    "монтгомери": 1,
    "монте": 1,
    "монти": 1,
    "монтморенки": 1,
    "морган": 1,
    "морген": 1,
    "мордекэй": 1,
    "морис": 1,
    "морлей": 1,
    "моррис": 1,
    "морт": 1,
    "морти": 1,
    "мортимер": 1,
    "мортон": 1,
    "мосс": 1,
    "моэ": 1,
    "мстислав": 1,
    "мулава": 1,
    "мурат": 1,
    "мэйнард": 1,
    "мэйнерд": 1,
    "мэйор": 1,
    "мэйсон": 1,
    "мэйтланд": 1,
    "мэлори": 1,
    "мэль": 1,
    "мэриан": 1,
    "мэрион": 1,
    "мэт": 1,
    "мэтт": 1,
    "мэтти": 1,
    "мэтью": 1,
    "мюд": 1,
    "надир": 1,
    "назаниль": 1,
    "назар": 1,
    "назарий": 1,
    "назим": 1,
    "найджел": 1,
    "найлс": 1,
    "наль": 1,
    "нанди": 1,
    "нат": 1,
    "натан": 1,
    "наум": 1,
    "науэлл": 1,
    "наш": 1,
    "невада": 1,
    "неван": 1,
    "невил": 1,
    "невилл": 1,
    "нед": 1,
    "нейл": 1,
    "нейлл": 1,
    "нейт": 1,
    "нельсон": 1,
    "нео": 1,
    "неон": 1,
    "неонил": 1,
    "нестер": 1,
    "нестор": 1,
    "нивек": 1,
    "нивен": 1,
    "ник": 1,
    "никандр": 1,
    "никанор": 1,
    "никита": 1,
    "никифор": 1,
    "никк": 1,
    "никки": 1,
    "никодим": 1,
    "никола": 1,
    "николай": 1,
    "николас": 1,
    "никон": 1,
    "нил": 1,
    "нили": 1,
    "нимбус": 1,
    "нинел": 1,
    "нинель": 1,
    "нисон": 1,
    "нифонт": 1,
    "ноа": 1,
    "новомир": 1,
    "нодар": 1,
    "ной": 1,
    "нолан": 1,
    "нолл": 1,
    "норберт": 1,
    "норвуд": 1,
    "норд": 1,
    "норм": 1,
    "норман": 1,
    "норманд": 1,
    "норрис": 1,
    "нортон": 1,
    "ноубль": 1,
    "ноэль": 1,
    "ньют": 1,
    "ньютон": 1,
    "оберон": 1,
    "обин": 1,
    "обри": 1,
    "овидий": 1,
    "огастин": 1,
    "огден": 1,
    "огэст": 1,
    "оделл": 1,
    "одиссей": 1,
    "одлей": 1,
    "одран": 1,
    "оз": 1,
    "оззи": 1,
    "океан": 1,
    "оксар": 1,
    "октавиан": 1,
    "октябрин": 1,
    "октябрь": 1,
    "олби": 1,
    "олбэйн": 1,
    "олдвен": 1,
    "олдвин": 1,
    "олден": 1,
    "олдин": 1,
    "олдис": 1,
    "олдон": 1,
    "олдос": 1,
    "олдред": 1,
    "олдус": 1,
    "олдфорд": 1,
    "олег": 1,
    "олей": 1,
    "оли": 1,
    "оливер": 1,
    "олимпий": 1,
    "олластер": 1,
    "олластир": 1,
    "оллгар": 1,
    "оллджер": 1,
    "олли": 1,
    "оллин": 1,
    "оллисдэйр": 1,
    "оллистер": 1,
    "оллистэйр": 1,
    "оллон": 1,
    "оллэйстар": 1,
    "ольгерд": 1,
    "омар": 1,
    "омега": 1,
    "онисим": 1,
    "ора": 1,
    "оран": 1,
    "орвал": 1,
    "орвилл": 1,
    "орест": 1,
    "ориан": 1,
    "ормерод": 1,
    "оррелл": 1,
    "оррин": 1,
    "орсон": 1,
    "осберт": 1,
    "осбоерн": 1,
    "осборн": 1,
    "освальд": 1,
    "осень": 1,
    "осип": 1,
    "оскар": 1,
    "остап": 1,
    "остен": 1,
    "остин": 1,
    "остромир": 1,
    "отис": 1,
    "оттис": 1,
    "отто": 1,
    "оттон": 1,
    "оуин": 1,
    "оуэн": 1,
    "ошин": 1,
    "павел": 1,
    "пайс": 1,
    "палладий": 1,
    "палмер": 1,
    "панкрас": 1,
    "пантелей": 1,
    "пантелеймон": 1,
    "панфил": 1,
    "парамон": 1,
    "паркер": 1,
    "паррис": 1,
    "партизан": 1,
    "пат": 1,
    "патрик": 1,
    "патси": 1,
    "пахом": 1,
    "пеитон": 1,
    "пепин": 1,
    "пересвет": 1,
    "перри": 1,
    "перс": 1,
    "перси": 1,
    "персиваль": 1,
    "петеркин": 1,
    "пимен": 1,
    "пип": 1,
    "пипер": 1,
    "пирр": 1,
    "пирс": 1,
    "пит": 1,
    "питер": 1,
    "платон": 1,
    "пол": 1,
    "поли": 1,
    "поликарп": 1,
    "помпей": 1,
    "портер": 1,
    "порфирий": 1,
    "потап": 1,
    "престон": 1,
    "приам": 1,
    "принц": 1,
    "пров": 1,
    "прозор": 1,
    "прокопий": 1,
    "прокофий": 1,
    "проспер": 1,
    "протас": 1,
    "прохор": 1,
    "пэйс": 1,
    "пэйси": 1,
    "пэйтон": 1,
    "пётр": 1,
    "петр": 1,
    "равель": 1,
    "равен": 1,
    "равиль": 1,
    "радамес": 1,
    "радий": 1,
    "радим": 1,
    "радислав": 1,
    "радомир": 1,
    "раз": 1,
    "раймонд": 1,
    "раймунд": 1,
    "райордан": 1,
    "райт": 1,
    "ралф": 1,
    "ралфи": 1,
    "ральф": 1,
    "ранделл": 1,
    "ранди": 1,
    "рандолф": 1,
    "рандольф": 1,
    "расс": 1,
    "рассел": 1,
    "рассэль": 1,
    "расти": 1,
    "растус": 1,
    "ратмир": 1,
    "рауль": 1,
    "рафаил": 1,
    "рафаэль": 1,
    "рашид": 1,
    "раян": 1,
    "реарден": 1,
    "ревмир": 1,
    "реган": 1,
    "редд": 1,
    "редж": 1,
    "реджи": 1,
    "реджинальд": 1,
    "редклиф": 1,
    "редклифф": 1,
    "редлей": 1,
    "редманд": 1,
    "редмонд": 1,
    "реид": 1,
    "рей": 1,
    "рейли": 1,
    "рейнард": 1,
    "рейнольд": 1,
    "рекс": 1,
    "рем": 1,
    "ренальд": 1,
    "ренат": 1,
    "риган": 1,
    "ригби": 1,
    "рид": 1,
    "ридлей": 1,
    "риель": 1,
    "рик": 1,
    "рикей": 1,
    "рики": 1,
    "рилан": 1,
    "рилей": 1,
    "рили": 1,
    "ринат": 1,
    "рио": 1,
    "риплей": 1,
    "рис": 1,
    "рихард": 1,
    "рич": 1,
    "ричард": 1,
    "ричи": 1,
    "роальд": 1,
    "роб": 1,
    "робби": 1,
    "роберт": 1,
    "робеспьер": 1,
    "роби": 1,
    "робин": 1,
    "робинзон": 1,
    "рован": 1,
    "род": 1,
    "роддж": 1,
    "родджер": 1,
    "родди": 1,
    "родерик": 1,
    "роджер": 1,
    "родион": 1,
    "родни": 1,
    "родолф": 1,
    "рождеро": 1,
    "рой": 1,
    "ройл": 1,
    "ройс": 1,
    "ройстон": 1,
    "роки": 1,
    "ролан": 1,
    "роланд": 1,
    "роли": 1,
    "ролланд": 1,
    "ролли": 1,
    "роман": 1,
    "ромен": 1,
    "ромуальд": 1,
    "рон": 1,
    "рональд": 1,
    "ронни": 1,
    "рори": 1,
    "роско": 1,
    "росс": 1,
    "ростислав": 1,
    "роуланд": 1,
    "роулей": 1,
    "роял": 1,
    "рубен": 1,
    "рубин": 1,
    "руди": 1,
    "рудольф": 1,
    "рудьярд": 1,
    "рунар": 1,
    "руслан": 1,
    "руссо": 1,
    "рустам": 1,
    "рустем": 1,
    "рхетт": 1,
    "рьюб": 1,
    "рэд": 1,
    "рэй": 1,
    "рэйнард": 1,
    "рэйнер": 1,
    "рэйф": 1,
    "рэм": 1,
    "рэндал": 1,
    "рэндалл": 1,
    "рюрик": 1,
    "сава": 1,
    "савва": 1,
    "савелий": 1,
    "савьер": 1,
    "сайг": 1,
    "саймон": 1,
    "салал": 1,
    "салливан": 1,
    "самми": 1,
    "самойло": 1,
    "самсон": 1,
    "самуил": 1,
    "сандфорд": 1,
    "санни": 1,
    "санфорд": 1,
    "свет": 1,
    "светлан": 1,
    "светозар": 1,
    "светослав": 1,
    "свизин": 1,
    "свизун": 1,
    "свиней": 1,
    "святогор": 1,
    "святополк": 1,
    "святослав": 1,
    "себастьян": 1,
    "севард": 1,
    "севастиан": 1,
    "севастьян": 1,
    "север": 1,
    "севериан": 1,
    "северин": 1,
    "северьян": 1,
    "северян": 1,
    "седрик": 1,
    "сеймур": 1,
    "селби": 1,
    "семён": 1,
    "септембер": 1,
    "серапион": 1,
    "серафим": 1,
    "сергей": 1,
    "сесил": 1,
    "сет": 1,
    "сефтон": 1,
    "сивард": 1,
    "сигизмунд": 1,
    "сигманд": 1,
    "сид": 1,
    "сидней": 1,
    "сидор": 1,
    "сила": 1,
    "силас": 1,
    "силвестр": 1,
    "сильвер": 1,
    "сильвест": 1,
    "сильвестр": 1,
    "симеон": 1,
    "симон": 1,
    "синклэйр": 1,
    "сирил": 1,
    "сисар": 1,
    "скай": 1,
    "скилар": 1,
    "скилер": 1,
    "скот": 1,
    "скотти": 1,
    "скуилер": 1,
    "слава": 1,
    "слай": 1,
    "слэйд": 1,
    "совет": 1,
    "сократ": 1,
    "соломон": 1,
    "сони": 1,
    "сонни": 1,
    "софокл": 1,
    "софон": 1,
    "спайк": 1,
    "спарроу": 1,
    "спартак": 1,
    "спенсер": 1,
    "спиридон": 1,
    "спиро": 1,
    "стакей": 1,
    "сталий": 1,
    "сталь": 1,
    "станислав": 1,
    "стаффорд": 1,
    "степан": 1,
    "стерлинг": 1,
    "стеф": 1,
    "стефан": 1,
    "сти": 1,
    "стив": 1,
    "стивен": 1,
    "стиви": 1,
    "стиу": 1,
    "сторм": 1,
    "стратон": 1,
    "сту": 1,
    "стэки": 1,
    "стэн": 1,
    "стэнли": 1,
    "стэнфорд": 1,
    "стюарт": 1,
    "сурен": 1,
    "сэм": 1,
    "сэмюэль": 1,
    "сэнди": 1,
    "тад": 1,
    "таддеус": 1,
    "таир": 1,
    "тай": 1,
    "такер": 1,
    "тал": 1,
    "талбот": 1,
    "таннер": 1,
    "тарас": 1,
    "таскилл": 1,
    "таффи": 1,
    "тед": 1,
    "тейгу": 1,
    "тейдж": 1,
    "теймураз": 1,
    "тейрк": 1,
    "текс": 1,
    "тельнан": 1,
    "тенгиз": 1,
    "тенней": 1,
    "теннизон": 1,
    "тео": 1,
    "теобальд": 1,
    "теодор": 1,
    "теранс": 1,
    "теренс": 1,
    "терентий": 1,
    "терло": 1,
    "терранс": 1,
    "террелл": 1,
    "терренс": 1,
    "терстон": 1,
    "ти": 1,
    "тиарнак": 1,
    "тиарнан": 1,
    "тибалт": 1,
    "тибби": 1,
    "тигран": 1,
    "тигу": 1,
    "тизон": 1,
    "тилар": 1,
    "тилер": 1,
    "тилор": 1,
    "тим": 1,
    "тимми": 1,
    "тимоти": 1,
    "тимофей": 1,
    "тимур": 1,
    "тирелл": 1,
    "тирнан": 1,
    "тирней": 1,
    "тирон": 1,
    "тироун": 1,
    "тиррелл": 1,
    "тит": 1,
    "тихомир": 1,
    "тихон": 1,
    "тоал": 1,
    "тоби": 1,
    "тобиас": 1,
    "тобин": 1,
    "товий": 1,
    "тод": 1,
    "тодд": 1,
    "толли": 1,
    "том": 1,
    "томас": 1,
    "томми": 1,
    "тон": 1,
    "тони": 1,
    "топэр": 1,
    "торез": 1,
    "торий": 1,
    "торлей": 1,
    "торнтон": 1,
    "травис": 1,
    "тракей": 1,
    "трантер": 1,
    "траффорд": 1,
    "траэрн": 1,
    "трев": 1,
    "тревельян": 1,
    "тревор": 1,
    "трейврс": 1,
    "трейс": 1,
    "трейси": 1,
    "трент": 1,
    "трентон": 1,
    "тристан": 1,
    "тристрам": 1,
    "трифон": 1,
    "трой": 1,
    "трофим": 1,
    "труман": 1,
    "туллий": 1,
    "тусон": 1,
    "тэдди": 1,
    "тэди": 1,
    "тэйлер": 1,
    "тэйлор": 1,
    "тэйн": 1,
    "тэйт": 1,
    "тэл": 1,
    "тэмпл": 1,
    "тэрри": 1,
    "уилбер": 1,
    "уиллард": 1,
    "уиллис": 1,
    "уилфред": 1,
    "уилфрид": 1,
    "уильям": 1,
    "уинстон": 1,
    "уинфред": 1,
    "уисдом": 1,
    "улайксс": 1,
    "улиссес": 1,
    "ульяна": 1,
    "уолли": 1,
    "уоллис": 1,
    "уолт": 1,
    "уолтер": 1,
    "уолтон": 1,
    "уорик": 1,
    "уорнер": 1,
    "уоррен": 1,
    "уот": 1,
    "уоткин": 1,
    "уптон": 1,
    "урбан": 1,
    "уриах": 1,
    "устин": 1,
    "уэйн": 1,
    "уэсли": 1,
    "фабиан": 1,
    "фаддей": 1,
    "фадей": 1,
    "фалк": 1,
    "фарид": 1,
    "фарлей": 1,
    "фарон": 1,
    "фарран": 1,
    "февралин": 1,
    "федор": 1,
    "федосий": 1,
    "фелан": 1,
    "фелиз": 1,
    "феликс": 1,
    "фелим": 1,
    "фелис": 1,
    "фентон": 1,
    "феодосий": 1,
    "феофан": 1,
    "ферги": 1,
    "фергус": 1,
    "ферд": 1,
    "ферди": 1,
    "фердинанд": 1,
    "фернан": 1,
    "фернанд": 1,
    "фестер": 1,
    "фестус": 1,
    "фидель": 1,
    "фидо": 1,
    "фил": 1,
    "филайп": 1,
    "филандр": 1,
    "филарет": 1,
    "филат": 1,
    "филберт": 1,
    "филимон": 1,
    "филип": 1,
    "филипп": 1,
    "фило": 1,
    "финикс": 1,
    "финис": 1,
    "флегонт": 1,
    "флемминг": 1,
    "флечер": 1,
    "флинн": 1,
    "флинт": 1,
    "флойд": 1,
    "флорентий": 1,
    "флоренц": 1,
    "флорин": 1,
    "флорри": 1,
    "флурри": 1,
    "фок": 1,
    "фокс": 1,
    "фома": 1,
    "фонз": 1,
    "фонзи": 1,
    "форбес": 1,
    "форд": 1,
    "форест": 1,
    "форрест": 1,
    "фостер": 1,
    "фот": 1,
    "фотий": 1,
    "фоук": 1,
    "фразир": 1,
    "франклин": 1,
    "франц": 1,
    "фред": 1,
    "фредди": 1,
    "фредерик": 1,
    "фредрик": 1,
    "фрейзер": 1,
    "фрейзр": 1,
    "фридрих": 1,
    "фримэн": 1,
    "фритс": 1,
    "фродо": 1,
    "фрол": 1,
    "фрэнк": 1,
    "фрэнки": 1,
    "фрэнклин": 1,
    "фрэнс": 1,
    "фрэнсис": 1,
    "фёдор": 1,
    "хавелок": 1,
    "хадвин": 1,
    "хадлей": 1,
    "хал": 1,
    "хам": 1,
    "хамиш": 1,
    "хамлет": 1,
    "хаммонд": 1,
    "ханк": 1,
    "ханлей": 1,
    "хантер": 1,
    "харв": 1,
    "харви": 1,
    "харди": 1,
    "хардинг": 1,
    "харитон": 1,
    "харкоерт": 1,
    "харлан": 1,
    "харланд": 1,
    "харлей": 1,
    "харлин": 1,
    "хармон": 1,
    "харпер": 1,
    "харрис": 1,
    "харрисон": 1,
    "хартлей": 1,
    "хауелл": 1,
    "хедлей": 1,
    "хек": 1,
    "хендерсон": 1,
    "хендрик": 1,
    "хенрай": 1,
    "хенри": 1,
    "херб": 1,
    "херби": 1,
    "хервей": 1,
    "херлей": 1,
    "хиацинт": 1,
    "хилари": 1,
    "хиллэри": 1,
    "хирам": 1,
    "хис": 1,
    "хитклифф": 1,
    "хию": 1,
    "хоард": 1,
    "хоб": 1,
    "ходдж": 1,
    "хойт": 1,
    "холден": 1,
    "холл": 1,
    "холлис": 1,
    "хомер": 1,
    "хопкин": 1,
    "хорас": 1,
    "хоратайо": 1,
    "хоуи": 1,
    "храбр": 1,
    "христоф": 1,
    "христофор": 1,
    "худд": 1,
    "хуей": 1,
    "хует": 1,
    "хукк": 1,
    "хукслей": 1,
    "хумберт": 1,
    "хунтлей": 1,
    "хуффи": 1,
    "хью": 1,
    "хьюберт": 1,
    "хьюго": 1,
    "хьюи": 1,
    "хэвен": 1,
    "хэдлей": 1,
    "хэйвуд": 1,
    "хэйден": 1,
    "хэйл": 1,
    "хэмфри": 1,
    "хэппи": 1,
    "хюи": 1,
    "цезарь": 1,
    "чад": 1,
    "чадвик": 1,
    "чаз": 1,
    "чак": 1,
    "чакки": 1,
    "чарлз": 1,
    "чарли": 1,
    "чарлтон": 1,
    "чарльз": 1,
    "час": 1,
    "чейз": 1,
    "чендлер": 1,
    "ченс": 1,
    "черокез": 1,
    "чеслав": 1,
    "честер": 1,
    "чеьянн": 1,
    "чип": 1,
    "чонки": 1,
    "чонси": 1,
    "ша": 1,
    "шад": 1,
    "шаи": 1,
    "шайенн": 1,
    "шакуилл": 1,
    "шамиль": 1,
    "шамус": 1,
    "шан": 1,
    "шаннен": 1,
    "шаннон": 1,
    "шау": 1,
    "шеврон": 1,
    "шелби": 1,
    "шелдон": 1,
    "шеллей": 1,
    "шелтон": 1,
    "шем": 1,
    "шервуд": 1,
    "шеридан": 1,
    "шерлок": 1,
    "шерман": 1,
    "ши": 1,
    "шилох": 1,
    "шимус": 1,
    "шмидт": 1,
    "шолто": 1,
    "шон": 1,
    "шэй": 1,
    "шэйн": 1,
    "эбби": 1,
    "эбен": 1,
    "эбенезер": 1,
    "эвальд": 1,
    "эван": 1,
    "эвелин": 1,
    "эверард": 1,
    "эверетт": 1,
    "эверитт": 1,
    "эвот": 1,
    "эгберт": 1,
    "эд": 1,
    "эдан": 1,
    "эдвард": 1,
    "эдвин": 1,
    "эдгар": 1,
    "эдди": 1,
    "эдип": 1,
    "эдисон": 1,
    "эдмонд": 1,
    "эдмунд": 1,
    "эдон": 1,
    "эдуард": 1,
    "эдун": 1,
    "эзраа": 1,
    "эзэлстан": 1,
    "эзэлуолф": 1,
    "эйб": 1,
    "эйби": 1,
    "эйвери": 1,
    "эйден": 1,
    "эйлберт": 1,
    "эйлвард": 1,
    "эймерей": 1,
    "эймери": 1,
    "эйнар": 1,
    "эйнслей": 1,
    "эйнсли": 1,
    "эйс": 1,
    "элайотт": 1,
    "элбан": 1,
    "элвин": 1,
    "элвис": 1,
    "элвуд": 1,
    "элгар": 1,
    "элдвен": 1,
    "элдвин": 1,
    "элден": 1,
    "элджер": 1,
    "элдин": 1,
    "элдис": 1,
    "элдон": 1,
    "элдред": 1,
    "элдус": 1,
    "электрон": 1,
    "эли": 1,
    "элиас": 1,
    "элиджа": 1,
    "элиот": 1,
    "элла": 1,
    "эллгар": 1,
    "эллджер": 1,
    "эллери": 1,
    "эллиот": 1,
    "эллис": 1,
    "элмер": 1,
    "элрик": 1,
    "элрой": 1,
    "элсдон": 1,
    "эль": 1,
    "эльберт": 1,
    "эльбрус": 1,
    "эльдар": 1,
    "эльмар": 1,
    "эльмир": 1,
    "эльтон": 1,
    "эмерсон": 1,
    "эмилиан": 1,
    "эмилий": 1,
    "эмиль": 1,
    "эммануель": 1,
    "эммануил": 1,
    "эммерсон": 1,
    "эммет": 1,
    "эмметт": 1,
    "эмори": 1,
    "эмэри": 1,
    "энвер": 1,
    "энгель": 1,
    "энджелберт": 1,
    "энди": 1,
    "эндрю": 1,
    "энергий": 1,
    "энтони": 1,
    "эразм": 1,
    "эраст": 1,
    "эрван": 1,
    "эрвин": 1,
    "эрг": 1,
    "эрек": 1,
    "эрий": 1,
    "эрик": 1,
    "эрих": 1,
    "эрл": 1,
    "эрлен": 1,
    "эрн": 1,
    "эрнест": 1,
    "эрни": 1,
    "эрнст": 1,
    "эрон": 1,
    "эррол": 1,
    "эрролл": 1,
    "этан": 1,
    "этелберт": 1,
    "этелред": 1,
    "этелрик": 1,
    "этелхард": 1,
    "эшли": 1,
    "эюзби": 1,
    "ювеналий": 1,
    "юджин": 1,
    "юлиан": 1,
    "юлий": 1,
    "юлиус": 1,
    "юм": 1,
    "юниор": 1,
    "юпитер": 1,
    "юрий": 1,
    "юстас": 1,
    "юстин": 1,
    "яков": 1,
    "ян": 1,
    "янкей": 1,
    "янки": 1,
    "януарий": 1,
    "ярвуд": 1,
    "яромир": 1,
    "ярополк": 1,
    "ярослав": 1
  }, exports.ruBindingWords = [ "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "пота", "потому", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "тож", "только", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы", "а-ля", "без", "безо", "благодаря", "близ", "в", "ввиду", "вглубь", "вдоль", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "во", "возле", "вокруг", "вопреки", "впереди", "вразрез", "вроде", "вслед", "вследствие", "для", "до", "за", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "к", "ко", "кроме", "кругом", "меж", "между", "мимо", "на", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду", "насупротив", "насчёт", "не", "ниже", "о", "об", "обо", "обок", "около", "окромя", "округ", "от", "относительно", "ото", "перед", "передо", "по", "по-за", "по-над", "поверх", "под", "подле", "подо", "подобно", "позади", "помимо", "поперёк", "порядка", "посередине", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "применительно", "про", "против", "путём", "ради", "с", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "со", "согласно", "спустя", "среди", "средь", "сродни", "судя", "супротив", "у", "через", "чрез", "иже", "какой-либо", "какой-то", "кое-кто", "кой", "кто", "кто-либо", "многий", "мя", "насколько", "немногий", "нещечко", "никой", "ничегошеньки", "се", "сё", "такой-то", "тот-то", "чё", "чево", "чей-либо", "чей-нибудь", "чей-то", "шо", "эта", "кем", "ком", "кому", "нахуя", "чей", "чему", "вам", "вами", "вас", "вы", "Вы", "ее", "её", "его", "ей", "ему", "ею", "им", "ими", "их", "меня", "мне", "мной", "мною", "мы", "нём", "нем", "нам", "нами", "неё", "него", "ней", "нему", "нею", "ним", "ними", "них", "он", "она", "оне", "они", "оно", "тебе", "тебя", "тобой", "тобою", "ты", "я", "иной", "кое-какой", "кое-чей", "кое-что", "кой-какой", "кой-кто", "кто-нибудь", "кто-то", "куда-нибудь", "некто", "нечто", "что-либо", "что-нибудь", "что-то", "весь", "всякий", "любой", "сам", "самый", "таков", "этакий", "другой", "некем", "некому", "нечего", "нечем", "нечему", "никакой", "никто", "ничего", "ничей", "ничем", "ничему", "ничто", "ваш", "ихний", "моё", "мой", "моя", "наш", "свой", "твой", "оный", "сей", "сие", "сии", "сия", "та", "такой", "тот", "ту", "эдакий", "эти", "это", "этот", "ась", "аюшки", "таки", "а", "авось-либо", "ага", "аминь", "б", "бишь", "буквально", "бы", "было", "вишь", "вон", "вот", "вот-вот", "вряд", "всего", "давай", "де", "действительно", "дескать", "добро", "довольно", "ещё", "исключительно", "ить", "ишь", "ка", "кажется", "конечно", "ладно", "лих", "лучше", "мол", "навряд", "наоборот", "небось", "нет", "неужели", "нехай", "никак", "ну", "ну-с", "по-видимому", "пожалуй", "пожалуйста", "полно", "положительно", "предовольно", "простите", "просто-напросто", "пускай", "разумеется", "сём-ка", "сем", "скорее", "спасибо", "так", "то-то", "тоже", "уж", "уже", "ужели", "ужли", "фон", "хорошо", "эдак", "эк", "этак" ];
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.words = {}, exports = window.lastName.plugins.ru.words) : exports = module.exports, function(exports) {
  return exports.adverbs = [ "абсолютно", "адски", "азартно", "активно", "аспидно", "баснословно", "бдительно", "безапелляционно", "безбожно", "безвозвратно", "безгранично", "безжалостно", "беззаветно", "беззастенчиво", "безмерно", "безмятежно", "безнадежно", "безоговорочно", "безраздельно", "безропотно", "безудержно", "безукоризненно", "безумно", "безупречно", "безусловно", "безустанно", "безутешно", "бескомпромиссно", "бесконечно", "беспардонно", "бесповоротно", "беспощадно", "беспредельно", "беспрекословно", "бесследно", "бессовестно", "бесстыдно", "бесчеловечно", "бешено", "бурно", "вдребезги", "вконец", "вовсю", "всемерно", "всесторонне", "всецело", "всячески", "высоко", "глубоко", "горько", "горячо", "грубо", "густо", "диаметрально", "дико", "досконально", "досыта", "дотошно", "дьявольски", "жарко", "жгуче", "железно", "жестко", "жестоко", "живо", "жизненно", "жутко", "запоем", "запредельно", "зверски", "здорово", "злостно", "идеально", "излишне", "изрядно", "изумительно", "исключительно", "исступленно", "истово", "истошно", "исчерпывающе", "кардинально", "катастрофически", "категорически", "клятвенно", "колоссально", "крайне", "крепко", "кристально", "кровно", "крупно", "круто", "люто", "максимально", "мертвецки", "мучительно", "навзрыд", "нагло", "наглухо", "наглядно", "наголову", "надежно", "надрывно", "назубок", "намертво", "наотрез", "напрочь", "нарочито", "насквозь", "настоятельно", "насущно", "начисто", "небывало", "невероятно", "невиданно", "невообразимо", "невыносимо", "невыразимо", "недопустимо", "неизмеримо", "неимоверно", "неистово", "немилосердно", "немыслимо", "необыкновенно", "необычайно", "неописуемо", "неопровержимо", "непомерно", "непоправимо", "непостижимо", "непримиримо", "непробудно", "непроходимо", "неразрывно", "несказанно", "неслыханно", "несметно", "несравненно", "нестерпимо", "неудержимо", "неузнаваемо", "неуклонно", "неукоснительно", "неустанно", "неусыпно", "неутешно", "неутомимо", "нещадно", "оглушительно", "ожесточенно", "ослепительно", "основательно", "остро", "откровенно", "открыто", "отлично", "отменно", "отчаянно", "очень", "панически", "патологически", "пламенно", "плотно", "по-настоящему", "по-собачьи", "подлинно", "подчеркнуто", "позарез", "поистине", "полностью", "поразительно", "порядком", "порядочно", "потрясающе", "предельно", "прекрасно", "преступно", "прилично", "примитивно", "принципиально", "приторно", "пронзительно", "радикально", "разительно", "редкостно", "резко", "рекордно", "свято", "серьезно", "сильно", "слепо", "смертельно", "совершенно", "совсем", "страстно", "страшно", "строго", "строго-настрого", "существенно", "твердо", "тяжело", "тяжко", "убийственно", "удивительно", "ужасающе", "ужасно", "фанатически", "фанатично", "фантастически", "феноменально", "хорошенько", "хорошо", "чертовски", "чрезвычайно", "чрезмерно", "чудовищно", "широко", "шумно", "щедро", "ярко", "яростно" ], exports.unions = [ "а", "а именно", "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "все-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как бы", "как то", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "после того как", "пота", "потому", "потому как", "потому что", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "то есть", "тож", "только", "только что", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы" ], exports.prepositionAll = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо", "включая", "невзирая на", "несмотря на", "по", "по-за", "про", "с", "сквозь", "со", "спустя", "через", "чрез", "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по", "при", "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "среди", "средь", "супротив", "у", "в связи с", "в соответствии с", "вслед за", "лицом к лицу с", "над", "надо", "наряду с", "перед", "передо", "по сравнению с", "по-над", "пред", "предо", "рядом с", "следом за" ], exports.prepositionSimple = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionAcusative = [ "в", "включая", "во", "за", "на", "не в", "не за", "невзирая на", "несмотря на", "о", "об", "обо", "по", "по-за", "под", "подо", "про", "с", "сквозь", "со", "спустя", "через", "чрез" ], exports.prepositionDative = [ "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по" ], exports.prepositionPrepositional = [ "в", "во", "на", "не в", "о", "об", "обо", "по", "при" ], exports.prepositionGenetive = [ "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "меж", "между", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "со", "среди", "средь", "супротив", "у" ], exports.prepositionInstrumental = [ "в связи с", "в соответствии с", "вслед за", "за", "лицом к лицу с", "меж", "между", "над", "надо", "наряду с", "не за", "перед", "передо", "по сравнению с", "по-над", "под", "подо", "пред", "предо", "рядом с", "с", "следом за", "со" ], exports.prepositionWithSingleCase = [ "без", "без ведома", "безо", "благодаря", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в связи с", "в силу", "в соответствии с", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "вдоль по", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "вопреки", "впереди", "впредь до", "вроде", "вслед", "вслед за", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "к", "ко", "кроме", "кругом", "лицом к", "лицом к лицу с", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду с", "насупротив", "насчёт", "начиная с", "не без", "не считая", "невзирая на", "недалеко от", "независимо от", "несмотря на", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "перед", "передо", "по линии", "по мере", "по направлению к", "по отношению к", "по поводу", "по причине", "по случаю", "по сравнению с", "по-за", "по-над", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "подобно", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "при помощи", "применительно к", "про", "против", "путём", "ради", "рядом с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "согласно", "спустя", "среди", "средь", "сродни", "судя по", "супротив", "у", "через", "чрез" ], exports.prepositionWith2Cases = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionWith3Cases = [ "по", "с", "со" ];
}(exports);

var exports, ref, util, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.dates = {}, exports = window.lastName.plugins.ru.dates, ref = window.lastName.plugins.ru.ref, util = window.lastName.util) : (exports = module.exports, ref = require("./ref"), util = require("../../util")), function(exports, util, ref) {
  var dateObjectToString, extractDates, getRuMonthIndex, getValidDate, packDates, packIntervals, ruMonthInDates;
  return ruMonthInDates = [ "января", "февраля", "марта", "аперля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря" ], dateObjectToString = function(dateObj) {
    var d, m, y, _ref;
    return y = ((_ref = typeof dateObj.y) === "number" || _ref === "string") && dateObj.y || "", m = dateObj.m + 1, m = m > 9 && m || "0" + m, d = dateObj.d > 9 && dateObj.d || "0" + dateObj.d, "" + d + "." + m + "." + y;
  }, getValidDate = function(dateObj) {
    var defaultYear, dt;
    defaultYear = dateObj.y;
    if (void 0 === dateObj.y || dateObj.y < 1970 || dateObj.y > 2038) dateObj.y = 2e3;
    return dt = new Date(Date.UTC(dateObj.y, dateObj.m, dateObj.d)), dt.getMonth() === dateObj.m && dt.getDate() === dateObj.d ? (dateObj.y = defaultYear, dateObj) : null;
  }, getRuMonthIndex = function(str) {
    var m;
    return m = str.toLowerCase().match(/(\s|^)(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s|$)/g), m ? ruMonthInDates.indexOf(m[0].replace(/\s/g, "")) : -1;
  }, exports.extractDates = extractDates = function(strArr) {
    var dates, intervals, sources;
    return dates = {}, sources = [], intervals = {}, strArr instanceof Array || (strArr = [ strArr ]), strArr.map(function(str) {
      var dStr, date, found, from, fromDate, fromMonth, fromYear, id, intObject, mIndex, sourceStr, to, toDate, toYear, verboseMatch, wordsArr, _ref, _results;
      verboseMatch = str.match(/\s+\d{1,2}\s+((января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)\s+|)(\d{2,4}(\s+года|)\s+|)по\s+\d{1,2}\s+(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s+\d{2,4}|)(\s+|$)/mig);
      if (!verboseMatch) {
        wordsArr = str.split(" "), found = !1, _results = [];
        while (wordsArr.length > 2 && !found) /^\d[\d]$/.test(wordsArr[0]) && (mIndex = ruMonthInDates.indexOf(wordsArr[1].toLowerCase()), mIndex >= 0 ? (date = {
          d: parseInt(wordsArr[0], 10),
          m: mIndex
        }, /^\d{2,4}$/.test(wordsArr[2]) ? (date.y = parseInt(wordsArr[2], 10), sourceStr = wordsArr.slice(0, 3).join(" ")) : sourceStr = wordsArr.slice(0, 2).join(" ")) : /^\d\d\.\d\d.\d{2,4}$/.test(wordsArr[0] || /^\d\d\.\d\d$/.test(wordsArr[0])) ? (date = {
          d: parseInt(wordsArr[0].slice(0, 3), 10),
          m: parseInt(wordsArr[0].slice(3, 6), 10),
          y: parseInt(wordsArr[0].slice(6), 10) || void 0
        }, sourceStr = wordsArr[0]) : date = {}, date = getValidDate(date), date && (found = !0, sources.push(sourceStr), dStr = dateObjectToString(date), dates[dStr] ? dates[dStr].count++ : dates[dStr] = {
          count: 1,
          value: date
        })), _results.push(wordsArr.shift());
        return _results;
      }
      _ref = verboseMatch[0].toLowerCase().split("по"), from = _ref[0], to = _ref[1], toYear = to.replace(/\d{1,2}/, "").match(/\d+/g), toYear ? toYear = parseInt(toYear[0], 10) : toYear = void 0, toDate = {
        d: parseInt(to.match(/\d{1,2}/g)[0], 10),
        m: getRuMonthIndex(to),
        y: toYear
      }, fromYear = from.replace(/\d{1,2}/, "").match(/\d+/g), fromMonth = getRuMonthIndex(from), fromYear ? fromYear = parseInt(fromYear[0], 10) : fromYear = toYear, fromMonth === -1 && (fromMonth = toDate.m), fromDate = {
        d: parseInt(from.match(/\d{1,2}/g)[0], 10),
        m: fromMonth,
        y: fromYear
      }, toDate = getValidDate(toDate), fromDate = getValidDate(fromDate);
      if (toDate && fromDate) return intObject = {
        from: dateObjectToString(fromDate),
        from_value: fromDate,
        to: dateObjectToString(toDate),
        to_value: toDate
      }, id = "" + intObject.from + "-" + intObject.to, intervals[id] ? intervals[id].count++ : (intObject.count = 1, intervals[id] = intObject), sources.push(verboseMatch[0]);
    }), {
      dates: dates,
      sources: sources,
      intervals: intervals
    };
  }, exports.packDates = packDates = function(dates, defaultYear) {
    var dateObj, id, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in dates) dateObj = dates[id], "undefined" != typeof dateObj.value.y && years.push(dateObj.value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in dates) dateObj = dates[id], "undefined" == typeof dateObj.value.y && (dateObj.value.y = defaultYear), out["" + dateObjectToString(dateObj.value)] = dateObj.count;
    return out;
  }, exports.packIntervals = packIntervals = function(intervals, defaultYear) {
    var id, interval, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in intervals) interval = intervals[id], "undefined" != typeof interval.from_value.y && years.push(interval.from_value.y), "undefined" != typeof interval.to_value.y && years.push(interval.to_value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in intervals) interval = intervals[id], "undefined" == typeof interval.from_value.y && (interval.from_value.y = defaultYear), "undefined" == typeof interval.to_value.y && (interval.to_value.y = defaultYear), out["" + dateObjectToString(interval.from_value) + "-" + dateObjectToString(interval.to_value)] = interval.count;
    return out;
  }, exports.preFilter = function(text, result) {
    var dates, numRe;
    numRe = /((([а-яё]+)\s+){0,1}\d[\.\d]{0,}(\s+(([a-яё]+)|([\.\d]+))){1,6})|([12]\d\d\d)/mig, dates = extractDates(util.unique(text.match(numRe) || [])), util.dictKeys(dates.dates).length > 0 && (result.dates = packDates(dates.dates)), util.dictKeys(dates.intervals).length > 0 && (result.intervals = packIntervals(dates.intervals));
    if (dates.sources.length > 0) return result.date_sources = dates.sources;
  };
}(exports, util, ref);

var exports, ref, util, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.inclines = {}, exports = window.lastName.plugins.ru.inclines, util = window.lastName.util, ref = window.lastName.plugins.ru.ref) : (exports = module.exports, util = require("../../util"), ref = require("./ref")), function(exports, util, ref) {
  var cases, doInclineFemaleName, doInclineMaleName, findProperName, genderMatch, getNominative, inclineAndGetResult, inclineFemMiddleName, inclineFemaleName, inclineFemaleNameAndGetResult, inclineFemaleSurname, inclineMaleMiddleName, inclineMaleName, inclineMaleNameAndGetResult, inclineMaleSurname, inclineMiddleName, inclineMiddleNameOrSurname, inclineName, inclinePersonSurname, inclineSurname, matchCase, matchNameAndSurname, matchNameParts;
  return cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ], exports.doInclineFemaleName = doInclineFemaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, aUnstressedRe, name2;
    return aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, aUnstressedRe = /ца$/g, name2 = name.slice(0, -1), aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aUnstressedRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ей", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /ия$/g.test(name) && name.length > 3 ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "и" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ь", "" + name2 + "ью", "" + name2 + "и" ] : /[жшщцч]$/g.test(name) ? [ "" + name, "" + name + "и", "" + name + "и", "" + name, "" + name + "ью", "" + name + "и" ] : [ name, name, name, name, name, name ];
  }, exports.doInclineMaleName = doInclineMaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, hardConsonants, hissingAndChe, ishortRe, name2;
    return hardConsonants = /[бвгдзклмнпрстфх]$/g, hissingAndChe = /[жшщцч]$/g, ishortRe = /((ай)|(ей)|(ой)|(уй)|(яй)|(юй)|(ий))$/g, aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, name2 = name.slice(0, -1), name === "Лев" ? [ "Лев", "Льва", "Льву", "Льва", "Львом", "Льве" ] : name === "Павел" ? [ "Павел", "Павла", "Павлу", "Павла", "Павлом", "Павле" ] : /и$/g.test(name) ? [ name, name, name, name, name, name ] : hissingAndChe.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ем", "" + name + "е" ] : hardConsonants.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ом", "" + name + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : ishortRe.test(name) ? [ "" + name2 + "й", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ко$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /о$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : null;
  }, inclineAndGetResult = function(fn, args) {
    var i, name, r;
    r = null;
    for (i in args) {
      name = args[i], r = fn(name, !0);
      if (r.found) break;
    }
    return r;
  }, inclineFemaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineFemaleName, arguments);
  }, inclineMaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineMaleName, arguments);
  }, exports.inclineFemaleName = inclineFemaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name3, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), nl = name.toLowerCase(), nominativeRe = /[адежзийклмнорстуьэя]$/g, canInclineRe = /[жшщцчаяь]$/g, genitiveRe = /[иы]$/g, dativeRe = /[еи]$/g, accusativeRe = /[жшщцчьую]$/g, instrumentalRe = /((ой)|(ей)|(еи)|(ью))$/g, prepositionalRe = /[еи]$/g, result = r = null, nominativeRe.test(nl) && ref.ruFemaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineFemaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "female",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name2 = name.slice(0, -1), name_cases = [], genitiveRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("dative"))), prepositionalRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("prepositional"))), accusativeRe.test(nl) && (/[ую]$/g.test(nl) ? r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а") : r = inclineFemaleNameAndGetResult(name), r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (name3 = name.slice(0, -2), r = inclineFemaleNameAndGetResult("" + name3 + "я", "" + name3 + "а", "" + name3 + "ь", "" + name3), r && r.found && (result = r, name_cases.push("instrumental"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineMaleName = inclineMaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), name === "Льв" && (name = "Лев"), name === "Павл" && (name = "Павел"), nl = name.toLowerCase(), nominativeRe = /([вгдзклмнпрстфхжшцьй]|(ба)|(ва)|(да)|(за)|(ла)|(ма)|(на)|(па)|(ра)|(са)|(та)|(фа)|(га)|(ка)|(ха)|(жа)|(ша)|(ща)|(ца)|(ча)|(я)|(ло)|(ко))$/g, canInclineRe = /([бвгдзклмнпрстфхжшцьая]|(ия)|(ья)|(ея)|(ий)|(ей))$/g, genitiveRe = /[аяыи]$/g, dativeRe = /(([еую])|(ии))$/g, accusativeRe = /[аяую]$/g, instrumentalRe = /((ом)|(ем)|(ой)|(ей)|(ёй))$/g, prepositionalRe = /((е)|(ии))$/g, name2 = name.slice(0, -1), result = r = null, nominativeRe.test(nl) && ref.ruMaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineMaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "male",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name_cases = [], genitiveRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /ы$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "о", "" + name2 + "а") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "а", "" + name.slice(0, -1) + "я", "" + name.slice(0, -1) + "о") : r = null, r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (/у$/g.test(nl) ? r = inclineMaleName(name2) : /[аеиоуя]ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "й") : /ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "ь") : /е$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "и", "" + name2 + "я", "" + name2 + "o") : /ии$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я") : r = null, r && r.found && (result = r, name_cases.push("dative"))), accusativeRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /у$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а") : /[ую]$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : r = null, r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (/ом$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2)) : /ем$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2), "" + name.slice(0, -2) + "ь", "" + name.slice(0, -2) + "й") : /ой$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "а", "" + name.slice(0, -2) + "о") : /((ей)|(ёй))$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "я", "" + name.slice(0, -2) + "а") : r = null, r && r.found && (result = r, name_cases.push("instrumental"))), prepositionalRe.test(nl) && (/е$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2, "" + name2 + "ь", "" + name2 + "й", "" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я", "" + name2 + "й") : r = null, r && r.found && (result = r, name_cases.push("prepositional"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineName = inclineName = function(name) {
    var fn, mn, result;
    return fn = inclineFemaleName(name), mn = inclineMaleName(name), fn.found ? result = {
      found: !0,
      src: name,
      gender: "female",
      guess_case: fn.guess_case,
      female_cases: fn.cases,
      possible_cases: fn.possible_cases,
      nominative: fn.nominative
    } : mn.found ? result = {
      found: !0,
      src: name,
      gender: "male",
      guess_case: mn.guess_case,
      male_cases: mn.cases,
      possible_cases: mn.possible_cases,
      nominative: mn.nominative
    } : fn.possible_yes && mn.possible_yes ? (result = {
      found: "maybe",
      src: name,
      gender: [ "male", "female" ],
      female_cases: fn.cases,
      male_cases: mn.cases,
      possible_cases: util.merge(fn.possible_cases, mn.possible_cases)
    }, result.guess_case = fn.guess_case_index <= mn.guess_case_index ? fn.guess_case : mn.guess_case) : fn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "female",
      female_cases: fn.cases,
      guess_case: fn.cases,
      possible_cases: fn.possible_cases
    } : mn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "male",
      male_cases: mn.cases,
      guess_case: mn.cases,
      possible_cases: mn.possible_cases
    } : result = {
      found: !1,
      src: name
    }, result;
  }, inclineSurname = function(surname, noInclinesRe, inclineRe, casesRe) {
    var c, cases_index, check, i, result, surname_cases, _i, _j, _len, _len2;
    result = {
      found: null,
      src: surname,
      cases: null,
      cases_index: null
    };
    if (noInclinesRe && noInclinesRe.test(surname)) result = {
      found: surname,
      src: surname,
      cases: [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ],
      cases_index: [ 0, 1, 2, 3, 4, 5 ]
    }; else for (_i = 0, _len = inclineRe.length; _i < _len; _i++) {
      check = inclineRe[_i];
      if (check[0].test(surname)) {
        result = {
          found: surname.replace(check[0], check[1]),
          src: surname
        }, cases_index = [], surname_cases = [], i = 0;
        for (_j = 0, _len2 = casesRe.length; _j < _len2; _j++) c = casesRe[_j], c.test(surname) && (cases_index.push(i), surname_cases.push(cases[i])), i++;
        surname_cases.length === 0 ? (result.found = null, result.cases = null) : result.cases = surname_cases, result.cases_index = cases_index;
        break;
      }
    }
    return result.surname_cases && (result.guess_case = result.surname_cases[0]), result;
  }, exports.inclineFemaleSurname = inclineFemaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(е)|(о)|(э)|(и)|(ы)|(^[нв]у)|(^ую)|(уа)|(иа)|(ман)|(вич)|(ян))$/g, inclineRe = [ [ /((ова)|(овой)|(ову))$/g, "ова" ], [ /((ева)|(евой)|(еву))$/g, "ева" ], [ /((ёва)|(ёвой)|(ёву))$/g, "ёва" ], [ /((ина)|(иной)|(ину))$/g, "ина" ], [ /((ая)|(ой)|(ую))$/g, "ая" ] ], casesRe = [ /((ова)|(ева)|(ёва)|(ина)|(ая))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((ову)|(еву)|(ёву)|(ину)|(ую))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, exports.inclineMaleSurname = inclineMaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(^ве)|(^го)|(э)|(и)|(ы)|(^му)|(ю)|(уа)|(иа))$/g, inclineRe = [ [ /((ов)|(ова)|(ову)|(овым)|(ове))$/g, "ов" ], [ /((ев)|(ева)|(еву)|(евым)|(еве))$/g, "ев" ], [ /((ёв)|(ёва)|(ёву)|(ёвым)|(ёве))$/g, "ёв" ], [ /((ин)|(ина)|(ину)|(иным)|(ине))$/g, "ин" ], [ /((ский)|(ского)|(скому)|(ским)|(ском))$/g, "ский" ], [ /((ской)|(ского)|(скому)|(ским)|(ском))$/g, "ской" ], [ /((ман)|(мана)|(ману)|(маном)|(мане))$/g, "ман" ], [ /((ой)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ой" ], [ /((ий)|(ого)|(ому)|(ого)|(им)|(ом))$/g, "ий" ], [ /((ый)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ый" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ], [ /((ян)|(яна)|(яну)|(яна)|(яном)|(яне))$/g, "ян" ] ], casesRe = [ /((ов)|(ев)|(ёв)|(ин)|(ский)|(ской)|(ой)|(ий)|(ый)|(ман)|(ич)|(ян))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((ову)|(еву)|(ёву)|(ину)|(скому)|(ому)|(ману)|(ичу)|(яну))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((овым)|(евым)|(ёвым)|(иным)|(ским)|(им)|(ым)|(маном)|(ичем)|(яном))$/g, /((ове)|(еве)|(ёве)|(ине)|(ском)|(ом)|(мане)|(иче)|(яне))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, inclineMiddleNameOrSurname = function(src, fem, male) {
    var result, _ref;
    return fem.found === (_ref = male.found) && _ref === null ? result = {
      found: !1,
      src: src,
      value: null,
      gender: null
    } : fem.found && male.found ? (result = {
      found: !0,
      src: src,
      gender: [ "male", "female" ]
    }, result.nominative_male = male.found, result.nominative_female = fem.found, result.female_cases = fem.cases, result.male_cases = male.cases, fem.cases.length === 6 ? male.cases.length === 6 ? (result.guess_sex = "unknown", result.possible_cases = util.merge(fem.cases, male.cases)) : (result.guess_sex = "male", result.nominative = male.found, result.possible_cases = male.cases) : fem.cases.length === 1 && male.cases.length > 1 ? (result.guess_sex = "female", result.nominative = fem.found, result.possible_cases = fem.cases) : result.possible_cases = util.merge(fem.cases, male.cases)) : fem.found ? male.found || (result = {
      found: !0,
      src: src,
      gender: "female",
      female_cases: fem.cases,
      guess_case: fem.guess_case,
      nominative: fem.found,
      possible_cases: fem.cases
    }) : result = {
      found: !0,
      src: src,
      gender: "male",
      male_cases: male.cases,
      guess_case: male.guess_case,
      nominative: male.found,
      possible_cases: male.cases
    }, result;
  }, exports.inclineSurname = inclinePersonSurname = function(surname) {
    return inclineMiddleNameOrSurname(surname, inclineFemaleSurname(surname), inclineMaleSurname(surname));
  }, exports.inclineMaleMiddleName = inclineMaleMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((евич)|(евича)|(евичу)|(евича)|(евичем)|(евиче))$/g, "евич" ], [ /((ович)|(овича)|(овичу)|(овича)|(овичем)|(овиче))$/g, "ович" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ] ], casesRe = [ /((евич)|(ович)|(ич))$/g, /((евича)|(овича)|(ича))$/g, /((евичу)|(овичу)|(ичу))$/g, /((евича)|(овича)|(ича))$/g, /((евичем)|(овичем)|(ичем))$/g, /((евиче)|(овиче)|(иче))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineFemMiddleName = inclineFemMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((вна)|(вны)|(вне)|(вну)|(вной)|(вне))$/g, "вна" ], [ /((чна)|(чны)|(чне)|(чну)|(чной)|(чне))$/g, "чна" ] ], casesRe = [ /((вна)|(чна))$/g, /((вны)|(чны))$/g, /((вне)|(чне))$/g, /((вну)|(чну))$/g, /((вной)|(чной))$/g, /((вне)|(чне))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineMiddleName = inclineMiddleName = function(mname) {
    return inclineMiddleNameOrSurname(mname, inclineFemMiddleName(mname), inclineMaleMiddleName(mname));
  }, genderMatch = function(g1, g2) {
    return g1 === g2 || __indexOf.call(g2, g1) >= 0 ? g1 : __indexOf.call(g1, g2) >= 0 ? g2 : null;
  }, matchNameParts = function(fn, mn, sn) {
    var overallGender, surname, theCase;
    return theCase = util.intersection(fn.possible_cases, mn.possible_cases), overallGender = genderMatch(genderMatch(fn.gender, mn.gender), sn.gender), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: mn.nominative,
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchNameAndSurname = function(fn, sn) {
    var overallGender, surname, theCase;
    return overallGender = genderMatch(fn.gender, sn.gender), theCase = util.intersection(fn.possible_cases, sn.possible_cases), theCase || (sn.possible_cases = sn["" + overallGender + "_cases"], sn.nominative = sn["nominative_" + overallGender], theCase = util.intersection(fn.possible_cases, sn.possible_cases)), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: "",
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchCase = function(pObj, target_case, gender) {
    return __indexOf.call(pObj["" + gender + "_cases"], target_case) >= 0;
  }, getNominative = function(pObj, gender) {
    var gnstr, nom;
    return gnstr = "nominative_" + gender, nom = pObj.nominative && pObj.nominative || pObj[gnstr], nom;
  }, exports.findProperName = findProperName = function(listOfWords, opts) {
    var mnr2, mnr3, nr1, nr2, nr3, result, sr1, sr2, sr3;
    opts == null && (opts = {}), result = {
      found: !1
    };
    switch (listOfWords.length) {
     case 1:
      result = inclineName(listOfWords[0]), result.found ? result.first_name = result.nominative : (result = inclinePersonSurname(listOfWords[0]), result.found && (result.surname = result.nominative));
      break;
     case 2:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr1.found && sr2.found && (result = matchNameAndSurname(nr1, sr2)), !result.found && sr1.found && nr2.found && (result = matchNameAndSurname(sr1, nr2));
      break;
     case 3:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), sr3 = inclinePersonSurname(listOfWords[2]), mnr2 = inclineMiddleName(listOfWords[1]), mnr3 = inclineMiddleName(listOfWords[2]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr3 = inclineName(listOfWords[2]), nr3.found ? result = {
        found: !1,
        error: "name at the end of 3-component proper name"
      } : nr1.found ? (mnr2.found && sr3.found && (result = matchNameParts(nr1, mnr2, sr3)), !result.found && sr2.found && (result = matchNameAndSurname(nr1, sr2))) : sr1.found && nr2.found && mnr3.found ? result = matchNameParts(nr2, mnr3, sr1) : nr2.found && sr3.found && (result = matchNameAndSurname(nr2, sr3));
    }
    return result.first_name || (result.first_name = ""), result.middle_name || (result.middle_name = ""), result.surname || (result.surname = ""), result.first_name || result.middle_name || result.surname || (result = {
      found: !1,
      error: "person not found"
    }), result.src = listOfWords.join(" "), result;
  }, exports.getInitialFormOfAdjective = function(adj) {
    var base;
    return adj = adj.toLowerCase(), /^[а-яё]{2,}(ая|ее|ие|ий|им|ими|их|ого|его|ое|ой|ом|ому|ою|ую|ые|ый|ым|ыми|ых|юю|яя)$/.test(adj) ? (/^[а-яё]{2,}(ими|ого|его|ому|ыми)$/gi.test(adj) ? base = adj.slice(0, -3) : base = adj.slice(0, -2), [ "" + base + "ый", "" + base + "ий", "" + base + "ой" ]) : null;
  }, exports.getVerbInfinitive = function(verb) {
    var pastTime, result, verbEnd;
    return verb = verb.toLowerCase(), /^[а-яё]{3,}(ать|аться|ить|иться|еть|еться|оть|оться|уть|утся|ются|ть|ться)$/.test(verb) ? verb : (/^[а-яё]{3,}(сь|ся)$/.test(verb) ? (verbEnd = verb.slice(-2), verb = verb.slice(0, -2)) : verbEnd = "", pastTime = verb.match(/^[а-яё]{3,}(л|ла|ло|ли)$/), pastTime ? result = verb.slice(0, -(1 + pastTime[1].length) + 1 || 9e9) + "ть" : /[а-яё]{3,}(у|ю|ем|ешь|ете|ет|ут|ют|им|ишь|ите|ит|ат|ят)$/.test(verb) && (/[а-яё]{3,}(ишь|ит|им|ите|ат|ят)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd ] : /[а-яё]{3,}(у|ю|ешь|ет|ем|ете|ут|ют)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd, "" + verb + "оть" + verbEnd, "" + verb + "уть" + verbEnd, "" + verb + "ть" + verbEnd ] : result = null), result);
  };
}(exports, util, ref);

var exports, ruWords, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.morpho = {}, exports = window.lastName.plugins.ru.morpho, ruWords = window.lastName.plugins.ru.words) : (exports = module.exports, ruWords = require("./words")), function(exports, ruWords) {
  var exceptions, getRulesAdjective, getRulesVerb, morphoRu;
  return exports.getWordRe = function() {
    return /^[а-я\-ё\d]+$/ig;
  }, exports.getAdjectiveEnds = function() {
    return {
      feminine: {
        ends: /((ая)|(ой)|(ую)|(яя)|(ей)|(юю))$/g,
        hard: /((ая)|(ой)|(ую))$/g,
        sort: /((яя)|(ей)|(юю))$/g,
        hardNominativeEnd: "ая",
        softNominativeEnd: "яя",
        gender: "feminine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ая" ? [ "" + word + "ая", "" + word + "ой", "" + word + "ой", "" + word + "ую", "" + word + "ой", "" + word + "ой" ] : [ "" + word + "яя", "" + word + "ей", "" + word + "ей", "" + word + "юю", "" + word + "ей", "" + word + "ей" ];
        }
      },
      masculine: {
        ends: /((ый)|(ого)|(ому)|(ым)|(ом)|(ий)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ый)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ий)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ый",
        softNominativeEnd: "ий",
        gender: "masculine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ый" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ий", "" + word + "ого", "" + word + "ому", "" + word + "ий", "" + word + "им", "" + word + "ом" ] : [ "" + word + "ый", "" + word + "ого", "" + word + "ому", "" + word + "ый", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ий", "" + word + "его", "" + word + "ему", "" + word + "ий", "" + word + "им", "" + word + "ем" ];
        }
      },
      neuter: {
        ends: /((ое)|(ого)|(ому)|(ым)|(ом)|(ее)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ое)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ее)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ое",
        softNominativeEnd: "ее",
        gender: "neuter",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ое" ? [ "" + word + "ое", "" + word + "ого", "" + word + "ому", "" + word + "ое", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ее", "" + word + "его", "" + word + "ему", "" + word + "ее", "" + word + "им", "" + word + "ем" ];
        }
      },
      plural: {
        ends: /((ые)|(ых)|(ым)|(ыми)|(ых)|(ие)|(их)|(им)|(ими)|(их))$/g,
        hard: /((ые)|(ых)|(ым)|(ыми)|(ых))$/g,
        soft: /((ие)|(их)|(им)|(ими)|(их))$/g,
        hardNominativeEnd: "ые",
        softNominativeEnd: "ие",
        gender: "unknown",
        singular: !1,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ые" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ] : [ "" + word + "ые", "" + word + "ых", "" + word + "ым", "" + word + "ые", "" + word + "ыми", "" + word + "ых" ] : [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ];
        }
      }
    };
  }, exceptions = function(word) {}, getRulesVerb = function() {
    return [ [ /нул[aи]{0,1}$/g, "ать" ], [ /еть$/g, "ать" ], [ /(ает)|(ают)$/g, "ать" ], [ /ал[aи]{0,1}$/g, "ать" ], [ /ул[aи]{0,1}$/g, "ать" ], [ /((ить)|(ать))$/g, "ать" ], [ /ая$/g, "ать" ], [ /((ил)|(или)|(ила)|(ило))$/g, "лять" ], [ /(ятся)|(ится)|(ился)|(илась)|(илось)$/g, "ится" ], [ /(яться)|(иться)$/g, "иться" ] ];
  }, getRulesAdjective = function() {
    return [ [ /в((ая)|(ые)|(ый)|(ое))$/, "вый" ], [ /((ая)|(ой)|(ие)|(ые)|(ый)|(ую))$/, "ый" ], [ /((яя)|(ее)|(ий)|(юю))$/, "ий" ] ];
  }, exports.morpho = morphoRu = function(word) {
    var adj, adjective, result, rule, verb, _i, _j, _len, _len2, _ref, _ref2;
    if (__indexOf.call(ruWords.adverbs, word) >= 0) return {
      type: "abverb",
      value: word
    };
    if (__indexOf.call(ruWords.prepositionAll, word) >= 0) return {
      type: "preposition",
      value: word
    };
    if (__indexOf.call(ruWords.unions, word) >= 0) return {
      type: "union",
      value: word
    };
    result = {
      type: "",
      value: ""
    }, verb = null, adjective = null, _ref = getRulesVerb();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      rule = _ref[_i];
      if (rule[0].test(word)) {
        result = {
          type: verb,
          value: word.replace(rule[0], rule[1])
        };
        break;
      }
    }
    _ref2 = getRulesAdjective();
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      rule = _ref2[_j];
      if (rule[0].test(word)) {
        adj = word.replace(rule[0], rule[1]), result.type ? (result.type += " adjective", result.value = [ result.value, adj ]) : result = {
          type: "adjective",
          value: adj
        };
        break;
      }
    }
    return result;
  }, exports.analyseText = function(text) {
    var doubleSpaceRe, enRe, punctuationRe, r, result, ruRe, t, wordRe, _i, _len, _ref;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&№“”\—]/g, doubleSpaceRe = /\s+/g, text = text.replace(punctuationRe, " $& ").replace(doubleSpaceRe, " ") + " .", result = [], _ref = text.split(" ");
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      t = _ref[_i], ruRe = /^[а-я\-ё]+$/ig, enRe = /^[a-z\-]+$/ig, wordRe = /^[а-яё\-\da-z]+$/ig, r = morphoRu(t.toLowerCase());
      switch (r.type) {
       case "adverb":
        result.push("[ADV " + t + "]");
        break;
       case "verb":
       case "adjective":
        result.push("[ " + r.value + " ]");
        break;
       case "verb adjective":
        result.push("[#VA " + r.value[0] + "]");
        break;
       case "union":
        result.push("[U " + t + "]");
        break;
       case "preposition":
        result.push("[PP " + t + "]");
        break;
       default:
        result.push(t);
      }
      t === "." && result.push("\n");
    }
    return result;
  }, exports.parseRuSentence = function(sentences) {
    var abbrevs, common_used_words, digits, regular_words, special_words, total_words;
    return sentences instanceof Array || (sentences = [ sentences ]), abbrevs = {}, special_words = {}, digits = {}, common_used_words = {}, regular_words = {}, total_words = 0, sentences.map(function(sent) {
      var i, result, w, word, words, _len, _ref, _results;
      words = sent.split(" "), _results = [];
      for (i = 0, _len = words.length; i < _len; i++) word = words[i], /^[[,:\/\\\?!\+\-\*\(\)\[\]\&\№\—]]+$/.test(words) || total_words++, /^(\d+(|(\.(|\d+))))$/.test(word) ? digits[word] ? _results.push(digits[word]++) : _results.push(digits[word] = 1) : isUpperCase(word) && /^[а-яё\-]{2,}$/i.test(word) ? abbrevs[word] ? _results.push(abbrevs[word]++) : _results.push(abbrevs[word] = 1) : i > 0 && isCapitalized(word) && /^[а-яё\-]{2,}$/i.test(word) ? special_words[word] ? _results.push(special_words[word]++) : _results.push(special_words[word] = 1) : /^[а-яё\-]+$/i.test(word) && !/^\-+$/.test(word) ? (w = word.toLowerCase(), result = morphoRu(w), (_ref = result.type) !== "adverb" && _ref !== "preposition" && _ref !== "union" ? regular_words[w] ? _results.push(regular_words[w]++) : _results.push(regular_words[w] = 1) : common_used_words[w] ? _results.push(common_used_words[w]++) : _results.push(common_used_words[w] = 1)) : _results.push(void 0);
      return _results;
    }), {
      abbrevs: abbrevs,
      common_used_words: common_used_words,
      special_words: special_words,
      regular_words: regular_words,
      digits: digits,
      total_words: total_words
    };
  };
}(exports, ruWords);

var exports, inclines, morpho, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.propernames = {}, exports = window.lastName.plugins.ru.propernames, morpho = window.lastName.plugins.ru.morpho, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, morpho = require("./morpho"), inclines = require("./inclines")), function(exports, morpho, inclines) {
  return exports.postFilter = function(text, result) {
    var curProperName, id, p, pn, pnDict, properNames, properNamesRe, punctuationRe, _i, _j, _len, _len2, _ref, _ref2;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&\№“”\—]/g, properNames = [], curProperName = [], properNamesRe = /[А-Я][а-яё]+(\s+[А-Я][а-яё]+){0,2}/gm, _ref = text.match(properNamesRe);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) pn = _ref[_i], curProperName = pn.replace(/\s+/g, " ").split(" "), curProperName && (pn = inclines.findProperName(curProperName), pn && pn.found && properNames.push(pn));
    pnDict = {};
    for (_j = 0, _len2 = properNames.length; _j < _len2; _j++) p = properNames[_j], id = "" + (p.first_name || "") + "-" + (p.middle_name || "") + "-" + (p.surname || ""), pnDict[id] ? (pnDict[id].count += 1, (_ref2 = p.src, __indexOf.call(pnDict[id].src, _ref2) < 0) && pnDict[id].src.push(p.src)) : (pnDict[id] = p, pnDict[id].src = [ p.src ], pnDict[id].count = 1);
    return result.propernames = pnDict;
  };
}(exports, morpho, inclines);

var exports, inclines, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName.plugins.ru.feelings = {}, exports = window.lastName.plugins.ru.feelings, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, inclines = require("./inclines")), function(exports, inclines) {
  var evaluateSentenceNeutrality, getNegativePhrasesRe, negativeAdjectives, negativeVerbs, negativeWordsIncline;
  return exports.positive = [], negativeAdjectives = {
    "агрессивный": 3,
    "атакованный": 2,
    "бедный": 2,
    "беззащитный": 2,
    "безнадежный": 3,
    "безрадостный": 2,
    "бесплодный": 3,
    "беспомощный": 3,
    "бесправный": 2,
    "бессердечный": 1,
    "бессильный": 1,
    "бесцельный": 2,
    "бесчестный": 2,
    "вздорный": 1,
    "виновный": 1,
    "ворчливый": 1,
    "враждебный": 2,
    "вспыльчивый": 1,
    "выпученный": 1,
    "выселенный": 3,
    "высмеянный": 2,
    "выхолощенный": 1,
    "глубокий": 1,
    "глупый": 2,
    "горький": 2,
    "готический": 2,
    "гротескный": 1,
    "грустный": 1,
    "грязный": 1,
    "девальвированный": 2,
    "деградировавший": 2,
    "дегуманизированный": 2,
    "дезорганизованный": 2,
    "дезориентированный": 2,
    "деморализованный": 3,
    "дерзкий": 1,
    "дерьмовый": 3,
    "дефектный": 3,
    "драматический": 3,
    "жалкий": 3,
    "жесткий": 2,
    "жестокосердный": 2,
    "заброшенный": 1,
    "забываемый": 1,
    "забывчивый": 1,
    "забытый": 2,
    "зависимый": 1,
    "заинтересованный": 1,
    "запрещенный": 3,
    "запутанный": 2,
    "застенчивый": 1,
    "застрявший": 1,
    "затравленный": 2,
    "зверский": 3,
    "злобный": 2,
    "идиотский": 3,
    "измельченный": 2,
    "измученный": 2,
    "изнасилованный": 3,
    "изолированный": 3,
    "изумленный": 1,
    "интенсивный": 1,
    "иррациональный": 2,
    "исключенный": 2,
    "искусственный": 2,
    "испуганный": 2,
    "истерический": 3,
    "исчерпанный": 2,
    "капризный": 2,
    "контролируемый": 1,
    "критический": 1,
    "ленивый": 2,
    "лишенный": 2,
    "ложный": 2,
    "мазохистский": 1,
    "мертвый": 3,
    "меченый": 2,
    "мрачный": 2,
    "мстительный": 2,
    "навязчивый": 2,
    "надоедливый": 2,
    "наказанный": 2,
    "нарушенный": 2,
    "натянутый": 2,
    "неадекватный": 2,
    "неактивный": 1,
    "небезопасный": 2,
    "небрежный": 1,
    "невежественный": 1,
    "невидимый": 1,
    "невротический": 2,
    "негуманный": 2,
    "недействительный": 1,
    "недовольный": 2,
    "недостаточный": 1,
    "недоуменный": 1,
    "незаземленный": 1,
    "незначительный": 1,
    "неискренний": 1,
    "некомпетентный": 2,
    "ненавистный": 3,
    "необщительный": 2,
    "неполный": 2,
    "неправильный": 2,
    "неприятный": 2,
    "нервный": 2,
    "нерешительный": 1,
    "несбалансированный": 1,
    "несовместимый": 2,
    "несоответствующий": 2,
    "неспособный": 3,
    "несчастный": 2,
    "неуклюжий": 2,
    "неуловимый": 1,
    "неуместный": 2,
    "нечестный": 2,
    "неэффективный": 2,
    "низкий": 1,
    "обвиняемый": 3,
    "обедненный": 1,
    "обезумевший": 3,
    "обиженный": 2,
    "обманутый": 2,
    "обозленный": 2,
    "оборонительный": 1,
    "обремененный": 1,
    "обременительный": 1,
    "обреченный": 2,
    "ограниченный": 1,
    "одержимый": 3,
    "одинокий": 2,
    "одноразовый": 1,
    "озабоченный": 2,
    "окаменелый": 1,
    "онемелый": 1,
    "опальный": 2,
    "опасный": 3,
    "опустошенный": 1,
    "опущенный": 2,
    "опьяненный": 1,
    "оскорбленный": 2,
    "осмеянный": 2,
    "острый": 1,
    "осужденный": 3,
    "осушенный": 2,
    "ответственный": 2,
    "отвратительный": 3,
    "отдаленный": 1,
    "отдельный": 1,
    "отрицательный": 2,
    "отсталый": 2,
    "отчаянный": 1,
    "ошибочный": 1,
    "параноидальный": 2,
    "паршивый": 2,
    "пассивный": 1,
    "переполненный": 2,
    "пессимистический": 2,
    "печальный": 2,
    "побежденный": 3,
    "поверхностный": 2,
    "поврежденный": 3,
    "подавленный": 2,
    "поддельный": 3,
    "покинутый": 2,
    "покорный": 1,
    "порабощенный": 3,
    "потерянный": 2,
    "потерпевший": 2,
    "потребленный": 1,
    "презираемый": 2,
    "презренный": 3,
    "презрительный": 2,
    "прерванный": 1,
    "принудительный": 2,
    "психотический": 2,
    "пустынный": 1,
    "пьяный": 2,
    "равнодушный": 1,
    "развращенный": 3,
    "раздраженный": 2,
    "раздражительный": 2,
    "разочарованный": 2,
    "разочаровывающий": 3,
    "разрушенный": 3,
    "разрушительный": 2,
    "разъяренный": 3,
    "раненый": 2,
    "ревнивый": 2,
    "садистский": 2,
    "самоубийственный": 3,
    "саркастический": 1,
    "сварливый": 1,
    "сгоревший": 3,
    "сердитый": 2,
    "серый": 1,
    "скучающий": 1,
    "скучный": 1,
    "сломанный": 2,
    "смущенный": 1,
    "созерцательный": 1,
    "сомнительный": 2,
    "спорный": 2,
    "спровоцированный": 2,
    "спутанный": 2,
    "спущенный": 2,
    "стереотипный": 1,
    "стесненный": 1,
    "странный": 1,
    "страшный": 2,
    "сумасшедший": 2,
    "тихий": 1,
    "тормозящий": 2,
    "торопливый": 2,
    "тоскливый": 3,
    "требовательный": 2,
    "тревожный": 2,
    "трудный": 2,
    "трусливый": 2,
    "тупой": 1,
    "тщеславный": 2,
    "угнетенный": 2,
    "угрюмый": 2,
    "удаляемый": 2,
    "удрученный": 2,
    "ужасный": 3,
    "уклончивый": 2,
    "униженный": 3,
    "унылый": 3,
    "урезанный": 2,
    "фальшивый": 3,
    "хаотический": 2,
    "холодный": 1,
    "хрупкий": 1,
    "цепкий": 2,
    "циничный": 2,
    "чертовский": 2,
    "чрезмерный": 2,
    "чувствительный": 2,
    "эгоистичный": 2,
    "эгоцентричный": 3,
    "эксплуатируемый": 2,
    "эмансипированный": 2,
    "эмоциональный": 1,
    "яростный": 3
  }, negativeVerbs = {
    "беспокоить": 2,
    "бить": 2,
    "внушать": 2,
    "волноваться": 2,
    "высмеивать": 2,
    "грызть": 1,
    "диктовать": 2,
    "дребезжать": 1,
    "дрожать": 1,
    "дрогнуть": 2,
    "загнать": 2,
    "запугивать": 3,
    "запутаться": 2,
    "злоупотреблять": 2,
    "игнорировать": 1,
    "избегать": 1,
    "издеваться": 3,
    "изменять": 2,
    "командовать": 1,
    "лгать": 2,
    "лишить": 2,
    "манипулировать": 2,
    "молчать": 1,
    "надувать": 1,
    "ненавидеть": 3,
    "обвинять": 2,
    "обидеть": 2,
    "опорочить": 3,
    "освистать": 3,
    "отбрасывать": 1,
    "отвлекаться": 2,
    "отклонить": 2,
    "отрекаться": 3,
    "оттолкнуть": 2,
    "паниковать": 2,
    "перепутаться": 2,
    "подавить": 3,
    "подвергаться": 2,
    "пострадать": 2,
    "предавать": 3,
    "пренебрегать": 2,
    "препятствовать": 2,
    "преследовать": 2,
    "принижаться": 2,
    "приставать": 2,
    "прослушивать": 2,
    "разгромить": 2,
    "раздражаться": 2,
    "растаскивать": 2,
    "рисковать": 2,
    "ругать": 2,
    "сдуваться": 1,
    "смолчать": 2,
    "снизиться": 1,
    "сорвать": 1,
    "сожалеть": 2,
    "соизволить": 2,
    "солгать": 2,
    "сомневаться": 2,
    "споткнуться": 1,
    "столкнуться": 2,
    "страдать": 2,
    "стрелять": 3,
    "судить": 2,
    "толкнуть": 1,
    "убить": 3,
    "убивать": 3,
    "уговаривать": 1,
    "удалять": 2,
    "уклоняться": 2,
    "унижать": 3,
    "шантажировать": 2
  }, negativeWordsIncline = {
    "боль": 2,
    "вниз": 1,
    "горе": 3,
    "дно": 2,
    "мало": 1,
    "мучение": 2,
    "недовольство": 2,
    "плохо": 2,
    "противно": 3,
    "совестно": 2,
    "только": 1,
    "ужас": 3,
    "смерть": 3,
    "неодобрительно": 2,
    "разгром": 2,
    "отчаяние": 3
  }, exports.getNegativePhrasesRe = getNegativePhrasesRe = function() {
    return [ [ /[^а-яё]при\sотягчающих\sобстоятельствах[^а-яё]/ig, 2 ], [ /[^а-яё]ненависть\sк[^а-яё]/ig, 3 ], [ /[^а-яё]в\sубыток[^а-яё]/ig, 2 ], [ /[^а-яё]сыт[аы]?\sпо\sгорло[^а-яё]/ig, 3 ], [ /[^а-яё]заслужива[ею]т\sнаказания[^а-яё]/ig, 2 ], [ /[^а-яё]находящ(егося|ейся|емся|ихся)\sпод\sугрозой\sисчезновения[^а-яё]/ig, 3 ], [ /[^а-яё]в\sзаблуждение[^а-яё]/ig, 2 ], [ /[^а-яё]сбит[аы]?\sс\sтолку[^а-яё]/ig, 2 ], [ /[^а-яё]в\sужасе[^а-яё]/ig, 3 ], [ /[^а-яё]не\sрекоменд(ую|уем|уется|овал|овала|овали)[^а-яё]/ig, 2 ], [ /[^а-яё]не\sодобря(ю|ем|л|ла|ли|ется)[^а-яё]/ig, 2 ], [ /[^а-яё]пятно\sна[^а-яё]/ig, 2 ], [ /[^а-яё]в\sклетке[^а-яё]/ig, 1 ], [ /[^а-яё]неправильно\sпонял[аи]?[^а-яё]/ig, 2 ], [ /[^а-яё]вне\sпределов\sдосягаемости[^а-яё]/ig, 1 ], [ /[^а-яё]взял[аи]?\sна[^а-яё]/ig, 2 ], [ /[^а-яё]играл[аи]?\sс[^а-яё]/ig, 2 ], [ /[^а-яё]черный\sсписок[^а-яё]/ig, 3 ], [ /[^а-яё]возбужден[оы]\sуголовн(ое|ые)\sдел[оа][^а-яё]/ig, 8 ], [ /[^а-яё]жертв(|а|ы|ам|ами)[^а-яё]/ig, 3 ] ];
  }, exports.evaluateSentenceNeutrality = evaluateSentenceNeutrality = function(sentence) {
    var adj, adjArray, adjIndex, curWords, cur_index, ind, index, m, nr, resetCurIndex, vIndex, verb, words, wrd, _i, _j, _k, _len, _len2, _len3, _ref, _ref2;
    index = 0, cur_index = 0, words = [], curWords = [], _ref = getNegativePhrasesRe();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) nr = _ref[_i], m = sentence.match(nr[0]), m && (m.map(function(wordsSequence) {
      return words.push(wordsSequence);
    }), index -= nr[1] * m.length);
    resetCurIndex = function() {
      if (cur_index) return index += cur_index, words.push(curWords), curWords = [], cur_index = 0;
    }, _ref2 = sentence.split(/\s/);
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      wrd = _ref2[_j];
      if (__indexOf.call(".,-—!?()[]", wrd) >= 0) {
        cur_index = -cur_index, resetCurIndex();
        continue;
      }
      ind = negativeWordsIncline[wrd.toLowerCase()];
      if (ind) curWords.push(wrd), cur_index = cur_index * ind || ind; else {
        adjArray = inclines.getInitialFormOfAdjective(wrd);
        if (!adjArray) verb = inclines.getVerbInfinitive(wrd), vIndex = negativeVerbs[verb], vIndex ? (curWords.push(wrd), cur_index = cur_index * vIndex || vIndex) : (cur_index = -cur_index, resetCurIndex()); else for (_k = 0, _len3 = adjArray.length; _k < _len3; _k++) {
          adj = adjArray[_k], adjIndex = negativeAdjectives[adj];
          if (adjIndex) {
            curWords.push(wrd), cur_index = cur_index * adjIndex || adjIndex;
            break;
          }
        }
      }
    }
    return resetCurIndex(-cur_index), [ index, words ];
  }, exports.postFilter = function(text, result) {
    var emoIndex, emoWords, i, index, overallIndex, s, _len, _ref, _ref2;
    emoIndex = [], overallIndex = 0, _ref = result.misc.sentences;
    for (i = 0, _len = _ref.length; i < _len; i++) s = _ref[i], _ref2 = evaluateSentenceNeutrality(s), index = _ref2[0], emoWords = _ref2[1], emoIndex.push([ index, emoWords ]), overallIndex += index;
    return result.feelings = {
      emoIndex: emoIndex,
      overallIndex: overallIndex,
      emoScore: overallIndex / result.counters.words_total || 1
    };
  };
}(exports, inclines);

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).analysis || (_base.analysis = {}), exports = window.lastName.analysis) : exports = module.exports, function(exports) {
  return exports.analyse = function(text, plugins) {
    var f, misc, postFilter, preFilters, result, util, _i, _j, _len, _len2;
    plugins == null && (plugins = []), "undefined" == typeof global ? (misc = window.lastName.misc, util = window.lastName.util) : (misc = require("./misc"), util = require("./util")), result = {}, misc.preFilter(text, result), preFilters = plugins.filter(function(plugin) {
      return "function" == typeof plugin.preFilter;
    }), postFilter = plugins.filter(function(plugin) {
      return "function" == typeof plugin.postFilter;
    });
    for (_i = 0, _len = preFilters.length; _i < _len; _i++) f = preFilters[_i], f.preFilter(text, result);
    for (_j = 0, _len2 = postFilter.length; _j < _len2; _j++) f = postFilter[_j], f.postFilter(text, result);
    return result.version = util.version, result;
  };
}(exports);

var __slice = Array.prototype.slice;

(function(lastname) {
  return lastname.version = "0.3.5", lastname.findProperName = function() {
    var args, inclines, lang;
    return lang = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [], inclines = lastname.plugins["" + lang].inclines, inclines.findProperName.apply(this, args);
  };
})(window.lastName || (window.lastName = {}));

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).misc || (_base.misc = {}), exports = window.lastName.misc) : exports = module.exports, function(exports) {
  return exports.preFilter = function(text, result) {
    var chars_total, emo, emoticons, findEmo, ind, punctuationRe, sentences, signs, signs_total, spaces_total, tempTxt, word_length_mid, words_total, _i, _len;
    signs = text.match(/[-\+=\/\.,\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]{1}/g), signs_total = signs && signs.length || 0, spaces_total = /\s/.test(text) ? text.match(/\s/g).length : 0, chars_total = text.length, words_total = text.split(/\s/).filter(function(wrd) {
      return wrd.length > 0 && !/^[-\+=\/\.\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]+$/.test(wrd);
    }).length, word_length_mid = words_total ? (chars_total - spaces_total - signs_total) / words_total : 0, emoticons = [ ":-)", "(-:", ":o)", ":)", "(:", ":->", ":-}", ":-t", ":*)", ":-)))", ":-D", "(-D", ":'-)", "%-)", ":-/", ":-I", ":~)", "(:-(", ":-(", ":-c", ":-(((", ":-<", ">:-(", ":-[", "(:-&", "%-(", ">:-<", "~ :-(", "%-(", ":/)", ":-|", ":-e", ":-X", ":-v", ":-I", ":-8(", ":-O", ":-@", ":,-(", ":'-(", "~:-o", "]:-)>", "):-)", ";->", ":-x", ":-*", "8-]", ":-J", ":-&", ":-p", ":-P", ";-)", ";)", "'-)", ":-7", "?-(", "B-D", ":-B", ":-*)", ":-9", "|-p", ":-b", "-]:-)[-", "8-I", "8-|", "|:-|", ":-]", "|-)", "|-I", "I^o", "|-O", ':-"', ":-s", ":-#", ":-!", ":-()", ":-D", "(:-$", ":-(*)", ":-')", ":-R", "%+|", "%+{", "X-(", "<:-)", "*:o)", "@;-)", "X:-)", ":>)", "&:-)", "#:-)", "8-)", "8:-)", "B-)", "B-]", "O:-)", "&8-|", ":-{", ":-)}", ":-)#", ":-Q", ":-I", ":-d~", ":-?", ":-/I", ":-) X", "{(:-)", ":-{}", "[:-)", "d :-o", "~:-(", "~~:-(", "))", "(:-I", "3:-o", "[: |]", "M-)", ":X)", ":-M", "*8((:", "O+", "O->", "||*(", "||*)", "<{:-)}", "(-: :-)", "@->-", "@==", "<')))))- <" ], emoticons.sort(function(a, b) {
      return b.length - a.length;
    }), tempTxt = text.slice(0), findEmo = [];
    for (_i = 0, _len = emoticons.length; _i < _len; _i++) {
      emo = emoticons[_i], ind = 0;
      while (ind >= 0) ind = tempTxt.indexOf(emo, ind), ind !== -1 && (findEmo.push(emo), tempTxt = tempTxt.replace(emo, ""), ind -= emo.length + 2);
    }
    return punctuationRe = /(https?\:\/\/.*[\s$])|(\.\s)|(,\s)|(\s\:)|(:\s)|(\s\/)|(\/\s)|(\s\\)(\\\s)|\?|!|\+|\'|\"|«|»|\*|\(|\)|\[|\]|\&|\№|“|”|\—/g, tempTxt = text.replace(punctuationRe, " $& ").replace(/\s+/g, " "), /[\?\!\.]\s{0,}$/.test(tempTxt) || (tempTxt += " . "), sentences = tempTxt.replace(/\s\?\s/gm, " ?? ").replace(/\s\!\s/gm, " !! ").replace(/\s\.\s/gm, " .. ").split(/[\?\!\.](\s+|$)/gm).filter(function(s) {
      return !/^\s{0,}$/.test(s);
    }), result.misc = {
      digits: util.arrayToDict(text.match(/-?((\d+[\.,]\d+)|(\d+))/ig) || []),
      emoticons: util.arrayToDict(findEmo),
      romans: util.arrayToDict(text.match(/(^|\s|-)[CMDXLXVI]+(\s|-|$)/g) || []),
      sentences: sentences
    }, result.counters = {
      chars_total: chars_total,
      words_total: words_total,
      signs_total: signs_total,
      spaces_total: spaces_total,
      word_length_mid: word_length_mid,
      words_in_sentence_mid: sentences.length ? words_total / sentences.length : 0
    }, result;
  };
}(exports);

var exports, _base, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).util || (_base.util = {}), exports = window.lastName.util) : exports = module.exports, function(exports) {
  var capitalize, dictKeys, intersection, isCapitalized, isLowerCase, isUpperCase, merge, unique;
  return exports.version = "0.3.17", exports.capitalize = capitalize = function(s) {
    if (s) return "" + s[0].toUpperCase() + s.slice(1).toLowerCase();
  }, exports.dictKeys = dictKeys = function(dict) {
    var k, keys, v;
    keys = [];
    for (k in dict) v = dict[k], keys.push(k);
    return keys;
  }, exports.isCapitalized = isCapitalized = function(word) {
    var cap;
    return 0 <= word.indexOf("-") ? (cap = !0, word.split("-").map(function(wrd) {
      return cap && (cap = isCapitalized(wrd));
    }), cap) : word && word === capitalize(word) || !1;
  }, exports.isUpperCase = isUpperCase = function(word) {
    return word === word.toUpperCase();
  }, exports.isLowerCase = isLowerCase = function(word) {
    return word === word.toLowerCase();
  }, exports.unique = unique = function(array) {
    var key, output, value, _ref, _results;
    output = {};
    for (key = 0, _ref = array.length; 0 <= _ref ? key < _ref : key > _ref; 0 <= _ref ? key++ : key--) output[array[key]] = array[key];
    _results = [];
    for (key in output) value = output[key], _results.push(value);
    return _results;
  }, exports.merge = merge = function(l1, l2) {
    var l;
    return l = [], l1.map(function(x) {
      return l.push(x);
    }), l2.map(function(x) {
      return l.push(x);
    }), unique(l);
  }, exports.intersection = intersection = function(l1, l2) {
    var i, _i, _len;
    for (_i = 0, _len = l1.length; _i < _len; _i++) {
      i = l1[_i];
      if (__indexOf.call(l2, i) >= 0) return i;
    }
    return null;
  }, exports.arrayToDict = function(arr) {
    var d, i, _i, _len;
    d = {};
    for (_i = 0, _len = arr.length; _i < _len; _i++) i = arr[_i], d[i] ? d[i]++ : d[i] = 1;
    return d;
  };
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.ref = {}, exports = window.lastName.plugins.ru.ref) : exports = module.exports, function(exports) {
  return exports.ruFemaleNamesDict = {
    "альвина": 1,
    "анелия": 1,
    "августа": 1,
    "августина": 1,
    "авдотья": 1,
    "авелина": 1,
    "аврелия": 1,
    "аврора": 1,
    "агапия": 1,
    "агата": 1,
    "агафья": 1,
    "агафия": 1,
    "аглаида": 1,
    "аглая": 1,
    "агнеса": 1,
    "агнесса": 1,
    "агния": 1,
    "агриппмеа": 1,
    "агрефена": 1,
    "ада": 1,
    "адина": 1,
    "адель": 1,
    "аделия": 1,
    "аделаида": 1,
    "аза": 1,
    "азалия": 1,
    "аида": 1,
    "айседора": 1,
    "айсылу": 1,
    "акилина": 1,
    "акулина": 1,
    "аксинья": 1,
    "алевтина": 1,
    "александра": 1,
    "алеся": 1,
    "алена": 1,
    "алина": 1,
    "алиса": 1,
    "алия": 1,
    "алла": 1,
    "алика": 1,
    "альбина": 1,
    "альмир": 1,
    "альфия": 1,
    "амина": 1,
    "анастасия": 1,
    "анатолия": 1,
    "ангелина": 1,
    "анжела": 1,
    "анимаиса": 1,
    "анисия": 1,
    "анисья": 1,
    "анна": 1,
    "анита": 1,
    "антонина": 1,
    "антонида": 1,
    "антония": 1,
    "анфиса": 1,
    "анфуса": 1,
    "анфия": 1,
    "амира": 1,
    "аполлинария": 1,
    "аревик": 1,
    "ариадна": 1,
    "арина": 1,
    "аркадия": 1,
    "арсения": 1,
    "арсиана": 1,
    "артемия": 1,
    "асель": 1,
    "аста": 1,
    "астра": 1,
    "астрид": 1,
    "афанасия": 1,
    "афродита": 1,
    "аэлита": 1,
    "аэлла": 1,
    "амалия": 1,
    "бажена": 1,
    "беата": 1,
    "беатриса": 1,
    "бела": 1,
    "белла": 1,
    "беллатриса": 1,
    "берта": 1,
    "богдана": 1,
    "божена": 1,
    "болеслава": 1,
    "борислава": 1,
    "бриджет": 1,
    "бронислава": 1,
    "валентина": 1,
    "валерия": 1,
    "ванда": 1,
    "варвара": 1,
    "василина": 1,
    "василиса": 1,
    "васса": 1,
    "вацлава": 1,
    "вевея": 1,
    "велора": 1,
    "велория": 1,
    "венера": 1,
    "вера": 1,
    "вероника": 1,
    "веселина": 1,
    "веста": 1,
    "видана": 1,
    "викторина": 1,
    "виктория": 1,
    "вилена": 1,
    "виола": 1,
    "виолетта": 1,
    "виоланта": 1,
    "виринея": 1,
    "вита": 1,
    "виталия": 1,
    "виталина": 1,
    "виулена": 1,
    "влада": 1,
    "владилена": 1,
    "владимира": 1,
    "владислава": 1,
    "владлена": 1,
    "власта": 1,
    "воля": 1,
    "всеслава": 1,
    "гайя": 1,
    "гали": 1,
    "галина": 1,
    "ганна": 1,
    "гаяна": 1,
    "гаяния": 1,
    "гвинет": 1,
    "гелена": 1,
    "гелия": 1,
    "гелла": 1,
    "генриетта": 1,
    "гертруда": 1,
    "глафира": 1,
    "гликерия": 1,
    "глория": 1,
    "голуба": 1,
    "горислава": 1,
    "гюльанэ": 1,
    "гюльнара": 1,
    "гюльчитай": 1,
    "даздраперма": 1,
    "дайна": 1,
    "дана": 1,
    "дарья": 1,
    "дария": 1,
    "дарина": 1,
    "дарьяна": 1,
    "декабрина": 1,
    "дея": 1,
    "дия": 1,
    "джиневра": 1,
    "дженнифер": 1,
    "джульета": 1,
    "дианна": 1,
    "дилия": 1,
    "диля": 1,
    "дильфуза": 1,
    "дина": 1,
    "диния": 1,
    "диодора": 1,
    "дионисия": 1,
    "добрава": 1,
    "домна": 1,
    "домина": 1,
    "домника": 1,
    "доминика": 1,
    "донара": 1,
    "дорофея": 1,
    "доротея": 1,
    "ева": 1,
    "евгения": 1,
    "евдокия": 1,
    "евлалия": 1,
    "евлампия": 1,
    "евпраксия": 1,
    "евстолия": 1,
    "евфалия": 1,
    "евфросиния": 1,
    "екатерина": 1,
    "елена": 1,
    "елизавета": 1,
    "еликонида": 1,
    "ермиония": 1,
    "есения": 1,
    "ефимия": 1,
    "евфремия": 1,
    "жанна": 1,
    "ждана": 1,
    "жаннэ": 1,
    "жасмина": 1,
    "забава": 1,
    "заира": 1,
    "зара": 1,
    "зарема": 1,
    "зарина": 1,
    "зорина": 1,
    "заряна": 1,
    "зауре": 1,
    "звенислава": 1,
    "земфира": 1,
    "зиля": 1,
    "зинаида": 1,
    "зиновия": 1,
    "злата": 1,
    "зозан": 1,
    "зоя": 1,
    "зульфия": 1,
    "иванна": 1,
    "ида": 1,
    "илария": 1,
    "илиана": 1,
    "илона": 1,
    "ильмира": 1,
    "инга": 1,
    "индира": 1,
    "инесса": 1,
    "инна": 1,
    "иоанна": 1,
    "иона": 1,
    "ипатия": 1,
    "ипполита": 1,
    "ирада": 1,
    "ираида": 1,
    "ирена": 1,
    "ироида": 1,
    "ираклия": 1,
    "ирина": 1,
    "исидора": 1,
    "искра": 1,
    "ифигения": 1,
    "ия": 1,
    "кадрия": 1,
    "кермен": 1,
    "калиса": 1,
    "каллиста": 1,
    "камилла": 1,
    "камила": 1,
    "капитолина": 1,
    "карина": 1,
    "каролина": 1,
    "катерина": 1,
    "кира": 1,
    "кирилла": 1,
    "клавдия": 1,
    "клара": 1,
    "клариса": 1,
    "кларисса": 1,
    "клеопатра": 1,
    "клио": 1,
    "клер": 1,
    "конкордия": 1,
    "констанция": 1,
    "кристина": 1,
    "ксения": 1,
    "лавиния": 1,
    "лада": 1,
    "лана": 1,
    "лариса": 1,
    "лаура": 1,
    "лейла": 1,
    "лема": 1,
    "лена": 1,
    "лениана": 1,
    "ленина": 1,
    "леонида": 1,
    "леонила": 1,
    "леонтия": 1,
    "леся": 1,
    "ливия": 1,
    "лидия": 1,
    "лилиана": 1,
    "лилия": 1,
    "лилит": 1,
    "лина": 1,
    "лира": 1,
    "лия": 1,
    "лея": 1,
    "лора": 1,
    "луиза": 1,
    "лукерия": 1,
    "лукиана": 1,
    "лукина": 1,
    "люцина": 1,
    "лусинэ": 1,
    "любава": 1,
    "любовь": 1,
    "любомира": 1,
    "людмила": 1,
    "ляля": 1,
    "мавра": 1,
    "магда": 1,
    "магдалина": 1,
    "мадлен": 1,
    "майя": 1,
    "мая": 1,
    "мальвина": 1,
    "маргарита": 1,
    "мариана": 1,
    "марьяна": 1,
    "марианна": 1,
    "мариетта": 1,
    "мариэтта": 1,
    "марика": 1,
    "марина": 1,
    "мария": 1,
    "марья": 1,
    "мари": 1,
    "марлен": 1,
    "марлена": 1,
    "марта": 1,
    "марфа": 1,
    "матильда": 1,
    "матрена": 1,
    "матрёна": 1,
    "матрона": 1,
    "мелания": 1,
    "меланья": 1,
    "мелитина": 1,
    "милада": 1,
    "милана": 1,
    "милен": 1,
    "милица": 1,
    "милия": 1,
    "милослава": 1,
    "мира": 1,
    "мирра": 1,
    "мирослава": 1,
    "митродора": 1,
    "млада": 1,
    "мстислава": 1,
    "нада": 1,
    "надежда": 1,
    "надия": 1,
    "наина": 1,
    "наира": 1,
    "нана": 1,
    "настасья": 1,
    "наталья": 1,
    "наталия": 1,
    "нелли": 1,
    "неонила": 1,
    "ника": 1,
    "нина": 1,
    "нинелла": 1,
    "нинель": 1,
    "новелла": 1,
    "нонна": 1,
    "нора": 1,
    "нуркыз": 1,
    "насиба": 1,
    "оксана": 1,
    "октавия": 1,
    "октябрина": 1,
    "олеся": 1,
    "оливия": 1,
    "олимпиада": 1,
    "олимпия": 1,
    "ольга": 1,
    "офелия": 1,
    "павла": 1,
    "павлина": 1,
    "патриция": 1,
    "пелагея": 1,
    "платонида": 1,
    "поликсена": 1,
    "полина": 1,
    "правдина": 1,
    "прасковья": 1,
    "пенелопа": 1,
    "полислава": 1,
    "рада": 1,
    "радмила": 1,
    "раиса": 1,
    "раймонда": 1,
    "раялла": 1,
    "ревмира": 1,
    "регина": 1,
    "рената": 1,
    "римма": 1,
    "рогнеда": 1,
    "роза": 1,
    "розалина": 1,
    "розалия": 1,
    "розана": 1,
    "роксан": 1,
    "ростислава": 1,
    "руслана": 1,
    "руфина": 1,
    "руфь": 1,
    "раида": 1,
    "сабина": 1,
    "сабрина": 1,
    "саломея": 1,
    "соломея": 1,
    "самира": 1,
    "светлана": 1,
    "светозара": 1,
    "светослава": 1,
    "свобода": 1,
    "святослава": 1,
    "севастьяна": 1,
    "северина": 1,
    "селена": 1,
    "селина": 1,
    "селестина": 1,
    "серафима": 1,
    "сергияна": 1,
    "сильва": 1,
    "агриппина": 1,
    "алёна": 1,
    "вилора": 1,
    "вилория": 1,
    "джульетта": 1,
    "диана": 1,
    "евфимия": 1,
    "ефросиния": 1,
    "калерия": 1,
    "милена": 1,
    "муза": 1,
    "савина": 1,
    "сильвия": 1,
    "симона": 1,
    "слава": 1,
    "славяна": 1,
    "снежана": 1,
    "софья": 1,
    "софия": 1,
    "станислава": 1,
    "стелла": 1,
    "степанида": 1,
    "стефанида": 1,
    "стефания": 1,
    "сусанна": 1,
    "сосанна": 1,
    "сюзанна": 1,
    "таира": 1,
    "таисия": 1,
    "тальяна": 1,
    "тамара": 1,
    "тамила": 1,
    "томила": 1,
    "татьяна": 1,
    "текуса": 1,
    "тереза": 1,
    "улита": 1,
    "ульяна": 1,
    "услада": 1,
    "устинья": 1,
    "фаина": 1,
    "февронья": 1,
    "феликсана": 1,
    "фелицата": 1,
    "фелицитата": 1,
    "фелиция": 1,
    "федора": 1,
    "феодора": 1,
    "феодосия": 1,
    "феодосья": 1,
    "феоктиста": 1,
    "феофания": 1,
    "феона": 1,
    "флавия": 1,
    "флора": 1,
    "флория": 1,
    "флорентина": 1,
    "флоренция": 1,
    "флориана": 1,
    "фотина": 1,
    "харита": 1,
    "харитина": 1,
    "хиония": 1,
    "христина": 1,
    "цецилия": 1,
    "чеслава": 1,
    "эвелина": 1,
    "эвридика": 1,
    "эдда": 1,
    "элеонора": 1,
    "элина": 1,
    "эльвира": 1,
    "эльмира": 1,
    "эльза": 1,
    "эмилия": 1,
    "эмма": 1,
    "эрика": 1,
    "эсфирь": 1,
    "юдифь": 1,
    "юзефа": 1,
    "юлиана": 1,
    "юлитта": 1,
    "юлия": 1,
    "юманита": 1,
    "юния": 1,
    "юнона": 1,
    "юстина": 1,
    "ядвига": 1,
    "яна": 1,
    "янина": 1,
    "яромира": 1,
    "ярослава": 1
  }, exports.ruMaleNamesDict = {
    "ааран": 1,
    "аарен": 1,
    "ааррон": 1,
    "аб": 1,
    "аббат": 1,
    "абботт": 1,
    "абей": 1,
    "абелл": 1,
    "абель": 1,
    "абнар": 1,
    "абнер": 1,
    "абнор": 1,
    "абот": 1,
    "аботт": 1,
    "абрам": 1,
    "абран": 1,
    "абрахам": 1,
    "абсалон": 1,
    "авангард": 1,
    "август": 1,
    "августин": 1,
    "авдей": 1,
    "авдий": 1,
    "авенир": 1,
    "аверилл": 1,
    "аверкий": 1,
    "авксентий": 1,
    "аврам": 1,
    "аврор": 1,
    "аврорий": 1,
    "агап": 1,
    "аггей": 1,
    "агей": 1,
    "адам": 1,
    "аддам": 1,
    "аддисон": 1,
    "аден": 1,
    "адий": 1,
    "адисон": 1,
    "адиссон": 1,
    "адлэй": 1,
    "адней": 1,
    "адольф": 1,
    "адонис": 1,
    "адриан": 1,
    "адэйр": 1,
    "адэр": 1,
    "азия": 1,
    "азэлстан": 1,
    "айбл": 1,
    "айзек": 1,
    "айк": 1,
    "ак": 1,
    "акей": 1,
    "акерлеа": 1,
    "акерлей": 1,
    "акерли": 1,
    "аки": 1,
    "аким": 1,
    "аклеа": 1,
    "аклей": 1,
    "акли": 1,
    "аксён": 1,
    "актон": 1,
    "акэль": 1,
    "алан": 1,
    "аластеир": 1,
    "аластэйр": 1,
    "алвар": 1,
    "алвен": 1,
    "алви": 1,
    "алвин": 1,
    "алвис": 1,
    "алгар": 1,
    "алджернон": 1,
    "алевтин": 1,
    "алеистер": 1,
    "алек": 1,
    "алекс": 1,
    "александр": 1,
    "алексей": 1,
    "ален": 1,
    "алестер": 1,
    "алжир": 1,
    "алик": 1,
    "аликс": 1,
    "алим": 1,
    "алисандр": 1,
    "алисдэйр": 1,
    "алиссандр": 1,
    "алистер": 1,
    "алистэйр": 1,
    "аллан": 1,
    "аллен": 1,
    "аллин": 1,
    "аллистер": 1,
    "аллистир": 1,
    "аллистэйр": 1,
    "алтон": 1,
    "алф": 1,
    "алфонзо": 1,
    "алфорд": 1,
    "алфрид": 1,
    "альберт": 1,
    "альбин": 1,
    "альвиан": 1,
    "альвин": 1,
    "альдина": 1,
    "альпин": 1,
    "альтаир": 1,
    "альфа": 1,
    "альфи": 1,
    "альфред": 1,
    "алэйстер": 1,
    "алэйстэйр": 1,
    "амби": 1,
    "амброуз": 1,
    "амедеус": 1,
    "амиас": 1,
    "амори": 1,
    "амос": 1,
    "амьяс": 1,
    "анакин": 1,
    "ананий": 1,
    "анастасий": 1,
    "анатолий": 1,
    "анвар": 1,
    "ангел": 1,
    "ангес": 1,
    "андерсон": 1,
    "анджелл": 1,
    "андрей": 1,
    "андреян": 1,
    "андриан": 1,
    "андрон": 1,
    "анж": 1,
    "анис": 1,
    "анисий": 1,
    "анисим": 1,
    "анри": 1,
    "анском": 1,
    "анскомб": 1,
    "ансон": 1,
    "антван": 1,
    "антип": 1,
    "антон": 1,
    "антоний": 1,
    "антонин": 1,
    "антуан": 1,
    "аполлинарий": 1,
    "аполлон": 1,
    "арам": 1,
    "арвид": 1,
    "аргент": 1,
    "арден": 1,
    "арефий": 1,
    "арий": 1,
    "арик": 1,
    "арил": 1,
    "арин": 1,
    "аристарх": 1,
    "аркадий": 1,
    "аркелл": 1,
    "арлен": 1,
    "арли": 1,
    "арман": 1,
    "армен": 1,
    "арн": 1,
    "арне": 1,
    "арни": 1,
    "арнольд": 1,
    "арран": 1,
    "аррин": 1,
    "аррон": 1,
    "арсен": 1,
    "арсений": 1,
    "арт": 1,
    "артамон": 1,
    "артемий": 1,
    "арти": 1,
    "артур": 1,
    "артём": 1,
    "архип": 1,
    "арчи": 1,
    "арчибальд": 1,
    "аселет": 1,
    "аселин": 1,
    "асер": 1,
    "аскольд": 1,
    "астон": 1,
    "атеист": 1,
    "афанасий": 1,
    "афиноген": 1,
    "афтон": 1,
    "аффтон": 1,
    "ахмат": 1,
    "ахмет": 1,
    "ачилл": 1,
    "аш": 1,
    "ашер": 1,
    "ашот": 1,
    "аштон": 1,
    "баграт": 1,
    "бад": 1,
    "бадди": 1,
    "бажен": 1,
    "баз": 1,
    "базилик": 1,
    "байрон": 1,
    "байярд": 1,
    "бак": 1,
    "бакстер": 1,
    "балдер": 1,
    "балдрик": 1,
    "бамби": 1,
    "баптист": 1,
    "бардолф": 1,
    "барии": 1,
    "барклей": 1,
    "барнабас": 1,
    "барни": 1,
    "барнэби": 1,
    "барретт": 1,
    "барри": 1,
    "барт": 1,
    "бартоломей": 1,
    "бассетт": 1,
    "бастер": 1,
    "бастиан": 1,
    "батч": 1,
    "баян": 1,
    "беван": 1,
    "беверли": 1,
    "бевис": 1,
    "бедивир": 1,
    "бейб": 1,
    "бейлей": 1,
    "бейлие": 1,
    "бен": 1,
    "бенджамин": 1,
    "бенджи": 1,
    "бенедикт": 1,
    "бенет": 1,
    "беннетт": 1,
    "бенни": 1,
    "бенние": 1,
    "бенсон": 1,
    "бентлей": 1,
    "бентон": 1,
    "беорегард": 1,
    "бердт": 1,
    "беренгар": 1,
    "беренджер": 1,
    "берет": 1,
    "бернард": 1,
    "берни": 1,
    "берри": 1,
    "берт": 1,
    "берти": 1,
    "бертольд": 1,
    "бертон": 1,
    "бертрам": 1,
    "бертран": 1,
    "бивис": 1,
    "билл": 1,
    "билли": 1,
    "бисш": 1,
    "биф": 1,
    "блейн": 1,
    "близэ": 1,
    "блисс": 1,
    "блэйз": 1,
    "блэйк": 1,
    "блэйн": 1,
    "блэр": 1,
    "боб": 1,
    "бобби": 1,
    "богдан": 1,
    "боеслав": 1,
    "болдуин": 1,
    "болеслав": 1,
    "боллард": 1,
    "бомонт": 1,
    "бонифэйс": 1,
    "боримир": 1,
    "борис": 1,
    "борислав": 1,
    "боян": 1,
    "брадлей": 1,
    "браеден": 1,
    "брайен": 1,
    "брайон": 1,
    "бранден": 1,
    "брандон": 1,
    "браннон": 1,
    "брейден": 1,
    "брейдн": 1,
    "брендан": 1,
    "бренден": 1,
    "брендон": 1,
    "бреннан": 1,
    "брент": 1,
    "брентон": 1,
    "брет": 1,
    "бретт": 1,
    "бриар": 1,
    "брион": 1,
    "брис": 1,
    "бриско": 1,
    "бриттон": 1,
    "бриэм": 1,
    "бродерик": 1,
    "броди": 1,
    "броз": 1,
    "брок": 1,
    "бронислав": 1,
    "бронт": 1,
    "броуди": 1,
    "броук": 1,
    "брук": 1,
    "брукс": 1,
    "бруно": 1,
    "брутус": 1,
    "брьянт": 1,
    "брэд": 1,
    "брэди": 1,
    "брэдфорд": 1,
    "брэйден": 1,
    "брэйди": 1,
    "брэм": 1,
    "брэн": 1,
    "брюс": 1,
    "брююс": 1,
    "будимир": 1,
    "буз": 1,
    "букер": 1,
    "булат": 1,
    "бью": 1,
    "бэйли": 1,
    "вавила": 1,
    "вадим": 1,
    "вал": 1,
    "валентайн": 1,
    "валентин": 1,
    "валериан": 1,
    "валерий": 1,
    "валерьян": 1,
    "вальдемар": 1,
    "вальтер": 1,
    "ванадий": 1,
    "вард": 1,
    "варлаам": 1,
    "варлам": 1,
    "варлен": 1,
    "вартан": 1,
    "варфоломей": 1,
    "василий": 1,
    "василько": 1,
    "ваухан": 1,
    "вахтанг": 1,
    "вацлав": 1,
    "вашингтон": 1,
    "вебстер": 1,
    "велдон": 1,
    "велимир": 1,
    "велислав": 1,
    "велор": 1,
    "велорий": 1,
    "венедикт": 1,
    "вениамин": 1,
    "вер": 1,
    "вергилий": 1,
    "верджил": 1,
    "верн": 1,
    "вернон": 1,
    "вестер": 1,
    "вестлей": 1,
    "вестон": 1,
    "вик": 1,
    "викентий": 1,
    "виктор": 1,
    "вил": 1,
    "вилберн": 1,
    "вилей": 1,
    "вилен": 1,
    "вилий": 1,
    "вилиор": 1,
    "вилки": 1,
    "вилл": 1,
    "вилли": 1,
    "виллоби": 1,
    "вилмар": 1,
    "вилмер": 1,
    "вилмот": 1,
    "вилор": 1,
    "вилорг": 1,
    "вилорий": 1,
    "вилсон": 1,
    "вилф": 1,
    "вилфорд": 1,
    "виль": 1,
    "вильгельм": 1,
    "вильтон": 1,
    "вильям": 1,
    "вин": 1,
    "виндзор": 1,
    "винни": 1,
    "винс": 1,
    "винсент": 1,
    "винслоу": 1,
    "винтроп": 1,
    "винцент": 1,
    "виолен": 1,
    "вирджиль": 1,
    "виссарион": 1,
    "вистан": 1,
    "виталий": 1,
    "витейкр": 1,
    "витней": 1,
    "витольд": 1,
    "влад": 1,
    "владелин": 1,
    "владилен": 1,
    "владимир": 1,
    "владислав": 1,
    "владлен": 1,
    "влас": 1,
    "власий": 1,
    "воган": 1,
    "вогн": 1,
    "воин": 1,
    "воислав": 1,
    "волдо": 1,
    "волемир": 1,
    "волкер": 1,
    "воллис": 1,
    "володар": 1,
    "вольдемар": 1,
    "вольмир": 1,
    "вольт": 1,
    "вольф": 1,
    "вольфрам": 1,
    "воспой": 1,
    "всеволод": 1,
    "всемил": 1,
    "вуди": 1,
    "вудроу": 1,
    "вулф": 1,
    "вьятт": 1,
    "вэйд": 1,
    "вэйланд": 1,
    "вэнс": 1,
    "вячеслав": 1,
    "габби": 1,
    "габриель": 1,
    "габриэль": 1,
    "гавриил": 1,
    "гаврил": 1,
    "гаврила": 1,
    "гаврило": 1,
    "гай": 1,
    "гайдар": 1,
    "гайлс": 1,
    "галактион": 1,
    "гален": 1,
    "галий": 1,
    "гамильтон": 1,
    "гамлет": 1,
    "гантэр": 1,
    "гаральд": 1,
    "гарван": 1,
    "гарей": 1,
    "гарибальди": 1,
    "гарланд": 1,
    "гарнет": 1,
    "гарольд": 1,
    "гарри": 1,
    "гаррий": 1,
    "гарс": 1,
    "гарфилд": 1,
    "гас": 1,
    "гаспар": 1,
    "гваделупа": 1,
    "гвидон": 1,
    "гейб": 1,
    "гейл": 1,
    "гейр": 1,
    "гектор": 1,
    "гелеон": 1,
    "гелиан": 1,
    "гелий": 1,
    "ген": 1,
    "гений": 1,
    "геннадий": 1,
    "генри": 1,
    "генрих": 1,
    "геодар": 1,
    "георгий": 1,
    "геральд": 1,
    "герасим": 1,
    "герберт": 1,
    "герман": 1,
    "гермоген": 1,
    "герольд": 1,
    "геронт": 1,
    "геронтий": 1,
    "герт": 1,
    "гертруд": 1,
    "гидеон": 1,
    "гильберт": 1,
    "гисберт": 1,
    "гладвин": 1,
    "гланвилл": 1,
    "глеб": 1,
    "глендауэр": 1,
    "гленн": 1,
    "глэн": 1,
    "говард": 1,
    "годвин": 1,
    "годфри": 1,
    "голлагэр": 1,
    "голладжер": 1,
    "гомер": 1,
    "горазд": 1,
    "гораций": 1,
    "горд": 1,
    "гордей": 1,
    "горден": 1,
    "гордий": 1,
    "гордон": 1,
    "горимир": 1,
    "горислав": 1,
    "горн": 1,
    "граем": 1,
    "грай": 1,
    "гранвилл": 1,
    "гранд": 1,
    "гранит": 1,
    "грахэйм": 1,
    "грег": 1,
    "грей": 1,
    "гренвилл": 1,
    "григорий": 1,
    "гриир": 1,
    "грир": 1,
    "гриффин": 1,
    "гриффит": 1,
    "гровер": 1,
    "грэг": 1,
    "грэгори": 1,
    "грэди": 1,
    "грэм": 1,
    "гудвин": 1,
    "гудзон": 1,
    "гурий": 1,
    "густав": 1,
    "гэй": 1,
    "гэйбл": 1,
    "гэйг": 1,
    "гэйдж": 1,
    "гэйелорд": 1,
    "гэйл": 1,
    "гэйлон": 1,
    "гэйлорд": 1,
    "гэйр": 1,
    "гэлл": 1,
    "гэри": 1,
    "давей": 1,
    "дави": 1,
    "давид": 1,
    "давыд": 1,
    "дад": 1,
    "дадда": 1,
    "дадли": 1,
    "даймонд": 1,
    "дакей": 1,
    "дакота": 1,
    "дакс": 1,
    "далтон": 1,
    "дамайон": 1,
    "дамиан": 1,
    "дамир": 1,
    "дан": 1,
    "дана": 1,
    "дани": 1,
    "даниар": 1,
    "даниил": 1,
    "данил": 1,
    "данила": 1,
    "данило": 1,
    "даниэль": 1,
    "данки": 1,
    "данни": 1,
    "дар": 1,
    "дарби": 1,
    "дарвин": 1,
    "дарден": 1,
    "дарен": 1,
    "дариан": 1,
    "дарил": 1,
    "дарин": 1,
    "дарки": 1,
    "дарнелл": 1,
    "даррел": 1,
    "даррен": 1,
    "даррил": 1,
    "даррин": 1,
    "даррэль": 1,
    "дасти": 1,
    "дастин": 1,
    "дау": 1,
    "дафф": 1,
    "даффи": 1,
    "дашилл": 1,
    "дван": 1,
    "двэйн": 1,
    "деай": 1,
    "деван": 1,
    "девен": 1,
    "девереукс": 1,
    "девин": 1,
    "девон": 1,
    "дейв": 1,
    "дейл": 1,
    "дейрлл": 1,
    "дейрн": 1,
    "декабрий": 1,
    "деклан": 1,
    "декстер": 1,
    "делберт": 1,
    "делл": 1,
    "делмар": 1,
    "делрой": 1,
    "дементий": 1,
    "деметриус": 1,
    "демид": 1,
    "демократ": 1,
    "демон": 1,
    "демьян": 1,
    "ден": 1,
    "денвер": 1,
    "денеб": 1,
    "дензэль": 1,
    "дени": 1,
    "денил": 1,
    "денис": 1,
    "деннис": 1,
    "дентон": 1,
    "деон": 1,
    "деонн": 1,
    "деонт": 1,
    "дерби": 1,
    "дерек": 1,
    "дерик": 1,
    "дермот": 1,
    "дерок": 1,
    "деррен": 1,
    "дерри": 1,
    "деррил": 1,
    "дефорест": 1,
    "дефоррест": 1,
    "дешон": 1,
    "джадд": 1,
    "джадин": 1,
    "джай": 1,
    "джайлс": 1,
    "джак": 1,
    "джамар": 1,
    "джамей": 1,
    "джамисон": 1,
    "джарвис": 1,
    "джаред": 1,
    "джарод": 1,
    "джарред": 1,
    "джарретт": 1,
    "джаррод": 1,
    "джаспер": 1,
    "джасти": 1,
    "джастин": 1,
    "джеб": 1,
    "джед": 1,
    "джедидиа": 1,
    "джейдн": 1,
    "джейк": 1,
    "джейлн": 1,
    "джейми": 1,
    "джеймс": 1,
    "джейрт": 1,
    "джейсон": 1,
    "джекки": 1,
    "джекоб": 1,
    "джем": 1,
    "дженкин": 1,
    "джеп": 1,
    "джер": 1,
    "джералд": 1,
    "джеральд": 1,
    "джерард": 1,
    "джерваз": 1,
    "джервис": 1,
    "джереми": 1,
    "джери": 1,
    "джермэйн": 1,
    "джеролд": 1,
    "джером": 1,
    "джеррард": 1,
    "джерред": 1,
    "джерри": 1,
    "джеррод": 1,
    "джерролд": 1,
    "джес": 1,
    "джесси": 1,
    "джетро": 1,
    "джетт": 1,
    "джеф": 1,
    "джеффери": 1,
    "джефферсон": 1,
    "джеффрей": 1,
    "джеффри": 1,
    "джиб": 1,
    "джид": 1,
    "джиди": 1,
    "джил": 1,
    "джим": 1,
    "джими": 1,
    "джимми": 1,
    "джисберт": 1,
    "джиффард": 1,
    "джо": 1,
    "джоб": 1,
    "джоби": 1,
    "джоджо": 1,
    "джоди": 1,
    "джозеф": 1,
    "джой": 1,
    "джойс": 1,
    "джон": 1,
    "джоназан": 1,
    "джоназон": 1,
    "джонасон": 1,
    "джонатан": 1,
    "джоней": 1,
    "джони": 1,
    "джонни": 1,
    "джонти": 1,
    "джорги": 1,
    "джордан": 1,
    "джордж": 1,
    "джорди": 1,
    "джордон": 1,
    "джосс": 1,
    "джоул": 1,
    "джош": 1,
    "джошоа": 1,
    "джошуа": 1,
    "джулс": 1,
    "джульян": 1,
    "джустис": 1,
    "джьюд": 1,
    "джэй": 1,
    "джэйд": 1,
    "джэйда": 1,
    "джэйден": 1,
    "джэйдон": 1,
    "джэйкоб": 1,
    "джэйлен": 1,
    "джэйлин": 1,
    "джэйлон": 1,
    "джэймес": 1,
    "джэйсон": 1,
    "джэксон": 1,
    "джэмини": 1,
    "джэмми": 1,
    "джэн": 1,
    "ди": 1,
    "диакон": 1,
    "дигби": 1,
    "диггори": 1,
    "дигори": 1,
    "дидим": 1,
    "дизон": 1,
    "дик": 1,
    "дики": 1,
    "дикки": 1,
    "дил": 1,
    "дилан": 1,
    "дилберт": 1,
    "димер": 1,
    "димитрий": 1,
    "дин": 1,
    "диндр": 1,
    "дионис": 1,
    "дионисий": 1,
    "дирк": 1,
    "дмитрий": 1,
    "доб": 1,
    "добрыня": 1,
    "додж": 1,
    "дольф": 1,
    "дом": 1,
    "доменик": 1,
    "доминик": 1,
    "дон": 1,
    "дональд": 1,
    "дональт": 1,
    "донат": 1,
    "донни": 1,
    "донован": 1,
    "дор": 1,
    "дориан": 1,
    "дорофей": 1,
    "доусон": 1,
    "драйк": 1,
    "древ": 1,
    "дрейвн": 1,
    "дуайт": 1,
    "дуан": 1,
    "дуг": 1,
    "дуги": 1,
    "дуглас": 1,
    "дункан": 1,
    "дунстан": 1,
    "дью": 1,
    "дьюей": 1,
    "дьюэйн": 1,
    "дэвид": 1,
    "дэвис": 1,
    "дэй": 1,
    "дэйви": 1,
    "дэйн": 1,
    "дэйтон": 1,
    "дэн": 1,
    "дэни": 1,
    "дэниел": 1,
    "дэнни": 1,
    "дэррик": 1,
    "дэшон": 1,
    "дюк": 1,
    "евгений": 1,
    "евграф": 1,
    "евдоким": 1,
    "евлампий": 1,
    "евлогий": 1,
    "евсей": 1,
    "евстафий": 1,
    "егор": 1,
    "елеазар": 1,
    "елизар": 1,
    "елисей": 1,
    "емельян": 1,
    "епифан": 1,
    "еремей": 1,
    "ермак": 1,
    "ермил": 1,
    "ермолай": 1,
    "ерофей": 1,
    "еруслан": 1,
    "ефим": 1,
    "ефрем": 1,
    "ждан": 1,
    "жерар": 1,
    "жозеф": 1,
    "жорес": 1,
    "жюль": 1,
    "завир": 1,
    "зак": 1,
    "закери": 1,
    "зандер": 1,
    "захар": 1,
    "захарий": 1,
    "зачариа": 1,
    "зачэри": 1,
    "зед": 1,
    "зедекиа": 1,
    "зек": 1,
    "зигмунд": 1,
    "зигфрид": 1,
    "зиновий": 1,
    "зорий": 1,
    "зосим": 1,
    "зосима": 1,
    "зот": 1,
    "зубин": 1,
    "зэофилус": 1,
    "иб": 1,
    "ибрагим": 1,
    "иван": 1,
    "игнат": 1,
    "игнатий": 1,
    "игнатиус": 1,
    "игорь": 1,
    "ид": 1,
    "иероним": 1,
    "иззи": 1,
    "изидор": 1,
    "измаил": 1,
    "измайло": 1,
    "изяслав": 1,
    "ий": 1,
    "икар": 1,
    "илар": 1,
    "иларий": 1,
    "иларион": 1,
    "илий": 1,
    "илиодор": 1,
    "илларион": 1,
    "илья": 1,
    "имон": 1,
    "инглеберт": 1,
    "инграм": 1,
    "инди": 1,
    "индиана": 1,
    "индиго": 1,
    "инесент": 1,
    "иниго": 1,
    "иннокентий": 1,
    "иоанн": 1,
    "иорик": 1,
    "иосиф": 1,
    "ипат": 1,
    "ипатий": 1,
    "ипполит": 1,
    "ираклий": 1,
    "ирвайн": 1,
    "ирвин": 1,
    "ирвинг": 1,
    "ириней": 1,
    "ириний": 1,
    "ирл": 1,
    "ирм": 1,
    "ирнест": 1,
    "исай": 1,
    "исайя": 1,
    "исак": 1,
    "исакий": 1,
    "исей": 1,
    "исидор": 1,
    "иссак": 1,
    "исси": 1,
    "истер": 1,
    "июлий": 1,
    "йорк": 1,
    "ка": 1,
    "кадмус": 1,
    "казимир": 1,
    "каин": 1,
    "каир": 1,
    "кайд": 1,
    "кайл": 1,
    "кал": 1,
    "калин": 1,
    "калина": 1,
    "каллен": 1,
    "кам": 1,
    "камден": 1,
    "камиль": 1,
    "камрон": 1,
    "капитон": 1,
    "карбрей": 1,
    "карбри": 1,
    "карвер": 1,
    "карей": 1,
    "карен": 1,
    "карл": 1,
    "карлайл": 1,
    "карлейл": 1,
    "карлин": 1,
    "карлтон": 1,
    "карм": 1,
    "кармий": 1,
    "карп": 1,
    "каррол": 1,
    "картер": 1,
    "касиди": 1,
    "каспар": 1,
    "каспер": 1,
    "кассиди": 1,
    "касьян": 1,
    "квентин": 1,
    "квинтин": 1,
    "кеван": 1,
    "кевин": 1,
    "кей": 1,
    "кейденс": 1,
    "кейдн": 1,
    "кейлб": 1,
    "кеймрон": 1,
    "кейси": 1,
    "келвин": 1,
    "келкей": 1,
    "келл": 1,
    "келли": 1,
    "келсей": 1,
    "кемп": 1,
    "кен": 1,
    "кендал": 1,
    "кендол": 1,
    "кендрик": 1,
    "кенелм": 1,
    "кензи": 1,
    "кенит": 1,
    "кеннеди": 1,
    "кеннет": 1,
    "кенни": 1,
    "кеннит": 1,
    "кенрик": 1,
    "кент": 1,
    "кентиджерн": 1,
    "кентон": 1,
    "кермит": 1,
    "керней": 1,
    "керр": 1,
    "керри": 1,
    "керт": 1,
    "кертис": 1,
    "кешон": 1,
    "ки": 1,
    "киаран": 1,
    "килан": 1,
    "килер": 1,
    "килиан": 1,
    "киллиан": 1,
    "ким": 1,
    "кимбелайн": 1,
    "кимберли": 1,
    "кимбол": 1,
    "кимбэль": 1,
    "кин": 1,
    "кинан": 1,
    "кинастон": 1,
    "кинг": 1,
    "кингслей": 1,
    "кип": 1,
    "киприан": 1,
    "кир": 1,
    "киран": 1,
    "кирби": 1,
    "кирилл": 1,
    "кирк": 1,
    "кирон": 1,
    "кирус": 1,
    "кит": 1,
    "китон": 1,
    "киф": 1,
    "клавдий": 1,
    "клайв": 1,
    "клайд": 1,
    "кланкей": 1,
    "кланки": 1,
    "кларенс": 1,
    "кларк": 1,
    "клев": 1,
    "клей": 1,
    "клейтон": 1,
    "клем": 1,
    "клемент": 1,
    "клементий": 1,
    "клемми": 1,
    "клетис": 1,
    "клетус": 1,
    "кливленд": 1,
    "клим": 1,
    "климент": 1,
    "климентий": 1,
    "клинт": 1,
    "клинтон": 1,
    "клифтон": 1,
    "клифф": 1,
    "клиффорд": 1,
    "клод": 1,
    "клэйрк": 1,
    "клэр": 1,
    "кодей": 1,
    "коди": 1,
    "коертней": 1,
    "козьма": 1,
    "кола": 1,
    "коламбан": 1,
    "колберт": 1,
    "колби": 1,
    "колдер": 1,
    "колин": 1,
    "коллахан": 1,
    "коллин": 1,
    "коллум": 1,
    "колтен": 1,
    "колтон": 1,
    "колумбий": 1,
    "кольт": 1,
    "конан": 1,
    "конвей": 1,
    "кондрат": 1,
    "кондратий": 1,
    "конлей": 1,
    "коннелл": 1,
    "коннер": 1,
    "коннор": 1,
    "конон": 1,
    "конор": 1,
    "конрад": 1,
    "константин": 1,
    "конфуций": 1,
    "корбин": 1,
    "корделл": 1,
    "корей": 1,
    "кори": 1,
    "корней": 1,
    "корнелий": 1,
    "корнелиус": 1,
    "корнил": 1,
    "кортней": 1,
    "кортни": 1,
    "корэй": 1,
    "коти": 1,
    "коул": 1,
    "коулман": 1,
    "краснослав": 1,
    "крис": 1,
    "криспиан": 1,
    "криспин": 1,
    "кристи": 1,
    "кристиан": 1,
    "кристопэр": 1,
    "кристоф": 1,
    "кристофер": 1,
    "крофорд": 1,
    "крофтон": 1,
    "крэйг": 1,
    "ксавайор": 1,
    "ксавьер": 1,
    "ксан": 1,
    "ксенофонт": 1,
    "ксзавир": 1,
    "кузьма": 1,
    "куин": 1,
    "куинкей": 1,
    "куинси": 1,
    "куинтон": 1,
    "купер": 1,
    "куприян": 1,
    "курт": 1,
    "куртис": 1,
    "кэйд": 1,
    "кэйдн": 1,
    "кэйл": 1,
    "кэйлб": 1,
    "кэймрон": 1,
    "кэйн": 1,
    "кэйси": 1,
    "кэлвин": 1,
    "кэм": 1,
    "кэмп": 1,
    "кэмпбэл": 1,
    "кэри": 1,
    "кюри": 1,
    "лаверн": 1,
    "лавлл": 1,
    "лавр": 1,
    "лаврентий": 1,
    "лаз": 1,
    "лазарь": 1,
    "лайл": 1,
    "лайонел": 1,
    "лаки": 1,
    "ланни": 1,
    "ланфорд": 1,
    "ларион": 1,
    "ларк": 1,
    "ларкин": 1,
    "ларри": 1,
    "лаэрт": 1,
    "лев": 1,
    "леви": 1,
    "левкий": 1,
    "лейврн": 1,
    "лейн": 1,
    "лейтон": 1,
    "лекс": 1,
    "леланд": 1,
    "лель": 1,
    "лем": 1,
    "лемми": 1,
    "лемюэль": 1,
    "лен": 1,
    "ленар": 1,
    "ленард": 1,
    "лени": 1,
    "лениан": 1,
    "леннард": 1,
    "ленни": 1,
    "лео": 1,
    "леон": 1,
    "леонард": 1,
    "леонид": 1,
    "леонтий": 1,
    "леопольд": 1,
    "лермонт": 1,
    "лерой": 1,
    "лес": 1,
    "лесли": 1,
    "лестер": 1,
    "ли": 1,
    "либерт": 1,
    "ливадий": 1,
    "лии": 1,
    "лин": 1,
    "линдон": 1,
    "линдсей": 1,
    "линдси": 1,
    "линкольн": 1,
    "линн": 1,
    "линсей": 1,
    "линтон": 1,
    "линус": 1,
    "линфорд": 1,
    "лионель": 1,
    "лир": 1,
    "лирой": 1,
    "лисандр": 1,
    "литон": 1,
    "лихнис": 1,
    "ллойд": 1,
    "ллью": 1,
    "лльюелин": 1,
    "лльюеллин": 1,
    "ло": 1,
    "ловэль": 1,
    "лойд": 1,
    "лон": 1,
    "лондон": 1,
    "лонни": 1,
    "лонс": 1,
    "лор": 1,
    "лорен": 1,
    "лоренс": 1,
    "лори": 1,
    "лорин": 1,
    "лорис": 1,
    "лорни": 1,
    "лоррин": 1,
    "лосон": 1,
    "лоуэлл": 1,
    "лоэнгрин": 1,
    "лу": 1,
    "лудо": 1,
    "луи": 1,
    "лука": 1,
    "лукиан": 1,
    "лукьян": 1,
    "льюин": 1,
    "льюис": 1,
    "лэйк": 1,
    "лэйн": 1,
    "лэйтон": 1,
    "лэндон": 1,
    "лэнс": 1,
    "лэрри": 1,
    "любим": 1,
    "любомир": 1,
    "людвиг": 1,
    "людовик": 1,
    "люк": 1,
    "люкс": 1,
    "люксен": 1,
    "люсьен": 1,
    "лютер": 1,
    "люциан": 1,
    "маверик": 1,
    "маврикий": 1,
    "мадисон": 1,
    "маеслав": 1,
    "май": 1,
    "майк": 1,
    "майкл": 1,
    "майлз": 1,
    "майрон": 1,
    "майслав": 1,
    "макар": 1,
    "макарий": 1,
    "макей": 1,
    "макензи": 1,
    "маки": 1,
    "макинтош": 1,
    "маккензи": 1,
    "макс": 1,
    "максвелл": 1,
    "максим": 1,
    "максимилиан": 1,
    "максимиллиан": 1,
    "максимильян": 1,
    "малачи": 1,
    "малком": 1,
    "малоун": 1,
    "манлей": 1,
    "манни": 1,
    "манникс": 1,
    "мануил": 1,
    "мануйло": 1,
    "манфред": 1,
    "марат": 1,
    "марвин": 1,
    "мариан": 1,
    "марин": 1,
    "мариус": 1,
    "марк": 1,
    "марка": 1,
    "маркел": 1,
    "маркиан": 1,
    "марко": 1,
    "маркус": 1,
    "марлен": 1,
    "марлин": 1,
    "марлон": 1,
    "марлоу": 1,
    "мармадьюк": 1,
    "марри": 1,
    "марс": 1,
    "марсен": 1,
    "марти": 1,
    "мартиал": 1,
    "мартин": 1,
    "мартын": 1,
    "маршал": 1,
    "маршалл": 1,
    "марьян": 1,
    "масон": 1,
    "мастерман": 1,
    "матвей": 1,
    "матти": 1,
    "мед": 1,
    "мелвилль": 1,
    "мелвин": 1,
    "мельбурн": 1,
    "мерв": 1,
    "мервин": 1,
    "мерди": 1,
    "мердо": 1,
    "мердок": 1,
    "мередит": 1,
    "мерит": 1,
    "меркурий": 1,
    "мерл": 1,
    "мерлин": 1,
    "меррилл": 1,
    "мерритт": 1,
    "мертон": 1,
    "мерфи": 1,
    "мефодий": 1,
    "мечеслав": 1,
    "мечислав": 1,
    "мид": 1,
    "миид": 1,
    "мик": 1,
    "мика": 1,
    "мики": 1,
    "микки": 1,
    "милад": 1,
    "милан": 1,
    "милберн": 1,
    "милен": 1,
    "милий": 1,
    "миллард": 1,
    "мило": 1,
    "милонег": 1,
    "милослав": 1,
    "милтон": 1,
    "милфорд": 1,
    "мир": 1,
    "мирон": 1,
    "мирослав": 1,
    "митчелл": 1,
    "михаил": 1,
    "михайло": 1,
    "мич": 1,
    "мича": 1,
    "мичил": 1,
    "мо": 1,
    "модест": 1,
    "моз": 1,
    "моисей": 1,
    "молком": 1,
    "монолит": 1,
    "монро": 1,
    "монтагью": 1,
    "монтгомери": 1,
    "монте": 1,
    "монти": 1,
    "монтморенки": 1,
    "морган": 1,
    "морген": 1,
    "мордекэй": 1,
    "морис": 1,
    "морлей": 1,
    "моррис": 1,
    "морт": 1,
    "морти": 1,
    "мортимер": 1,
    "мортон": 1,
    "мосс": 1,
    "моэ": 1,
    "мстислав": 1,
    "мулава": 1,
    "мурат": 1,
    "мэйнард": 1,
    "мэйнерд": 1,
    "мэйор": 1,
    "мэйсон": 1,
    "мэйтланд": 1,
    "мэлори": 1,
    "мэль": 1,
    "мэриан": 1,
    "мэрион": 1,
    "мэт": 1,
    "мэтт": 1,
    "мэтти": 1,
    "мэтью": 1,
    "мюд": 1,
    "надир": 1,
    "назаниль": 1,
    "назар": 1,
    "назарий": 1,
    "назим": 1,
    "найджел": 1,
    "найлс": 1,
    "наль": 1,
    "нанди": 1,
    "нат": 1,
    "натан": 1,
    "наум": 1,
    "науэлл": 1,
    "наш": 1,
    "невада": 1,
    "неван": 1,
    "невил": 1,
    "невилл": 1,
    "нед": 1,
    "нейл": 1,
    "нейлл": 1,
    "нейт": 1,
    "нельсон": 1,
    "нео": 1,
    "неон": 1,
    "неонил": 1,
    "нестер": 1,
    "нестор": 1,
    "нивек": 1,
    "нивен": 1,
    "ник": 1,
    "никандр": 1,
    "никанор": 1,
    "никита": 1,
    "никифор": 1,
    "никк": 1,
    "никки": 1,
    "никодим": 1,
    "никола": 1,
    "николай": 1,
    "николас": 1,
    "никон": 1,
    "нил": 1,
    "нили": 1,
    "нимбус": 1,
    "нинел": 1,
    "нинель": 1,
    "нисон": 1,
    "нифонт": 1,
    "ноа": 1,
    "новомир": 1,
    "нодар": 1,
    "ной": 1,
    "нолан": 1,
    "нолл": 1,
    "норберт": 1,
    "норвуд": 1,
    "норд": 1,
    "норм": 1,
    "норман": 1,
    "норманд": 1,
    "норрис": 1,
    "нортон": 1,
    "ноубль": 1,
    "ноэль": 1,
    "ньют": 1,
    "ньютон": 1,
    "оберон": 1,
    "обин": 1,
    "обри": 1,
    "овидий": 1,
    "огастин": 1,
    "огден": 1,
    "огэст": 1,
    "оделл": 1,
    "одиссей": 1,
    "одлей": 1,
    "одран": 1,
    "оз": 1,
    "оззи": 1,
    "океан": 1,
    "оксар": 1,
    "октавиан": 1,
    "октябрин": 1,
    "октябрь": 1,
    "олби": 1,
    "олбэйн": 1,
    "олдвен": 1,
    "олдвин": 1,
    "олден": 1,
    "олдин": 1,
    "олдис": 1,
    "олдон": 1,
    "олдос": 1,
    "олдред": 1,
    "олдус": 1,
    "олдфорд": 1,
    "олег": 1,
    "олей": 1,
    "оли": 1,
    "оливер": 1,
    "олимпий": 1,
    "олластер": 1,
    "олластир": 1,
    "оллгар": 1,
    "оллджер": 1,
    "олли": 1,
    "оллин": 1,
    "оллисдэйр": 1,
    "оллистер": 1,
    "оллистэйр": 1,
    "оллон": 1,
    "оллэйстар": 1,
    "ольгерд": 1,
    "омар": 1,
    "омега": 1,
    "онисим": 1,
    "ора": 1,
    "оран": 1,
    "орвал": 1,
    "орвилл": 1,
    "орест": 1,
    "ориан": 1,
    "ормерод": 1,
    "оррелл": 1,
    "оррин": 1,
    "орсон": 1,
    "осберт": 1,
    "осбоерн": 1,
    "осборн": 1,
    "освальд": 1,
    "осень": 1,
    "осип": 1,
    "оскар": 1,
    "остап": 1,
    "остен": 1,
    "остин": 1,
    "остромир": 1,
    "отис": 1,
    "оттис": 1,
    "отто": 1,
    "оттон": 1,
    "оуин": 1,
    "оуэн": 1,
    "ошин": 1,
    "павел": 1,
    "пайс": 1,
    "палладий": 1,
    "палмер": 1,
    "панкрас": 1,
    "пантелей": 1,
    "пантелеймон": 1,
    "панфил": 1,
    "парамон": 1,
    "паркер": 1,
    "паррис": 1,
    "партизан": 1,
    "пат": 1,
    "патрик": 1,
    "патси": 1,
    "пахом": 1,
    "пеитон": 1,
    "пепин": 1,
    "пересвет": 1,
    "перри": 1,
    "перс": 1,
    "перси": 1,
    "персиваль": 1,
    "петеркин": 1,
    "пимен": 1,
    "пип": 1,
    "пипер": 1,
    "пирр": 1,
    "пирс": 1,
    "пит": 1,
    "питер": 1,
    "платон": 1,
    "пол": 1,
    "поли": 1,
    "поликарп": 1,
    "помпей": 1,
    "портер": 1,
    "порфирий": 1,
    "потап": 1,
    "престон": 1,
    "приам": 1,
    "принц": 1,
    "пров": 1,
    "прозор": 1,
    "прокопий": 1,
    "прокофий": 1,
    "проспер": 1,
    "протас": 1,
    "прохор": 1,
    "пэйс": 1,
    "пэйси": 1,
    "пэйтон": 1,
    "пётр": 1,
    "петр": 1,
    "равель": 1,
    "равен": 1,
    "равиль": 1,
    "радамес": 1,
    "радий": 1,
    "радим": 1,
    "радислав": 1,
    "радомир": 1,
    "раз": 1,
    "раймонд": 1,
    "раймунд": 1,
    "райордан": 1,
    "райт": 1,
    "ралф": 1,
    "ралфи": 1,
    "ральф": 1,
    "ранделл": 1,
    "ранди": 1,
    "рандолф": 1,
    "рандольф": 1,
    "расс": 1,
    "рассел": 1,
    "рассэль": 1,
    "расти": 1,
    "растус": 1,
    "ратмир": 1,
    "рауль": 1,
    "рафаил": 1,
    "рафаэль": 1,
    "рашид": 1,
    "раян": 1,
    "реарден": 1,
    "ревмир": 1,
    "реган": 1,
    "редд": 1,
    "редж": 1,
    "реджи": 1,
    "реджинальд": 1,
    "редклиф": 1,
    "редклифф": 1,
    "редлей": 1,
    "редманд": 1,
    "редмонд": 1,
    "реид": 1,
    "рей": 1,
    "рейли": 1,
    "рейнард": 1,
    "рейнольд": 1,
    "рекс": 1,
    "рем": 1,
    "ренальд": 1,
    "ренат": 1,
    "риган": 1,
    "ригби": 1,
    "рид": 1,
    "ридлей": 1,
    "риель": 1,
    "рик": 1,
    "рикей": 1,
    "рики": 1,
    "рилан": 1,
    "рилей": 1,
    "рили": 1,
    "ринат": 1,
    "рио": 1,
    "риплей": 1,
    "рис": 1,
    "рихард": 1,
    "рич": 1,
    "ричард": 1,
    "ричи": 1,
    "роальд": 1,
    "роб": 1,
    "робби": 1,
    "роберт": 1,
    "робеспьер": 1,
    "роби": 1,
    "робин": 1,
    "робинзон": 1,
    "рован": 1,
    "род": 1,
    "роддж": 1,
    "родджер": 1,
    "родди": 1,
    "родерик": 1,
    "роджер": 1,
    "родион": 1,
    "родни": 1,
    "родолф": 1,
    "рождеро": 1,
    "рой": 1,
    "ройл": 1,
    "ройс": 1,
    "ройстон": 1,
    "роки": 1,
    "ролан": 1,
    "роланд": 1,
    "роли": 1,
    "ролланд": 1,
    "ролли": 1,
    "роман": 1,
    "ромен": 1,
    "ромуальд": 1,
    "рон": 1,
    "рональд": 1,
    "ронни": 1,
    "рори": 1,
    "роско": 1,
    "росс": 1,
    "ростислав": 1,
    "роуланд": 1,
    "роулей": 1,
    "роял": 1,
    "рубен": 1,
    "рубин": 1,
    "руди": 1,
    "рудольф": 1,
    "рудьярд": 1,
    "рунар": 1,
    "руслан": 1,
    "руссо": 1,
    "рустам": 1,
    "рустем": 1,
    "рхетт": 1,
    "рьюб": 1,
    "рэд": 1,
    "рэй": 1,
    "рэйнард": 1,
    "рэйнер": 1,
    "рэйф": 1,
    "рэм": 1,
    "рэндал": 1,
    "рэндалл": 1,
    "рюрик": 1,
    "сава": 1,
    "савва": 1,
    "савелий": 1,
    "савьер": 1,
    "сайг": 1,
    "саймон": 1,
    "салал": 1,
    "салливан": 1,
    "самми": 1,
    "самойло": 1,
    "самсон": 1,
    "самуил": 1,
    "сандфорд": 1,
    "санни": 1,
    "санфорд": 1,
    "свет": 1,
    "светлан": 1,
    "светозар": 1,
    "светослав": 1,
    "свизин": 1,
    "свизун": 1,
    "свиней": 1,
    "святогор": 1,
    "святополк": 1,
    "святослав": 1,
    "себастьян": 1,
    "севард": 1,
    "севастиан": 1,
    "севастьян": 1,
    "север": 1,
    "севериан": 1,
    "северин": 1,
    "северьян": 1,
    "северян": 1,
    "седрик": 1,
    "сеймур": 1,
    "селби": 1,
    "семён": 1,
    "септембер": 1,
    "серапион": 1,
    "серафим": 1,
    "сергей": 1,
    "сесил": 1,
    "сет": 1,
    "сефтон": 1,
    "сивард": 1,
    "сигизмунд": 1,
    "сигманд": 1,
    "сид": 1,
    "сидней": 1,
    "сидор": 1,
    "сила": 1,
    "силас": 1,
    "силвестр": 1,
    "сильвер": 1,
    "сильвест": 1,
    "сильвестр": 1,
    "симеон": 1,
    "симон": 1,
    "синклэйр": 1,
    "сирил": 1,
    "сисар": 1,
    "скай": 1,
    "скилар": 1,
    "скилер": 1,
    "скот": 1,
    "скотти": 1,
    "скуилер": 1,
    "слава": 1,
    "слай": 1,
    "слэйд": 1,
    "совет": 1,
    "сократ": 1,
    "соломон": 1,
    "сони": 1,
    "сонни": 1,
    "софокл": 1,
    "софон": 1,
    "спайк": 1,
    "спарроу": 1,
    "спартак": 1,
    "спенсер": 1,
    "спиридон": 1,
    "спиро": 1,
    "стакей": 1,
    "сталий": 1,
    "сталь": 1,
    "станислав": 1,
    "стаффорд": 1,
    "степан": 1,
    "стерлинг": 1,
    "стеф": 1,
    "стефан": 1,
    "сти": 1,
    "стив": 1,
    "стивен": 1,
    "стиви": 1,
    "стиу": 1,
    "сторм": 1,
    "стратон": 1,
    "сту": 1,
    "стэки": 1,
    "стэн": 1,
    "стэнли": 1,
    "стэнфорд": 1,
    "стюарт": 1,
    "сурен": 1,
    "сэм": 1,
    "сэмюэль": 1,
    "сэнди": 1,
    "тад": 1,
    "таддеус": 1,
    "таир": 1,
    "тай": 1,
    "такер": 1,
    "тал": 1,
    "талбот": 1,
    "таннер": 1,
    "тарас": 1,
    "таскилл": 1,
    "таффи": 1,
    "тед": 1,
    "тейгу": 1,
    "тейдж": 1,
    "теймураз": 1,
    "тейрк": 1,
    "текс": 1,
    "тельнан": 1,
    "тенгиз": 1,
    "тенней": 1,
    "теннизон": 1,
    "тео": 1,
    "теобальд": 1,
    "теодор": 1,
    "теранс": 1,
    "теренс": 1,
    "терентий": 1,
    "терло": 1,
    "терранс": 1,
    "террелл": 1,
    "терренс": 1,
    "терстон": 1,
    "ти": 1,
    "тиарнак": 1,
    "тиарнан": 1,
    "тибалт": 1,
    "тибби": 1,
    "тигран": 1,
    "тигу": 1,
    "тизон": 1,
    "тилар": 1,
    "тилер": 1,
    "тилор": 1,
    "тим": 1,
    "тимми": 1,
    "тимоти": 1,
    "тимофей": 1,
    "тимур": 1,
    "тирелл": 1,
    "тирнан": 1,
    "тирней": 1,
    "тирон": 1,
    "тироун": 1,
    "тиррелл": 1,
    "тит": 1,
    "тихомир": 1,
    "тихон": 1,
    "тоал": 1,
    "тоби": 1,
    "тобиас": 1,
    "тобин": 1,
    "товий": 1,
    "тод": 1,
    "тодд": 1,
    "толли": 1,
    "том": 1,
    "томас": 1,
    "томми": 1,
    "тон": 1,
    "тони": 1,
    "топэр": 1,
    "торез": 1,
    "торий": 1,
    "торлей": 1,
    "торнтон": 1,
    "травис": 1,
    "тракей": 1,
    "трантер": 1,
    "траффорд": 1,
    "траэрн": 1,
    "трев": 1,
    "тревельян": 1,
    "тревор": 1,
    "трейврс": 1,
    "трейс": 1,
    "трейси": 1,
    "трент": 1,
    "трентон": 1,
    "тристан": 1,
    "тристрам": 1,
    "трифон": 1,
    "трой": 1,
    "трофим": 1,
    "труман": 1,
    "туллий": 1,
    "тусон": 1,
    "тэдди": 1,
    "тэди": 1,
    "тэйлер": 1,
    "тэйлор": 1,
    "тэйн": 1,
    "тэйт": 1,
    "тэл": 1,
    "тэмпл": 1,
    "тэрри": 1,
    "уилбер": 1,
    "уиллард": 1,
    "уиллис": 1,
    "уилфред": 1,
    "уилфрид": 1,
    "уильям": 1,
    "уинстон": 1,
    "уинфред": 1,
    "уисдом": 1,
    "улайксс": 1,
    "улиссес": 1,
    "ульяна": 1,
    "уолли": 1,
    "уоллис": 1,
    "уолт": 1,
    "уолтер": 1,
    "уолтон": 1,
    "уорик": 1,
    "уорнер": 1,
    "уоррен": 1,
    "уот": 1,
    "уоткин": 1,
    "уптон": 1,
    "урбан": 1,
    "уриах": 1,
    "устин": 1,
    "уэйн": 1,
    "уэсли": 1,
    "фабиан": 1,
    "фаддей": 1,
    "фадей": 1,
    "фалк": 1,
    "фарид": 1,
    "фарлей": 1,
    "фарон": 1,
    "фарран": 1,
    "февралин": 1,
    "федор": 1,
    "федосий": 1,
    "фелан": 1,
    "фелиз": 1,
    "феликс": 1,
    "фелим": 1,
    "фелис": 1,
    "фентон": 1,
    "феодосий": 1,
    "феофан": 1,
    "ферги": 1,
    "фергус": 1,
    "ферд": 1,
    "ферди": 1,
    "фердинанд": 1,
    "фернан": 1,
    "фернанд": 1,
    "фестер": 1,
    "фестус": 1,
    "фидель": 1,
    "фидо": 1,
    "фил": 1,
    "филайп": 1,
    "филандр": 1,
    "филарет": 1,
    "филат": 1,
    "филберт": 1,
    "филимон": 1,
    "филип": 1,
    "филипп": 1,
    "фило": 1,
    "финикс": 1,
    "финис": 1,
    "флегонт": 1,
    "флемминг": 1,
    "флечер": 1,
    "флинн": 1,
    "флинт": 1,
    "флойд": 1,
    "флорентий": 1,
    "флоренц": 1,
    "флорин": 1,
    "флорри": 1,
    "флурри": 1,
    "фок": 1,
    "фокс": 1,
    "фома": 1,
    "фонз": 1,
    "фонзи": 1,
    "форбес": 1,
    "форд": 1,
    "форест": 1,
    "форрест": 1,
    "фостер": 1,
    "фот": 1,
    "фотий": 1,
    "фоук": 1,
    "фразир": 1,
    "франклин": 1,
    "франц": 1,
    "фред": 1,
    "фредди": 1,
    "фредерик": 1,
    "фредрик": 1,
    "фрейзер": 1,
    "фрейзр": 1,
    "фридрих": 1,
    "фримэн": 1,
    "фритс": 1,
    "фродо": 1,
    "фрол": 1,
    "фрэнк": 1,
    "фрэнки": 1,
    "фрэнклин": 1,
    "фрэнс": 1,
    "фрэнсис": 1,
    "фёдор": 1,
    "хавелок": 1,
    "хадвин": 1,
    "хадлей": 1,
    "хал": 1,
    "хам": 1,
    "хамиш": 1,
    "хамлет": 1,
    "хаммонд": 1,
    "ханк": 1,
    "ханлей": 1,
    "хантер": 1,
    "харв": 1,
    "харви": 1,
    "харди": 1,
    "хардинг": 1,
    "харитон": 1,
    "харкоерт": 1,
    "харлан": 1,
    "харланд": 1,
    "харлей": 1,
    "харлин": 1,
    "хармон": 1,
    "харпер": 1,
    "харрис": 1,
    "харрисон": 1,
    "хартлей": 1,
    "хауелл": 1,
    "хедлей": 1,
    "хек": 1,
    "хендерсон": 1,
    "хендрик": 1,
    "хенрай": 1,
    "хенри": 1,
    "херб": 1,
    "херби": 1,
    "хервей": 1,
    "херлей": 1,
    "хиацинт": 1,
    "хилари": 1,
    "хиллэри": 1,
    "хирам": 1,
    "хис": 1,
    "хитклифф": 1,
    "хию": 1,
    "хоард": 1,
    "хоб": 1,
    "ходдж": 1,
    "хойт": 1,
    "холден": 1,
    "холл": 1,
    "холлис": 1,
    "хомер": 1,
    "хопкин": 1,
    "хорас": 1,
    "хоратайо": 1,
    "хоуи": 1,
    "храбр": 1,
    "христоф": 1,
    "христофор": 1,
    "худд": 1,
    "хуей": 1,
    "хует": 1,
    "хукк": 1,
    "хукслей": 1,
    "хумберт": 1,
    "хунтлей": 1,
    "хуффи": 1,
    "хью": 1,
    "хьюберт": 1,
    "хьюго": 1,
    "хьюи": 1,
    "хэвен": 1,
    "хэдлей": 1,
    "хэйвуд": 1,
    "хэйден": 1,
    "хэйл": 1,
    "хэмфри": 1,
    "хэппи": 1,
    "хюи": 1,
    "цезарь": 1,
    "чад": 1,
    "чадвик": 1,
    "чаз": 1,
    "чак": 1,
    "чакки": 1,
    "чарлз": 1,
    "чарли": 1,
    "чарлтон": 1,
    "чарльз": 1,
    "час": 1,
    "чейз": 1,
    "чендлер": 1,
    "ченс": 1,
    "черокез": 1,
    "чеслав": 1,
    "честер": 1,
    "чеьянн": 1,
    "чип": 1,
    "чонки": 1,
    "чонси": 1,
    "ша": 1,
    "шад": 1,
    "шаи": 1,
    "шайенн": 1,
    "шакуилл": 1,
    "шамиль": 1,
    "шамус": 1,
    "шан": 1,
    "шаннен": 1,
    "шаннон": 1,
    "шау": 1,
    "шеврон": 1,
    "шелби": 1,
    "шелдон": 1,
    "шеллей": 1,
    "шелтон": 1,
    "шем": 1,
    "шервуд": 1,
    "шеридан": 1,
    "шерлок": 1,
    "шерман": 1,
    "ши": 1,
    "шилох": 1,
    "шимус": 1,
    "шмидт": 1,
    "шолто": 1,
    "шон": 1,
    "шэй": 1,
    "шэйн": 1,
    "эбби": 1,
    "эбен": 1,
    "эбенезер": 1,
    "эвальд": 1,
    "эван": 1,
    "эвелин": 1,
    "эверард": 1,
    "эверетт": 1,
    "эверитт": 1,
    "эвот": 1,
    "эгберт": 1,
    "эд": 1,
    "эдан": 1,
    "эдвард": 1,
    "эдвин": 1,
    "эдгар": 1,
    "эдди": 1,
    "эдип": 1,
    "эдисон": 1,
    "эдмонд": 1,
    "эдмунд": 1,
    "эдон": 1,
    "эдуард": 1,
    "эдун": 1,
    "эзраа": 1,
    "эзэлстан": 1,
    "эзэлуолф": 1,
    "эйб": 1,
    "эйби": 1,
    "эйвери": 1,
    "эйден": 1,
    "эйлберт": 1,
    "эйлвард": 1,
    "эймерей": 1,
    "эймери": 1,
    "эйнар": 1,
    "эйнслей": 1,
    "эйнсли": 1,
    "эйс": 1,
    "элайотт": 1,
    "элбан": 1,
    "элвин": 1,
    "элвис": 1,
    "элвуд": 1,
    "элгар": 1,
    "элдвен": 1,
    "элдвин": 1,
    "элден": 1,
    "элджер": 1,
    "элдин": 1,
    "элдис": 1,
    "элдон": 1,
    "элдред": 1,
    "элдус": 1,
    "электрон": 1,
    "эли": 1,
    "элиас": 1,
    "элиджа": 1,
    "элиот": 1,
    "элла": 1,
    "эллгар": 1,
    "эллджер": 1,
    "эллери": 1,
    "эллиот": 1,
    "эллис": 1,
    "элмер": 1,
    "элрик": 1,
    "элрой": 1,
    "элсдон": 1,
    "эль": 1,
    "эльберт": 1,
    "эльбрус": 1,
    "эльдар": 1,
    "эльмар": 1,
    "эльмир": 1,
    "эльтон": 1,
    "эмерсон": 1,
    "эмилиан": 1,
    "эмилий": 1,
    "эмиль": 1,
    "эммануель": 1,
    "эммануил": 1,
    "эммерсон": 1,
    "эммет": 1,
    "эмметт": 1,
    "эмори": 1,
    "эмэри": 1,
    "энвер": 1,
    "энгель": 1,
    "энджелберт": 1,
    "энди": 1,
    "эндрю": 1,
    "энергий": 1,
    "энтони": 1,
    "эразм": 1,
    "эраст": 1,
    "эрван": 1,
    "эрвин": 1,
    "эрг": 1,
    "эрек": 1,
    "эрий": 1,
    "эрик": 1,
    "эрих": 1,
    "эрл": 1,
    "эрлен": 1,
    "эрн": 1,
    "эрнест": 1,
    "эрни": 1,
    "эрнст": 1,
    "эрон": 1,
    "эррол": 1,
    "эрролл": 1,
    "этан": 1,
    "этелберт": 1,
    "этелред": 1,
    "этелрик": 1,
    "этелхард": 1,
    "эшли": 1,
    "эюзби": 1,
    "ювеналий": 1,
    "юджин": 1,
    "юлиан": 1,
    "юлий": 1,
    "юлиус": 1,
    "юм": 1,
    "юниор": 1,
    "юпитер": 1,
    "юрий": 1,
    "юстас": 1,
    "юстин": 1,
    "яков": 1,
    "ян": 1,
    "янкей": 1,
    "янки": 1,
    "януарий": 1,
    "ярвуд": 1,
    "яромир": 1,
    "ярополк": 1,
    "ярослав": 1
  }, exports.ruBindingWords = [ "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "пота", "потому", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "тож", "только", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы", "а-ля", "без", "безо", "благодаря", "близ", "в", "ввиду", "вглубь", "вдоль", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "во", "возле", "вокруг", "вопреки", "впереди", "вразрез", "вроде", "вслед", "вследствие", "для", "до", "за", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "к", "ко", "кроме", "кругом", "меж", "между", "мимо", "на", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду", "насупротив", "насчёт", "не", "ниже", "о", "об", "обо", "обок", "около", "окромя", "округ", "от", "относительно", "ото", "перед", "передо", "по", "по-за", "по-над", "поверх", "под", "подле", "подо", "подобно", "позади", "помимо", "поперёк", "порядка", "посередине", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "применительно", "про", "против", "путём", "ради", "с", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "со", "согласно", "спустя", "среди", "средь", "сродни", "судя", "супротив", "у", "через", "чрез", "иже", "какой-либо", "какой-то", "кое-кто", "кой", "кто", "кто-либо", "многий", "мя", "насколько", "немногий", "нещечко", "никой", "ничегошеньки", "се", "сё", "такой-то", "тот-то", "чё", "чево", "чей-либо", "чей-нибудь", "чей-то", "шо", "эта", "кем", "ком", "кому", "нахуя", "чей", "чему", "вам", "вами", "вас", "вы", "Вы", "ее", "её", "его", "ей", "ему", "ею", "им", "ими", "их", "меня", "мне", "мной", "мною", "мы", "нём", "нем", "нам", "нами", "неё", "него", "ней", "нему", "нею", "ним", "ними", "них", "он", "она", "оне", "они", "оно", "тебе", "тебя", "тобой", "тобою", "ты", "я", "иной", "кое-какой", "кое-чей", "кое-что", "кой-какой", "кой-кто", "кто-нибудь", "кто-то", "куда-нибудь", "некто", "нечто", "что-либо", "что-нибудь", "что-то", "весь", "всякий", "любой", "сам", "самый", "таков", "этакий", "другой", "некем", "некому", "нечего", "нечем", "нечему", "никакой", "никто", "ничего", "ничей", "ничем", "ничему", "ничто", "ваш", "ихний", "моё", "мой", "моя", "наш", "свой", "твой", "оный", "сей", "сие", "сии", "сия", "та", "такой", "тот", "ту", "эдакий", "эти", "это", "этот", "ась", "аюшки", "таки", "а", "авось-либо", "ага", "аминь", "б", "бишь", "буквально", "бы", "было", "вишь", "вон", "вот", "вот-вот", "вряд", "всего", "давай", "де", "действительно", "дескать", "добро", "довольно", "ещё", "исключительно", "ить", "ишь", "ка", "кажется", "конечно", "ладно", "лих", "лучше", "мол", "навряд", "наоборот", "небось", "нет", "неужели", "нехай", "никак", "ну", "ну-с", "по-видимому", "пожалуй", "пожалуйста", "полно", "положительно", "предовольно", "простите", "просто-напросто", "пускай", "разумеется", "сём-ка", "сем", "скорее", "спасибо", "так", "то-то", "тоже", "уж", "уже", "ужели", "ужли", "фон", "хорошо", "эдак", "эк", "этак" ];
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.words = {}, exports = window.lastName.plugins.ru.words) : exports = module.exports, function(exports) {
  return exports.adverbs = [ "абсолютно", "адски", "азартно", "активно", "аспидно", "баснословно", "бдительно", "безапелляционно", "безбожно", "безвозвратно", "безгранично", "безжалостно", "беззаветно", "беззастенчиво", "безмерно", "безмятежно", "безнадежно", "безоговорочно", "безраздельно", "безропотно", "безудержно", "безукоризненно", "безумно", "безупречно", "безусловно", "безустанно", "безутешно", "бескомпромиссно", "бесконечно", "беспардонно", "бесповоротно", "беспощадно", "беспредельно", "беспрекословно", "бесследно", "бессовестно", "бесстыдно", "бесчеловечно", "бешено", "бурно", "вдребезги", "вконец", "вовсю", "всемерно", "всесторонне", "всецело", "всячески", "высоко", "глубоко", "горько", "горячо", "грубо", "густо", "диаметрально", "дико", "досконально", "досыта", "дотошно", "дьявольски", "жарко", "жгуче", "железно", "жестко", "жестоко", "живо", "жизненно", "жутко", "запоем", "запредельно", "зверски", "здорово", "злостно", "идеально", "излишне", "изрядно", "изумительно", "исключительно", "исступленно", "истово", "истошно", "исчерпывающе", "кардинально", "катастрофически", "категорически", "клятвенно", "колоссально", "крайне", "крепко", "кристально", "кровно", "крупно", "круто", "люто", "максимально", "мертвецки", "мучительно", "навзрыд", "нагло", "наглухо", "наглядно", "наголову", "надежно", "надрывно", "назубок", "намертво", "наотрез", "напрочь", "нарочито", "насквозь", "настоятельно", "насущно", "начисто", "небывало", "невероятно", "невиданно", "невообразимо", "невыносимо", "невыразимо", "недопустимо", "неизмеримо", "неимоверно", "неистово", "немилосердно", "немыслимо", "необыкновенно", "необычайно", "неописуемо", "неопровержимо", "непомерно", "непоправимо", "непостижимо", "непримиримо", "непробудно", "непроходимо", "неразрывно", "несказанно", "неслыханно", "несметно", "несравненно", "нестерпимо", "неудержимо", "неузнаваемо", "неуклонно", "неукоснительно", "неустанно", "неусыпно", "неутешно", "неутомимо", "нещадно", "оглушительно", "ожесточенно", "ослепительно", "основательно", "остро", "откровенно", "открыто", "отлично", "отменно", "отчаянно", "очень", "панически", "патологически", "пламенно", "плотно", "по-настоящему", "по-собачьи", "подлинно", "подчеркнуто", "позарез", "поистине", "полностью", "поразительно", "порядком", "порядочно", "потрясающе", "предельно", "прекрасно", "преступно", "прилично", "примитивно", "принципиально", "приторно", "пронзительно", "радикально", "разительно", "редкостно", "резко", "рекордно", "свято", "серьезно", "сильно", "слепо", "смертельно", "совершенно", "совсем", "страстно", "страшно", "строго", "строго-настрого", "существенно", "твердо", "тяжело", "тяжко", "убийственно", "удивительно", "ужасающе", "ужасно", "фанатически", "фанатично", "фантастически", "феноменально", "хорошенько", "хорошо", "чертовски", "чрезвычайно", "чрезмерно", "чудовищно", "широко", "шумно", "щедро", "ярко", "яростно" ], exports.unions = [ "а", "а именно", "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "все-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как бы", "как то", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "после того как", "пота", "потому", "потому как", "потому что", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "то есть", "тож", "только", "только что", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы" ], exports.prepositionAll = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо", "включая", "невзирая на", "несмотря на", "по", "по-за", "про", "с", "сквозь", "со", "спустя", "через", "чрез", "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по", "при", "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "среди", "средь", "супротив", "у", "в связи с", "в соответствии с", "вслед за", "лицом к лицу с", "над", "надо", "наряду с", "перед", "передо", "по сравнению с", "по-над", "пред", "предо", "рядом с", "следом за" ], exports.prepositionSimple = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionAcusative = [ "в", "включая", "во", "за", "на", "не в", "не за", "невзирая на", "несмотря на", "о", "об", "обо", "по", "по-за", "под", "подо", "про", "с", "сквозь", "со", "спустя", "через", "чрез" ], exports.prepositionDative = [ "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по" ], exports.prepositionPrepositional = [ "в", "во", "на", "не в", "о", "об", "обо", "по", "при" ], exports.prepositionGenetive = [ "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "меж", "между", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "со", "среди", "средь", "супротив", "у" ], exports.prepositionInstrumental = [ "в связи с", "в соответствии с", "вслед за", "за", "лицом к лицу с", "меж", "между", "над", "надо", "наряду с", "не за", "перед", "передо", "по сравнению с", "по-над", "под", "подо", "пред", "предо", "рядом с", "с", "следом за", "со" ], exports.prepositionWithSingleCase = [ "без", "без ведома", "безо", "благодаря", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в связи с", "в силу", "в соответствии с", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "вдоль по", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "вопреки", "впереди", "впредь до", "вроде", "вслед", "вслед за", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "к", "ко", "кроме", "кругом", "лицом к", "лицом к лицу с", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду с", "насупротив", "насчёт", "начиная с", "не без", "не считая", "невзирая на", "недалеко от", "независимо от", "несмотря на", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "перед", "передо", "по линии", "по мере", "по направлению к", "по отношению к", "по поводу", "по причине", "по случаю", "по сравнению с", "по-за", "по-над", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "подобно", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "при помощи", "применительно к", "про", "против", "путём", "ради", "рядом с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "согласно", "спустя", "среди", "средь", "сродни", "судя по", "супротив", "у", "через", "чрез" ], exports.prepositionWith2Cases = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionWith3Cases = [ "по", "с", "со" ];
}(exports);

var exports, ref, util, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.dates = {}, exports = window.lastName.plugins.ru.dates, ref = window.lastName.plugins.ru.ref, util = window.lastName.util) : (exports = module.exports, ref = require("./ref"), util = require("../../util")), function(exports, util, ref) {
  var dateObjectToString, extractDates, getRuMonthIndex, getValidDate, packDates, packIntervals, ruMonthInDates;
  return ruMonthInDates = [ "января", "февраля", "марта", "аперля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря" ], dateObjectToString = function(dateObj) {
    var d, m, y, _ref;
    return y = ((_ref = typeof dateObj.y) === "number" || _ref === "string") && dateObj.y || "", m = dateObj.m + 1, m = m > 9 && m || "0" + m, d = dateObj.d > 9 && dateObj.d || "0" + dateObj.d, "" + d + "." + m + "." + y;
  }, getValidDate = function(dateObj) {
    var defaultYear, dt;
    defaultYear = dateObj.y;
    if (void 0 === dateObj.y || dateObj.y < 1970 || dateObj.y > 2038) dateObj.y = 2e3;
    return dt = new Date(Date.UTC(dateObj.y, dateObj.m, dateObj.d)), dt.getMonth() === dateObj.m && dt.getDate() === dateObj.d ? (dateObj.y = defaultYear, dateObj) : null;
  }, getRuMonthIndex = function(str) {
    var m;
    return m = str.toLowerCase().match(/(\s|^)(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s|$)/g), m ? ruMonthInDates.indexOf(m[0].replace(/\s/g, "")) : -1;
  }, exports.extractDates = extractDates = function(strArr) {
    var dates, intervals, sources;
    return dates = {}, sources = [], intervals = {}, strArr instanceof Array || (strArr = [ strArr ]), strArr.map(function(str) {
      var dStr, date, found, from, fromDate, fromMonth, fromYear, id, intObject, mIndex, sourceStr, to, toDate, toYear, verboseMatch, wordsArr, _ref, _results;
      verboseMatch = str.match(/\s+\d{1,2}\s+((января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)\s+|)(\d{2,4}(\s+года|)\s+|)по\s+\d{1,2}\s+(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s+\d{2,4}|)(\s+|$)/mig);
      if (!verboseMatch) {
        wordsArr = str.split(" "), found = !1, _results = [];
        while (wordsArr.length > 2 && !found) /^\d[\d]$/.test(wordsArr[0]) && (mIndex = ruMonthInDates.indexOf(wordsArr[1].toLowerCase()), mIndex >= 0 ? (date = {
          d: parseInt(wordsArr[0], 10),
          m: mIndex
        }, /^\d{2,4}$/.test(wordsArr[2]) ? (date.y = parseInt(wordsArr[2], 10), sourceStr = wordsArr.slice(0, 3).join(" ")) : sourceStr = wordsArr.slice(0, 2).join(" ")) : /^\d\d\.\d\d.\d{2,4}$/.test(wordsArr[0] || /^\d\d\.\d\d$/.test(wordsArr[0])) ? (date = {
          d: parseInt(wordsArr[0].slice(0, 3), 10),
          m: parseInt(wordsArr[0].slice(3, 6), 10),
          y: parseInt(wordsArr[0].slice(6), 10) || void 0
        }, sourceStr = wordsArr[0]) : date = {}, date = getValidDate(date), date && (found = !0, sources.push(sourceStr), dStr = dateObjectToString(date), dates[dStr] ? dates[dStr].count++ : dates[dStr] = {
          count: 1,
          value: date
        })), _results.push(wordsArr.shift());
        return _results;
      }
      _ref = verboseMatch[0].toLowerCase().split("по"), from = _ref[0], to = _ref[1], toYear = to.replace(/\d{1,2}/, "").match(/\d+/g), toYear ? toYear = parseInt(toYear[0], 10) : toYear = void 0, toDate = {
        d: parseInt(to.match(/\d{1,2}/g)[0], 10),
        m: getRuMonthIndex(to),
        y: toYear
      }, fromYear = from.replace(/\d{1,2}/, "").match(/\d+/g), fromMonth = getRuMonthIndex(from), fromYear ? fromYear = parseInt(fromYear[0], 10) : fromYear = toYear, fromMonth === -1 && (fromMonth = toDate.m), fromDate = {
        d: parseInt(from.match(/\d{1,2}/g)[0], 10),
        m: fromMonth,
        y: fromYear
      }, toDate = getValidDate(toDate), fromDate = getValidDate(fromDate);
      if (toDate && fromDate) return intObject = {
        from: dateObjectToString(fromDate),
        from_value: fromDate,
        to: dateObjectToString(toDate),
        to_value: toDate
      }, id = "" + intObject.from + "-" + intObject.to, intervals[id] ? intervals[id].count++ : (intObject.count = 1, intervals[id] = intObject), sources.push(verboseMatch[0]);
    }), {
      dates: dates,
      sources: sources,
      intervals: intervals
    };
  }, exports.packDates = packDates = function(dates, defaultYear) {
    var dateObj, id, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in dates) dateObj = dates[id], "undefined" != typeof dateObj.value.y && years.push(dateObj.value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in dates) dateObj = dates[id], "undefined" == typeof dateObj.value.y && (dateObj.value.y = defaultYear), out["" + dateObjectToString(dateObj.value)] = dateObj.count;
    return out;
  }, exports.packIntervals = packIntervals = function(intervals, defaultYear) {
    var id, interval, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in intervals) interval = intervals[id], "undefined" != typeof interval.from_value.y && years.push(interval.from_value.y), "undefined" != typeof interval.to_value.y && years.push(interval.to_value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in intervals) interval = intervals[id], "undefined" == typeof interval.from_value.y && (interval.from_value.y = defaultYear), "undefined" == typeof interval.to_value.y && (interval.to_value.y = defaultYear), out["" + dateObjectToString(interval.from_value) + "-" + dateObjectToString(interval.to_value)] = interval.count;
    return out;
  }, exports.preFilter = function(text, result) {
    var dates, numRe;
    numRe = /((([а-яё]+)\s+){0,1}\d[\.\d]{0,}(\s+(([a-яё]+)|([\.\d]+))){1,6})|([12]\d\d\d)/mig, dates = extractDates(util.unique(text.match(numRe) || [])), util.dictKeys(dates.dates).length > 0 && (result.dates = packDates(dates.dates)), util.dictKeys(dates.intervals).length > 0 && (result.intervals = packIntervals(dates.intervals));
    if (dates.sources.length > 0) return result.date_sources = dates.sources;
  };
}(exports, util, ref);

var exports, ref, util, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.inclines = {}, exports = window.lastName.plugins.ru.inclines, util = window.lastName.util, ref = window.lastName.plugins.ru.ref) : (exports = module.exports, util = require("../../util"), ref = require("./ref")), function(exports, util, ref) {
  var cases, doInclineFemaleName, doInclineMaleName, findProperName, genderMatch, getNominative, inclineAndGetResult, inclineFemMiddleName, inclineFemaleName, inclineFemaleNameAndGetResult, inclineFemaleSurname, inclineMaleMiddleName, inclineMaleName, inclineMaleNameAndGetResult, inclineMaleSurname, inclineMiddleName, inclineMiddleNameOrSurname, inclineName, inclinePersonSurname, inclineSurname, matchCase, matchNameAndSurname, matchNameParts;
  return cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ], exports.doInclineFemaleName = doInclineFemaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, aUnstressedRe, name2;
    return aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, aUnstressedRe = /ца$/g, name2 = name.slice(0, -1), aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aUnstressedRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ей", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /ия$/g.test(name) && name.length > 3 ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "и" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ь", "" + name2 + "ью", "" + name2 + "и" ] : /[жшщцч]$/g.test(name) ? [ "" + name, "" + name + "и", "" + name + "и", "" + name, "" + name + "ью", "" + name + "и" ] : [ name, name, name, name, name, name ];
  }, exports.doInclineMaleName = doInclineMaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, hardConsonants, hissingAndChe, ishortRe, name2;
    return hardConsonants = /[бвгдзклмнпрстфх]$/g, hissingAndChe = /[жшщцч]$/g, ishortRe = /((ай)|(ей)|(ой)|(уй)|(яй)|(юй)|(ий))$/g, aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, name2 = name.slice(0, -1), name === "Лев" ? [ "Лев", "Льва", "Льву", "Льва", "Львом", "Льве" ] : name === "Павел" ? [ "Павел", "Павла", "Павлу", "Павла", "Павлом", "Павле" ] : /и$/g.test(name) ? [ name, name, name, name, name, name ] : hissingAndChe.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ем", "" + name + "е" ] : hardConsonants.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ом", "" + name + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : ishortRe.test(name) ? [ "" + name2 + "й", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ко$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /о$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : null;
  }, inclineAndGetResult = function(fn, args) {
    var i, name, r;
    r = null;
    for (i in args) {
      name = args[i], r = fn(name, !0);
      if (r.found) break;
    }
    return r;
  }, inclineFemaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineFemaleName, arguments);
  }, inclineMaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineMaleName, arguments);
  }, exports.inclineFemaleName = inclineFemaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name3, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), nl = name.toLowerCase(), nominativeRe = /[адежзийклмнорстуьэя]$/g, canInclineRe = /[жшщцчаяь]$/g, genitiveRe = /[иы]$/g, dativeRe = /[еи]$/g, accusativeRe = /[жшщцчьую]$/g, instrumentalRe = /((ой)|(ей)|(еи)|(ью))$/g, prepositionalRe = /[еи]$/g, result = r = null, nominativeRe.test(nl) && ref.ruFemaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineFemaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "female",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name2 = name.slice(0, -1), name_cases = [], genitiveRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("dative"))), prepositionalRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("prepositional"))), accusativeRe.test(nl) && (/[ую]$/g.test(nl) ? r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а") : r = inclineFemaleNameAndGetResult(name), r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (name3 = name.slice(0, -2), r = inclineFemaleNameAndGetResult("" + name3 + "я", "" + name3 + "а", "" + name3 + "ь", "" + name3), r && r.found && (result = r, name_cases.push("instrumental"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineMaleName = inclineMaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), name === "Льв" && (name = "Лев"), name === "Павл" && (name = "Павел"), nl = name.toLowerCase(), nominativeRe = /([вгдзклмнпрстфхжшцьй]|(ба)|(ва)|(да)|(за)|(ла)|(ма)|(на)|(па)|(ра)|(са)|(та)|(фа)|(га)|(ка)|(ха)|(жа)|(ша)|(ща)|(ца)|(ча)|(я)|(ло)|(ко))$/g, canInclineRe = /([бвгдзклмнпрстфхжшцьая]|(ия)|(ья)|(ея)|(ий)|(ей))$/g, genitiveRe = /[аяыи]$/g, dativeRe = /(([еую])|(ии))$/g, accusativeRe = /[аяую]$/g, instrumentalRe = /((ом)|(ем)|(ой)|(ей)|(ёй))$/g, prepositionalRe = /((е)|(ии))$/g, name2 = name.slice(0, -1), result = r = null, nominativeRe.test(nl) && ref.ruMaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineMaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "male",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name_cases = [], genitiveRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /ы$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "о", "" + name2 + "а") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "а", "" + name.slice(0, -1) + "я", "" + name.slice(0, -1) + "о") : r = null, r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (/у$/g.test(nl) ? r = inclineMaleName(name2) : /[аеиоуя]ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "й") : /ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "ь") : /е$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "и", "" + name2 + "я", "" + name2 + "o") : /ии$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я") : r = null, r && r.found && (result = r, name_cases.push("dative"))), accusativeRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /у$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а") : /[ую]$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : r = null, r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (/ом$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2)) : /ем$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2), "" + name.slice(0, -2) + "ь", "" + name.slice(0, -2) + "й") : /ой$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "а", "" + name.slice(0, -2) + "о") : /((ей)|(ёй))$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "я", "" + name.slice(0, -2) + "а") : r = null, r && r.found && (result = r, name_cases.push("instrumental"))), prepositionalRe.test(nl) && (/е$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2, "" + name2 + "ь", "" + name2 + "й", "" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я", "" + name2 + "й") : r = null, r && r.found && (result = r, name_cases.push("prepositional"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineName = inclineName = function(name) {
    var fn, mn, result;
    return fn = inclineFemaleName(name), mn = inclineMaleName(name), fn.found ? result = {
      found: !0,
      src: name,
      gender: "female",
      guess_case: fn.guess_case,
      female_cases: fn.cases,
      possible_cases: fn.possible_cases,
      nominative: fn.nominative
    } : mn.found ? result = {
      found: !0,
      src: name,
      gender: "male",
      guess_case: mn.guess_case,
      male_cases: mn.cases,
      possible_cases: mn.possible_cases,
      nominative: mn.nominative
    } : fn.possible_yes && mn.possible_yes ? (result = {
      found: "maybe",
      src: name,
      gender: [ "male", "female" ],
      female_cases: fn.cases,
      male_cases: mn.cases,
      possible_cases: util.merge(fn.possible_cases, mn.possible_cases)
    }, result.guess_case = fn.guess_case_index <= mn.guess_case_index ? fn.guess_case : mn.guess_case) : fn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "female",
      female_cases: fn.cases,
      guess_case: fn.cases,
      possible_cases: fn.possible_cases
    } : mn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "male",
      male_cases: mn.cases,
      guess_case: mn.cases,
      possible_cases: mn.possible_cases
    } : result = {
      found: !1,
      src: name
    }, result;
  }, inclineSurname = function(surname, noInclinesRe, inclineRe, casesRe) {
    var c, cases_index, check, i, result, surname_cases, _i, _j, _len, _len2;
    result = {
      found: null,
      src: surname,
      cases: null,
      cases_index: null
    };
    if (noInclinesRe && noInclinesRe.test(surname)) result = {
      found: surname,
      src: surname,
      cases: [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ],
      cases_index: [ 0, 1, 2, 3, 4, 5 ]
    }; else for (_i = 0, _len = inclineRe.length; _i < _len; _i++) {
      check = inclineRe[_i];
      if (check[0].test(surname)) {
        result = {
          found: surname.replace(check[0], check[1]),
          src: surname
        }, cases_index = [], surname_cases = [], i = 0;
        for (_j = 0, _len2 = casesRe.length; _j < _len2; _j++) c = casesRe[_j], c.test(surname) && (cases_index.push(i), surname_cases.push(cases[i])), i++;
        surname_cases.length === 0 ? (result.found = null, result.cases = null) : result.cases = surname_cases, result.cases_index = cases_index;
        break;
      }
    }
    return result.surname_cases && (result.guess_case = result.surname_cases[0]), result;
  }, exports.inclineFemaleSurname = inclineFemaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(е)|(о)|(э)|(и)|(ы)|(^[нв]у)|(^ую)|(уа)|(иа)|(ман)|(вич)|(ян))$/g, inclineRe = [ [ /((ова)|(овой)|(ову))$/g, "ова" ], [ /((ева)|(евой)|(еву))$/g, "ева" ], [ /((ёва)|(ёвой)|(ёву))$/g, "ёва" ], [ /((ина)|(иной)|(ину))$/g, "ина" ], [ /((ая)|(ой)|(ую))$/g, "ая" ] ], casesRe = [ /((ова)|(ева)|(ёва)|(ина)|(ая))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((ову)|(еву)|(ёву)|(ину)|(ую))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, exports.inclineMaleSurname = inclineMaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(^ве)|(^го)|(э)|(и)|(ы)|(^му)|(ю)|(уа)|(иа))$/g, inclineRe = [ [ /((ов)|(ова)|(ову)|(овым)|(ове))$/g, "ов" ], [ /((ев)|(ева)|(еву)|(евым)|(еве))$/g, "ев" ], [ /((ёв)|(ёва)|(ёву)|(ёвым)|(ёве))$/g, "ёв" ], [ /((ин)|(ина)|(ину)|(иным)|(ине))$/g, "ин" ], [ /((ский)|(ского)|(скому)|(ским)|(ском))$/g, "ский" ], [ /((ской)|(ского)|(скому)|(ским)|(ском))$/g, "ской" ], [ /((ман)|(мана)|(ману)|(маном)|(мане))$/g, "ман" ], [ /((ой)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ой" ], [ /((ий)|(ого)|(ому)|(ого)|(им)|(ом))$/g, "ий" ], [ /((ый)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ый" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ], [ /((ян)|(яна)|(яну)|(яна)|(яном)|(яне))$/g, "ян" ] ], casesRe = [ /((ов)|(ев)|(ёв)|(ин)|(ский)|(ской)|(ой)|(ий)|(ый)|(ман)|(ич)|(ян))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((ову)|(еву)|(ёву)|(ину)|(скому)|(ому)|(ману)|(ичу)|(яну))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((овым)|(евым)|(ёвым)|(иным)|(ским)|(им)|(ым)|(маном)|(ичем)|(яном))$/g, /((ове)|(еве)|(ёве)|(ине)|(ском)|(ом)|(мане)|(иче)|(яне))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, inclineMiddleNameOrSurname = function(src, fem, male) {
    var result, _ref;
    return fem.found === (_ref = male.found) && _ref === null ? result = {
      found: !1,
      src: src,
      value: null,
      gender: null
    } : fem.found && male.found ? (result = {
      found: !0,
      src: src,
      gender: [ "male", "female" ]
    }, result.nominative_male = male.found, result.nominative_female = fem.found, result.female_cases = fem.cases, result.male_cases = male.cases, fem.cases.length === 6 ? male.cases.length === 6 ? (result.guess_sex = "unknown", result.possible_cases = util.merge(fem.cases, male.cases)) : (result.guess_sex = "male", result.nominative = male.found, result.possible_cases = male.cases) : fem.cases.length === 1 && male.cases.length > 1 ? (result.guess_sex = "female", result.nominative = fem.found, result.possible_cases = fem.cases) : result.possible_cases = util.merge(fem.cases, male.cases)) : fem.found ? male.found || (result = {
      found: !0,
      src: src,
      gender: "female",
      female_cases: fem.cases,
      guess_case: fem.guess_case,
      nominative: fem.found,
      possible_cases: fem.cases
    }) : result = {
      found: !0,
      src: src,
      gender: "male",
      male_cases: male.cases,
      guess_case: male.guess_case,
      nominative: male.found,
      possible_cases: male.cases
    }, result;
  }, exports.inclineSurname = inclinePersonSurname = function(surname) {
    return inclineMiddleNameOrSurname(surname, inclineFemaleSurname(surname), inclineMaleSurname(surname));
  }, exports.inclineMaleMiddleName = inclineMaleMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((евич)|(евича)|(евичу)|(евича)|(евичем)|(евиче))$/g, "евич" ], [ /((ович)|(овича)|(овичу)|(овича)|(овичем)|(овиче))$/g, "ович" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ] ], casesRe = [ /((евич)|(ович)|(ич))$/g, /((евича)|(овича)|(ича))$/g, /((евичу)|(овичу)|(ичу))$/g, /((евича)|(овича)|(ича))$/g, /((евичем)|(овичем)|(ичем))$/g, /((евиче)|(овиче)|(иче))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineFemMiddleName = inclineFemMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((вна)|(вны)|(вне)|(вну)|(вной)|(вне))$/g, "вна" ], [ /((чна)|(чны)|(чне)|(чну)|(чной)|(чне))$/g, "чна" ] ], casesRe = [ /((вна)|(чна))$/g, /((вны)|(чны))$/g, /((вне)|(чне))$/g, /((вну)|(чну))$/g, /((вной)|(чной))$/g, /((вне)|(чне))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineMiddleName = inclineMiddleName = function(mname) {
    return inclineMiddleNameOrSurname(mname, inclineFemMiddleName(mname), inclineMaleMiddleName(mname));
  }, genderMatch = function(g1, g2) {
    return g1 === g2 || __indexOf.call(g2, g1) >= 0 ? g1 : __indexOf.call(g1, g2) >= 0 ? g2 : null;
  }, matchNameParts = function(fn, mn, sn) {
    var overallGender, surname, theCase;
    return theCase = util.intersection(fn.possible_cases, mn.possible_cases), overallGender = genderMatch(genderMatch(fn.gender, mn.gender), sn.gender), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: mn.nominative,
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchNameAndSurname = function(fn, sn) {
    var overallGender, surname, theCase;
    return overallGender = genderMatch(fn.gender, sn.gender), theCase = util.intersection(fn.possible_cases, sn.possible_cases), theCase || (sn.possible_cases = sn["" + overallGender + "_cases"], sn.nominative = sn["nominative_" + overallGender], theCase = util.intersection(fn.possible_cases, sn.possible_cases)), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: "",
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchCase = function(pObj, target_case, gender) {
    return __indexOf.call(pObj["" + gender + "_cases"], target_case) >= 0;
  }, getNominative = function(pObj, gender) {
    var gnstr, nom;
    return gnstr = "nominative_" + gender, nom = pObj.nominative && pObj.nominative || pObj[gnstr], nom;
  }, exports.findProperName = findProperName = function(listOfWords, opts) {
    var mnr2, mnr3, nr1, nr2, nr3, result, sr1, sr2, sr3;
    opts == null && (opts = {}), result = {
      found: !1
    };
    switch (listOfWords.length) {
     case 1:
      result = inclineName(listOfWords[0]), result.found ? result.first_name = result.nominative : (result = inclinePersonSurname(listOfWords[0]), result.found && (result.surname = result.nominative));
      break;
     case 2:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr1.found && sr2.found && (result = matchNameAndSurname(nr1, sr2)), !result.found && sr1.found && nr2.found && (result = matchNameAndSurname(sr1, nr2));
      break;
     case 3:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), sr3 = inclinePersonSurname(listOfWords[2]), mnr2 = inclineMiddleName(listOfWords[1]), mnr3 = inclineMiddleName(listOfWords[2]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr3 = inclineName(listOfWords[2]), nr3.found ? result = {
        found: !1,
        error: "name at the end of 3-component proper name"
      } : nr1.found ? (mnr2.found && sr3.found && (result = matchNameParts(nr1, mnr2, sr3)), !result.found && sr2.found && (result = matchNameAndSurname(nr1, sr2))) : sr1.found && nr2.found && mnr3.found ? result = matchNameParts(nr2, mnr3, sr1) : nr2.found && sr3.found && (result = matchNameAndSurname(nr2, sr3));
    }
    return result.first_name || (result.first_name = ""), result.middle_name || (result.middle_name = ""), result.surname || (result.surname = ""), result.first_name || result.middle_name || result.surname || (result = {
      found: !1,
      error: "person not found"
    }), result.src = listOfWords.join(" "), result;
  }, exports.getInitialFormOfAdjective = function(adj) {
    var base;
    return adj = adj.toLowerCase(), /^[а-яё]{2,}(ая|ее|ие|ий|им|ими|их|ого|его|ое|ой|ом|ому|ою|ую|ые|ый|ым|ыми|ых|юю|яя)$/.test(adj) ? (/^[а-яё]{2,}(ими|ого|его|ому|ыми)$/gi.test(adj) ? base = adj.slice(0, -3) : base = adj.slice(0, -2), [ "" + base + "ый", "" + base + "ий", "" + base + "ой" ]) : null;
  }, exports.getVerbInfinitive = function(verb) {
    var pastTime, result, verbEnd;
    return verb = verb.toLowerCase(), /^[а-яё]{3,}(ать|аться|ить|иться|еть|еться|оть|оться|уть|утся|ются|ть|ться)$/.test(verb) ? verb : (/^[а-яё]{3,}(сь|ся)$/.test(verb) ? (verbEnd = verb.slice(-2), verb = verb.slice(0, -2)) : verbEnd = "", pastTime = verb.match(/^[а-яё]{3,}(л|ла|ло|ли)$/), pastTime ? result = verb.slice(0, -(1 + pastTime[1].length) + 1 || 9e9) + "ть" : /[а-яё]{3,}(у|ю|ем|ешь|ете|ет|ут|ют|им|ишь|ите|ит|ат|ят)$/.test(verb) && (/[а-яё]{3,}(ишь|ит|им|ите|ат|ят)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd ] : /[а-яё]{3,}(у|ю|ешь|ет|ем|ете|ут|ют)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd, "" + verb + "оть" + verbEnd, "" + verb + "уть" + verbEnd, "" + verb + "ть" + verbEnd ] : result = null), result);
  };
}(exports, util, ref);

var exports, ruWords, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.morpho = {}, exports = window.lastName.plugins.ru.morpho, ruWords = window.lastName.plugins.ru.words) : (exports = module.exports, ruWords = require("./words")), function(exports, ruWords) {
  var exceptions, getRulesAdjective, getRulesVerb, morphoRu;
  return exports.getWordRe = function() {
    return /^[а-я\-ё\d]+$/ig;
  }, exports.getAdjectiveEnds = function() {
    return {
      feminine: {
        ends: /((ая)|(ой)|(ую)|(яя)|(ей)|(юю))$/g,
        hard: /((ая)|(ой)|(ую))$/g,
        sort: /((яя)|(ей)|(юю))$/g,
        hardNominativeEnd: "ая",
        softNominativeEnd: "яя",
        gender: "feminine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ая" ? [ "" + word + "ая", "" + word + "ой", "" + word + "ой", "" + word + "ую", "" + word + "ой", "" + word + "ой" ] : [ "" + word + "яя", "" + word + "ей", "" + word + "ей", "" + word + "юю", "" + word + "ей", "" + word + "ей" ];
        }
      },
      masculine: {
        ends: /((ый)|(ого)|(ому)|(ым)|(ом)|(ий)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ый)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ий)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ый",
        softNominativeEnd: "ий",
        gender: "masculine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ый" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ий", "" + word + "ого", "" + word + "ому", "" + word + "ий", "" + word + "им", "" + word + "ом" ] : [ "" + word + "ый", "" + word + "ого", "" + word + "ому", "" + word + "ый", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ий", "" + word + "его", "" + word + "ему", "" + word + "ий", "" + word + "им", "" + word + "ем" ];
        }
      },
      neuter: {
        ends: /((ое)|(ого)|(ому)|(ым)|(ом)|(ее)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ое)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ее)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ое",
        softNominativeEnd: "ее",
        gender: "neuter",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ое" ? [ "" + word + "ое", "" + word + "ого", "" + word + "ому", "" + word + "ое", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ее", "" + word + "его", "" + word + "ему", "" + word + "ее", "" + word + "им", "" + word + "ем" ];
        }
      },
      plural: {
        ends: /((ые)|(ых)|(ым)|(ыми)|(ых)|(ие)|(их)|(им)|(ими)|(их))$/g,
        hard: /((ые)|(ых)|(ым)|(ыми)|(ых))$/g,
        soft: /((ие)|(их)|(им)|(ими)|(их))$/g,
        hardNominativeEnd: "ые",
        softNominativeEnd: "ие",
        gender: "unknown",
        singular: !1,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ые" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ] : [ "" + word + "ые", "" + word + "ых", "" + word + "ым", "" + word + "ые", "" + word + "ыми", "" + word + "ых" ] : [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ];
        }
      }
    };
  }, exceptions = function(word) {}, getRulesVerb = function() {
    return [ [ /нул[aи]{0,1}$/g, "ать" ], [ /еть$/g, "ать" ], [ /(ает)|(ают)$/g, "ать" ], [ /ал[aи]{0,1}$/g, "ать" ], [ /ул[aи]{0,1}$/g, "ать" ], [ /((ить)|(ать))$/g, "ать" ], [ /ая$/g, "ать" ], [ /((ил)|(или)|(ила)|(ило))$/g, "лять" ], [ /(ятся)|(ится)|(ился)|(илась)|(илось)$/g, "ится" ], [ /(яться)|(иться)$/g, "иться" ] ];
  }, getRulesAdjective = function() {
    return [ [ /в((ая)|(ые)|(ый)|(ое))$/, "вый" ], [ /((ая)|(ой)|(ие)|(ые)|(ый)|(ую))$/, "ый" ], [ /((яя)|(ее)|(ий)|(юю))$/, "ий" ] ];
  }, exports.morpho = morphoRu = function(word) {
    var adj, adjective, result, rule, verb, _i, _j, _len, _len2, _ref, _ref2;
    if (__indexOf.call(ruWords.adverbs, word) >= 0) return {
      type: "abverb",
      value: word
    };
    if (__indexOf.call(ruWords.prepositionAll, word) >= 0) return {
      type: "preposition",
      value: word
    };
    if (__indexOf.call(ruWords.unions, word) >= 0) return {
      type: "union",
      value: word
    };
    result = {
      type: "",
      value: ""
    }, verb = null, adjective = null, _ref = getRulesVerb();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      rule = _ref[_i];
      if (rule[0].test(word)) {
        result = {
          type: verb,
          value: word.replace(rule[0], rule[1])
        };
        break;
      }
    }
    _ref2 = getRulesAdjective();
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      rule = _ref2[_j];
      if (rule[0].test(word)) {
        adj = word.replace(rule[0], rule[1]), result.type ? (result.type += " adjective", result.value = [ result.value, adj ]) : result = {
          type: "adjective",
          value: adj
        };
        break;
      }
    }
    return result;
  }, exports.analyseText = function(text) {
    var doubleSpaceRe, enRe, punctuationRe, r, result, ruRe, t, wordRe, _i, _len, _ref;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&№“”\—]/g, doubleSpaceRe = /\s+/g, text = text.replace(punctuationRe, " $& ").replace(doubleSpaceRe, " ") + " .", result = [], _ref = text.split(" ");
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      t = _ref[_i], ruRe = /^[а-я\-ё]+$/ig, enRe = /^[a-z\-]+$/ig, wordRe = /^[а-яё\-\da-z]+$/ig, r = morphoRu(t.toLowerCase());
      switch (r.type) {
       case "adverb":
        result.push("[ADV " + t + "]");
        break;
       case "verb":
       case "adjective":
        result.push("[ " + r.value + " ]");
        break;
       case "verb adjective":
        result.push("[#VA " + r.value[0] + "]");
        break;
       case "union":
        result.push("[U " + t + "]");
        break;
       case "preposition":
        result.push("[PP " + t + "]");
        break;
       default:
        result.push(t);
      }
      t === "." && result.push("\n");
    }
    return result;
  }, exports.parseRuSentence = function(sentences) {
    var abbrevs, common_used_words, digits, regular_words, special_words, total_words;
    return sentences instanceof Array || (sentences = [ sentences ]), abbrevs = {}, special_words = {}, digits = {}, common_used_words = {}, regular_words = {}, total_words = 0, sentences.map(function(sent) {
      var i, result, w, word, words, _len, _ref, _results;
      words = sent.split(" "), _results = [];
      for (i = 0, _len = words.length; i < _len; i++) word = words[i], /^[[,:\/\\\?!\+\-\*\(\)\[\]\&\№\—]]+$/.test(words) || total_words++, /^(\d+(|(\.(|\d+))))$/.test(word) ? digits[word] ? _results.push(digits[word]++) : _results.push(digits[word] = 1) : isUpperCase(word) && /^[а-яё\-]{2,}$/i.test(word) ? abbrevs[word] ? _results.push(abbrevs[word]++) : _results.push(abbrevs[word] = 1) : i > 0 && isCapitalized(word) && /^[а-яё\-]{2,}$/i.test(word) ? special_words[word] ? _results.push(special_words[word]++) : _results.push(special_words[word] = 1) : /^[а-яё\-]+$/i.test(word) && !/^\-+$/.test(word) ? (w = word.toLowerCase(), result = morphoRu(w), (_ref = result.type) !== "adverb" && _ref !== "preposition" && _ref !== "union" ? regular_words[w] ? _results.push(regular_words[w]++) : _results.push(regular_words[w] = 1) : common_used_words[w] ? _results.push(common_used_words[w]++) : _results.push(common_used_words[w] = 1)) : _results.push(void 0);
      return _results;
    }), {
      abbrevs: abbrevs,
      common_used_words: common_used_words,
      special_words: special_words,
      regular_words: regular_words,
      digits: digits,
      total_words: total_words
    };
  };
}(exports, ruWords);

var exports, inclines, morpho, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.propernames = {}, exports = window.lastName.plugins.ru.propernames, morpho = window.lastName.plugins.ru.morpho, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, morpho = require("./morpho"), inclines = require("./inclines")), function(exports, morpho, inclines) {
  return exports.postFilter = function(text, result) {
    var curProperName, id, p, pn, pnDict, properNames, properNamesRe, punctuationRe, _i, _j, _len, _len2, _ref, _ref2;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&\№“”\—]/g, properNames = [], curProperName = [], properNamesRe = /[А-Я][а-яё]+(\s+[А-Я][а-яё]+){0,2}/gm, _ref = text.match(properNamesRe);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) pn = _ref[_i], curProperName = pn.replace(/\s+/g, " ").split(" "), curProperName && (pn = inclines.findProperName(curProperName), pn && pn.found && properNames.push(pn));
    pnDict = {};
    for (_j = 0, _len2 = properNames.length; _j < _len2; _j++) p = properNames[_j], id = "" + (p.first_name || "") + "-" + (p.middle_name || "") + "-" + (p.surname || ""), pnDict[id] ? (pnDict[id].count += 1, (_ref2 = p.src, __indexOf.call(pnDict[id].src, _ref2) < 0) && pnDict[id].src.push(p.src)) : (pnDict[id] = p, pnDict[id].src = [ p.src ], pnDict[id].count = 1);
    return result.propernames = pnDict;
  };
}(exports, morpho, inclines);

var exports, inclines, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName.plugins.ru.feelings = {}, exports = window.lastName.plugins.ru.feelings, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, inclines = require("./inclines")), function(exports, inclines) {
  var evaluateSentenceNeutrality, getNegativePhrasesRe, negativeAdjectives, negativeVerbs, negativeWordsIncline;
  return exports.positive = [], negativeAdjectives = {
    "агрессивный": 3,
    "атакованный": 2,
    "бедный": 2,
    "беззащитный": 2,
    "безнадежный": 3,
    "безрадостный": 2,
    "бесплодный": 3,
    "беспомощный": 3,
    "бесправный": 2,
    "бессердечный": 1,
    "бессильный": 1,
    "бесцельный": 2,
    "бесчестный": 2,
    "вздорный": 1,
    "виновный": 1,
    "ворчливый": 1,
    "враждебный": 2,
    "вспыльчивый": 1,
    "выпученный": 1,
    "выселенный": 3,
    "высмеянный": 2,
    "выхолощенный": 1,
    "глубокий": 1,
    "глупый": 2,
    "горький": 2,
    "готический": 2,
    "гротескный": 1,
    "грустный": 1,
    "грязный": 1,
    "девальвированный": 2,
    "деградировавший": 2,
    "дегуманизированный": 2,
    "дезорганизованный": 2,
    "дезориентированный": 2,
    "деморализованный": 3,
    "дерзкий": 1,
    "дерьмовый": 3,
    "дефектный": 3,
    "драматический": 3,
    "жалкий": 3,
    "жесткий": 2,
    "жестокосердный": 2,
    "заброшенный": 1,
    "забываемый": 1,
    "забывчивый": 1,
    "забытый": 2,
    "зависимый": 1,
    "заинтересованный": 1,
    "запрещенный": 3,
    "запутанный": 2,
    "застенчивый": 1,
    "застрявший": 1,
    "затравленный": 2,
    "зверский": 3,
    "злобный": 2,
    "идиотский": 3,
    "измельченный": 2,
    "измученный": 2,
    "изнасилованный": 3,
    "изолированный": 3,
    "изумленный": 1,
    "интенсивный": 1,
    "иррациональный": 2,
    "исключенный": 2,
    "искусственный": 2,
    "испуганный": 2,
    "истерический": 3,
    "исчерпанный": 2,
    "капризный": 2,
    "контролируемый": 1,
    "критический": 1,
    "ленивый": 2,
    "лишенный": 2,
    "ложный": 2,
    "мазохистский": 1,
    "мертвый": 3,
    "меченый": 2,
    "мрачный": 2,
    "мстительный": 2,
    "навязчивый": 2,
    "надоедливый": 2,
    "наказанный": 2,
    "нарушенный": 2,
    "натянутый": 2,
    "неадекватный": 2,
    "неактивный": 1,
    "небезопасный": 2,
    "небрежный": 1,
    "невежественный": 1,
    "невидимый": 1,
    "невротический": 2,
    "негуманный": 2,
    "недействительный": 1,
    "недовольный": 2,
    "недостаточный": 1,
    "недоуменный": 1,
    "незаземленный": 1,
    "незначительный": 1,
    "неискренний": 1,
    "некомпетентный": 2,
    "ненавистный": 3,
    "необщительный": 2,
    "неполный": 2,
    "неправильный": 2,
    "неприятный": 2,
    "нервный": 2,
    "нерешительный": 1,
    "несбалансированный": 1,
    "несовместимый": 2,
    "несоответствующий": 2,
    "неспособный": 3,
    "несчастный": 2,
    "неуклюжий": 2,
    "неуловимый": 1,
    "неуместный": 2,
    "нечестный": 2,
    "неэффективный": 2,
    "низкий": 1,
    "обвиняемый": 3,
    "обедненный": 1,
    "обезумевший": 3,
    "обиженный": 2,
    "обманутый": 2,
    "обозленный": 2,
    "оборонительный": 1,
    "обремененный": 1,
    "обременительный": 1,
    "обреченный": 2,
    "ограниченный": 1,
    "одержимый": 3,
    "одинокий": 2,
    "одноразовый": 1,
    "озабоченный": 2,
    "окаменелый": 1,
    "онемелый": 1,
    "опальный": 2,
    "опасный": 3,
    "опустошенный": 1,
    "опущенный": 2,
    "опьяненный": 1,
    "оскорбленный": 2,
    "осмеянный": 2,
    "острый": 1,
    "осужденный": 3,
    "осушенный": 2,
    "ответственный": 2,
    "отвратительный": 3,
    "отдаленный": 1,
    "отдельный": 1,
    "отрицательный": 2,
    "отсталый": 2,
    "отчаянный": 1,
    "ошибочный": 1,
    "параноидальный": 2,
    "паршивый": 2,
    "пассивный": 1,
    "переполненный": 2,
    "пессимистический": 2,
    "печальный": 2,
    "побежденный": 3,
    "поверхностный": 2,
    "поврежденный": 3,
    "подавленный": 2,
    "поддельный": 3,
    "покинутый": 2,
    "покорный": 1,
    "порабощенный": 3,
    "потерянный": 2,
    "потерпевший": 2,
    "потребленный": 1,
    "презираемый": 2,
    "презренный": 3,
    "презрительный": 2,
    "прерванный": 1,
    "принудительный": 2,
    "психотический": 2,
    "пустынный": 1,
    "пьяный": 2,
    "равнодушный": 1,
    "развращенный": 3,
    "раздраженный": 2,
    "раздражительный": 2,
    "разочарованный": 2,
    "разочаровывающий": 3,
    "разрушенный": 3,
    "разрушительный": 2,
    "разъяренный": 3,
    "раненый": 2,
    "ревнивый": 2,
    "садистский": 2,
    "самоубийственный": 3,
    "саркастический": 1,
    "сварливый": 1,
    "сгоревший": 3,
    "сердитый": 2,
    "серый": 1,
    "скучающий": 1,
    "скучный": 1,
    "сломанный": 2,
    "смущенный": 1,
    "созерцательный": 1,
    "сомнительный": 2,
    "спорный": 2,
    "спровоцированный": 2,
    "спутанный": 2,
    "спущенный": 2,
    "стереотипный": 1,
    "стесненный": 1,
    "странный": 1,
    "страшный": 2,
    "сумасшедший": 2,
    "тихий": 1,
    "тормозящий": 2,
    "торопливый": 2,
    "тоскливый": 3,
    "требовательный": 2,
    "тревожный": 2,
    "трудный": 2,
    "трусливый": 2,
    "тупой": 1,
    "тщеславный": 2,
    "угнетенный": 2,
    "угрюмый": 2,
    "удаляемый": 2,
    "удрученный": 2,
    "ужасный": 3,
    "уклончивый": 2,
    "униженный": 3,
    "унылый": 3,
    "урезанный": 2,
    "фальшивый": 3,
    "хаотический": 2,
    "холодный": 1,
    "хрупкий": 1,
    "цепкий": 2,
    "циничный": 2,
    "чертовский": 2,
    "чрезмерный": 2,
    "чувствительный": 2,
    "эгоистичный": 2,
    "эгоцентричный": 3,
    "эксплуатируемый": 2,
    "эмансипированный": 2,
    "эмоциональный": 1,
    "яростный": 3
  }, negativeVerbs = {
    "беспокоить": 2,
    "бить": 2,
    "внушать": 2,
    "волноваться": 2,
    "высмеивать": 2,
    "грызть": 1,
    "диктовать": 2,
    "дребезжать": 1,
    "дрожать": 1,
    "дрогнуть": 2,
    "загнать": 2,
    "запугивать": 3,
    "запутаться": 2,
    "злоупотреблять": 2,
    "игнорировать": 1,
    "избегать": 1,
    "издеваться": 3,
    "изменять": 2,
    "командовать": 1,
    "лгать": 2,
    "лишить": 2,
    "манипулировать": 2,
    "молчать": 1,
    "надувать": 1,
    "ненавидеть": 3,
    "обвинять": 2,
    "обидеть": 2,
    "опорочить": 3,
    "освистать": 3,
    "отбрасывать": 1,
    "отвлекаться": 2,
    "отклонить": 2,
    "отрекаться": 3,
    "оттолкнуть": 2,
    "паниковать": 2,
    "перепутаться": 2,
    "подавить": 3,
    "подвергаться": 2,
    "пострадать": 2,
    "предавать": 3,
    "пренебрегать": 2,
    "препятствовать": 2,
    "преследовать": 2,
    "принижаться": 2,
    "приставать": 2,
    "прослушивать": 2,
    "разгромить": 2,
    "раздражаться": 2,
    "растаскивать": 2,
    "рисковать": 2,
    "ругать": 2,
    "сдуваться": 1,
    "смолчать": 2,
    "снизиться": 1,
    "сорвать": 1,
    "сожалеть": 2,
    "соизволить": 2,
    "солгать": 2,
    "сомневаться": 2,
    "споткнуться": 1,
    "столкнуться": 2,
    "страдать": 2,
    "стрелять": 3,
    "судить": 2,
    "толкнуть": 1,
    "убить": 3,
    "убивать": 3,
    "уговаривать": 1,
    "удалять": 2,
    "уклоняться": 2,
    "унижать": 3,
    "шантажировать": 2
  }, negativeWordsIncline = {
    "боль": 2,
    "вниз": 1,
    "горе": 3,
    "дно": 2,
    "мало": 1,
    "мучение": 2,
    "недовольство": 2,
    "плохо": 2,
    "противно": 3,
    "совестно": 2,
    "только": 1,
    "ужас": 3,
    "смерть": 3,
    "неодобрительно": 2,
    "разгром": 2,
    "отчаяние": 3
  }, exports.getNegativePhrasesRe = getNegativePhrasesRe = function() {
    return [ [ /[^а-яё]при\sотягчающих\sобстоятельствах[^а-яё]/ig, 2 ], [ /[^а-яё]ненависть\sк[^а-яё]/ig, 3 ], [ /[^а-яё]в\sубыток[^а-яё]/ig, 2 ], [ /[^а-яё]сыт[аы]?\sпо\sгорло[^а-яё]/ig, 3 ], [ /[^а-яё]заслужива[ею]т\sнаказания[^а-яё]/ig, 2 ], [ /[^а-яё]находящ(егося|ейся|емся|ихся)\sпод\sугрозой\sисчезновения[^а-яё]/ig, 3 ], [ /[^а-яё]в\sзаблуждение[^а-яё]/ig, 2 ], [ /[^а-яё]сбит[аы]?\sс\sтолку[^а-яё]/ig, 2 ], [ /[^а-яё]в\sужасе[^а-яё]/ig, 3 ], [ /[^а-яё]не\sрекоменд(ую|уем|уется|овал|овала|овали)[^а-яё]/ig, 2 ], [ /[^а-яё]не\sодобря(ю|ем|л|ла|ли|ется)[^а-яё]/ig, 2 ], [ /[^а-яё]пятно\sна[^а-яё]/ig, 2 ], [ /[^а-яё]в\sклетке[^а-яё]/ig, 1 ], [ /[^а-яё]неправильно\sпонял[аи]?[^а-яё]/ig, 2 ], [ /[^а-яё]вне\sпределов\sдосягаемости[^а-яё]/ig, 1 ], [ /[^а-яё]взял[аи]?\sна[^а-яё]/ig, 2 ], [ /[^а-яё]играл[аи]?\sс[^а-яё]/ig, 2 ], [ /[^а-яё]черный\sсписок[^а-яё]/ig, 3 ], [ /[^а-яё]возбужден[оы]\sуголовн(ое|ые)\sдел[оа][^а-яё]/ig, 8 ], [ /[^а-яё]жертв(|а|ы|ам|ами)[^а-яё]/ig, 3 ] ];
  }, exports.evaluateSentenceNeutrality = evaluateSentenceNeutrality = function(sentence) {
    var adj, adjArray, adjIndex, curWords, cur_index, ind, index, m, nr, resetCurIndex, vIndex, verb, words, wrd, _i, _j, _k, _len, _len2, _len3, _ref, _ref2;
    index = 0, cur_index = 0, words = [], curWords = [], _ref = getNegativePhrasesRe();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) nr = _ref[_i], m = sentence.match(nr[0]), m && (m.map(function(wordsSequence) {
      return words.push(wordsSequence);
    }), index -= nr[1] * m.length);
    resetCurIndex = function() {
      if (cur_index) return index += cur_index, words.push(curWords), curWords = [], cur_index = 0;
    }, _ref2 = sentence.split(/\s/);
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      wrd = _ref2[_j];
      if (__indexOf.call(".,-—!?()[]", wrd) >= 0) {
        cur_index = -cur_index, resetCurIndex();
        continue;
      }
      ind = negativeWordsIncline[wrd.toLowerCase()];
      if (ind) curWords.push(wrd), cur_index = cur_index * ind || ind; else {
        adjArray = inclines.getInitialFormOfAdjective(wrd);
        if (!adjArray) verb = inclines.getVerbInfinitive(wrd), vIndex = negativeVerbs[verb], vIndex ? (curWords.push(wrd), cur_index = cur_index * vIndex || vIndex) : (cur_index = -cur_index, resetCurIndex()); else for (_k = 0, _len3 = adjArray.length; _k < _len3; _k++) {
          adj = adjArray[_k], adjIndex = negativeAdjectives[adj];
          if (adjIndex) {
            curWords.push(wrd), cur_index = cur_index * adjIndex || adjIndex;
            break;
          }
        }
      }
    }
    return resetCurIndex(-cur_index), [ index, words ];
  }, exports.postFilter = function(text, result) {
    var emoIndex, emoWords, i, index, overallIndex, s, _len, _ref, _ref2;
    emoIndex = [], overallIndex = 0, _ref = result.misc.sentences;
    for (i = 0, _len = _ref.length; i < _len; i++) s = _ref[i], _ref2 = evaluateSentenceNeutrality(s), index = _ref2[0], emoWords = _ref2[1], emoIndex.push([ index, emoWords ]), overallIndex += index;
    return result.feelings = {
      emoIndex: emoIndex,
      overallIndex: overallIndex,
      emoScore: overallIndex / result.counters.words_total || 1
    };
  };
}(exports, inclines);

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).analysis || (_base.analysis = {}), exports = window.lastName.analysis) : exports = module.exports, function(exports) {
  return exports.analyse = function(text, plugins) {
    var f, misc, postFilter, preFilters, result, util, _i, _j, _len, _len2;
    plugins == null && (plugins = []), "undefined" == typeof global ? (misc = window.lastName.misc, util = window.lastName.util) : (misc = require("./misc"), util = require("./util")), result = {}, misc.preFilter(text, result), preFilters = plugins.filter(function(plugin) {
      return "function" == typeof plugin.preFilter;
    }), postFilter = plugins.filter(function(plugin) {
      return "function" == typeof plugin.postFilter;
    });
    for (_i = 0, _len = preFilters.length; _i < _len; _i++) f = preFilters[_i], f.preFilter(text, result);
    for (_j = 0, _len2 = postFilter.length; _j < _len2; _j++) f = postFilter[_j], f.postFilter(text, result);
    return result.version = util.version, result;
  };
}(exports);

var __slice = Array.prototype.slice;

(function(lastname) {
  return lastname.version = "0.3.5", lastname.findProperName = function() {
    var args, inclines, lang;
    return lang = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [], inclines = lastname.plugins["" + lang].inclines, inclines.findProperName.apply(this, args);
  };
})(window.lastName || (window.lastName = {}));

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).misc || (_base.misc = {}), exports = window.lastName.misc) : exports = module.exports, function(exports) {
  return exports.preFilter = function(text, result) {
    var chars_total, emo, emoticons, findEmo, ind, punctuationRe, sentences, signs, signs_total, spaces_total, tempTxt, word_length_mid, words_total, _i, _len;
    signs = text.match(/[-\+=\/\.,\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]{1}/g), signs_total = signs && signs.length || 0, spaces_total = /\s/.test(text) ? text.match(/\s/g).length : 0, chars_total = text.length, words_total = text.split(/\s/).filter(function(wrd) {
      return wrd.length > 0 && !/^[-\+=\/\.\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]+$/.test(wrd);
    }).length, word_length_mid = words_total ? (chars_total - spaces_total - signs_total) / words_total : 0, emoticons = [ ":-)", "(-:", ":o)", ":)", "(:", ":->", ":-}", ":-t", ":*)", ":-)))", ":-D", "(-D", ":'-)", "%-)", ":-/", ":-I", ":~)", "(:-(", ":-(", ":-c", ":-(((", ":-<", ">:-(", ":-[", "(:-&", "%-(", ">:-<", "~ :-(", "%-(", ":/)", ":-|", ":-e", ":-X", ":-v", ":-I", ":-8(", ":-O", ":-@", ":,-(", ":'-(", "~:-o", "]:-)>", "):-)", ";->", ":-x", ":-*", "8-]", ":-J", ":-&", ":-p", ":-P", ";-)", ";)", "'-)", ":-7", "?-(", "B-D", ":-B", ":-*)", ":-9", "|-p", ":-b", "-]:-)[-", "8-I", "8-|", "|:-|", ":-]", "|-)", "|-I", "I^o", "|-O", ':-"', ":-s", ":-#", ":-!", ":-()", ":-D", "(:-$", ":-(*)", ":-')", ":-R", "%+|", "%+{", "X-(", "<:-)", "*:o)", "@;-)", "X:-)", ":>)", "&:-)", "#:-)", "8-)", "8:-)", "B-)", "B-]", "O:-)", "&8-|", ":-{", ":-)}", ":-)#", ":-Q", ":-I", ":-d~", ":-?", ":-/I", ":-) X", "{(:-)", ":-{}", "[:-)", "d :-o", "~:-(", "~~:-(", "))", "(:-I", "3:-o", "[: |]", "M-)", ":X)", ":-M", "*8((:", "O+", "O->", "||*(", "||*)", "<{:-)}", "(-: :-)", "@->-", "@==", "<')))))- <" ], emoticons.sort(function(a, b) {
      return b.length - a.length;
    }), tempTxt = text.slice(0), findEmo = [];
    for (_i = 0, _len = emoticons.length; _i < _len; _i++) {
      emo = emoticons[_i], ind = 0;
      while (ind >= 0) ind = tempTxt.indexOf(emo, ind), ind !== -1 && (findEmo.push(emo), tempTxt = tempTxt.replace(emo, ""), ind -= emo.length + 2);
    }
    return punctuationRe = /(https?\:\/\/.*[\s$])|(\.\s)|(,\s)|(\s\:)|(:\s)|(\s\/)|(\/\s)|(\s\\)(\\\s)|\?|!|\+|\'|\"|«|»|\*|\(|\)|\[|\]|\&|\№|“|”|\—/g, tempTxt = text.replace(punctuationRe, " $& ").replace(/\s+/g, " "), /[\?\!\.]\s{0,}$/.test(tempTxt) || (tempTxt += " . "), sentences = tempTxt.replace(/\s\?\s/gm, " ?? ").replace(/\s\!\s/gm, " !! ").replace(/\s\.\s/gm, " .. ").split(/[\?\!\.](\s+|$)/gm).filter(function(s) {
      return !/^\s{0,}$/.test(s);
    }), result.misc = {
      digits: util.arrayToDict(text.match(/-?((\d+[\.,]\d+)|(\d+))/ig) || []),
      emoticons: util.arrayToDict(findEmo),
      romans: util.arrayToDict(text.match(/M*(D?C{0,3}|C[DM])(L?X{0,3}|X[LC])(V?I{0,3}|I[VX])/g) || []),
      sentences: sentences
    }, result.counters = {
      chars_total: chars_total,
      words_total: words_total,
      signs_total: signs_total,
      spaces_total: spaces_total,
      word_length_mid: word_length_mid,
      words_in_sentence_mid: sentences.length ? words_total / sentences.length : 0
    }, result;
  };
}(exports);

var exports, _base, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).util || (_base.util = {}), exports = window.lastName.util) : exports = module.exports, function(exports) {
  var capitalize, dictKeys, intersection, isCapitalized, isLowerCase, isUpperCase, merge, unique;
  return exports.version = "0.3.17", exports.capitalize = capitalize = function(s) {
    if (s) return "" + s[0].toUpperCase() + s.slice(1).toLowerCase();
  }, exports.dictKeys = dictKeys = function(dict) {
    var k, keys, v;
    keys = [];
    for (k in dict) v = dict[k], keys.push(k);
    return keys;
  }, exports.isCapitalized = isCapitalized = function(word) {
    var cap;
    return 0 <= word.indexOf("-") ? (cap = !0, word.split("-").map(function(wrd) {
      return cap && (cap = isCapitalized(wrd));
    }), cap) : word && word === capitalize(word) || !1;
  }, exports.isUpperCase = isUpperCase = function(word) {
    return word === word.toUpperCase();
  }, exports.isLowerCase = isLowerCase = function(word) {
    return word === word.toLowerCase();
  }, exports.unique = unique = function(array) {
    var key, output, value, _ref, _results;
    output = {};
    for (key = 0, _ref = array.length; 0 <= _ref ? key < _ref : key > _ref; 0 <= _ref ? key++ : key--) output[array[key]] = array[key];
    _results = [];
    for (key in output) value = output[key], _results.push(value);
    return _results;
  }, exports.merge = merge = function(l1, l2) {
    var l;
    return l = [], l1.map(function(x) {
      return l.push(x);
    }), l2.map(function(x) {
      return l.push(x);
    }), unique(l);
  }, exports.intersection = intersection = function(l1, l2) {
    var i, _i, _len;
    for (_i = 0, _len = l1.length; _i < _len; _i++) {
      i = l1[_i];
      if (__indexOf.call(l2, i) >= 0) return i;
    }
    return null;
  }, exports.arrayToDict = function(arr) {
    var d, i, _i, _len;
    d = {};
    for (_i = 0, _len = arr.length; _i < _len; _i++) i = arr[_i], d[i] ? d[i]++ : d[i] = 1;
    return d;
  };
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.ref = {}, exports = window.lastName.plugins.ru.ref) : exports = module.exports, function(exports) {
  return exports.ruFemaleNamesDict = {
    "альвина": 1,
    "анелия": 1,
    "августа": 1,
    "августина": 1,
    "авдотья": 1,
    "авелина": 1,
    "аврелия": 1,
    "аврора": 1,
    "агапия": 1,
    "агата": 1,
    "агафья": 1,
    "агафия": 1,
    "аглаида": 1,
    "аглая": 1,
    "агнеса": 1,
    "агнесса": 1,
    "агния": 1,
    "агриппмеа": 1,
    "агрефена": 1,
    "ада": 1,
    "адина": 1,
    "адель": 1,
    "аделия": 1,
    "аделаида": 1,
    "аза": 1,
    "азалия": 1,
    "аида": 1,
    "айседора": 1,
    "айсылу": 1,
    "акилина": 1,
    "акулина": 1,
    "аксинья": 1,
    "алевтина": 1,
    "александра": 1,
    "алеся": 1,
    "алена": 1,
    "алина": 1,
    "алиса": 1,
    "алия": 1,
    "алла": 1,
    "алика": 1,
    "альбина": 1,
    "альмир": 1,
    "альфия": 1,
    "амина": 1,
    "анастасия": 1,
    "анатолия": 1,
    "ангелина": 1,
    "анжела": 1,
    "анимаиса": 1,
    "анисия": 1,
    "анисья": 1,
    "анна": 1,
    "анита": 1,
    "антонина": 1,
    "антонида": 1,
    "антония": 1,
    "анфиса": 1,
    "анфуса": 1,
    "анфия": 1,
    "амира": 1,
    "аполлинария": 1,
    "аревик": 1,
    "ариадна": 1,
    "арина": 1,
    "аркадия": 1,
    "арсения": 1,
    "арсиана": 1,
    "артемия": 1,
    "асель": 1,
    "аста": 1,
    "астра": 1,
    "астрид": 1,
    "афанасия": 1,
    "афродита": 1,
    "аэлита": 1,
    "аэлла": 1,
    "амалия": 1,
    "бажена": 1,
    "беата": 1,
    "беатриса": 1,
    "бела": 1,
    "белла": 1,
    "беллатриса": 1,
    "берта": 1,
    "богдана": 1,
    "божена": 1,
    "болеслава": 1,
    "борислава": 1,
    "бриджет": 1,
    "бронислава": 1,
    "валентина": 1,
    "валерия": 1,
    "ванда": 1,
    "варвара": 1,
    "василина": 1,
    "василиса": 1,
    "васса": 1,
    "вацлава": 1,
    "вевея": 1,
    "велора": 1,
    "велория": 1,
    "венера": 1,
    "вера": 1,
    "вероника": 1,
    "веселина": 1,
    "веста": 1,
    "видана": 1,
    "викторина": 1,
    "виктория": 1,
    "вилена": 1,
    "виола": 1,
    "виолетта": 1,
    "виоланта": 1,
    "виринея": 1,
    "вита": 1,
    "виталия": 1,
    "виталина": 1,
    "виулена": 1,
    "влада": 1,
    "владилена": 1,
    "владимира": 1,
    "владислава": 1,
    "владлена": 1,
    "власта": 1,
    "воля": 1,
    "всеслава": 1,
    "гайя": 1,
    "гали": 1,
    "галина": 1,
    "ганна": 1,
    "гаяна": 1,
    "гаяния": 1,
    "гвинет": 1,
    "гелена": 1,
    "гелия": 1,
    "гелла": 1,
    "генриетта": 1,
    "гертруда": 1,
    "глафира": 1,
    "гликерия": 1,
    "глория": 1,
    "голуба": 1,
    "горислава": 1,
    "гюльанэ": 1,
    "гюльнара": 1,
    "гюльчитай": 1,
    "даздраперма": 1,
    "дайна": 1,
    "дана": 1,
    "дарья": 1,
    "дария": 1,
    "дарина": 1,
    "дарьяна": 1,
    "декабрина": 1,
    "дея": 1,
    "дия": 1,
    "джиневра": 1,
    "дженнифер": 1,
    "джульета": 1,
    "дианна": 1,
    "дилия": 1,
    "диля": 1,
    "дильфуза": 1,
    "дина": 1,
    "диния": 1,
    "диодора": 1,
    "дионисия": 1,
    "добрава": 1,
    "домна": 1,
    "домина": 1,
    "домника": 1,
    "доминика": 1,
    "донара": 1,
    "дорофея": 1,
    "доротея": 1,
    "ева": 1,
    "евгения": 1,
    "евдокия": 1,
    "евлалия": 1,
    "евлампия": 1,
    "евпраксия": 1,
    "евстолия": 1,
    "евфалия": 1,
    "евфросиния": 1,
    "екатерина": 1,
    "елена": 1,
    "елизавета": 1,
    "еликонида": 1,
    "ермиония": 1,
    "есения": 1,
    "ефимия": 1,
    "евфремия": 1,
    "жанна": 1,
    "ждана": 1,
    "жаннэ": 1,
    "жасмина": 1,
    "забава": 1,
    "заира": 1,
    "зара": 1,
    "зарема": 1,
    "зарина": 1,
    "зорина": 1,
    "заряна": 1,
    "зауре": 1,
    "звенислава": 1,
    "земфира": 1,
    "зиля": 1,
    "зинаида": 1,
    "зиновия": 1,
    "злата": 1,
    "зозан": 1,
    "зоя": 1,
    "зульфия": 1,
    "иванна": 1,
    "ида": 1,
    "илария": 1,
    "илиана": 1,
    "илона": 1,
    "ильмира": 1,
    "инга": 1,
    "индира": 1,
    "инесса": 1,
    "инна": 1,
    "иоанна": 1,
    "иона": 1,
    "ипатия": 1,
    "ипполита": 1,
    "ирада": 1,
    "ираида": 1,
    "ирена": 1,
    "ироида": 1,
    "ираклия": 1,
    "ирина": 1,
    "исидора": 1,
    "искра": 1,
    "ифигения": 1,
    "ия": 1,
    "кадрия": 1,
    "кермен": 1,
    "калиса": 1,
    "каллиста": 1,
    "камилла": 1,
    "камила": 1,
    "капитолина": 1,
    "карина": 1,
    "каролина": 1,
    "катерина": 1,
    "кира": 1,
    "кирилла": 1,
    "клавдия": 1,
    "клара": 1,
    "клариса": 1,
    "кларисса": 1,
    "клеопатра": 1,
    "клио": 1,
    "клер": 1,
    "конкордия": 1,
    "констанция": 1,
    "кристина": 1,
    "ксения": 1,
    "лавиния": 1,
    "лада": 1,
    "лана": 1,
    "лариса": 1,
    "лаура": 1,
    "лейла": 1,
    "лема": 1,
    "лена": 1,
    "лениана": 1,
    "ленина": 1,
    "леонида": 1,
    "леонила": 1,
    "леонтия": 1,
    "леся": 1,
    "ливия": 1,
    "лидия": 1,
    "лилиана": 1,
    "лилия": 1,
    "лилит": 1,
    "лина": 1,
    "лира": 1,
    "лия": 1,
    "лея": 1,
    "лора": 1,
    "луиза": 1,
    "лукерия": 1,
    "лукиана": 1,
    "лукина": 1,
    "люцина": 1,
    "лусинэ": 1,
    "любава": 1,
    "любовь": 1,
    "любомира": 1,
    "людмила": 1,
    "ляля": 1,
    "мавра": 1,
    "магда": 1,
    "магдалина": 1,
    "мадлен": 1,
    "майя": 1,
    "мая": 1,
    "мальвина": 1,
    "маргарита": 1,
    "мариана": 1,
    "марьяна": 1,
    "марианна": 1,
    "мариетта": 1,
    "мариэтта": 1,
    "марика": 1,
    "марина": 1,
    "мария": 1,
    "марья": 1,
    "мари": 1,
    "марлен": 1,
    "марлена": 1,
    "марта": 1,
    "марфа": 1,
    "матильда": 1,
    "матрена": 1,
    "матрёна": 1,
    "матрона": 1,
    "мелания": 1,
    "меланья": 1,
    "мелитина": 1,
    "милада": 1,
    "милана": 1,
    "милен": 1,
    "милица": 1,
    "милия": 1,
    "милослава": 1,
    "мира": 1,
    "мирра": 1,
    "мирослава": 1,
    "митродора": 1,
    "млада": 1,
    "мстислава": 1,
    "нада": 1,
    "надежда": 1,
    "надия": 1,
    "наина": 1,
    "наира": 1,
    "нана": 1,
    "настасья": 1,
    "наталья": 1,
    "наталия": 1,
    "нелли": 1,
    "неонила": 1,
    "ника": 1,
    "нина": 1,
    "нинелла": 1,
    "нинель": 1,
    "новелла": 1,
    "нонна": 1,
    "нора": 1,
    "нуркыз": 1,
    "насиба": 1,
    "оксана": 1,
    "октавия": 1,
    "октябрина": 1,
    "олеся": 1,
    "оливия": 1,
    "олимпиада": 1,
    "олимпия": 1,
    "ольга": 1,
    "офелия": 1,
    "павла": 1,
    "павлина": 1,
    "патриция": 1,
    "пелагея": 1,
    "платонида": 1,
    "поликсена": 1,
    "полина": 1,
    "правдина": 1,
    "прасковья": 1,
    "пенелопа": 1,
    "полислава": 1,
    "рада": 1,
    "радмила": 1,
    "раиса": 1,
    "раймонда": 1,
    "раялла": 1,
    "ревмира": 1,
    "регина": 1,
    "рената": 1,
    "римма": 1,
    "рогнеда": 1,
    "роза": 1,
    "розалина": 1,
    "розалия": 1,
    "розана": 1,
    "роксан": 1,
    "ростислава": 1,
    "руслана": 1,
    "руфина": 1,
    "руфь": 1,
    "раида": 1,
    "сабина": 1,
    "сабрина": 1,
    "саломея": 1,
    "соломея": 1,
    "самира": 1,
    "светлана": 1,
    "светозара": 1,
    "светослава": 1,
    "свобода": 1,
    "святослава": 1,
    "севастьяна": 1,
    "северина": 1,
    "селена": 1,
    "селина": 1,
    "селестина": 1,
    "серафима": 1,
    "сергияна": 1,
    "сильва": 1,
    "агриппина": 1,
    "алёна": 1,
    "вилора": 1,
    "вилория": 1,
    "джульетта": 1,
    "диана": 1,
    "евфимия": 1,
    "ефросиния": 1,
    "калерия": 1,
    "милена": 1,
    "муза": 1,
    "савина": 1,
    "сильвия": 1,
    "симона": 1,
    "слава": 1,
    "славяна": 1,
    "снежана": 1,
    "софья": 1,
    "софия": 1,
    "станислава": 1,
    "стелла": 1,
    "степанида": 1,
    "стефанида": 1,
    "стефания": 1,
    "сусанна": 1,
    "сосанна": 1,
    "сюзанна": 1,
    "таира": 1,
    "таисия": 1,
    "тальяна": 1,
    "тамара": 1,
    "тамила": 1,
    "томила": 1,
    "татьяна": 1,
    "текуса": 1,
    "тереза": 1,
    "улита": 1,
    "ульяна": 1,
    "услада": 1,
    "устинья": 1,
    "фаина": 1,
    "февронья": 1,
    "феликсана": 1,
    "фелицата": 1,
    "фелицитата": 1,
    "фелиция": 1,
    "федора": 1,
    "феодора": 1,
    "феодосия": 1,
    "феодосья": 1,
    "феоктиста": 1,
    "феофания": 1,
    "феона": 1,
    "флавия": 1,
    "флора": 1,
    "флория": 1,
    "флорентина": 1,
    "флоренция": 1,
    "флориана": 1,
    "фотина": 1,
    "харита": 1,
    "харитина": 1,
    "хиония": 1,
    "христина": 1,
    "цецилия": 1,
    "чеслава": 1,
    "эвелина": 1,
    "эвридика": 1,
    "эдда": 1,
    "элеонора": 1,
    "элина": 1,
    "эльвира": 1,
    "эльмира": 1,
    "эльза": 1,
    "эмилия": 1,
    "эмма": 1,
    "эрика": 1,
    "эсфирь": 1,
    "юдифь": 1,
    "юзефа": 1,
    "юлиана": 1,
    "юлитта": 1,
    "юлия": 1,
    "юманита": 1,
    "юния": 1,
    "юнона": 1,
    "юстина": 1,
    "ядвига": 1,
    "яна": 1,
    "янина": 1,
    "яромира": 1,
    "ярослава": 1
  }, exports.ruMaleNamesDict = {
    "ааран": 1,
    "аарен": 1,
    "ааррон": 1,
    "аб": 1,
    "аббат": 1,
    "абботт": 1,
    "абей": 1,
    "абелл": 1,
    "абель": 1,
    "абнар": 1,
    "абнер": 1,
    "абнор": 1,
    "абот": 1,
    "аботт": 1,
    "абрам": 1,
    "абран": 1,
    "абрахам": 1,
    "абсалон": 1,
    "авангард": 1,
    "август": 1,
    "августин": 1,
    "авдей": 1,
    "авдий": 1,
    "авенир": 1,
    "аверилл": 1,
    "аверкий": 1,
    "авксентий": 1,
    "аврам": 1,
    "аврор": 1,
    "аврорий": 1,
    "агап": 1,
    "аггей": 1,
    "агей": 1,
    "адам": 1,
    "аддам": 1,
    "аддисон": 1,
    "аден": 1,
    "адий": 1,
    "адисон": 1,
    "адиссон": 1,
    "адлэй": 1,
    "адней": 1,
    "адольф": 1,
    "адонис": 1,
    "адриан": 1,
    "адэйр": 1,
    "адэр": 1,
    "азия": 1,
    "азэлстан": 1,
    "айбл": 1,
    "айзек": 1,
    "айк": 1,
    "ак": 1,
    "акей": 1,
    "акерлеа": 1,
    "акерлей": 1,
    "акерли": 1,
    "аки": 1,
    "аким": 1,
    "аклеа": 1,
    "аклей": 1,
    "акли": 1,
    "аксён": 1,
    "актон": 1,
    "акэль": 1,
    "алан": 1,
    "аластеир": 1,
    "аластэйр": 1,
    "алвар": 1,
    "алвен": 1,
    "алви": 1,
    "алвин": 1,
    "алвис": 1,
    "алгар": 1,
    "алджернон": 1,
    "алевтин": 1,
    "алеистер": 1,
    "алек": 1,
    "алекс": 1,
    "александр": 1,
    "алексей": 1,
    "ален": 1,
    "алестер": 1,
    "алжир": 1,
    "алик": 1,
    "аликс": 1,
    "алим": 1,
    "алисандр": 1,
    "алисдэйр": 1,
    "алиссандр": 1,
    "алистер": 1,
    "алистэйр": 1,
    "аллан": 1,
    "аллен": 1,
    "аллин": 1,
    "аллистер": 1,
    "аллистир": 1,
    "аллистэйр": 1,
    "алтон": 1,
    "алф": 1,
    "алфонзо": 1,
    "алфорд": 1,
    "алфрид": 1,
    "альберт": 1,
    "альбин": 1,
    "альвиан": 1,
    "альвин": 1,
    "альдина": 1,
    "альпин": 1,
    "альтаир": 1,
    "альфа": 1,
    "альфи": 1,
    "альфред": 1,
    "алэйстер": 1,
    "алэйстэйр": 1,
    "амби": 1,
    "амброуз": 1,
    "амедеус": 1,
    "амиас": 1,
    "амори": 1,
    "амос": 1,
    "амьяс": 1,
    "анакин": 1,
    "ананий": 1,
    "анастасий": 1,
    "анатолий": 1,
    "анвар": 1,
    "ангел": 1,
    "ангес": 1,
    "андерсон": 1,
    "анджелл": 1,
    "андрей": 1,
    "андреян": 1,
    "андриан": 1,
    "андрон": 1,
    "анж": 1,
    "анис": 1,
    "анисий": 1,
    "анисим": 1,
    "анри": 1,
    "анском": 1,
    "анскомб": 1,
    "ансон": 1,
    "антван": 1,
    "антип": 1,
    "антон": 1,
    "антоний": 1,
    "антонин": 1,
    "антуан": 1,
    "аполлинарий": 1,
    "аполлон": 1,
    "арам": 1,
    "арвид": 1,
    "аргент": 1,
    "арден": 1,
    "арефий": 1,
    "арий": 1,
    "арик": 1,
    "арил": 1,
    "арин": 1,
    "аристарх": 1,
    "аркадий": 1,
    "аркелл": 1,
    "арлен": 1,
    "арли": 1,
    "арман": 1,
    "армен": 1,
    "арн": 1,
    "арне": 1,
    "арни": 1,
    "арнольд": 1,
    "арран": 1,
    "аррин": 1,
    "аррон": 1,
    "арсен": 1,
    "арсений": 1,
    "арт": 1,
    "артамон": 1,
    "артемий": 1,
    "арти": 1,
    "артур": 1,
    "артём": 1,
    "архип": 1,
    "арчи": 1,
    "арчибальд": 1,
    "аселет": 1,
    "аселин": 1,
    "асер": 1,
    "аскольд": 1,
    "астон": 1,
    "атеист": 1,
    "афанасий": 1,
    "афиноген": 1,
    "афтон": 1,
    "аффтон": 1,
    "ахмат": 1,
    "ахмет": 1,
    "ачилл": 1,
    "аш": 1,
    "ашер": 1,
    "ашот": 1,
    "аштон": 1,
    "баграт": 1,
    "бад": 1,
    "бадди": 1,
    "бажен": 1,
    "баз": 1,
    "базилик": 1,
    "байрон": 1,
    "байярд": 1,
    "бак": 1,
    "бакстер": 1,
    "балдер": 1,
    "балдрик": 1,
    "бамби": 1,
    "баптист": 1,
    "бардолф": 1,
    "барии": 1,
    "барклей": 1,
    "барнабас": 1,
    "барни": 1,
    "барнэби": 1,
    "барретт": 1,
    "барри": 1,
    "барт": 1,
    "бартоломей": 1,
    "бассетт": 1,
    "бастер": 1,
    "бастиан": 1,
    "батч": 1,
    "баян": 1,
    "беван": 1,
    "беверли": 1,
    "бевис": 1,
    "бедивир": 1,
    "бейб": 1,
    "бейлей": 1,
    "бейлие": 1,
    "бен": 1,
    "бенджамин": 1,
    "бенджи": 1,
    "бенедикт": 1,
    "бенет": 1,
    "беннетт": 1,
    "бенни": 1,
    "бенние": 1,
    "бенсон": 1,
    "бентлей": 1,
    "бентон": 1,
    "беорегард": 1,
    "бердт": 1,
    "беренгар": 1,
    "беренджер": 1,
    "берет": 1,
    "бернард": 1,
    "берни": 1,
    "берри": 1,
    "берт": 1,
    "берти": 1,
    "бертольд": 1,
    "бертон": 1,
    "бертрам": 1,
    "бертран": 1,
    "бивис": 1,
    "билл": 1,
    "билли": 1,
    "бисш": 1,
    "биф": 1,
    "блейн": 1,
    "близэ": 1,
    "блисс": 1,
    "блэйз": 1,
    "блэйк": 1,
    "блэйн": 1,
    "блэр": 1,
    "боб": 1,
    "бобби": 1,
    "богдан": 1,
    "боеслав": 1,
    "болдуин": 1,
    "болеслав": 1,
    "боллард": 1,
    "бомонт": 1,
    "бонифэйс": 1,
    "боримир": 1,
    "борис": 1,
    "борислав": 1,
    "боян": 1,
    "брадлей": 1,
    "браеден": 1,
    "брайен": 1,
    "брайон": 1,
    "бранден": 1,
    "брандон": 1,
    "браннон": 1,
    "брейден": 1,
    "брейдн": 1,
    "брендан": 1,
    "бренден": 1,
    "брендон": 1,
    "бреннан": 1,
    "брент": 1,
    "брентон": 1,
    "брет": 1,
    "бретт": 1,
    "бриар": 1,
    "брион": 1,
    "брис": 1,
    "бриско": 1,
    "бриттон": 1,
    "бриэм": 1,
    "бродерик": 1,
    "броди": 1,
    "броз": 1,
    "брок": 1,
    "бронислав": 1,
    "бронт": 1,
    "броуди": 1,
    "броук": 1,
    "брук": 1,
    "брукс": 1,
    "бруно": 1,
    "брутус": 1,
    "брьянт": 1,
    "брэд": 1,
    "брэди": 1,
    "брэдфорд": 1,
    "брэйден": 1,
    "брэйди": 1,
    "брэм": 1,
    "брэн": 1,
    "брюс": 1,
    "брююс": 1,
    "будимир": 1,
    "буз": 1,
    "букер": 1,
    "булат": 1,
    "бью": 1,
    "бэйли": 1,
    "вавила": 1,
    "вадим": 1,
    "вал": 1,
    "валентайн": 1,
    "валентин": 1,
    "валериан": 1,
    "валерий": 1,
    "валерьян": 1,
    "вальдемар": 1,
    "вальтер": 1,
    "ванадий": 1,
    "вард": 1,
    "варлаам": 1,
    "варлам": 1,
    "варлен": 1,
    "вартан": 1,
    "варфоломей": 1,
    "василий": 1,
    "василько": 1,
    "ваухан": 1,
    "вахтанг": 1,
    "вацлав": 1,
    "вашингтон": 1,
    "вебстер": 1,
    "велдон": 1,
    "велимир": 1,
    "велислав": 1,
    "велор": 1,
    "велорий": 1,
    "венедикт": 1,
    "вениамин": 1,
    "вер": 1,
    "вергилий": 1,
    "верджил": 1,
    "верн": 1,
    "вернон": 1,
    "вестер": 1,
    "вестлей": 1,
    "вестон": 1,
    "вик": 1,
    "викентий": 1,
    "виктор": 1,
    "вил": 1,
    "вилберн": 1,
    "вилей": 1,
    "вилен": 1,
    "вилий": 1,
    "вилиор": 1,
    "вилки": 1,
    "вилл": 1,
    "вилли": 1,
    "виллоби": 1,
    "вилмар": 1,
    "вилмер": 1,
    "вилмот": 1,
    "вилор": 1,
    "вилорг": 1,
    "вилорий": 1,
    "вилсон": 1,
    "вилф": 1,
    "вилфорд": 1,
    "виль": 1,
    "вильгельм": 1,
    "вильтон": 1,
    "вильям": 1,
    "вин": 1,
    "виндзор": 1,
    "винни": 1,
    "винс": 1,
    "винсент": 1,
    "винслоу": 1,
    "винтроп": 1,
    "винцент": 1,
    "виолен": 1,
    "вирджиль": 1,
    "виссарион": 1,
    "вистан": 1,
    "виталий": 1,
    "витейкр": 1,
    "витней": 1,
    "витольд": 1,
    "влад": 1,
    "владелин": 1,
    "владилен": 1,
    "владимир": 1,
    "владислав": 1,
    "владлен": 1,
    "влас": 1,
    "власий": 1,
    "воган": 1,
    "вогн": 1,
    "воин": 1,
    "воислав": 1,
    "волдо": 1,
    "волемир": 1,
    "волкер": 1,
    "воллис": 1,
    "володар": 1,
    "вольдемар": 1,
    "вольмир": 1,
    "вольт": 1,
    "вольф": 1,
    "вольфрам": 1,
    "воспой": 1,
    "всеволод": 1,
    "всемил": 1,
    "вуди": 1,
    "вудроу": 1,
    "вулф": 1,
    "вьятт": 1,
    "вэйд": 1,
    "вэйланд": 1,
    "вэнс": 1,
    "вячеслав": 1,
    "габби": 1,
    "габриель": 1,
    "габриэль": 1,
    "гавриил": 1,
    "гаврил": 1,
    "гаврила": 1,
    "гаврило": 1,
    "гай": 1,
    "гайдар": 1,
    "гайлс": 1,
    "галактион": 1,
    "гален": 1,
    "галий": 1,
    "гамильтон": 1,
    "гамлет": 1,
    "гантэр": 1,
    "гаральд": 1,
    "гарван": 1,
    "гарей": 1,
    "гарибальди": 1,
    "гарланд": 1,
    "гарнет": 1,
    "гарольд": 1,
    "гарри": 1,
    "гаррий": 1,
    "гарс": 1,
    "гарфилд": 1,
    "гас": 1,
    "гаспар": 1,
    "гваделупа": 1,
    "гвидон": 1,
    "гейб": 1,
    "гейл": 1,
    "гейр": 1,
    "гектор": 1,
    "гелеон": 1,
    "гелиан": 1,
    "гелий": 1,
    "ген": 1,
    "гений": 1,
    "геннадий": 1,
    "генри": 1,
    "генрих": 1,
    "геодар": 1,
    "георгий": 1,
    "геральд": 1,
    "герасим": 1,
    "герберт": 1,
    "герман": 1,
    "гермоген": 1,
    "герольд": 1,
    "геронт": 1,
    "геронтий": 1,
    "герт": 1,
    "гертруд": 1,
    "гидеон": 1,
    "гильберт": 1,
    "гисберт": 1,
    "гладвин": 1,
    "гланвилл": 1,
    "глеб": 1,
    "глендауэр": 1,
    "гленн": 1,
    "глэн": 1,
    "говард": 1,
    "годвин": 1,
    "годфри": 1,
    "голлагэр": 1,
    "голладжер": 1,
    "гомер": 1,
    "горазд": 1,
    "гораций": 1,
    "горд": 1,
    "гордей": 1,
    "горден": 1,
    "гордий": 1,
    "гордон": 1,
    "горимир": 1,
    "горислав": 1,
    "горн": 1,
    "граем": 1,
    "грай": 1,
    "гранвилл": 1,
    "гранд": 1,
    "гранит": 1,
    "грахэйм": 1,
    "грег": 1,
    "грей": 1,
    "гренвилл": 1,
    "григорий": 1,
    "гриир": 1,
    "грир": 1,
    "гриффин": 1,
    "гриффит": 1,
    "гровер": 1,
    "грэг": 1,
    "грэгори": 1,
    "грэди": 1,
    "грэм": 1,
    "гудвин": 1,
    "гудзон": 1,
    "гурий": 1,
    "густав": 1,
    "гэй": 1,
    "гэйбл": 1,
    "гэйг": 1,
    "гэйдж": 1,
    "гэйелорд": 1,
    "гэйл": 1,
    "гэйлон": 1,
    "гэйлорд": 1,
    "гэйр": 1,
    "гэлл": 1,
    "гэри": 1,
    "давей": 1,
    "дави": 1,
    "давид": 1,
    "давыд": 1,
    "дад": 1,
    "дадда": 1,
    "дадли": 1,
    "даймонд": 1,
    "дакей": 1,
    "дакота": 1,
    "дакс": 1,
    "далтон": 1,
    "дамайон": 1,
    "дамиан": 1,
    "дамир": 1,
    "дан": 1,
    "дана": 1,
    "дани": 1,
    "даниар": 1,
    "даниил": 1,
    "данил": 1,
    "данила": 1,
    "данило": 1,
    "даниэль": 1,
    "данки": 1,
    "данни": 1,
    "дар": 1,
    "дарби": 1,
    "дарвин": 1,
    "дарден": 1,
    "дарен": 1,
    "дариан": 1,
    "дарил": 1,
    "дарин": 1,
    "дарки": 1,
    "дарнелл": 1,
    "даррел": 1,
    "даррен": 1,
    "даррил": 1,
    "даррин": 1,
    "даррэль": 1,
    "дасти": 1,
    "дастин": 1,
    "дау": 1,
    "дафф": 1,
    "даффи": 1,
    "дашилл": 1,
    "дван": 1,
    "двэйн": 1,
    "деай": 1,
    "деван": 1,
    "девен": 1,
    "девереукс": 1,
    "девин": 1,
    "девон": 1,
    "дейв": 1,
    "дейл": 1,
    "дейрлл": 1,
    "дейрн": 1,
    "декабрий": 1,
    "деклан": 1,
    "декстер": 1,
    "делберт": 1,
    "делл": 1,
    "делмар": 1,
    "делрой": 1,
    "дементий": 1,
    "деметриус": 1,
    "демид": 1,
    "демократ": 1,
    "демон": 1,
    "демьян": 1,
    "ден": 1,
    "денвер": 1,
    "денеб": 1,
    "дензэль": 1,
    "дени": 1,
    "денил": 1,
    "денис": 1,
    "деннис": 1,
    "дентон": 1,
    "деон": 1,
    "деонн": 1,
    "деонт": 1,
    "дерби": 1,
    "дерек": 1,
    "дерик": 1,
    "дермот": 1,
    "дерок": 1,
    "деррен": 1,
    "дерри": 1,
    "деррил": 1,
    "дефорест": 1,
    "дефоррест": 1,
    "дешон": 1,
    "джадд": 1,
    "джадин": 1,
    "джай": 1,
    "джайлс": 1,
    "джак": 1,
    "джамар": 1,
    "джамей": 1,
    "джамисон": 1,
    "джарвис": 1,
    "джаред": 1,
    "джарод": 1,
    "джарред": 1,
    "джарретт": 1,
    "джаррод": 1,
    "джаспер": 1,
    "джасти": 1,
    "джастин": 1,
    "джеб": 1,
    "джед": 1,
    "джедидиа": 1,
    "джейдн": 1,
    "джейк": 1,
    "джейлн": 1,
    "джейми": 1,
    "джеймс": 1,
    "джейрт": 1,
    "джейсон": 1,
    "джекки": 1,
    "джекоб": 1,
    "джем": 1,
    "дженкин": 1,
    "джеп": 1,
    "джер": 1,
    "джералд": 1,
    "джеральд": 1,
    "джерард": 1,
    "джерваз": 1,
    "джервис": 1,
    "джереми": 1,
    "джери": 1,
    "джермэйн": 1,
    "джеролд": 1,
    "джером": 1,
    "джеррард": 1,
    "джерред": 1,
    "джерри": 1,
    "джеррод": 1,
    "джерролд": 1,
    "джес": 1,
    "джесси": 1,
    "джетро": 1,
    "джетт": 1,
    "джеф": 1,
    "джеффери": 1,
    "джефферсон": 1,
    "джеффрей": 1,
    "джеффри": 1,
    "джиб": 1,
    "джид": 1,
    "джиди": 1,
    "джил": 1,
    "джим": 1,
    "джими": 1,
    "джимми": 1,
    "джисберт": 1,
    "джиффард": 1,
    "джо": 1,
    "джоб": 1,
    "джоби": 1,
    "джоджо": 1,
    "джоди": 1,
    "джозеф": 1,
    "джой": 1,
    "джойс": 1,
    "джон": 1,
    "джоназан": 1,
    "джоназон": 1,
    "джонасон": 1,
    "джонатан": 1,
    "джоней": 1,
    "джони": 1,
    "джонни": 1,
    "джонти": 1,
    "джорги": 1,
    "джордан": 1,
    "джордж": 1,
    "джорди": 1,
    "джордон": 1,
    "джосс": 1,
    "джоул": 1,
    "джош": 1,
    "джошоа": 1,
    "джошуа": 1,
    "джулс": 1,
    "джульян": 1,
    "джустис": 1,
    "джьюд": 1,
    "джэй": 1,
    "джэйд": 1,
    "джэйда": 1,
    "джэйден": 1,
    "джэйдон": 1,
    "джэйкоб": 1,
    "джэйлен": 1,
    "джэйлин": 1,
    "джэйлон": 1,
    "джэймес": 1,
    "джэйсон": 1,
    "джэксон": 1,
    "джэмини": 1,
    "джэмми": 1,
    "джэн": 1,
    "ди": 1,
    "диакон": 1,
    "дигби": 1,
    "диггори": 1,
    "дигори": 1,
    "дидим": 1,
    "дизон": 1,
    "дик": 1,
    "дики": 1,
    "дикки": 1,
    "дил": 1,
    "дилан": 1,
    "дилберт": 1,
    "димер": 1,
    "димитрий": 1,
    "дин": 1,
    "диндр": 1,
    "дионис": 1,
    "дионисий": 1,
    "дирк": 1,
    "дмитрий": 1,
    "доб": 1,
    "добрыня": 1,
    "додж": 1,
    "дольф": 1,
    "дом": 1,
    "доменик": 1,
    "доминик": 1,
    "дон": 1,
    "дональд": 1,
    "дональт": 1,
    "донат": 1,
    "донни": 1,
    "донован": 1,
    "дор": 1,
    "дориан": 1,
    "дорофей": 1,
    "доусон": 1,
    "драйк": 1,
    "древ": 1,
    "дрейвн": 1,
    "дуайт": 1,
    "дуан": 1,
    "дуг": 1,
    "дуги": 1,
    "дуглас": 1,
    "дункан": 1,
    "дунстан": 1,
    "дью": 1,
    "дьюей": 1,
    "дьюэйн": 1,
    "дэвид": 1,
    "дэвис": 1,
    "дэй": 1,
    "дэйви": 1,
    "дэйн": 1,
    "дэйтон": 1,
    "дэн": 1,
    "дэни": 1,
    "дэниел": 1,
    "дэнни": 1,
    "дэррик": 1,
    "дэшон": 1,
    "дюк": 1,
    "евгений": 1,
    "евграф": 1,
    "евдоким": 1,
    "евлампий": 1,
    "евлогий": 1,
    "евсей": 1,
    "евстафий": 1,
    "егор": 1,
    "елеазар": 1,
    "елизар": 1,
    "елисей": 1,
    "емельян": 1,
    "епифан": 1,
    "еремей": 1,
    "ермак": 1,
    "ермил": 1,
    "ермолай": 1,
    "ерофей": 1,
    "еруслан": 1,
    "ефим": 1,
    "ефрем": 1,
    "ждан": 1,
    "жерар": 1,
    "жозеф": 1,
    "жорес": 1,
    "жюль": 1,
    "завир": 1,
    "зак": 1,
    "закери": 1,
    "зандер": 1,
    "захар": 1,
    "захарий": 1,
    "зачариа": 1,
    "зачэри": 1,
    "зед": 1,
    "зедекиа": 1,
    "зек": 1,
    "зигмунд": 1,
    "зигфрид": 1,
    "зиновий": 1,
    "зорий": 1,
    "зосим": 1,
    "зосима": 1,
    "зот": 1,
    "зубин": 1,
    "зэофилус": 1,
    "иб": 1,
    "ибрагим": 1,
    "иван": 1,
    "игнат": 1,
    "игнатий": 1,
    "игнатиус": 1,
    "игорь": 1,
    "ид": 1,
    "иероним": 1,
    "иззи": 1,
    "изидор": 1,
    "измаил": 1,
    "измайло": 1,
    "изяслав": 1,
    "ий": 1,
    "икар": 1,
    "илар": 1,
    "иларий": 1,
    "иларион": 1,
    "илий": 1,
    "илиодор": 1,
    "илларион": 1,
    "илья": 1,
    "имон": 1,
    "инглеберт": 1,
    "инграм": 1,
    "инди": 1,
    "индиана": 1,
    "индиго": 1,
    "инесент": 1,
    "иниго": 1,
    "иннокентий": 1,
    "иоанн": 1,
    "иорик": 1,
    "иосиф": 1,
    "ипат": 1,
    "ипатий": 1,
    "ипполит": 1,
    "ираклий": 1,
    "ирвайн": 1,
    "ирвин": 1,
    "ирвинг": 1,
    "ириней": 1,
    "ириний": 1,
    "ирл": 1,
    "ирм": 1,
    "ирнест": 1,
    "исай": 1,
    "исайя": 1,
    "исак": 1,
    "исакий": 1,
    "исей": 1,
    "исидор": 1,
    "иссак": 1,
    "исси": 1,
    "истер": 1,
    "июлий": 1,
    "йорк": 1,
    "ка": 1,
    "кадмус": 1,
    "казимир": 1,
    "каин": 1,
    "каир": 1,
    "кайд": 1,
    "кайл": 1,
    "кал": 1,
    "калин": 1,
    "калина": 1,
    "каллен": 1,
    "кам": 1,
    "камден": 1,
    "камиль": 1,
    "камрон": 1,
    "капитон": 1,
    "карбрей": 1,
    "карбри": 1,
    "карвер": 1,
    "карей": 1,
    "карен": 1,
    "карл": 1,
    "карлайл": 1,
    "карлейл": 1,
    "карлин": 1,
    "карлтон": 1,
    "карм": 1,
    "кармий": 1,
    "карп": 1,
    "каррол": 1,
    "картер": 1,
    "касиди": 1,
    "каспар": 1,
    "каспер": 1,
    "кассиди": 1,
    "касьян": 1,
    "квентин": 1,
    "квинтин": 1,
    "кеван": 1,
    "кевин": 1,
    "кей": 1,
    "кейденс": 1,
    "кейдн": 1,
    "кейлб": 1,
    "кеймрон": 1,
    "кейси": 1,
    "келвин": 1,
    "келкей": 1,
    "келл": 1,
    "келли": 1,
    "келсей": 1,
    "кемп": 1,
    "кен": 1,
    "кендал": 1,
    "кендол": 1,
    "кендрик": 1,
    "кенелм": 1,
    "кензи": 1,
    "кенит": 1,
    "кеннеди": 1,
    "кеннет": 1,
    "кенни": 1,
    "кеннит": 1,
    "кенрик": 1,
    "кент": 1,
    "кентиджерн": 1,
    "кентон": 1,
    "кермит": 1,
    "керней": 1,
    "керр": 1,
    "керри": 1,
    "керт": 1,
    "кертис": 1,
    "кешон": 1,
    "ки": 1,
    "киаран": 1,
    "килан": 1,
    "килер": 1,
    "килиан": 1,
    "киллиан": 1,
    "ким": 1,
    "кимбелайн": 1,
    "кимберли": 1,
    "кимбол": 1,
    "кимбэль": 1,
    "кин": 1,
    "кинан": 1,
    "кинастон": 1,
    "кинг": 1,
    "кингслей": 1,
    "кип": 1,
    "киприан": 1,
    "кир": 1,
    "киран": 1,
    "кирби": 1,
    "кирилл": 1,
    "кирк": 1,
    "кирон": 1,
    "кирус": 1,
    "кит": 1,
    "китон": 1,
    "киф": 1,
    "клавдий": 1,
    "клайв": 1,
    "клайд": 1,
    "кланкей": 1,
    "кланки": 1,
    "кларенс": 1,
    "кларк": 1,
    "клев": 1,
    "клей": 1,
    "клейтон": 1,
    "клем": 1,
    "клемент": 1,
    "клементий": 1,
    "клемми": 1,
    "клетис": 1,
    "клетус": 1,
    "кливленд": 1,
    "клим": 1,
    "климент": 1,
    "климентий": 1,
    "клинт": 1,
    "клинтон": 1,
    "клифтон": 1,
    "клифф": 1,
    "клиффорд": 1,
    "клод": 1,
    "клэйрк": 1,
    "клэр": 1,
    "кодей": 1,
    "коди": 1,
    "коертней": 1,
    "козьма": 1,
    "кола": 1,
    "коламбан": 1,
    "колберт": 1,
    "колби": 1,
    "колдер": 1,
    "колин": 1,
    "коллахан": 1,
    "коллин": 1,
    "коллум": 1,
    "колтен": 1,
    "колтон": 1,
    "колумбий": 1,
    "кольт": 1,
    "конан": 1,
    "конвей": 1,
    "кондрат": 1,
    "кондратий": 1,
    "конлей": 1,
    "коннелл": 1,
    "коннер": 1,
    "коннор": 1,
    "конон": 1,
    "конор": 1,
    "конрад": 1,
    "константин": 1,
    "конфуций": 1,
    "корбин": 1,
    "корделл": 1,
    "корей": 1,
    "кори": 1,
    "корней": 1,
    "корнелий": 1,
    "корнелиус": 1,
    "корнил": 1,
    "кортней": 1,
    "кортни": 1,
    "корэй": 1,
    "коти": 1,
    "коул": 1,
    "коулман": 1,
    "краснослав": 1,
    "крис": 1,
    "криспиан": 1,
    "криспин": 1,
    "кристи": 1,
    "кристиан": 1,
    "кристопэр": 1,
    "кристоф": 1,
    "кристофер": 1,
    "крофорд": 1,
    "крофтон": 1,
    "крэйг": 1,
    "ксавайор": 1,
    "ксавьер": 1,
    "ксан": 1,
    "ксенофонт": 1,
    "ксзавир": 1,
    "кузьма": 1,
    "куин": 1,
    "куинкей": 1,
    "куинси": 1,
    "куинтон": 1,
    "купер": 1,
    "куприян": 1,
    "курт": 1,
    "куртис": 1,
    "кэйд": 1,
    "кэйдн": 1,
    "кэйл": 1,
    "кэйлб": 1,
    "кэймрон": 1,
    "кэйн": 1,
    "кэйси": 1,
    "кэлвин": 1,
    "кэм": 1,
    "кэмп": 1,
    "кэмпбэл": 1,
    "кэри": 1,
    "кюри": 1,
    "лаверн": 1,
    "лавлл": 1,
    "лавр": 1,
    "лаврентий": 1,
    "лаз": 1,
    "лазарь": 1,
    "лайл": 1,
    "лайонел": 1,
    "лаки": 1,
    "ланни": 1,
    "ланфорд": 1,
    "ларион": 1,
    "ларк": 1,
    "ларкин": 1,
    "ларри": 1,
    "лаэрт": 1,
    "лев": 1,
    "леви": 1,
    "левкий": 1,
    "лейврн": 1,
    "лейн": 1,
    "лейтон": 1,
    "лекс": 1,
    "леланд": 1,
    "лель": 1,
    "лем": 1,
    "лемми": 1,
    "лемюэль": 1,
    "лен": 1,
    "ленар": 1,
    "ленард": 1,
    "лени": 1,
    "лениан": 1,
    "леннард": 1,
    "ленни": 1,
    "лео": 1,
    "леон": 1,
    "леонард": 1,
    "леонид": 1,
    "леонтий": 1,
    "леопольд": 1,
    "лермонт": 1,
    "лерой": 1,
    "лес": 1,
    "лесли": 1,
    "лестер": 1,
    "ли": 1,
    "либерт": 1,
    "ливадий": 1,
    "лии": 1,
    "лин": 1,
    "линдон": 1,
    "линдсей": 1,
    "линдси": 1,
    "линкольн": 1,
    "линн": 1,
    "линсей": 1,
    "линтон": 1,
    "линус": 1,
    "линфорд": 1,
    "лионель": 1,
    "лир": 1,
    "лирой": 1,
    "лисандр": 1,
    "литон": 1,
    "лихнис": 1,
    "ллойд": 1,
    "ллью": 1,
    "лльюелин": 1,
    "лльюеллин": 1,
    "ло": 1,
    "ловэль": 1,
    "лойд": 1,
    "лон": 1,
    "лондон": 1,
    "лонни": 1,
    "лонс": 1,
    "лор": 1,
    "лорен": 1,
    "лоренс": 1,
    "лори": 1,
    "лорин": 1,
    "лорис": 1,
    "лорни": 1,
    "лоррин": 1,
    "лосон": 1,
    "лоуэлл": 1,
    "лоэнгрин": 1,
    "лу": 1,
    "лудо": 1,
    "луи": 1,
    "лука": 1,
    "лукиан": 1,
    "лукьян": 1,
    "льюин": 1,
    "льюис": 1,
    "лэйк": 1,
    "лэйн": 1,
    "лэйтон": 1,
    "лэндон": 1,
    "лэнс": 1,
    "лэрри": 1,
    "любим": 1,
    "любомир": 1,
    "людвиг": 1,
    "людовик": 1,
    "люк": 1,
    "люкс": 1,
    "люксен": 1,
    "люсьен": 1,
    "лютер": 1,
    "люциан": 1,
    "маверик": 1,
    "маврикий": 1,
    "мадисон": 1,
    "маеслав": 1,
    "май": 1,
    "майк": 1,
    "майкл": 1,
    "майлз": 1,
    "майрон": 1,
    "майслав": 1,
    "макар": 1,
    "макарий": 1,
    "макей": 1,
    "макензи": 1,
    "маки": 1,
    "макинтош": 1,
    "маккензи": 1,
    "макс": 1,
    "максвелл": 1,
    "максим": 1,
    "максимилиан": 1,
    "максимиллиан": 1,
    "максимильян": 1,
    "малачи": 1,
    "малком": 1,
    "малоун": 1,
    "манлей": 1,
    "манни": 1,
    "манникс": 1,
    "мануил": 1,
    "мануйло": 1,
    "манфред": 1,
    "марат": 1,
    "марвин": 1,
    "мариан": 1,
    "марин": 1,
    "мариус": 1,
    "марк": 1,
    "марка": 1,
    "маркел": 1,
    "маркиан": 1,
    "марко": 1,
    "маркус": 1,
    "марлен": 1,
    "марлин": 1,
    "марлон": 1,
    "марлоу": 1,
    "мармадьюк": 1,
    "марри": 1,
    "марс": 1,
    "марсен": 1,
    "марти": 1,
    "мартиал": 1,
    "мартин": 1,
    "мартын": 1,
    "маршал": 1,
    "маршалл": 1,
    "марьян": 1,
    "масон": 1,
    "мастерман": 1,
    "матвей": 1,
    "матти": 1,
    "мед": 1,
    "мелвилль": 1,
    "мелвин": 1,
    "мельбурн": 1,
    "мерв": 1,
    "мервин": 1,
    "мерди": 1,
    "мердо": 1,
    "мердок": 1,
    "мередит": 1,
    "мерит": 1,
    "меркурий": 1,
    "мерл": 1,
    "мерлин": 1,
    "меррилл": 1,
    "мерритт": 1,
    "мертон": 1,
    "мерфи": 1,
    "мефодий": 1,
    "мечеслав": 1,
    "мечислав": 1,
    "мид": 1,
    "миид": 1,
    "мик": 1,
    "мика": 1,
    "мики": 1,
    "микки": 1,
    "милад": 1,
    "милан": 1,
    "милберн": 1,
    "милен": 1,
    "милий": 1,
    "миллард": 1,
    "мило": 1,
    "милонег": 1,
    "милослав": 1,
    "милтон": 1,
    "милфорд": 1,
    "мир": 1,
    "мирон": 1,
    "мирослав": 1,
    "митчелл": 1,
    "михаил": 1,
    "михайло": 1,
    "мич": 1,
    "мича": 1,
    "мичил": 1,
    "мо": 1,
    "модест": 1,
    "моз": 1,
    "моисей": 1,
    "молком": 1,
    "монолит": 1,
    "монро": 1,
    "монтагью": 1,
    "монтгомери": 1,
    "монте": 1,
    "монти": 1,
    "монтморенки": 1,
    "морган": 1,
    "морген": 1,
    "мордекэй": 1,
    "морис": 1,
    "морлей": 1,
    "моррис": 1,
    "морт": 1,
    "морти": 1,
    "мортимер": 1,
    "мортон": 1,
    "мосс": 1,
    "моэ": 1,
    "мстислав": 1,
    "мулава": 1,
    "мурат": 1,
    "мэйнард": 1,
    "мэйнерд": 1,
    "мэйор": 1,
    "мэйсон": 1,
    "мэйтланд": 1,
    "мэлори": 1,
    "мэль": 1,
    "мэриан": 1,
    "мэрион": 1,
    "мэт": 1,
    "мэтт": 1,
    "мэтти": 1,
    "мэтью": 1,
    "мюд": 1,
    "надир": 1,
    "назаниль": 1,
    "назар": 1,
    "назарий": 1,
    "назим": 1,
    "найджел": 1,
    "найлс": 1,
    "наль": 1,
    "нанди": 1,
    "нат": 1,
    "натан": 1,
    "наум": 1,
    "науэлл": 1,
    "наш": 1,
    "невада": 1,
    "неван": 1,
    "невил": 1,
    "невилл": 1,
    "нед": 1,
    "нейл": 1,
    "нейлл": 1,
    "нейт": 1,
    "нельсон": 1,
    "нео": 1,
    "неон": 1,
    "неонил": 1,
    "нестер": 1,
    "нестор": 1,
    "нивек": 1,
    "нивен": 1,
    "ник": 1,
    "никандр": 1,
    "никанор": 1,
    "никита": 1,
    "никифор": 1,
    "никк": 1,
    "никки": 1,
    "никодим": 1,
    "никола": 1,
    "николай": 1,
    "николас": 1,
    "никон": 1,
    "нил": 1,
    "нили": 1,
    "нимбус": 1,
    "нинел": 1,
    "нинель": 1,
    "нисон": 1,
    "нифонт": 1,
    "ноа": 1,
    "новомир": 1,
    "нодар": 1,
    "ной": 1,
    "нолан": 1,
    "нолл": 1,
    "норберт": 1,
    "норвуд": 1,
    "норд": 1,
    "норм": 1,
    "норман": 1,
    "норманд": 1,
    "норрис": 1,
    "нортон": 1,
    "ноубль": 1,
    "ноэль": 1,
    "ньют": 1,
    "ньютон": 1,
    "оберон": 1,
    "обин": 1,
    "обри": 1,
    "овидий": 1,
    "огастин": 1,
    "огден": 1,
    "огэст": 1,
    "оделл": 1,
    "одиссей": 1,
    "одлей": 1,
    "одран": 1,
    "оз": 1,
    "оззи": 1,
    "океан": 1,
    "оксар": 1,
    "октавиан": 1,
    "октябрин": 1,
    "октябрь": 1,
    "олби": 1,
    "олбэйн": 1,
    "олдвен": 1,
    "олдвин": 1,
    "олден": 1,
    "олдин": 1,
    "олдис": 1,
    "олдон": 1,
    "олдос": 1,
    "олдред": 1,
    "олдус": 1,
    "олдфорд": 1,
    "олег": 1,
    "олей": 1,
    "оли": 1,
    "оливер": 1,
    "олимпий": 1,
    "олластер": 1,
    "олластир": 1,
    "оллгар": 1,
    "оллджер": 1,
    "олли": 1,
    "оллин": 1,
    "оллисдэйр": 1,
    "оллистер": 1,
    "оллистэйр": 1,
    "оллон": 1,
    "оллэйстар": 1,
    "ольгерд": 1,
    "омар": 1,
    "омега": 1,
    "онисим": 1,
    "ора": 1,
    "оран": 1,
    "орвал": 1,
    "орвилл": 1,
    "орест": 1,
    "ориан": 1,
    "ормерод": 1,
    "оррелл": 1,
    "оррин": 1,
    "орсон": 1,
    "осберт": 1,
    "осбоерн": 1,
    "осборн": 1,
    "освальд": 1,
    "осень": 1,
    "осип": 1,
    "оскар": 1,
    "остап": 1,
    "остен": 1,
    "остин": 1,
    "остромир": 1,
    "отис": 1,
    "оттис": 1,
    "отто": 1,
    "оттон": 1,
    "оуин": 1,
    "оуэн": 1,
    "ошин": 1,
    "павел": 1,
    "пайс": 1,
    "палладий": 1,
    "палмер": 1,
    "панкрас": 1,
    "пантелей": 1,
    "пантелеймон": 1,
    "панфил": 1,
    "парамон": 1,
    "паркер": 1,
    "паррис": 1,
    "партизан": 1,
    "пат": 1,
    "патрик": 1,
    "патси": 1,
    "пахом": 1,
    "пеитон": 1,
    "пепин": 1,
    "пересвет": 1,
    "перри": 1,
    "перс": 1,
    "перси": 1,
    "персиваль": 1,
    "петеркин": 1,
    "пимен": 1,
    "пип": 1,
    "пипер": 1,
    "пирр": 1,
    "пирс": 1,
    "пит": 1,
    "питер": 1,
    "платон": 1,
    "пол": 1,
    "поли": 1,
    "поликарп": 1,
    "помпей": 1,
    "портер": 1,
    "порфирий": 1,
    "потап": 1,
    "престон": 1,
    "приам": 1,
    "принц": 1,
    "пров": 1,
    "прозор": 1,
    "прокопий": 1,
    "прокофий": 1,
    "проспер": 1,
    "протас": 1,
    "прохор": 1,
    "пэйс": 1,
    "пэйси": 1,
    "пэйтон": 1,
    "пётр": 1,
    "петр": 1,
    "равель": 1,
    "равен": 1,
    "равиль": 1,
    "радамес": 1,
    "радий": 1,
    "радим": 1,
    "радислав": 1,
    "радомир": 1,
    "раз": 1,
    "раймонд": 1,
    "раймунд": 1,
    "райордан": 1,
    "райт": 1,
    "ралф": 1,
    "ралфи": 1,
    "ральф": 1,
    "ранделл": 1,
    "ранди": 1,
    "рандолф": 1,
    "рандольф": 1,
    "расс": 1,
    "рассел": 1,
    "рассэль": 1,
    "расти": 1,
    "растус": 1,
    "ратмир": 1,
    "рауль": 1,
    "рафаил": 1,
    "рафаэль": 1,
    "рашид": 1,
    "раян": 1,
    "реарден": 1,
    "ревмир": 1,
    "реган": 1,
    "редд": 1,
    "редж": 1,
    "реджи": 1,
    "реджинальд": 1,
    "редклиф": 1,
    "редклифф": 1,
    "редлей": 1,
    "редманд": 1,
    "редмонд": 1,
    "реид": 1,
    "рей": 1,
    "рейли": 1,
    "рейнард": 1,
    "рейнольд": 1,
    "рекс": 1,
    "рем": 1,
    "ренальд": 1,
    "ренат": 1,
    "риган": 1,
    "ригби": 1,
    "рид": 1,
    "ридлей": 1,
    "риель": 1,
    "рик": 1,
    "рикей": 1,
    "рики": 1,
    "рилан": 1,
    "рилей": 1,
    "рили": 1,
    "ринат": 1,
    "рио": 1,
    "риплей": 1,
    "рис": 1,
    "рихард": 1,
    "рич": 1,
    "ричард": 1,
    "ричи": 1,
    "роальд": 1,
    "роб": 1,
    "робби": 1,
    "роберт": 1,
    "робеспьер": 1,
    "роби": 1,
    "робин": 1,
    "робинзон": 1,
    "рован": 1,
    "род": 1,
    "роддж": 1,
    "родджер": 1,
    "родди": 1,
    "родерик": 1,
    "роджер": 1,
    "родион": 1,
    "родни": 1,
    "родолф": 1,
    "рождеро": 1,
    "рой": 1,
    "ройл": 1,
    "ройс": 1,
    "ройстон": 1,
    "роки": 1,
    "ролан": 1,
    "роланд": 1,
    "роли": 1,
    "ролланд": 1,
    "ролли": 1,
    "роман": 1,
    "ромен": 1,
    "ромуальд": 1,
    "рон": 1,
    "рональд": 1,
    "ронни": 1,
    "рори": 1,
    "роско": 1,
    "росс": 1,
    "ростислав": 1,
    "роуланд": 1,
    "роулей": 1,
    "роял": 1,
    "рубен": 1,
    "рубин": 1,
    "руди": 1,
    "рудольф": 1,
    "рудьярд": 1,
    "рунар": 1,
    "руслан": 1,
    "руссо": 1,
    "рустам": 1,
    "рустем": 1,
    "рхетт": 1,
    "рьюб": 1,
    "рэд": 1,
    "рэй": 1,
    "рэйнард": 1,
    "рэйнер": 1,
    "рэйф": 1,
    "рэм": 1,
    "рэндал": 1,
    "рэндалл": 1,
    "рюрик": 1,
    "сава": 1,
    "савва": 1,
    "савелий": 1,
    "савьер": 1,
    "сайг": 1,
    "саймон": 1,
    "салал": 1,
    "салливан": 1,
    "самми": 1,
    "самойло": 1,
    "самсон": 1,
    "самуил": 1,
    "сандфорд": 1,
    "санни": 1,
    "санфорд": 1,
    "свет": 1,
    "светлан": 1,
    "светозар": 1,
    "светослав": 1,
    "свизин": 1,
    "свизун": 1,
    "свиней": 1,
    "святогор": 1,
    "святополк": 1,
    "святослав": 1,
    "себастьян": 1,
    "севард": 1,
    "севастиан": 1,
    "севастьян": 1,
    "север": 1,
    "севериан": 1,
    "северин": 1,
    "северьян": 1,
    "северян": 1,
    "седрик": 1,
    "сеймур": 1,
    "селби": 1,
    "семён": 1,
    "септембер": 1,
    "серапион": 1,
    "серафим": 1,
    "сергей": 1,
    "сесил": 1,
    "сет": 1,
    "сефтон": 1,
    "сивард": 1,
    "сигизмунд": 1,
    "сигманд": 1,
    "сид": 1,
    "сидней": 1,
    "сидор": 1,
    "сила": 1,
    "силас": 1,
    "силвестр": 1,
    "сильвер": 1,
    "сильвест": 1,
    "сильвестр": 1,
    "симеон": 1,
    "симон": 1,
    "синклэйр": 1,
    "сирил": 1,
    "сисар": 1,
    "скай": 1,
    "скилар": 1,
    "скилер": 1,
    "скот": 1,
    "скотти": 1,
    "скуилер": 1,
    "слава": 1,
    "слай": 1,
    "слэйд": 1,
    "совет": 1,
    "сократ": 1,
    "соломон": 1,
    "сони": 1,
    "сонни": 1,
    "софокл": 1,
    "софон": 1,
    "спайк": 1,
    "спарроу": 1,
    "спартак": 1,
    "спенсер": 1,
    "спиридон": 1,
    "спиро": 1,
    "стакей": 1,
    "сталий": 1,
    "сталь": 1,
    "станислав": 1,
    "стаффорд": 1,
    "степан": 1,
    "стерлинг": 1,
    "стеф": 1,
    "стефан": 1,
    "сти": 1,
    "стив": 1,
    "стивен": 1,
    "стиви": 1,
    "стиу": 1,
    "сторм": 1,
    "стратон": 1,
    "сту": 1,
    "стэки": 1,
    "стэн": 1,
    "стэнли": 1,
    "стэнфорд": 1,
    "стюарт": 1,
    "сурен": 1,
    "сэм": 1,
    "сэмюэль": 1,
    "сэнди": 1,
    "тад": 1,
    "таддеус": 1,
    "таир": 1,
    "тай": 1,
    "такер": 1,
    "тал": 1,
    "талбот": 1,
    "таннер": 1,
    "тарас": 1,
    "таскилл": 1,
    "таффи": 1,
    "тед": 1,
    "тейгу": 1,
    "тейдж": 1,
    "теймураз": 1,
    "тейрк": 1,
    "текс": 1,
    "тельнан": 1,
    "тенгиз": 1,
    "тенней": 1,
    "теннизон": 1,
    "тео": 1,
    "теобальд": 1,
    "теодор": 1,
    "теранс": 1,
    "теренс": 1,
    "терентий": 1,
    "терло": 1,
    "терранс": 1,
    "террелл": 1,
    "терренс": 1,
    "терстон": 1,
    "ти": 1,
    "тиарнак": 1,
    "тиарнан": 1,
    "тибалт": 1,
    "тибби": 1,
    "тигран": 1,
    "тигу": 1,
    "тизон": 1,
    "тилар": 1,
    "тилер": 1,
    "тилор": 1,
    "тим": 1,
    "тимми": 1,
    "тимоти": 1,
    "тимофей": 1,
    "тимур": 1,
    "тирелл": 1,
    "тирнан": 1,
    "тирней": 1,
    "тирон": 1,
    "тироун": 1,
    "тиррелл": 1,
    "тит": 1,
    "тихомир": 1,
    "тихон": 1,
    "тоал": 1,
    "тоби": 1,
    "тобиас": 1,
    "тобин": 1,
    "товий": 1,
    "тод": 1,
    "тодд": 1,
    "толли": 1,
    "том": 1,
    "томас": 1,
    "томми": 1,
    "тон": 1,
    "тони": 1,
    "топэр": 1,
    "торез": 1,
    "торий": 1,
    "торлей": 1,
    "торнтон": 1,
    "травис": 1,
    "тракей": 1,
    "трантер": 1,
    "траффорд": 1,
    "траэрн": 1,
    "трев": 1,
    "тревельян": 1,
    "тревор": 1,
    "трейврс": 1,
    "трейс": 1,
    "трейси": 1,
    "трент": 1,
    "трентон": 1,
    "тристан": 1,
    "тристрам": 1,
    "трифон": 1,
    "трой": 1,
    "трофим": 1,
    "труман": 1,
    "туллий": 1,
    "тусон": 1,
    "тэдди": 1,
    "тэди": 1,
    "тэйлер": 1,
    "тэйлор": 1,
    "тэйн": 1,
    "тэйт": 1,
    "тэл": 1,
    "тэмпл": 1,
    "тэрри": 1,
    "уилбер": 1,
    "уиллард": 1,
    "уиллис": 1,
    "уилфред": 1,
    "уилфрид": 1,
    "уильям": 1,
    "уинстон": 1,
    "уинфред": 1,
    "уисдом": 1,
    "улайксс": 1,
    "улиссес": 1,
    "ульяна": 1,
    "уолли": 1,
    "уоллис": 1,
    "уолт": 1,
    "уолтер": 1,
    "уолтон": 1,
    "уорик": 1,
    "уорнер": 1,
    "уоррен": 1,
    "уот": 1,
    "уоткин": 1,
    "уптон": 1,
    "урбан": 1,
    "уриах": 1,
    "устин": 1,
    "уэйн": 1,
    "уэсли": 1,
    "фабиан": 1,
    "фаддей": 1,
    "фадей": 1,
    "фалк": 1,
    "фарид": 1,
    "фарлей": 1,
    "фарон": 1,
    "фарран": 1,
    "февралин": 1,
    "федор": 1,
    "федосий": 1,
    "фелан": 1,
    "фелиз": 1,
    "феликс": 1,
    "фелим": 1,
    "фелис": 1,
    "фентон": 1,
    "феодосий": 1,
    "феофан": 1,
    "ферги": 1,
    "фергус": 1,
    "ферд": 1,
    "ферди": 1,
    "фердинанд": 1,
    "фернан": 1,
    "фернанд": 1,
    "фестер": 1,
    "фестус": 1,
    "фидель": 1,
    "фидо": 1,
    "фил": 1,
    "филайп": 1,
    "филандр": 1,
    "филарет": 1,
    "филат": 1,
    "филберт": 1,
    "филимон": 1,
    "филип": 1,
    "филипп": 1,
    "фило": 1,
    "финикс": 1,
    "финис": 1,
    "флегонт": 1,
    "флемминг": 1,
    "флечер": 1,
    "флинн": 1,
    "флинт": 1,
    "флойд": 1,
    "флорентий": 1,
    "флоренц": 1,
    "флорин": 1,
    "флорри": 1,
    "флурри": 1,
    "фок": 1,
    "фокс": 1,
    "фома": 1,
    "фонз": 1,
    "фонзи": 1,
    "форбес": 1,
    "форд": 1,
    "форест": 1,
    "форрест": 1,
    "фостер": 1,
    "фот": 1,
    "фотий": 1,
    "фоук": 1,
    "фразир": 1,
    "франклин": 1,
    "франц": 1,
    "фред": 1,
    "фредди": 1,
    "фредерик": 1,
    "фредрик": 1,
    "фрейзер": 1,
    "фрейзр": 1,
    "фридрих": 1,
    "фримэн": 1,
    "фритс": 1,
    "фродо": 1,
    "фрол": 1,
    "фрэнк": 1,
    "фрэнки": 1,
    "фрэнклин": 1,
    "фрэнс": 1,
    "фрэнсис": 1,
    "фёдор": 1,
    "хавелок": 1,
    "хадвин": 1,
    "хадлей": 1,
    "хал": 1,
    "хам": 1,
    "хамиш": 1,
    "хамлет": 1,
    "хаммонд": 1,
    "ханк": 1,
    "ханлей": 1,
    "хантер": 1,
    "харв": 1,
    "харви": 1,
    "харди": 1,
    "хардинг": 1,
    "харитон": 1,
    "харкоерт": 1,
    "харлан": 1,
    "харланд": 1,
    "харлей": 1,
    "харлин": 1,
    "хармон": 1,
    "харпер": 1,
    "харрис": 1,
    "харрисон": 1,
    "хартлей": 1,
    "хауелл": 1,
    "хедлей": 1,
    "хек": 1,
    "хендерсон": 1,
    "хендрик": 1,
    "хенрай": 1,
    "хенри": 1,
    "херб": 1,
    "херби": 1,
    "хервей": 1,
    "херлей": 1,
    "хиацинт": 1,
    "хилари": 1,
    "хиллэри": 1,
    "хирам": 1,
    "хис": 1,
    "хитклифф": 1,
    "хию": 1,
    "хоард": 1,
    "хоб": 1,
    "ходдж": 1,
    "хойт": 1,
    "холден": 1,
    "холл": 1,
    "холлис": 1,
    "хомер": 1,
    "хопкин": 1,
    "хорас": 1,
    "хоратайо": 1,
    "хоуи": 1,
    "храбр": 1,
    "христоф": 1,
    "христофор": 1,
    "худд": 1,
    "хуей": 1,
    "хует": 1,
    "хукк": 1,
    "хукслей": 1,
    "хумберт": 1,
    "хунтлей": 1,
    "хуффи": 1,
    "хью": 1,
    "хьюберт": 1,
    "хьюго": 1,
    "хьюи": 1,
    "хэвен": 1,
    "хэдлей": 1,
    "хэйвуд": 1,
    "хэйден": 1,
    "хэйл": 1,
    "хэмфри": 1,
    "хэппи": 1,
    "хюи": 1,
    "цезарь": 1,
    "чад": 1,
    "чадвик": 1,
    "чаз": 1,
    "чак": 1,
    "чакки": 1,
    "чарлз": 1,
    "чарли": 1,
    "чарлтон": 1,
    "чарльз": 1,
    "час": 1,
    "чейз": 1,
    "чендлер": 1,
    "ченс": 1,
    "черокез": 1,
    "чеслав": 1,
    "честер": 1,
    "чеьянн": 1,
    "чип": 1,
    "чонки": 1,
    "чонси": 1,
    "ша": 1,
    "шад": 1,
    "шаи": 1,
    "шайенн": 1,
    "шакуилл": 1,
    "шамиль": 1,
    "шамус": 1,
    "шан": 1,
    "шаннен": 1,
    "шаннон": 1,
    "шау": 1,
    "шеврон": 1,
    "шелби": 1,
    "шелдон": 1,
    "шеллей": 1,
    "шелтон": 1,
    "шем": 1,
    "шервуд": 1,
    "шеридан": 1,
    "шерлок": 1,
    "шерман": 1,
    "ши": 1,
    "шилох": 1,
    "шимус": 1,
    "шмидт": 1,
    "шолто": 1,
    "шон": 1,
    "шэй": 1,
    "шэйн": 1,
    "эбби": 1,
    "эбен": 1,
    "эбенезер": 1,
    "эвальд": 1,
    "эван": 1,
    "эвелин": 1,
    "эверард": 1,
    "эверетт": 1,
    "эверитт": 1,
    "эвот": 1,
    "эгберт": 1,
    "эд": 1,
    "эдан": 1,
    "эдвард": 1,
    "эдвин": 1,
    "эдгар": 1,
    "эдди": 1,
    "эдип": 1,
    "эдисон": 1,
    "эдмонд": 1,
    "эдмунд": 1,
    "эдон": 1,
    "эдуард": 1,
    "эдун": 1,
    "эзраа": 1,
    "эзэлстан": 1,
    "эзэлуолф": 1,
    "эйб": 1,
    "эйби": 1,
    "эйвери": 1,
    "эйден": 1,
    "эйлберт": 1,
    "эйлвард": 1,
    "эймерей": 1,
    "эймери": 1,
    "эйнар": 1,
    "эйнслей": 1,
    "эйнсли": 1,
    "эйс": 1,
    "элайотт": 1,
    "элбан": 1,
    "элвин": 1,
    "элвис": 1,
    "элвуд": 1,
    "элгар": 1,
    "элдвен": 1,
    "элдвин": 1,
    "элден": 1,
    "элджер": 1,
    "элдин": 1,
    "элдис": 1,
    "элдон": 1,
    "элдред": 1,
    "элдус": 1,
    "электрон": 1,
    "эли": 1,
    "элиас": 1,
    "элиджа": 1,
    "элиот": 1,
    "элла": 1,
    "эллгар": 1,
    "эллджер": 1,
    "эллери": 1,
    "эллиот": 1,
    "эллис": 1,
    "элмер": 1,
    "элрик": 1,
    "элрой": 1,
    "элсдон": 1,
    "эль": 1,
    "эльберт": 1,
    "эльбрус": 1,
    "эльдар": 1,
    "эльмар": 1,
    "эльмир": 1,
    "эльтон": 1,
    "эмерсон": 1,
    "эмилиан": 1,
    "эмилий": 1,
    "эмиль": 1,
    "эммануель": 1,
    "эммануил": 1,
    "эммерсон": 1,
    "эммет": 1,
    "эмметт": 1,
    "эмори": 1,
    "эмэри": 1,
    "энвер": 1,
    "энгель": 1,
    "энджелберт": 1,
    "энди": 1,
    "эндрю": 1,
    "энергий": 1,
    "энтони": 1,
    "эразм": 1,
    "эраст": 1,
    "эрван": 1,
    "эрвин": 1,
    "эрг": 1,
    "эрек": 1,
    "эрий": 1,
    "эрик": 1,
    "эрих": 1,
    "эрл": 1,
    "эрлен": 1,
    "эрн": 1,
    "эрнест": 1,
    "эрни": 1,
    "эрнст": 1,
    "эрон": 1,
    "эррол": 1,
    "эрролл": 1,
    "этан": 1,
    "этелберт": 1,
    "этелред": 1,
    "этелрик": 1,
    "этелхард": 1,
    "эшли": 1,
    "эюзби": 1,
    "ювеналий": 1,
    "юджин": 1,
    "юлиан": 1,
    "юлий": 1,
    "юлиус": 1,
    "юм": 1,
    "юниор": 1,
    "юпитер": 1,
    "юрий": 1,
    "юстас": 1,
    "юстин": 1,
    "яков": 1,
    "ян": 1,
    "янкей": 1,
    "янки": 1,
    "януарий": 1,
    "ярвуд": 1,
    "яромир": 1,
    "ярополк": 1,
    "ярослав": 1
  }, exports.ruBindingWords = [ "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "пота", "потому", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "тож", "только", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы", "а-ля", "без", "безо", "благодаря", "близ", "в", "ввиду", "вглубь", "вдоль", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "во", "возле", "вокруг", "вопреки", "впереди", "вразрез", "вроде", "вслед", "вследствие", "для", "до", "за", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "к", "ко", "кроме", "кругом", "меж", "между", "мимо", "на", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду", "насупротив", "насчёт", "не", "ниже", "о", "об", "обо", "обок", "около", "окромя", "округ", "от", "относительно", "ото", "перед", "передо", "по", "по-за", "по-над", "поверх", "под", "подле", "подо", "подобно", "позади", "помимо", "поперёк", "порядка", "посередине", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "применительно", "про", "против", "путём", "ради", "с", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "со", "согласно", "спустя", "среди", "средь", "сродни", "судя", "супротив", "у", "через", "чрез", "иже", "какой-либо", "какой-то", "кое-кто", "кой", "кто", "кто-либо", "многий", "мя", "насколько", "немногий", "нещечко", "никой", "ничегошеньки", "се", "сё", "такой-то", "тот-то", "чё", "чево", "чей-либо", "чей-нибудь", "чей-то", "шо", "эта", "кем", "ком", "кому", "нахуя", "чей", "чему", "вам", "вами", "вас", "вы", "Вы", "ее", "её", "его", "ей", "ему", "ею", "им", "ими", "их", "меня", "мне", "мной", "мною", "мы", "нём", "нем", "нам", "нами", "неё", "него", "ней", "нему", "нею", "ним", "ними", "них", "он", "она", "оне", "они", "оно", "тебе", "тебя", "тобой", "тобою", "ты", "я", "иной", "кое-какой", "кое-чей", "кое-что", "кой-какой", "кой-кто", "кто-нибудь", "кто-то", "куда-нибудь", "некто", "нечто", "что-либо", "что-нибудь", "что-то", "весь", "всякий", "любой", "сам", "самый", "таков", "этакий", "другой", "некем", "некому", "нечего", "нечем", "нечему", "никакой", "никто", "ничего", "ничей", "ничем", "ничему", "ничто", "ваш", "ихний", "моё", "мой", "моя", "наш", "свой", "твой", "оный", "сей", "сие", "сии", "сия", "та", "такой", "тот", "ту", "эдакий", "эти", "это", "этот", "ась", "аюшки", "таки", "а", "авось-либо", "ага", "аминь", "б", "бишь", "буквально", "бы", "было", "вишь", "вон", "вот", "вот-вот", "вряд", "всего", "давай", "де", "действительно", "дескать", "добро", "довольно", "ещё", "исключительно", "ить", "ишь", "ка", "кажется", "конечно", "ладно", "лих", "лучше", "мол", "навряд", "наоборот", "небось", "нет", "неужели", "нехай", "никак", "ну", "ну-с", "по-видимому", "пожалуй", "пожалуйста", "полно", "положительно", "предовольно", "простите", "просто-напросто", "пускай", "разумеется", "сём-ка", "сем", "скорее", "спасибо", "так", "то-то", "тоже", "уж", "уже", "ужели", "ужли", "фон", "хорошо", "эдак", "эк", "этак" ];
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.words = {}, exports = window.lastName.plugins.ru.words) : exports = module.exports, function(exports) {
  return exports.adverbs = [ "абсолютно", "адски", "азартно", "активно", "аспидно", "баснословно", "бдительно", "безапелляционно", "безбожно", "безвозвратно", "безгранично", "безжалостно", "беззаветно", "беззастенчиво", "безмерно", "безмятежно", "безнадежно", "безоговорочно", "безраздельно", "безропотно", "безудержно", "безукоризненно", "безумно", "безупречно", "безусловно", "безустанно", "безутешно", "бескомпромиссно", "бесконечно", "беспардонно", "бесповоротно", "беспощадно", "беспредельно", "беспрекословно", "бесследно", "бессовестно", "бесстыдно", "бесчеловечно", "бешено", "бурно", "вдребезги", "вконец", "вовсю", "всемерно", "всесторонне", "всецело", "всячески", "высоко", "глубоко", "горько", "горячо", "грубо", "густо", "диаметрально", "дико", "досконально", "досыта", "дотошно", "дьявольски", "жарко", "жгуче", "железно", "жестко", "жестоко", "живо", "жизненно", "жутко", "запоем", "запредельно", "зверски", "здорово", "злостно", "идеально", "излишне", "изрядно", "изумительно", "исключительно", "исступленно", "истово", "истошно", "исчерпывающе", "кардинально", "катастрофически", "категорически", "клятвенно", "колоссально", "крайне", "крепко", "кристально", "кровно", "крупно", "круто", "люто", "максимально", "мертвецки", "мучительно", "навзрыд", "нагло", "наглухо", "наглядно", "наголову", "надежно", "надрывно", "назубок", "намертво", "наотрез", "напрочь", "нарочито", "насквозь", "настоятельно", "насущно", "начисто", "небывало", "невероятно", "невиданно", "невообразимо", "невыносимо", "невыразимо", "недопустимо", "неизмеримо", "неимоверно", "неистово", "немилосердно", "немыслимо", "необыкновенно", "необычайно", "неописуемо", "неопровержимо", "непомерно", "непоправимо", "непостижимо", "непримиримо", "непробудно", "непроходимо", "неразрывно", "несказанно", "неслыханно", "несметно", "несравненно", "нестерпимо", "неудержимо", "неузнаваемо", "неуклонно", "неукоснительно", "неустанно", "неусыпно", "неутешно", "неутомимо", "нещадно", "оглушительно", "ожесточенно", "ослепительно", "основательно", "остро", "откровенно", "открыто", "отлично", "отменно", "отчаянно", "очень", "панически", "патологически", "пламенно", "плотно", "по-настоящему", "по-собачьи", "подлинно", "подчеркнуто", "позарез", "поистине", "полностью", "поразительно", "порядком", "порядочно", "потрясающе", "предельно", "прекрасно", "преступно", "прилично", "примитивно", "принципиально", "приторно", "пронзительно", "радикально", "разительно", "редкостно", "резко", "рекордно", "свято", "серьезно", "сильно", "слепо", "смертельно", "совершенно", "совсем", "страстно", "страшно", "строго", "строго-настрого", "существенно", "твердо", "тяжело", "тяжко", "убийственно", "удивительно", "ужасающе", "ужасно", "фанатически", "фанатично", "фантастически", "феноменально", "хорошенько", "хорошо", "чертовски", "чрезвычайно", "чрезмерно", "чудовищно", "широко", "шумно", "щедро", "ярко", "яростно" ], exports.unions = [ "а", "а именно", "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "все-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как бы", "как то", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "после того как", "пота", "потому", "потому как", "потому что", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "то есть", "тож", "только", "только что", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы" ], exports.prepositionAll = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо", "включая", "невзирая на", "несмотря на", "по", "по-за", "про", "с", "сквозь", "со", "спустя", "через", "чрез", "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по", "при", "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "среди", "средь", "супротив", "у", "в связи с", "в соответствии с", "вслед за", "лицом к лицу с", "над", "надо", "наряду с", "перед", "передо", "по сравнению с", "по-над", "пред", "предо", "рядом с", "следом за" ], exports.prepositionSimple = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionAcusative = [ "в", "включая", "во", "за", "на", "не в", "не за", "невзирая на", "несмотря на", "о", "об", "обо", "по", "по-за", "под", "подо", "про", "с", "сквозь", "со", "спустя", "через", "чрез" ], exports.prepositionDative = [ "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по" ], exports.prepositionPrepositional = [ "в", "во", "на", "не в", "о", "об", "обо", "по", "при" ], exports.prepositionGenetive = [ "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "меж", "между", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "со", "среди", "средь", "супротив", "у" ], exports.prepositionInstrumental = [ "в связи с", "в соответствии с", "вслед за", "за", "лицом к лицу с", "меж", "между", "над", "надо", "наряду с", "не за", "перед", "передо", "по сравнению с", "по-над", "под", "подо", "пред", "предо", "рядом с", "с", "следом за", "со" ], exports.prepositionWithSingleCase = [ "без", "без ведома", "безо", "благодаря", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в связи с", "в силу", "в соответствии с", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "вдоль по", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "вопреки", "впереди", "впредь до", "вроде", "вслед", "вслед за", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "к", "ко", "кроме", "кругом", "лицом к", "лицом к лицу с", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду с", "насупротив", "насчёт", "начиная с", "не без", "не считая", "невзирая на", "недалеко от", "независимо от", "несмотря на", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "перед", "передо", "по линии", "по мере", "по направлению к", "по отношению к", "по поводу", "по причине", "по случаю", "по сравнению с", "по-за", "по-над", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "подобно", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "при помощи", "применительно к", "про", "против", "путём", "ради", "рядом с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "согласно", "спустя", "среди", "средь", "сродни", "судя по", "супротив", "у", "через", "чрез" ], exports.prepositionWith2Cases = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionWith3Cases = [ "по", "с", "со" ];
}(exports);

var exports, ref, util, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.dates = {}, exports = window.lastName.plugins.ru.dates, ref = window.lastName.plugins.ru.ref, util = window.lastName.util) : (exports = module.exports, ref = require("./ref"), util = require("../../util")), function(exports, util, ref) {
  var dateObjectToString, extractDates, getRuMonthIndex, getValidDate, packDates, packIntervals, ruMonthInDates;
  return ruMonthInDates = [ "января", "февраля", "марта", "аперля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря" ], dateObjectToString = function(dateObj) {
    var d, m, y, _ref;
    return y = ((_ref = typeof dateObj.y) === "number" || _ref === "string") && dateObj.y || "", m = dateObj.m + 1, m = m > 9 && m || "0" + m, d = dateObj.d > 9 && dateObj.d || "0" + dateObj.d, "" + d + "." + m + "." + y;
  }, getValidDate = function(dateObj) {
    var defaultYear, dt;
    defaultYear = dateObj.y;
    if (void 0 === dateObj.y || dateObj.y < 1970 || dateObj.y > 2038) dateObj.y = 2e3;
    return dt = new Date(Date.UTC(dateObj.y, dateObj.m, dateObj.d)), dt.getMonth() === dateObj.m && dt.getDate() === dateObj.d ? (dateObj.y = defaultYear, dateObj) : null;
  }, getRuMonthIndex = function(str) {
    var m;
    return m = str.toLowerCase().match(/(\s|^)(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s|$)/g), m ? ruMonthInDates.indexOf(m[0].replace(/\s/g, "")) : -1;
  }, exports.extractDates = extractDates = function(strArr) {
    var dates, intervals, sources;
    return dates = {}, sources = [], intervals = {}, strArr instanceof Array || (strArr = [ strArr ]), strArr.map(function(str) {
      var dStr, date, found, from, fromDate, fromMonth, fromYear, id, intObject, mIndex, sourceStr, to, toDate, toYear, verboseMatch, wordsArr, _ref, _results;
      verboseMatch = str.match(/\s+\d{1,2}\s+((января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)\s+|)(\d{2,4}(\s+года|)\s+|)по\s+\d{1,2}\s+(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s+\d{2,4}|)(\s+|$)/mig);
      if (!verboseMatch) {
        wordsArr = str.split(" "), found = !1, _results = [];
        while (wordsArr.length > 2 && !found) /^\d[\d]$/.test(wordsArr[0]) && (mIndex = ruMonthInDates.indexOf(wordsArr[1].toLowerCase()), mIndex >= 0 ? (date = {
          d: parseInt(wordsArr[0], 10),
          m: mIndex
        }, /^\d{2,4}$/.test(wordsArr[2]) ? (date.y = parseInt(wordsArr[2], 10), sourceStr = wordsArr.slice(0, 3).join(" ")) : sourceStr = wordsArr.slice(0, 2).join(" ")) : /^\d\d\.\d\d.\d{2,4}$/.test(wordsArr[0] || /^\d\d\.\d\d$/.test(wordsArr[0])) ? (date = {
          d: parseInt(wordsArr[0].slice(0, 3), 10),
          m: parseInt(wordsArr[0].slice(3, 6), 10),
          y: parseInt(wordsArr[0].slice(6), 10) || void 0
        }, sourceStr = wordsArr[0]) : date = {}, date = getValidDate(date), date && (found = !0, sources.push(sourceStr), dStr = dateObjectToString(date), dates[dStr] ? dates[dStr].count++ : dates[dStr] = {
          count: 1,
          value: date
        })), _results.push(wordsArr.shift());
        return _results;
      }
      _ref = verboseMatch[0].toLowerCase().split("по"), from = _ref[0], to = _ref[1], toYear = to.replace(/\d{1,2}/, "").match(/\d+/g), toYear ? toYear = parseInt(toYear[0], 10) : toYear = void 0, toDate = {
        d: parseInt(to.match(/\d{1,2}/g)[0], 10),
        m: getRuMonthIndex(to),
        y: toYear
      }, fromYear = from.replace(/\d{1,2}/, "").match(/\d+/g), fromMonth = getRuMonthIndex(from), fromYear ? fromYear = parseInt(fromYear[0], 10) : fromYear = toYear, fromMonth === -1 && (fromMonth = toDate.m), fromDate = {
        d: parseInt(from.match(/\d{1,2}/g)[0], 10),
        m: fromMonth,
        y: fromYear
      }, toDate = getValidDate(toDate), fromDate = getValidDate(fromDate);
      if (toDate && fromDate) return intObject = {
        from: dateObjectToString(fromDate),
        from_value: fromDate,
        to: dateObjectToString(toDate),
        to_value: toDate
      }, id = "" + intObject.from + "-" + intObject.to, intervals[id] ? intervals[id].count++ : (intObject.count = 1, intervals[id] = intObject), sources.push(verboseMatch[0]);
    }), {
      dates: dates,
      sources: sources,
      intervals: intervals
    };
  }, exports.packDates = packDates = function(dates, defaultYear) {
    var dateObj, id, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in dates) dateObj = dates[id], "undefined" != typeof dateObj.value.y && years.push(dateObj.value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in dates) dateObj = dates[id], "undefined" == typeof dateObj.value.y && (dateObj.value.y = defaultYear), out["" + dateObjectToString(dateObj.value)] = dateObj.count;
    return out;
  }, exports.packIntervals = packIntervals = function(intervals, defaultYear) {
    var id, interval, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in intervals) interval = intervals[id], "undefined" != typeof interval.from_value.y && years.push(interval.from_value.y), "undefined" != typeof interval.to_value.y && years.push(interval.to_value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in intervals) interval = intervals[id], "undefined" == typeof interval.from_value.y && (interval.from_value.y = defaultYear), "undefined" == typeof interval.to_value.y && (interval.to_value.y = defaultYear), out["" + dateObjectToString(interval.from_value) + "-" + dateObjectToString(interval.to_value)] = interval.count;
    return out;
  }, exports.preFilter = function(text, result) {
    var dates, numRe;
    numRe = /((([а-яё]+)\s+){0,1}\d[\.\d]{0,}(\s+(([a-яё]+)|([\.\d]+))){1,6})|([12]\d\d\d)/mig, dates = extractDates(util.unique(text.match(numRe) || [])), util.dictKeys(dates.dates).length > 0 && (result.dates = packDates(dates.dates)), util.dictKeys(dates.intervals).length > 0 && (result.intervals = packIntervals(dates.intervals));
    if (dates.sources.length > 0) return result.date_sources = dates.sources;
  };
}(exports, util, ref);

var exports, ref, util, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.inclines = {}, exports = window.lastName.plugins.ru.inclines, util = window.lastName.util, ref = window.lastName.plugins.ru.ref) : (exports = module.exports, util = require("../../util"), ref = require("./ref")), function(exports, util, ref) {
  var cases, doInclineFemaleName, doInclineMaleName, findProperName, genderMatch, getNominative, inclineAndGetResult, inclineFemMiddleName, inclineFemaleName, inclineFemaleNameAndGetResult, inclineFemaleSurname, inclineMaleMiddleName, inclineMaleName, inclineMaleNameAndGetResult, inclineMaleSurname, inclineMiddleName, inclineMiddleNameOrSurname, inclineName, inclinePersonSurname, inclineSurname, matchCase, matchNameAndSurname, matchNameParts;
  return cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ], exports.doInclineFemaleName = doInclineFemaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, aUnstressedRe, name2;
    return aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, aUnstressedRe = /ца$/g, name2 = name.slice(0, -1), aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aUnstressedRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ей", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /ия$/g.test(name) && name.length > 3 ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "и" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ь", "" + name2 + "ью", "" + name2 + "и" ] : /[жшщцч]$/g.test(name) ? [ "" + name, "" + name + "и", "" + name + "и", "" + name, "" + name + "ью", "" + name + "и" ] : [ name, name, name, name, name, name ];
  }, exports.doInclineMaleName = doInclineMaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, hardConsonants, hissingAndChe, ishortRe, name2;
    return hardConsonants = /[бвгдзклмнпрстфх]$/g, hissingAndChe = /[жшщцч]$/g, ishortRe = /((ай)|(ей)|(ой)|(уй)|(яй)|(юй)|(ий))$/g, aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, name2 = name.slice(0, -1), name === "Лев" ? [ "Лев", "Льва", "Льву", "Льва", "Львом", "Льве" ] : name === "Павел" ? [ "Павел", "Павла", "Павлу", "Павла", "Павлом", "Павле" ] : /и$/g.test(name) ? [ name, name, name, name, name, name ] : hissingAndChe.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ем", "" + name + "е" ] : hardConsonants.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ом", "" + name + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : ishortRe.test(name) ? [ "" + name2 + "й", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ко$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /о$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : null;
  }, inclineAndGetResult = function(fn, args) {
    var i, name, r;
    r = null;
    for (i in args) {
      name = args[i], r = fn(name, !0);
      if (r.found) break;
    }
    return r;
  }, inclineFemaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineFemaleName, arguments);
  }, inclineMaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineMaleName, arguments);
  }, exports.inclineFemaleName = inclineFemaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name3, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), nl = name.toLowerCase(), nominativeRe = /[адежзийклмнорстуьэя]$/g, canInclineRe = /[жшщцчаяь]$/g, genitiveRe = /[иы]$/g, dativeRe = /[еи]$/g, accusativeRe = /[жшщцчьую]$/g, instrumentalRe = /((ой)|(ей)|(еи)|(ью))$/g, prepositionalRe = /[еи]$/g, result = r = null, nominativeRe.test(nl) && ref.ruFemaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineFemaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "female",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name2 = name.slice(0, -1), name_cases = [], genitiveRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("dative"))), prepositionalRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("prepositional"))), accusativeRe.test(nl) && (/[ую]$/g.test(nl) ? r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а") : r = inclineFemaleNameAndGetResult(name), r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (name3 = name.slice(0, -2), r = inclineFemaleNameAndGetResult("" + name3 + "я", "" + name3 + "а", "" + name3 + "ь", "" + name3), r && r.found && (result = r, name_cases.push("instrumental"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineMaleName = inclineMaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), name === "Льв" && (name = "Лев"), name === "Павл" && (name = "Павел"), nl = name.toLowerCase(), nominativeRe = /([вгдзклмнпрстфхжшцьй]|(ба)|(ва)|(да)|(за)|(ла)|(ма)|(на)|(па)|(ра)|(са)|(та)|(фа)|(га)|(ка)|(ха)|(жа)|(ша)|(ща)|(ца)|(ча)|(я)|(ло)|(ко))$/g, canInclineRe = /([бвгдзклмнпрстфхжшцьая]|(ия)|(ья)|(ея)|(ий)|(ей))$/g, genitiveRe = /[аяыи]$/g, dativeRe = /(([еую])|(ии))$/g, accusativeRe = /[аяую]$/g, instrumentalRe = /((ом)|(ем)|(ой)|(ей)|(ёй))$/g, prepositionalRe = /((е)|(ии))$/g, name2 = name.slice(0, -1), result = r = null, nominativeRe.test(nl) && ref.ruMaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineMaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "male",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name_cases = [], genitiveRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /ы$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "о", "" + name2 + "а") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "а", "" + name.slice(0, -1) + "я", "" + name.slice(0, -1) + "о") : r = null, r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (/у$/g.test(nl) ? r = inclineMaleName(name2) : /[аеиоуя]ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "й") : /ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "ь") : /е$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "и", "" + name2 + "я", "" + name2 + "o") : /ии$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я") : r = null, r && r.found && (result = r, name_cases.push("dative"))), accusativeRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /у$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а") : /[ую]$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : r = null, r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (/ом$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2)) : /ем$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2), "" + name.slice(0, -2) + "ь", "" + name.slice(0, -2) + "й") : /ой$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "а", "" + name.slice(0, -2) + "о") : /((ей)|(ёй))$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "я", "" + name.slice(0, -2) + "а") : r = null, r && r.found && (result = r, name_cases.push("instrumental"))), prepositionalRe.test(nl) && (/е$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2, "" + name2 + "ь", "" + name2 + "й", "" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я", "" + name2 + "й") : r = null, r && r.found && (result = r, name_cases.push("prepositional"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineName = inclineName = function(name) {
    var fn, mn, result;
    return fn = inclineFemaleName(name), mn = inclineMaleName(name), fn.found ? result = {
      found: !0,
      src: name,
      gender: "female",
      guess_case: fn.guess_case,
      female_cases: fn.cases,
      possible_cases: fn.possible_cases,
      nominative: fn.nominative
    } : mn.found ? result = {
      found: !0,
      src: name,
      gender: "male",
      guess_case: mn.guess_case,
      male_cases: mn.cases,
      possible_cases: mn.possible_cases,
      nominative: mn.nominative
    } : fn.possible_yes && mn.possible_yes ? (result = {
      found: "maybe",
      src: name,
      gender: [ "male", "female" ],
      female_cases: fn.cases,
      male_cases: mn.cases,
      possible_cases: util.merge(fn.possible_cases, mn.possible_cases)
    }, result.guess_case = fn.guess_case_index <= mn.guess_case_index ? fn.guess_case : mn.guess_case) : fn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "female",
      female_cases: fn.cases,
      guess_case: fn.cases,
      possible_cases: fn.possible_cases
    } : mn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "male",
      male_cases: mn.cases,
      guess_case: mn.cases,
      possible_cases: mn.possible_cases
    } : result = {
      found: !1,
      src: name
    }, result;
  }, inclineSurname = function(surname, noInclinesRe, inclineRe, casesRe) {
    var c, cases_index, check, i, result, surname_cases, _i, _j, _len, _len2;
    result = {
      found: null,
      src: surname,
      cases: null,
      cases_index: null
    };
    if (noInclinesRe && noInclinesRe.test(surname)) result = {
      found: surname,
      src: surname,
      cases: [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ],
      cases_index: [ 0, 1, 2, 3, 4, 5 ]
    }; else for (_i = 0, _len = inclineRe.length; _i < _len; _i++) {
      check = inclineRe[_i];
      if (check[0].test(surname)) {
        result = {
          found: surname.replace(check[0], check[1]),
          src: surname
        }, cases_index = [], surname_cases = [], i = 0;
        for (_j = 0, _len2 = casesRe.length; _j < _len2; _j++) c = casesRe[_j], c.test(surname) && (cases_index.push(i), surname_cases.push(cases[i])), i++;
        surname_cases.length === 0 ? (result.found = null, result.cases = null) : result.cases = surname_cases, result.cases_index = cases_index;
        break;
      }
    }
    return result.surname_cases && (result.guess_case = result.surname_cases[0]), result;
  }, exports.inclineFemaleSurname = inclineFemaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(е)|(о)|(э)|(и)|(ы)|(^[нв]у)|(^ую)|(уа)|(иа)|(ман)|(вич)|(ян))$/g, inclineRe = [ [ /((ова)|(овой)|(ову))$/g, "ова" ], [ /((ева)|(евой)|(еву))$/g, "ева" ], [ /((ёва)|(ёвой)|(ёву))$/g, "ёва" ], [ /((ина)|(иной)|(ину))$/g, "ина" ], [ /((ая)|(ой)|(ую))$/g, "ая" ] ], casesRe = [ /((ова)|(ева)|(ёва)|(ина)|(ая))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((ову)|(еву)|(ёву)|(ину)|(ую))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, exports.inclineMaleSurname = inclineMaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(^ве)|(^го)|(э)|(и)|(ы)|(^му)|(ю)|(уа)|(иа))$/g, inclineRe = [ [ /((ов)|(ова)|(ову)|(овым)|(ове))$/g, "ов" ], [ /((ев)|(ева)|(еву)|(евым)|(еве))$/g, "ев" ], [ /((ёв)|(ёва)|(ёву)|(ёвым)|(ёве))$/g, "ёв" ], [ /((ин)|(ина)|(ину)|(иным)|(ине))$/g, "ин" ], [ /((ский)|(ского)|(скому)|(ским)|(ском))$/g, "ский" ], [ /((ской)|(ского)|(скому)|(ским)|(ском))$/g, "ской" ], [ /((ман)|(мана)|(ману)|(маном)|(мане))$/g, "ман" ], [ /((ой)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ой" ], [ /((ий)|(ого)|(ому)|(ого)|(им)|(ом))$/g, "ий" ], [ /((ый)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ый" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ], [ /((ян)|(яна)|(яну)|(яна)|(яном)|(яне))$/g, "ян" ] ], casesRe = [ /((ов)|(ев)|(ёв)|(ин)|(ский)|(ской)|(ой)|(ий)|(ый)|(ман)|(ич)|(ян))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((ову)|(еву)|(ёву)|(ину)|(скому)|(ому)|(ману)|(ичу)|(яну))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((овым)|(евым)|(ёвым)|(иным)|(ским)|(им)|(ым)|(маном)|(ичем)|(яном))$/g, /((ове)|(еве)|(ёве)|(ине)|(ском)|(ом)|(мане)|(иче)|(яне))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, inclineMiddleNameOrSurname = function(src, fem, male) {
    var result, _ref;
    return fem.found === (_ref = male.found) && _ref === null ? result = {
      found: !1,
      src: src,
      value: null,
      gender: null
    } : fem.found && male.found ? (result = {
      found: !0,
      src: src,
      gender: [ "male", "female" ]
    }, result.nominative_male = male.found, result.nominative_female = fem.found, result.female_cases = fem.cases, result.male_cases = male.cases, fem.cases.length === 6 ? male.cases.length === 6 ? (result.guess_sex = "unknown", result.possible_cases = util.merge(fem.cases, male.cases)) : (result.guess_sex = "male", result.nominative = male.found, result.possible_cases = male.cases) : fem.cases.length === 1 && male.cases.length > 1 ? (result.guess_sex = "female", result.nominative = fem.found, result.possible_cases = fem.cases) : result.possible_cases = util.merge(fem.cases, male.cases)) : fem.found ? male.found || (result = {
      found: !0,
      src: src,
      gender: "female",
      female_cases: fem.cases,
      guess_case: fem.guess_case,
      nominative: fem.found,
      possible_cases: fem.cases
    }) : result = {
      found: !0,
      src: src,
      gender: "male",
      male_cases: male.cases,
      guess_case: male.guess_case,
      nominative: male.found,
      possible_cases: male.cases
    }, result;
  }, exports.inclineSurname = inclinePersonSurname = function(surname) {
    return inclineMiddleNameOrSurname(surname, inclineFemaleSurname(surname), inclineMaleSurname(surname));
  }, exports.inclineMaleMiddleName = inclineMaleMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((евич)|(евича)|(евичу)|(евича)|(евичем)|(евиче))$/g, "евич" ], [ /((ович)|(овича)|(овичу)|(овича)|(овичем)|(овиче))$/g, "ович" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ] ], casesRe = [ /((евич)|(ович)|(ич))$/g, /((евича)|(овича)|(ича))$/g, /((евичу)|(овичу)|(ичу))$/g, /((евича)|(овича)|(ича))$/g, /((евичем)|(овичем)|(ичем))$/g, /((евиче)|(овиче)|(иче))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineFemMiddleName = inclineFemMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((вна)|(вны)|(вне)|(вну)|(вной)|(вне))$/g, "вна" ], [ /((чна)|(чны)|(чне)|(чну)|(чной)|(чне))$/g, "чна" ] ], casesRe = [ /((вна)|(чна))$/g, /((вны)|(чны))$/g, /((вне)|(чне))$/g, /((вну)|(чну))$/g, /((вной)|(чной))$/g, /((вне)|(чне))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineMiddleName = inclineMiddleName = function(mname) {
    return inclineMiddleNameOrSurname(mname, inclineFemMiddleName(mname), inclineMaleMiddleName(mname));
  }, genderMatch = function(g1, g2) {
    return g1 === g2 || __indexOf.call(g2, g1) >= 0 ? g1 : __indexOf.call(g1, g2) >= 0 ? g2 : null;
  }, matchNameParts = function(fn, mn, sn) {
    var overallGender, surname, theCase;
    return theCase = util.intersection(fn.possible_cases, mn.possible_cases), overallGender = genderMatch(genderMatch(fn.gender, mn.gender), sn.gender), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: mn.nominative,
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchNameAndSurname = function(fn, sn) {
    var overallGender, surname, theCase;
    return overallGender = genderMatch(fn.gender, sn.gender), theCase = util.intersection(fn.possible_cases, sn.possible_cases), theCase || (sn.possible_cases = sn["" + overallGender + "_cases"], sn.nominative = sn["nominative_" + overallGender], theCase = util.intersection(fn.possible_cases, sn.possible_cases)), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: "",
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchCase = function(pObj, target_case, gender) {
    return __indexOf.call(pObj["" + gender + "_cases"], target_case) >= 0;
  }, getNominative = function(pObj, gender) {
    var gnstr, nom;
    return gnstr = "nominative_" + gender, nom = pObj.nominative && pObj.nominative || pObj[gnstr], nom;
  }, exports.findProperName = findProperName = function(listOfWords, opts) {
    var mnr2, mnr3, nr1, nr2, nr3, result, sr1, sr2, sr3;
    opts == null && (opts = {}), result = {
      found: !1
    };
    switch (listOfWords.length) {
     case 1:
      result = inclineName(listOfWords[0]), result.found ? result.first_name = result.nominative : (result = inclinePersonSurname(listOfWords[0]), result.found && (result.surname = result.nominative));
      break;
     case 2:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr1.found && sr2.found && (result = matchNameAndSurname(nr1, sr2)), !result.found && sr1.found && nr2.found && (result = matchNameAndSurname(sr1, nr2));
      break;
     case 3:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), sr3 = inclinePersonSurname(listOfWords[2]), mnr2 = inclineMiddleName(listOfWords[1]), mnr3 = inclineMiddleName(listOfWords[2]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr3 = inclineName(listOfWords[2]), nr3.found ? result = {
        found: !1,
        error: "name at the end of 3-component proper name"
      } : nr1.found ? (mnr2.found && sr3.found && (result = matchNameParts(nr1, mnr2, sr3)), !result.found && sr2.found && (result = matchNameAndSurname(nr1, sr2))) : sr1.found && nr2.found && mnr3.found ? result = matchNameParts(nr2, mnr3, sr1) : nr2.found && sr3.found && (result = matchNameAndSurname(nr2, sr3));
    }
    return result.first_name || (result.first_name = ""), result.middle_name || (result.middle_name = ""), result.surname || (result.surname = ""), result.first_name || result.middle_name || result.surname || (result = {
      found: !1,
      error: "person not found"
    }), result.src = listOfWords.join(" "), result;
  }, exports.getInitialFormOfAdjective = function(adj) {
    var base;
    return adj = adj.toLowerCase(), /^[а-яё]{2,}(ая|ее|ие|ий|им|ими|их|ого|его|ое|ой|ом|ому|ою|ую|ые|ый|ым|ыми|ых|юю|яя)$/.test(adj) ? (/^[а-яё]{2,}(ими|ого|его|ому|ыми)$/gi.test(adj) ? base = adj.slice(0, -3) : base = adj.slice(0, -2), [ "" + base + "ый", "" + base + "ий", "" + base + "ой" ]) : null;
  }, exports.getVerbInfinitive = function(verb) {
    var pastTime, result, verbEnd;
    return verb = verb.toLowerCase(), /^[а-яё]{3,}(ать|аться|ить|иться|еть|еться|оть|оться|уть|утся|ются|ть|ться)$/.test(verb) ? verb : (/^[а-яё]{3,}(сь|ся)$/.test(verb) ? (verbEnd = verb.slice(-2), verb = verb.slice(0, -2)) : verbEnd = "", pastTime = verb.match(/^[а-яё]{3,}(л|ла|ло|ли)$/), pastTime ? result = verb.slice(0, -(1 + pastTime[1].length) + 1 || 9e9) + "ть" : /[а-яё]{3,}(у|ю|ем|ешь|ете|ет|ут|ют|им|ишь|ите|ит|ат|ят)$/.test(verb) && (/[а-яё]{3,}(ишь|ит|им|ите|ат|ят)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd ] : /[а-яё]{3,}(у|ю|ешь|ет|ем|ете|ут|ют)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd, "" + verb + "оть" + verbEnd, "" + verb + "уть" + verbEnd, "" + verb + "ть" + verbEnd ] : result = null), result);
  };
}(exports, util, ref);

var exports, ruWords, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.morpho = {}, exports = window.lastName.plugins.ru.morpho, ruWords = window.lastName.plugins.ru.words) : (exports = module.exports, ruWords = require("./words")), function(exports, ruWords) {
  var exceptions, getRulesAdjective, getRulesVerb, morphoRu;
  return exports.getWordRe = function() {
    return /^[а-я\-ё\d]+$/ig;
  }, exports.getAdjectiveEnds = function() {
    return {
      feminine: {
        ends: /((ая)|(ой)|(ую)|(яя)|(ей)|(юю))$/g,
        hard: /((ая)|(ой)|(ую))$/g,
        sort: /((яя)|(ей)|(юю))$/g,
        hardNominativeEnd: "ая",
        softNominativeEnd: "яя",
        gender: "feminine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ая" ? [ "" + word + "ая", "" + word + "ой", "" + word + "ой", "" + word + "ую", "" + word + "ой", "" + word + "ой" ] : [ "" + word + "яя", "" + word + "ей", "" + word + "ей", "" + word + "юю", "" + word + "ей", "" + word + "ей" ];
        }
      },
      masculine: {
        ends: /((ый)|(ого)|(ому)|(ым)|(ом)|(ий)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ый)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ий)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ый",
        softNominativeEnd: "ий",
        gender: "masculine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ый" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ий", "" + word + "ого", "" + word + "ому", "" + word + "ий", "" + word + "им", "" + word + "ом" ] : [ "" + word + "ый", "" + word + "ого", "" + word + "ому", "" + word + "ый", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ий", "" + word + "его", "" + word + "ему", "" + word + "ий", "" + word + "им", "" + word + "ем" ];
        }
      },
      neuter: {
        ends: /((ое)|(ого)|(ому)|(ым)|(ом)|(ее)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ое)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ее)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ое",
        softNominativeEnd: "ее",
        gender: "neuter",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ое" ? [ "" + word + "ое", "" + word + "ого", "" + word + "ому", "" + word + "ое", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ее", "" + word + "его", "" + word + "ему", "" + word + "ее", "" + word + "им", "" + word + "ем" ];
        }
      },
      plural: {
        ends: /((ые)|(ых)|(ым)|(ыми)|(ых)|(ие)|(их)|(им)|(ими)|(их))$/g,
        hard: /((ые)|(ых)|(ым)|(ыми)|(ых))$/g,
        soft: /((ие)|(их)|(им)|(ими)|(их))$/g,
        hardNominativeEnd: "ые",
        softNominativeEnd: "ие",
        gender: "unknown",
        singular: !1,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ые" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ] : [ "" + word + "ые", "" + word + "ых", "" + word + "ым", "" + word + "ые", "" + word + "ыми", "" + word + "ых" ] : [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ];
        }
      }
    };
  }, exceptions = function(word) {}, getRulesVerb = function() {
    return [ [ /нул[aи]{0,1}$/g, "ать" ], [ /еть$/g, "ать" ], [ /(ает)|(ают)$/g, "ать" ], [ /ал[aи]{0,1}$/g, "ать" ], [ /ул[aи]{0,1}$/g, "ать" ], [ /((ить)|(ать))$/g, "ать" ], [ /ая$/g, "ать" ], [ /((ил)|(или)|(ила)|(ило))$/g, "лять" ], [ /(ятся)|(ится)|(ился)|(илась)|(илось)$/g, "ится" ], [ /(яться)|(иться)$/g, "иться" ] ];
  }, getRulesAdjective = function() {
    return [ [ /в((ая)|(ые)|(ый)|(ое))$/, "вый" ], [ /((ая)|(ой)|(ие)|(ые)|(ый)|(ую))$/, "ый" ], [ /((яя)|(ее)|(ий)|(юю))$/, "ий" ] ];
  }, exports.morpho = morphoRu = function(word) {
    var adj, adjective, result, rule, verb, _i, _j, _len, _len2, _ref, _ref2;
    if (__indexOf.call(ruWords.adverbs, word) >= 0) return {
      type: "abverb",
      value: word
    };
    if (__indexOf.call(ruWords.prepositionAll, word) >= 0) return {
      type: "preposition",
      value: word
    };
    if (__indexOf.call(ruWords.unions, word) >= 0) return {
      type: "union",
      value: word
    };
    result = {
      type: "",
      value: ""
    }, verb = null, adjective = null, _ref = getRulesVerb();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      rule = _ref[_i];
      if (rule[0].test(word)) {
        result = {
          type: verb,
          value: word.replace(rule[0], rule[1])
        };
        break;
      }
    }
    _ref2 = getRulesAdjective();
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      rule = _ref2[_j];
      if (rule[0].test(word)) {
        adj = word.replace(rule[0], rule[1]), result.type ? (result.type += " adjective", result.value = [ result.value, adj ]) : result = {
          type: "adjective",
          value: adj
        };
        break;
      }
    }
    return result;
  }, exports.analyseText = function(text) {
    var doubleSpaceRe, enRe, punctuationRe, r, result, ruRe, t, wordRe, _i, _len, _ref;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&№“”\—]/g, doubleSpaceRe = /\s+/g, text = text.replace(punctuationRe, " $& ").replace(doubleSpaceRe, " ") + " .", result = [], _ref = text.split(" ");
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      t = _ref[_i], ruRe = /^[а-я\-ё]+$/ig, enRe = /^[a-z\-]+$/ig, wordRe = /^[а-яё\-\da-z]+$/ig, r = morphoRu(t.toLowerCase());
      switch (r.type) {
       case "adverb":
        result.push("[ADV " + t + "]");
        break;
       case "verb":
       case "adjective":
        result.push("[ " + r.value + " ]");
        break;
       case "verb adjective":
        result.push("[#VA " + r.value[0] + "]");
        break;
       case "union":
        result.push("[U " + t + "]");
        break;
       case "preposition":
        result.push("[PP " + t + "]");
        break;
       default:
        result.push(t);
      }
      t === "." && result.push("\n");
    }
    return result;
  }, exports.parseRuSentence = function(sentences) {
    var abbrevs, common_used_words, digits, regular_words, special_words, total_words;
    return sentences instanceof Array || (sentences = [ sentences ]), abbrevs = {}, special_words = {}, digits = {}, common_used_words = {}, regular_words = {}, total_words = 0, sentences.map(function(sent) {
      var i, result, w, word, words, _len, _ref, _results;
      words = sent.split(" "), _results = [];
      for (i = 0, _len = words.length; i < _len; i++) word = words[i], /^[[,:\/\\\?!\+\-\*\(\)\[\]\&\№\—]]+$/.test(words) || total_words++, /^(\d+(|(\.(|\d+))))$/.test(word) ? digits[word] ? _results.push(digits[word]++) : _results.push(digits[word] = 1) : isUpperCase(word) && /^[а-яё\-]{2,}$/i.test(word) ? abbrevs[word] ? _results.push(abbrevs[word]++) : _results.push(abbrevs[word] = 1) : i > 0 && isCapitalized(word) && /^[а-яё\-]{2,}$/i.test(word) ? special_words[word] ? _results.push(special_words[word]++) : _results.push(special_words[word] = 1) : /^[а-яё\-]+$/i.test(word) && !/^\-+$/.test(word) ? (w = word.toLowerCase(), result = morphoRu(w), (_ref = result.type) !== "adverb" && _ref !== "preposition" && _ref !== "union" ? regular_words[w] ? _results.push(regular_words[w]++) : _results.push(regular_words[w] = 1) : common_used_words[w] ? _results.push(common_used_words[w]++) : _results.push(common_used_words[w] = 1)) : _results.push(void 0);
      return _results;
    }), {
      abbrevs: abbrevs,
      common_used_words: common_used_words,
      special_words: special_words,
      regular_words: regular_words,
      digits: digits,
      total_words: total_words
    };
  };
}(exports, ruWords);

var exports, inclines, morpho, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.propernames = {}, exports = window.lastName.plugins.ru.propernames, morpho = window.lastName.plugins.ru.morpho, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, morpho = require("./morpho"), inclines = require("./inclines")), function(exports, morpho, inclines) {
  return exports.postFilter = function(text, result) {
    var curProperName, id, p, pn, pnDict, properNames, properNamesRe, punctuationRe, _i, _j, _len, _len2, _ref, _ref2;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&\№“”\—]/g, properNames = [], curProperName = [], properNamesRe = /[А-Я][а-яё]+(\s+[А-Я][а-яё]+){0,2}/gm, _ref = text.match(properNamesRe);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) pn = _ref[_i], curProperName = pn.replace(/\s+/g, " ").split(" "), curProperName && (pn = inclines.findProperName(curProperName), pn && pn.found && properNames.push(pn));
    pnDict = {};
    for (_j = 0, _len2 = properNames.length; _j < _len2; _j++) p = properNames[_j], id = "" + (p.first_name || "") + "-" + (p.middle_name || "") + "-" + (p.surname || ""), pnDict[id] ? (pnDict[id].count += 1, (_ref2 = p.src, __indexOf.call(pnDict[id].src, _ref2) < 0) && pnDict[id].src.push(p.src)) : (pnDict[id] = p, pnDict[id].src = [ p.src ], pnDict[id].count = 1);
    return result.propernames = pnDict;
  };
}(exports, morpho, inclines);

var exports, inclines, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName.plugins.ru.feelings = {}, exports = window.lastName.plugins.ru.feelings, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, inclines = require("./inclines")), function(exports, inclines) {
  var evaluateSentenceNeutrality, getNegativePhrasesRe, negativeAdjectives, negativeVerbs, negativeWordsIncline;
  return exports.positive = [], negativeAdjectives = {
    "агрессивный": 3,
    "атакованный": 2,
    "бедный": 2,
    "беззащитный": 2,
    "безнадежный": 3,
    "безрадостный": 2,
    "бесплодный": 3,
    "беспомощный": 3,
    "бесправный": 2,
    "бессердечный": 1,
    "бессильный": 1,
    "бесцельный": 2,
    "бесчестный": 2,
    "вздорный": 1,
    "виновный": 1,
    "ворчливый": 1,
    "враждебный": 2,
    "вспыльчивый": 1,
    "выпученный": 1,
    "выселенный": 3,
    "высмеянный": 2,
    "выхолощенный": 1,
    "глубокий": 1,
    "глупый": 2,
    "горький": 2,
    "готический": 2,
    "гротескный": 1,
    "грустный": 1,
    "грязный": 1,
    "девальвированный": 2,
    "деградировавший": 2,
    "дегуманизированный": 2,
    "дезорганизованный": 2,
    "дезориентированный": 2,
    "деморализованный": 3,
    "дерзкий": 1,
    "дерьмовый": 3,
    "дефектный": 3,
    "драматический": 3,
    "жалкий": 3,
    "жесткий": 2,
    "жестокосердный": 2,
    "заброшенный": 1,
    "забываемый": 1,
    "забывчивый": 1,
    "забытый": 2,
    "зависимый": 1,
    "заинтересованный": 1,
    "запрещенный": 3,
    "запутанный": 2,
    "застенчивый": 1,
    "застрявший": 1,
    "затравленный": 2,
    "зверский": 3,
    "злобный": 2,
    "идиотский": 3,
    "измельченный": 2,
    "измученный": 2,
    "изнасилованный": 3,
    "изолированный": 3,
    "изумленный": 1,
    "интенсивный": 1,
    "иррациональный": 2,
    "исключенный": 2,
    "искусственный": 2,
    "испуганный": 2,
    "истерический": 3,
    "исчерпанный": 2,
    "капризный": 2,
    "контролируемый": 1,
    "критический": 1,
    "ленивый": 2,
    "лишенный": 2,
    "ложный": 2,
    "мазохистский": 1,
    "мертвый": 3,
    "меченый": 2,
    "мрачный": 2,
    "мстительный": 2,
    "навязчивый": 2,
    "надоедливый": 2,
    "наказанный": 2,
    "нарушенный": 2,
    "натянутый": 2,
    "неадекватный": 2,
    "неактивный": 1,
    "небезопасный": 2,
    "небрежный": 1,
    "невежественный": 1,
    "невидимый": 1,
    "невротический": 2,
    "негуманный": 2,
    "недействительный": 1,
    "недовольный": 2,
    "недостаточный": 1,
    "недоуменный": 1,
    "незаземленный": 1,
    "незначительный": 1,
    "неискренний": 1,
    "некомпетентный": 2,
    "ненавистный": 3,
    "необщительный": 2,
    "неполный": 2,
    "неправильный": 2,
    "неприятный": 2,
    "нервный": 2,
    "нерешительный": 1,
    "несбалансированный": 1,
    "несовместимый": 2,
    "несоответствующий": 2,
    "неспособный": 3,
    "несчастный": 2,
    "неуклюжий": 2,
    "неуловимый": 1,
    "неуместный": 2,
    "нечестный": 2,
    "неэффективный": 2,
    "низкий": 1,
    "обвиняемый": 3,
    "обедненный": 1,
    "обезумевший": 3,
    "обиженный": 2,
    "обманутый": 2,
    "обозленный": 2,
    "оборонительный": 1,
    "обремененный": 1,
    "обременительный": 1,
    "обреченный": 2,
    "ограниченный": 1,
    "одержимый": 3,
    "одинокий": 2,
    "одноразовый": 1,
    "озабоченный": 2,
    "окаменелый": 1,
    "онемелый": 1,
    "опальный": 2,
    "опасный": 3,
    "опустошенный": 1,
    "опущенный": 2,
    "опьяненный": 1,
    "оскорбленный": 2,
    "осмеянный": 2,
    "острый": 1,
    "осужденный": 3,
    "осушенный": 2,
    "ответственный": 2,
    "отвратительный": 3,
    "отдаленный": 1,
    "отдельный": 1,
    "отрицательный": 2,
    "отсталый": 2,
    "отчаянный": 1,
    "ошибочный": 1,
    "параноидальный": 2,
    "паршивый": 2,
    "пассивный": 1,
    "переполненный": 2,
    "пессимистический": 2,
    "печальный": 2,
    "побежденный": 3,
    "поверхностный": 2,
    "поврежденный": 3,
    "подавленный": 2,
    "поддельный": 3,
    "покинутый": 2,
    "покорный": 1,
    "порабощенный": 3,
    "потерянный": 2,
    "потерпевший": 2,
    "потребленный": 1,
    "презираемый": 2,
    "презренный": 3,
    "презрительный": 2,
    "прерванный": 1,
    "принудительный": 2,
    "психотический": 2,
    "пустынный": 1,
    "пьяный": 2,
    "равнодушный": 1,
    "развращенный": 3,
    "раздраженный": 2,
    "раздражительный": 2,
    "разочарованный": 2,
    "разочаровывающий": 3,
    "разрушенный": 3,
    "разрушительный": 2,
    "разъяренный": 3,
    "раненый": 2,
    "ревнивый": 2,
    "садистский": 2,
    "самоубийственный": 3,
    "саркастический": 1,
    "сварливый": 1,
    "сгоревший": 3,
    "сердитый": 2,
    "серый": 1,
    "скучающий": 1,
    "скучный": 1,
    "сломанный": 2,
    "смущенный": 1,
    "созерцательный": 1,
    "сомнительный": 2,
    "спорный": 2,
    "спровоцированный": 2,
    "спутанный": 2,
    "спущенный": 2,
    "стереотипный": 1,
    "стесненный": 1,
    "странный": 1,
    "страшный": 2,
    "сумасшедший": 2,
    "тихий": 1,
    "тормозящий": 2,
    "торопливый": 2,
    "тоскливый": 3,
    "требовательный": 2,
    "тревожный": 2,
    "трудный": 2,
    "трусливый": 2,
    "тупой": 1,
    "тщеславный": 2,
    "угнетенный": 2,
    "угрюмый": 2,
    "удаляемый": 2,
    "удрученный": 2,
    "ужасный": 3,
    "уклончивый": 2,
    "униженный": 3,
    "унылый": 3,
    "урезанный": 2,
    "фальшивый": 3,
    "хаотический": 2,
    "холодный": 1,
    "хрупкий": 1,
    "цепкий": 2,
    "циничный": 2,
    "чертовский": 2,
    "чрезмерный": 2,
    "чувствительный": 2,
    "эгоистичный": 2,
    "эгоцентричный": 3,
    "эксплуатируемый": 2,
    "эмансипированный": 2,
    "эмоциональный": 1,
    "яростный": 3
  }, negativeVerbs = {
    "беспокоить": 2,
    "бить": 2,
    "внушать": 2,
    "волноваться": 2,
    "высмеивать": 2,
    "грызть": 1,
    "диктовать": 2,
    "дребезжать": 1,
    "дрожать": 1,
    "дрогнуть": 2,
    "загнать": 2,
    "запугивать": 3,
    "запутаться": 2,
    "злоупотреблять": 2,
    "игнорировать": 1,
    "избегать": 1,
    "издеваться": 3,
    "изменять": 2,
    "командовать": 1,
    "лгать": 2,
    "лишить": 2,
    "манипулировать": 2,
    "молчать": 1,
    "надувать": 1,
    "ненавидеть": 3,
    "обвинять": 2,
    "обидеть": 2,
    "опорочить": 3,
    "освистать": 3,
    "отбрасывать": 1,
    "отвлекаться": 2,
    "отклонить": 2,
    "отрекаться": 3,
    "оттолкнуть": 2,
    "паниковать": 2,
    "перепутаться": 2,
    "подавить": 3,
    "подвергаться": 2,
    "пострадать": 2,
    "предавать": 3,
    "пренебрегать": 2,
    "препятствовать": 2,
    "преследовать": 2,
    "принижаться": 2,
    "приставать": 2,
    "прослушивать": 2,
    "разгромить": 2,
    "раздражаться": 2,
    "растаскивать": 2,
    "рисковать": 2,
    "ругать": 2,
    "сдуваться": 1,
    "смолчать": 2,
    "снизиться": 1,
    "сорвать": 1,
    "сожалеть": 2,
    "соизволить": 2,
    "солгать": 2,
    "сомневаться": 2,
    "споткнуться": 1,
    "столкнуться": 2,
    "страдать": 2,
    "стрелять": 3,
    "судить": 2,
    "толкнуть": 1,
    "убить": 3,
    "убивать": 3,
    "уговаривать": 1,
    "удалять": 2,
    "уклоняться": 2,
    "унижать": 3,
    "шантажировать": 2
  }, negativeWordsIncline = {
    "боль": 2,
    "вниз": 1,
    "горе": 3,
    "дно": 2,
    "мало": 1,
    "мучение": 2,
    "недовольство": 2,
    "плохо": 2,
    "противно": 3,
    "совестно": 2,
    "только": 1,
    "ужас": 3,
    "смерть": 3,
    "неодобрительно": 2,
    "разгром": 2,
    "отчаяние": 3
  }, exports.getNegativePhrasesRe = getNegativePhrasesRe = function() {
    return [ [ /[^а-яё]при\sотягчающих\sобстоятельствах[^а-яё]/ig, 2 ], [ /[^а-яё]ненависть\sк[^а-яё]/ig, 3 ], [ /[^а-яё]в\sубыток[^а-яё]/ig, 2 ], [ /[^а-яё]сыт[аы]?\sпо\sгорло[^а-яё]/ig, 3 ], [ /[^а-яё]заслужива[ею]т\sнаказания[^а-яё]/ig, 2 ], [ /[^а-яё]находящ(егося|ейся|емся|ихся)\sпод\sугрозой\sисчезновения[^а-яё]/ig, 3 ], [ /[^а-яё]в\sзаблуждение[^а-яё]/ig, 2 ], [ /[^а-яё]сбит[аы]?\sс\sтолку[^а-яё]/ig, 2 ], [ /[^а-яё]в\sужасе[^а-яё]/ig, 3 ], [ /[^а-яё]не\sрекоменд(ую|уем|уется|овал|овала|овали)[^а-яё]/ig, 2 ], [ /[^а-яё]не\sодобря(ю|ем|л|ла|ли|ется)[^а-яё]/ig, 2 ], [ /[^а-яё]пятно\sна[^а-яё]/ig, 2 ], [ /[^а-яё]в\sклетке[^а-яё]/ig, 1 ], [ /[^а-яё]неправильно\sпонял[аи]?[^а-яё]/ig, 2 ], [ /[^а-яё]вне\sпределов\sдосягаемости[^а-яё]/ig, 1 ], [ /[^а-яё]взял[аи]?\sна[^а-яё]/ig, 2 ], [ /[^а-яё]играл[аи]?\sс[^а-яё]/ig, 2 ], [ /[^а-яё]черный\sсписок[^а-яё]/ig, 3 ], [ /[^а-яё]возбужден[оы]\sуголовн(ое|ые)\sдел[оа][^а-яё]/ig, 8 ], [ /[^а-яё]жертв(|а|ы|ам|ами)[^а-яё]/ig, 3 ] ];
  }, exports.evaluateSentenceNeutrality = evaluateSentenceNeutrality = function(sentence) {
    var adj, adjArray, adjIndex, curWords, cur_index, ind, index, m, nr, resetCurIndex, vIndex, verb, words, wrd, _i, _j, _k, _len, _len2, _len3, _ref, _ref2;
    index = 0, cur_index = 0, words = [], curWords = [], _ref = getNegativePhrasesRe();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) nr = _ref[_i], m = sentence.match(nr[0]), m && (m.map(function(wordsSequence) {
      return words.push(wordsSequence);
    }), index -= nr[1] * m.length);
    resetCurIndex = function() {
      if (cur_index) return index += cur_index, words.push(curWords), curWords = [], cur_index = 0;
    }, _ref2 = sentence.split(/\s/);
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      wrd = _ref2[_j];
      if (__indexOf.call(".,-—!?()[]", wrd) >= 0) {
        cur_index = -cur_index, resetCurIndex();
        continue;
      }
      ind = negativeWordsIncline[wrd.toLowerCase()];
      if (ind) curWords.push(wrd), cur_index = cur_index * ind || ind; else {
        adjArray = inclines.getInitialFormOfAdjective(wrd);
        if (!adjArray) verb = inclines.getVerbInfinitive(wrd), vIndex = negativeVerbs[verb], vIndex ? (curWords.push(wrd), cur_index = cur_index * vIndex || vIndex) : (cur_index = -cur_index, resetCurIndex()); else for (_k = 0, _len3 = adjArray.length; _k < _len3; _k++) {
          adj = adjArray[_k], adjIndex = negativeAdjectives[adj];
          if (adjIndex) {
            curWords.push(wrd), cur_index = cur_index * adjIndex || adjIndex;
            break;
          }
        }
      }
    }
    return resetCurIndex(-cur_index), [ index, words ];
  }, exports.postFilter = function(text, result) {
    var emoIndex, emoWords, i, index, overallIndex, s, _len, _ref, _ref2;
    emoIndex = [], overallIndex = 0, _ref = result.misc.sentences;
    for (i = 0, _len = _ref.length; i < _len; i++) s = _ref[i], _ref2 = evaluateSentenceNeutrality(s), index = _ref2[0], emoWords = _ref2[1], emoIndex.push([ index, emoWords ]), overallIndex += index;
    return result.feelings = {
      emoIndex: emoIndex,
      overallIndex: overallIndex,
      emoScore: overallIndex / result.counters.words_total || 1
    };
  };
}(exports, inclines);

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).analysis || (_base.analysis = {}), exports = window.lastName.analysis) : exports = module.exports, function(exports) {
  return exports.analyse = function(text, plugins) {
    var f, misc, postFilter, preFilters, result, util, _i, _j, _len, _len2;
    plugins == null && (plugins = []), "undefined" == typeof global ? (misc = window.lastName.misc, util = window.lastName.util) : (misc = require("./misc"), util = require("./util")), result = {}, misc.preFilter(text, result), preFilters = plugins.filter(function(plugin) {
      return "function" == typeof plugin.preFilter;
    }), postFilter = plugins.filter(function(plugin) {
      return "function" == typeof plugin.postFilter;
    });
    for (_i = 0, _len = preFilters.length; _i < _len; _i++) f = preFilters[_i], f.preFilter(text, result);
    for (_j = 0, _len2 = postFilter.length; _j < _len2; _j++) f = postFilter[_j], f.postFilter(text, result);
    return result.version = util.version, result;
  };
}(exports);

var __slice = Array.prototype.slice;

(function(lastname) {
  return lastname.version = "0.3.5", lastname.findProperName = function() {
    var args, inclines, lang;
    return lang = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [], inclines = lastname.plugins["" + lang].inclines, inclines.findProperName.apply(this, args);
  };
})(window.lastName || (window.lastName = {}));

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).misc || (_base.misc = {}), exports = window.lastName.misc) : exports = module.exports, function(exports) {
  return exports.preFilter = function(text, result) {
    var chars_total, emo, emoticons, findEmo, ind, punctuationRe, sentences, signs, signs_total, spaces_total, tempTxt, word_length_mid, words_total, _i, _len;
    signs = text.match(/[-\+=\/\.,\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]{1}/g), signs_total = signs && signs.length || 0, spaces_total = /\s/.test(text) ? text.match(/\s/g).length : 0, chars_total = text.length, words_total = text.split(/\s/).filter(function(wrd) {
      return wrd.length > 0 && !/^[-\+=\/\.\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]+$/.test(wrd);
    }).length, word_length_mid = words_total ? (chars_total - spaces_total - signs_total) / words_total : 0, emoticons = [ ":-)", "(-:", ":o)", ":)", "(:", ":->", ":-}", ":-t", ":*)", ":-)))", ":-D", "(-D", ":'-)", "%-)", ":-/", ":-I", ":~)", "(:-(", ":-(", ":-c", ":-(((", ":-<", ">:-(", ":-[", "(:-&", "%-(", ">:-<", "~ :-(", "%-(", ":/)", ":-|", ":-e", ":-X", ":-v", ":-I", ":-8(", ":-O", ":-@", ":,-(", ":'-(", "~:-o", "]:-)>", "):-)", ";->", ":-x", ":-*", "8-]", ":-J", ":-&", ":-p", ":-P", ";-)", ";)", "'-)", ":-7", "?-(", "B-D", ":-B", ":-*)", ":-9", "|-p", ":-b", "-]:-)[-", "8-I", "8-|", "|:-|", ":-]", "|-)", "|-I", "I^o", "|-O", ':-"', ":-s", ":-#", ":-!", ":-()", ":-D", "(:-$", ":-(*)", ":-')", ":-R", "%+|", "%+{", "X-(", "<:-)", "*:o)", "@;-)", "X:-)", ":>)", "&:-)", "#:-)", "8-)", "8:-)", "B-)", "B-]", "O:-)", "&8-|", ":-{", ":-)}", ":-)#", ":-Q", ":-I", ":-d~", ":-?", ":-/I", ":-) X", "{(:-)", ":-{}", "[:-)", "d :-o", "~:-(", "~~:-(", "))", "(:-I", "3:-o", "[: |]", "M-)", ":X)", ":-M", "*8((:", "O+", "O->", "||*(", "||*)", "<{:-)}", "(-: :-)", "@->-", "@==", "<')))))- <" ], emoticons.sort(function(a, b) {
      return b.length - a.length;
    }), tempTxt = text.slice(0), findEmo = [];
    for (_i = 0, _len = emoticons.length; _i < _len; _i++) {
      emo = emoticons[_i], ind = 0;
      while (ind >= 0) ind = tempTxt.indexOf(emo, ind), ind !== -1 && (findEmo.push(emo), tempTxt = tempTxt.replace(emo, ""), ind -= emo.length + 2);
    }
    return punctuationRe = /(https?\:\/\/.*[\s$])|(\.\s)|(,\s)|(\s\:)|(:\s)|(\s\/)|(\/\s)|(\s\\)(\\\s)|\?|!|\+|\'|\"|«|»|\*|\(|\)|\[|\]|\&|\№|“|”|\—/g, tempTxt = text.replace(punctuationRe, " $& ").replace(/\s+/g, " "), /[\?\!\.]\s{0,}$/.test(tempTxt) || (tempTxt += " . "), sentences = tempTxt.replace(/\s\?\s/gm, " ?? ").replace(/\s\!\s/gm, " !! ").replace(/\s\.\s/gm, " .. ").split(/[\?\!\.](\s+|$)/gm).filter(function(s) {
      return !/^\s{0,}$/.test(s);
    }), result.misc = {
      digits: util.arrayToDict(text.match(/-?((\d+[\.,]\d+)|(\d+))/ig) || []),
      emoticons: util.arrayToDict(findEmo),
      romans: util.arrayToDict(text.match(/^(?=[MDCLXVI])M*(C[MD]|D?C{0,3})(X[CL]|L?X{0,3})(I[XV]|V?I{0,3})/g) || []),
      sentences: sentences
    }, result.counters = {
      chars_total: chars_total,
      words_total: words_total,
      signs_total: signs_total,
      spaces_total: spaces_total,
      word_length_mid: word_length_mid,
      words_in_sentence_mid: sentences.length ? words_total / sentences.length : 0
    }, result;
  };
}(exports);

var exports, _base, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).util || (_base.util = {}), exports = window.lastName.util) : exports = module.exports, function(exports) {
  var capitalize, dictKeys, intersection, isCapitalized, isLowerCase, isUpperCase, merge, unique;
  return exports.version = "0.3.17", exports.capitalize = capitalize = function(s) {
    if (s) return "" + s[0].toUpperCase() + s.slice(1).toLowerCase();
  }, exports.dictKeys = dictKeys = function(dict) {
    var k, keys, v;
    keys = [];
    for (k in dict) v = dict[k], keys.push(k);
    return keys;
  }, exports.isCapitalized = isCapitalized = function(word) {
    var cap;
    return 0 <= word.indexOf("-") ? (cap = !0, word.split("-").map(function(wrd) {
      return cap && (cap = isCapitalized(wrd));
    }), cap) : word && word === capitalize(word) || !1;
  }, exports.isUpperCase = isUpperCase = function(word) {
    return word === word.toUpperCase();
  }, exports.isLowerCase = isLowerCase = function(word) {
    return word === word.toLowerCase();
  }, exports.unique = unique = function(array) {
    var key, output, value, _ref, _results;
    output = {};
    for (key = 0, _ref = array.length; 0 <= _ref ? key < _ref : key > _ref; 0 <= _ref ? key++ : key--) output[array[key]] = array[key];
    _results = [];
    for (key in output) value = output[key], _results.push(value);
    return _results;
  }, exports.merge = merge = function(l1, l2) {
    var l;
    return l = [], l1.map(function(x) {
      return l.push(x);
    }), l2.map(function(x) {
      return l.push(x);
    }), unique(l);
  }, exports.intersection = intersection = function(l1, l2) {
    var i, _i, _len;
    for (_i = 0, _len = l1.length; _i < _len; _i++) {
      i = l1[_i];
      if (__indexOf.call(l2, i) >= 0) return i;
    }
    return null;
  }, exports.arrayToDict = function(arr) {
    var d, i, _i, _len;
    d = {};
    for (_i = 0, _len = arr.length; _i < _len; _i++) i = arr[_i], d[i] ? d[i]++ : d[i] = 1;
    return d;
  };
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.ref = {}, exports = window.lastName.plugins.ru.ref) : exports = module.exports, function(exports) {
  return exports.ruFemaleNamesDict = {
    "альвина": 1,
    "анелия": 1,
    "августа": 1,
    "августина": 1,
    "авдотья": 1,
    "авелина": 1,
    "аврелия": 1,
    "аврора": 1,
    "агапия": 1,
    "агата": 1,
    "агафья": 1,
    "агафия": 1,
    "аглаида": 1,
    "аглая": 1,
    "агнеса": 1,
    "агнесса": 1,
    "агния": 1,
    "агриппмеа": 1,
    "агрефена": 1,
    "ада": 1,
    "адина": 1,
    "адель": 1,
    "аделия": 1,
    "аделаида": 1,
    "аза": 1,
    "азалия": 1,
    "аида": 1,
    "айседора": 1,
    "айсылу": 1,
    "акилина": 1,
    "акулина": 1,
    "аксинья": 1,
    "алевтина": 1,
    "александра": 1,
    "алеся": 1,
    "алена": 1,
    "алина": 1,
    "алиса": 1,
    "алия": 1,
    "алла": 1,
    "алика": 1,
    "альбина": 1,
    "альмир": 1,
    "альфия": 1,
    "амина": 1,
    "анастасия": 1,
    "анатолия": 1,
    "ангелина": 1,
    "анжела": 1,
    "анимаиса": 1,
    "анисия": 1,
    "анисья": 1,
    "анна": 1,
    "анита": 1,
    "антонина": 1,
    "антонида": 1,
    "антония": 1,
    "анфиса": 1,
    "анфуса": 1,
    "анфия": 1,
    "амира": 1,
    "аполлинария": 1,
    "аревик": 1,
    "ариадна": 1,
    "арина": 1,
    "аркадия": 1,
    "арсения": 1,
    "арсиана": 1,
    "артемия": 1,
    "асель": 1,
    "аста": 1,
    "астра": 1,
    "астрид": 1,
    "афанасия": 1,
    "афродита": 1,
    "аэлита": 1,
    "аэлла": 1,
    "амалия": 1,
    "бажена": 1,
    "беата": 1,
    "беатриса": 1,
    "бела": 1,
    "белла": 1,
    "беллатриса": 1,
    "берта": 1,
    "богдана": 1,
    "божена": 1,
    "болеслава": 1,
    "борислава": 1,
    "бриджет": 1,
    "бронислава": 1,
    "валентина": 1,
    "валерия": 1,
    "ванда": 1,
    "варвара": 1,
    "василина": 1,
    "василиса": 1,
    "васса": 1,
    "вацлава": 1,
    "вевея": 1,
    "велора": 1,
    "велория": 1,
    "венера": 1,
    "вера": 1,
    "вероника": 1,
    "веселина": 1,
    "веста": 1,
    "видана": 1,
    "викторина": 1,
    "виктория": 1,
    "вилена": 1,
    "виола": 1,
    "виолетта": 1,
    "виоланта": 1,
    "виринея": 1,
    "вита": 1,
    "виталия": 1,
    "виталина": 1,
    "виулена": 1,
    "влада": 1,
    "владилена": 1,
    "владимира": 1,
    "владислава": 1,
    "владлена": 1,
    "власта": 1,
    "воля": 1,
    "всеслава": 1,
    "гайя": 1,
    "гали": 1,
    "галина": 1,
    "ганна": 1,
    "гаяна": 1,
    "гаяния": 1,
    "гвинет": 1,
    "гелена": 1,
    "гелия": 1,
    "гелла": 1,
    "генриетта": 1,
    "гертруда": 1,
    "глафира": 1,
    "гликерия": 1,
    "глория": 1,
    "голуба": 1,
    "горислава": 1,
    "гюльанэ": 1,
    "гюльнара": 1,
    "гюльчитай": 1,
    "даздраперма": 1,
    "дайна": 1,
    "дана": 1,
    "дарья": 1,
    "дария": 1,
    "дарина": 1,
    "дарьяна": 1,
    "декабрина": 1,
    "дея": 1,
    "дия": 1,
    "джиневра": 1,
    "дженнифер": 1,
    "джульета": 1,
    "дианна": 1,
    "дилия": 1,
    "диля": 1,
    "дильфуза": 1,
    "дина": 1,
    "диния": 1,
    "диодора": 1,
    "дионисия": 1,
    "добрава": 1,
    "домна": 1,
    "домина": 1,
    "домника": 1,
    "доминика": 1,
    "донара": 1,
    "дорофея": 1,
    "доротея": 1,
    "ева": 1,
    "евгения": 1,
    "евдокия": 1,
    "евлалия": 1,
    "евлампия": 1,
    "евпраксия": 1,
    "евстолия": 1,
    "евфалия": 1,
    "евфросиния": 1,
    "екатерина": 1,
    "елена": 1,
    "елизавета": 1,
    "еликонида": 1,
    "ермиония": 1,
    "есения": 1,
    "ефимия": 1,
    "евфремия": 1,
    "жанна": 1,
    "ждана": 1,
    "жаннэ": 1,
    "жасмина": 1,
    "забава": 1,
    "заира": 1,
    "зара": 1,
    "зарема": 1,
    "зарина": 1,
    "зорина": 1,
    "заряна": 1,
    "зауре": 1,
    "звенислава": 1,
    "земфира": 1,
    "зиля": 1,
    "зинаида": 1,
    "зиновия": 1,
    "злата": 1,
    "зозан": 1,
    "зоя": 1,
    "зульфия": 1,
    "иванна": 1,
    "ида": 1,
    "илария": 1,
    "илиана": 1,
    "илона": 1,
    "ильмира": 1,
    "инга": 1,
    "индира": 1,
    "инесса": 1,
    "инна": 1,
    "иоанна": 1,
    "иона": 1,
    "ипатия": 1,
    "ипполита": 1,
    "ирада": 1,
    "ираида": 1,
    "ирена": 1,
    "ироида": 1,
    "ираклия": 1,
    "ирина": 1,
    "исидора": 1,
    "искра": 1,
    "ифигения": 1,
    "ия": 1,
    "кадрия": 1,
    "кермен": 1,
    "калиса": 1,
    "каллиста": 1,
    "камилла": 1,
    "камила": 1,
    "капитолина": 1,
    "карина": 1,
    "каролина": 1,
    "катерина": 1,
    "кира": 1,
    "кирилла": 1,
    "клавдия": 1,
    "клара": 1,
    "клариса": 1,
    "кларисса": 1,
    "клеопатра": 1,
    "клио": 1,
    "клер": 1,
    "конкордия": 1,
    "констанция": 1,
    "кристина": 1,
    "ксения": 1,
    "лавиния": 1,
    "лада": 1,
    "лана": 1,
    "лариса": 1,
    "лаура": 1,
    "лейла": 1,
    "лема": 1,
    "лена": 1,
    "лениана": 1,
    "ленина": 1,
    "леонида": 1,
    "леонила": 1,
    "леонтия": 1,
    "леся": 1,
    "ливия": 1,
    "лидия": 1,
    "лилиана": 1,
    "лилия": 1,
    "лилит": 1,
    "лина": 1,
    "лира": 1,
    "лия": 1,
    "лея": 1,
    "лора": 1,
    "луиза": 1,
    "лукерия": 1,
    "лукиана": 1,
    "лукина": 1,
    "люцина": 1,
    "лусинэ": 1,
    "любава": 1,
    "любовь": 1,
    "любомира": 1,
    "людмила": 1,
    "ляля": 1,
    "мавра": 1,
    "магда": 1,
    "магдалина": 1,
    "мадлен": 1,
    "майя": 1,
    "мая": 1,
    "мальвина": 1,
    "маргарита": 1,
    "мариана": 1,
    "марьяна": 1,
    "марианна": 1,
    "мариетта": 1,
    "мариэтта": 1,
    "марика": 1,
    "марина": 1,
    "мария": 1,
    "марья": 1,
    "мари": 1,
    "марлен": 1,
    "марлена": 1,
    "марта": 1,
    "марфа": 1,
    "матильда": 1,
    "матрена": 1,
    "матрёна": 1,
    "матрона": 1,
    "мелания": 1,
    "меланья": 1,
    "мелитина": 1,
    "милада": 1,
    "милана": 1,
    "милен": 1,
    "милица": 1,
    "милия": 1,
    "милослава": 1,
    "мира": 1,
    "мирра": 1,
    "мирослава": 1,
    "митродора": 1,
    "млада": 1,
    "мстислава": 1,
    "нада": 1,
    "надежда": 1,
    "надия": 1,
    "наина": 1,
    "наира": 1,
    "нана": 1,
    "настасья": 1,
    "наталья": 1,
    "наталия": 1,
    "нелли": 1,
    "неонила": 1,
    "ника": 1,
    "нина": 1,
    "нинелла": 1,
    "нинель": 1,
    "новелла": 1,
    "нонна": 1,
    "нора": 1,
    "нуркыз": 1,
    "насиба": 1,
    "оксана": 1,
    "октавия": 1,
    "октябрина": 1,
    "олеся": 1,
    "оливия": 1,
    "олимпиада": 1,
    "олимпия": 1,
    "ольга": 1,
    "офелия": 1,
    "павла": 1,
    "павлина": 1,
    "патриция": 1,
    "пелагея": 1,
    "платонида": 1,
    "поликсена": 1,
    "полина": 1,
    "правдина": 1,
    "прасковья": 1,
    "пенелопа": 1,
    "полислава": 1,
    "рада": 1,
    "радмила": 1,
    "раиса": 1,
    "раймонда": 1,
    "раялла": 1,
    "ревмира": 1,
    "регина": 1,
    "рената": 1,
    "римма": 1,
    "рогнеда": 1,
    "роза": 1,
    "розалина": 1,
    "розалия": 1,
    "розана": 1,
    "роксан": 1,
    "ростислава": 1,
    "руслана": 1,
    "руфина": 1,
    "руфь": 1,
    "раида": 1,
    "сабина": 1,
    "сабрина": 1,
    "саломея": 1,
    "соломея": 1,
    "самира": 1,
    "светлана": 1,
    "светозара": 1,
    "светослава": 1,
    "свобода": 1,
    "святослава": 1,
    "севастьяна": 1,
    "северина": 1,
    "селена": 1,
    "селина": 1,
    "селестина": 1,
    "серафима": 1,
    "сергияна": 1,
    "сильва": 1,
    "агриппина": 1,
    "алёна": 1,
    "вилора": 1,
    "вилория": 1,
    "джульетта": 1,
    "диана": 1,
    "евфимия": 1,
    "ефросиния": 1,
    "калерия": 1,
    "милена": 1,
    "муза": 1,
    "савина": 1,
    "сильвия": 1,
    "симона": 1,
    "слава": 1,
    "славяна": 1,
    "снежана": 1,
    "софья": 1,
    "софия": 1,
    "станислава": 1,
    "стелла": 1,
    "степанида": 1,
    "стефанида": 1,
    "стефания": 1,
    "сусанна": 1,
    "сосанна": 1,
    "сюзанна": 1,
    "таира": 1,
    "таисия": 1,
    "тальяна": 1,
    "тамара": 1,
    "тамила": 1,
    "томила": 1,
    "татьяна": 1,
    "текуса": 1,
    "тереза": 1,
    "улита": 1,
    "ульяна": 1,
    "услада": 1,
    "устинья": 1,
    "фаина": 1,
    "февронья": 1,
    "феликсана": 1,
    "фелицата": 1,
    "фелицитата": 1,
    "фелиция": 1,
    "федора": 1,
    "феодора": 1,
    "феодосия": 1,
    "феодосья": 1,
    "феоктиста": 1,
    "феофания": 1,
    "феона": 1,
    "флавия": 1,
    "флора": 1,
    "флория": 1,
    "флорентина": 1,
    "флоренция": 1,
    "флориана": 1,
    "фотина": 1,
    "харита": 1,
    "харитина": 1,
    "хиония": 1,
    "христина": 1,
    "цецилия": 1,
    "чеслава": 1,
    "эвелина": 1,
    "эвридика": 1,
    "эдда": 1,
    "элеонора": 1,
    "элина": 1,
    "эльвира": 1,
    "эльмира": 1,
    "эльза": 1,
    "эмилия": 1,
    "эмма": 1,
    "эрика": 1,
    "эсфирь": 1,
    "юдифь": 1,
    "юзефа": 1,
    "юлиана": 1,
    "юлитта": 1,
    "юлия": 1,
    "юманита": 1,
    "юния": 1,
    "юнона": 1,
    "юстина": 1,
    "ядвига": 1,
    "яна": 1,
    "янина": 1,
    "яромира": 1,
    "ярослава": 1
  }, exports.ruMaleNamesDict = {
    "ааран": 1,
    "аарен": 1,
    "ааррон": 1,
    "аб": 1,
    "аббат": 1,
    "абботт": 1,
    "абей": 1,
    "абелл": 1,
    "абель": 1,
    "абнар": 1,
    "абнер": 1,
    "абнор": 1,
    "абот": 1,
    "аботт": 1,
    "абрам": 1,
    "абран": 1,
    "абрахам": 1,
    "абсалон": 1,
    "авангард": 1,
    "август": 1,
    "августин": 1,
    "авдей": 1,
    "авдий": 1,
    "авенир": 1,
    "аверилл": 1,
    "аверкий": 1,
    "авксентий": 1,
    "аврам": 1,
    "аврор": 1,
    "аврорий": 1,
    "агап": 1,
    "аггей": 1,
    "агей": 1,
    "адам": 1,
    "аддам": 1,
    "аддисон": 1,
    "аден": 1,
    "адий": 1,
    "адисон": 1,
    "адиссон": 1,
    "адлэй": 1,
    "адней": 1,
    "адольф": 1,
    "адонис": 1,
    "адриан": 1,
    "адэйр": 1,
    "адэр": 1,
    "азия": 1,
    "азэлстан": 1,
    "айбл": 1,
    "айзек": 1,
    "айк": 1,
    "ак": 1,
    "акей": 1,
    "акерлеа": 1,
    "акерлей": 1,
    "акерли": 1,
    "аки": 1,
    "аким": 1,
    "аклеа": 1,
    "аклей": 1,
    "акли": 1,
    "аксён": 1,
    "актон": 1,
    "акэль": 1,
    "алан": 1,
    "аластеир": 1,
    "аластэйр": 1,
    "алвар": 1,
    "алвен": 1,
    "алви": 1,
    "алвин": 1,
    "алвис": 1,
    "алгар": 1,
    "алджернон": 1,
    "алевтин": 1,
    "алеистер": 1,
    "алек": 1,
    "алекс": 1,
    "александр": 1,
    "алексей": 1,
    "ален": 1,
    "алестер": 1,
    "алжир": 1,
    "алик": 1,
    "аликс": 1,
    "алим": 1,
    "алисандр": 1,
    "алисдэйр": 1,
    "алиссандр": 1,
    "алистер": 1,
    "алистэйр": 1,
    "аллан": 1,
    "аллен": 1,
    "аллин": 1,
    "аллистер": 1,
    "аллистир": 1,
    "аллистэйр": 1,
    "алтон": 1,
    "алф": 1,
    "алфонзо": 1,
    "алфорд": 1,
    "алфрид": 1,
    "альберт": 1,
    "альбин": 1,
    "альвиан": 1,
    "альвин": 1,
    "альдина": 1,
    "альпин": 1,
    "альтаир": 1,
    "альфа": 1,
    "альфи": 1,
    "альфред": 1,
    "алэйстер": 1,
    "алэйстэйр": 1,
    "амби": 1,
    "амброуз": 1,
    "амедеус": 1,
    "амиас": 1,
    "амори": 1,
    "амос": 1,
    "амьяс": 1,
    "анакин": 1,
    "ананий": 1,
    "анастасий": 1,
    "анатолий": 1,
    "анвар": 1,
    "ангел": 1,
    "ангес": 1,
    "андерсон": 1,
    "анджелл": 1,
    "андрей": 1,
    "андреян": 1,
    "андриан": 1,
    "андрон": 1,
    "анж": 1,
    "анис": 1,
    "анисий": 1,
    "анисим": 1,
    "анри": 1,
    "анском": 1,
    "анскомб": 1,
    "ансон": 1,
    "антван": 1,
    "антип": 1,
    "антон": 1,
    "антоний": 1,
    "антонин": 1,
    "антуан": 1,
    "аполлинарий": 1,
    "аполлон": 1,
    "арам": 1,
    "арвид": 1,
    "аргент": 1,
    "арден": 1,
    "арефий": 1,
    "арий": 1,
    "арик": 1,
    "арил": 1,
    "арин": 1,
    "аристарх": 1,
    "аркадий": 1,
    "аркелл": 1,
    "арлен": 1,
    "арли": 1,
    "арман": 1,
    "армен": 1,
    "арн": 1,
    "арне": 1,
    "арни": 1,
    "арнольд": 1,
    "арран": 1,
    "аррин": 1,
    "аррон": 1,
    "арсен": 1,
    "арсений": 1,
    "арт": 1,
    "артамон": 1,
    "артемий": 1,
    "арти": 1,
    "артур": 1,
    "артём": 1,
    "архип": 1,
    "арчи": 1,
    "арчибальд": 1,
    "аселет": 1,
    "аселин": 1,
    "асер": 1,
    "аскольд": 1,
    "астон": 1,
    "атеист": 1,
    "афанасий": 1,
    "афиноген": 1,
    "афтон": 1,
    "аффтон": 1,
    "ахмат": 1,
    "ахмет": 1,
    "ачилл": 1,
    "аш": 1,
    "ашер": 1,
    "ашот": 1,
    "аштон": 1,
    "баграт": 1,
    "бад": 1,
    "бадди": 1,
    "бажен": 1,
    "баз": 1,
    "базилик": 1,
    "байрон": 1,
    "байярд": 1,
    "бак": 1,
    "бакстер": 1,
    "балдер": 1,
    "балдрик": 1,
    "бамби": 1,
    "баптист": 1,
    "бардолф": 1,
    "барии": 1,
    "барклей": 1,
    "барнабас": 1,
    "барни": 1,
    "барнэби": 1,
    "барретт": 1,
    "барри": 1,
    "барт": 1,
    "бартоломей": 1,
    "бассетт": 1,
    "бастер": 1,
    "бастиан": 1,
    "батч": 1,
    "баян": 1,
    "беван": 1,
    "беверли": 1,
    "бевис": 1,
    "бедивир": 1,
    "бейб": 1,
    "бейлей": 1,
    "бейлие": 1,
    "бен": 1,
    "бенджамин": 1,
    "бенджи": 1,
    "бенедикт": 1,
    "бенет": 1,
    "беннетт": 1,
    "бенни": 1,
    "бенние": 1,
    "бенсон": 1,
    "бентлей": 1,
    "бентон": 1,
    "беорегард": 1,
    "бердт": 1,
    "беренгар": 1,
    "беренджер": 1,
    "берет": 1,
    "бернард": 1,
    "берни": 1,
    "берри": 1,
    "берт": 1,
    "берти": 1,
    "бертольд": 1,
    "бертон": 1,
    "бертрам": 1,
    "бертран": 1,
    "бивис": 1,
    "билл": 1,
    "билли": 1,
    "бисш": 1,
    "биф": 1,
    "блейн": 1,
    "близэ": 1,
    "блисс": 1,
    "блэйз": 1,
    "блэйк": 1,
    "блэйн": 1,
    "блэр": 1,
    "боб": 1,
    "бобби": 1,
    "богдан": 1,
    "боеслав": 1,
    "болдуин": 1,
    "болеслав": 1,
    "боллард": 1,
    "бомонт": 1,
    "бонифэйс": 1,
    "боримир": 1,
    "борис": 1,
    "борислав": 1,
    "боян": 1,
    "брадлей": 1,
    "браеден": 1,
    "брайен": 1,
    "брайон": 1,
    "бранден": 1,
    "брандон": 1,
    "браннон": 1,
    "брейден": 1,
    "брейдн": 1,
    "брендан": 1,
    "бренден": 1,
    "брендон": 1,
    "бреннан": 1,
    "брент": 1,
    "брентон": 1,
    "брет": 1,
    "бретт": 1,
    "бриар": 1,
    "брион": 1,
    "брис": 1,
    "бриско": 1,
    "бриттон": 1,
    "бриэм": 1,
    "бродерик": 1,
    "броди": 1,
    "броз": 1,
    "брок": 1,
    "бронислав": 1,
    "бронт": 1,
    "броуди": 1,
    "броук": 1,
    "брук": 1,
    "брукс": 1,
    "бруно": 1,
    "брутус": 1,
    "брьянт": 1,
    "брэд": 1,
    "брэди": 1,
    "брэдфорд": 1,
    "брэйден": 1,
    "брэйди": 1,
    "брэм": 1,
    "брэн": 1,
    "брюс": 1,
    "брююс": 1,
    "будимир": 1,
    "буз": 1,
    "букер": 1,
    "булат": 1,
    "бью": 1,
    "бэйли": 1,
    "вавила": 1,
    "вадим": 1,
    "вал": 1,
    "валентайн": 1,
    "валентин": 1,
    "валериан": 1,
    "валерий": 1,
    "валерьян": 1,
    "вальдемар": 1,
    "вальтер": 1,
    "ванадий": 1,
    "вард": 1,
    "варлаам": 1,
    "варлам": 1,
    "варлен": 1,
    "вартан": 1,
    "варфоломей": 1,
    "василий": 1,
    "василько": 1,
    "ваухан": 1,
    "вахтанг": 1,
    "вацлав": 1,
    "вашингтон": 1,
    "вебстер": 1,
    "велдон": 1,
    "велимир": 1,
    "велислав": 1,
    "велор": 1,
    "велорий": 1,
    "венедикт": 1,
    "вениамин": 1,
    "вер": 1,
    "вергилий": 1,
    "верджил": 1,
    "верн": 1,
    "вернон": 1,
    "вестер": 1,
    "вестлей": 1,
    "вестон": 1,
    "вик": 1,
    "викентий": 1,
    "виктор": 1,
    "вил": 1,
    "вилберн": 1,
    "вилей": 1,
    "вилен": 1,
    "вилий": 1,
    "вилиор": 1,
    "вилки": 1,
    "вилл": 1,
    "вилли": 1,
    "виллоби": 1,
    "вилмар": 1,
    "вилмер": 1,
    "вилмот": 1,
    "вилор": 1,
    "вилорг": 1,
    "вилорий": 1,
    "вилсон": 1,
    "вилф": 1,
    "вилфорд": 1,
    "виль": 1,
    "вильгельм": 1,
    "вильтон": 1,
    "вильям": 1,
    "вин": 1,
    "виндзор": 1,
    "винни": 1,
    "винс": 1,
    "винсент": 1,
    "винслоу": 1,
    "винтроп": 1,
    "винцент": 1,
    "виолен": 1,
    "вирджиль": 1,
    "виссарион": 1,
    "вистан": 1,
    "виталий": 1,
    "витейкр": 1,
    "витней": 1,
    "витольд": 1,
    "влад": 1,
    "владелин": 1,
    "владилен": 1,
    "владимир": 1,
    "владислав": 1,
    "владлен": 1,
    "влас": 1,
    "власий": 1,
    "воган": 1,
    "вогн": 1,
    "воин": 1,
    "воислав": 1,
    "волдо": 1,
    "волемир": 1,
    "волкер": 1,
    "воллис": 1,
    "володар": 1,
    "вольдемар": 1,
    "вольмир": 1,
    "вольт": 1,
    "вольф": 1,
    "вольфрам": 1,
    "воспой": 1,
    "всеволод": 1,
    "всемил": 1,
    "вуди": 1,
    "вудроу": 1,
    "вулф": 1,
    "вьятт": 1,
    "вэйд": 1,
    "вэйланд": 1,
    "вэнс": 1,
    "вячеслав": 1,
    "габби": 1,
    "габриель": 1,
    "габриэль": 1,
    "гавриил": 1,
    "гаврил": 1,
    "гаврила": 1,
    "гаврило": 1,
    "гай": 1,
    "гайдар": 1,
    "гайлс": 1,
    "галактион": 1,
    "гален": 1,
    "галий": 1,
    "гамильтон": 1,
    "гамлет": 1,
    "гантэр": 1,
    "гаральд": 1,
    "гарван": 1,
    "гарей": 1,
    "гарибальди": 1,
    "гарланд": 1,
    "гарнет": 1,
    "гарольд": 1,
    "гарри": 1,
    "гаррий": 1,
    "гарс": 1,
    "гарфилд": 1,
    "гас": 1,
    "гаспар": 1,
    "гваделупа": 1,
    "гвидон": 1,
    "гейб": 1,
    "гейл": 1,
    "гейр": 1,
    "гектор": 1,
    "гелеон": 1,
    "гелиан": 1,
    "гелий": 1,
    "ген": 1,
    "гений": 1,
    "геннадий": 1,
    "генри": 1,
    "генрих": 1,
    "геодар": 1,
    "георгий": 1,
    "геральд": 1,
    "герасим": 1,
    "герберт": 1,
    "герман": 1,
    "гермоген": 1,
    "герольд": 1,
    "геронт": 1,
    "геронтий": 1,
    "герт": 1,
    "гертруд": 1,
    "гидеон": 1,
    "гильберт": 1,
    "гисберт": 1,
    "гладвин": 1,
    "гланвилл": 1,
    "глеб": 1,
    "глендауэр": 1,
    "гленн": 1,
    "глэн": 1,
    "говард": 1,
    "годвин": 1,
    "годфри": 1,
    "голлагэр": 1,
    "голладжер": 1,
    "гомер": 1,
    "горазд": 1,
    "гораций": 1,
    "горд": 1,
    "гордей": 1,
    "горден": 1,
    "гордий": 1,
    "гордон": 1,
    "горимир": 1,
    "горислав": 1,
    "горн": 1,
    "граем": 1,
    "грай": 1,
    "гранвилл": 1,
    "гранд": 1,
    "гранит": 1,
    "грахэйм": 1,
    "грег": 1,
    "грей": 1,
    "гренвилл": 1,
    "григорий": 1,
    "гриир": 1,
    "грир": 1,
    "гриффин": 1,
    "гриффит": 1,
    "гровер": 1,
    "грэг": 1,
    "грэгори": 1,
    "грэди": 1,
    "грэм": 1,
    "гудвин": 1,
    "гудзон": 1,
    "гурий": 1,
    "густав": 1,
    "гэй": 1,
    "гэйбл": 1,
    "гэйг": 1,
    "гэйдж": 1,
    "гэйелорд": 1,
    "гэйл": 1,
    "гэйлон": 1,
    "гэйлорд": 1,
    "гэйр": 1,
    "гэлл": 1,
    "гэри": 1,
    "давей": 1,
    "дави": 1,
    "давид": 1,
    "давыд": 1,
    "дад": 1,
    "дадда": 1,
    "дадли": 1,
    "даймонд": 1,
    "дакей": 1,
    "дакота": 1,
    "дакс": 1,
    "далтон": 1,
    "дамайон": 1,
    "дамиан": 1,
    "дамир": 1,
    "дан": 1,
    "дана": 1,
    "дани": 1,
    "даниар": 1,
    "даниил": 1,
    "данил": 1,
    "данила": 1,
    "данило": 1,
    "даниэль": 1,
    "данки": 1,
    "данни": 1,
    "дар": 1,
    "дарби": 1,
    "дарвин": 1,
    "дарден": 1,
    "дарен": 1,
    "дариан": 1,
    "дарил": 1,
    "дарин": 1,
    "дарки": 1,
    "дарнелл": 1,
    "даррел": 1,
    "даррен": 1,
    "даррил": 1,
    "даррин": 1,
    "даррэль": 1,
    "дасти": 1,
    "дастин": 1,
    "дау": 1,
    "дафф": 1,
    "даффи": 1,
    "дашилл": 1,
    "дван": 1,
    "двэйн": 1,
    "деай": 1,
    "деван": 1,
    "девен": 1,
    "девереукс": 1,
    "девин": 1,
    "девон": 1,
    "дейв": 1,
    "дейл": 1,
    "дейрлл": 1,
    "дейрн": 1,
    "декабрий": 1,
    "деклан": 1,
    "декстер": 1,
    "делберт": 1,
    "делл": 1,
    "делмар": 1,
    "делрой": 1,
    "дементий": 1,
    "деметриус": 1,
    "демид": 1,
    "демократ": 1,
    "демон": 1,
    "демьян": 1,
    "ден": 1,
    "денвер": 1,
    "денеб": 1,
    "дензэль": 1,
    "дени": 1,
    "денил": 1,
    "денис": 1,
    "деннис": 1,
    "дентон": 1,
    "деон": 1,
    "деонн": 1,
    "деонт": 1,
    "дерби": 1,
    "дерек": 1,
    "дерик": 1,
    "дермот": 1,
    "дерок": 1,
    "деррен": 1,
    "дерри": 1,
    "деррил": 1,
    "дефорест": 1,
    "дефоррест": 1,
    "дешон": 1,
    "джадд": 1,
    "джадин": 1,
    "джай": 1,
    "джайлс": 1,
    "джак": 1,
    "джамар": 1,
    "джамей": 1,
    "джамисон": 1,
    "джарвис": 1,
    "джаред": 1,
    "джарод": 1,
    "джарред": 1,
    "джарретт": 1,
    "джаррод": 1,
    "джаспер": 1,
    "джасти": 1,
    "джастин": 1,
    "джеб": 1,
    "джед": 1,
    "джедидиа": 1,
    "джейдн": 1,
    "джейк": 1,
    "джейлн": 1,
    "джейми": 1,
    "джеймс": 1,
    "джейрт": 1,
    "джейсон": 1,
    "джекки": 1,
    "джекоб": 1,
    "джем": 1,
    "дженкин": 1,
    "джеп": 1,
    "джер": 1,
    "джералд": 1,
    "джеральд": 1,
    "джерард": 1,
    "джерваз": 1,
    "джервис": 1,
    "джереми": 1,
    "джери": 1,
    "джермэйн": 1,
    "джеролд": 1,
    "джером": 1,
    "джеррард": 1,
    "джерред": 1,
    "джерри": 1,
    "джеррод": 1,
    "джерролд": 1,
    "джес": 1,
    "джесси": 1,
    "джетро": 1,
    "джетт": 1,
    "джеф": 1,
    "джеффери": 1,
    "джефферсон": 1,
    "джеффрей": 1,
    "джеффри": 1,
    "джиб": 1,
    "джид": 1,
    "джиди": 1,
    "джил": 1,
    "джим": 1,
    "джими": 1,
    "джимми": 1,
    "джисберт": 1,
    "джиффард": 1,
    "джо": 1,
    "джоб": 1,
    "джоби": 1,
    "джоджо": 1,
    "джоди": 1,
    "джозеф": 1,
    "джой": 1,
    "джойс": 1,
    "джон": 1,
    "джоназан": 1,
    "джоназон": 1,
    "джонасон": 1,
    "джонатан": 1,
    "джоней": 1,
    "джони": 1,
    "джонни": 1,
    "джонти": 1,
    "джорги": 1,
    "джордан": 1,
    "джордж": 1,
    "джорди": 1,
    "джордон": 1,
    "джосс": 1,
    "джоул": 1,
    "джош": 1,
    "джошоа": 1,
    "джошуа": 1,
    "джулс": 1,
    "джульян": 1,
    "джустис": 1,
    "джьюд": 1,
    "джэй": 1,
    "джэйд": 1,
    "джэйда": 1,
    "джэйден": 1,
    "джэйдон": 1,
    "джэйкоб": 1,
    "джэйлен": 1,
    "джэйлин": 1,
    "джэйлон": 1,
    "джэймес": 1,
    "джэйсон": 1,
    "джэксон": 1,
    "джэмини": 1,
    "джэмми": 1,
    "джэн": 1,
    "ди": 1,
    "диакон": 1,
    "дигби": 1,
    "диггори": 1,
    "дигори": 1,
    "дидим": 1,
    "дизон": 1,
    "дик": 1,
    "дики": 1,
    "дикки": 1,
    "дил": 1,
    "дилан": 1,
    "дилберт": 1,
    "димер": 1,
    "димитрий": 1,
    "дин": 1,
    "диндр": 1,
    "дионис": 1,
    "дионисий": 1,
    "дирк": 1,
    "дмитрий": 1,
    "доб": 1,
    "добрыня": 1,
    "додж": 1,
    "дольф": 1,
    "дом": 1,
    "доменик": 1,
    "доминик": 1,
    "дон": 1,
    "дональд": 1,
    "дональт": 1,
    "донат": 1,
    "донни": 1,
    "донован": 1,
    "дор": 1,
    "дориан": 1,
    "дорофей": 1,
    "доусон": 1,
    "драйк": 1,
    "древ": 1,
    "дрейвн": 1,
    "дуайт": 1,
    "дуан": 1,
    "дуг": 1,
    "дуги": 1,
    "дуглас": 1,
    "дункан": 1,
    "дунстан": 1,
    "дью": 1,
    "дьюей": 1,
    "дьюэйн": 1,
    "дэвид": 1,
    "дэвис": 1,
    "дэй": 1,
    "дэйви": 1,
    "дэйн": 1,
    "дэйтон": 1,
    "дэн": 1,
    "дэни": 1,
    "дэниел": 1,
    "дэнни": 1,
    "дэррик": 1,
    "дэшон": 1,
    "дюк": 1,
    "евгений": 1,
    "евграф": 1,
    "евдоким": 1,
    "евлампий": 1,
    "евлогий": 1,
    "евсей": 1,
    "евстафий": 1,
    "егор": 1,
    "елеазар": 1,
    "елизар": 1,
    "елисей": 1,
    "емельян": 1,
    "епифан": 1,
    "еремей": 1,
    "ермак": 1,
    "ермил": 1,
    "ермолай": 1,
    "ерофей": 1,
    "еруслан": 1,
    "ефим": 1,
    "ефрем": 1,
    "ждан": 1,
    "жерар": 1,
    "жозеф": 1,
    "жорес": 1,
    "жюль": 1,
    "завир": 1,
    "зак": 1,
    "закери": 1,
    "зандер": 1,
    "захар": 1,
    "захарий": 1,
    "зачариа": 1,
    "зачэри": 1,
    "зед": 1,
    "зедекиа": 1,
    "зек": 1,
    "зигмунд": 1,
    "зигфрид": 1,
    "зиновий": 1,
    "зорий": 1,
    "зосим": 1,
    "зосима": 1,
    "зот": 1,
    "зубин": 1,
    "зэофилус": 1,
    "иб": 1,
    "ибрагим": 1,
    "иван": 1,
    "игнат": 1,
    "игнатий": 1,
    "игнатиус": 1,
    "игорь": 1,
    "ид": 1,
    "иероним": 1,
    "иззи": 1,
    "изидор": 1,
    "измаил": 1,
    "измайло": 1,
    "изяслав": 1,
    "ий": 1,
    "икар": 1,
    "илар": 1,
    "иларий": 1,
    "иларион": 1,
    "илий": 1,
    "илиодор": 1,
    "илларион": 1,
    "илья": 1,
    "имон": 1,
    "инглеберт": 1,
    "инграм": 1,
    "инди": 1,
    "индиана": 1,
    "индиго": 1,
    "инесент": 1,
    "иниго": 1,
    "иннокентий": 1,
    "иоанн": 1,
    "иорик": 1,
    "иосиф": 1,
    "ипат": 1,
    "ипатий": 1,
    "ипполит": 1,
    "ираклий": 1,
    "ирвайн": 1,
    "ирвин": 1,
    "ирвинг": 1,
    "ириней": 1,
    "ириний": 1,
    "ирл": 1,
    "ирм": 1,
    "ирнест": 1,
    "исай": 1,
    "исайя": 1,
    "исак": 1,
    "исакий": 1,
    "исей": 1,
    "исидор": 1,
    "иссак": 1,
    "исси": 1,
    "истер": 1,
    "июлий": 1,
    "йорк": 1,
    "ка": 1,
    "кадмус": 1,
    "казимир": 1,
    "каин": 1,
    "каир": 1,
    "кайд": 1,
    "кайл": 1,
    "кал": 1,
    "калин": 1,
    "калина": 1,
    "каллен": 1,
    "кам": 1,
    "камден": 1,
    "камиль": 1,
    "камрон": 1,
    "капитон": 1,
    "карбрей": 1,
    "карбри": 1,
    "карвер": 1,
    "карей": 1,
    "карен": 1,
    "карл": 1,
    "карлайл": 1,
    "карлейл": 1,
    "карлин": 1,
    "карлтон": 1,
    "карм": 1,
    "кармий": 1,
    "карп": 1,
    "каррол": 1,
    "картер": 1,
    "касиди": 1,
    "каспар": 1,
    "каспер": 1,
    "кассиди": 1,
    "касьян": 1,
    "квентин": 1,
    "квинтин": 1,
    "кеван": 1,
    "кевин": 1,
    "кей": 1,
    "кейденс": 1,
    "кейдн": 1,
    "кейлб": 1,
    "кеймрон": 1,
    "кейси": 1,
    "келвин": 1,
    "келкей": 1,
    "келл": 1,
    "келли": 1,
    "келсей": 1,
    "кемп": 1,
    "кен": 1,
    "кендал": 1,
    "кендол": 1,
    "кендрик": 1,
    "кенелм": 1,
    "кензи": 1,
    "кенит": 1,
    "кеннеди": 1,
    "кеннет": 1,
    "кенни": 1,
    "кеннит": 1,
    "кенрик": 1,
    "кент": 1,
    "кентиджерн": 1,
    "кентон": 1,
    "кермит": 1,
    "керней": 1,
    "керр": 1,
    "керри": 1,
    "керт": 1,
    "кертис": 1,
    "кешон": 1,
    "ки": 1,
    "киаран": 1,
    "килан": 1,
    "килер": 1,
    "килиан": 1,
    "киллиан": 1,
    "ким": 1,
    "кимбелайн": 1,
    "кимберли": 1,
    "кимбол": 1,
    "кимбэль": 1,
    "кин": 1,
    "кинан": 1,
    "кинастон": 1,
    "кинг": 1,
    "кингслей": 1,
    "кип": 1,
    "киприан": 1,
    "кир": 1,
    "киран": 1,
    "кирби": 1,
    "кирилл": 1,
    "кирк": 1,
    "кирон": 1,
    "кирус": 1,
    "кит": 1,
    "китон": 1,
    "киф": 1,
    "клавдий": 1,
    "клайв": 1,
    "клайд": 1,
    "кланкей": 1,
    "кланки": 1,
    "кларенс": 1,
    "кларк": 1,
    "клев": 1,
    "клей": 1,
    "клейтон": 1,
    "клем": 1,
    "клемент": 1,
    "клементий": 1,
    "клемми": 1,
    "клетис": 1,
    "клетус": 1,
    "кливленд": 1,
    "клим": 1,
    "климент": 1,
    "климентий": 1,
    "клинт": 1,
    "клинтон": 1,
    "клифтон": 1,
    "клифф": 1,
    "клиффорд": 1,
    "клод": 1,
    "клэйрк": 1,
    "клэр": 1,
    "кодей": 1,
    "коди": 1,
    "коертней": 1,
    "козьма": 1,
    "кола": 1,
    "коламбан": 1,
    "колберт": 1,
    "колби": 1,
    "колдер": 1,
    "колин": 1,
    "коллахан": 1,
    "коллин": 1,
    "коллум": 1,
    "колтен": 1,
    "колтон": 1,
    "колумбий": 1,
    "кольт": 1,
    "конан": 1,
    "конвей": 1,
    "кондрат": 1,
    "кондратий": 1,
    "конлей": 1,
    "коннелл": 1,
    "коннер": 1,
    "коннор": 1,
    "конон": 1,
    "конор": 1,
    "конрад": 1,
    "константин": 1,
    "конфуций": 1,
    "корбин": 1,
    "корделл": 1,
    "корей": 1,
    "кори": 1,
    "корней": 1,
    "корнелий": 1,
    "корнелиус": 1,
    "корнил": 1,
    "кортней": 1,
    "кортни": 1,
    "корэй": 1,
    "коти": 1,
    "коул": 1,
    "коулман": 1,
    "краснослав": 1,
    "крис": 1,
    "криспиан": 1,
    "криспин": 1,
    "кристи": 1,
    "кристиан": 1,
    "кристопэр": 1,
    "кристоф": 1,
    "кристофер": 1,
    "крофорд": 1,
    "крофтон": 1,
    "крэйг": 1,
    "ксавайор": 1,
    "ксавьер": 1,
    "ксан": 1,
    "ксенофонт": 1,
    "ксзавир": 1,
    "кузьма": 1,
    "куин": 1,
    "куинкей": 1,
    "куинси": 1,
    "куинтон": 1,
    "купер": 1,
    "куприян": 1,
    "курт": 1,
    "куртис": 1,
    "кэйд": 1,
    "кэйдн": 1,
    "кэйл": 1,
    "кэйлб": 1,
    "кэймрон": 1,
    "кэйн": 1,
    "кэйси": 1,
    "кэлвин": 1,
    "кэм": 1,
    "кэмп": 1,
    "кэмпбэл": 1,
    "кэри": 1,
    "кюри": 1,
    "лаверн": 1,
    "лавлл": 1,
    "лавр": 1,
    "лаврентий": 1,
    "лаз": 1,
    "лазарь": 1,
    "лайл": 1,
    "лайонел": 1,
    "лаки": 1,
    "ланни": 1,
    "ланфорд": 1,
    "ларион": 1,
    "ларк": 1,
    "ларкин": 1,
    "ларри": 1,
    "лаэрт": 1,
    "лев": 1,
    "леви": 1,
    "левкий": 1,
    "лейврн": 1,
    "лейн": 1,
    "лейтон": 1,
    "лекс": 1,
    "леланд": 1,
    "лель": 1,
    "лем": 1,
    "лемми": 1,
    "лемюэль": 1,
    "лен": 1,
    "ленар": 1,
    "ленард": 1,
    "лени": 1,
    "лениан": 1,
    "леннард": 1,
    "ленни": 1,
    "лео": 1,
    "леон": 1,
    "леонард": 1,
    "леонид": 1,
    "леонтий": 1,
    "леопольд": 1,
    "лермонт": 1,
    "лерой": 1,
    "лес": 1,
    "лесли": 1,
    "лестер": 1,
    "ли": 1,
    "либерт": 1,
    "ливадий": 1,
    "лии": 1,
    "лин": 1,
    "линдон": 1,
    "линдсей": 1,
    "линдси": 1,
    "линкольн": 1,
    "линн": 1,
    "линсей": 1,
    "линтон": 1,
    "линус": 1,
    "линфорд": 1,
    "лионель": 1,
    "лир": 1,
    "лирой": 1,
    "лисандр": 1,
    "литон": 1,
    "лихнис": 1,
    "ллойд": 1,
    "ллью": 1,
    "лльюелин": 1,
    "лльюеллин": 1,
    "ло": 1,
    "ловэль": 1,
    "лойд": 1,
    "лон": 1,
    "лондон": 1,
    "лонни": 1,
    "лонс": 1,
    "лор": 1,
    "лорен": 1,
    "лоренс": 1,
    "лори": 1,
    "лорин": 1,
    "лорис": 1,
    "лорни": 1,
    "лоррин": 1,
    "лосон": 1,
    "лоуэлл": 1,
    "лоэнгрин": 1,
    "лу": 1,
    "лудо": 1,
    "луи": 1,
    "лука": 1,
    "лукиан": 1,
    "лукьян": 1,
    "льюин": 1,
    "льюис": 1,
    "лэйк": 1,
    "лэйн": 1,
    "лэйтон": 1,
    "лэндон": 1,
    "лэнс": 1,
    "лэрри": 1,
    "любим": 1,
    "любомир": 1,
    "людвиг": 1,
    "людовик": 1,
    "люк": 1,
    "люкс": 1,
    "люксен": 1,
    "люсьен": 1,
    "лютер": 1,
    "люциан": 1,
    "маверик": 1,
    "маврикий": 1,
    "мадисон": 1,
    "маеслав": 1,
    "май": 1,
    "майк": 1,
    "майкл": 1,
    "майлз": 1,
    "майрон": 1,
    "майслав": 1,
    "макар": 1,
    "макарий": 1,
    "макей": 1,
    "макензи": 1,
    "маки": 1,
    "макинтош": 1,
    "маккензи": 1,
    "макс": 1,
    "максвелл": 1,
    "максим": 1,
    "максимилиан": 1,
    "максимиллиан": 1,
    "максимильян": 1,
    "малачи": 1,
    "малком": 1,
    "малоун": 1,
    "манлей": 1,
    "манни": 1,
    "манникс": 1,
    "мануил": 1,
    "мануйло": 1,
    "манфред": 1,
    "марат": 1,
    "марвин": 1,
    "мариан": 1,
    "марин": 1,
    "мариус": 1,
    "марк": 1,
    "марка": 1,
    "маркел": 1,
    "маркиан": 1,
    "марко": 1,
    "маркус": 1,
    "марлен": 1,
    "марлин": 1,
    "марлон": 1,
    "марлоу": 1,
    "мармадьюк": 1,
    "марри": 1,
    "марс": 1,
    "марсен": 1,
    "марти": 1,
    "мартиал": 1,
    "мартин": 1,
    "мартын": 1,
    "маршал": 1,
    "маршалл": 1,
    "марьян": 1,
    "масон": 1,
    "мастерман": 1,
    "матвей": 1,
    "матти": 1,
    "мед": 1,
    "мелвилль": 1,
    "мелвин": 1,
    "мельбурн": 1,
    "мерв": 1,
    "мервин": 1,
    "мерди": 1,
    "мердо": 1,
    "мердок": 1,
    "мередит": 1,
    "мерит": 1,
    "меркурий": 1,
    "мерл": 1,
    "мерлин": 1,
    "меррилл": 1,
    "мерритт": 1,
    "мертон": 1,
    "мерфи": 1,
    "мефодий": 1,
    "мечеслав": 1,
    "мечислав": 1,
    "мид": 1,
    "миид": 1,
    "мик": 1,
    "мика": 1,
    "мики": 1,
    "микки": 1,
    "милад": 1,
    "милан": 1,
    "милберн": 1,
    "милен": 1,
    "милий": 1,
    "миллард": 1,
    "мило": 1,
    "милонег": 1,
    "милослав": 1,
    "милтон": 1,
    "милфорд": 1,
    "мир": 1,
    "мирон": 1,
    "мирослав": 1,
    "митчелл": 1,
    "михаил": 1,
    "михайло": 1,
    "мич": 1,
    "мича": 1,
    "мичил": 1,
    "мо": 1,
    "модест": 1,
    "моз": 1,
    "моисей": 1,
    "молком": 1,
    "монолит": 1,
    "монро": 1,
    "монтагью": 1,
    "монтгомери": 1,
    "монте": 1,
    "монти": 1,
    "монтморенки": 1,
    "морган": 1,
    "морген": 1,
    "мордекэй": 1,
    "морис": 1,
    "морлей": 1,
    "моррис": 1,
    "морт": 1,
    "морти": 1,
    "мортимер": 1,
    "мортон": 1,
    "мосс": 1,
    "моэ": 1,
    "мстислав": 1,
    "мулава": 1,
    "мурат": 1,
    "мэйнард": 1,
    "мэйнерд": 1,
    "мэйор": 1,
    "мэйсон": 1,
    "мэйтланд": 1,
    "мэлори": 1,
    "мэль": 1,
    "мэриан": 1,
    "мэрион": 1,
    "мэт": 1,
    "мэтт": 1,
    "мэтти": 1,
    "мэтью": 1,
    "мюд": 1,
    "надир": 1,
    "назаниль": 1,
    "назар": 1,
    "назарий": 1,
    "назим": 1,
    "найджел": 1,
    "найлс": 1,
    "наль": 1,
    "нанди": 1,
    "нат": 1,
    "натан": 1,
    "наум": 1,
    "науэлл": 1,
    "наш": 1,
    "невада": 1,
    "неван": 1,
    "невил": 1,
    "невилл": 1,
    "нед": 1,
    "нейл": 1,
    "нейлл": 1,
    "нейт": 1,
    "нельсон": 1,
    "нео": 1,
    "неон": 1,
    "неонил": 1,
    "нестер": 1,
    "нестор": 1,
    "нивек": 1,
    "нивен": 1,
    "ник": 1,
    "никандр": 1,
    "никанор": 1,
    "никита": 1,
    "никифор": 1,
    "никк": 1,
    "никки": 1,
    "никодим": 1,
    "никола": 1,
    "николай": 1,
    "николас": 1,
    "никон": 1,
    "нил": 1,
    "нили": 1,
    "нимбус": 1,
    "нинел": 1,
    "нинель": 1,
    "нисон": 1,
    "нифонт": 1,
    "ноа": 1,
    "новомир": 1,
    "нодар": 1,
    "ной": 1,
    "нолан": 1,
    "нолл": 1,
    "норберт": 1,
    "норвуд": 1,
    "норд": 1,
    "норм": 1,
    "норман": 1,
    "норманд": 1,
    "норрис": 1,
    "нортон": 1,
    "ноубль": 1,
    "ноэль": 1,
    "ньют": 1,
    "ньютон": 1,
    "оберон": 1,
    "обин": 1,
    "обри": 1,
    "овидий": 1,
    "огастин": 1,
    "огден": 1,
    "огэст": 1,
    "оделл": 1,
    "одиссей": 1,
    "одлей": 1,
    "одран": 1,
    "оз": 1,
    "оззи": 1,
    "океан": 1,
    "оксар": 1,
    "октавиан": 1,
    "октябрин": 1,
    "октябрь": 1,
    "олби": 1,
    "олбэйн": 1,
    "олдвен": 1,
    "олдвин": 1,
    "олден": 1,
    "олдин": 1,
    "олдис": 1,
    "олдон": 1,
    "олдос": 1,
    "олдред": 1,
    "олдус": 1,
    "олдфорд": 1,
    "олег": 1,
    "олей": 1,
    "оли": 1,
    "оливер": 1,
    "олимпий": 1,
    "олластер": 1,
    "олластир": 1,
    "оллгар": 1,
    "оллджер": 1,
    "олли": 1,
    "оллин": 1,
    "оллисдэйр": 1,
    "оллистер": 1,
    "оллистэйр": 1,
    "оллон": 1,
    "оллэйстар": 1,
    "ольгерд": 1,
    "омар": 1,
    "омега": 1,
    "онисим": 1,
    "ора": 1,
    "оран": 1,
    "орвал": 1,
    "орвилл": 1,
    "орест": 1,
    "ориан": 1,
    "ормерод": 1,
    "оррелл": 1,
    "оррин": 1,
    "орсон": 1,
    "осберт": 1,
    "осбоерн": 1,
    "осборн": 1,
    "освальд": 1,
    "осень": 1,
    "осип": 1,
    "оскар": 1,
    "остап": 1,
    "остен": 1,
    "остин": 1,
    "остромир": 1,
    "отис": 1,
    "оттис": 1,
    "отто": 1,
    "оттон": 1,
    "оуин": 1,
    "оуэн": 1,
    "ошин": 1,
    "павел": 1,
    "пайс": 1,
    "палладий": 1,
    "палмер": 1,
    "панкрас": 1,
    "пантелей": 1,
    "пантелеймон": 1,
    "панфил": 1,
    "парамон": 1,
    "паркер": 1,
    "паррис": 1,
    "партизан": 1,
    "пат": 1,
    "патрик": 1,
    "патси": 1,
    "пахом": 1,
    "пеитон": 1,
    "пепин": 1,
    "пересвет": 1,
    "перри": 1,
    "перс": 1,
    "перси": 1,
    "персиваль": 1,
    "петеркин": 1,
    "пимен": 1,
    "пип": 1,
    "пипер": 1,
    "пирр": 1,
    "пирс": 1,
    "пит": 1,
    "питер": 1,
    "платон": 1,
    "пол": 1,
    "поли": 1,
    "поликарп": 1,
    "помпей": 1,
    "портер": 1,
    "порфирий": 1,
    "потап": 1,
    "престон": 1,
    "приам": 1,
    "принц": 1,
    "пров": 1,
    "прозор": 1,
    "прокопий": 1,
    "прокофий": 1,
    "проспер": 1,
    "протас": 1,
    "прохор": 1,
    "пэйс": 1,
    "пэйси": 1,
    "пэйтон": 1,
    "пётр": 1,
    "петр": 1,
    "равель": 1,
    "равен": 1,
    "равиль": 1,
    "радамес": 1,
    "радий": 1,
    "радим": 1,
    "радислав": 1,
    "радомир": 1,
    "раз": 1,
    "раймонд": 1,
    "раймунд": 1,
    "райордан": 1,
    "райт": 1,
    "ралф": 1,
    "ралфи": 1,
    "ральф": 1,
    "ранделл": 1,
    "ранди": 1,
    "рандолф": 1,
    "рандольф": 1,
    "расс": 1,
    "рассел": 1,
    "рассэль": 1,
    "расти": 1,
    "растус": 1,
    "ратмир": 1,
    "рауль": 1,
    "рафаил": 1,
    "рафаэль": 1,
    "рашид": 1,
    "раян": 1,
    "реарден": 1,
    "ревмир": 1,
    "реган": 1,
    "редд": 1,
    "редж": 1,
    "реджи": 1,
    "реджинальд": 1,
    "редклиф": 1,
    "редклифф": 1,
    "редлей": 1,
    "редманд": 1,
    "редмонд": 1,
    "реид": 1,
    "рей": 1,
    "рейли": 1,
    "рейнард": 1,
    "рейнольд": 1,
    "рекс": 1,
    "рем": 1,
    "ренальд": 1,
    "ренат": 1,
    "риган": 1,
    "ригби": 1,
    "рид": 1,
    "ридлей": 1,
    "риель": 1,
    "рик": 1,
    "рикей": 1,
    "рики": 1,
    "рилан": 1,
    "рилей": 1,
    "рили": 1,
    "ринат": 1,
    "рио": 1,
    "риплей": 1,
    "рис": 1,
    "рихард": 1,
    "рич": 1,
    "ричард": 1,
    "ричи": 1,
    "роальд": 1,
    "роб": 1,
    "робби": 1,
    "роберт": 1,
    "робеспьер": 1,
    "роби": 1,
    "робин": 1,
    "робинзон": 1,
    "рован": 1,
    "род": 1,
    "роддж": 1,
    "родджер": 1,
    "родди": 1,
    "родерик": 1,
    "роджер": 1,
    "родион": 1,
    "родни": 1,
    "родолф": 1,
    "рождеро": 1,
    "рой": 1,
    "ройл": 1,
    "ройс": 1,
    "ройстон": 1,
    "роки": 1,
    "ролан": 1,
    "роланд": 1,
    "роли": 1,
    "ролланд": 1,
    "ролли": 1,
    "роман": 1,
    "ромен": 1,
    "ромуальд": 1,
    "рон": 1,
    "рональд": 1,
    "ронни": 1,
    "рори": 1,
    "роско": 1,
    "росс": 1,
    "ростислав": 1,
    "роуланд": 1,
    "роулей": 1,
    "роял": 1,
    "рубен": 1,
    "рубин": 1,
    "руди": 1,
    "рудольф": 1,
    "рудьярд": 1,
    "рунар": 1,
    "руслан": 1,
    "руссо": 1,
    "рустам": 1,
    "рустем": 1,
    "рхетт": 1,
    "рьюб": 1,
    "рэд": 1,
    "рэй": 1,
    "рэйнард": 1,
    "рэйнер": 1,
    "рэйф": 1,
    "рэм": 1,
    "рэндал": 1,
    "рэндалл": 1,
    "рюрик": 1,
    "сава": 1,
    "савва": 1,
    "савелий": 1,
    "савьер": 1,
    "сайг": 1,
    "саймон": 1,
    "салал": 1,
    "салливан": 1,
    "самми": 1,
    "самойло": 1,
    "самсон": 1,
    "самуил": 1,
    "сандфорд": 1,
    "санни": 1,
    "санфорд": 1,
    "свет": 1,
    "светлан": 1,
    "светозар": 1,
    "светослав": 1,
    "свизин": 1,
    "свизун": 1,
    "свиней": 1,
    "святогор": 1,
    "святополк": 1,
    "святослав": 1,
    "себастьян": 1,
    "севард": 1,
    "севастиан": 1,
    "севастьян": 1,
    "север": 1,
    "севериан": 1,
    "северин": 1,
    "северьян": 1,
    "северян": 1,
    "седрик": 1,
    "сеймур": 1,
    "селби": 1,
    "семён": 1,
    "септембер": 1,
    "серапион": 1,
    "серафим": 1,
    "сергей": 1,
    "сесил": 1,
    "сет": 1,
    "сефтон": 1,
    "сивард": 1,
    "сигизмунд": 1,
    "сигманд": 1,
    "сид": 1,
    "сидней": 1,
    "сидор": 1,
    "сила": 1,
    "силас": 1,
    "силвестр": 1,
    "сильвер": 1,
    "сильвест": 1,
    "сильвестр": 1,
    "симеон": 1,
    "симон": 1,
    "синклэйр": 1,
    "сирил": 1,
    "сисар": 1,
    "скай": 1,
    "скилар": 1,
    "скилер": 1,
    "скот": 1,
    "скотти": 1,
    "скуилер": 1,
    "слава": 1,
    "слай": 1,
    "слэйд": 1,
    "совет": 1,
    "сократ": 1,
    "соломон": 1,
    "сони": 1,
    "сонни": 1,
    "софокл": 1,
    "софон": 1,
    "спайк": 1,
    "спарроу": 1,
    "спартак": 1,
    "спенсер": 1,
    "спиридон": 1,
    "спиро": 1,
    "стакей": 1,
    "сталий": 1,
    "сталь": 1,
    "станислав": 1,
    "стаффорд": 1,
    "степан": 1,
    "стерлинг": 1,
    "стеф": 1,
    "стефан": 1,
    "сти": 1,
    "стив": 1,
    "стивен": 1,
    "стиви": 1,
    "стиу": 1,
    "сторм": 1,
    "стратон": 1,
    "сту": 1,
    "стэки": 1,
    "стэн": 1,
    "стэнли": 1,
    "стэнфорд": 1,
    "стюарт": 1,
    "сурен": 1,
    "сэм": 1,
    "сэмюэль": 1,
    "сэнди": 1,
    "тад": 1,
    "таддеус": 1,
    "таир": 1,
    "тай": 1,
    "такер": 1,
    "тал": 1,
    "талбот": 1,
    "таннер": 1,
    "тарас": 1,
    "таскилл": 1,
    "таффи": 1,
    "тед": 1,
    "тейгу": 1,
    "тейдж": 1,
    "теймураз": 1,
    "тейрк": 1,
    "текс": 1,
    "тельнан": 1,
    "тенгиз": 1,
    "тенней": 1,
    "теннизон": 1,
    "тео": 1,
    "теобальд": 1,
    "теодор": 1,
    "теранс": 1,
    "теренс": 1,
    "терентий": 1,
    "терло": 1,
    "терранс": 1,
    "террелл": 1,
    "терренс": 1,
    "терстон": 1,
    "ти": 1,
    "тиарнак": 1,
    "тиарнан": 1,
    "тибалт": 1,
    "тибби": 1,
    "тигран": 1,
    "тигу": 1,
    "тизон": 1,
    "тилар": 1,
    "тилер": 1,
    "тилор": 1,
    "тим": 1,
    "тимми": 1,
    "тимоти": 1,
    "тимофей": 1,
    "тимур": 1,
    "тирелл": 1,
    "тирнан": 1,
    "тирней": 1,
    "тирон": 1,
    "тироун": 1,
    "тиррелл": 1,
    "тит": 1,
    "тихомир": 1,
    "тихон": 1,
    "тоал": 1,
    "тоби": 1,
    "тобиас": 1,
    "тобин": 1,
    "товий": 1,
    "тод": 1,
    "тодд": 1,
    "толли": 1,
    "том": 1,
    "томас": 1,
    "томми": 1,
    "тон": 1,
    "тони": 1,
    "топэр": 1,
    "торез": 1,
    "торий": 1,
    "торлей": 1,
    "торнтон": 1,
    "травис": 1,
    "тракей": 1,
    "трантер": 1,
    "траффорд": 1,
    "траэрн": 1,
    "трев": 1,
    "тревельян": 1,
    "тревор": 1,
    "трейврс": 1,
    "трейс": 1,
    "трейси": 1,
    "трент": 1,
    "трентон": 1,
    "тристан": 1,
    "тристрам": 1,
    "трифон": 1,
    "трой": 1,
    "трофим": 1,
    "труман": 1,
    "туллий": 1,
    "тусон": 1,
    "тэдди": 1,
    "тэди": 1,
    "тэйлер": 1,
    "тэйлор": 1,
    "тэйн": 1,
    "тэйт": 1,
    "тэл": 1,
    "тэмпл": 1,
    "тэрри": 1,
    "уилбер": 1,
    "уиллард": 1,
    "уиллис": 1,
    "уилфред": 1,
    "уилфрид": 1,
    "уильям": 1,
    "уинстон": 1,
    "уинфред": 1,
    "уисдом": 1,
    "улайксс": 1,
    "улиссес": 1,
    "ульяна": 1,
    "уолли": 1,
    "уоллис": 1,
    "уолт": 1,
    "уолтер": 1,
    "уолтон": 1,
    "уорик": 1,
    "уорнер": 1,
    "уоррен": 1,
    "уот": 1,
    "уоткин": 1,
    "уптон": 1,
    "урбан": 1,
    "уриах": 1,
    "устин": 1,
    "уэйн": 1,
    "уэсли": 1,
    "фабиан": 1,
    "фаддей": 1,
    "фадей": 1,
    "фалк": 1,
    "фарид": 1,
    "фарлей": 1,
    "фарон": 1,
    "фарран": 1,
    "февралин": 1,
    "федор": 1,
    "федосий": 1,
    "фелан": 1,
    "фелиз": 1,
    "феликс": 1,
    "фелим": 1,
    "фелис": 1,
    "фентон": 1,
    "феодосий": 1,
    "феофан": 1,
    "ферги": 1,
    "фергус": 1,
    "ферд": 1,
    "ферди": 1,
    "фердинанд": 1,
    "фернан": 1,
    "фернанд": 1,
    "фестер": 1,
    "фестус": 1,
    "фидель": 1,
    "фидо": 1,
    "фил": 1,
    "филайп": 1,
    "филандр": 1,
    "филарет": 1,
    "филат": 1,
    "филберт": 1,
    "филимон": 1,
    "филип": 1,
    "филипп": 1,
    "фило": 1,
    "финикс": 1,
    "финис": 1,
    "флегонт": 1,
    "флемминг": 1,
    "флечер": 1,
    "флинн": 1,
    "флинт": 1,
    "флойд": 1,
    "флорентий": 1,
    "флоренц": 1,
    "флорин": 1,
    "флорри": 1,
    "флурри": 1,
    "фок": 1,
    "фокс": 1,
    "фома": 1,
    "фонз": 1,
    "фонзи": 1,
    "форбес": 1,
    "форд": 1,
    "форест": 1,
    "форрест": 1,
    "фостер": 1,
    "фот": 1,
    "фотий": 1,
    "фоук": 1,
    "фразир": 1,
    "франклин": 1,
    "франц": 1,
    "фред": 1,
    "фредди": 1,
    "фредерик": 1,
    "фредрик": 1,
    "фрейзер": 1,
    "фрейзр": 1,
    "фридрих": 1,
    "фримэн": 1,
    "фритс": 1,
    "фродо": 1,
    "фрол": 1,
    "фрэнк": 1,
    "фрэнки": 1,
    "фрэнклин": 1,
    "фрэнс": 1,
    "фрэнсис": 1,
    "фёдор": 1,
    "хавелок": 1,
    "хадвин": 1,
    "хадлей": 1,
    "хал": 1,
    "хам": 1,
    "хамиш": 1,
    "хамлет": 1,
    "хаммонд": 1,
    "ханк": 1,
    "ханлей": 1,
    "хантер": 1,
    "харв": 1,
    "харви": 1,
    "харди": 1,
    "хардинг": 1,
    "харитон": 1,
    "харкоерт": 1,
    "харлан": 1,
    "харланд": 1,
    "харлей": 1,
    "харлин": 1,
    "хармон": 1,
    "харпер": 1,
    "харрис": 1,
    "харрисон": 1,
    "хартлей": 1,
    "хауелл": 1,
    "хедлей": 1,
    "хек": 1,
    "хендерсон": 1,
    "хендрик": 1,
    "хенрай": 1,
    "хенри": 1,
    "херб": 1,
    "херби": 1,
    "хервей": 1,
    "херлей": 1,
    "хиацинт": 1,
    "хилари": 1,
    "хиллэри": 1,
    "хирам": 1,
    "хис": 1,
    "хитклифф": 1,
    "хию": 1,
    "хоард": 1,
    "хоб": 1,
    "ходдж": 1,
    "хойт": 1,
    "холден": 1,
    "холл": 1,
    "холлис": 1,
    "хомер": 1,
    "хопкин": 1,
    "хорас": 1,
    "хоратайо": 1,
    "хоуи": 1,
    "храбр": 1,
    "христоф": 1,
    "христофор": 1,
    "худд": 1,
    "хуей": 1,
    "хует": 1,
    "хукк": 1,
    "хукслей": 1,
    "хумберт": 1,
    "хунтлей": 1,
    "хуффи": 1,
    "хью": 1,
    "хьюберт": 1,
    "хьюго": 1,
    "хьюи": 1,
    "хэвен": 1,
    "хэдлей": 1,
    "хэйвуд": 1,
    "хэйден": 1,
    "хэйл": 1,
    "хэмфри": 1,
    "хэппи": 1,
    "хюи": 1,
    "цезарь": 1,
    "чад": 1,
    "чадвик": 1,
    "чаз": 1,
    "чак": 1,
    "чакки": 1,
    "чарлз": 1,
    "чарли": 1,
    "чарлтон": 1,
    "чарльз": 1,
    "час": 1,
    "чейз": 1,
    "чендлер": 1,
    "ченс": 1,
    "черокез": 1,
    "чеслав": 1,
    "честер": 1,
    "чеьянн": 1,
    "чип": 1,
    "чонки": 1,
    "чонси": 1,
    "ша": 1,
    "шад": 1,
    "шаи": 1,
    "шайенн": 1,
    "шакуилл": 1,
    "шамиль": 1,
    "шамус": 1,
    "шан": 1,
    "шаннен": 1,
    "шаннон": 1,
    "шау": 1,
    "шеврон": 1,
    "шелби": 1,
    "шелдон": 1,
    "шеллей": 1,
    "шелтон": 1,
    "шем": 1,
    "шервуд": 1,
    "шеридан": 1,
    "шерлок": 1,
    "шерман": 1,
    "ши": 1,
    "шилох": 1,
    "шимус": 1,
    "шмидт": 1,
    "шолто": 1,
    "шон": 1,
    "шэй": 1,
    "шэйн": 1,
    "эбби": 1,
    "эбен": 1,
    "эбенезер": 1,
    "эвальд": 1,
    "эван": 1,
    "эвелин": 1,
    "эверард": 1,
    "эверетт": 1,
    "эверитт": 1,
    "эвот": 1,
    "эгберт": 1,
    "эд": 1,
    "эдан": 1,
    "эдвард": 1,
    "эдвин": 1,
    "эдгар": 1,
    "эдди": 1,
    "эдип": 1,
    "эдисон": 1,
    "эдмонд": 1,
    "эдмунд": 1,
    "эдон": 1,
    "эдуард": 1,
    "эдун": 1,
    "эзраа": 1,
    "эзэлстан": 1,
    "эзэлуолф": 1,
    "эйб": 1,
    "эйби": 1,
    "эйвери": 1,
    "эйден": 1,
    "эйлберт": 1,
    "эйлвард": 1,
    "эймерей": 1,
    "эймери": 1,
    "эйнар": 1,
    "эйнслей": 1,
    "эйнсли": 1,
    "эйс": 1,
    "элайотт": 1,
    "элбан": 1,
    "элвин": 1,
    "элвис": 1,
    "элвуд": 1,
    "элгар": 1,
    "элдвен": 1,
    "элдвин": 1,
    "элден": 1,
    "элджер": 1,
    "элдин": 1,
    "элдис": 1,
    "элдон": 1,
    "элдред": 1,
    "элдус": 1,
    "электрон": 1,
    "эли": 1,
    "элиас": 1,
    "элиджа": 1,
    "элиот": 1,
    "элла": 1,
    "эллгар": 1,
    "эллджер": 1,
    "эллери": 1,
    "эллиот": 1,
    "эллис": 1,
    "элмер": 1,
    "элрик": 1,
    "элрой": 1,
    "элсдон": 1,
    "эль": 1,
    "эльберт": 1,
    "эльбрус": 1,
    "эльдар": 1,
    "эльмар": 1,
    "эльмир": 1,
    "эльтон": 1,
    "эмерсон": 1,
    "эмилиан": 1,
    "эмилий": 1,
    "эмиль": 1,
    "эммануель": 1,
    "эммануил": 1,
    "эммерсон": 1,
    "эммет": 1,
    "эмметт": 1,
    "эмори": 1,
    "эмэри": 1,
    "энвер": 1,
    "энгель": 1,
    "энджелберт": 1,
    "энди": 1,
    "эндрю": 1,
    "энергий": 1,
    "энтони": 1,
    "эразм": 1,
    "эраст": 1,
    "эрван": 1,
    "эрвин": 1,
    "эрг": 1,
    "эрек": 1,
    "эрий": 1,
    "эрик": 1,
    "эрих": 1,
    "эрл": 1,
    "эрлен": 1,
    "эрн": 1,
    "эрнест": 1,
    "эрни": 1,
    "эрнст": 1,
    "эрон": 1,
    "эррол": 1,
    "эрролл": 1,
    "этан": 1,
    "этелберт": 1,
    "этелред": 1,
    "этелрик": 1,
    "этелхард": 1,
    "эшли": 1,
    "эюзби": 1,
    "ювеналий": 1,
    "юджин": 1,
    "юлиан": 1,
    "юлий": 1,
    "юлиус": 1,
    "юм": 1,
    "юниор": 1,
    "юпитер": 1,
    "юрий": 1,
    "юстас": 1,
    "юстин": 1,
    "яков": 1,
    "ян": 1,
    "янкей": 1,
    "янки": 1,
    "януарий": 1,
    "ярвуд": 1,
    "яромир": 1,
    "ярополк": 1,
    "ярослав": 1
  }, exports.ruBindingWords = [ "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "пота", "потому", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "тож", "только", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы", "а-ля", "без", "безо", "благодаря", "близ", "в", "ввиду", "вглубь", "вдоль", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "во", "возле", "вокруг", "вопреки", "впереди", "вразрез", "вроде", "вслед", "вследствие", "для", "до", "за", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "к", "ко", "кроме", "кругом", "меж", "между", "мимо", "на", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду", "насупротив", "насчёт", "не", "ниже", "о", "об", "обо", "обок", "около", "окромя", "округ", "от", "относительно", "ото", "перед", "передо", "по", "по-за", "по-над", "поверх", "под", "подле", "подо", "подобно", "позади", "помимо", "поперёк", "порядка", "посередине", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "применительно", "про", "против", "путём", "ради", "с", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "со", "согласно", "спустя", "среди", "средь", "сродни", "судя", "супротив", "у", "через", "чрез", "иже", "какой-либо", "какой-то", "кое-кто", "кой", "кто", "кто-либо", "многий", "мя", "насколько", "немногий", "нещечко", "никой", "ничегошеньки", "се", "сё", "такой-то", "тот-то", "чё", "чево", "чей-либо", "чей-нибудь", "чей-то", "шо", "эта", "кем", "ком", "кому", "нахуя", "чей", "чему", "вам", "вами", "вас", "вы", "Вы", "ее", "её", "его", "ей", "ему", "ею", "им", "ими", "их", "меня", "мне", "мной", "мною", "мы", "нём", "нем", "нам", "нами", "неё", "него", "ней", "нему", "нею", "ним", "ними", "них", "он", "она", "оне", "они", "оно", "тебе", "тебя", "тобой", "тобою", "ты", "я", "иной", "кое-какой", "кое-чей", "кое-что", "кой-какой", "кой-кто", "кто-нибудь", "кто-то", "куда-нибудь", "некто", "нечто", "что-либо", "что-нибудь", "что-то", "весь", "всякий", "любой", "сам", "самый", "таков", "этакий", "другой", "некем", "некому", "нечего", "нечем", "нечему", "никакой", "никто", "ничего", "ничей", "ничем", "ничему", "ничто", "ваш", "ихний", "моё", "мой", "моя", "наш", "свой", "твой", "оный", "сей", "сие", "сии", "сия", "та", "такой", "тот", "ту", "эдакий", "эти", "это", "этот", "ась", "аюшки", "таки", "а", "авось-либо", "ага", "аминь", "б", "бишь", "буквально", "бы", "было", "вишь", "вон", "вот", "вот-вот", "вряд", "всего", "давай", "де", "действительно", "дескать", "добро", "довольно", "ещё", "исключительно", "ить", "ишь", "ка", "кажется", "конечно", "ладно", "лих", "лучше", "мол", "навряд", "наоборот", "небось", "нет", "неужели", "нехай", "никак", "ну", "ну-с", "по-видимому", "пожалуй", "пожалуйста", "полно", "положительно", "предовольно", "простите", "просто-напросто", "пускай", "разумеется", "сём-ка", "сем", "скорее", "спасибо", "так", "то-то", "тоже", "уж", "уже", "ужели", "ужли", "фон", "хорошо", "эдак", "эк", "этак" ];
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.words = {}, exports = window.lastName.plugins.ru.words) : exports = module.exports, function(exports) {
  return exports.adverbs = [ "абсолютно", "адски", "азартно", "активно", "аспидно", "баснословно", "бдительно", "безапелляционно", "безбожно", "безвозвратно", "безгранично", "безжалостно", "беззаветно", "беззастенчиво", "безмерно", "безмятежно", "безнадежно", "безоговорочно", "безраздельно", "безропотно", "безудержно", "безукоризненно", "безумно", "безупречно", "безусловно", "безустанно", "безутешно", "бескомпромиссно", "бесконечно", "беспардонно", "бесповоротно", "беспощадно", "беспредельно", "беспрекословно", "бесследно", "бессовестно", "бесстыдно", "бесчеловечно", "бешено", "бурно", "вдребезги", "вконец", "вовсю", "всемерно", "всесторонне", "всецело", "всячески", "высоко", "глубоко", "горько", "горячо", "грубо", "густо", "диаметрально", "дико", "досконально", "досыта", "дотошно", "дьявольски", "жарко", "жгуче", "железно", "жестко", "жестоко", "живо", "жизненно", "жутко", "запоем", "запредельно", "зверски", "здорово", "злостно", "идеально", "излишне", "изрядно", "изумительно", "исключительно", "исступленно", "истово", "истошно", "исчерпывающе", "кардинально", "катастрофически", "категорически", "клятвенно", "колоссально", "крайне", "крепко", "кристально", "кровно", "крупно", "круто", "люто", "максимально", "мертвецки", "мучительно", "навзрыд", "нагло", "наглухо", "наглядно", "наголову", "надежно", "надрывно", "назубок", "намертво", "наотрез", "напрочь", "нарочито", "насквозь", "настоятельно", "насущно", "начисто", "небывало", "невероятно", "невиданно", "невообразимо", "невыносимо", "невыразимо", "недопустимо", "неизмеримо", "неимоверно", "неистово", "немилосердно", "немыслимо", "необыкновенно", "необычайно", "неописуемо", "неопровержимо", "непомерно", "непоправимо", "непостижимо", "непримиримо", "непробудно", "непроходимо", "неразрывно", "несказанно", "неслыханно", "несметно", "несравненно", "нестерпимо", "неудержимо", "неузнаваемо", "неуклонно", "неукоснительно", "неустанно", "неусыпно", "неутешно", "неутомимо", "нещадно", "оглушительно", "ожесточенно", "ослепительно", "основательно", "остро", "откровенно", "открыто", "отлично", "отменно", "отчаянно", "очень", "панически", "патологически", "пламенно", "плотно", "по-настоящему", "по-собачьи", "подлинно", "подчеркнуто", "позарез", "поистине", "полностью", "поразительно", "порядком", "порядочно", "потрясающе", "предельно", "прекрасно", "преступно", "прилично", "примитивно", "принципиально", "приторно", "пронзительно", "радикально", "разительно", "редкостно", "резко", "рекордно", "свято", "серьезно", "сильно", "слепо", "смертельно", "совершенно", "совсем", "страстно", "страшно", "строго", "строго-настрого", "существенно", "твердо", "тяжело", "тяжко", "убийственно", "удивительно", "ужасающе", "ужасно", "фанатически", "фанатично", "фантастически", "феноменально", "хорошенько", "хорошо", "чертовски", "чрезвычайно", "чрезмерно", "чудовищно", "широко", "шумно", "щедро", "ярко", "яростно" ], exports.unions = [ "а", "а именно", "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "все-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как бы", "как то", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "после того как", "пота", "потому", "потому как", "потому что", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "то есть", "тож", "только", "только что", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы" ], exports.prepositionAll = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо", "включая", "невзирая на", "несмотря на", "по", "по-за", "про", "с", "сквозь", "со", "спустя", "через", "чрез", "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по", "при", "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "среди", "средь", "супротив", "у", "в связи с", "в соответствии с", "вслед за", "лицом к лицу с", "над", "надо", "наряду с", "перед", "передо", "по сравнению с", "по-над", "пред", "предо", "рядом с", "следом за" ], exports.prepositionSimple = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionAcusative = [ "в", "включая", "во", "за", "на", "не в", "не за", "невзирая на", "несмотря на", "о", "об", "обо", "по", "по-за", "под", "подо", "про", "с", "сквозь", "со", "спустя", "через", "чрез" ], exports.prepositionDative = [ "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по" ], exports.prepositionPrepositional = [ "в", "во", "на", "не в", "о", "об", "обо", "по", "при" ], exports.prepositionGenetive = [ "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "меж", "между", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "со", "среди", "средь", "супротив", "у" ], exports.prepositionInstrumental = [ "в связи с", "в соответствии с", "вслед за", "за", "лицом к лицу с", "меж", "между", "над", "надо", "наряду с", "не за", "перед", "передо", "по сравнению с", "по-над", "под", "подо", "пред", "предо", "рядом с", "с", "следом за", "со" ], exports.prepositionWithSingleCase = [ "без", "без ведома", "безо", "благодаря", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в связи с", "в силу", "в соответствии с", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "вдоль по", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "вопреки", "впереди", "впредь до", "вроде", "вслед", "вслед за", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "к", "ко", "кроме", "кругом", "лицом к", "лицом к лицу с", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду с", "насупротив", "насчёт", "начиная с", "не без", "не считая", "невзирая на", "недалеко от", "независимо от", "несмотря на", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "перед", "передо", "по линии", "по мере", "по направлению к", "по отношению к", "по поводу", "по причине", "по случаю", "по сравнению с", "по-за", "по-над", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "подобно", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "при помощи", "применительно к", "про", "против", "путём", "ради", "рядом с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "согласно", "спустя", "среди", "средь", "сродни", "судя по", "супротив", "у", "через", "чрез" ], exports.prepositionWith2Cases = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionWith3Cases = [ "по", "с", "со" ];
}(exports);

var exports, ref, util, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.dates = {}, exports = window.lastName.plugins.ru.dates, ref = window.lastName.plugins.ru.ref, util = window.lastName.util) : (exports = module.exports, ref = require("./ref"), util = require("../../util")), function(exports, util, ref) {
  var dateObjectToString, extractDates, getRuMonthIndex, getValidDate, packDates, packIntervals, ruMonthInDates;
  return ruMonthInDates = [ "января", "февраля", "марта", "аперля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря" ], dateObjectToString = function(dateObj) {
    var d, m, y, _ref;
    return y = ((_ref = typeof dateObj.y) === "number" || _ref === "string") && dateObj.y || "", m = dateObj.m + 1, m = m > 9 && m || "0" + m, d = dateObj.d > 9 && dateObj.d || "0" + dateObj.d, "" + d + "." + m + "." + y;
  }, getValidDate = function(dateObj) {
    var defaultYear, dt;
    defaultYear = dateObj.y;
    if (void 0 === dateObj.y || dateObj.y < 1970 || dateObj.y > 2038) dateObj.y = 2e3;
    return dt = new Date(Date.UTC(dateObj.y, dateObj.m, dateObj.d)), dt.getMonth() === dateObj.m && dt.getDate() === dateObj.d ? (dateObj.y = defaultYear, dateObj) : null;
  }, getRuMonthIndex = function(str) {
    var m;
    return m = str.toLowerCase().match(/(\s|^)(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s|$)/g), m ? ruMonthInDates.indexOf(m[0].replace(/\s/g, "")) : -1;
  }, exports.extractDates = extractDates = function(strArr) {
    var dates, intervals, sources;
    return dates = {}, sources = [], intervals = {}, strArr instanceof Array || (strArr = [ strArr ]), strArr.map(function(str) {
      var dStr, date, found, from, fromDate, fromMonth, fromYear, id, intObject, mIndex, sourceStr, to, toDate, toYear, verboseMatch, wordsArr, _ref, _results;
      verboseMatch = str.match(/\s+\d{1,2}\s+((января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)\s+|)(\d{2,4}(\s+года|)\s+|)по\s+\d{1,2}\s+(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s+\d{2,4}|)(\s+|$)/mig);
      if (!verboseMatch) {
        wordsArr = str.split(" "), found = !1, _results = [];
        while (wordsArr.length > 2 && !found) /^\d[\d]$/.test(wordsArr[0]) && (mIndex = ruMonthInDates.indexOf(wordsArr[1].toLowerCase()), mIndex >= 0 ? (date = {
          d: parseInt(wordsArr[0], 10),
          m: mIndex
        }, /^\d{2,4}$/.test(wordsArr[2]) ? (date.y = parseInt(wordsArr[2], 10), sourceStr = wordsArr.slice(0, 3).join(" ")) : sourceStr = wordsArr.slice(0, 2).join(" ")) : /^\d\d\.\d\d.\d{2,4}$/.test(wordsArr[0] || /^\d\d\.\d\d$/.test(wordsArr[0])) ? (date = {
          d: parseInt(wordsArr[0].slice(0, 3), 10),
          m: parseInt(wordsArr[0].slice(3, 6), 10),
          y: parseInt(wordsArr[0].slice(6), 10) || void 0
        }, sourceStr = wordsArr[0]) : date = {}, date = getValidDate(date), date && (found = !0, sources.push(sourceStr), dStr = dateObjectToString(date), dates[dStr] ? dates[dStr].count++ : dates[dStr] = {
          count: 1,
          value: date
        })), _results.push(wordsArr.shift());
        return _results;
      }
      _ref = verboseMatch[0].toLowerCase().split("по"), from = _ref[0], to = _ref[1], toYear = to.replace(/\d{1,2}/, "").match(/\d+/g), toYear ? toYear = parseInt(toYear[0], 10) : toYear = void 0, toDate = {
        d: parseInt(to.match(/\d{1,2}/g)[0], 10),
        m: getRuMonthIndex(to),
        y: toYear
      }, fromYear = from.replace(/\d{1,2}/, "").match(/\d+/g), fromMonth = getRuMonthIndex(from), fromYear ? fromYear = parseInt(fromYear[0], 10) : fromYear = toYear, fromMonth === -1 && (fromMonth = toDate.m), fromDate = {
        d: parseInt(from.match(/\d{1,2}/g)[0], 10),
        m: fromMonth,
        y: fromYear
      }, toDate = getValidDate(toDate), fromDate = getValidDate(fromDate);
      if (toDate && fromDate) return intObject = {
        from: dateObjectToString(fromDate),
        from_value: fromDate,
        to: dateObjectToString(toDate),
        to_value: toDate
      }, id = "" + intObject.from + "-" + intObject.to, intervals[id] ? intervals[id].count++ : (intObject.count = 1, intervals[id] = intObject), sources.push(verboseMatch[0]);
    }), {
      dates: dates,
      sources: sources,
      intervals: intervals
    };
  }, exports.packDates = packDates = function(dates, defaultYear) {
    var dateObj, id, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in dates) dateObj = dates[id], "undefined" != typeof dateObj.value.y && years.push(dateObj.value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in dates) dateObj = dates[id], "undefined" == typeof dateObj.value.y && (dateObj.value.y = defaultYear), out["" + dateObjectToString(dateObj.value)] = dateObj.count;
    return out;
  }, exports.packIntervals = packIntervals = function(intervals, defaultYear) {
    var id, interval, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in intervals) interval = intervals[id], "undefined" != typeof interval.from_value.y && years.push(interval.from_value.y), "undefined" != typeof interval.to_value.y && years.push(interval.to_value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in intervals) interval = intervals[id], "undefined" == typeof interval.from_value.y && (interval.from_value.y = defaultYear), "undefined" == typeof interval.to_value.y && (interval.to_value.y = defaultYear), out["" + dateObjectToString(interval.from_value) + "-" + dateObjectToString(interval.to_value)] = interval.count;
    return out;
  }, exports.preFilter = function(text, result) {
    var dates, numRe;
    numRe = /((([а-яё]+)\s+){0,1}\d[\.\d]{0,}(\s+(([a-яё]+)|([\.\d]+))){1,6})|([12]\d\d\d)/mig, dates = extractDates(util.unique(text.match(numRe) || [])), util.dictKeys(dates.dates).length > 0 && (result.dates = packDates(dates.dates)), util.dictKeys(dates.intervals).length > 0 && (result.intervals = packIntervals(dates.intervals));
    if (dates.sources.length > 0) return result.date_sources = dates.sources;
  };
}(exports, util, ref);

var exports, ref, util, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.inclines = {}, exports = window.lastName.plugins.ru.inclines, util = window.lastName.util, ref = window.lastName.plugins.ru.ref) : (exports = module.exports, util = require("../../util"), ref = require("./ref")), function(exports, util, ref) {
  var cases, doInclineFemaleName, doInclineMaleName, findProperName, genderMatch, getNominative, inclineAndGetResult, inclineFemMiddleName, inclineFemaleName, inclineFemaleNameAndGetResult, inclineFemaleSurname, inclineMaleMiddleName, inclineMaleName, inclineMaleNameAndGetResult, inclineMaleSurname, inclineMiddleName, inclineMiddleNameOrSurname, inclineName, inclinePersonSurname, inclineSurname, matchCase, matchNameAndSurname, matchNameParts;
  return cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ], exports.doInclineFemaleName = doInclineFemaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, aUnstressedRe, name2;
    return aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, aUnstressedRe = /ца$/g, name2 = name.slice(0, -1), aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aUnstressedRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ей", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /ия$/g.test(name) && name.length > 3 ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "и" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ь", "" + name2 + "ью", "" + name2 + "и" ] : /[жшщцч]$/g.test(name) ? [ "" + name, "" + name + "и", "" + name + "и", "" + name, "" + name + "ью", "" + name + "и" ] : [ name, name, name, name, name, name ];
  }, exports.doInclineMaleName = doInclineMaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, hardConsonants, hissingAndChe, ishortRe, name2;
    return hardConsonants = /[бвгдзклмнпрстфх]$/g, hissingAndChe = /[жшщцч]$/g, ishortRe = /((ай)|(ей)|(ой)|(уй)|(яй)|(юй)|(ий))$/g, aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, name2 = name.slice(0, -1), name === "Лев" ? [ "Лев", "Льва", "Льву", "Льва", "Львом", "Льве" ] : name === "Павел" ? [ "Павел", "Павла", "Павлу", "Павла", "Павлом", "Павле" ] : /и$/g.test(name) ? [ name, name, name, name, name, name ] : hissingAndChe.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ем", "" + name + "е" ] : hardConsonants.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ом", "" + name + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : ishortRe.test(name) ? [ "" + name2 + "й", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ко$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /о$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : null;
  }, inclineAndGetResult = function(fn, args) {
    var i, name, r;
    r = null;
    for (i in args) {
      name = args[i], r = fn(name, !0);
      if (r.found) break;
    }
    return r;
  }, inclineFemaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineFemaleName, arguments);
  }, inclineMaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineMaleName, arguments);
  }, exports.inclineFemaleName = inclineFemaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name3, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), nl = name.toLowerCase(), nominativeRe = /[адежзийклмнорстуьэя]$/g, canInclineRe = /[жшщцчаяь]$/g, genitiveRe = /[иы]$/g, dativeRe = /[еи]$/g, accusativeRe = /[жшщцчьую]$/g, instrumentalRe = /((ой)|(ей)|(еи)|(ью))$/g, prepositionalRe = /[еи]$/g, result = r = null, nominativeRe.test(nl) && ref.ruFemaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineFemaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "female",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name2 = name.slice(0, -1), name_cases = [], genitiveRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("dative"))), prepositionalRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("prepositional"))), accusativeRe.test(nl) && (/[ую]$/g.test(nl) ? r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а") : r = inclineFemaleNameAndGetResult(name), r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (name3 = name.slice(0, -2), r = inclineFemaleNameAndGetResult("" + name3 + "я", "" + name3 + "а", "" + name3 + "ь", "" + name3), r && r.found && (result = r, name_cases.push("instrumental"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineMaleName = inclineMaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), name === "Льв" && (name = "Лев"), name === "Павл" && (name = "Павел"), nl = name.toLowerCase(), nominativeRe = /([вгдзклмнпрстфхжшцьй]|(ба)|(ва)|(да)|(за)|(ла)|(ма)|(на)|(па)|(ра)|(са)|(та)|(фа)|(га)|(ка)|(ха)|(жа)|(ша)|(ща)|(ца)|(ча)|(я)|(ло)|(ко))$/g, canInclineRe = /([бвгдзклмнпрстфхжшцьая]|(ия)|(ья)|(ея)|(ий)|(ей))$/g, genitiveRe = /[аяыи]$/g, dativeRe = /(([еую])|(ии))$/g, accusativeRe = /[аяую]$/g, instrumentalRe = /((ом)|(ем)|(ой)|(ей)|(ёй))$/g, prepositionalRe = /((е)|(ии))$/g, name2 = name.slice(0, -1), result = r = null, nominativeRe.test(nl) && ref.ruMaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineMaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "male",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name_cases = [], genitiveRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /ы$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "о", "" + name2 + "а") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "а", "" + name.slice(0, -1) + "я", "" + name.slice(0, -1) + "о") : r = null, r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (/у$/g.test(nl) ? r = inclineMaleName(name2) : /[аеиоуя]ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "й") : /ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "ь") : /е$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "и", "" + name2 + "я", "" + name2 + "o") : /ии$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я") : r = null, r && r.found && (result = r, name_cases.push("dative"))), accusativeRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /у$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а") : /[ую]$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : r = null, r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (/ом$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2)) : /ем$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2), "" + name.slice(0, -2) + "ь", "" + name.slice(0, -2) + "й") : /ой$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "а", "" + name.slice(0, -2) + "о") : /((ей)|(ёй))$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "я", "" + name.slice(0, -2) + "а") : r = null, r && r.found && (result = r, name_cases.push("instrumental"))), prepositionalRe.test(nl) && (/е$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2, "" + name2 + "ь", "" + name2 + "й", "" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я", "" + name2 + "й") : r = null, r && r.found && (result = r, name_cases.push("prepositional"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineName = inclineName = function(name) {
    var fn, mn, result;
    return fn = inclineFemaleName(name), mn = inclineMaleName(name), fn.found ? result = {
      found: !0,
      src: name,
      gender: "female",
      guess_case: fn.guess_case,
      female_cases: fn.cases,
      possible_cases: fn.possible_cases,
      nominative: fn.nominative
    } : mn.found ? result = {
      found: !0,
      src: name,
      gender: "male",
      guess_case: mn.guess_case,
      male_cases: mn.cases,
      possible_cases: mn.possible_cases,
      nominative: mn.nominative
    } : fn.possible_yes && mn.possible_yes ? (result = {
      found: "maybe",
      src: name,
      gender: [ "male", "female" ],
      female_cases: fn.cases,
      male_cases: mn.cases,
      possible_cases: util.merge(fn.possible_cases, mn.possible_cases)
    }, result.guess_case = fn.guess_case_index <= mn.guess_case_index ? fn.guess_case : mn.guess_case) : fn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "female",
      female_cases: fn.cases,
      guess_case: fn.cases,
      possible_cases: fn.possible_cases
    } : mn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "male",
      male_cases: mn.cases,
      guess_case: mn.cases,
      possible_cases: mn.possible_cases
    } : result = {
      found: !1,
      src: name
    }, result;
  }, inclineSurname = function(surname, noInclinesRe, inclineRe, casesRe) {
    var c, cases_index, check, i, result, surname_cases, _i, _j, _len, _len2;
    result = {
      found: null,
      src: surname,
      cases: null,
      cases_index: null
    };
    if (noInclinesRe && noInclinesRe.test(surname)) result = {
      found: surname,
      src: surname,
      cases: [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ],
      cases_index: [ 0, 1, 2, 3, 4, 5 ]
    }; else for (_i = 0, _len = inclineRe.length; _i < _len; _i++) {
      check = inclineRe[_i];
      if (check[0].test(surname)) {
        result = {
          found: surname.replace(check[0], check[1]),
          src: surname
        }, cases_index = [], surname_cases = [], i = 0;
        for (_j = 0, _len2 = casesRe.length; _j < _len2; _j++) c = casesRe[_j], c.test(surname) && (cases_index.push(i), surname_cases.push(cases[i])), i++;
        surname_cases.length === 0 ? (result.found = null, result.cases = null) : result.cases = surname_cases, result.cases_index = cases_index;
        break;
      }
    }
    return result.surname_cases && (result.guess_case = result.surname_cases[0]), result;
  }, exports.inclineFemaleSurname = inclineFemaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(е)|(о)|(э)|(и)|(ы)|(^[нв]у)|(^ую)|(уа)|(иа)|(ман)|(вич)|(ян))$/g, inclineRe = [ [ /((ова)|(овой)|(ову))$/g, "ова" ], [ /((ева)|(евой)|(еву))$/g, "ева" ], [ /((ёва)|(ёвой)|(ёву))$/g, "ёва" ], [ /((ина)|(иной)|(ину))$/g, "ина" ], [ /((ая)|(ой)|(ую))$/g, "ая" ] ], casesRe = [ /((ова)|(ева)|(ёва)|(ина)|(ая))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((ову)|(еву)|(ёву)|(ину)|(ую))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, exports.inclineMaleSurname = inclineMaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(^ве)|(^го)|(э)|(и)|(ы)|(^му)|(ю)|(уа)|(иа))$/g, inclineRe = [ [ /((ов)|(ова)|(ову)|(овым)|(ове))$/g, "ов" ], [ /((ев)|(ева)|(еву)|(евым)|(еве))$/g, "ев" ], [ /((ёв)|(ёва)|(ёву)|(ёвым)|(ёве))$/g, "ёв" ], [ /((ин)|(ина)|(ину)|(иным)|(ине))$/g, "ин" ], [ /((ский)|(ского)|(скому)|(ским)|(ском))$/g, "ский" ], [ /((ской)|(ского)|(скому)|(ским)|(ском))$/g, "ской" ], [ /((ман)|(мана)|(ману)|(маном)|(мане))$/g, "ман" ], [ /((ой)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ой" ], [ /((ий)|(ого)|(ому)|(ого)|(им)|(ом))$/g, "ий" ], [ /((ый)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ый" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ], [ /((ян)|(яна)|(яну)|(яна)|(яном)|(яне))$/g, "ян" ] ], casesRe = [ /((ов)|(ев)|(ёв)|(ин)|(ский)|(ской)|(ой)|(ий)|(ый)|(ман)|(ич)|(ян))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((ову)|(еву)|(ёву)|(ину)|(скому)|(ому)|(ману)|(ичу)|(яну))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((овым)|(евым)|(ёвым)|(иным)|(ским)|(им)|(ым)|(маном)|(ичем)|(яном))$/g, /((ове)|(еве)|(ёве)|(ине)|(ском)|(ом)|(мане)|(иче)|(яне))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, inclineMiddleNameOrSurname = function(src, fem, male) {
    var result, _ref;
    return fem.found === (_ref = male.found) && _ref === null ? result = {
      found: !1,
      src: src,
      value: null,
      gender: null
    } : fem.found && male.found ? (result = {
      found: !0,
      src: src,
      gender: [ "male", "female" ]
    }, result.nominative_male = male.found, result.nominative_female = fem.found, result.female_cases = fem.cases, result.male_cases = male.cases, fem.cases.length === 6 ? male.cases.length === 6 ? (result.guess_sex = "unknown", result.possible_cases = util.merge(fem.cases, male.cases)) : (result.guess_sex = "male", result.nominative = male.found, result.possible_cases = male.cases) : fem.cases.length === 1 && male.cases.length > 1 ? (result.guess_sex = "female", result.nominative = fem.found, result.possible_cases = fem.cases) : result.possible_cases = util.merge(fem.cases, male.cases)) : fem.found ? male.found || (result = {
      found: !0,
      src: src,
      gender: "female",
      female_cases: fem.cases,
      guess_case: fem.guess_case,
      nominative: fem.found,
      possible_cases: fem.cases
    }) : result = {
      found: !0,
      src: src,
      gender: "male",
      male_cases: male.cases,
      guess_case: male.guess_case,
      nominative: male.found,
      possible_cases: male.cases
    }, result;
  }, exports.inclineSurname = inclinePersonSurname = function(surname) {
    return inclineMiddleNameOrSurname(surname, inclineFemaleSurname(surname), inclineMaleSurname(surname));
  }, exports.inclineMaleMiddleName = inclineMaleMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((евич)|(евича)|(евичу)|(евича)|(евичем)|(евиче))$/g, "евич" ], [ /((ович)|(овича)|(овичу)|(овича)|(овичем)|(овиче))$/g, "ович" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ] ], casesRe = [ /((евич)|(ович)|(ич))$/g, /((евича)|(овича)|(ича))$/g, /((евичу)|(овичу)|(ичу))$/g, /((евича)|(овича)|(ича))$/g, /((евичем)|(овичем)|(ичем))$/g, /((евиче)|(овиче)|(иче))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineFemMiddleName = inclineFemMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((вна)|(вны)|(вне)|(вну)|(вной)|(вне))$/g, "вна" ], [ /((чна)|(чны)|(чне)|(чну)|(чной)|(чне))$/g, "чна" ] ], casesRe = [ /((вна)|(чна))$/g, /((вны)|(чны))$/g, /((вне)|(чне))$/g, /((вну)|(чну))$/g, /((вной)|(чной))$/g, /((вне)|(чне))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineMiddleName = inclineMiddleName = function(mname) {
    return inclineMiddleNameOrSurname(mname, inclineFemMiddleName(mname), inclineMaleMiddleName(mname));
  }, genderMatch = function(g1, g2) {
    return g1 === g2 || __indexOf.call(g2, g1) >= 0 ? g1 : __indexOf.call(g1, g2) >= 0 ? g2 : null;
  }, matchNameParts = function(fn, mn, sn) {
    var overallGender, surname, theCase;
    return theCase = util.intersection(fn.possible_cases, mn.possible_cases), overallGender = genderMatch(genderMatch(fn.gender, mn.gender), sn.gender), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: mn.nominative,
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchNameAndSurname = function(fn, sn) {
    var overallGender, surname, theCase;
    return overallGender = genderMatch(fn.gender, sn.gender), theCase = util.intersection(fn.possible_cases, sn.possible_cases), theCase || (sn.possible_cases = sn["" + overallGender + "_cases"], sn.nominative = sn["nominative_" + overallGender], theCase = util.intersection(fn.possible_cases, sn.possible_cases)), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: "",
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchCase = function(pObj, target_case, gender) {
    return __indexOf.call(pObj["" + gender + "_cases"], target_case) >= 0;
  }, getNominative = function(pObj, gender) {
    var gnstr, nom;
    return gnstr = "nominative_" + gender, nom = pObj.nominative && pObj.nominative || pObj[gnstr], nom;
  }, exports.findProperName = findProperName = function(listOfWords, opts) {
    var mnr2, mnr3, nr1, nr2, nr3, result, sr1, sr2, sr3;
    opts == null && (opts = {}), result = {
      found: !1
    };
    switch (listOfWords.length) {
     case 1:
      result = inclineName(listOfWords[0]), result.found ? result.first_name = result.nominative : (result = inclinePersonSurname(listOfWords[0]), result.found && (result.surname = result.nominative));
      break;
     case 2:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr1.found && sr2.found && (result = matchNameAndSurname(nr1, sr2)), !result.found && sr1.found && nr2.found && (result = matchNameAndSurname(sr1, nr2));
      break;
     case 3:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), sr3 = inclinePersonSurname(listOfWords[2]), mnr2 = inclineMiddleName(listOfWords[1]), mnr3 = inclineMiddleName(listOfWords[2]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr3 = inclineName(listOfWords[2]), nr3.found ? result = {
        found: !1,
        error: "name at the end of 3-component proper name"
      } : nr1.found ? (mnr2.found && sr3.found && (result = matchNameParts(nr1, mnr2, sr3)), !result.found && sr2.found && (result = matchNameAndSurname(nr1, sr2))) : sr1.found && nr2.found && mnr3.found ? result = matchNameParts(nr2, mnr3, sr1) : nr2.found && sr3.found && (result = matchNameAndSurname(nr2, sr3));
    }
    return result.first_name || (result.first_name = ""), result.middle_name || (result.middle_name = ""), result.surname || (result.surname = ""), result.first_name || result.middle_name || result.surname || (result = {
      found: !1,
      error: "person not found"
    }), result.src = listOfWords.join(" "), result;
  }, exports.getInitialFormOfAdjective = function(adj) {
    var base;
    return adj = adj.toLowerCase(), /^[а-яё]{2,}(ая|ее|ие|ий|им|ими|их|ого|его|ое|ой|ом|ому|ою|ую|ые|ый|ым|ыми|ых|юю|яя)$/.test(adj) ? (/^[а-яё]{2,}(ими|ого|его|ому|ыми)$/gi.test(adj) ? base = adj.slice(0, -3) : base = adj.slice(0, -2), [ "" + base + "ый", "" + base + "ий", "" + base + "ой" ]) : null;
  }, exports.getVerbInfinitive = function(verb) {
    var pastTime, result, verbEnd;
    return verb = verb.toLowerCase(), /^[а-яё]{3,}(ать|аться|ить|иться|еть|еться|оть|оться|уть|утся|ются|ть|ться)$/.test(verb) ? verb : (/^[а-яё]{3,}(сь|ся)$/.test(verb) ? (verbEnd = verb.slice(-2), verb = verb.slice(0, -2)) : verbEnd = "", pastTime = verb.match(/^[а-яё]{3,}(л|ла|ло|ли)$/), pastTime ? result = verb.slice(0, -(1 + pastTime[1].length) + 1 || 9e9) + "ть" : /[а-яё]{3,}(у|ю|ем|ешь|ете|ет|ут|ют|им|ишь|ите|ит|ат|ят)$/.test(verb) && (/[а-яё]{3,}(ишь|ит|им|ите|ат|ят)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd ] : /[а-яё]{3,}(у|ю|ешь|ет|ем|ете|ут|ют)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd, "" + verb + "оть" + verbEnd, "" + verb + "уть" + verbEnd, "" + verb + "ть" + verbEnd ] : result = null), result);
  };
}(exports, util, ref);

var exports, ruWords, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.morpho = {}, exports = window.lastName.plugins.ru.morpho, ruWords = window.lastName.plugins.ru.words) : (exports = module.exports, ruWords = require("./words")), function(exports, ruWords) {
  var exceptions, getRulesAdjective, getRulesVerb, morphoRu;
  return exports.getWordRe = function() {
    return /^[а-я\-ё\d]+$/ig;
  }, exports.getAdjectiveEnds = function() {
    return {
      feminine: {
        ends: /((ая)|(ой)|(ую)|(яя)|(ей)|(юю))$/g,
        hard: /((ая)|(ой)|(ую))$/g,
        sort: /((яя)|(ей)|(юю))$/g,
        hardNominativeEnd: "ая",
        softNominativeEnd: "яя",
        gender: "feminine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ая" ? [ "" + word + "ая", "" + word + "ой", "" + word + "ой", "" + word + "ую", "" + word + "ой", "" + word + "ой" ] : [ "" + word + "яя", "" + word + "ей", "" + word + "ей", "" + word + "юю", "" + word + "ей", "" + word + "ей" ];
        }
      },
      masculine: {
        ends: /((ый)|(ого)|(ому)|(ым)|(ом)|(ий)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ый)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ий)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ый",
        softNominativeEnd: "ий",
        gender: "masculine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ый" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ий", "" + word + "ого", "" + word + "ому", "" + word + "ий", "" + word + "им", "" + word + "ом" ] : [ "" + word + "ый", "" + word + "ого", "" + word + "ому", "" + word + "ый", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ий", "" + word + "его", "" + word + "ему", "" + word + "ий", "" + word + "им", "" + word + "ем" ];
        }
      },
      neuter: {
        ends: /((ое)|(ого)|(ому)|(ым)|(ом)|(ее)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ое)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ее)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ое",
        softNominativeEnd: "ее",
        gender: "neuter",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ое" ? [ "" + word + "ое", "" + word + "ого", "" + word + "ому", "" + word + "ое", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ее", "" + word + "его", "" + word + "ему", "" + word + "ее", "" + word + "им", "" + word + "ем" ];
        }
      },
      plural: {
        ends: /((ые)|(ых)|(ым)|(ыми)|(ых)|(ие)|(их)|(им)|(ими)|(их))$/g,
        hard: /((ые)|(ых)|(ым)|(ыми)|(ых))$/g,
        soft: /((ие)|(их)|(им)|(ими)|(их))$/g,
        hardNominativeEnd: "ые",
        softNominativeEnd: "ие",
        gender: "unknown",
        singular: !1,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ые" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ] : [ "" + word + "ые", "" + word + "ых", "" + word + "ым", "" + word + "ые", "" + word + "ыми", "" + word + "ых" ] : [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ];
        }
      }
    };
  }, exceptions = function(word) {}, getRulesVerb = function() {
    return [ [ /нул[aи]{0,1}$/g, "ать" ], [ /еть$/g, "ать" ], [ /(ает)|(ают)$/g, "ать" ], [ /ал[aи]{0,1}$/g, "ать" ], [ /ул[aи]{0,1}$/g, "ать" ], [ /((ить)|(ать))$/g, "ать" ], [ /ая$/g, "ать" ], [ /((ил)|(или)|(ила)|(ило))$/g, "лять" ], [ /(ятся)|(ится)|(ился)|(илась)|(илось)$/g, "ится" ], [ /(яться)|(иться)$/g, "иться" ] ];
  }, getRulesAdjective = function() {
    return [ [ /в((ая)|(ые)|(ый)|(ое))$/, "вый" ], [ /((ая)|(ой)|(ие)|(ые)|(ый)|(ую))$/, "ый" ], [ /((яя)|(ее)|(ий)|(юю))$/, "ий" ] ];
  }, exports.morpho = morphoRu = function(word) {
    var adj, adjective, result, rule, verb, _i, _j, _len, _len2, _ref, _ref2;
    if (__indexOf.call(ruWords.adverbs, word) >= 0) return {
      type: "abverb",
      value: word
    };
    if (__indexOf.call(ruWords.prepositionAll, word) >= 0) return {
      type: "preposition",
      value: word
    };
    if (__indexOf.call(ruWords.unions, word) >= 0) return {
      type: "union",
      value: word
    };
    result = {
      type: "",
      value: ""
    }, verb = null, adjective = null, _ref = getRulesVerb();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      rule = _ref[_i];
      if (rule[0].test(word)) {
        result = {
          type: verb,
          value: word.replace(rule[0], rule[1])
        };
        break;
      }
    }
    _ref2 = getRulesAdjective();
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      rule = _ref2[_j];
      if (rule[0].test(word)) {
        adj = word.replace(rule[0], rule[1]), result.type ? (result.type += " adjective", result.value = [ result.value, adj ]) : result = {
          type: "adjective",
          value: adj
        };
        break;
      }
    }
    return result;
  }, exports.analyseText = function(text) {
    var doubleSpaceRe, enRe, punctuationRe, r, result, ruRe, t, wordRe, _i, _len, _ref;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&№“”\—]/g, doubleSpaceRe = /\s+/g, text = text.replace(punctuationRe, " $& ").replace(doubleSpaceRe, " ") + " .", result = [], _ref = text.split(" ");
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      t = _ref[_i], ruRe = /^[а-я\-ё]+$/ig, enRe = /^[a-z\-]+$/ig, wordRe = /^[а-яё\-\da-z]+$/ig, r = morphoRu(t.toLowerCase());
      switch (r.type) {
       case "adverb":
        result.push("[ADV " + t + "]");
        break;
       case "verb":
       case "adjective":
        result.push("[ " + r.value + " ]");
        break;
       case "verb adjective":
        result.push("[#VA " + r.value[0] + "]");
        break;
       case "union":
        result.push("[U " + t + "]");
        break;
       case "preposition":
        result.push("[PP " + t + "]");
        break;
       default:
        result.push(t);
      }
      t === "." && result.push("\n");
    }
    return result;
  }, exports.parseRuSentence = function(sentences) {
    var abbrevs, common_used_words, digits, regular_words, special_words, total_words;
    return sentences instanceof Array || (sentences = [ sentences ]), abbrevs = {}, special_words = {}, digits = {}, common_used_words = {}, regular_words = {}, total_words = 0, sentences.map(function(sent) {
      var i, result, w, word, words, _len, _ref, _results;
      words = sent.split(" "), _results = [];
      for (i = 0, _len = words.length; i < _len; i++) word = words[i], /^[[,:\/\\\?!\+\-\*\(\)\[\]\&\№\—]]+$/.test(words) || total_words++, /^(\d+(|(\.(|\d+))))$/.test(word) ? digits[word] ? _results.push(digits[word]++) : _results.push(digits[word] = 1) : isUpperCase(word) && /^[а-яё\-]{2,}$/i.test(word) ? abbrevs[word] ? _results.push(abbrevs[word]++) : _results.push(abbrevs[word] = 1) : i > 0 && isCapitalized(word) && /^[а-яё\-]{2,}$/i.test(word) ? special_words[word] ? _results.push(special_words[word]++) : _results.push(special_words[word] = 1) : /^[а-яё\-]+$/i.test(word) && !/^\-+$/.test(word) ? (w = word.toLowerCase(), result = morphoRu(w), (_ref = result.type) !== "adverb" && _ref !== "preposition" && _ref !== "union" ? regular_words[w] ? _results.push(regular_words[w]++) : _results.push(regular_words[w] = 1) : common_used_words[w] ? _results.push(common_used_words[w]++) : _results.push(common_used_words[w] = 1)) : _results.push(void 0);
      return _results;
    }), {
      abbrevs: abbrevs,
      common_used_words: common_used_words,
      special_words: special_words,
      regular_words: regular_words,
      digits: digits,
      total_words: total_words
    };
  };
}(exports, ruWords);

var exports, inclines, morpho, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.propernames = {}, exports = window.lastName.plugins.ru.propernames, morpho = window.lastName.plugins.ru.morpho, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, morpho = require("./morpho"), inclines = require("./inclines")), function(exports, morpho, inclines) {
  return exports.postFilter = function(text, result) {
    var curProperName, id, p, pn, pnDict, properNames, properNamesRe, punctuationRe, _i, _j, _len, _len2, _ref, _ref2;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&\№“”\—]/g, properNames = [], curProperName = [], properNamesRe = /[А-Я][а-яё]+(\s+[А-Я][а-яё]+){0,2}/gm, _ref = text.match(properNamesRe);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) pn = _ref[_i], curProperName = pn.replace(/\s+/g, " ").split(" "), curProperName && (pn = inclines.findProperName(curProperName), pn && pn.found && properNames.push(pn));
    pnDict = {};
    for (_j = 0, _len2 = properNames.length; _j < _len2; _j++) p = properNames[_j], id = "" + (p.first_name || "") + "-" + (p.middle_name || "") + "-" + (p.surname || ""), pnDict[id] ? (pnDict[id].count += 1, (_ref2 = p.src, __indexOf.call(pnDict[id].src, _ref2) < 0) && pnDict[id].src.push(p.src)) : (pnDict[id] = p, pnDict[id].src = [ p.src ], pnDict[id].count = 1);
    return result.propernames = pnDict;
  };
}(exports, morpho, inclines);

var exports, inclines, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName.plugins.ru.feelings = {}, exports = window.lastName.plugins.ru.feelings, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, inclines = require("./inclines")), function(exports, inclines) {
  var evaluateSentenceNeutrality, getNegativePhrasesRe, negativeAdjectives, negativeVerbs, negativeWordsIncline;
  return exports.positive = [], negativeAdjectives = {
    "агрессивный": 3,
    "атакованный": 2,
    "бедный": 2,
    "беззащитный": 2,
    "безнадежный": 3,
    "безрадостный": 2,
    "бесплодный": 3,
    "беспомощный": 3,
    "бесправный": 2,
    "бессердечный": 1,
    "бессильный": 1,
    "бесцельный": 2,
    "бесчестный": 2,
    "вздорный": 1,
    "виновный": 1,
    "ворчливый": 1,
    "враждебный": 2,
    "вспыльчивый": 1,
    "выпученный": 1,
    "выселенный": 3,
    "высмеянный": 2,
    "выхолощенный": 1,
    "глубокий": 1,
    "глупый": 2,
    "горький": 2,
    "готический": 2,
    "гротескный": 1,
    "грустный": 1,
    "грязный": 1,
    "девальвированный": 2,
    "деградировавший": 2,
    "дегуманизированный": 2,
    "дезорганизованный": 2,
    "дезориентированный": 2,
    "деморализованный": 3,
    "дерзкий": 1,
    "дерьмовый": 3,
    "дефектный": 3,
    "драматический": 3,
    "жалкий": 3,
    "жесткий": 2,
    "жестокосердный": 2,
    "заброшенный": 1,
    "забываемый": 1,
    "забывчивый": 1,
    "забытый": 2,
    "зависимый": 1,
    "заинтересованный": 1,
    "запрещенный": 3,
    "запутанный": 2,
    "застенчивый": 1,
    "застрявший": 1,
    "затравленный": 2,
    "зверский": 3,
    "злобный": 2,
    "идиотский": 3,
    "измельченный": 2,
    "измученный": 2,
    "изнасилованный": 3,
    "изолированный": 3,
    "изумленный": 1,
    "интенсивный": 1,
    "иррациональный": 2,
    "исключенный": 2,
    "искусственный": 2,
    "испуганный": 2,
    "истерический": 3,
    "исчерпанный": 2,
    "капризный": 2,
    "контролируемый": 1,
    "критический": 1,
    "ленивый": 2,
    "лишенный": 2,
    "ложный": 2,
    "мазохистский": 1,
    "мертвый": 3,
    "меченый": 2,
    "мрачный": 2,
    "мстительный": 2,
    "навязчивый": 2,
    "надоедливый": 2,
    "наказанный": 2,
    "нарушенный": 2,
    "натянутый": 2,
    "неадекватный": 2,
    "неактивный": 1,
    "небезопасный": 2,
    "небрежный": 1,
    "невежественный": 1,
    "невидимый": 1,
    "невротический": 2,
    "негуманный": 2,
    "недействительный": 1,
    "недовольный": 2,
    "недостаточный": 1,
    "недоуменный": 1,
    "незаземленный": 1,
    "незначительный": 1,
    "неискренний": 1,
    "некомпетентный": 2,
    "ненавистный": 3,
    "необщительный": 2,
    "неполный": 2,
    "неправильный": 2,
    "неприятный": 2,
    "нервный": 2,
    "нерешительный": 1,
    "несбалансированный": 1,
    "несовместимый": 2,
    "несоответствующий": 2,
    "неспособный": 3,
    "несчастный": 2,
    "неуклюжий": 2,
    "неуловимый": 1,
    "неуместный": 2,
    "нечестный": 2,
    "неэффективный": 2,
    "низкий": 1,
    "обвиняемый": 3,
    "обедненный": 1,
    "обезумевший": 3,
    "обиженный": 2,
    "обманутый": 2,
    "обозленный": 2,
    "оборонительный": 1,
    "обремененный": 1,
    "обременительный": 1,
    "обреченный": 2,
    "ограниченный": 1,
    "одержимый": 3,
    "одинокий": 2,
    "одноразовый": 1,
    "озабоченный": 2,
    "окаменелый": 1,
    "онемелый": 1,
    "опальный": 2,
    "опасный": 3,
    "опустошенный": 1,
    "опущенный": 2,
    "опьяненный": 1,
    "оскорбленный": 2,
    "осмеянный": 2,
    "острый": 1,
    "осужденный": 3,
    "осушенный": 2,
    "ответственный": 2,
    "отвратительный": 3,
    "отдаленный": 1,
    "отдельный": 1,
    "отрицательный": 2,
    "отсталый": 2,
    "отчаянный": 1,
    "ошибочный": 1,
    "параноидальный": 2,
    "паршивый": 2,
    "пассивный": 1,
    "переполненный": 2,
    "пессимистический": 2,
    "печальный": 2,
    "побежденный": 3,
    "поверхностный": 2,
    "поврежденный": 3,
    "подавленный": 2,
    "поддельный": 3,
    "покинутый": 2,
    "покорный": 1,
    "порабощенный": 3,
    "потерянный": 2,
    "потерпевший": 2,
    "потребленный": 1,
    "презираемый": 2,
    "презренный": 3,
    "презрительный": 2,
    "прерванный": 1,
    "принудительный": 2,
    "психотический": 2,
    "пустынный": 1,
    "пьяный": 2,
    "равнодушный": 1,
    "развращенный": 3,
    "раздраженный": 2,
    "раздражительный": 2,
    "разочарованный": 2,
    "разочаровывающий": 3,
    "разрушенный": 3,
    "разрушительный": 2,
    "разъяренный": 3,
    "раненый": 2,
    "ревнивый": 2,
    "садистский": 2,
    "самоубийственный": 3,
    "саркастический": 1,
    "сварливый": 1,
    "сгоревший": 3,
    "сердитый": 2,
    "серый": 1,
    "скучающий": 1,
    "скучный": 1,
    "сломанный": 2,
    "смущенный": 1,
    "созерцательный": 1,
    "сомнительный": 2,
    "спорный": 2,
    "спровоцированный": 2,
    "спутанный": 2,
    "спущенный": 2,
    "стереотипный": 1,
    "стесненный": 1,
    "странный": 1,
    "страшный": 2,
    "сумасшедший": 2,
    "тихий": 1,
    "тормозящий": 2,
    "торопливый": 2,
    "тоскливый": 3,
    "требовательный": 2,
    "тревожный": 2,
    "трудный": 2,
    "трусливый": 2,
    "тупой": 1,
    "тщеславный": 2,
    "угнетенный": 2,
    "угрюмый": 2,
    "удаляемый": 2,
    "удрученный": 2,
    "ужасный": 3,
    "уклончивый": 2,
    "униженный": 3,
    "унылый": 3,
    "урезанный": 2,
    "фальшивый": 3,
    "хаотический": 2,
    "холодный": 1,
    "хрупкий": 1,
    "цепкий": 2,
    "циничный": 2,
    "чертовский": 2,
    "чрезмерный": 2,
    "чувствительный": 2,
    "эгоистичный": 2,
    "эгоцентричный": 3,
    "эксплуатируемый": 2,
    "эмансипированный": 2,
    "эмоциональный": 1,
    "яростный": 3
  }, negativeVerbs = {
    "беспокоить": 2,
    "бить": 2,
    "внушать": 2,
    "волноваться": 2,
    "высмеивать": 2,
    "грызть": 1,
    "диктовать": 2,
    "дребезжать": 1,
    "дрожать": 1,
    "дрогнуть": 2,
    "загнать": 2,
    "запугивать": 3,
    "запутаться": 2,
    "злоупотреблять": 2,
    "игнорировать": 1,
    "избегать": 1,
    "издеваться": 3,
    "изменять": 2,
    "командовать": 1,
    "лгать": 2,
    "лишить": 2,
    "манипулировать": 2,
    "молчать": 1,
    "надувать": 1,
    "ненавидеть": 3,
    "обвинять": 2,
    "обидеть": 2,
    "опорочить": 3,
    "освистать": 3,
    "отбрасывать": 1,
    "отвлекаться": 2,
    "отклонить": 2,
    "отрекаться": 3,
    "оттолкнуть": 2,
    "паниковать": 2,
    "перепутаться": 2,
    "подавить": 3,
    "подвергаться": 2,
    "пострадать": 2,
    "предавать": 3,
    "пренебрегать": 2,
    "препятствовать": 2,
    "преследовать": 2,
    "принижаться": 2,
    "приставать": 2,
    "прослушивать": 2,
    "разгромить": 2,
    "раздражаться": 2,
    "растаскивать": 2,
    "рисковать": 2,
    "ругать": 2,
    "сдуваться": 1,
    "смолчать": 2,
    "снизиться": 1,
    "сорвать": 1,
    "сожалеть": 2,
    "соизволить": 2,
    "солгать": 2,
    "сомневаться": 2,
    "споткнуться": 1,
    "столкнуться": 2,
    "страдать": 2,
    "стрелять": 3,
    "судить": 2,
    "толкнуть": 1,
    "убить": 3,
    "убивать": 3,
    "уговаривать": 1,
    "удалять": 2,
    "уклоняться": 2,
    "унижать": 3,
    "шантажировать": 2
  }, negativeWordsIncline = {
    "боль": 2,
    "вниз": 1,
    "горе": 3,
    "дно": 2,
    "мало": 1,
    "мучение": 2,
    "недовольство": 2,
    "плохо": 2,
    "противно": 3,
    "совестно": 2,
    "только": 1,
    "ужас": 3,
    "смерть": 3,
    "неодобрительно": 2,
    "разгром": 2,
    "отчаяние": 3
  }, exports.getNegativePhrasesRe = getNegativePhrasesRe = function() {
    return [ [ /[^а-яё]при\sотягчающих\sобстоятельствах[^а-яё]/ig, 2 ], [ /[^а-яё]ненависть\sк[^а-яё]/ig, 3 ], [ /[^а-яё]в\sубыток[^а-яё]/ig, 2 ], [ /[^а-яё]сыт[аы]?\sпо\sгорло[^а-яё]/ig, 3 ], [ /[^а-яё]заслужива[ею]т\sнаказания[^а-яё]/ig, 2 ], [ /[^а-яё]находящ(егося|ейся|емся|ихся)\sпод\sугрозой\sисчезновения[^а-яё]/ig, 3 ], [ /[^а-яё]в\sзаблуждение[^а-яё]/ig, 2 ], [ /[^а-яё]сбит[аы]?\sс\sтолку[^а-яё]/ig, 2 ], [ /[^а-яё]в\sужасе[^а-яё]/ig, 3 ], [ /[^а-яё]не\sрекоменд(ую|уем|уется|овал|овала|овали)[^а-яё]/ig, 2 ], [ /[^а-яё]не\sодобря(ю|ем|л|ла|ли|ется)[^а-яё]/ig, 2 ], [ /[^а-яё]пятно\sна[^а-яё]/ig, 2 ], [ /[^а-яё]в\sклетке[^а-яё]/ig, 1 ], [ /[^а-яё]неправильно\sпонял[аи]?[^а-яё]/ig, 2 ], [ /[^а-яё]вне\sпределов\sдосягаемости[^а-яё]/ig, 1 ], [ /[^а-яё]взял[аи]?\sна[^а-яё]/ig, 2 ], [ /[^а-яё]играл[аи]?\sс[^а-яё]/ig, 2 ], [ /[^а-яё]черный\sсписок[^а-яё]/ig, 3 ], [ /[^а-яё]возбужден[оы]\sуголовн(ое|ые)\sдел[оа][^а-яё]/ig, 8 ], [ /[^а-яё]жертв(|а|ы|ам|ами)[^а-яё]/ig, 3 ] ];
  }, exports.evaluateSentenceNeutrality = evaluateSentenceNeutrality = function(sentence) {
    var adj, adjArray, adjIndex, curWords, cur_index, ind, index, m, nr, resetCurIndex, vIndex, verb, words, wrd, _i, _j, _k, _len, _len2, _len3, _ref, _ref2;
    index = 0, cur_index = 0, words = [], curWords = [], _ref = getNegativePhrasesRe();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) nr = _ref[_i], m = sentence.match(nr[0]), m && (m.map(function(wordsSequence) {
      return words.push(wordsSequence);
    }), index -= nr[1] * m.length);
    resetCurIndex = function() {
      if (cur_index) return index += cur_index, words.push(curWords), curWords = [], cur_index = 0;
    }, _ref2 = sentence.split(/\s/);
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      wrd = _ref2[_j];
      if (__indexOf.call(".,-—!?()[]", wrd) >= 0) {
        cur_index = -cur_index, resetCurIndex();
        continue;
      }
      ind = negativeWordsIncline[wrd.toLowerCase()];
      if (ind) curWords.push(wrd), cur_index = cur_index * ind || ind; else {
        adjArray = inclines.getInitialFormOfAdjective(wrd);
        if (!adjArray) verb = inclines.getVerbInfinitive(wrd), vIndex = negativeVerbs[verb], vIndex ? (curWords.push(wrd), cur_index = cur_index * vIndex || vIndex) : (cur_index = -cur_index, resetCurIndex()); else for (_k = 0, _len3 = adjArray.length; _k < _len3; _k++) {
          adj = adjArray[_k], adjIndex = negativeAdjectives[adj];
          if (adjIndex) {
            curWords.push(wrd), cur_index = cur_index * adjIndex || adjIndex;
            break;
          }
        }
      }
    }
    return resetCurIndex(-cur_index), [ index, words ];
  }, exports.postFilter = function(text, result) {
    var emoIndex, emoWords, i, index, overallIndex, s, _len, _ref, _ref2;
    emoIndex = [], overallIndex = 0, _ref = result.misc.sentences;
    for (i = 0, _len = _ref.length; i < _len; i++) s = _ref[i], _ref2 = evaluateSentenceNeutrality(s), index = _ref2[0], emoWords = _ref2[1], emoIndex.push([ index, emoWords ]), overallIndex += index;
    return result.feelings = {
      emoIndex: emoIndex,
      overallIndex: overallIndex,
      emoScore: overallIndex / result.counters.words_total || 1
    };
  };
}(exports, inclines);

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).analysis || (_base.analysis = {}), exports = window.lastName.analysis) : exports = module.exports, function(exports) {
  return exports.analyse = function(text, plugins) {
    var f, misc, postFilter, preFilters, result, util, _i, _j, _len, _len2;
    plugins == null && (plugins = []), "undefined" == typeof global ? (misc = window.lastName.misc, util = window.lastName.util) : (misc = require("./misc"), util = require("./util")), result = {}, misc.preFilter(text, result), preFilters = plugins.filter(function(plugin) {
      return "function" == typeof plugin.preFilter;
    }), postFilter = plugins.filter(function(plugin) {
      return "function" == typeof plugin.postFilter;
    });
    for (_i = 0, _len = preFilters.length; _i < _len; _i++) f = preFilters[_i], f.preFilter(text, result);
    for (_j = 0, _len2 = postFilter.length; _j < _len2; _j++) f = postFilter[_j], f.postFilter(text, result);
    return result.version = util.version, result;
  };
}(exports);

var __slice = Array.prototype.slice;

(function(lastname) {
  return lastname.version = "0.3.5", lastname.findProperName = function() {
    var args, inclines, lang;
    return lang = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [], inclines = lastname.plugins["" + lang].inclines, inclines.findProperName.apply(this, args);
  };
})(window.lastName || (window.lastName = {}));

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).misc || (_base.misc = {}), exports = window.lastName.misc) : exports = module.exports, function(exports) {
  return exports.preFilter = function(text, result) {
    var chars_total, emo, emoticons, findEmo, ind, punctuationRe, sentences, signs, signs_total, spaces_total, tempTxt, word_length_mid, words_total, _i, _len;
    signs = text.match(/[-\+=\/\.,\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]{1}/g), signs_total = signs && signs.length || 0, spaces_total = /\s/.test(text) ? text.match(/\s/g).length : 0, chars_total = text.length, words_total = text.split(/\s/).filter(function(wrd) {
      return wrd.length > 0 && !/^[-\+=\/\.\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]+$/.test(wrd);
    }).length, word_length_mid = words_total ? (chars_total - spaces_total - signs_total) / words_total : 0, emoticons = [ ":-)", "(-:", ":o)", ":)", "(:", ":->", ":-}", ":-t", ":*)", ":-)))", ":-D", "(-D", ":'-)", "%-)", ":-/", ":-I", ":~)", "(:-(", ":-(", ":-c", ":-(((", ":-<", ">:-(", ":-[", "(:-&", "%-(", ">:-<", "~ :-(", "%-(", ":/)", ":-|", ":-e", ":-X", ":-v", ":-I", ":-8(", ":-O", ":-@", ":,-(", ":'-(", "~:-o", "]:-)>", "):-)", ";->", ":-x", ":-*", "8-]", ":-J", ":-&", ":-p", ":-P", ";-)", ";)", "'-)", ":-7", "?-(", "B-D", ":-B", ":-*)", ":-9", "|-p", ":-b", "-]:-)[-", "8-I", "8-|", "|:-|", ":-]", "|-)", "|-I", "I^o", "|-O", ':-"', ":-s", ":-#", ":-!", ":-()", ":-D", "(:-$", ":-(*)", ":-')", ":-R", "%+|", "%+{", "X-(", "<:-)", "*:o)", "@;-)", "X:-)", ":>)", "&:-)", "#:-)", "8-)", "8:-)", "B-)", "B-]", "O:-)", "&8-|", ":-{", ":-)}", ":-)#", ":-Q", ":-I", ":-d~", ":-?", ":-/I", ":-) X", "{(:-)", ":-{}", "[:-)", "d :-o", "~:-(", "~~:-(", "))", "(:-I", "3:-o", "[: |]", "M-)", ":X)", ":-M", "*8((:", "O+", "O->", "||*(", "||*)", "<{:-)}", "(-: :-)", "@->-", "@==", "<')))))- <" ], emoticons.sort(function(a, b) {
      return b.length - a.length;
    }), tempTxt = text.slice(0), findEmo = [];
    for (_i = 0, _len = emoticons.length; _i < _len; _i++) {
      emo = emoticons[_i], ind = 0;
      while (ind >= 0) ind = tempTxt.indexOf(emo, ind), ind !== -1 && (findEmo.push(emo), tempTxt = tempTxt.replace(emo, ""), ind -= emo.length + 2);
    }
    return punctuationRe = /(https?\:\/\/.*[\s$])|(\.\s)|(,\s)|(\s\:)|(:\s)|(\s\/)|(\/\s)|(\s\\)(\\\s)|\?|!|\+|\'|\"|«|»|\*|\(|\)|\[|\]|\&|\№|“|”|\—/g, tempTxt = text.replace(punctuationRe, " $& ").replace(/\s+/g, " "), /[\?\!\.]\s{0,}$/.test(tempTxt) || (tempTxt += " . "), sentences = tempTxt.replace(/\s\?\s/gm, " ?? ").replace(/\s\!\s/gm, " !! ").replace(/\s\.\s/gm, " .. ").split(/[\?\!\.](\s+|$)/gm).filter(function(s) {
      return !/^\s{0,}$/.test(s);
    }), result.misc = {
      digits: util.arrayToDict(text.match(/-?((\d+[\.,]\d+)|(\d+))/ig) || []),
      emoticons: util.arrayToDict(findEmo),
      romans: util.arrayToDict(text.match(/(([IXCM])\2{3,})|[^IVXLCDM]|([IL][LCDM])|([XD][DM])|(V[VXLCDM])|(IX[VXLC])|(VI[VX])|(XC[LCDM])|(LX[LC])|((CM|DC)[DM])|(I[VX]I)|(X[CL]X)|(C[DM]C)|(I{2,}[VX])|(X{2,}[CL])|(C{2,}[DM])/g) || []),
      sentences: sentences
    }, result.counters = {
      chars_total: chars_total,
      words_total: words_total,
      signs_total: signs_total,
      spaces_total: spaces_total,
      word_length_mid: word_length_mid,
      words_in_sentence_mid: sentences.length ? words_total / sentences.length : 0
    }, result;
  };
}(exports);

var exports, _base, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).util || (_base.util = {}), exports = window.lastName.util) : exports = module.exports, function(exports) {
  var capitalize, dictKeys, intersection, isCapitalized, isLowerCase, isUpperCase, merge, unique;
  return exports.version = "0.3.17", exports.capitalize = capitalize = function(s) {
    if (s) return "" + s[0].toUpperCase() + s.slice(1).toLowerCase();
  }, exports.dictKeys = dictKeys = function(dict) {
    var k, keys, v;
    keys = [];
    for (k in dict) v = dict[k], keys.push(k);
    return keys;
  }, exports.isCapitalized = isCapitalized = function(word) {
    var cap;
    return 0 <= word.indexOf("-") ? (cap = !0, word.split("-").map(function(wrd) {
      return cap && (cap = isCapitalized(wrd));
    }), cap) : word && word === capitalize(word) || !1;
  }, exports.isUpperCase = isUpperCase = function(word) {
    return word === word.toUpperCase();
  }, exports.isLowerCase = isLowerCase = function(word) {
    return word === word.toLowerCase();
  }, exports.unique = unique = function(array) {
    var key, output, value, _ref, _results;
    output = {};
    for (key = 0, _ref = array.length; 0 <= _ref ? key < _ref : key > _ref; 0 <= _ref ? key++ : key--) output[array[key]] = array[key];
    _results = [];
    for (key in output) value = output[key], _results.push(value);
    return _results;
  }, exports.merge = merge = function(l1, l2) {
    var l;
    return l = [], l1.map(function(x) {
      return l.push(x);
    }), l2.map(function(x) {
      return l.push(x);
    }), unique(l);
  }, exports.intersection = intersection = function(l1, l2) {
    var i, _i, _len;
    for (_i = 0, _len = l1.length; _i < _len; _i++) {
      i = l1[_i];
      if (__indexOf.call(l2, i) >= 0) return i;
    }
    return null;
  }, exports.arrayToDict = function(arr) {
    var d, i, _i, _len;
    d = {};
    for (_i = 0, _len = arr.length; _i < _len; _i++) i = arr[_i], d[i] ? d[i]++ : d[i] = 1;
    return d;
  };
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.ref = {}, exports = window.lastName.plugins.ru.ref) : exports = module.exports, function(exports) {
  return exports.ruFemaleNamesDict = {
    "альвина": 1,
    "анелия": 1,
    "августа": 1,
    "августина": 1,
    "авдотья": 1,
    "авелина": 1,
    "аврелия": 1,
    "аврора": 1,
    "агапия": 1,
    "агата": 1,
    "агафья": 1,
    "агафия": 1,
    "аглаида": 1,
    "аглая": 1,
    "агнеса": 1,
    "агнесса": 1,
    "агния": 1,
    "агриппмеа": 1,
    "агрефена": 1,
    "ада": 1,
    "адина": 1,
    "адель": 1,
    "аделия": 1,
    "аделаида": 1,
    "аза": 1,
    "азалия": 1,
    "аида": 1,
    "айседора": 1,
    "айсылу": 1,
    "акилина": 1,
    "акулина": 1,
    "аксинья": 1,
    "алевтина": 1,
    "александра": 1,
    "алеся": 1,
    "алена": 1,
    "алина": 1,
    "алиса": 1,
    "алия": 1,
    "алла": 1,
    "алика": 1,
    "альбина": 1,
    "альмир": 1,
    "альфия": 1,
    "амина": 1,
    "анастасия": 1,
    "анатолия": 1,
    "ангелина": 1,
    "анжела": 1,
    "анимаиса": 1,
    "анисия": 1,
    "анисья": 1,
    "анна": 1,
    "анита": 1,
    "антонина": 1,
    "антонида": 1,
    "антония": 1,
    "анфиса": 1,
    "анфуса": 1,
    "анфия": 1,
    "амира": 1,
    "аполлинария": 1,
    "аревик": 1,
    "ариадна": 1,
    "арина": 1,
    "аркадия": 1,
    "арсения": 1,
    "арсиана": 1,
    "артемия": 1,
    "асель": 1,
    "аста": 1,
    "астра": 1,
    "астрид": 1,
    "афанасия": 1,
    "афродита": 1,
    "аэлита": 1,
    "аэлла": 1,
    "амалия": 1,
    "бажена": 1,
    "беата": 1,
    "беатриса": 1,
    "бела": 1,
    "белла": 1,
    "беллатриса": 1,
    "берта": 1,
    "богдана": 1,
    "божена": 1,
    "болеслава": 1,
    "борислава": 1,
    "бриджет": 1,
    "бронислава": 1,
    "валентина": 1,
    "валерия": 1,
    "ванда": 1,
    "варвара": 1,
    "василина": 1,
    "василиса": 1,
    "васса": 1,
    "вацлава": 1,
    "вевея": 1,
    "велора": 1,
    "велория": 1,
    "венера": 1,
    "вера": 1,
    "вероника": 1,
    "веселина": 1,
    "веста": 1,
    "видана": 1,
    "викторина": 1,
    "виктория": 1,
    "вилена": 1,
    "виола": 1,
    "виолетта": 1,
    "виоланта": 1,
    "виринея": 1,
    "вита": 1,
    "виталия": 1,
    "виталина": 1,
    "виулена": 1,
    "влада": 1,
    "владилена": 1,
    "владимира": 1,
    "владислава": 1,
    "владлена": 1,
    "власта": 1,
    "воля": 1,
    "всеслава": 1,
    "гайя": 1,
    "гали": 1,
    "галина": 1,
    "ганна": 1,
    "гаяна": 1,
    "гаяния": 1,
    "гвинет": 1,
    "гелена": 1,
    "гелия": 1,
    "гелла": 1,
    "генриетта": 1,
    "гертруда": 1,
    "глафира": 1,
    "гликерия": 1,
    "глория": 1,
    "голуба": 1,
    "горислава": 1,
    "гюльанэ": 1,
    "гюльнара": 1,
    "гюльчитай": 1,
    "даздраперма": 1,
    "дайна": 1,
    "дана": 1,
    "дарья": 1,
    "дария": 1,
    "дарина": 1,
    "дарьяна": 1,
    "декабрина": 1,
    "дея": 1,
    "дия": 1,
    "джиневра": 1,
    "дженнифер": 1,
    "джульета": 1,
    "дианна": 1,
    "дилия": 1,
    "диля": 1,
    "дильфуза": 1,
    "дина": 1,
    "диния": 1,
    "диодора": 1,
    "дионисия": 1,
    "добрава": 1,
    "домна": 1,
    "домина": 1,
    "домника": 1,
    "доминика": 1,
    "донара": 1,
    "дорофея": 1,
    "доротея": 1,
    "ева": 1,
    "евгения": 1,
    "евдокия": 1,
    "евлалия": 1,
    "евлампия": 1,
    "евпраксия": 1,
    "евстолия": 1,
    "евфалия": 1,
    "евфросиния": 1,
    "екатерина": 1,
    "елена": 1,
    "елизавета": 1,
    "еликонида": 1,
    "ермиония": 1,
    "есения": 1,
    "ефимия": 1,
    "евфремия": 1,
    "жанна": 1,
    "ждана": 1,
    "жаннэ": 1,
    "жасмина": 1,
    "забава": 1,
    "заира": 1,
    "зара": 1,
    "зарема": 1,
    "зарина": 1,
    "зорина": 1,
    "заряна": 1,
    "зауре": 1,
    "звенислава": 1,
    "земфира": 1,
    "зиля": 1,
    "зинаида": 1,
    "зиновия": 1,
    "злата": 1,
    "зозан": 1,
    "зоя": 1,
    "зульфия": 1,
    "иванна": 1,
    "ида": 1,
    "илария": 1,
    "илиана": 1,
    "илона": 1,
    "ильмира": 1,
    "инга": 1,
    "индира": 1,
    "инесса": 1,
    "инна": 1,
    "иоанна": 1,
    "иона": 1,
    "ипатия": 1,
    "ипполита": 1,
    "ирада": 1,
    "ираида": 1,
    "ирена": 1,
    "ироида": 1,
    "ираклия": 1,
    "ирина": 1,
    "исидора": 1,
    "искра": 1,
    "ифигения": 1,
    "ия": 1,
    "кадрия": 1,
    "кермен": 1,
    "калиса": 1,
    "каллиста": 1,
    "камилла": 1,
    "камила": 1,
    "капитолина": 1,
    "карина": 1,
    "каролина": 1,
    "катерина": 1,
    "кира": 1,
    "кирилла": 1,
    "клавдия": 1,
    "клара": 1,
    "клариса": 1,
    "кларисса": 1,
    "клеопатра": 1,
    "клио": 1,
    "клер": 1,
    "конкордия": 1,
    "констанция": 1,
    "кристина": 1,
    "ксения": 1,
    "лавиния": 1,
    "лада": 1,
    "лана": 1,
    "лариса": 1,
    "лаура": 1,
    "лейла": 1,
    "лема": 1,
    "лена": 1,
    "лениана": 1,
    "ленина": 1,
    "леонида": 1,
    "леонила": 1,
    "леонтия": 1,
    "леся": 1,
    "ливия": 1,
    "лидия": 1,
    "лилиана": 1,
    "лилия": 1,
    "лилит": 1,
    "лина": 1,
    "лира": 1,
    "лия": 1,
    "лея": 1,
    "лора": 1,
    "луиза": 1,
    "лукерия": 1,
    "лукиана": 1,
    "лукина": 1,
    "люцина": 1,
    "лусинэ": 1,
    "любава": 1,
    "любовь": 1,
    "любомира": 1,
    "людмила": 1,
    "ляля": 1,
    "мавра": 1,
    "магда": 1,
    "магдалина": 1,
    "мадлен": 1,
    "майя": 1,
    "мая": 1,
    "мальвина": 1,
    "маргарита": 1,
    "мариана": 1,
    "марьяна": 1,
    "марианна": 1,
    "мариетта": 1,
    "мариэтта": 1,
    "марика": 1,
    "марина": 1,
    "мария": 1,
    "марья": 1,
    "мари": 1,
    "марлен": 1,
    "марлена": 1,
    "марта": 1,
    "марфа": 1,
    "матильда": 1,
    "матрена": 1,
    "матрёна": 1,
    "матрона": 1,
    "мелания": 1,
    "меланья": 1,
    "мелитина": 1,
    "милада": 1,
    "милана": 1,
    "милен": 1,
    "милица": 1,
    "милия": 1,
    "милослава": 1,
    "мира": 1,
    "мирра": 1,
    "мирослава": 1,
    "митродора": 1,
    "млада": 1,
    "мстислава": 1,
    "нада": 1,
    "надежда": 1,
    "надия": 1,
    "наина": 1,
    "наира": 1,
    "нана": 1,
    "настасья": 1,
    "наталья": 1,
    "наталия": 1,
    "нелли": 1,
    "неонила": 1,
    "ника": 1,
    "нина": 1,
    "нинелла": 1,
    "нинель": 1,
    "новелла": 1,
    "нонна": 1,
    "нора": 1,
    "нуркыз": 1,
    "насиба": 1,
    "оксана": 1,
    "октавия": 1,
    "октябрина": 1,
    "олеся": 1,
    "оливия": 1,
    "олимпиада": 1,
    "олимпия": 1,
    "ольга": 1,
    "офелия": 1,
    "павла": 1,
    "павлина": 1,
    "патриция": 1,
    "пелагея": 1,
    "платонида": 1,
    "поликсена": 1,
    "полина": 1,
    "правдина": 1,
    "прасковья": 1,
    "пенелопа": 1,
    "полислава": 1,
    "рада": 1,
    "радмила": 1,
    "раиса": 1,
    "раймонда": 1,
    "раялла": 1,
    "ревмира": 1,
    "регина": 1,
    "рената": 1,
    "римма": 1,
    "рогнеда": 1,
    "роза": 1,
    "розалина": 1,
    "розалия": 1,
    "розана": 1,
    "роксан": 1,
    "ростислава": 1,
    "руслана": 1,
    "руфина": 1,
    "руфь": 1,
    "раида": 1,
    "сабина": 1,
    "сабрина": 1,
    "саломея": 1,
    "соломея": 1,
    "самира": 1,
    "светлана": 1,
    "светозара": 1,
    "светослава": 1,
    "свобода": 1,
    "святослава": 1,
    "севастьяна": 1,
    "северина": 1,
    "селена": 1,
    "селина": 1,
    "селестина": 1,
    "серафима": 1,
    "сергияна": 1,
    "сильва": 1,
    "агриппина": 1,
    "алёна": 1,
    "вилора": 1,
    "вилория": 1,
    "джульетта": 1,
    "диана": 1,
    "евфимия": 1,
    "ефросиния": 1,
    "калерия": 1,
    "милена": 1,
    "муза": 1,
    "савина": 1,
    "сильвия": 1,
    "симона": 1,
    "слава": 1,
    "славяна": 1,
    "снежана": 1,
    "софья": 1,
    "софия": 1,
    "станислава": 1,
    "стелла": 1,
    "степанида": 1,
    "стефанида": 1,
    "стефания": 1,
    "сусанна": 1,
    "сосанна": 1,
    "сюзанна": 1,
    "таира": 1,
    "таисия": 1,
    "тальяна": 1,
    "тамара": 1,
    "тамила": 1,
    "томила": 1,
    "татьяна": 1,
    "текуса": 1,
    "тереза": 1,
    "улита": 1,
    "ульяна": 1,
    "услада": 1,
    "устинья": 1,
    "фаина": 1,
    "февронья": 1,
    "феликсана": 1,
    "фелицата": 1,
    "фелицитата": 1,
    "фелиция": 1,
    "федора": 1,
    "феодора": 1,
    "феодосия": 1,
    "феодосья": 1,
    "феоктиста": 1,
    "феофания": 1,
    "феона": 1,
    "флавия": 1,
    "флора": 1,
    "флория": 1,
    "флорентина": 1,
    "флоренция": 1,
    "флориана": 1,
    "фотина": 1,
    "харита": 1,
    "харитина": 1,
    "хиония": 1,
    "христина": 1,
    "цецилия": 1,
    "чеслава": 1,
    "эвелина": 1,
    "эвридика": 1,
    "эдда": 1,
    "элеонора": 1,
    "элина": 1,
    "эльвира": 1,
    "эльмира": 1,
    "эльза": 1,
    "эмилия": 1,
    "эмма": 1,
    "эрика": 1,
    "эсфирь": 1,
    "юдифь": 1,
    "юзефа": 1,
    "юлиана": 1,
    "юлитта": 1,
    "юлия": 1,
    "юманита": 1,
    "юния": 1,
    "юнона": 1,
    "юстина": 1,
    "ядвига": 1,
    "яна": 1,
    "янина": 1,
    "яромира": 1,
    "ярослава": 1
  }, exports.ruMaleNamesDict = {
    "ааран": 1,
    "аарен": 1,
    "ааррон": 1,
    "аб": 1,
    "аббат": 1,
    "абботт": 1,
    "абей": 1,
    "абелл": 1,
    "абель": 1,
    "абнар": 1,
    "абнер": 1,
    "абнор": 1,
    "абот": 1,
    "аботт": 1,
    "абрам": 1,
    "абран": 1,
    "абрахам": 1,
    "абсалон": 1,
    "авангард": 1,
    "август": 1,
    "августин": 1,
    "авдей": 1,
    "авдий": 1,
    "авенир": 1,
    "аверилл": 1,
    "аверкий": 1,
    "авксентий": 1,
    "аврам": 1,
    "аврор": 1,
    "аврорий": 1,
    "агап": 1,
    "аггей": 1,
    "агей": 1,
    "адам": 1,
    "аддам": 1,
    "аддисон": 1,
    "аден": 1,
    "адий": 1,
    "адисон": 1,
    "адиссон": 1,
    "адлэй": 1,
    "адней": 1,
    "адольф": 1,
    "адонис": 1,
    "адриан": 1,
    "адэйр": 1,
    "адэр": 1,
    "азия": 1,
    "азэлстан": 1,
    "айбл": 1,
    "айзек": 1,
    "айк": 1,
    "ак": 1,
    "акей": 1,
    "акерлеа": 1,
    "акерлей": 1,
    "акерли": 1,
    "аки": 1,
    "аким": 1,
    "аклеа": 1,
    "аклей": 1,
    "акли": 1,
    "аксён": 1,
    "актон": 1,
    "акэль": 1,
    "алан": 1,
    "аластеир": 1,
    "аластэйр": 1,
    "алвар": 1,
    "алвен": 1,
    "алви": 1,
    "алвин": 1,
    "алвис": 1,
    "алгар": 1,
    "алджернон": 1,
    "алевтин": 1,
    "алеистер": 1,
    "алек": 1,
    "алекс": 1,
    "александр": 1,
    "алексей": 1,
    "ален": 1,
    "алестер": 1,
    "алжир": 1,
    "алик": 1,
    "аликс": 1,
    "алим": 1,
    "алисандр": 1,
    "алисдэйр": 1,
    "алиссандр": 1,
    "алистер": 1,
    "алистэйр": 1,
    "аллан": 1,
    "аллен": 1,
    "аллин": 1,
    "аллистер": 1,
    "аллистир": 1,
    "аллистэйр": 1,
    "алтон": 1,
    "алф": 1,
    "алфонзо": 1,
    "алфорд": 1,
    "алфрид": 1,
    "альберт": 1,
    "альбин": 1,
    "альвиан": 1,
    "альвин": 1,
    "альдина": 1,
    "альпин": 1,
    "альтаир": 1,
    "альфа": 1,
    "альфи": 1,
    "альфред": 1,
    "алэйстер": 1,
    "алэйстэйр": 1,
    "амби": 1,
    "амброуз": 1,
    "амедеус": 1,
    "амиас": 1,
    "амори": 1,
    "амос": 1,
    "амьяс": 1,
    "анакин": 1,
    "ананий": 1,
    "анастасий": 1,
    "анатолий": 1,
    "анвар": 1,
    "ангел": 1,
    "ангес": 1,
    "андерсон": 1,
    "анджелл": 1,
    "андрей": 1,
    "андреян": 1,
    "андриан": 1,
    "андрон": 1,
    "анж": 1,
    "анис": 1,
    "анисий": 1,
    "анисим": 1,
    "анри": 1,
    "анском": 1,
    "анскомб": 1,
    "ансон": 1,
    "антван": 1,
    "антип": 1,
    "антон": 1,
    "антоний": 1,
    "антонин": 1,
    "антуан": 1,
    "аполлинарий": 1,
    "аполлон": 1,
    "арам": 1,
    "арвид": 1,
    "аргент": 1,
    "арден": 1,
    "арефий": 1,
    "арий": 1,
    "арик": 1,
    "арил": 1,
    "арин": 1,
    "аристарх": 1,
    "аркадий": 1,
    "аркелл": 1,
    "арлен": 1,
    "арли": 1,
    "арман": 1,
    "армен": 1,
    "арн": 1,
    "арне": 1,
    "арни": 1,
    "арнольд": 1,
    "арран": 1,
    "аррин": 1,
    "аррон": 1,
    "арсен": 1,
    "арсений": 1,
    "арт": 1,
    "артамон": 1,
    "артемий": 1,
    "арти": 1,
    "артур": 1,
    "артём": 1,
    "архип": 1,
    "арчи": 1,
    "арчибальд": 1,
    "аселет": 1,
    "аселин": 1,
    "асер": 1,
    "аскольд": 1,
    "астон": 1,
    "атеист": 1,
    "афанасий": 1,
    "афиноген": 1,
    "афтон": 1,
    "аффтон": 1,
    "ахмат": 1,
    "ахмет": 1,
    "ачилл": 1,
    "аш": 1,
    "ашер": 1,
    "ашот": 1,
    "аштон": 1,
    "баграт": 1,
    "бад": 1,
    "бадди": 1,
    "бажен": 1,
    "баз": 1,
    "базилик": 1,
    "байрон": 1,
    "байярд": 1,
    "бак": 1,
    "бакстер": 1,
    "балдер": 1,
    "балдрик": 1,
    "бамби": 1,
    "баптист": 1,
    "бардолф": 1,
    "барии": 1,
    "барклей": 1,
    "барнабас": 1,
    "барни": 1,
    "барнэби": 1,
    "барретт": 1,
    "барри": 1,
    "барт": 1,
    "бартоломей": 1,
    "бассетт": 1,
    "бастер": 1,
    "бастиан": 1,
    "батч": 1,
    "баян": 1,
    "беван": 1,
    "беверли": 1,
    "бевис": 1,
    "бедивир": 1,
    "бейб": 1,
    "бейлей": 1,
    "бейлие": 1,
    "бен": 1,
    "бенджамин": 1,
    "бенджи": 1,
    "бенедикт": 1,
    "бенет": 1,
    "беннетт": 1,
    "бенни": 1,
    "бенние": 1,
    "бенсон": 1,
    "бентлей": 1,
    "бентон": 1,
    "беорегард": 1,
    "бердт": 1,
    "беренгар": 1,
    "беренджер": 1,
    "берет": 1,
    "бернард": 1,
    "берни": 1,
    "берри": 1,
    "берт": 1,
    "берти": 1,
    "бертольд": 1,
    "бертон": 1,
    "бертрам": 1,
    "бертран": 1,
    "бивис": 1,
    "билл": 1,
    "билли": 1,
    "бисш": 1,
    "биф": 1,
    "блейн": 1,
    "близэ": 1,
    "блисс": 1,
    "блэйз": 1,
    "блэйк": 1,
    "блэйн": 1,
    "блэр": 1,
    "боб": 1,
    "бобби": 1,
    "богдан": 1,
    "боеслав": 1,
    "болдуин": 1,
    "болеслав": 1,
    "боллард": 1,
    "бомонт": 1,
    "бонифэйс": 1,
    "боримир": 1,
    "борис": 1,
    "борислав": 1,
    "боян": 1,
    "брадлей": 1,
    "браеден": 1,
    "брайен": 1,
    "брайон": 1,
    "бранден": 1,
    "брандон": 1,
    "браннон": 1,
    "брейден": 1,
    "брейдн": 1,
    "брендан": 1,
    "бренден": 1,
    "брендон": 1,
    "бреннан": 1,
    "брент": 1,
    "брентон": 1,
    "брет": 1,
    "бретт": 1,
    "бриар": 1,
    "брион": 1,
    "брис": 1,
    "бриско": 1,
    "бриттон": 1,
    "бриэм": 1,
    "бродерик": 1,
    "броди": 1,
    "броз": 1,
    "брок": 1,
    "бронислав": 1,
    "бронт": 1,
    "броуди": 1,
    "броук": 1,
    "брук": 1,
    "брукс": 1,
    "бруно": 1,
    "брутус": 1,
    "брьянт": 1,
    "брэд": 1,
    "брэди": 1,
    "брэдфорд": 1,
    "брэйден": 1,
    "брэйди": 1,
    "брэм": 1,
    "брэн": 1,
    "брюс": 1,
    "брююс": 1,
    "будимир": 1,
    "буз": 1,
    "букер": 1,
    "булат": 1,
    "бью": 1,
    "бэйли": 1,
    "вавила": 1,
    "вадим": 1,
    "вал": 1,
    "валентайн": 1,
    "валентин": 1,
    "валериан": 1,
    "валерий": 1,
    "валерьян": 1,
    "вальдемар": 1,
    "вальтер": 1,
    "ванадий": 1,
    "вард": 1,
    "варлаам": 1,
    "варлам": 1,
    "варлен": 1,
    "вартан": 1,
    "варфоломей": 1,
    "василий": 1,
    "василько": 1,
    "ваухан": 1,
    "вахтанг": 1,
    "вацлав": 1,
    "вашингтон": 1,
    "вебстер": 1,
    "велдон": 1,
    "велимир": 1,
    "велислав": 1,
    "велор": 1,
    "велорий": 1,
    "венедикт": 1,
    "вениамин": 1,
    "вер": 1,
    "вергилий": 1,
    "верджил": 1,
    "верн": 1,
    "вернон": 1,
    "вестер": 1,
    "вестлей": 1,
    "вестон": 1,
    "вик": 1,
    "викентий": 1,
    "виктор": 1,
    "вил": 1,
    "вилберн": 1,
    "вилей": 1,
    "вилен": 1,
    "вилий": 1,
    "вилиор": 1,
    "вилки": 1,
    "вилл": 1,
    "вилли": 1,
    "виллоби": 1,
    "вилмар": 1,
    "вилмер": 1,
    "вилмот": 1,
    "вилор": 1,
    "вилорг": 1,
    "вилорий": 1,
    "вилсон": 1,
    "вилф": 1,
    "вилфорд": 1,
    "виль": 1,
    "вильгельм": 1,
    "вильтон": 1,
    "вильям": 1,
    "вин": 1,
    "виндзор": 1,
    "винни": 1,
    "винс": 1,
    "винсент": 1,
    "винслоу": 1,
    "винтроп": 1,
    "винцент": 1,
    "виолен": 1,
    "вирджиль": 1,
    "виссарион": 1,
    "вистан": 1,
    "виталий": 1,
    "витейкр": 1,
    "витней": 1,
    "витольд": 1,
    "влад": 1,
    "владелин": 1,
    "владилен": 1,
    "владимир": 1,
    "владислав": 1,
    "владлен": 1,
    "влас": 1,
    "власий": 1,
    "воган": 1,
    "вогн": 1,
    "воин": 1,
    "воислав": 1,
    "волдо": 1,
    "волемир": 1,
    "волкер": 1,
    "воллис": 1,
    "володар": 1,
    "вольдемар": 1,
    "вольмир": 1,
    "вольт": 1,
    "вольф": 1,
    "вольфрам": 1,
    "воспой": 1,
    "всеволод": 1,
    "всемил": 1,
    "вуди": 1,
    "вудроу": 1,
    "вулф": 1,
    "вьятт": 1,
    "вэйд": 1,
    "вэйланд": 1,
    "вэнс": 1,
    "вячеслав": 1,
    "габби": 1,
    "габриель": 1,
    "габриэль": 1,
    "гавриил": 1,
    "гаврил": 1,
    "гаврила": 1,
    "гаврило": 1,
    "гай": 1,
    "гайдар": 1,
    "гайлс": 1,
    "галактион": 1,
    "гален": 1,
    "галий": 1,
    "гамильтон": 1,
    "гамлет": 1,
    "гантэр": 1,
    "гаральд": 1,
    "гарван": 1,
    "гарей": 1,
    "гарибальди": 1,
    "гарланд": 1,
    "гарнет": 1,
    "гарольд": 1,
    "гарри": 1,
    "гаррий": 1,
    "гарс": 1,
    "гарфилд": 1,
    "гас": 1,
    "гаспар": 1,
    "гваделупа": 1,
    "гвидон": 1,
    "гейб": 1,
    "гейл": 1,
    "гейр": 1,
    "гектор": 1,
    "гелеон": 1,
    "гелиан": 1,
    "гелий": 1,
    "ген": 1,
    "гений": 1,
    "геннадий": 1,
    "генри": 1,
    "генрих": 1,
    "геодар": 1,
    "георгий": 1,
    "геральд": 1,
    "герасим": 1,
    "герберт": 1,
    "герман": 1,
    "гермоген": 1,
    "герольд": 1,
    "геронт": 1,
    "геронтий": 1,
    "герт": 1,
    "гертруд": 1,
    "гидеон": 1,
    "гильберт": 1,
    "гисберт": 1,
    "гладвин": 1,
    "гланвилл": 1,
    "глеб": 1,
    "глендауэр": 1,
    "гленн": 1,
    "глэн": 1,
    "говард": 1,
    "годвин": 1,
    "годфри": 1,
    "голлагэр": 1,
    "голладжер": 1,
    "гомер": 1,
    "горазд": 1,
    "гораций": 1,
    "горд": 1,
    "гордей": 1,
    "горден": 1,
    "гордий": 1,
    "гордон": 1,
    "горимир": 1,
    "горислав": 1,
    "горн": 1,
    "граем": 1,
    "грай": 1,
    "гранвилл": 1,
    "гранд": 1,
    "гранит": 1,
    "грахэйм": 1,
    "грег": 1,
    "грей": 1,
    "гренвилл": 1,
    "григорий": 1,
    "гриир": 1,
    "грир": 1,
    "гриффин": 1,
    "гриффит": 1,
    "гровер": 1,
    "грэг": 1,
    "грэгори": 1,
    "грэди": 1,
    "грэм": 1,
    "гудвин": 1,
    "гудзон": 1,
    "гурий": 1,
    "густав": 1,
    "гэй": 1,
    "гэйбл": 1,
    "гэйг": 1,
    "гэйдж": 1,
    "гэйелорд": 1,
    "гэйл": 1,
    "гэйлон": 1,
    "гэйлорд": 1,
    "гэйр": 1,
    "гэлл": 1,
    "гэри": 1,
    "давей": 1,
    "дави": 1,
    "давид": 1,
    "давыд": 1,
    "дад": 1,
    "дадда": 1,
    "дадли": 1,
    "даймонд": 1,
    "дакей": 1,
    "дакота": 1,
    "дакс": 1,
    "далтон": 1,
    "дамайон": 1,
    "дамиан": 1,
    "дамир": 1,
    "дан": 1,
    "дана": 1,
    "дани": 1,
    "даниар": 1,
    "даниил": 1,
    "данил": 1,
    "данила": 1,
    "данило": 1,
    "даниэль": 1,
    "данки": 1,
    "данни": 1,
    "дар": 1,
    "дарби": 1,
    "дарвин": 1,
    "дарден": 1,
    "дарен": 1,
    "дариан": 1,
    "дарил": 1,
    "дарин": 1,
    "дарки": 1,
    "дарнелл": 1,
    "даррел": 1,
    "даррен": 1,
    "даррил": 1,
    "даррин": 1,
    "даррэль": 1,
    "дасти": 1,
    "дастин": 1,
    "дау": 1,
    "дафф": 1,
    "даффи": 1,
    "дашилл": 1,
    "дван": 1,
    "двэйн": 1,
    "деай": 1,
    "деван": 1,
    "девен": 1,
    "девереукс": 1,
    "девин": 1,
    "девон": 1,
    "дейв": 1,
    "дейл": 1,
    "дейрлл": 1,
    "дейрн": 1,
    "декабрий": 1,
    "деклан": 1,
    "декстер": 1,
    "делберт": 1,
    "делл": 1,
    "делмар": 1,
    "делрой": 1,
    "дементий": 1,
    "деметриус": 1,
    "демид": 1,
    "демократ": 1,
    "демон": 1,
    "демьян": 1,
    "ден": 1,
    "денвер": 1,
    "денеб": 1,
    "дензэль": 1,
    "дени": 1,
    "денил": 1,
    "денис": 1,
    "деннис": 1,
    "дентон": 1,
    "деон": 1,
    "деонн": 1,
    "деонт": 1,
    "дерби": 1,
    "дерек": 1,
    "дерик": 1,
    "дермот": 1,
    "дерок": 1,
    "деррен": 1,
    "дерри": 1,
    "деррил": 1,
    "дефорест": 1,
    "дефоррест": 1,
    "дешон": 1,
    "джадд": 1,
    "джадин": 1,
    "джай": 1,
    "джайлс": 1,
    "джак": 1,
    "джамар": 1,
    "джамей": 1,
    "джамисон": 1,
    "джарвис": 1,
    "джаред": 1,
    "джарод": 1,
    "джарред": 1,
    "джарретт": 1,
    "джаррод": 1,
    "джаспер": 1,
    "джасти": 1,
    "джастин": 1,
    "джеб": 1,
    "джед": 1,
    "джедидиа": 1,
    "джейдн": 1,
    "джейк": 1,
    "джейлн": 1,
    "джейми": 1,
    "джеймс": 1,
    "джейрт": 1,
    "джейсон": 1,
    "джекки": 1,
    "джекоб": 1,
    "джем": 1,
    "дженкин": 1,
    "джеп": 1,
    "джер": 1,
    "джералд": 1,
    "джеральд": 1,
    "джерард": 1,
    "джерваз": 1,
    "джервис": 1,
    "джереми": 1,
    "джери": 1,
    "джермэйн": 1,
    "джеролд": 1,
    "джером": 1,
    "джеррард": 1,
    "джерред": 1,
    "джерри": 1,
    "джеррод": 1,
    "джерролд": 1,
    "джес": 1,
    "джесси": 1,
    "джетро": 1,
    "джетт": 1,
    "джеф": 1,
    "джеффери": 1,
    "джефферсон": 1,
    "джеффрей": 1,
    "джеффри": 1,
    "джиб": 1,
    "джид": 1,
    "джиди": 1,
    "джил": 1,
    "джим": 1,
    "джими": 1,
    "джимми": 1,
    "джисберт": 1,
    "джиффард": 1,
    "джо": 1,
    "джоб": 1,
    "джоби": 1,
    "джоджо": 1,
    "джоди": 1,
    "джозеф": 1,
    "джой": 1,
    "джойс": 1,
    "джон": 1,
    "джоназан": 1,
    "джоназон": 1,
    "джонасон": 1,
    "джонатан": 1,
    "джоней": 1,
    "джони": 1,
    "джонни": 1,
    "джонти": 1,
    "джорги": 1,
    "джордан": 1,
    "джордж": 1,
    "джорди": 1,
    "джордон": 1,
    "джосс": 1,
    "джоул": 1,
    "джош": 1,
    "джошоа": 1,
    "джошуа": 1,
    "джулс": 1,
    "джульян": 1,
    "джустис": 1,
    "джьюд": 1,
    "джэй": 1,
    "джэйд": 1,
    "джэйда": 1,
    "джэйден": 1,
    "джэйдон": 1,
    "джэйкоб": 1,
    "джэйлен": 1,
    "джэйлин": 1,
    "джэйлон": 1,
    "джэймес": 1,
    "джэйсон": 1,
    "джэксон": 1,
    "джэмини": 1,
    "джэмми": 1,
    "джэн": 1,
    "ди": 1,
    "диакон": 1,
    "дигби": 1,
    "диггори": 1,
    "дигори": 1,
    "дидим": 1,
    "дизон": 1,
    "дик": 1,
    "дики": 1,
    "дикки": 1,
    "дил": 1,
    "дилан": 1,
    "дилберт": 1,
    "димер": 1,
    "димитрий": 1,
    "дин": 1,
    "диндр": 1,
    "дионис": 1,
    "дионисий": 1,
    "дирк": 1,
    "дмитрий": 1,
    "доб": 1,
    "добрыня": 1,
    "додж": 1,
    "дольф": 1,
    "дом": 1,
    "доменик": 1,
    "доминик": 1,
    "дон": 1,
    "дональд": 1,
    "дональт": 1,
    "донат": 1,
    "донни": 1,
    "донован": 1,
    "дор": 1,
    "дориан": 1,
    "дорофей": 1,
    "доусон": 1,
    "драйк": 1,
    "древ": 1,
    "дрейвн": 1,
    "дуайт": 1,
    "дуан": 1,
    "дуг": 1,
    "дуги": 1,
    "дуглас": 1,
    "дункан": 1,
    "дунстан": 1,
    "дью": 1,
    "дьюей": 1,
    "дьюэйн": 1,
    "дэвид": 1,
    "дэвис": 1,
    "дэй": 1,
    "дэйви": 1,
    "дэйн": 1,
    "дэйтон": 1,
    "дэн": 1,
    "дэни": 1,
    "дэниел": 1,
    "дэнни": 1,
    "дэррик": 1,
    "дэшон": 1,
    "дюк": 1,
    "евгений": 1,
    "евграф": 1,
    "евдоким": 1,
    "евлампий": 1,
    "евлогий": 1,
    "евсей": 1,
    "евстафий": 1,
    "егор": 1,
    "елеазар": 1,
    "елизар": 1,
    "елисей": 1,
    "емельян": 1,
    "епифан": 1,
    "еремей": 1,
    "ермак": 1,
    "ермил": 1,
    "ермолай": 1,
    "ерофей": 1,
    "еруслан": 1,
    "ефим": 1,
    "ефрем": 1,
    "ждан": 1,
    "жерар": 1,
    "жозеф": 1,
    "жорес": 1,
    "жюль": 1,
    "завир": 1,
    "зак": 1,
    "закери": 1,
    "зандер": 1,
    "захар": 1,
    "захарий": 1,
    "зачариа": 1,
    "зачэри": 1,
    "зед": 1,
    "зедекиа": 1,
    "зек": 1,
    "зигмунд": 1,
    "зигфрид": 1,
    "зиновий": 1,
    "зорий": 1,
    "зосим": 1,
    "зосима": 1,
    "зот": 1,
    "зубин": 1,
    "зэофилус": 1,
    "иб": 1,
    "ибрагим": 1,
    "иван": 1,
    "игнат": 1,
    "игнатий": 1,
    "игнатиус": 1,
    "игорь": 1,
    "ид": 1,
    "иероним": 1,
    "иззи": 1,
    "изидор": 1,
    "измаил": 1,
    "измайло": 1,
    "изяслав": 1,
    "ий": 1,
    "икар": 1,
    "илар": 1,
    "иларий": 1,
    "иларион": 1,
    "илий": 1,
    "илиодор": 1,
    "илларион": 1,
    "илья": 1,
    "имон": 1,
    "инглеберт": 1,
    "инграм": 1,
    "инди": 1,
    "индиана": 1,
    "индиго": 1,
    "инесент": 1,
    "иниго": 1,
    "иннокентий": 1,
    "иоанн": 1,
    "иорик": 1,
    "иосиф": 1,
    "ипат": 1,
    "ипатий": 1,
    "ипполит": 1,
    "ираклий": 1,
    "ирвайн": 1,
    "ирвин": 1,
    "ирвинг": 1,
    "ириней": 1,
    "ириний": 1,
    "ирл": 1,
    "ирм": 1,
    "ирнест": 1,
    "исай": 1,
    "исайя": 1,
    "исак": 1,
    "исакий": 1,
    "исей": 1,
    "исидор": 1,
    "иссак": 1,
    "исси": 1,
    "истер": 1,
    "июлий": 1,
    "йорк": 1,
    "ка": 1,
    "кадмус": 1,
    "казимир": 1,
    "каин": 1,
    "каир": 1,
    "кайд": 1,
    "кайл": 1,
    "кал": 1,
    "калин": 1,
    "калина": 1,
    "каллен": 1,
    "кам": 1,
    "камден": 1,
    "камиль": 1,
    "камрон": 1,
    "капитон": 1,
    "карбрей": 1,
    "карбри": 1,
    "карвер": 1,
    "карей": 1,
    "карен": 1,
    "карл": 1,
    "карлайл": 1,
    "карлейл": 1,
    "карлин": 1,
    "карлтон": 1,
    "карм": 1,
    "кармий": 1,
    "карп": 1,
    "каррол": 1,
    "картер": 1,
    "касиди": 1,
    "каспар": 1,
    "каспер": 1,
    "кассиди": 1,
    "касьян": 1,
    "квентин": 1,
    "квинтин": 1,
    "кеван": 1,
    "кевин": 1,
    "кей": 1,
    "кейденс": 1,
    "кейдн": 1,
    "кейлб": 1,
    "кеймрон": 1,
    "кейси": 1,
    "келвин": 1,
    "келкей": 1,
    "келл": 1,
    "келли": 1,
    "келсей": 1,
    "кемп": 1,
    "кен": 1,
    "кендал": 1,
    "кендол": 1,
    "кендрик": 1,
    "кенелм": 1,
    "кензи": 1,
    "кенит": 1,
    "кеннеди": 1,
    "кеннет": 1,
    "кенни": 1,
    "кеннит": 1,
    "кенрик": 1,
    "кент": 1,
    "кентиджерн": 1,
    "кентон": 1,
    "кермит": 1,
    "керней": 1,
    "керр": 1,
    "керри": 1,
    "керт": 1,
    "кертис": 1,
    "кешон": 1,
    "ки": 1,
    "киаран": 1,
    "килан": 1,
    "килер": 1,
    "килиан": 1,
    "киллиан": 1,
    "ким": 1,
    "кимбелайн": 1,
    "кимберли": 1,
    "кимбол": 1,
    "кимбэль": 1,
    "кин": 1,
    "кинан": 1,
    "кинастон": 1,
    "кинг": 1,
    "кингслей": 1,
    "кип": 1,
    "киприан": 1,
    "кир": 1,
    "киран": 1,
    "кирби": 1,
    "кирилл": 1,
    "кирк": 1,
    "кирон": 1,
    "кирус": 1,
    "кит": 1,
    "китон": 1,
    "киф": 1,
    "клавдий": 1,
    "клайв": 1,
    "клайд": 1,
    "кланкей": 1,
    "кланки": 1,
    "кларенс": 1,
    "кларк": 1,
    "клев": 1,
    "клей": 1,
    "клейтон": 1,
    "клем": 1,
    "клемент": 1,
    "клементий": 1,
    "клемми": 1,
    "клетис": 1,
    "клетус": 1,
    "кливленд": 1,
    "клим": 1,
    "климент": 1,
    "климентий": 1,
    "клинт": 1,
    "клинтон": 1,
    "клифтон": 1,
    "клифф": 1,
    "клиффорд": 1,
    "клод": 1,
    "клэйрк": 1,
    "клэр": 1,
    "кодей": 1,
    "коди": 1,
    "коертней": 1,
    "козьма": 1,
    "кола": 1,
    "коламбан": 1,
    "колберт": 1,
    "колби": 1,
    "колдер": 1,
    "колин": 1,
    "коллахан": 1,
    "коллин": 1,
    "коллум": 1,
    "колтен": 1,
    "колтон": 1,
    "колумбий": 1,
    "кольт": 1,
    "конан": 1,
    "конвей": 1,
    "кондрат": 1,
    "кондратий": 1,
    "конлей": 1,
    "коннелл": 1,
    "коннер": 1,
    "коннор": 1,
    "конон": 1,
    "конор": 1,
    "конрад": 1,
    "константин": 1,
    "конфуций": 1,
    "корбин": 1,
    "корделл": 1,
    "корей": 1,
    "кори": 1,
    "корней": 1,
    "корнелий": 1,
    "корнелиус": 1,
    "корнил": 1,
    "кортней": 1,
    "кортни": 1,
    "корэй": 1,
    "коти": 1,
    "коул": 1,
    "коулман": 1,
    "краснослав": 1,
    "крис": 1,
    "криспиан": 1,
    "криспин": 1,
    "кристи": 1,
    "кристиан": 1,
    "кристопэр": 1,
    "кристоф": 1,
    "кристофер": 1,
    "крофорд": 1,
    "крофтон": 1,
    "крэйг": 1,
    "ксавайор": 1,
    "ксавьер": 1,
    "ксан": 1,
    "ксенофонт": 1,
    "ксзавир": 1,
    "кузьма": 1,
    "куин": 1,
    "куинкей": 1,
    "куинси": 1,
    "куинтон": 1,
    "купер": 1,
    "куприян": 1,
    "курт": 1,
    "куртис": 1,
    "кэйд": 1,
    "кэйдн": 1,
    "кэйл": 1,
    "кэйлб": 1,
    "кэймрон": 1,
    "кэйн": 1,
    "кэйси": 1,
    "кэлвин": 1,
    "кэм": 1,
    "кэмп": 1,
    "кэмпбэл": 1,
    "кэри": 1,
    "кюри": 1,
    "лаверн": 1,
    "лавлл": 1,
    "лавр": 1,
    "лаврентий": 1,
    "лаз": 1,
    "лазарь": 1,
    "лайл": 1,
    "лайонел": 1,
    "лаки": 1,
    "ланни": 1,
    "ланфорд": 1,
    "ларион": 1,
    "ларк": 1,
    "ларкин": 1,
    "ларри": 1,
    "лаэрт": 1,
    "лев": 1,
    "леви": 1,
    "левкий": 1,
    "лейврн": 1,
    "лейн": 1,
    "лейтон": 1,
    "лекс": 1,
    "леланд": 1,
    "лель": 1,
    "лем": 1,
    "лемми": 1,
    "лемюэль": 1,
    "лен": 1,
    "ленар": 1,
    "ленард": 1,
    "лени": 1,
    "лениан": 1,
    "леннард": 1,
    "ленни": 1,
    "лео": 1,
    "леон": 1,
    "леонард": 1,
    "леонид": 1,
    "леонтий": 1,
    "леопольд": 1,
    "лермонт": 1,
    "лерой": 1,
    "лес": 1,
    "лесли": 1,
    "лестер": 1,
    "ли": 1,
    "либерт": 1,
    "ливадий": 1,
    "лии": 1,
    "лин": 1,
    "линдон": 1,
    "линдсей": 1,
    "линдси": 1,
    "линкольн": 1,
    "линн": 1,
    "линсей": 1,
    "линтон": 1,
    "линус": 1,
    "линфорд": 1,
    "лионель": 1,
    "лир": 1,
    "лирой": 1,
    "лисандр": 1,
    "литон": 1,
    "лихнис": 1,
    "ллойд": 1,
    "ллью": 1,
    "лльюелин": 1,
    "лльюеллин": 1,
    "ло": 1,
    "ловэль": 1,
    "лойд": 1,
    "лон": 1,
    "лондон": 1,
    "лонни": 1,
    "лонс": 1,
    "лор": 1,
    "лорен": 1,
    "лоренс": 1,
    "лори": 1,
    "лорин": 1,
    "лорис": 1,
    "лорни": 1,
    "лоррин": 1,
    "лосон": 1,
    "лоуэлл": 1,
    "лоэнгрин": 1,
    "лу": 1,
    "лудо": 1,
    "луи": 1,
    "лука": 1,
    "лукиан": 1,
    "лукьян": 1,
    "льюин": 1,
    "льюис": 1,
    "лэйк": 1,
    "лэйн": 1,
    "лэйтон": 1,
    "лэндон": 1,
    "лэнс": 1,
    "лэрри": 1,
    "любим": 1,
    "любомир": 1,
    "людвиг": 1,
    "людовик": 1,
    "люк": 1,
    "люкс": 1,
    "люксен": 1,
    "люсьен": 1,
    "лютер": 1,
    "люциан": 1,
    "маверик": 1,
    "маврикий": 1,
    "мадисон": 1,
    "маеслав": 1,
    "май": 1,
    "майк": 1,
    "майкл": 1,
    "майлз": 1,
    "майрон": 1,
    "майслав": 1,
    "макар": 1,
    "макарий": 1,
    "макей": 1,
    "макензи": 1,
    "маки": 1,
    "макинтош": 1,
    "маккензи": 1,
    "макс": 1,
    "максвелл": 1,
    "максим": 1,
    "максимилиан": 1,
    "максимиллиан": 1,
    "максимильян": 1,
    "малачи": 1,
    "малком": 1,
    "малоун": 1,
    "манлей": 1,
    "манни": 1,
    "манникс": 1,
    "мануил": 1,
    "мануйло": 1,
    "манфред": 1,
    "марат": 1,
    "марвин": 1,
    "мариан": 1,
    "марин": 1,
    "мариус": 1,
    "марк": 1,
    "марка": 1,
    "маркел": 1,
    "маркиан": 1,
    "марко": 1,
    "маркус": 1,
    "марлен": 1,
    "марлин": 1,
    "марлон": 1,
    "марлоу": 1,
    "мармадьюк": 1,
    "марри": 1,
    "марс": 1,
    "марсен": 1,
    "марти": 1,
    "мартиал": 1,
    "мартин": 1,
    "мартын": 1,
    "маршал": 1,
    "маршалл": 1,
    "марьян": 1,
    "масон": 1,
    "мастерман": 1,
    "матвей": 1,
    "матти": 1,
    "мед": 1,
    "мелвилль": 1,
    "мелвин": 1,
    "мельбурн": 1,
    "мерв": 1,
    "мервин": 1,
    "мерди": 1,
    "мердо": 1,
    "мердок": 1,
    "мередит": 1,
    "мерит": 1,
    "меркурий": 1,
    "мерл": 1,
    "мерлин": 1,
    "меррилл": 1,
    "мерритт": 1,
    "мертон": 1,
    "мерфи": 1,
    "мефодий": 1,
    "мечеслав": 1,
    "мечислав": 1,
    "мид": 1,
    "миид": 1,
    "мик": 1,
    "мика": 1,
    "мики": 1,
    "микки": 1,
    "милад": 1,
    "милан": 1,
    "милберн": 1,
    "милен": 1,
    "милий": 1,
    "миллард": 1,
    "мило": 1,
    "милонег": 1,
    "милослав": 1,
    "милтон": 1,
    "милфорд": 1,
    "мир": 1,
    "мирон": 1,
    "мирослав": 1,
    "митчелл": 1,
    "михаил": 1,
    "михайло": 1,
    "мич": 1,
    "мича": 1,
    "мичил": 1,
    "мо": 1,
    "модест": 1,
    "моз": 1,
    "моисей": 1,
    "молком": 1,
    "монолит": 1,
    "монро": 1,
    "монтагью": 1,
    "монтгомери": 1,
    "монте": 1,
    "монти": 1,
    "монтморенки": 1,
    "морган": 1,
    "морген": 1,
    "мордекэй": 1,
    "морис": 1,
    "морлей": 1,
    "моррис": 1,
    "морт": 1,
    "морти": 1,
    "мортимер": 1,
    "мортон": 1,
    "мосс": 1,
    "моэ": 1,
    "мстислав": 1,
    "мулава": 1,
    "мурат": 1,
    "мэйнард": 1,
    "мэйнерд": 1,
    "мэйор": 1,
    "мэйсон": 1,
    "мэйтланд": 1,
    "мэлори": 1,
    "мэль": 1,
    "мэриан": 1,
    "мэрион": 1,
    "мэт": 1,
    "мэтт": 1,
    "мэтти": 1,
    "мэтью": 1,
    "мюд": 1,
    "надир": 1,
    "назаниль": 1,
    "назар": 1,
    "назарий": 1,
    "назим": 1,
    "найджел": 1,
    "найлс": 1,
    "наль": 1,
    "нанди": 1,
    "нат": 1,
    "натан": 1,
    "наум": 1,
    "науэлл": 1,
    "наш": 1,
    "невада": 1,
    "неван": 1,
    "невил": 1,
    "невилл": 1,
    "нед": 1,
    "нейл": 1,
    "нейлл": 1,
    "нейт": 1,
    "нельсон": 1,
    "нео": 1,
    "неон": 1,
    "неонил": 1,
    "нестер": 1,
    "нестор": 1,
    "нивек": 1,
    "нивен": 1,
    "ник": 1,
    "никандр": 1,
    "никанор": 1,
    "никита": 1,
    "никифор": 1,
    "никк": 1,
    "никки": 1,
    "никодим": 1,
    "никола": 1,
    "николай": 1,
    "николас": 1,
    "никон": 1,
    "нил": 1,
    "нили": 1,
    "нимбус": 1,
    "нинел": 1,
    "нинель": 1,
    "нисон": 1,
    "нифонт": 1,
    "ноа": 1,
    "новомир": 1,
    "нодар": 1,
    "ной": 1,
    "нолан": 1,
    "нолл": 1,
    "норберт": 1,
    "норвуд": 1,
    "норд": 1,
    "норм": 1,
    "норман": 1,
    "норманд": 1,
    "норрис": 1,
    "нортон": 1,
    "ноубль": 1,
    "ноэль": 1,
    "ньют": 1,
    "ньютон": 1,
    "оберон": 1,
    "обин": 1,
    "обри": 1,
    "овидий": 1,
    "огастин": 1,
    "огден": 1,
    "огэст": 1,
    "оделл": 1,
    "одиссей": 1,
    "одлей": 1,
    "одран": 1,
    "оз": 1,
    "оззи": 1,
    "океан": 1,
    "оксар": 1,
    "октавиан": 1,
    "октябрин": 1,
    "октябрь": 1,
    "олби": 1,
    "олбэйн": 1,
    "олдвен": 1,
    "олдвин": 1,
    "олден": 1,
    "олдин": 1,
    "олдис": 1,
    "олдон": 1,
    "олдос": 1,
    "олдред": 1,
    "олдус": 1,
    "олдфорд": 1,
    "олег": 1,
    "олей": 1,
    "оли": 1,
    "оливер": 1,
    "олимпий": 1,
    "олластер": 1,
    "олластир": 1,
    "оллгар": 1,
    "оллджер": 1,
    "олли": 1,
    "оллин": 1,
    "оллисдэйр": 1,
    "оллистер": 1,
    "оллистэйр": 1,
    "оллон": 1,
    "оллэйстар": 1,
    "ольгерд": 1,
    "омар": 1,
    "омега": 1,
    "онисим": 1,
    "ора": 1,
    "оран": 1,
    "орвал": 1,
    "орвилл": 1,
    "орест": 1,
    "ориан": 1,
    "ормерод": 1,
    "оррелл": 1,
    "оррин": 1,
    "орсон": 1,
    "осберт": 1,
    "осбоерн": 1,
    "осборн": 1,
    "освальд": 1,
    "осень": 1,
    "осип": 1,
    "оскар": 1,
    "остап": 1,
    "остен": 1,
    "остин": 1,
    "остромир": 1,
    "отис": 1,
    "оттис": 1,
    "отто": 1,
    "оттон": 1,
    "оуин": 1,
    "оуэн": 1,
    "ошин": 1,
    "павел": 1,
    "пайс": 1,
    "палладий": 1,
    "палмер": 1,
    "панкрас": 1,
    "пантелей": 1,
    "пантелеймон": 1,
    "панфил": 1,
    "парамон": 1,
    "паркер": 1,
    "паррис": 1,
    "партизан": 1,
    "пат": 1,
    "патрик": 1,
    "патси": 1,
    "пахом": 1,
    "пеитон": 1,
    "пепин": 1,
    "пересвет": 1,
    "перри": 1,
    "перс": 1,
    "перси": 1,
    "персиваль": 1,
    "петеркин": 1,
    "пимен": 1,
    "пип": 1,
    "пипер": 1,
    "пирр": 1,
    "пирс": 1,
    "пит": 1,
    "питер": 1,
    "платон": 1,
    "пол": 1,
    "поли": 1,
    "поликарп": 1,
    "помпей": 1,
    "портер": 1,
    "порфирий": 1,
    "потап": 1,
    "престон": 1,
    "приам": 1,
    "принц": 1,
    "пров": 1,
    "прозор": 1,
    "прокопий": 1,
    "прокофий": 1,
    "проспер": 1,
    "протас": 1,
    "прохор": 1,
    "пэйс": 1,
    "пэйси": 1,
    "пэйтон": 1,
    "пётр": 1,
    "петр": 1,
    "равель": 1,
    "равен": 1,
    "равиль": 1,
    "радамес": 1,
    "радий": 1,
    "радим": 1,
    "радислав": 1,
    "радомир": 1,
    "раз": 1,
    "раймонд": 1,
    "раймунд": 1,
    "райордан": 1,
    "райт": 1,
    "ралф": 1,
    "ралфи": 1,
    "ральф": 1,
    "ранделл": 1,
    "ранди": 1,
    "рандолф": 1,
    "рандольф": 1,
    "расс": 1,
    "рассел": 1,
    "рассэль": 1,
    "расти": 1,
    "растус": 1,
    "ратмир": 1,
    "рауль": 1,
    "рафаил": 1,
    "рафаэль": 1,
    "рашид": 1,
    "раян": 1,
    "реарден": 1,
    "ревмир": 1,
    "реган": 1,
    "редд": 1,
    "редж": 1,
    "реджи": 1,
    "реджинальд": 1,
    "редклиф": 1,
    "редклифф": 1,
    "редлей": 1,
    "редманд": 1,
    "редмонд": 1,
    "реид": 1,
    "рей": 1,
    "рейли": 1,
    "рейнард": 1,
    "рейнольд": 1,
    "рекс": 1,
    "рем": 1,
    "ренальд": 1,
    "ренат": 1,
    "риган": 1,
    "ригби": 1,
    "рид": 1,
    "ридлей": 1,
    "риель": 1,
    "рик": 1,
    "рикей": 1,
    "рики": 1,
    "рилан": 1,
    "рилей": 1,
    "рили": 1,
    "ринат": 1,
    "рио": 1,
    "риплей": 1,
    "рис": 1,
    "рихард": 1,
    "рич": 1,
    "ричард": 1,
    "ричи": 1,
    "роальд": 1,
    "роб": 1,
    "робби": 1,
    "роберт": 1,
    "робеспьер": 1,
    "роби": 1,
    "робин": 1,
    "робинзон": 1,
    "рован": 1,
    "род": 1,
    "роддж": 1,
    "родджер": 1,
    "родди": 1,
    "родерик": 1,
    "роджер": 1,
    "родион": 1,
    "родни": 1,
    "родолф": 1,
    "рождеро": 1,
    "рой": 1,
    "ройл": 1,
    "ройс": 1,
    "ройстон": 1,
    "роки": 1,
    "ролан": 1,
    "роланд": 1,
    "роли": 1,
    "ролланд": 1,
    "ролли": 1,
    "роман": 1,
    "ромен": 1,
    "ромуальд": 1,
    "рон": 1,
    "рональд": 1,
    "ронни": 1,
    "рори": 1,
    "роско": 1,
    "росс": 1,
    "ростислав": 1,
    "роуланд": 1,
    "роулей": 1,
    "роял": 1,
    "рубен": 1,
    "рубин": 1,
    "руди": 1,
    "рудольф": 1,
    "рудьярд": 1,
    "рунар": 1,
    "руслан": 1,
    "руссо": 1,
    "рустам": 1,
    "рустем": 1,
    "рхетт": 1,
    "рьюб": 1,
    "рэд": 1,
    "рэй": 1,
    "рэйнард": 1,
    "рэйнер": 1,
    "рэйф": 1,
    "рэм": 1,
    "рэндал": 1,
    "рэндалл": 1,
    "рюрик": 1,
    "сава": 1,
    "савва": 1,
    "савелий": 1,
    "савьер": 1,
    "сайг": 1,
    "саймон": 1,
    "салал": 1,
    "салливан": 1,
    "самми": 1,
    "самойло": 1,
    "самсон": 1,
    "самуил": 1,
    "сандфорд": 1,
    "санни": 1,
    "санфорд": 1,
    "свет": 1,
    "светлан": 1,
    "светозар": 1,
    "светослав": 1,
    "свизин": 1,
    "свизун": 1,
    "свиней": 1,
    "святогор": 1,
    "святополк": 1,
    "святослав": 1,
    "себастьян": 1,
    "севард": 1,
    "севастиан": 1,
    "севастьян": 1,
    "север": 1,
    "севериан": 1,
    "северин": 1,
    "северьян": 1,
    "северян": 1,
    "седрик": 1,
    "сеймур": 1,
    "селби": 1,
    "семён": 1,
    "септембер": 1,
    "серапион": 1,
    "серафим": 1,
    "сергей": 1,
    "сесил": 1,
    "сет": 1,
    "сефтон": 1,
    "сивард": 1,
    "сигизмунд": 1,
    "сигманд": 1,
    "сид": 1,
    "сидней": 1,
    "сидор": 1,
    "сила": 1,
    "силас": 1,
    "силвестр": 1,
    "сильвер": 1,
    "сильвест": 1,
    "сильвестр": 1,
    "симеон": 1,
    "симон": 1,
    "синклэйр": 1,
    "сирил": 1,
    "сисар": 1,
    "скай": 1,
    "скилар": 1,
    "скилер": 1,
    "скот": 1,
    "скотти": 1,
    "скуилер": 1,
    "слава": 1,
    "слай": 1,
    "слэйд": 1,
    "совет": 1,
    "сократ": 1,
    "соломон": 1,
    "сони": 1,
    "сонни": 1,
    "софокл": 1,
    "софон": 1,
    "спайк": 1,
    "спарроу": 1,
    "спартак": 1,
    "спенсер": 1,
    "спиридон": 1,
    "спиро": 1,
    "стакей": 1,
    "сталий": 1,
    "сталь": 1,
    "станислав": 1,
    "стаффорд": 1,
    "степан": 1,
    "стерлинг": 1,
    "стеф": 1,
    "стефан": 1,
    "сти": 1,
    "стив": 1,
    "стивен": 1,
    "стиви": 1,
    "стиу": 1,
    "сторм": 1,
    "стратон": 1,
    "сту": 1,
    "стэки": 1,
    "стэн": 1,
    "стэнли": 1,
    "стэнфорд": 1,
    "стюарт": 1,
    "сурен": 1,
    "сэм": 1,
    "сэмюэль": 1,
    "сэнди": 1,
    "тад": 1,
    "таддеус": 1,
    "таир": 1,
    "тай": 1,
    "такер": 1,
    "тал": 1,
    "талбот": 1,
    "таннер": 1,
    "тарас": 1,
    "таскилл": 1,
    "таффи": 1,
    "тед": 1,
    "тейгу": 1,
    "тейдж": 1,
    "теймураз": 1,
    "тейрк": 1,
    "текс": 1,
    "тельнан": 1,
    "тенгиз": 1,
    "тенней": 1,
    "теннизон": 1,
    "тео": 1,
    "теобальд": 1,
    "теодор": 1,
    "теранс": 1,
    "теренс": 1,
    "терентий": 1,
    "терло": 1,
    "терранс": 1,
    "террелл": 1,
    "терренс": 1,
    "терстон": 1,
    "ти": 1,
    "тиарнак": 1,
    "тиарнан": 1,
    "тибалт": 1,
    "тибби": 1,
    "тигран": 1,
    "тигу": 1,
    "тизон": 1,
    "тилар": 1,
    "тилер": 1,
    "тилор": 1,
    "тим": 1,
    "тимми": 1,
    "тимоти": 1,
    "тимофей": 1,
    "тимур": 1,
    "тирелл": 1,
    "тирнан": 1,
    "тирней": 1,
    "тирон": 1,
    "тироун": 1,
    "тиррелл": 1,
    "тит": 1,
    "тихомир": 1,
    "тихон": 1,
    "тоал": 1,
    "тоби": 1,
    "тобиас": 1,
    "тобин": 1,
    "товий": 1,
    "тод": 1,
    "тодд": 1,
    "толли": 1,
    "том": 1,
    "томас": 1,
    "томми": 1,
    "тон": 1,
    "тони": 1,
    "топэр": 1,
    "торез": 1,
    "торий": 1,
    "торлей": 1,
    "торнтон": 1,
    "травис": 1,
    "тракей": 1,
    "трантер": 1,
    "траффорд": 1,
    "траэрн": 1,
    "трев": 1,
    "тревельян": 1,
    "тревор": 1,
    "трейврс": 1,
    "трейс": 1,
    "трейси": 1,
    "трент": 1,
    "трентон": 1,
    "тристан": 1,
    "тристрам": 1,
    "трифон": 1,
    "трой": 1,
    "трофим": 1,
    "труман": 1,
    "туллий": 1,
    "тусон": 1,
    "тэдди": 1,
    "тэди": 1,
    "тэйлер": 1,
    "тэйлор": 1,
    "тэйн": 1,
    "тэйт": 1,
    "тэл": 1,
    "тэмпл": 1,
    "тэрри": 1,
    "уилбер": 1,
    "уиллард": 1,
    "уиллис": 1,
    "уилфред": 1,
    "уилфрид": 1,
    "уильям": 1,
    "уинстон": 1,
    "уинфред": 1,
    "уисдом": 1,
    "улайксс": 1,
    "улиссес": 1,
    "ульяна": 1,
    "уолли": 1,
    "уоллис": 1,
    "уолт": 1,
    "уолтер": 1,
    "уолтон": 1,
    "уорик": 1,
    "уорнер": 1,
    "уоррен": 1,
    "уот": 1,
    "уоткин": 1,
    "уптон": 1,
    "урбан": 1,
    "уриах": 1,
    "устин": 1,
    "уэйн": 1,
    "уэсли": 1,
    "фабиан": 1,
    "фаддей": 1,
    "фадей": 1,
    "фалк": 1,
    "фарид": 1,
    "фарлей": 1,
    "фарон": 1,
    "фарран": 1,
    "февралин": 1,
    "федор": 1,
    "федосий": 1,
    "фелан": 1,
    "фелиз": 1,
    "феликс": 1,
    "фелим": 1,
    "фелис": 1,
    "фентон": 1,
    "феодосий": 1,
    "феофан": 1,
    "ферги": 1,
    "фергус": 1,
    "ферд": 1,
    "ферди": 1,
    "фердинанд": 1,
    "фернан": 1,
    "фернанд": 1,
    "фестер": 1,
    "фестус": 1,
    "фидель": 1,
    "фидо": 1,
    "фил": 1,
    "филайп": 1,
    "филандр": 1,
    "филарет": 1,
    "филат": 1,
    "филберт": 1,
    "филимон": 1,
    "филип": 1,
    "филипп": 1,
    "фило": 1,
    "финикс": 1,
    "финис": 1,
    "флегонт": 1,
    "флемминг": 1,
    "флечер": 1,
    "флинн": 1,
    "флинт": 1,
    "флойд": 1,
    "флорентий": 1,
    "флоренц": 1,
    "флорин": 1,
    "флорри": 1,
    "флурри": 1,
    "фок": 1,
    "фокс": 1,
    "фома": 1,
    "фонз": 1,
    "фонзи": 1,
    "форбес": 1,
    "форд": 1,
    "форест": 1,
    "форрест": 1,
    "фостер": 1,
    "фот": 1,
    "фотий": 1,
    "фоук": 1,
    "фразир": 1,
    "франклин": 1,
    "франц": 1,
    "фред": 1,
    "фредди": 1,
    "фредерик": 1,
    "фредрик": 1,
    "фрейзер": 1,
    "фрейзр": 1,
    "фридрих": 1,
    "фримэн": 1,
    "фритс": 1,
    "фродо": 1,
    "фрол": 1,
    "фрэнк": 1,
    "фрэнки": 1,
    "фрэнклин": 1,
    "фрэнс": 1,
    "фрэнсис": 1,
    "фёдор": 1,
    "хавелок": 1,
    "хадвин": 1,
    "хадлей": 1,
    "хал": 1,
    "хам": 1,
    "хамиш": 1,
    "хамлет": 1,
    "хаммонд": 1,
    "ханк": 1,
    "ханлей": 1,
    "хантер": 1,
    "харв": 1,
    "харви": 1,
    "харди": 1,
    "хардинг": 1,
    "харитон": 1,
    "харкоерт": 1,
    "харлан": 1,
    "харланд": 1,
    "харлей": 1,
    "харлин": 1,
    "хармон": 1,
    "харпер": 1,
    "харрис": 1,
    "харрисон": 1,
    "хартлей": 1,
    "хауелл": 1,
    "хедлей": 1,
    "хек": 1,
    "хендерсон": 1,
    "хендрик": 1,
    "хенрай": 1,
    "хенри": 1,
    "херб": 1,
    "херби": 1,
    "хервей": 1,
    "херлей": 1,
    "хиацинт": 1,
    "хилари": 1,
    "хиллэри": 1,
    "хирам": 1,
    "хис": 1,
    "хитклифф": 1,
    "хию": 1,
    "хоард": 1,
    "хоб": 1,
    "ходдж": 1,
    "хойт": 1,
    "холден": 1,
    "холл": 1,
    "холлис": 1,
    "хомер": 1,
    "хопкин": 1,
    "хорас": 1,
    "хоратайо": 1,
    "хоуи": 1,
    "храбр": 1,
    "христоф": 1,
    "христофор": 1,
    "худд": 1,
    "хуей": 1,
    "хует": 1,
    "хукк": 1,
    "хукслей": 1,
    "хумберт": 1,
    "хунтлей": 1,
    "хуффи": 1,
    "хью": 1,
    "хьюберт": 1,
    "хьюго": 1,
    "хьюи": 1,
    "хэвен": 1,
    "хэдлей": 1,
    "хэйвуд": 1,
    "хэйден": 1,
    "хэйл": 1,
    "хэмфри": 1,
    "хэппи": 1,
    "хюи": 1,
    "цезарь": 1,
    "чад": 1,
    "чадвик": 1,
    "чаз": 1,
    "чак": 1,
    "чакки": 1,
    "чарлз": 1,
    "чарли": 1,
    "чарлтон": 1,
    "чарльз": 1,
    "час": 1,
    "чейз": 1,
    "чендлер": 1,
    "ченс": 1,
    "черокез": 1,
    "чеслав": 1,
    "честер": 1,
    "чеьянн": 1,
    "чип": 1,
    "чонки": 1,
    "чонси": 1,
    "ша": 1,
    "шад": 1,
    "шаи": 1,
    "шайенн": 1,
    "шакуилл": 1,
    "шамиль": 1,
    "шамус": 1,
    "шан": 1,
    "шаннен": 1,
    "шаннон": 1,
    "шау": 1,
    "шеврон": 1,
    "шелби": 1,
    "шелдон": 1,
    "шеллей": 1,
    "шелтон": 1,
    "шем": 1,
    "шервуд": 1,
    "шеридан": 1,
    "шерлок": 1,
    "шерман": 1,
    "ши": 1,
    "шилох": 1,
    "шимус": 1,
    "шмидт": 1,
    "шолто": 1,
    "шон": 1,
    "шэй": 1,
    "шэйн": 1,
    "эбби": 1,
    "эбен": 1,
    "эбенезер": 1,
    "эвальд": 1,
    "эван": 1,
    "эвелин": 1,
    "эверард": 1,
    "эверетт": 1,
    "эверитт": 1,
    "эвот": 1,
    "эгберт": 1,
    "эд": 1,
    "эдан": 1,
    "эдвард": 1,
    "эдвин": 1,
    "эдгар": 1,
    "эдди": 1,
    "эдип": 1,
    "эдисон": 1,
    "эдмонд": 1,
    "эдмунд": 1,
    "эдон": 1,
    "эдуард": 1,
    "эдун": 1,
    "эзраа": 1,
    "эзэлстан": 1,
    "эзэлуолф": 1,
    "эйб": 1,
    "эйби": 1,
    "эйвери": 1,
    "эйден": 1,
    "эйлберт": 1,
    "эйлвард": 1,
    "эймерей": 1,
    "эймери": 1,
    "эйнар": 1,
    "эйнслей": 1,
    "эйнсли": 1,
    "эйс": 1,
    "элайотт": 1,
    "элбан": 1,
    "элвин": 1,
    "элвис": 1,
    "элвуд": 1,
    "элгар": 1,
    "элдвен": 1,
    "элдвин": 1,
    "элден": 1,
    "элджер": 1,
    "элдин": 1,
    "элдис": 1,
    "элдон": 1,
    "элдред": 1,
    "элдус": 1,
    "электрон": 1,
    "эли": 1,
    "элиас": 1,
    "элиджа": 1,
    "элиот": 1,
    "элла": 1,
    "эллгар": 1,
    "эллджер": 1,
    "эллери": 1,
    "эллиот": 1,
    "эллис": 1,
    "элмер": 1,
    "элрик": 1,
    "элрой": 1,
    "элсдон": 1,
    "эль": 1,
    "эльберт": 1,
    "эльбрус": 1,
    "эльдар": 1,
    "эльмар": 1,
    "эльмир": 1,
    "эльтон": 1,
    "эмерсон": 1,
    "эмилиан": 1,
    "эмилий": 1,
    "эмиль": 1,
    "эммануель": 1,
    "эммануил": 1,
    "эммерсон": 1,
    "эммет": 1,
    "эмметт": 1,
    "эмори": 1,
    "эмэри": 1,
    "энвер": 1,
    "энгель": 1,
    "энджелберт": 1,
    "энди": 1,
    "эндрю": 1,
    "энергий": 1,
    "энтони": 1,
    "эразм": 1,
    "эраст": 1,
    "эрван": 1,
    "эрвин": 1,
    "эрг": 1,
    "эрек": 1,
    "эрий": 1,
    "эрик": 1,
    "эрих": 1,
    "эрл": 1,
    "эрлен": 1,
    "эрн": 1,
    "эрнест": 1,
    "эрни": 1,
    "эрнст": 1,
    "эрон": 1,
    "эррол": 1,
    "эрролл": 1,
    "этан": 1,
    "этелберт": 1,
    "этелред": 1,
    "этелрик": 1,
    "этелхард": 1,
    "эшли": 1,
    "эюзби": 1,
    "ювеналий": 1,
    "юджин": 1,
    "юлиан": 1,
    "юлий": 1,
    "юлиус": 1,
    "юм": 1,
    "юниор": 1,
    "юпитер": 1,
    "юрий": 1,
    "юстас": 1,
    "юстин": 1,
    "яков": 1,
    "ян": 1,
    "янкей": 1,
    "янки": 1,
    "януарий": 1,
    "ярвуд": 1,
    "яромир": 1,
    "ярополк": 1,
    "ярослав": 1
  }, exports.ruBindingWords = [ "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "пота", "потому", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "тож", "только", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы", "а-ля", "без", "безо", "благодаря", "близ", "в", "ввиду", "вглубь", "вдоль", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "во", "возле", "вокруг", "вопреки", "впереди", "вразрез", "вроде", "вслед", "вследствие", "для", "до", "за", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "к", "ко", "кроме", "кругом", "меж", "между", "мимо", "на", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду", "насупротив", "насчёт", "не", "ниже", "о", "об", "обо", "обок", "около", "окромя", "округ", "от", "относительно", "ото", "перед", "передо", "по", "по-за", "по-над", "поверх", "под", "подле", "подо", "подобно", "позади", "помимо", "поперёк", "порядка", "посередине", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "применительно", "про", "против", "путём", "ради", "с", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "со", "согласно", "спустя", "среди", "средь", "сродни", "судя", "супротив", "у", "через", "чрез", "иже", "какой-либо", "какой-то", "кое-кто", "кой", "кто", "кто-либо", "многий", "мя", "насколько", "немногий", "нещечко", "никой", "ничегошеньки", "се", "сё", "такой-то", "тот-то", "чё", "чево", "чей-либо", "чей-нибудь", "чей-то", "шо", "эта", "кем", "ком", "кому", "нахуя", "чей", "чему", "вам", "вами", "вас", "вы", "Вы", "ее", "её", "его", "ей", "ему", "ею", "им", "ими", "их", "меня", "мне", "мной", "мною", "мы", "нём", "нем", "нам", "нами", "неё", "него", "ней", "нему", "нею", "ним", "ними", "них", "он", "она", "оне", "они", "оно", "тебе", "тебя", "тобой", "тобою", "ты", "я", "иной", "кое-какой", "кое-чей", "кое-что", "кой-какой", "кой-кто", "кто-нибудь", "кто-то", "куда-нибудь", "некто", "нечто", "что-либо", "что-нибудь", "что-то", "весь", "всякий", "любой", "сам", "самый", "таков", "этакий", "другой", "некем", "некому", "нечего", "нечем", "нечему", "никакой", "никто", "ничего", "ничей", "ничем", "ничему", "ничто", "ваш", "ихний", "моё", "мой", "моя", "наш", "свой", "твой", "оный", "сей", "сие", "сии", "сия", "та", "такой", "тот", "ту", "эдакий", "эти", "это", "этот", "ась", "аюшки", "таки", "а", "авось-либо", "ага", "аминь", "б", "бишь", "буквально", "бы", "было", "вишь", "вон", "вот", "вот-вот", "вряд", "всего", "давай", "де", "действительно", "дескать", "добро", "довольно", "ещё", "исключительно", "ить", "ишь", "ка", "кажется", "конечно", "ладно", "лих", "лучше", "мол", "навряд", "наоборот", "небось", "нет", "неужели", "нехай", "никак", "ну", "ну-с", "по-видимому", "пожалуй", "пожалуйста", "полно", "положительно", "предовольно", "простите", "просто-напросто", "пускай", "разумеется", "сём-ка", "сем", "скорее", "спасибо", "так", "то-то", "тоже", "уж", "уже", "ужели", "ужли", "фон", "хорошо", "эдак", "эк", "этак" ];
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.words = {}, exports = window.lastName.plugins.ru.words) : exports = module.exports, function(exports) {
  return exports.adverbs = [ "абсолютно", "адски", "азартно", "активно", "аспидно", "баснословно", "бдительно", "безапелляционно", "безбожно", "безвозвратно", "безгранично", "безжалостно", "беззаветно", "беззастенчиво", "безмерно", "безмятежно", "безнадежно", "безоговорочно", "безраздельно", "безропотно", "безудержно", "безукоризненно", "безумно", "безупречно", "безусловно", "безустанно", "безутешно", "бескомпромиссно", "бесконечно", "беспардонно", "бесповоротно", "беспощадно", "беспредельно", "беспрекословно", "бесследно", "бессовестно", "бесстыдно", "бесчеловечно", "бешено", "бурно", "вдребезги", "вконец", "вовсю", "всемерно", "всесторонне", "всецело", "всячески", "высоко", "глубоко", "горько", "горячо", "грубо", "густо", "диаметрально", "дико", "досконально", "досыта", "дотошно", "дьявольски", "жарко", "жгуче", "железно", "жестко", "жестоко", "живо", "жизненно", "жутко", "запоем", "запредельно", "зверски", "здорово", "злостно", "идеально", "излишне", "изрядно", "изумительно", "исключительно", "исступленно", "истово", "истошно", "исчерпывающе", "кардинально", "катастрофически", "категорически", "клятвенно", "колоссально", "крайне", "крепко", "кристально", "кровно", "крупно", "круто", "люто", "максимально", "мертвецки", "мучительно", "навзрыд", "нагло", "наглухо", "наглядно", "наголову", "надежно", "надрывно", "назубок", "намертво", "наотрез", "напрочь", "нарочито", "насквозь", "настоятельно", "насущно", "начисто", "небывало", "невероятно", "невиданно", "невообразимо", "невыносимо", "невыразимо", "недопустимо", "неизмеримо", "неимоверно", "неистово", "немилосердно", "немыслимо", "необыкновенно", "необычайно", "неописуемо", "неопровержимо", "непомерно", "непоправимо", "непостижимо", "непримиримо", "непробудно", "непроходимо", "неразрывно", "несказанно", "неслыханно", "несметно", "несравненно", "нестерпимо", "неудержимо", "неузнаваемо", "неуклонно", "неукоснительно", "неустанно", "неусыпно", "неутешно", "неутомимо", "нещадно", "оглушительно", "ожесточенно", "ослепительно", "основательно", "остро", "откровенно", "открыто", "отлично", "отменно", "отчаянно", "очень", "панически", "патологически", "пламенно", "плотно", "по-настоящему", "по-собачьи", "подлинно", "подчеркнуто", "позарез", "поистине", "полностью", "поразительно", "порядком", "порядочно", "потрясающе", "предельно", "прекрасно", "преступно", "прилично", "примитивно", "принципиально", "приторно", "пронзительно", "радикально", "разительно", "редкостно", "резко", "рекордно", "свято", "серьезно", "сильно", "слепо", "смертельно", "совершенно", "совсем", "страстно", "страшно", "строго", "строго-настрого", "существенно", "твердо", "тяжело", "тяжко", "убийственно", "удивительно", "ужасающе", "ужасно", "фанатически", "фанатично", "фантастически", "феноменально", "хорошенько", "хорошо", "чертовски", "чрезвычайно", "чрезмерно", "чудовищно", "широко", "шумно", "щедро", "ярко", "яростно" ], exports.unions = [ "а", "а именно", "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "все-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как бы", "как то", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "после того как", "пота", "потому", "потому как", "потому что", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "то есть", "тож", "только", "только что", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы" ], exports.prepositionAll = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо", "включая", "невзирая на", "несмотря на", "по", "по-за", "про", "с", "сквозь", "со", "спустя", "через", "чрез", "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по", "при", "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "среди", "средь", "супротив", "у", "в связи с", "в соответствии с", "вслед за", "лицом к лицу с", "над", "надо", "наряду с", "перед", "передо", "по сравнению с", "по-над", "пред", "предо", "рядом с", "следом за" ], exports.prepositionSimple = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionAcusative = [ "в", "включая", "во", "за", "на", "не в", "не за", "невзирая на", "несмотря на", "о", "об", "обо", "по", "по-за", "под", "подо", "про", "с", "сквозь", "со", "спустя", "через", "чрез" ], exports.prepositionDative = [ "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по" ], exports.prepositionPrepositional = [ "в", "во", "на", "не в", "о", "об", "обо", "по", "при" ], exports.prepositionGenetive = [ "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "меж", "между", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "со", "среди", "средь", "супротив", "у" ], exports.prepositionInstrumental = [ "в связи с", "в соответствии с", "вслед за", "за", "лицом к лицу с", "меж", "между", "над", "надо", "наряду с", "не за", "перед", "передо", "по сравнению с", "по-над", "под", "подо", "пред", "предо", "рядом с", "с", "следом за", "со" ], exports.prepositionWithSingleCase = [ "без", "без ведома", "безо", "благодаря", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в связи с", "в силу", "в соответствии с", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "вдоль по", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "вопреки", "впереди", "впредь до", "вроде", "вслед", "вслед за", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "к", "ко", "кроме", "кругом", "лицом к", "лицом к лицу с", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду с", "насупротив", "насчёт", "начиная с", "не без", "не считая", "невзирая на", "недалеко от", "независимо от", "несмотря на", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "перед", "передо", "по линии", "по мере", "по направлению к", "по отношению к", "по поводу", "по причине", "по случаю", "по сравнению с", "по-за", "по-над", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "подобно", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "при помощи", "применительно к", "про", "против", "путём", "ради", "рядом с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "согласно", "спустя", "среди", "средь", "сродни", "судя по", "супротив", "у", "через", "чрез" ], exports.prepositionWith2Cases = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionWith3Cases = [ "по", "с", "со" ];
}(exports);

var exports, ref, util, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.dates = {}, exports = window.lastName.plugins.ru.dates, ref = window.lastName.plugins.ru.ref, util = window.lastName.util) : (exports = module.exports, ref = require("./ref"), util = require("../../util")), function(exports, util, ref) {
  var dateObjectToString, extractDates, getRuMonthIndex, getValidDate, packDates, packIntervals, ruMonthInDates;
  return ruMonthInDates = [ "января", "февраля", "марта", "аперля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря" ], dateObjectToString = function(dateObj) {
    var d, m, y, _ref;
    return y = ((_ref = typeof dateObj.y) === "number" || _ref === "string") && dateObj.y || "", m = dateObj.m + 1, m = m > 9 && m || "0" + m, d = dateObj.d > 9 && dateObj.d || "0" + dateObj.d, "" + d + "." + m + "." + y;
  }, getValidDate = function(dateObj) {
    var defaultYear, dt;
    defaultYear = dateObj.y;
    if (void 0 === dateObj.y || dateObj.y < 1970 || dateObj.y > 2038) dateObj.y = 2e3;
    return dt = new Date(Date.UTC(dateObj.y, dateObj.m, dateObj.d)), dt.getMonth() === dateObj.m && dt.getDate() === dateObj.d ? (dateObj.y = defaultYear, dateObj) : null;
  }, getRuMonthIndex = function(str) {
    var m;
    return m = str.toLowerCase().match(/(\s|^)(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s|$)/g), m ? ruMonthInDates.indexOf(m[0].replace(/\s/g, "")) : -1;
  }, exports.extractDates = extractDates = function(strArr) {
    var dates, intervals, sources;
    return dates = {}, sources = [], intervals = {}, strArr instanceof Array || (strArr = [ strArr ]), strArr.map(function(str) {
      var dStr, date, found, from, fromDate, fromMonth, fromYear, id, intObject, mIndex, sourceStr, to, toDate, toYear, verboseMatch, wordsArr, _ref, _results;
      verboseMatch = str.match(/\s+\d{1,2}\s+((января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)\s+|)(\d{2,4}(\s+года|)\s+|)по\s+\d{1,2}\s+(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s+\d{2,4}|)(\s+|$)/mig);
      if (!verboseMatch) {
        wordsArr = str.split(" "), found = !1, _results = [];
        while (wordsArr.length > 2 && !found) /^\d[\d]$/.test(wordsArr[0]) && (mIndex = ruMonthInDates.indexOf(wordsArr[1].toLowerCase()), mIndex >= 0 ? (date = {
          d: parseInt(wordsArr[0], 10),
          m: mIndex
        }, /^\d{2,4}$/.test(wordsArr[2]) ? (date.y = parseInt(wordsArr[2], 10), sourceStr = wordsArr.slice(0, 3).join(" ")) : sourceStr = wordsArr.slice(0, 2).join(" ")) : /^\d\d\.\d\d.\d{2,4}$/.test(wordsArr[0] || /^\d\d\.\d\d$/.test(wordsArr[0])) ? (date = {
          d: parseInt(wordsArr[0].slice(0, 3), 10),
          m: parseInt(wordsArr[0].slice(3, 6), 10),
          y: parseInt(wordsArr[0].slice(6), 10) || void 0
        }, sourceStr = wordsArr[0]) : date = {}, date = getValidDate(date), date && (found = !0, sources.push(sourceStr), dStr = dateObjectToString(date), dates[dStr] ? dates[dStr].count++ : dates[dStr] = {
          count: 1,
          value: date
        })), _results.push(wordsArr.shift());
        return _results;
      }
      _ref = verboseMatch[0].toLowerCase().split("по"), from = _ref[0], to = _ref[1], toYear = to.replace(/\d{1,2}/, "").match(/\d+/g), toYear ? toYear = parseInt(toYear[0], 10) : toYear = void 0, toDate = {
        d: parseInt(to.match(/\d{1,2}/g)[0], 10),
        m: getRuMonthIndex(to),
        y: toYear
      }, fromYear = from.replace(/\d{1,2}/, "").match(/\d+/g), fromMonth = getRuMonthIndex(from), fromYear ? fromYear = parseInt(fromYear[0], 10) : fromYear = toYear, fromMonth === -1 && (fromMonth = toDate.m), fromDate = {
        d: parseInt(from.match(/\d{1,2}/g)[0], 10),
        m: fromMonth,
        y: fromYear
      }, toDate = getValidDate(toDate), fromDate = getValidDate(fromDate);
      if (toDate && fromDate) return intObject = {
        from: dateObjectToString(fromDate),
        from_value: fromDate,
        to: dateObjectToString(toDate),
        to_value: toDate
      }, id = "" + intObject.from + "-" + intObject.to, intervals[id] ? intervals[id].count++ : (intObject.count = 1, intervals[id] = intObject), sources.push(verboseMatch[0]);
    }), {
      dates: dates,
      sources: sources,
      intervals: intervals
    };
  }, exports.packDates = packDates = function(dates, defaultYear) {
    var dateObj, id, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in dates) dateObj = dates[id], "undefined" != typeof dateObj.value.y && years.push(dateObj.value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in dates) dateObj = dates[id], "undefined" == typeof dateObj.value.y && (dateObj.value.y = defaultYear), out["" + dateObjectToString(dateObj.value)] = dateObj.count;
    return out;
  }, exports.packIntervals = packIntervals = function(intervals, defaultYear) {
    var id, interval, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in intervals) interval = intervals[id], "undefined" != typeof interval.from_value.y && years.push(interval.from_value.y), "undefined" != typeof interval.to_value.y && years.push(interval.to_value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in intervals) interval = intervals[id], "undefined" == typeof interval.from_value.y && (interval.from_value.y = defaultYear), "undefined" == typeof interval.to_value.y && (interval.to_value.y = defaultYear), out["" + dateObjectToString(interval.from_value) + "-" + dateObjectToString(interval.to_value)] = interval.count;
    return out;
  }, exports.preFilter = function(text, result) {
    var dates, numRe;
    numRe = /((([а-яё]+)\s+){0,1}\d[\.\d]{0,}(\s+(([a-яё]+)|([\.\d]+))){1,6})|([12]\d\d\d)/mig, dates = extractDates(util.unique(text.match(numRe) || [])), util.dictKeys(dates.dates).length > 0 && (result.dates = packDates(dates.dates)), util.dictKeys(dates.intervals).length > 0 && (result.intervals = packIntervals(dates.intervals));
    if (dates.sources.length > 0) return result.date_sources = dates.sources;
  };
}(exports, util, ref);

var exports, ref, util, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.inclines = {}, exports = window.lastName.plugins.ru.inclines, util = window.lastName.util, ref = window.lastName.plugins.ru.ref) : (exports = module.exports, util = require("../../util"), ref = require("./ref")), function(exports, util, ref) {
  var cases, doInclineFemaleName, doInclineMaleName, findProperName, genderMatch, getNominative, inclineAndGetResult, inclineFemMiddleName, inclineFemaleName, inclineFemaleNameAndGetResult, inclineFemaleSurname, inclineMaleMiddleName, inclineMaleName, inclineMaleNameAndGetResult, inclineMaleSurname, inclineMiddleName, inclineMiddleNameOrSurname, inclineName, inclinePersonSurname, inclineSurname, matchCase, matchNameAndSurname, matchNameParts;
  return cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ], exports.doInclineFemaleName = doInclineFemaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, aUnstressedRe, name2;
    return aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, aUnstressedRe = /ца$/g, name2 = name.slice(0, -1), aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aUnstressedRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ей", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /ия$/g.test(name) && name.length > 3 ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "и" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ь", "" + name2 + "ью", "" + name2 + "и" ] : /[жшщцч]$/g.test(name) ? [ "" + name, "" + name + "и", "" + name + "и", "" + name, "" + name + "ью", "" + name + "и" ] : [ name, name, name, name, name, name ];
  }, exports.doInclineMaleName = doInclineMaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, hardConsonants, hissingAndChe, ishortRe, name2;
    return hardConsonants = /[бвгдзклмнпрстфх]$/g, hissingAndChe = /[жшщцч]$/g, ishortRe = /((ай)|(ей)|(ой)|(уй)|(яй)|(юй)|(ий))$/g, aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, name2 = name.slice(0, -1), name === "Лев" ? [ "Лев", "Льва", "Льву", "Льва", "Львом", "Льве" ] : name === "Павел" ? [ "Павел", "Павла", "Павлу", "Павла", "Павлом", "Павле" ] : /и$/g.test(name) ? [ name, name, name, name, name, name ] : hissingAndChe.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ем", "" + name + "е" ] : hardConsonants.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ом", "" + name + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : ishortRe.test(name) ? [ "" + name2 + "й", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ко$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /о$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : null;
  }, inclineAndGetResult = function(fn, args) {
    var i, name, r;
    r = null;
    for (i in args) {
      name = args[i], r = fn(name, !0);
      if (r.found) break;
    }
    return r;
  }, inclineFemaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineFemaleName, arguments);
  }, inclineMaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineMaleName, arguments);
  }, exports.inclineFemaleName = inclineFemaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name3, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), nl = name.toLowerCase(), nominativeRe = /[адежзийклмнорстуьэя]$/g, canInclineRe = /[жшщцчаяь]$/g, genitiveRe = /[иы]$/g, dativeRe = /[еи]$/g, accusativeRe = /[жшщцчьую]$/g, instrumentalRe = /((ой)|(ей)|(еи)|(ью))$/g, prepositionalRe = /[еи]$/g, result = r = null, nominativeRe.test(nl) && ref.ruFemaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineFemaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "female",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name2 = name.slice(0, -1), name_cases = [], genitiveRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("dative"))), prepositionalRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("prepositional"))), accusativeRe.test(nl) && (/[ую]$/g.test(nl) ? r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а") : r = inclineFemaleNameAndGetResult(name), r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (name3 = name.slice(0, -2), r = inclineFemaleNameAndGetResult("" + name3 + "я", "" + name3 + "а", "" + name3 + "ь", "" + name3), r && r.found && (result = r, name_cases.push("instrumental"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineMaleName = inclineMaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), name === "Льв" && (name = "Лев"), name === "Павл" && (name = "Павел"), nl = name.toLowerCase(), nominativeRe = /([вгдзклмнпрстфхжшцьй]|(ба)|(ва)|(да)|(за)|(ла)|(ма)|(на)|(па)|(ра)|(са)|(та)|(фа)|(га)|(ка)|(ха)|(жа)|(ша)|(ща)|(ца)|(ча)|(я)|(ло)|(ко))$/g, canInclineRe = /([бвгдзклмнпрстфхжшцьая]|(ия)|(ья)|(ея)|(ий)|(ей))$/g, genitiveRe = /[аяыи]$/g, dativeRe = /(([еую])|(ии))$/g, accusativeRe = /[аяую]$/g, instrumentalRe = /((ом)|(ем)|(ой)|(ей)|(ёй))$/g, prepositionalRe = /((е)|(ии))$/g, name2 = name.slice(0, -1), result = r = null, nominativeRe.test(nl) && ref.ruMaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineMaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "male",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name_cases = [], genitiveRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /ы$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "о", "" + name2 + "а") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "а", "" + name.slice(0, -1) + "я", "" + name.slice(0, -1) + "о") : r = null, r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (/у$/g.test(nl) ? r = inclineMaleName(name2) : /[аеиоуя]ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "й") : /ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "ь") : /е$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "и", "" + name2 + "я", "" + name2 + "o") : /ии$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я") : r = null, r && r.found && (result = r, name_cases.push("dative"))), accusativeRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /у$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а") : /[ую]$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : r = null, r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (/ом$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2)) : /ем$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2), "" + name.slice(0, -2) + "ь", "" + name.slice(0, -2) + "й") : /ой$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "а", "" + name.slice(0, -2) + "о") : /((ей)|(ёй))$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "я", "" + name.slice(0, -2) + "а") : r = null, r && r.found && (result = r, name_cases.push("instrumental"))), prepositionalRe.test(nl) && (/е$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2, "" + name2 + "ь", "" + name2 + "й", "" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я", "" + name2 + "й") : r = null, r && r.found && (result = r, name_cases.push("prepositional"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineName = inclineName = function(name) {
    var fn, mn, result;
    return fn = inclineFemaleName(name), mn = inclineMaleName(name), fn.found ? result = {
      found: !0,
      src: name,
      gender: "female",
      guess_case: fn.guess_case,
      female_cases: fn.cases,
      possible_cases: fn.possible_cases,
      nominative: fn.nominative
    } : mn.found ? result = {
      found: !0,
      src: name,
      gender: "male",
      guess_case: mn.guess_case,
      male_cases: mn.cases,
      possible_cases: mn.possible_cases,
      nominative: mn.nominative
    } : fn.possible_yes && mn.possible_yes ? (result = {
      found: "maybe",
      src: name,
      gender: [ "male", "female" ],
      female_cases: fn.cases,
      male_cases: mn.cases,
      possible_cases: util.merge(fn.possible_cases, mn.possible_cases)
    }, result.guess_case = fn.guess_case_index <= mn.guess_case_index ? fn.guess_case : mn.guess_case) : fn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "female",
      female_cases: fn.cases,
      guess_case: fn.cases,
      possible_cases: fn.possible_cases
    } : mn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "male",
      male_cases: mn.cases,
      guess_case: mn.cases,
      possible_cases: mn.possible_cases
    } : result = {
      found: !1,
      src: name
    }, result;
  }, inclineSurname = function(surname, noInclinesRe, inclineRe, casesRe) {
    var c, cases_index, check, i, result, surname_cases, _i, _j, _len, _len2;
    result = {
      found: null,
      src: surname,
      cases: null,
      cases_index: null
    };
    if (noInclinesRe && noInclinesRe.test(surname)) result = {
      found: surname,
      src: surname,
      cases: [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ],
      cases_index: [ 0, 1, 2, 3, 4, 5 ]
    }; else for (_i = 0, _len = inclineRe.length; _i < _len; _i++) {
      check = inclineRe[_i];
      if (check[0].test(surname)) {
        result = {
          found: surname.replace(check[0], check[1]),
          src: surname
        }, cases_index = [], surname_cases = [], i = 0;
        for (_j = 0, _len2 = casesRe.length; _j < _len2; _j++) c = casesRe[_j], c.test(surname) && (cases_index.push(i), surname_cases.push(cases[i])), i++;
        surname_cases.length === 0 ? (result.found = null, result.cases = null) : result.cases = surname_cases, result.cases_index = cases_index;
        break;
      }
    }
    return result.surname_cases && (result.guess_case = result.surname_cases[0]), result;
  }, exports.inclineFemaleSurname = inclineFemaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(е)|(о)|(э)|(и)|(ы)|(^[нв]у)|(^ую)|(уа)|(иа)|(ман)|(вич)|(ян))$/g, inclineRe = [ [ /((ова)|(овой)|(ову))$/g, "ова" ], [ /((ева)|(евой)|(еву))$/g, "ева" ], [ /((ёва)|(ёвой)|(ёву))$/g, "ёва" ], [ /((ина)|(иной)|(ину))$/g, "ина" ], [ /((ая)|(ой)|(ую))$/g, "ая" ] ], casesRe = [ /((ова)|(ева)|(ёва)|(ина)|(ая))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((ову)|(еву)|(ёву)|(ину)|(ую))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, exports.inclineMaleSurname = inclineMaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(^ве)|(^го)|(э)|(и)|(ы)|(^му)|(ю)|(уа)|(иа))$/g, inclineRe = [ [ /((ов)|(ова)|(ову)|(овым)|(ове))$/g, "ов" ], [ /((ев)|(ева)|(еву)|(евым)|(еве))$/g, "ев" ], [ /((ёв)|(ёва)|(ёву)|(ёвым)|(ёве))$/g, "ёв" ], [ /((ин)|(ина)|(ину)|(иным)|(ине))$/g, "ин" ], [ /((ский)|(ского)|(скому)|(ским)|(ском))$/g, "ский" ], [ /((ской)|(ского)|(скому)|(ским)|(ском))$/g, "ской" ], [ /((ман)|(мана)|(ману)|(маном)|(мане))$/g, "ман" ], [ /((ой)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ой" ], [ /((ий)|(ого)|(ому)|(ого)|(им)|(ом))$/g, "ий" ], [ /((ый)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ый" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ], [ /((ян)|(яна)|(яну)|(яна)|(яном)|(яне))$/g, "ян" ] ], casesRe = [ /((ов)|(ев)|(ёв)|(ин)|(ский)|(ской)|(ой)|(ий)|(ый)|(ман)|(ич)|(ян))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((ову)|(еву)|(ёву)|(ину)|(скому)|(ому)|(ману)|(ичу)|(яну))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((овым)|(евым)|(ёвым)|(иным)|(ским)|(им)|(ым)|(маном)|(ичем)|(яном))$/g, /((ове)|(еве)|(ёве)|(ине)|(ском)|(ом)|(мане)|(иче)|(яне))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, inclineMiddleNameOrSurname = function(src, fem, male) {
    var result, _ref;
    return fem.found === (_ref = male.found) && _ref === null ? result = {
      found: !1,
      src: src,
      value: null,
      gender: null
    } : fem.found && male.found ? (result = {
      found: !0,
      src: src,
      gender: [ "male", "female" ]
    }, result.nominative_male = male.found, result.nominative_female = fem.found, result.female_cases = fem.cases, result.male_cases = male.cases, fem.cases.length === 6 ? male.cases.length === 6 ? (result.guess_sex = "unknown", result.possible_cases = util.merge(fem.cases, male.cases)) : (result.guess_sex = "male", result.nominative = male.found, result.possible_cases = male.cases) : fem.cases.length === 1 && male.cases.length > 1 ? (result.guess_sex = "female", result.nominative = fem.found, result.possible_cases = fem.cases) : result.possible_cases = util.merge(fem.cases, male.cases)) : fem.found ? male.found || (result = {
      found: !0,
      src: src,
      gender: "female",
      female_cases: fem.cases,
      guess_case: fem.guess_case,
      nominative: fem.found,
      possible_cases: fem.cases
    }) : result = {
      found: !0,
      src: src,
      gender: "male",
      male_cases: male.cases,
      guess_case: male.guess_case,
      nominative: male.found,
      possible_cases: male.cases
    }, result;
  }, exports.inclineSurname = inclinePersonSurname = function(surname) {
    return inclineMiddleNameOrSurname(surname, inclineFemaleSurname(surname), inclineMaleSurname(surname));
  }, exports.inclineMaleMiddleName = inclineMaleMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((евич)|(евича)|(евичу)|(евича)|(евичем)|(евиче))$/g, "евич" ], [ /((ович)|(овича)|(овичу)|(овича)|(овичем)|(овиче))$/g, "ович" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ] ], casesRe = [ /((евич)|(ович)|(ич))$/g, /((евича)|(овича)|(ича))$/g, /((евичу)|(овичу)|(ичу))$/g, /((евича)|(овича)|(ича))$/g, /((евичем)|(овичем)|(ичем))$/g, /((евиче)|(овиче)|(иче))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineFemMiddleName = inclineFemMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((вна)|(вны)|(вне)|(вну)|(вной)|(вне))$/g, "вна" ], [ /((чна)|(чны)|(чне)|(чну)|(чной)|(чне))$/g, "чна" ] ], casesRe = [ /((вна)|(чна))$/g, /((вны)|(чны))$/g, /((вне)|(чне))$/g, /((вну)|(чну))$/g, /((вной)|(чной))$/g, /((вне)|(чне))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineMiddleName = inclineMiddleName = function(mname) {
    return inclineMiddleNameOrSurname(mname, inclineFemMiddleName(mname), inclineMaleMiddleName(mname));
  }, genderMatch = function(g1, g2) {
    return g1 === g2 || __indexOf.call(g2, g1) >= 0 ? g1 : __indexOf.call(g1, g2) >= 0 ? g2 : null;
  }, matchNameParts = function(fn, mn, sn) {
    var overallGender, surname, theCase;
    return theCase = util.intersection(fn.possible_cases, mn.possible_cases), overallGender = genderMatch(genderMatch(fn.gender, mn.gender), sn.gender), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: mn.nominative,
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchNameAndSurname = function(fn, sn) {
    var overallGender, surname, theCase;
    return overallGender = genderMatch(fn.gender, sn.gender), theCase = util.intersection(fn.possible_cases, sn.possible_cases), theCase || (sn.possible_cases = sn["" + overallGender + "_cases"], sn.nominative = sn["nominative_" + overallGender], theCase = util.intersection(fn.possible_cases, sn.possible_cases)), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: "",
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchCase = function(pObj, target_case, gender) {
    return __indexOf.call(pObj["" + gender + "_cases"], target_case) >= 0;
  }, getNominative = function(pObj, gender) {
    var gnstr, nom;
    return gnstr = "nominative_" + gender, nom = pObj.nominative && pObj.nominative || pObj[gnstr], nom;
  }, exports.findProperName = findProperName = function(listOfWords, opts) {
    var mnr2, mnr3, nr1, nr2, nr3, result, sr1, sr2, sr3;
    opts == null && (opts = {}), result = {
      found: !1
    };
    switch (listOfWords.length) {
     case 1:
      result = inclineName(listOfWords[0]), result.found ? result.first_name = result.nominative : (result = inclinePersonSurname(listOfWords[0]), result.found && (result.surname = result.nominative));
      break;
     case 2:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr1.found && sr2.found && (result = matchNameAndSurname(nr1, sr2)), !result.found && sr1.found && nr2.found && (result = matchNameAndSurname(sr1, nr2));
      break;
     case 3:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), sr3 = inclinePersonSurname(listOfWords[2]), mnr2 = inclineMiddleName(listOfWords[1]), mnr3 = inclineMiddleName(listOfWords[2]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr3 = inclineName(listOfWords[2]), nr3.found ? result = {
        found: !1,
        error: "name at the end of 3-component proper name"
      } : nr1.found ? (mnr2.found && sr3.found && (result = matchNameParts(nr1, mnr2, sr3)), !result.found && sr2.found && (result = matchNameAndSurname(nr1, sr2))) : sr1.found && nr2.found && mnr3.found ? result = matchNameParts(nr2, mnr3, sr1) : nr2.found && sr3.found && (result = matchNameAndSurname(nr2, sr3));
    }
    return result.first_name || (result.first_name = ""), result.middle_name || (result.middle_name = ""), result.surname || (result.surname = ""), result.first_name || result.middle_name || result.surname || (result = {
      found: !1,
      error: "person not found"
    }), result.src = listOfWords.join(" "), result;
  }, exports.getInitialFormOfAdjective = function(adj) {
    var base;
    return adj = adj.toLowerCase(), /^[а-яё]{2,}(ая|ее|ие|ий|им|ими|их|ого|его|ое|ой|ом|ому|ою|ую|ые|ый|ым|ыми|ых|юю|яя)$/.test(adj) ? (/^[а-яё]{2,}(ими|ого|его|ому|ыми)$/gi.test(adj) ? base = adj.slice(0, -3) : base = adj.slice(0, -2), [ "" + base + "ый", "" + base + "ий", "" + base + "ой" ]) : null;
  }, exports.getVerbInfinitive = function(verb) {
    var pastTime, result, verbEnd;
    return verb = verb.toLowerCase(), /^[а-яё]{3,}(ать|аться|ить|иться|еть|еться|оть|оться|уть|утся|ются|ть|ться)$/.test(verb) ? verb : (/^[а-яё]{3,}(сь|ся)$/.test(verb) ? (verbEnd = verb.slice(-2), verb = verb.slice(0, -2)) : verbEnd = "", pastTime = verb.match(/^[а-яё]{3,}(л|ла|ло|ли)$/), pastTime ? result = verb.slice(0, -(1 + pastTime[1].length) + 1 || 9e9) + "ть" : /[а-яё]{3,}(у|ю|ем|ешь|ете|ет|ут|ют|им|ишь|ите|ит|ат|ят)$/.test(verb) && (/[а-яё]{3,}(ишь|ит|им|ите|ат|ят)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd ] : /[а-яё]{3,}(у|ю|ешь|ет|ем|ете|ут|ют)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd, "" + verb + "оть" + verbEnd, "" + verb + "уть" + verbEnd, "" + verb + "ть" + verbEnd ] : result = null), result);
  };
}(exports, util, ref);

var exports, ruWords, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.morpho = {}, exports = window.lastName.plugins.ru.morpho, ruWords = window.lastName.plugins.ru.words) : (exports = module.exports, ruWords = require("./words")), function(exports, ruWords) {
  var exceptions, getRulesAdjective, getRulesVerb, morphoRu;
  return exports.getWordRe = function() {
    return /^[а-я\-ё\d]+$/ig;
  }, exports.getAdjectiveEnds = function() {
    return {
      feminine: {
        ends: /((ая)|(ой)|(ую)|(яя)|(ей)|(юю))$/g,
        hard: /((ая)|(ой)|(ую))$/g,
        sort: /((яя)|(ей)|(юю))$/g,
        hardNominativeEnd: "ая",
        softNominativeEnd: "яя",
        gender: "feminine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ая" ? [ "" + word + "ая", "" + word + "ой", "" + word + "ой", "" + word + "ую", "" + word + "ой", "" + word + "ой" ] : [ "" + word + "яя", "" + word + "ей", "" + word + "ей", "" + word + "юю", "" + word + "ей", "" + word + "ей" ];
        }
      },
      masculine: {
        ends: /((ый)|(ого)|(ому)|(ым)|(ом)|(ий)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ый)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ий)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ый",
        softNominativeEnd: "ий",
        gender: "masculine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ый" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ий", "" + word + "ого", "" + word + "ому", "" + word + "ий", "" + word + "им", "" + word + "ом" ] : [ "" + word + "ый", "" + word + "ого", "" + word + "ому", "" + word + "ый", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ий", "" + word + "его", "" + word + "ему", "" + word + "ий", "" + word + "им", "" + word + "ем" ];
        }
      },
      neuter: {
        ends: /((ое)|(ого)|(ому)|(ым)|(ом)|(ее)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ое)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ее)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ое",
        softNominativeEnd: "ее",
        gender: "neuter",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ое" ? [ "" + word + "ое", "" + word + "ого", "" + word + "ому", "" + word + "ое", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ее", "" + word + "его", "" + word + "ему", "" + word + "ее", "" + word + "им", "" + word + "ем" ];
        }
      },
      plural: {
        ends: /((ые)|(ых)|(ым)|(ыми)|(ых)|(ие)|(их)|(им)|(ими)|(их))$/g,
        hard: /((ые)|(ых)|(ым)|(ыми)|(ых))$/g,
        soft: /((ие)|(их)|(им)|(ими)|(их))$/g,
        hardNominativeEnd: "ые",
        softNominativeEnd: "ие",
        gender: "unknown",
        singular: !1,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ые" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ] : [ "" + word + "ые", "" + word + "ых", "" + word + "ым", "" + word + "ые", "" + word + "ыми", "" + word + "ых" ] : [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ];
        }
      }
    };
  }, exceptions = function(word) {}, getRulesVerb = function() {
    return [ [ /нул[aи]{0,1}$/g, "ать" ], [ /еть$/g, "ать" ], [ /(ает)|(ают)$/g, "ать" ], [ /ал[aи]{0,1}$/g, "ать" ], [ /ул[aи]{0,1}$/g, "ать" ], [ /((ить)|(ать))$/g, "ать" ], [ /ая$/g, "ать" ], [ /((ил)|(или)|(ила)|(ило))$/g, "лять" ], [ /(ятся)|(ится)|(ился)|(илась)|(илось)$/g, "ится" ], [ /(яться)|(иться)$/g, "иться" ] ];
  }, getRulesAdjective = function() {
    return [ [ /в((ая)|(ые)|(ый)|(ое))$/, "вый" ], [ /((ая)|(ой)|(ие)|(ые)|(ый)|(ую))$/, "ый" ], [ /((яя)|(ее)|(ий)|(юю))$/, "ий" ] ];
  }, exports.morpho = morphoRu = function(word) {
    var adj, adjective, result, rule, verb, _i, _j, _len, _len2, _ref, _ref2;
    if (__indexOf.call(ruWords.adverbs, word) >= 0) return {
      type: "abverb",
      value: word
    };
    if (__indexOf.call(ruWords.prepositionAll, word) >= 0) return {
      type: "preposition",
      value: word
    };
    if (__indexOf.call(ruWords.unions, word) >= 0) return {
      type: "union",
      value: word
    };
    result = {
      type: "",
      value: ""
    }, verb = null, adjective = null, _ref = getRulesVerb();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      rule = _ref[_i];
      if (rule[0].test(word)) {
        result = {
          type: verb,
          value: word.replace(rule[0], rule[1])
        };
        break;
      }
    }
    _ref2 = getRulesAdjective();
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      rule = _ref2[_j];
      if (rule[0].test(word)) {
        adj = word.replace(rule[0], rule[1]), result.type ? (result.type += " adjective", result.value = [ result.value, adj ]) : result = {
          type: "adjective",
          value: adj
        };
        break;
      }
    }
    return result;
  }, exports.analyseText = function(text) {
    var doubleSpaceRe, enRe, punctuationRe, r, result, ruRe, t, wordRe, _i, _len, _ref;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&№“”\—]/g, doubleSpaceRe = /\s+/g, text = text.replace(punctuationRe, " $& ").replace(doubleSpaceRe, " ") + " .", result = [], _ref = text.split(" ");
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      t = _ref[_i], ruRe = /^[а-я\-ё]+$/ig, enRe = /^[a-z\-]+$/ig, wordRe = /^[а-яё\-\da-z]+$/ig, r = morphoRu(t.toLowerCase());
      switch (r.type) {
       case "adverb":
        result.push("[ADV " + t + "]");
        break;
       case "verb":
       case "adjective":
        result.push("[ " + r.value + " ]");
        break;
       case "verb adjective":
        result.push("[#VA " + r.value[0] + "]");
        break;
       case "union":
        result.push("[U " + t + "]");
        break;
       case "preposition":
        result.push("[PP " + t + "]");
        break;
       default:
        result.push(t);
      }
      t === "." && result.push("\n");
    }
    return result;
  }, exports.parseRuSentence = function(sentences) {
    var abbrevs, common_used_words, digits, regular_words, special_words, total_words;
    return sentences instanceof Array || (sentences = [ sentences ]), abbrevs = {}, special_words = {}, digits = {}, common_used_words = {}, regular_words = {}, total_words = 0, sentences.map(function(sent) {
      var i, result, w, word, words, _len, _ref, _results;
      words = sent.split(" "), _results = [];
      for (i = 0, _len = words.length; i < _len; i++) word = words[i], /^[[,:\/\\\?!\+\-\*\(\)\[\]\&\№\—]]+$/.test(words) || total_words++, /^(\d+(|(\.(|\d+))))$/.test(word) ? digits[word] ? _results.push(digits[word]++) : _results.push(digits[word] = 1) : isUpperCase(word) && /^[а-яё\-]{2,}$/i.test(word) ? abbrevs[word] ? _results.push(abbrevs[word]++) : _results.push(abbrevs[word] = 1) : i > 0 && isCapitalized(word) && /^[а-яё\-]{2,}$/i.test(word) ? special_words[word] ? _results.push(special_words[word]++) : _results.push(special_words[word] = 1) : /^[а-яё\-]+$/i.test(word) && !/^\-+$/.test(word) ? (w = word.toLowerCase(), result = morphoRu(w), (_ref = result.type) !== "adverb" && _ref !== "preposition" && _ref !== "union" ? regular_words[w] ? _results.push(regular_words[w]++) : _results.push(regular_words[w] = 1) : common_used_words[w] ? _results.push(common_used_words[w]++) : _results.push(common_used_words[w] = 1)) : _results.push(void 0);
      return _results;
    }), {
      abbrevs: abbrevs,
      common_used_words: common_used_words,
      special_words: special_words,
      regular_words: regular_words,
      digits: digits,
      total_words: total_words
    };
  };
}(exports, ruWords);

var exports, inclines, morpho, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.propernames = {}, exports = window.lastName.plugins.ru.propernames, morpho = window.lastName.plugins.ru.morpho, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, morpho = require("./morpho"), inclines = require("./inclines")), function(exports, morpho, inclines) {
  return exports.postFilter = function(text, result) {
    var curProperName, id, p, pn, pnDict, properNames, properNamesRe, punctuationRe, _i, _j, _len, _len2, _ref, _ref2;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&\№“”\—]/g, properNames = [], curProperName = [], properNamesRe = /[А-Я][а-яё]+(\s+[А-Я][а-яё]+){0,2}/gm, _ref = text.match(properNamesRe);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) pn = _ref[_i], curProperName = pn.replace(/\s+/g, " ").split(" "), curProperName && (pn = inclines.findProperName(curProperName), pn && pn.found && properNames.push(pn));
    pnDict = {};
    for (_j = 0, _len2 = properNames.length; _j < _len2; _j++) p = properNames[_j], id = "" + (p.first_name || "") + "-" + (p.middle_name || "") + "-" + (p.surname || ""), pnDict[id] ? (pnDict[id].count += 1, (_ref2 = p.src, __indexOf.call(pnDict[id].src, _ref2) < 0) && pnDict[id].src.push(p.src)) : (pnDict[id] = p, pnDict[id].src = [ p.src ], pnDict[id].count = 1);
    return result.propernames = pnDict;
  };
}(exports, morpho, inclines);

var exports, inclines, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName.plugins.ru.feelings = {}, exports = window.lastName.plugins.ru.feelings, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, inclines = require("./inclines")), function(exports, inclines) {
  var evaluateSentenceNeutrality, getNegativePhrasesRe, negativeAdjectives, negativeVerbs, negativeWordsIncline;
  return exports.positive = [], negativeAdjectives = {
    "агрессивный": 3,
    "атакованный": 2,
    "бедный": 2,
    "беззащитный": 2,
    "безнадежный": 3,
    "безрадостный": 2,
    "бесплодный": 3,
    "беспомощный": 3,
    "бесправный": 2,
    "бессердечный": 1,
    "бессильный": 1,
    "бесцельный": 2,
    "бесчестный": 2,
    "вздорный": 1,
    "виновный": 1,
    "ворчливый": 1,
    "враждебный": 2,
    "вспыльчивый": 1,
    "выпученный": 1,
    "выселенный": 3,
    "высмеянный": 2,
    "выхолощенный": 1,
    "глубокий": 1,
    "глупый": 2,
    "горький": 2,
    "готический": 2,
    "гротескный": 1,
    "грустный": 1,
    "грязный": 1,
    "девальвированный": 2,
    "деградировавший": 2,
    "дегуманизированный": 2,
    "дезорганизованный": 2,
    "дезориентированный": 2,
    "деморализованный": 3,
    "дерзкий": 1,
    "дерьмовый": 3,
    "дефектный": 3,
    "драматический": 3,
    "жалкий": 3,
    "жесткий": 2,
    "жестокосердный": 2,
    "заброшенный": 1,
    "забываемый": 1,
    "забывчивый": 1,
    "забытый": 2,
    "зависимый": 1,
    "заинтересованный": 1,
    "запрещенный": 3,
    "запутанный": 2,
    "застенчивый": 1,
    "застрявший": 1,
    "затравленный": 2,
    "зверский": 3,
    "злобный": 2,
    "идиотский": 3,
    "измельченный": 2,
    "измученный": 2,
    "изнасилованный": 3,
    "изолированный": 3,
    "изумленный": 1,
    "интенсивный": 1,
    "иррациональный": 2,
    "исключенный": 2,
    "искусственный": 2,
    "испуганный": 2,
    "истерический": 3,
    "исчерпанный": 2,
    "капризный": 2,
    "контролируемый": 1,
    "критический": 1,
    "ленивый": 2,
    "лишенный": 2,
    "ложный": 2,
    "мазохистский": 1,
    "мертвый": 3,
    "меченый": 2,
    "мрачный": 2,
    "мстительный": 2,
    "навязчивый": 2,
    "надоедливый": 2,
    "наказанный": 2,
    "нарушенный": 2,
    "натянутый": 2,
    "неадекватный": 2,
    "неактивный": 1,
    "небезопасный": 2,
    "небрежный": 1,
    "невежественный": 1,
    "невидимый": 1,
    "невротический": 2,
    "негуманный": 2,
    "недействительный": 1,
    "недовольный": 2,
    "недостаточный": 1,
    "недоуменный": 1,
    "незаземленный": 1,
    "незначительный": 1,
    "неискренний": 1,
    "некомпетентный": 2,
    "ненавистный": 3,
    "необщительный": 2,
    "неполный": 2,
    "неправильный": 2,
    "неприятный": 2,
    "нервный": 2,
    "нерешительный": 1,
    "несбалансированный": 1,
    "несовместимый": 2,
    "несоответствующий": 2,
    "неспособный": 3,
    "несчастный": 2,
    "неуклюжий": 2,
    "неуловимый": 1,
    "неуместный": 2,
    "нечестный": 2,
    "неэффективный": 2,
    "низкий": 1,
    "обвиняемый": 3,
    "обедненный": 1,
    "обезумевший": 3,
    "обиженный": 2,
    "обманутый": 2,
    "обозленный": 2,
    "оборонительный": 1,
    "обремененный": 1,
    "обременительный": 1,
    "обреченный": 2,
    "ограниченный": 1,
    "одержимый": 3,
    "одинокий": 2,
    "одноразовый": 1,
    "озабоченный": 2,
    "окаменелый": 1,
    "онемелый": 1,
    "опальный": 2,
    "опасный": 3,
    "опустошенный": 1,
    "опущенный": 2,
    "опьяненный": 1,
    "оскорбленный": 2,
    "осмеянный": 2,
    "острый": 1,
    "осужденный": 3,
    "осушенный": 2,
    "ответственный": 2,
    "отвратительный": 3,
    "отдаленный": 1,
    "отдельный": 1,
    "отрицательный": 2,
    "отсталый": 2,
    "отчаянный": 1,
    "ошибочный": 1,
    "параноидальный": 2,
    "паршивый": 2,
    "пассивный": 1,
    "переполненный": 2,
    "пессимистический": 2,
    "печальный": 2,
    "побежденный": 3,
    "поверхностный": 2,
    "поврежденный": 3,
    "подавленный": 2,
    "поддельный": 3,
    "покинутый": 2,
    "покорный": 1,
    "порабощенный": 3,
    "потерянный": 2,
    "потерпевший": 2,
    "потребленный": 1,
    "презираемый": 2,
    "презренный": 3,
    "презрительный": 2,
    "прерванный": 1,
    "принудительный": 2,
    "психотический": 2,
    "пустынный": 1,
    "пьяный": 2,
    "равнодушный": 1,
    "развращенный": 3,
    "раздраженный": 2,
    "раздражительный": 2,
    "разочарованный": 2,
    "разочаровывающий": 3,
    "разрушенный": 3,
    "разрушительный": 2,
    "разъяренный": 3,
    "раненый": 2,
    "ревнивый": 2,
    "садистский": 2,
    "самоубийственный": 3,
    "саркастический": 1,
    "сварливый": 1,
    "сгоревший": 3,
    "сердитый": 2,
    "серый": 1,
    "скучающий": 1,
    "скучный": 1,
    "сломанный": 2,
    "смущенный": 1,
    "созерцательный": 1,
    "сомнительный": 2,
    "спорный": 2,
    "спровоцированный": 2,
    "спутанный": 2,
    "спущенный": 2,
    "стереотипный": 1,
    "стесненный": 1,
    "странный": 1,
    "страшный": 2,
    "сумасшедший": 2,
    "тихий": 1,
    "тормозящий": 2,
    "торопливый": 2,
    "тоскливый": 3,
    "требовательный": 2,
    "тревожный": 2,
    "трудный": 2,
    "трусливый": 2,
    "тупой": 1,
    "тщеславный": 2,
    "угнетенный": 2,
    "угрюмый": 2,
    "удаляемый": 2,
    "удрученный": 2,
    "ужасный": 3,
    "уклончивый": 2,
    "униженный": 3,
    "унылый": 3,
    "урезанный": 2,
    "фальшивый": 3,
    "хаотический": 2,
    "холодный": 1,
    "хрупкий": 1,
    "цепкий": 2,
    "циничный": 2,
    "чертовский": 2,
    "чрезмерный": 2,
    "чувствительный": 2,
    "эгоистичный": 2,
    "эгоцентричный": 3,
    "эксплуатируемый": 2,
    "эмансипированный": 2,
    "эмоциональный": 1,
    "яростный": 3
  }, negativeVerbs = {
    "беспокоить": 2,
    "бить": 2,
    "внушать": 2,
    "волноваться": 2,
    "высмеивать": 2,
    "грызть": 1,
    "диктовать": 2,
    "дребезжать": 1,
    "дрожать": 1,
    "дрогнуть": 2,
    "загнать": 2,
    "запугивать": 3,
    "запутаться": 2,
    "злоупотреблять": 2,
    "игнорировать": 1,
    "избегать": 1,
    "издеваться": 3,
    "изменять": 2,
    "командовать": 1,
    "лгать": 2,
    "лишить": 2,
    "манипулировать": 2,
    "молчать": 1,
    "надувать": 1,
    "ненавидеть": 3,
    "обвинять": 2,
    "обидеть": 2,
    "опорочить": 3,
    "освистать": 3,
    "отбрасывать": 1,
    "отвлекаться": 2,
    "отклонить": 2,
    "отрекаться": 3,
    "оттолкнуть": 2,
    "паниковать": 2,
    "перепутаться": 2,
    "подавить": 3,
    "подвергаться": 2,
    "пострадать": 2,
    "предавать": 3,
    "пренебрегать": 2,
    "препятствовать": 2,
    "преследовать": 2,
    "принижаться": 2,
    "приставать": 2,
    "прослушивать": 2,
    "разгромить": 2,
    "раздражаться": 2,
    "растаскивать": 2,
    "рисковать": 2,
    "ругать": 2,
    "сдуваться": 1,
    "смолчать": 2,
    "снизиться": 1,
    "сорвать": 1,
    "сожалеть": 2,
    "соизволить": 2,
    "солгать": 2,
    "сомневаться": 2,
    "споткнуться": 1,
    "столкнуться": 2,
    "страдать": 2,
    "стрелять": 3,
    "судить": 2,
    "толкнуть": 1,
    "убить": 3,
    "убивать": 3,
    "уговаривать": 1,
    "удалять": 2,
    "уклоняться": 2,
    "унижать": 3,
    "шантажировать": 2
  }, negativeWordsIncline = {
    "боль": 2,
    "вниз": 1,
    "горе": 3,
    "дно": 2,
    "мало": 1,
    "мучение": 2,
    "недовольство": 2,
    "плохо": 2,
    "противно": 3,
    "совестно": 2,
    "только": 1,
    "ужас": 3,
    "смерть": 3,
    "неодобрительно": 2,
    "разгром": 2,
    "отчаяние": 3
  }, exports.getNegativePhrasesRe = getNegativePhrasesRe = function() {
    return [ [ /[^а-яё]при\sотягчающих\sобстоятельствах[^а-яё]/ig, 2 ], [ /[^а-яё]ненависть\sк[^а-яё]/ig, 3 ], [ /[^а-яё]в\sубыток[^а-яё]/ig, 2 ], [ /[^а-яё]сыт[аы]?\sпо\sгорло[^а-яё]/ig, 3 ], [ /[^а-яё]заслужива[ею]т\sнаказания[^а-яё]/ig, 2 ], [ /[^а-яё]находящ(егося|ейся|емся|ихся)\sпод\sугрозой\sисчезновения[^а-яё]/ig, 3 ], [ /[^а-яё]в\sзаблуждение[^а-яё]/ig, 2 ], [ /[^а-яё]сбит[аы]?\sс\sтолку[^а-яё]/ig, 2 ], [ /[^а-яё]в\sужасе[^а-яё]/ig, 3 ], [ /[^а-яё]не\sрекоменд(ую|уем|уется|овал|овала|овали)[^а-яё]/ig, 2 ], [ /[^а-яё]не\sодобря(ю|ем|л|ла|ли|ется)[^а-яё]/ig, 2 ], [ /[^а-яё]пятно\sна[^а-яё]/ig, 2 ], [ /[^а-яё]в\sклетке[^а-яё]/ig, 1 ], [ /[^а-яё]неправильно\sпонял[аи]?[^а-яё]/ig, 2 ], [ /[^а-яё]вне\sпределов\sдосягаемости[^а-яё]/ig, 1 ], [ /[^а-яё]взял[аи]?\sна[^а-яё]/ig, 2 ], [ /[^а-яё]играл[аи]?\sс[^а-яё]/ig, 2 ], [ /[^а-яё]черный\sсписок[^а-яё]/ig, 3 ], [ /[^а-яё]возбужден[оы]\sуголовн(ое|ые)\sдел[оа][^а-яё]/ig, 8 ], [ /[^а-яё]жертв(|а|ы|ам|ами)[^а-яё]/ig, 3 ] ];
  }, exports.evaluateSentenceNeutrality = evaluateSentenceNeutrality = function(sentence) {
    var adj, adjArray, adjIndex, curWords, cur_index, ind, index, m, nr, resetCurIndex, vIndex, verb, words, wrd, _i, _j, _k, _len, _len2, _len3, _ref, _ref2;
    index = 0, cur_index = 0, words = [], curWords = [], _ref = getNegativePhrasesRe();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) nr = _ref[_i], m = sentence.match(nr[0]), m && (m.map(function(wordsSequence) {
      return words.push(wordsSequence);
    }), index -= nr[1] * m.length);
    resetCurIndex = function() {
      if (cur_index) return index += cur_index, words.push(curWords), curWords = [], cur_index = 0;
    }, _ref2 = sentence.split(/\s/);
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      wrd = _ref2[_j];
      if (__indexOf.call(".,-—!?()[]", wrd) >= 0) {
        cur_index = -cur_index, resetCurIndex();
        continue;
      }
      ind = negativeWordsIncline[wrd.toLowerCase()];
      if (ind) curWords.push(wrd), cur_index = cur_index * ind || ind; else {
        adjArray = inclines.getInitialFormOfAdjective(wrd);
        if (!adjArray) verb = inclines.getVerbInfinitive(wrd), vIndex = negativeVerbs[verb], vIndex ? (curWords.push(wrd), cur_index = cur_index * vIndex || vIndex) : (cur_index = -cur_index, resetCurIndex()); else for (_k = 0, _len3 = adjArray.length; _k < _len3; _k++) {
          adj = adjArray[_k], adjIndex = negativeAdjectives[adj];
          if (adjIndex) {
            curWords.push(wrd), cur_index = cur_index * adjIndex || adjIndex;
            break;
          }
        }
      }
    }
    return resetCurIndex(-cur_index), [ index, words ];
  }, exports.postFilter = function(text, result) {
    var emoIndex, emoWords, i, index, overallIndex, s, _len, _ref, _ref2;
    emoIndex = [], overallIndex = 0, _ref = result.misc.sentences;
    for (i = 0, _len = _ref.length; i < _len; i++) s = _ref[i], _ref2 = evaluateSentenceNeutrality(s), index = _ref2[0], emoWords = _ref2[1], emoIndex.push([ index, emoWords ]), overallIndex += index;
    return result.feelings = {
      emoIndex: emoIndex,
      overallIndex: overallIndex,
      emoScore: overallIndex / result.counters.words_total || 1
    };
  };
}(exports, inclines);

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).analysis || (_base.analysis = {}), exports = window.lastName.analysis) : exports = module.exports, function(exports) {
  return exports.analyse = function(text, plugins) {
    var f, misc, postFilter, preFilters, result, util, _i, _j, _len, _len2;
    plugins == null && (plugins = []), "undefined" == typeof global ? (misc = window.lastName.misc, util = window.lastName.util) : (misc = require("./misc"), util = require("./util")), result = {}, misc.preFilter(text, result), preFilters = plugins.filter(function(plugin) {
      return "function" == typeof plugin.preFilter;
    }), postFilter = plugins.filter(function(plugin) {
      return "function" == typeof plugin.postFilter;
    });
    for (_i = 0, _len = preFilters.length; _i < _len; _i++) f = preFilters[_i], f.preFilter(text, result);
    for (_j = 0, _len2 = postFilter.length; _j < _len2; _j++) f = postFilter[_j], f.postFilter(text, result);
    return result.version = util.version, result;
  };
}(exports);

var __slice = Array.prototype.slice;

(function(lastname) {
  return lastname.version = "0.3.5", lastname.findProperName = function() {
    var args, inclines, lang;
    return lang = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [], inclines = lastname.plugins["" + lang].inclines, inclines.findProperName.apply(this, args);
  };
})(window.lastName || (window.lastName = {}));

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).misc || (_base.misc = {}), exports = window.lastName.misc) : exports = module.exports, function(exports) {
  return exports.preFilter = function(text, result) {
    var chars_total, emo, emoticons, findEmo, ind, punctuationRe, sentences, signs, signs_total, spaces_total, tempTxt, word_length_mid, words_total, _i, _len;
    signs = text.match(/[-\+=\/\.,\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]{1}/g), signs_total = signs && signs.length || 0, spaces_total = /\s/.test(text) ? text.match(/\s/g).length : 0, chars_total = text.length, words_total = text.split(/\s/).filter(function(wrd) {
      return wrd.length > 0 && !/^[-\+=\/\.\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]+$/.test(wrd);
    }).length, word_length_mid = words_total ? (chars_total - spaces_total - signs_total) / words_total : 0, emoticons = [ ":-)", "(-:", ":o)", ":)", "(:", ":->", ":-}", ":-t", ":*)", ":-)))", ":-D", "(-D", ":'-)", "%-)", ":-/", ":-I", ":~)", "(:-(", ":-(", ":-c", ":-(((", ":-<", ">:-(", ":-[", "(:-&", "%-(", ">:-<", "~ :-(", "%-(", ":/)", ":-|", ":-e", ":-X", ":-v", ":-I", ":-8(", ":-O", ":-@", ":,-(", ":'-(", "~:-o", "]:-)>", "):-)", ";->", ":-x", ":-*", "8-]", ":-J", ":-&", ":-p", ":-P", ";-)", ";)", "'-)", ":-7", "?-(", "B-D", ":-B", ":-*)", ":-9", "|-p", ":-b", "-]:-)[-", "8-I", "8-|", "|:-|", ":-]", "|-)", "|-I", "I^o", "|-O", ':-"', ":-s", ":-#", ":-!", ":-()", ":-D", "(:-$", ":-(*)", ":-')", ":-R", "%+|", "%+{", "X-(", "<:-)", "*:o)", "@;-)", "X:-)", ":>)", "&:-)", "#:-)", "8-)", "8:-)", "B-)", "B-]", "O:-)", "&8-|", ":-{", ":-)}", ":-)#", ":-Q", ":-I", ":-d~", ":-?", ":-/I", ":-) X", "{(:-)", ":-{}", "[:-)", "d :-o", "~:-(", "~~:-(", "))", "(:-I", "3:-o", "[: |]", "M-)", ":X)", ":-M", "*8((:", "O+", "O->", "||*(", "||*)", "<{:-)}", "(-: :-)", "@->-", "@==", "<')))))- <" ], emoticons.sort(function(a, b) {
      return b.length - a.length;
    }), tempTxt = text.slice(0), findEmo = [];
    for (_i = 0, _len = emoticons.length; _i < _len; _i++) {
      emo = emoticons[_i], ind = 0;
      while (ind >= 0) ind = tempTxt.indexOf(emo, ind), ind !== -1 && (findEmo.push(emo), tempTxt = tempTxt.replace(emo, ""), ind -= emo.length + 2);
    }
    return punctuationRe = /(https?\:\/\/.*[\s$])|(\.\s)|(,\s)|(\s\:)|(:\s)|(\s\/)|(\/\s)|(\s\\)(\\\s)|\?|!|\+|\'|\"|«|»|\*|\(|\)|\[|\]|\&|\№|“|”|\—/g, tempTxt = text.replace(punctuationRe, " $& ").replace(/\s+/g, " "), /[\?\!\.]\s{0,}$/.test(tempTxt) || (tempTxt += " . "), sentences = tempTxt.replace(/\s\?\s/gm, " ?? ").replace(/\s\!\s/gm, " !! ").replace(/\s\.\s/gm, " .. ").split(/[\?\!\.](\s+|$)/gm).filter(function(s) {
      return !/^\s{0,}$/.test(s);
    }), result.misc = {
      digits: util.arrayToDict(text.match(/-?((\d+[\.,]\d+)|(\d+))/ig) || []),
      emoticons: util.arrayToDict(findEmo),
      romans: util.arrayToDict(text.match(/(M*(D?C{0,3}|C[DM])(L?X{0,3}|X[LC])(V?I{0,3}|I[VX]))/g) || []),
      sentences: sentences
    }, result.counters = {
      chars_total: chars_total,
      words_total: words_total,
      signs_total: signs_total,
      spaces_total: spaces_total,
      word_length_mid: word_length_mid,
      words_in_sentence_mid: sentences.length ? words_total / sentences.length : 0
    }, result;
  };
}(exports);

var exports, _base, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).util || (_base.util = {}), exports = window.lastName.util) : exports = module.exports, function(exports) {
  var capitalize, dictKeys, intersection, isCapitalized, isLowerCase, isUpperCase, merge, unique;
  return exports.version = "0.3.17", exports.capitalize = capitalize = function(s) {
    if (s) return "" + s[0].toUpperCase() + s.slice(1).toLowerCase();
  }, exports.dictKeys = dictKeys = function(dict) {
    var k, keys, v;
    keys = [];
    for (k in dict) v = dict[k], keys.push(k);
    return keys;
  }, exports.isCapitalized = isCapitalized = function(word) {
    var cap;
    return 0 <= word.indexOf("-") ? (cap = !0, word.split("-").map(function(wrd) {
      return cap && (cap = isCapitalized(wrd));
    }), cap) : word && word === capitalize(word) || !1;
  }, exports.isUpperCase = isUpperCase = function(word) {
    return word === word.toUpperCase();
  }, exports.isLowerCase = isLowerCase = function(word) {
    return word === word.toLowerCase();
  }, exports.unique = unique = function(array) {
    var key, output, value, _ref, _results;
    output = {};
    for (key = 0, _ref = array.length; 0 <= _ref ? key < _ref : key > _ref; 0 <= _ref ? key++ : key--) output[array[key]] = array[key];
    _results = [];
    for (key in output) value = output[key], _results.push(value);
    return _results;
  }, exports.merge = merge = function(l1, l2) {
    var l;
    return l = [], l1.map(function(x) {
      return l.push(x);
    }), l2.map(function(x) {
      return l.push(x);
    }), unique(l);
  }, exports.intersection = intersection = function(l1, l2) {
    var i, _i, _len;
    for (_i = 0, _len = l1.length; _i < _len; _i++) {
      i = l1[_i];
      if (__indexOf.call(l2, i) >= 0) return i;
    }
    return null;
  }, exports.arrayToDict = function(arr) {
    var d, i, _i, _len;
    d = {};
    for (_i = 0, _len = arr.length; _i < _len; _i++) i = arr[_i], d[i] ? d[i]++ : d[i] = 1;
    return d;
  };
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.ref = {}, exports = window.lastName.plugins.ru.ref) : exports = module.exports, function(exports) {
  return exports.ruFemaleNamesDict = {
    "альвина": 1,
    "анелия": 1,
    "августа": 1,
    "августина": 1,
    "авдотья": 1,
    "авелина": 1,
    "аврелия": 1,
    "аврора": 1,
    "агапия": 1,
    "агата": 1,
    "агафья": 1,
    "агафия": 1,
    "аглаида": 1,
    "аглая": 1,
    "агнеса": 1,
    "агнесса": 1,
    "агния": 1,
    "агриппмеа": 1,
    "агрефена": 1,
    "ада": 1,
    "адина": 1,
    "адель": 1,
    "аделия": 1,
    "аделаида": 1,
    "аза": 1,
    "азалия": 1,
    "аида": 1,
    "айседора": 1,
    "айсылу": 1,
    "акилина": 1,
    "акулина": 1,
    "аксинья": 1,
    "алевтина": 1,
    "александра": 1,
    "алеся": 1,
    "алена": 1,
    "алина": 1,
    "алиса": 1,
    "алия": 1,
    "алла": 1,
    "алика": 1,
    "альбина": 1,
    "альмир": 1,
    "альфия": 1,
    "амина": 1,
    "анастасия": 1,
    "анатолия": 1,
    "ангелина": 1,
    "анжела": 1,
    "анимаиса": 1,
    "анисия": 1,
    "анисья": 1,
    "анна": 1,
    "анита": 1,
    "антонина": 1,
    "антонида": 1,
    "антония": 1,
    "анфиса": 1,
    "анфуса": 1,
    "анфия": 1,
    "амира": 1,
    "аполлинария": 1,
    "аревик": 1,
    "ариадна": 1,
    "арина": 1,
    "аркадия": 1,
    "арсения": 1,
    "арсиана": 1,
    "артемия": 1,
    "асель": 1,
    "аста": 1,
    "астра": 1,
    "астрид": 1,
    "афанасия": 1,
    "афродита": 1,
    "аэлита": 1,
    "аэлла": 1,
    "амалия": 1,
    "бажена": 1,
    "беата": 1,
    "беатриса": 1,
    "бела": 1,
    "белла": 1,
    "беллатриса": 1,
    "берта": 1,
    "богдана": 1,
    "божена": 1,
    "болеслава": 1,
    "борислава": 1,
    "бриджет": 1,
    "бронислава": 1,
    "валентина": 1,
    "валерия": 1,
    "ванда": 1,
    "варвара": 1,
    "василина": 1,
    "василиса": 1,
    "васса": 1,
    "вацлава": 1,
    "вевея": 1,
    "велора": 1,
    "велория": 1,
    "венера": 1,
    "вера": 1,
    "вероника": 1,
    "веселина": 1,
    "веста": 1,
    "видана": 1,
    "викторина": 1,
    "виктория": 1,
    "вилена": 1,
    "виола": 1,
    "виолетта": 1,
    "виоланта": 1,
    "виринея": 1,
    "вита": 1,
    "виталия": 1,
    "виталина": 1,
    "виулена": 1,
    "влада": 1,
    "владилена": 1,
    "владимира": 1,
    "владислава": 1,
    "владлена": 1,
    "власта": 1,
    "воля": 1,
    "всеслава": 1,
    "гайя": 1,
    "гали": 1,
    "галина": 1,
    "ганна": 1,
    "гаяна": 1,
    "гаяния": 1,
    "гвинет": 1,
    "гелена": 1,
    "гелия": 1,
    "гелла": 1,
    "генриетта": 1,
    "гертруда": 1,
    "глафира": 1,
    "гликерия": 1,
    "глория": 1,
    "голуба": 1,
    "горислава": 1,
    "гюльанэ": 1,
    "гюльнара": 1,
    "гюльчитай": 1,
    "даздраперма": 1,
    "дайна": 1,
    "дана": 1,
    "дарья": 1,
    "дария": 1,
    "дарина": 1,
    "дарьяна": 1,
    "декабрина": 1,
    "дея": 1,
    "дия": 1,
    "джиневра": 1,
    "дженнифер": 1,
    "джульета": 1,
    "дианна": 1,
    "дилия": 1,
    "диля": 1,
    "дильфуза": 1,
    "дина": 1,
    "диния": 1,
    "диодора": 1,
    "дионисия": 1,
    "добрава": 1,
    "домна": 1,
    "домина": 1,
    "домника": 1,
    "доминика": 1,
    "донара": 1,
    "дорофея": 1,
    "доротея": 1,
    "ева": 1,
    "евгения": 1,
    "евдокия": 1,
    "евлалия": 1,
    "евлампия": 1,
    "евпраксия": 1,
    "евстолия": 1,
    "евфалия": 1,
    "евфросиния": 1,
    "екатерина": 1,
    "елена": 1,
    "елизавета": 1,
    "еликонида": 1,
    "ермиония": 1,
    "есения": 1,
    "ефимия": 1,
    "евфремия": 1,
    "жанна": 1,
    "ждана": 1,
    "жаннэ": 1,
    "жасмина": 1,
    "забава": 1,
    "заира": 1,
    "зара": 1,
    "зарема": 1,
    "зарина": 1,
    "зорина": 1,
    "заряна": 1,
    "зауре": 1,
    "звенислава": 1,
    "земфира": 1,
    "зиля": 1,
    "зинаида": 1,
    "зиновия": 1,
    "злата": 1,
    "зозан": 1,
    "зоя": 1,
    "зульфия": 1,
    "иванна": 1,
    "ида": 1,
    "илария": 1,
    "илиана": 1,
    "илона": 1,
    "ильмира": 1,
    "инга": 1,
    "индира": 1,
    "инесса": 1,
    "инна": 1,
    "иоанна": 1,
    "иона": 1,
    "ипатия": 1,
    "ипполита": 1,
    "ирада": 1,
    "ираида": 1,
    "ирена": 1,
    "ироида": 1,
    "ираклия": 1,
    "ирина": 1,
    "исидора": 1,
    "искра": 1,
    "ифигения": 1,
    "ия": 1,
    "кадрия": 1,
    "кермен": 1,
    "калиса": 1,
    "каллиста": 1,
    "камилла": 1,
    "камила": 1,
    "капитолина": 1,
    "карина": 1,
    "каролина": 1,
    "катерина": 1,
    "кира": 1,
    "кирилла": 1,
    "клавдия": 1,
    "клара": 1,
    "клариса": 1,
    "кларисса": 1,
    "клеопатра": 1,
    "клио": 1,
    "клер": 1,
    "конкордия": 1,
    "констанция": 1,
    "кристина": 1,
    "ксения": 1,
    "лавиния": 1,
    "лада": 1,
    "лана": 1,
    "лариса": 1,
    "лаура": 1,
    "лейла": 1,
    "лема": 1,
    "лена": 1,
    "лениана": 1,
    "ленина": 1,
    "леонида": 1,
    "леонила": 1,
    "леонтия": 1,
    "леся": 1,
    "ливия": 1,
    "лидия": 1,
    "лилиана": 1,
    "лилия": 1,
    "лилит": 1,
    "лина": 1,
    "лира": 1,
    "лия": 1,
    "лея": 1,
    "лора": 1,
    "луиза": 1,
    "лукерия": 1,
    "лукиана": 1,
    "лукина": 1,
    "люцина": 1,
    "лусинэ": 1,
    "любава": 1,
    "любовь": 1,
    "любомира": 1,
    "людмила": 1,
    "ляля": 1,
    "мавра": 1,
    "магда": 1,
    "магдалина": 1,
    "мадлен": 1,
    "майя": 1,
    "мая": 1,
    "мальвина": 1,
    "маргарита": 1,
    "мариана": 1,
    "марьяна": 1,
    "марианна": 1,
    "мариетта": 1,
    "мариэтта": 1,
    "марика": 1,
    "марина": 1,
    "мария": 1,
    "марья": 1,
    "мари": 1,
    "марлен": 1,
    "марлена": 1,
    "марта": 1,
    "марфа": 1,
    "матильда": 1,
    "матрена": 1,
    "матрёна": 1,
    "матрона": 1,
    "мелания": 1,
    "меланья": 1,
    "мелитина": 1,
    "милада": 1,
    "милана": 1,
    "милен": 1,
    "милица": 1,
    "милия": 1,
    "милослава": 1,
    "мира": 1,
    "мирра": 1,
    "мирослава": 1,
    "митродора": 1,
    "млада": 1,
    "мстислава": 1,
    "нада": 1,
    "надежда": 1,
    "надия": 1,
    "наина": 1,
    "наира": 1,
    "нана": 1,
    "настасья": 1,
    "наталья": 1,
    "наталия": 1,
    "нелли": 1,
    "неонила": 1,
    "ника": 1,
    "нина": 1,
    "нинелла": 1,
    "нинель": 1,
    "новелла": 1,
    "нонна": 1,
    "нора": 1,
    "нуркыз": 1,
    "насиба": 1,
    "оксана": 1,
    "октавия": 1,
    "октябрина": 1,
    "олеся": 1,
    "оливия": 1,
    "олимпиада": 1,
    "олимпия": 1,
    "ольга": 1,
    "офелия": 1,
    "павла": 1,
    "павлина": 1,
    "патриция": 1,
    "пелагея": 1,
    "платонида": 1,
    "поликсена": 1,
    "полина": 1,
    "правдина": 1,
    "прасковья": 1,
    "пенелопа": 1,
    "полислава": 1,
    "рада": 1,
    "радмила": 1,
    "раиса": 1,
    "раймонда": 1,
    "раялла": 1,
    "ревмира": 1,
    "регина": 1,
    "рената": 1,
    "римма": 1,
    "рогнеда": 1,
    "роза": 1,
    "розалина": 1,
    "розалия": 1,
    "розана": 1,
    "роксан": 1,
    "ростислава": 1,
    "руслана": 1,
    "руфина": 1,
    "руфь": 1,
    "раида": 1,
    "сабина": 1,
    "сабрина": 1,
    "саломея": 1,
    "соломея": 1,
    "самира": 1,
    "светлана": 1,
    "светозара": 1,
    "светослава": 1,
    "свобода": 1,
    "святослава": 1,
    "севастьяна": 1,
    "северина": 1,
    "селена": 1,
    "селина": 1,
    "селестина": 1,
    "серафима": 1,
    "сергияна": 1,
    "сильва": 1,
    "агриппина": 1,
    "алёна": 1,
    "вилора": 1,
    "вилория": 1,
    "джульетта": 1,
    "диана": 1,
    "евфимия": 1,
    "ефросиния": 1,
    "калерия": 1,
    "милена": 1,
    "муза": 1,
    "савина": 1,
    "сильвия": 1,
    "симона": 1,
    "слава": 1,
    "славяна": 1,
    "снежана": 1,
    "софья": 1,
    "софия": 1,
    "станислава": 1,
    "стелла": 1,
    "степанида": 1,
    "стефанида": 1,
    "стефания": 1,
    "сусанна": 1,
    "сосанна": 1,
    "сюзанна": 1,
    "таира": 1,
    "таисия": 1,
    "тальяна": 1,
    "тамара": 1,
    "тамила": 1,
    "томила": 1,
    "татьяна": 1,
    "текуса": 1,
    "тереза": 1,
    "улита": 1,
    "ульяна": 1,
    "услада": 1,
    "устинья": 1,
    "фаина": 1,
    "февронья": 1,
    "феликсана": 1,
    "фелицата": 1,
    "фелицитата": 1,
    "фелиция": 1,
    "федора": 1,
    "феодора": 1,
    "феодосия": 1,
    "феодосья": 1,
    "феоктиста": 1,
    "феофания": 1,
    "феона": 1,
    "флавия": 1,
    "флора": 1,
    "флория": 1,
    "флорентина": 1,
    "флоренция": 1,
    "флориана": 1,
    "фотина": 1,
    "харита": 1,
    "харитина": 1,
    "хиония": 1,
    "христина": 1,
    "цецилия": 1,
    "чеслава": 1,
    "эвелина": 1,
    "эвридика": 1,
    "эдда": 1,
    "элеонора": 1,
    "элина": 1,
    "эльвира": 1,
    "эльмира": 1,
    "эльза": 1,
    "эмилия": 1,
    "эмма": 1,
    "эрика": 1,
    "эсфирь": 1,
    "юдифь": 1,
    "юзефа": 1,
    "юлиана": 1,
    "юлитта": 1,
    "юлия": 1,
    "юманита": 1,
    "юния": 1,
    "юнона": 1,
    "юстина": 1,
    "ядвига": 1,
    "яна": 1,
    "янина": 1,
    "яромира": 1,
    "ярослава": 1
  }, exports.ruMaleNamesDict = {
    "ааран": 1,
    "аарен": 1,
    "ааррон": 1,
    "аб": 1,
    "аббат": 1,
    "абботт": 1,
    "абей": 1,
    "абелл": 1,
    "абель": 1,
    "абнар": 1,
    "абнер": 1,
    "абнор": 1,
    "абот": 1,
    "аботт": 1,
    "абрам": 1,
    "абран": 1,
    "абрахам": 1,
    "абсалон": 1,
    "авангард": 1,
    "август": 1,
    "августин": 1,
    "авдей": 1,
    "авдий": 1,
    "авенир": 1,
    "аверилл": 1,
    "аверкий": 1,
    "авксентий": 1,
    "аврам": 1,
    "аврор": 1,
    "аврорий": 1,
    "агап": 1,
    "аггей": 1,
    "агей": 1,
    "адам": 1,
    "аддам": 1,
    "аддисон": 1,
    "аден": 1,
    "адий": 1,
    "адисон": 1,
    "адиссон": 1,
    "адлэй": 1,
    "адней": 1,
    "адольф": 1,
    "адонис": 1,
    "адриан": 1,
    "адэйр": 1,
    "адэр": 1,
    "азия": 1,
    "азэлстан": 1,
    "айбл": 1,
    "айзек": 1,
    "айк": 1,
    "ак": 1,
    "акей": 1,
    "акерлеа": 1,
    "акерлей": 1,
    "акерли": 1,
    "аки": 1,
    "аким": 1,
    "аклеа": 1,
    "аклей": 1,
    "акли": 1,
    "аксён": 1,
    "актон": 1,
    "акэль": 1,
    "алан": 1,
    "аластеир": 1,
    "аластэйр": 1,
    "алвар": 1,
    "алвен": 1,
    "алви": 1,
    "алвин": 1,
    "алвис": 1,
    "алгар": 1,
    "алджернон": 1,
    "алевтин": 1,
    "алеистер": 1,
    "алек": 1,
    "алекс": 1,
    "александр": 1,
    "алексей": 1,
    "ален": 1,
    "алестер": 1,
    "алжир": 1,
    "алик": 1,
    "аликс": 1,
    "алим": 1,
    "алисандр": 1,
    "алисдэйр": 1,
    "алиссандр": 1,
    "алистер": 1,
    "алистэйр": 1,
    "аллан": 1,
    "аллен": 1,
    "аллин": 1,
    "аллистер": 1,
    "аллистир": 1,
    "аллистэйр": 1,
    "алтон": 1,
    "алф": 1,
    "алфонзо": 1,
    "алфорд": 1,
    "алфрид": 1,
    "альберт": 1,
    "альбин": 1,
    "альвиан": 1,
    "альвин": 1,
    "альдина": 1,
    "альпин": 1,
    "альтаир": 1,
    "альфа": 1,
    "альфи": 1,
    "альфред": 1,
    "алэйстер": 1,
    "алэйстэйр": 1,
    "амби": 1,
    "амброуз": 1,
    "амедеус": 1,
    "амиас": 1,
    "амори": 1,
    "амос": 1,
    "амьяс": 1,
    "анакин": 1,
    "ананий": 1,
    "анастасий": 1,
    "анатолий": 1,
    "анвар": 1,
    "ангел": 1,
    "ангес": 1,
    "андерсон": 1,
    "анджелл": 1,
    "андрей": 1,
    "андреян": 1,
    "андриан": 1,
    "андрон": 1,
    "анж": 1,
    "анис": 1,
    "анисий": 1,
    "анисим": 1,
    "анри": 1,
    "анском": 1,
    "анскомб": 1,
    "ансон": 1,
    "антван": 1,
    "антип": 1,
    "антон": 1,
    "антоний": 1,
    "антонин": 1,
    "антуан": 1,
    "аполлинарий": 1,
    "аполлон": 1,
    "арам": 1,
    "арвид": 1,
    "аргент": 1,
    "арден": 1,
    "арефий": 1,
    "арий": 1,
    "арик": 1,
    "арил": 1,
    "арин": 1,
    "аристарх": 1,
    "аркадий": 1,
    "аркелл": 1,
    "арлен": 1,
    "арли": 1,
    "арман": 1,
    "армен": 1,
    "арн": 1,
    "арне": 1,
    "арни": 1,
    "арнольд": 1,
    "арран": 1,
    "аррин": 1,
    "аррон": 1,
    "арсен": 1,
    "арсений": 1,
    "арт": 1,
    "артамон": 1,
    "артемий": 1,
    "арти": 1,
    "артур": 1,
    "артём": 1,
    "архип": 1,
    "арчи": 1,
    "арчибальд": 1,
    "аселет": 1,
    "аселин": 1,
    "асер": 1,
    "аскольд": 1,
    "астон": 1,
    "атеист": 1,
    "афанасий": 1,
    "афиноген": 1,
    "афтон": 1,
    "аффтон": 1,
    "ахмат": 1,
    "ахмет": 1,
    "ачилл": 1,
    "аш": 1,
    "ашер": 1,
    "ашот": 1,
    "аштон": 1,
    "баграт": 1,
    "бад": 1,
    "бадди": 1,
    "бажен": 1,
    "баз": 1,
    "базилик": 1,
    "байрон": 1,
    "байярд": 1,
    "бак": 1,
    "бакстер": 1,
    "балдер": 1,
    "балдрик": 1,
    "бамби": 1,
    "баптист": 1,
    "бардолф": 1,
    "барии": 1,
    "барклей": 1,
    "барнабас": 1,
    "барни": 1,
    "барнэби": 1,
    "барретт": 1,
    "барри": 1,
    "барт": 1,
    "бартоломей": 1,
    "бассетт": 1,
    "бастер": 1,
    "бастиан": 1,
    "батч": 1,
    "баян": 1,
    "беван": 1,
    "беверли": 1,
    "бевис": 1,
    "бедивир": 1,
    "бейб": 1,
    "бейлей": 1,
    "бейлие": 1,
    "бен": 1,
    "бенджамин": 1,
    "бенджи": 1,
    "бенедикт": 1,
    "бенет": 1,
    "беннетт": 1,
    "бенни": 1,
    "бенние": 1,
    "бенсон": 1,
    "бентлей": 1,
    "бентон": 1,
    "беорегард": 1,
    "бердт": 1,
    "беренгар": 1,
    "беренджер": 1,
    "берет": 1,
    "бернард": 1,
    "берни": 1,
    "берри": 1,
    "берт": 1,
    "берти": 1,
    "бертольд": 1,
    "бертон": 1,
    "бертрам": 1,
    "бертран": 1,
    "бивис": 1,
    "билл": 1,
    "билли": 1,
    "бисш": 1,
    "биф": 1,
    "блейн": 1,
    "близэ": 1,
    "блисс": 1,
    "блэйз": 1,
    "блэйк": 1,
    "блэйн": 1,
    "блэр": 1,
    "боб": 1,
    "бобби": 1,
    "богдан": 1,
    "боеслав": 1,
    "болдуин": 1,
    "болеслав": 1,
    "боллард": 1,
    "бомонт": 1,
    "бонифэйс": 1,
    "боримир": 1,
    "борис": 1,
    "борислав": 1,
    "боян": 1,
    "брадлей": 1,
    "браеден": 1,
    "брайен": 1,
    "брайон": 1,
    "бранден": 1,
    "брандон": 1,
    "браннон": 1,
    "брейден": 1,
    "брейдн": 1,
    "брендан": 1,
    "бренден": 1,
    "брендон": 1,
    "бреннан": 1,
    "брент": 1,
    "брентон": 1,
    "брет": 1,
    "бретт": 1,
    "бриар": 1,
    "брион": 1,
    "брис": 1,
    "бриско": 1,
    "бриттон": 1,
    "бриэм": 1,
    "бродерик": 1,
    "броди": 1,
    "броз": 1,
    "брок": 1,
    "бронислав": 1,
    "бронт": 1,
    "броуди": 1,
    "броук": 1,
    "брук": 1,
    "брукс": 1,
    "бруно": 1,
    "брутус": 1,
    "брьянт": 1,
    "брэд": 1,
    "брэди": 1,
    "брэдфорд": 1,
    "брэйден": 1,
    "брэйди": 1,
    "брэм": 1,
    "брэн": 1,
    "брюс": 1,
    "брююс": 1,
    "будимир": 1,
    "буз": 1,
    "букер": 1,
    "булат": 1,
    "бью": 1,
    "бэйли": 1,
    "вавила": 1,
    "вадим": 1,
    "вал": 1,
    "валентайн": 1,
    "валентин": 1,
    "валериан": 1,
    "валерий": 1,
    "валерьян": 1,
    "вальдемар": 1,
    "вальтер": 1,
    "ванадий": 1,
    "вард": 1,
    "варлаам": 1,
    "варлам": 1,
    "варлен": 1,
    "вартан": 1,
    "варфоломей": 1,
    "василий": 1,
    "василько": 1,
    "ваухан": 1,
    "вахтанг": 1,
    "вацлав": 1,
    "вашингтон": 1,
    "вебстер": 1,
    "велдон": 1,
    "велимир": 1,
    "велислав": 1,
    "велор": 1,
    "велорий": 1,
    "венедикт": 1,
    "вениамин": 1,
    "вер": 1,
    "вергилий": 1,
    "верджил": 1,
    "верн": 1,
    "вернон": 1,
    "вестер": 1,
    "вестлей": 1,
    "вестон": 1,
    "вик": 1,
    "викентий": 1,
    "виктор": 1,
    "вил": 1,
    "вилберн": 1,
    "вилей": 1,
    "вилен": 1,
    "вилий": 1,
    "вилиор": 1,
    "вилки": 1,
    "вилл": 1,
    "вилли": 1,
    "виллоби": 1,
    "вилмар": 1,
    "вилмер": 1,
    "вилмот": 1,
    "вилор": 1,
    "вилорг": 1,
    "вилорий": 1,
    "вилсон": 1,
    "вилф": 1,
    "вилфорд": 1,
    "виль": 1,
    "вильгельм": 1,
    "вильтон": 1,
    "вильям": 1,
    "вин": 1,
    "виндзор": 1,
    "винни": 1,
    "винс": 1,
    "винсент": 1,
    "винслоу": 1,
    "винтроп": 1,
    "винцент": 1,
    "виолен": 1,
    "вирджиль": 1,
    "виссарион": 1,
    "вистан": 1,
    "виталий": 1,
    "витейкр": 1,
    "витней": 1,
    "витольд": 1,
    "влад": 1,
    "владелин": 1,
    "владилен": 1,
    "владимир": 1,
    "владислав": 1,
    "владлен": 1,
    "влас": 1,
    "власий": 1,
    "воган": 1,
    "вогн": 1,
    "воин": 1,
    "воислав": 1,
    "волдо": 1,
    "волемир": 1,
    "волкер": 1,
    "воллис": 1,
    "володар": 1,
    "вольдемар": 1,
    "вольмир": 1,
    "вольт": 1,
    "вольф": 1,
    "вольфрам": 1,
    "воспой": 1,
    "всеволод": 1,
    "всемил": 1,
    "вуди": 1,
    "вудроу": 1,
    "вулф": 1,
    "вьятт": 1,
    "вэйд": 1,
    "вэйланд": 1,
    "вэнс": 1,
    "вячеслав": 1,
    "габби": 1,
    "габриель": 1,
    "габриэль": 1,
    "гавриил": 1,
    "гаврил": 1,
    "гаврила": 1,
    "гаврило": 1,
    "гай": 1,
    "гайдар": 1,
    "гайлс": 1,
    "галактион": 1,
    "гален": 1,
    "галий": 1,
    "гамильтон": 1,
    "гамлет": 1,
    "гантэр": 1,
    "гаральд": 1,
    "гарван": 1,
    "гарей": 1,
    "гарибальди": 1,
    "гарланд": 1,
    "гарнет": 1,
    "гарольд": 1,
    "гарри": 1,
    "гаррий": 1,
    "гарс": 1,
    "гарфилд": 1,
    "гас": 1,
    "гаспар": 1,
    "гваделупа": 1,
    "гвидон": 1,
    "гейб": 1,
    "гейл": 1,
    "гейр": 1,
    "гектор": 1,
    "гелеон": 1,
    "гелиан": 1,
    "гелий": 1,
    "ген": 1,
    "гений": 1,
    "геннадий": 1,
    "генри": 1,
    "генрих": 1,
    "геодар": 1,
    "георгий": 1,
    "геральд": 1,
    "герасим": 1,
    "герберт": 1,
    "герман": 1,
    "гермоген": 1,
    "герольд": 1,
    "геронт": 1,
    "геронтий": 1,
    "герт": 1,
    "гертруд": 1,
    "гидеон": 1,
    "гильберт": 1,
    "гисберт": 1,
    "гладвин": 1,
    "гланвилл": 1,
    "глеб": 1,
    "глендауэр": 1,
    "гленн": 1,
    "глэн": 1,
    "говард": 1,
    "годвин": 1,
    "годфри": 1,
    "голлагэр": 1,
    "голладжер": 1,
    "гомер": 1,
    "горазд": 1,
    "гораций": 1,
    "горд": 1,
    "гордей": 1,
    "горден": 1,
    "гордий": 1,
    "гордон": 1,
    "горимир": 1,
    "горислав": 1,
    "горн": 1,
    "граем": 1,
    "грай": 1,
    "гранвилл": 1,
    "гранд": 1,
    "гранит": 1,
    "грахэйм": 1,
    "грег": 1,
    "грей": 1,
    "гренвилл": 1,
    "григорий": 1,
    "гриир": 1,
    "грир": 1,
    "гриффин": 1,
    "гриффит": 1,
    "гровер": 1,
    "грэг": 1,
    "грэгори": 1,
    "грэди": 1,
    "грэм": 1,
    "гудвин": 1,
    "гудзон": 1,
    "гурий": 1,
    "густав": 1,
    "гэй": 1,
    "гэйбл": 1,
    "гэйг": 1,
    "гэйдж": 1,
    "гэйелорд": 1,
    "гэйл": 1,
    "гэйлон": 1,
    "гэйлорд": 1,
    "гэйр": 1,
    "гэлл": 1,
    "гэри": 1,
    "давей": 1,
    "дави": 1,
    "давид": 1,
    "давыд": 1,
    "дад": 1,
    "дадда": 1,
    "дадли": 1,
    "даймонд": 1,
    "дакей": 1,
    "дакота": 1,
    "дакс": 1,
    "далтон": 1,
    "дамайон": 1,
    "дамиан": 1,
    "дамир": 1,
    "дан": 1,
    "дана": 1,
    "дани": 1,
    "даниар": 1,
    "даниил": 1,
    "данил": 1,
    "данила": 1,
    "данило": 1,
    "даниэль": 1,
    "данки": 1,
    "данни": 1,
    "дар": 1,
    "дарби": 1,
    "дарвин": 1,
    "дарден": 1,
    "дарен": 1,
    "дариан": 1,
    "дарил": 1,
    "дарин": 1,
    "дарки": 1,
    "дарнелл": 1,
    "даррел": 1,
    "даррен": 1,
    "даррил": 1,
    "даррин": 1,
    "даррэль": 1,
    "дасти": 1,
    "дастин": 1,
    "дау": 1,
    "дафф": 1,
    "даффи": 1,
    "дашилл": 1,
    "дван": 1,
    "двэйн": 1,
    "деай": 1,
    "деван": 1,
    "девен": 1,
    "девереукс": 1,
    "девин": 1,
    "девон": 1,
    "дейв": 1,
    "дейл": 1,
    "дейрлл": 1,
    "дейрн": 1,
    "декабрий": 1,
    "деклан": 1,
    "декстер": 1,
    "делберт": 1,
    "делл": 1,
    "делмар": 1,
    "делрой": 1,
    "дементий": 1,
    "деметриус": 1,
    "демид": 1,
    "демократ": 1,
    "демон": 1,
    "демьян": 1,
    "ден": 1,
    "денвер": 1,
    "денеб": 1,
    "дензэль": 1,
    "дени": 1,
    "денил": 1,
    "денис": 1,
    "деннис": 1,
    "дентон": 1,
    "деон": 1,
    "деонн": 1,
    "деонт": 1,
    "дерби": 1,
    "дерек": 1,
    "дерик": 1,
    "дермот": 1,
    "дерок": 1,
    "деррен": 1,
    "дерри": 1,
    "деррил": 1,
    "дефорест": 1,
    "дефоррест": 1,
    "дешон": 1,
    "джадд": 1,
    "джадин": 1,
    "джай": 1,
    "джайлс": 1,
    "джак": 1,
    "джамар": 1,
    "джамей": 1,
    "джамисон": 1,
    "джарвис": 1,
    "джаред": 1,
    "джарод": 1,
    "джарред": 1,
    "джарретт": 1,
    "джаррод": 1,
    "джаспер": 1,
    "джасти": 1,
    "джастин": 1,
    "джеб": 1,
    "джед": 1,
    "джедидиа": 1,
    "джейдн": 1,
    "джейк": 1,
    "джейлн": 1,
    "джейми": 1,
    "джеймс": 1,
    "джейрт": 1,
    "джейсон": 1,
    "джекки": 1,
    "джекоб": 1,
    "джем": 1,
    "дженкин": 1,
    "джеп": 1,
    "джер": 1,
    "джералд": 1,
    "джеральд": 1,
    "джерард": 1,
    "джерваз": 1,
    "джервис": 1,
    "джереми": 1,
    "джери": 1,
    "джермэйн": 1,
    "джеролд": 1,
    "джером": 1,
    "джеррард": 1,
    "джерред": 1,
    "джерри": 1,
    "джеррод": 1,
    "джерролд": 1,
    "джес": 1,
    "джесси": 1,
    "джетро": 1,
    "джетт": 1,
    "джеф": 1,
    "джеффери": 1,
    "джефферсон": 1,
    "джеффрей": 1,
    "джеффри": 1,
    "джиб": 1,
    "джид": 1,
    "джиди": 1,
    "джил": 1,
    "джим": 1,
    "джими": 1,
    "джимми": 1,
    "джисберт": 1,
    "джиффард": 1,
    "джо": 1,
    "джоб": 1,
    "джоби": 1,
    "джоджо": 1,
    "джоди": 1,
    "джозеф": 1,
    "джой": 1,
    "джойс": 1,
    "джон": 1,
    "джоназан": 1,
    "джоназон": 1,
    "джонасон": 1,
    "джонатан": 1,
    "джоней": 1,
    "джони": 1,
    "джонни": 1,
    "джонти": 1,
    "джорги": 1,
    "джордан": 1,
    "джордж": 1,
    "джорди": 1,
    "джордон": 1,
    "джосс": 1,
    "джоул": 1,
    "джош": 1,
    "джошоа": 1,
    "джошуа": 1,
    "джулс": 1,
    "джульян": 1,
    "джустис": 1,
    "джьюд": 1,
    "джэй": 1,
    "джэйд": 1,
    "джэйда": 1,
    "джэйден": 1,
    "джэйдон": 1,
    "джэйкоб": 1,
    "джэйлен": 1,
    "джэйлин": 1,
    "джэйлон": 1,
    "джэймес": 1,
    "джэйсон": 1,
    "джэксон": 1,
    "джэмини": 1,
    "джэмми": 1,
    "джэн": 1,
    "ди": 1,
    "диакон": 1,
    "дигби": 1,
    "диггори": 1,
    "дигори": 1,
    "дидим": 1,
    "дизон": 1,
    "дик": 1,
    "дики": 1,
    "дикки": 1,
    "дил": 1,
    "дилан": 1,
    "дилберт": 1,
    "димер": 1,
    "димитрий": 1,
    "дин": 1,
    "диндр": 1,
    "дионис": 1,
    "дионисий": 1,
    "дирк": 1,
    "дмитрий": 1,
    "доб": 1,
    "добрыня": 1,
    "додж": 1,
    "дольф": 1,
    "дом": 1,
    "доменик": 1,
    "доминик": 1,
    "дон": 1,
    "дональд": 1,
    "дональт": 1,
    "донат": 1,
    "донни": 1,
    "донован": 1,
    "дор": 1,
    "дориан": 1,
    "дорофей": 1,
    "доусон": 1,
    "драйк": 1,
    "древ": 1,
    "дрейвн": 1,
    "дуайт": 1,
    "дуан": 1,
    "дуг": 1,
    "дуги": 1,
    "дуглас": 1,
    "дункан": 1,
    "дунстан": 1,
    "дью": 1,
    "дьюей": 1,
    "дьюэйн": 1,
    "дэвид": 1,
    "дэвис": 1,
    "дэй": 1,
    "дэйви": 1,
    "дэйн": 1,
    "дэйтон": 1,
    "дэн": 1,
    "дэни": 1,
    "дэниел": 1,
    "дэнни": 1,
    "дэррик": 1,
    "дэшон": 1,
    "дюк": 1,
    "евгений": 1,
    "евграф": 1,
    "евдоким": 1,
    "евлампий": 1,
    "евлогий": 1,
    "евсей": 1,
    "евстафий": 1,
    "егор": 1,
    "елеазар": 1,
    "елизар": 1,
    "елисей": 1,
    "емельян": 1,
    "епифан": 1,
    "еремей": 1,
    "ермак": 1,
    "ермил": 1,
    "ермолай": 1,
    "ерофей": 1,
    "еруслан": 1,
    "ефим": 1,
    "ефрем": 1,
    "ждан": 1,
    "жерар": 1,
    "жозеф": 1,
    "жорес": 1,
    "жюль": 1,
    "завир": 1,
    "зак": 1,
    "закери": 1,
    "зандер": 1,
    "захар": 1,
    "захарий": 1,
    "зачариа": 1,
    "зачэри": 1,
    "зед": 1,
    "зедекиа": 1,
    "зек": 1,
    "зигмунд": 1,
    "зигфрид": 1,
    "зиновий": 1,
    "зорий": 1,
    "зосим": 1,
    "зосима": 1,
    "зот": 1,
    "зубин": 1,
    "зэофилус": 1,
    "иб": 1,
    "ибрагим": 1,
    "иван": 1,
    "игнат": 1,
    "игнатий": 1,
    "игнатиус": 1,
    "игорь": 1,
    "ид": 1,
    "иероним": 1,
    "иззи": 1,
    "изидор": 1,
    "измаил": 1,
    "измайло": 1,
    "изяслав": 1,
    "ий": 1,
    "икар": 1,
    "илар": 1,
    "иларий": 1,
    "иларион": 1,
    "илий": 1,
    "илиодор": 1,
    "илларион": 1,
    "илья": 1,
    "имон": 1,
    "инглеберт": 1,
    "инграм": 1,
    "инди": 1,
    "индиана": 1,
    "индиго": 1,
    "инесент": 1,
    "иниго": 1,
    "иннокентий": 1,
    "иоанн": 1,
    "иорик": 1,
    "иосиф": 1,
    "ипат": 1,
    "ипатий": 1,
    "ипполит": 1,
    "ираклий": 1,
    "ирвайн": 1,
    "ирвин": 1,
    "ирвинг": 1,
    "ириней": 1,
    "ириний": 1,
    "ирл": 1,
    "ирм": 1,
    "ирнест": 1,
    "исай": 1,
    "исайя": 1,
    "исак": 1,
    "исакий": 1,
    "исей": 1,
    "исидор": 1,
    "иссак": 1,
    "исси": 1,
    "истер": 1,
    "июлий": 1,
    "йорк": 1,
    "ка": 1,
    "кадмус": 1,
    "казимир": 1,
    "каин": 1,
    "каир": 1,
    "кайд": 1,
    "кайл": 1,
    "кал": 1,
    "калин": 1,
    "калина": 1,
    "каллен": 1,
    "кам": 1,
    "камден": 1,
    "камиль": 1,
    "камрон": 1,
    "капитон": 1,
    "карбрей": 1,
    "карбри": 1,
    "карвер": 1,
    "карей": 1,
    "карен": 1,
    "карл": 1,
    "карлайл": 1,
    "карлейл": 1,
    "карлин": 1,
    "карлтон": 1,
    "карм": 1,
    "кармий": 1,
    "карп": 1,
    "каррол": 1,
    "картер": 1,
    "касиди": 1,
    "каспар": 1,
    "каспер": 1,
    "кассиди": 1,
    "касьян": 1,
    "квентин": 1,
    "квинтин": 1,
    "кеван": 1,
    "кевин": 1,
    "кей": 1,
    "кейденс": 1,
    "кейдн": 1,
    "кейлб": 1,
    "кеймрон": 1,
    "кейси": 1,
    "келвин": 1,
    "келкей": 1,
    "келл": 1,
    "келли": 1,
    "келсей": 1,
    "кемп": 1,
    "кен": 1,
    "кендал": 1,
    "кендол": 1,
    "кендрик": 1,
    "кенелм": 1,
    "кензи": 1,
    "кенит": 1,
    "кеннеди": 1,
    "кеннет": 1,
    "кенни": 1,
    "кеннит": 1,
    "кенрик": 1,
    "кент": 1,
    "кентиджерн": 1,
    "кентон": 1,
    "кермит": 1,
    "керней": 1,
    "керр": 1,
    "керри": 1,
    "керт": 1,
    "кертис": 1,
    "кешон": 1,
    "ки": 1,
    "киаран": 1,
    "килан": 1,
    "килер": 1,
    "килиан": 1,
    "киллиан": 1,
    "ким": 1,
    "кимбелайн": 1,
    "кимберли": 1,
    "кимбол": 1,
    "кимбэль": 1,
    "кин": 1,
    "кинан": 1,
    "кинастон": 1,
    "кинг": 1,
    "кингслей": 1,
    "кип": 1,
    "киприан": 1,
    "кир": 1,
    "киран": 1,
    "кирби": 1,
    "кирилл": 1,
    "кирк": 1,
    "кирон": 1,
    "кирус": 1,
    "кит": 1,
    "китон": 1,
    "киф": 1,
    "клавдий": 1,
    "клайв": 1,
    "клайд": 1,
    "кланкей": 1,
    "кланки": 1,
    "кларенс": 1,
    "кларк": 1,
    "клев": 1,
    "клей": 1,
    "клейтон": 1,
    "клем": 1,
    "клемент": 1,
    "клементий": 1,
    "клемми": 1,
    "клетис": 1,
    "клетус": 1,
    "кливленд": 1,
    "клим": 1,
    "климент": 1,
    "климентий": 1,
    "клинт": 1,
    "клинтон": 1,
    "клифтон": 1,
    "клифф": 1,
    "клиффорд": 1,
    "клод": 1,
    "клэйрк": 1,
    "клэр": 1,
    "кодей": 1,
    "коди": 1,
    "коертней": 1,
    "козьма": 1,
    "кола": 1,
    "коламбан": 1,
    "колберт": 1,
    "колби": 1,
    "колдер": 1,
    "колин": 1,
    "коллахан": 1,
    "коллин": 1,
    "коллум": 1,
    "колтен": 1,
    "колтон": 1,
    "колумбий": 1,
    "кольт": 1,
    "конан": 1,
    "конвей": 1,
    "кондрат": 1,
    "кондратий": 1,
    "конлей": 1,
    "коннелл": 1,
    "коннер": 1,
    "коннор": 1,
    "конон": 1,
    "конор": 1,
    "конрад": 1,
    "константин": 1,
    "конфуций": 1,
    "корбин": 1,
    "корделл": 1,
    "корей": 1,
    "кори": 1,
    "корней": 1,
    "корнелий": 1,
    "корнелиус": 1,
    "корнил": 1,
    "кортней": 1,
    "кортни": 1,
    "корэй": 1,
    "коти": 1,
    "коул": 1,
    "коулман": 1,
    "краснослав": 1,
    "крис": 1,
    "криспиан": 1,
    "криспин": 1,
    "кристи": 1,
    "кристиан": 1,
    "кристопэр": 1,
    "кристоф": 1,
    "кристофер": 1,
    "крофорд": 1,
    "крофтон": 1,
    "крэйг": 1,
    "ксавайор": 1,
    "ксавьер": 1,
    "ксан": 1,
    "ксенофонт": 1,
    "ксзавир": 1,
    "кузьма": 1,
    "куин": 1,
    "куинкей": 1,
    "куинси": 1,
    "куинтон": 1,
    "купер": 1,
    "куприян": 1,
    "курт": 1,
    "куртис": 1,
    "кэйд": 1,
    "кэйдн": 1,
    "кэйл": 1,
    "кэйлб": 1,
    "кэймрон": 1,
    "кэйн": 1,
    "кэйси": 1,
    "кэлвин": 1,
    "кэм": 1,
    "кэмп": 1,
    "кэмпбэл": 1,
    "кэри": 1,
    "кюри": 1,
    "лаверн": 1,
    "лавлл": 1,
    "лавр": 1,
    "лаврентий": 1,
    "лаз": 1,
    "лазарь": 1,
    "лайл": 1,
    "лайонел": 1,
    "лаки": 1,
    "ланни": 1,
    "ланфорд": 1,
    "ларион": 1,
    "ларк": 1,
    "ларкин": 1,
    "ларри": 1,
    "лаэрт": 1,
    "лев": 1,
    "леви": 1,
    "левкий": 1,
    "лейврн": 1,
    "лейн": 1,
    "лейтон": 1,
    "лекс": 1,
    "леланд": 1,
    "лель": 1,
    "лем": 1,
    "лемми": 1,
    "лемюэль": 1,
    "лен": 1,
    "ленар": 1,
    "ленард": 1,
    "лени": 1,
    "лениан": 1,
    "леннард": 1,
    "ленни": 1,
    "лео": 1,
    "леон": 1,
    "леонард": 1,
    "леонид": 1,
    "леонтий": 1,
    "леопольд": 1,
    "лермонт": 1,
    "лерой": 1,
    "лес": 1,
    "лесли": 1,
    "лестер": 1,
    "ли": 1,
    "либерт": 1,
    "ливадий": 1,
    "лии": 1,
    "лин": 1,
    "линдон": 1,
    "линдсей": 1,
    "линдси": 1,
    "линкольн": 1,
    "линн": 1,
    "линсей": 1,
    "линтон": 1,
    "линус": 1,
    "линфорд": 1,
    "лионель": 1,
    "лир": 1,
    "лирой": 1,
    "лисандр": 1,
    "литон": 1,
    "лихнис": 1,
    "ллойд": 1,
    "ллью": 1,
    "лльюелин": 1,
    "лльюеллин": 1,
    "ло": 1,
    "ловэль": 1,
    "лойд": 1,
    "лон": 1,
    "лондон": 1,
    "лонни": 1,
    "лонс": 1,
    "лор": 1,
    "лорен": 1,
    "лоренс": 1,
    "лори": 1,
    "лорин": 1,
    "лорис": 1,
    "лорни": 1,
    "лоррин": 1,
    "лосон": 1,
    "лоуэлл": 1,
    "лоэнгрин": 1,
    "лу": 1,
    "лудо": 1,
    "луи": 1,
    "лука": 1,
    "лукиан": 1,
    "лукьян": 1,
    "льюин": 1,
    "льюис": 1,
    "лэйк": 1,
    "лэйн": 1,
    "лэйтон": 1,
    "лэндон": 1,
    "лэнс": 1,
    "лэрри": 1,
    "любим": 1,
    "любомир": 1,
    "людвиг": 1,
    "людовик": 1,
    "люк": 1,
    "люкс": 1,
    "люксен": 1,
    "люсьен": 1,
    "лютер": 1,
    "люциан": 1,
    "маверик": 1,
    "маврикий": 1,
    "мадисон": 1,
    "маеслав": 1,
    "май": 1,
    "майк": 1,
    "майкл": 1,
    "майлз": 1,
    "майрон": 1,
    "майслав": 1,
    "макар": 1,
    "макарий": 1,
    "макей": 1,
    "макензи": 1,
    "маки": 1,
    "макинтош": 1,
    "маккензи": 1,
    "макс": 1,
    "максвелл": 1,
    "максим": 1,
    "максимилиан": 1,
    "максимиллиан": 1,
    "максимильян": 1,
    "малачи": 1,
    "малком": 1,
    "малоун": 1,
    "манлей": 1,
    "манни": 1,
    "манникс": 1,
    "мануил": 1,
    "мануйло": 1,
    "манфред": 1,
    "марат": 1,
    "марвин": 1,
    "мариан": 1,
    "марин": 1,
    "мариус": 1,
    "марк": 1,
    "марка": 1,
    "маркел": 1,
    "маркиан": 1,
    "марко": 1,
    "маркус": 1,
    "марлен": 1,
    "марлин": 1,
    "марлон": 1,
    "марлоу": 1,
    "мармадьюк": 1,
    "марри": 1,
    "марс": 1,
    "марсен": 1,
    "марти": 1,
    "мартиал": 1,
    "мартин": 1,
    "мартын": 1,
    "маршал": 1,
    "маршалл": 1,
    "марьян": 1,
    "масон": 1,
    "мастерман": 1,
    "матвей": 1,
    "матти": 1,
    "мед": 1,
    "мелвилль": 1,
    "мелвин": 1,
    "мельбурн": 1,
    "мерв": 1,
    "мервин": 1,
    "мерди": 1,
    "мердо": 1,
    "мердок": 1,
    "мередит": 1,
    "мерит": 1,
    "меркурий": 1,
    "мерл": 1,
    "мерлин": 1,
    "меррилл": 1,
    "мерритт": 1,
    "мертон": 1,
    "мерфи": 1,
    "мефодий": 1,
    "мечеслав": 1,
    "мечислав": 1,
    "мид": 1,
    "миид": 1,
    "мик": 1,
    "мика": 1,
    "мики": 1,
    "микки": 1,
    "милад": 1,
    "милан": 1,
    "милберн": 1,
    "милен": 1,
    "милий": 1,
    "миллард": 1,
    "мило": 1,
    "милонег": 1,
    "милослав": 1,
    "милтон": 1,
    "милфорд": 1,
    "мир": 1,
    "мирон": 1,
    "мирослав": 1,
    "митчелл": 1,
    "михаил": 1,
    "михайло": 1,
    "мич": 1,
    "мича": 1,
    "мичил": 1,
    "мо": 1,
    "модест": 1,
    "моз": 1,
    "моисей": 1,
    "молком": 1,
    "монолит": 1,
    "монро": 1,
    "монтагью": 1,
    "монтгомери": 1,
    "монте": 1,
    "монти": 1,
    "монтморенки": 1,
    "морган": 1,
    "морген": 1,
    "мордекэй": 1,
    "морис": 1,
    "морлей": 1,
    "моррис": 1,
    "морт": 1,
    "морти": 1,
    "мортимер": 1,
    "мортон": 1,
    "мосс": 1,
    "моэ": 1,
    "мстислав": 1,
    "мулава": 1,
    "мурат": 1,
    "мэйнард": 1,
    "мэйнерд": 1,
    "мэйор": 1,
    "мэйсон": 1,
    "мэйтланд": 1,
    "мэлори": 1,
    "мэль": 1,
    "мэриан": 1,
    "мэрион": 1,
    "мэт": 1,
    "мэтт": 1,
    "мэтти": 1,
    "мэтью": 1,
    "мюд": 1,
    "надир": 1,
    "назаниль": 1,
    "назар": 1,
    "назарий": 1,
    "назим": 1,
    "найджел": 1,
    "найлс": 1,
    "наль": 1,
    "нанди": 1,
    "нат": 1,
    "натан": 1,
    "наум": 1,
    "науэлл": 1,
    "наш": 1,
    "невада": 1,
    "неван": 1,
    "невил": 1,
    "невилл": 1,
    "нед": 1,
    "нейл": 1,
    "нейлл": 1,
    "нейт": 1,
    "нельсон": 1,
    "нео": 1,
    "неон": 1,
    "неонил": 1,
    "нестер": 1,
    "нестор": 1,
    "нивек": 1,
    "нивен": 1,
    "ник": 1,
    "никандр": 1,
    "никанор": 1,
    "никита": 1,
    "никифор": 1,
    "никк": 1,
    "никки": 1,
    "никодим": 1,
    "никола": 1,
    "николай": 1,
    "николас": 1,
    "никон": 1,
    "нил": 1,
    "нили": 1,
    "нимбус": 1,
    "нинел": 1,
    "нинель": 1,
    "нисон": 1,
    "нифонт": 1,
    "ноа": 1,
    "новомир": 1,
    "нодар": 1,
    "ной": 1,
    "нолан": 1,
    "нолл": 1,
    "норберт": 1,
    "норвуд": 1,
    "норд": 1,
    "норм": 1,
    "норман": 1,
    "норманд": 1,
    "норрис": 1,
    "нортон": 1,
    "ноубль": 1,
    "ноэль": 1,
    "ньют": 1,
    "ньютон": 1,
    "оберон": 1,
    "обин": 1,
    "обри": 1,
    "овидий": 1,
    "огастин": 1,
    "огден": 1,
    "огэст": 1,
    "оделл": 1,
    "одиссей": 1,
    "одлей": 1,
    "одран": 1,
    "оз": 1,
    "оззи": 1,
    "океан": 1,
    "оксар": 1,
    "октавиан": 1,
    "октябрин": 1,
    "октябрь": 1,
    "олби": 1,
    "олбэйн": 1,
    "олдвен": 1,
    "олдвин": 1,
    "олден": 1,
    "олдин": 1,
    "олдис": 1,
    "олдон": 1,
    "олдос": 1,
    "олдред": 1,
    "олдус": 1,
    "олдфорд": 1,
    "олег": 1,
    "олей": 1,
    "оли": 1,
    "оливер": 1,
    "олимпий": 1,
    "олластер": 1,
    "олластир": 1,
    "оллгар": 1,
    "оллджер": 1,
    "олли": 1,
    "оллин": 1,
    "оллисдэйр": 1,
    "оллистер": 1,
    "оллистэйр": 1,
    "оллон": 1,
    "оллэйстар": 1,
    "ольгерд": 1,
    "омар": 1,
    "омега": 1,
    "онисим": 1,
    "ора": 1,
    "оран": 1,
    "орвал": 1,
    "орвилл": 1,
    "орест": 1,
    "ориан": 1,
    "ормерод": 1,
    "оррелл": 1,
    "оррин": 1,
    "орсон": 1,
    "осберт": 1,
    "осбоерн": 1,
    "осборн": 1,
    "освальд": 1,
    "осень": 1,
    "осип": 1,
    "оскар": 1,
    "остап": 1,
    "остен": 1,
    "остин": 1,
    "остромир": 1,
    "отис": 1,
    "оттис": 1,
    "отто": 1,
    "оттон": 1,
    "оуин": 1,
    "оуэн": 1,
    "ошин": 1,
    "павел": 1,
    "пайс": 1,
    "палладий": 1,
    "палмер": 1,
    "панкрас": 1,
    "пантелей": 1,
    "пантелеймон": 1,
    "панфил": 1,
    "парамон": 1,
    "паркер": 1,
    "паррис": 1,
    "партизан": 1,
    "пат": 1,
    "патрик": 1,
    "патси": 1,
    "пахом": 1,
    "пеитон": 1,
    "пепин": 1,
    "пересвет": 1,
    "перри": 1,
    "перс": 1,
    "перси": 1,
    "персиваль": 1,
    "петеркин": 1,
    "пимен": 1,
    "пип": 1,
    "пипер": 1,
    "пирр": 1,
    "пирс": 1,
    "пит": 1,
    "питер": 1,
    "платон": 1,
    "пол": 1,
    "поли": 1,
    "поликарп": 1,
    "помпей": 1,
    "портер": 1,
    "порфирий": 1,
    "потап": 1,
    "престон": 1,
    "приам": 1,
    "принц": 1,
    "пров": 1,
    "прозор": 1,
    "прокопий": 1,
    "прокофий": 1,
    "проспер": 1,
    "протас": 1,
    "прохор": 1,
    "пэйс": 1,
    "пэйси": 1,
    "пэйтон": 1,
    "пётр": 1,
    "петр": 1,
    "равель": 1,
    "равен": 1,
    "равиль": 1,
    "радамес": 1,
    "радий": 1,
    "радим": 1,
    "радислав": 1,
    "радомир": 1,
    "раз": 1,
    "раймонд": 1,
    "раймунд": 1,
    "райордан": 1,
    "райт": 1,
    "ралф": 1,
    "ралфи": 1,
    "ральф": 1,
    "ранделл": 1,
    "ранди": 1,
    "рандолф": 1,
    "рандольф": 1,
    "расс": 1,
    "рассел": 1,
    "рассэль": 1,
    "расти": 1,
    "растус": 1,
    "ратмир": 1,
    "рауль": 1,
    "рафаил": 1,
    "рафаэль": 1,
    "рашид": 1,
    "раян": 1,
    "реарден": 1,
    "ревмир": 1,
    "реган": 1,
    "редд": 1,
    "редж": 1,
    "реджи": 1,
    "реджинальд": 1,
    "редклиф": 1,
    "редклифф": 1,
    "редлей": 1,
    "редманд": 1,
    "редмонд": 1,
    "реид": 1,
    "рей": 1,
    "рейли": 1,
    "рейнард": 1,
    "рейнольд": 1,
    "рекс": 1,
    "рем": 1,
    "ренальд": 1,
    "ренат": 1,
    "риган": 1,
    "ригби": 1,
    "рид": 1,
    "ридлей": 1,
    "риель": 1,
    "рик": 1,
    "рикей": 1,
    "рики": 1,
    "рилан": 1,
    "рилей": 1,
    "рили": 1,
    "ринат": 1,
    "рио": 1,
    "риплей": 1,
    "рис": 1,
    "рихард": 1,
    "рич": 1,
    "ричард": 1,
    "ричи": 1,
    "роальд": 1,
    "роб": 1,
    "робби": 1,
    "роберт": 1,
    "робеспьер": 1,
    "роби": 1,
    "робин": 1,
    "робинзон": 1,
    "рован": 1,
    "род": 1,
    "роддж": 1,
    "родджер": 1,
    "родди": 1,
    "родерик": 1,
    "роджер": 1,
    "родион": 1,
    "родни": 1,
    "родолф": 1,
    "рождеро": 1,
    "рой": 1,
    "ройл": 1,
    "ройс": 1,
    "ройстон": 1,
    "роки": 1,
    "ролан": 1,
    "роланд": 1,
    "роли": 1,
    "ролланд": 1,
    "ролли": 1,
    "роман": 1,
    "ромен": 1,
    "ромуальд": 1,
    "рон": 1,
    "рональд": 1,
    "ронни": 1,
    "рори": 1,
    "роско": 1,
    "росс": 1,
    "ростислав": 1,
    "роуланд": 1,
    "роулей": 1,
    "роял": 1,
    "рубен": 1,
    "рубин": 1,
    "руди": 1,
    "рудольф": 1,
    "рудьярд": 1,
    "рунар": 1,
    "руслан": 1,
    "руссо": 1,
    "рустам": 1,
    "рустем": 1,
    "рхетт": 1,
    "рьюб": 1,
    "рэд": 1,
    "рэй": 1,
    "рэйнард": 1,
    "рэйнер": 1,
    "рэйф": 1,
    "рэм": 1,
    "рэндал": 1,
    "рэндалл": 1,
    "рюрик": 1,
    "сава": 1,
    "савва": 1,
    "савелий": 1,
    "савьер": 1,
    "сайг": 1,
    "саймон": 1,
    "салал": 1,
    "салливан": 1,
    "самми": 1,
    "самойло": 1,
    "самсон": 1,
    "самуил": 1,
    "сандфорд": 1,
    "санни": 1,
    "санфорд": 1,
    "свет": 1,
    "светлан": 1,
    "светозар": 1,
    "светослав": 1,
    "свизин": 1,
    "свизун": 1,
    "свиней": 1,
    "святогор": 1,
    "святополк": 1,
    "святослав": 1,
    "себастьян": 1,
    "севард": 1,
    "севастиан": 1,
    "севастьян": 1,
    "север": 1,
    "севериан": 1,
    "северин": 1,
    "северьян": 1,
    "северян": 1,
    "седрик": 1,
    "сеймур": 1,
    "селби": 1,
    "семён": 1,
    "септембер": 1,
    "серапион": 1,
    "серафим": 1,
    "сергей": 1,
    "сесил": 1,
    "сет": 1,
    "сефтон": 1,
    "сивард": 1,
    "сигизмунд": 1,
    "сигманд": 1,
    "сид": 1,
    "сидней": 1,
    "сидор": 1,
    "сила": 1,
    "силас": 1,
    "силвестр": 1,
    "сильвер": 1,
    "сильвест": 1,
    "сильвестр": 1,
    "симеон": 1,
    "симон": 1,
    "синклэйр": 1,
    "сирил": 1,
    "сисар": 1,
    "скай": 1,
    "скилар": 1,
    "скилер": 1,
    "скот": 1,
    "скотти": 1,
    "скуилер": 1,
    "слава": 1,
    "слай": 1,
    "слэйд": 1,
    "совет": 1,
    "сократ": 1,
    "соломон": 1,
    "сони": 1,
    "сонни": 1,
    "софокл": 1,
    "софон": 1,
    "спайк": 1,
    "спарроу": 1,
    "спартак": 1,
    "спенсер": 1,
    "спиридон": 1,
    "спиро": 1,
    "стакей": 1,
    "сталий": 1,
    "сталь": 1,
    "станислав": 1,
    "стаффорд": 1,
    "степан": 1,
    "стерлинг": 1,
    "стеф": 1,
    "стефан": 1,
    "сти": 1,
    "стив": 1,
    "стивен": 1,
    "стиви": 1,
    "стиу": 1,
    "сторм": 1,
    "стратон": 1,
    "сту": 1,
    "стэки": 1,
    "стэн": 1,
    "стэнли": 1,
    "стэнфорд": 1,
    "стюарт": 1,
    "сурен": 1,
    "сэм": 1,
    "сэмюэль": 1,
    "сэнди": 1,
    "тад": 1,
    "таддеус": 1,
    "таир": 1,
    "тай": 1,
    "такер": 1,
    "тал": 1,
    "талбот": 1,
    "таннер": 1,
    "тарас": 1,
    "таскилл": 1,
    "таффи": 1,
    "тед": 1,
    "тейгу": 1,
    "тейдж": 1,
    "теймураз": 1,
    "тейрк": 1,
    "текс": 1,
    "тельнан": 1,
    "тенгиз": 1,
    "тенней": 1,
    "теннизон": 1,
    "тео": 1,
    "теобальд": 1,
    "теодор": 1,
    "теранс": 1,
    "теренс": 1,
    "терентий": 1,
    "терло": 1,
    "терранс": 1,
    "террелл": 1,
    "терренс": 1,
    "терстон": 1,
    "ти": 1,
    "тиарнак": 1,
    "тиарнан": 1,
    "тибалт": 1,
    "тибби": 1,
    "тигран": 1,
    "тигу": 1,
    "тизон": 1,
    "тилар": 1,
    "тилер": 1,
    "тилор": 1,
    "тим": 1,
    "тимми": 1,
    "тимоти": 1,
    "тимофей": 1,
    "тимур": 1,
    "тирелл": 1,
    "тирнан": 1,
    "тирней": 1,
    "тирон": 1,
    "тироун": 1,
    "тиррелл": 1,
    "тит": 1,
    "тихомир": 1,
    "тихон": 1,
    "тоал": 1,
    "тоби": 1,
    "тобиас": 1,
    "тобин": 1,
    "товий": 1,
    "тод": 1,
    "тодд": 1,
    "толли": 1,
    "том": 1,
    "томас": 1,
    "томми": 1,
    "тон": 1,
    "тони": 1,
    "топэр": 1,
    "торез": 1,
    "торий": 1,
    "торлей": 1,
    "торнтон": 1,
    "травис": 1,
    "тракей": 1,
    "трантер": 1,
    "траффорд": 1,
    "траэрн": 1,
    "трев": 1,
    "тревельян": 1,
    "тревор": 1,
    "трейврс": 1,
    "трейс": 1,
    "трейси": 1,
    "трент": 1,
    "трентон": 1,
    "тристан": 1,
    "тристрам": 1,
    "трифон": 1,
    "трой": 1,
    "трофим": 1,
    "труман": 1,
    "туллий": 1,
    "тусон": 1,
    "тэдди": 1,
    "тэди": 1,
    "тэйлер": 1,
    "тэйлор": 1,
    "тэйн": 1,
    "тэйт": 1,
    "тэл": 1,
    "тэмпл": 1,
    "тэрри": 1,
    "уилбер": 1,
    "уиллард": 1,
    "уиллис": 1,
    "уилфред": 1,
    "уилфрид": 1,
    "уильям": 1,
    "уинстон": 1,
    "уинфред": 1,
    "уисдом": 1,
    "улайксс": 1,
    "улиссес": 1,
    "ульяна": 1,
    "уолли": 1,
    "уоллис": 1,
    "уолт": 1,
    "уолтер": 1,
    "уолтон": 1,
    "уорик": 1,
    "уорнер": 1,
    "уоррен": 1,
    "уот": 1,
    "уоткин": 1,
    "уптон": 1,
    "урбан": 1,
    "уриах": 1,
    "устин": 1,
    "уэйн": 1,
    "уэсли": 1,
    "фабиан": 1,
    "фаддей": 1,
    "фадей": 1,
    "фалк": 1,
    "фарид": 1,
    "фарлей": 1,
    "фарон": 1,
    "фарран": 1,
    "февралин": 1,
    "федор": 1,
    "федосий": 1,
    "фелан": 1,
    "фелиз": 1,
    "феликс": 1,
    "фелим": 1,
    "фелис": 1,
    "фентон": 1,
    "феодосий": 1,
    "феофан": 1,
    "ферги": 1,
    "фергус": 1,
    "ферд": 1,
    "ферди": 1,
    "фердинанд": 1,
    "фернан": 1,
    "фернанд": 1,
    "фестер": 1,
    "фестус": 1,
    "фидель": 1,
    "фидо": 1,
    "фил": 1,
    "филайп": 1,
    "филандр": 1,
    "филарет": 1,
    "филат": 1,
    "филберт": 1,
    "филимон": 1,
    "филип": 1,
    "филипп": 1,
    "фило": 1,
    "финикс": 1,
    "финис": 1,
    "флегонт": 1,
    "флемминг": 1,
    "флечер": 1,
    "флинн": 1,
    "флинт": 1,
    "флойд": 1,
    "флорентий": 1,
    "флоренц": 1,
    "флорин": 1,
    "флорри": 1,
    "флурри": 1,
    "фок": 1,
    "фокс": 1,
    "фома": 1,
    "фонз": 1,
    "фонзи": 1,
    "форбес": 1,
    "форд": 1,
    "форест": 1,
    "форрест": 1,
    "фостер": 1,
    "фот": 1,
    "фотий": 1,
    "фоук": 1,
    "фразир": 1,
    "франклин": 1,
    "франц": 1,
    "фред": 1,
    "фредди": 1,
    "фредерик": 1,
    "фредрик": 1,
    "фрейзер": 1,
    "фрейзр": 1,
    "фридрих": 1,
    "фримэн": 1,
    "фритс": 1,
    "фродо": 1,
    "фрол": 1,
    "фрэнк": 1,
    "фрэнки": 1,
    "фрэнклин": 1,
    "фрэнс": 1,
    "фрэнсис": 1,
    "фёдор": 1,
    "хавелок": 1,
    "хадвин": 1,
    "хадлей": 1,
    "хал": 1,
    "хам": 1,
    "хамиш": 1,
    "хамлет": 1,
    "хаммонд": 1,
    "ханк": 1,
    "ханлей": 1,
    "хантер": 1,
    "харв": 1,
    "харви": 1,
    "харди": 1,
    "хардинг": 1,
    "харитон": 1,
    "харкоерт": 1,
    "харлан": 1,
    "харланд": 1,
    "харлей": 1,
    "харлин": 1,
    "хармон": 1,
    "харпер": 1,
    "харрис": 1,
    "харрисон": 1,
    "хартлей": 1,
    "хауелл": 1,
    "хедлей": 1,
    "хек": 1,
    "хендерсон": 1,
    "хендрик": 1,
    "хенрай": 1,
    "хенри": 1,
    "херб": 1,
    "херби": 1,
    "хервей": 1,
    "херлей": 1,
    "хиацинт": 1,
    "хилари": 1,
    "хиллэри": 1,
    "хирам": 1,
    "хис": 1,
    "хитклифф": 1,
    "хию": 1,
    "хоард": 1,
    "хоб": 1,
    "ходдж": 1,
    "хойт": 1,
    "холден": 1,
    "холл": 1,
    "холлис": 1,
    "хомер": 1,
    "хопкин": 1,
    "хорас": 1,
    "хоратайо": 1,
    "хоуи": 1,
    "храбр": 1,
    "христоф": 1,
    "христофор": 1,
    "худд": 1,
    "хуей": 1,
    "хует": 1,
    "хукк": 1,
    "хукслей": 1,
    "хумберт": 1,
    "хунтлей": 1,
    "хуффи": 1,
    "хью": 1,
    "хьюберт": 1,
    "хьюго": 1,
    "хьюи": 1,
    "хэвен": 1,
    "хэдлей": 1,
    "хэйвуд": 1,
    "хэйден": 1,
    "хэйл": 1,
    "хэмфри": 1,
    "хэппи": 1,
    "хюи": 1,
    "цезарь": 1,
    "чад": 1,
    "чадвик": 1,
    "чаз": 1,
    "чак": 1,
    "чакки": 1,
    "чарлз": 1,
    "чарли": 1,
    "чарлтон": 1,
    "чарльз": 1,
    "час": 1,
    "чейз": 1,
    "чендлер": 1,
    "ченс": 1,
    "черокез": 1,
    "чеслав": 1,
    "честер": 1,
    "чеьянн": 1,
    "чип": 1,
    "чонки": 1,
    "чонси": 1,
    "ша": 1,
    "шад": 1,
    "шаи": 1,
    "шайенн": 1,
    "шакуилл": 1,
    "шамиль": 1,
    "шамус": 1,
    "шан": 1,
    "шаннен": 1,
    "шаннон": 1,
    "шау": 1,
    "шеврон": 1,
    "шелби": 1,
    "шелдон": 1,
    "шеллей": 1,
    "шелтон": 1,
    "шем": 1,
    "шервуд": 1,
    "шеридан": 1,
    "шерлок": 1,
    "шерман": 1,
    "ши": 1,
    "шилох": 1,
    "шимус": 1,
    "шмидт": 1,
    "шолто": 1,
    "шон": 1,
    "шэй": 1,
    "шэйн": 1,
    "эбби": 1,
    "эбен": 1,
    "эбенезер": 1,
    "эвальд": 1,
    "эван": 1,
    "эвелин": 1,
    "эверард": 1,
    "эверетт": 1,
    "эверитт": 1,
    "эвот": 1,
    "эгберт": 1,
    "эд": 1,
    "эдан": 1,
    "эдвард": 1,
    "эдвин": 1,
    "эдгар": 1,
    "эдди": 1,
    "эдип": 1,
    "эдисон": 1,
    "эдмонд": 1,
    "эдмунд": 1,
    "эдон": 1,
    "эдуард": 1,
    "эдун": 1,
    "эзраа": 1,
    "эзэлстан": 1,
    "эзэлуолф": 1,
    "эйб": 1,
    "эйби": 1,
    "эйвери": 1,
    "эйден": 1,
    "эйлберт": 1,
    "эйлвард": 1,
    "эймерей": 1,
    "эймери": 1,
    "эйнар": 1,
    "эйнслей": 1,
    "эйнсли": 1,
    "эйс": 1,
    "элайотт": 1,
    "элбан": 1,
    "элвин": 1,
    "элвис": 1,
    "элвуд": 1,
    "элгар": 1,
    "элдвен": 1,
    "элдвин": 1,
    "элден": 1,
    "элджер": 1,
    "элдин": 1,
    "элдис": 1,
    "элдон": 1,
    "элдред": 1,
    "элдус": 1,
    "электрон": 1,
    "эли": 1,
    "элиас": 1,
    "элиджа": 1,
    "элиот": 1,
    "элла": 1,
    "эллгар": 1,
    "эллджер": 1,
    "эллери": 1,
    "эллиот": 1,
    "эллис": 1,
    "элмер": 1,
    "элрик": 1,
    "элрой": 1,
    "элсдон": 1,
    "эль": 1,
    "эльберт": 1,
    "эльбрус": 1,
    "эльдар": 1,
    "эльмар": 1,
    "эльмир": 1,
    "эльтон": 1,
    "эмерсон": 1,
    "эмилиан": 1,
    "эмилий": 1,
    "эмиль": 1,
    "эммануель": 1,
    "эммануил": 1,
    "эммерсон": 1,
    "эммет": 1,
    "эмметт": 1,
    "эмори": 1,
    "эмэри": 1,
    "энвер": 1,
    "энгель": 1,
    "энджелберт": 1,
    "энди": 1,
    "эндрю": 1,
    "энергий": 1,
    "энтони": 1,
    "эразм": 1,
    "эраст": 1,
    "эрван": 1,
    "эрвин": 1,
    "эрг": 1,
    "эрек": 1,
    "эрий": 1,
    "эрик": 1,
    "эрих": 1,
    "эрл": 1,
    "эрлен": 1,
    "эрн": 1,
    "эрнест": 1,
    "эрни": 1,
    "эрнст": 1,
    "эрон": 1,
    "эррол": 1,
    "эрролл": 1,
    "этан": 1,
    "этелберт": 1,
    "этелред": 1,
    "этелрик": 1,
    "этелхард": 1,
    "эшли": 1,
    "эюзби": 1,
    "ювеналий": 1,
    "юджин": 1,
    "юлиан": 1,
    "юлий": 1,
    "юлиус": 1,
    "юм": 1,
    "юниор": 1,
    "юпитер": 1,
    "юрий": 1,
    "юстас": 1,
    "юстин": 1,
    "яков": 1,
    "ян": 1,
    "янкей": 1,
    "янки": 1,
    "януарий": 1,
    "ярвуд": 1,
    "яромир": 1,
    "ярополк": 1,
    "ярослав": 1
  }, exports.ruBindingWords = [ "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "пота", "потому", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "тож", "только", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы", "а-ля", "без", "безо", "благодаря", "близ", "в", "ввиду", "вглубь", "вдоль", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "во", "возле", "вокруг", "вопреки", "впереди", "вразрез", "вроде", "вслед", "вследствие", "для", "до", "за", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "к", "ко", "кроме", "кругом", "меж", "между", "мимо", "на", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду", "насупротив", "насчёт", "не", "ниже", "о", "об", "обо", "обок", "около", "окромя", "округ", "от", "относительно", "ото", "перед", "передо", "по", "по-за", "по-над", "поверх", "под", "подле", "подо", "подобно", "позади", "помимо", "поперёк", "порядка", "посередине", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "применительно", "про", "против", "путём", "ради", "с", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "со", "согласно", "спустя", "среди", "средь", "сродни", "судя", "супротив", "у", "через", "чрез", "иже", "какой-либо", "какой-то", "кое-кто", "кой", "кто", "кто-либо", "многий", "мя", "насколько", "немногий", "нещечко", "никой", "ничегошеньки", "се", "сё", "такой-то", "тот-то", "чё", "чево", "чей-либо", "чей-нибудь", "чей-то", "шо", "эта", "кем", "ком", "кому", "нахуя", "чей", "чему", "вам", "вами", "вас", "вы", "Вы", "ее", "её", "его", "ей", "ему", "ею", "им", "ими", "их", "меня", "мне", "мной", "мною", "мы", "нём", "нем", "нам", "нами", "неё", "него", "ней", "нему", "нею", "ним", "ними", "них", "он", "она", "оне", "они", "оно", "тебе", "тебя", "тобой", "тобою", "ты", "я", "иной", "кое-какой", "кое-чей", "кое-что", "кой-какой", "кой-кто", "кто-нибудь", "кто-то", "куда-нибудь", "некто", "нечто", "что-либо", "что-нибудь", "что-то", "весь", "всякий", "любой", "сам", "самый", "таков", "этакий", "другой", "некем", "некому", "нечего", "нечем", "нечему", "никакой", "никто", "ничего", "ничей", "ничем", "ничему", "ничто", "ваш", "ихний", "моё", "мой", "моя", "наш", "свой", "твой", "оный", "сей", "сие", "сии", "сия", "та", "такой", "тот", "ту", "эдакий", "эти", "это", "этот", "ась", "аюшки", "таки", "а", "авось-либо", "ага", "аминь", "б", "бишь", "буквально", "бы", "было", "вишь", "вон", "вот", "вот-вот", "вряд", "всего", "давай", "де", "действительно", "дескать", "добро", "довольно", "ещё", "исключительно", "ить", "ишь", "ка", "кажется", "конечно", "ладно", "лих", "лучше", "мол", "навряд", "наоборот", "небось", "нет", "неужели", "нехай", "никак", "ну", "ну-с", "по-видимому", "пожалуй", "пожалуйста", "полно", "положительно", "предовольно", "простите", "просто-напросто", "пускай", "разумеется", "сём-ка", "сем", "скорее", "спасибо", "так", "то-то", "тоже", "уж", "уже", "ужели", "ужли", "фон", "хорошо", "эдак", "эк", "этак" ];
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.words = {}, exports = window.lastName.plugins.ru.words) : exports = module.exports, function(exports) {
  return exports.adverbs = [ "абсолютно", "адски", "азартно", "активно", "аспидно", "баснословно", "бдительно", "безапелляционно", "безбожно", "безвозвратно", "безгранично", "безжалостно", "беззаветно", "беззастенчиво", "безмерно", "безмятежно", "безнадежно", "безоговорочно", "безраздельно", "безропотно", "безудержно", "безукоризненно", "безумно", "безупречно", "безусловно", "безустанно", "безутешно", "бескомпромиссно", "бесконечно", "беспардонно", "бесповоротно", "беспощадно", "беспредельно", "беспрекословно", "бесследно", "бессовестно", "бесстыдно", "бесчеловечно", "бешено", "бурно", "вдребезги", "вконец", "вовсю", "всемерно", "всесторонне", "всецело", "всячески", "высоко", "глубоко", "горько", "горячо", "грубо", "густо", "диаметрально", "дико", "досконально", "досыта", "дотошно", "дьявольски", "жарко", "жгуче", "железно", "жестко", "жестоко", "живо", "жизненно", "жутко", "запоем", "запредельно", "зверски", "здорово", "злостно", "идеально", "излишне", "изрядно", "изумительно", "исключительно", "исступленно", "истово", "истошно", "исчерпывающе", "кардинально", "катастрофически", "категорически", "клятвенно", "колоссально", "крайне", "крепко", "кристально", "кровно", "крупно", "круто", "люто", "максимально", "мертвецки", "мучительно", "навзрыд", "нагло", "наглухо", "наглядно", "наголову", "надежно", "надрывно", "назубок", "намертво", "наотрез", "напрочь", "нарочито", "насквозь", "настоятельно", "насущно", "начисто", "небывало", "невероятно", "невиданно", "невообразимо", "невыносимо", "невыразимо", "недопустимо", "неизмеримо", "неимоверно", "неистово", "немилосердно", "немыслимо", "необыкновенно", "необычайно", "неописуемо", "неопровержимо", "непомерно", "непоправимо", "непостижимо", "непримиримо", "непробудно", "непроходимо", "неразрывно", "несказанно", "неслыханно", "несметно", "несравненно", "нестерпимо", "неудержимо", "неузнаваемо", "неуклонно", "неукоснительно", "неустанно", "неусыпно", "неутешно", "неутомимо", "нещадно", "оглушительно", "ожесточенно", "ослепительно", "основательно", "остро", "откровенно", "открыто", "отлично", "отменно", "отчаянно", "очень", "панически", "патологически", "пламенно", "плотно", "по-настоящему", "по-собачьи", "подлинно", "подчеркнуто", "позарез", "поистине", "полностью", "поразительно", "порядком", "порядочно", "потрясающе", "предельно", "прекрасно", "преступно", "прилично", "примитивно", "принципиально", "приторно", "пронзительно", "радикально", "разительно", "редкостно", "резко", "рекордно", "свято", "серьезно", "сильно", "слепо", "смертельно", "совершенно", "совсем", "страстно", "страшно", "строго", "строго-настрого", "существенно", "твердо", "тяжело", "тяжко", "убийственно", "удивительно", "ужасающе", "ужасно", "фанатически", "фанатично", "фантастически", "феноменально", "хорошенько", "хорошо", "чертовски", "чрезвычайно", "чрезмерно", "чудовищно", "широко", "шумно", "щедро", "ярко", "яростно" ], exports.unions = [ "а", "а именно", "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "все-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как бы", "как то", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "после того как", "пота", "потому", "потому как", "потому что", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "то есть", "тож", "только", "только что", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы" ], exports.prepositionAll = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо", "включая", "невзирая на", "несмотря на", "по", "по-за", "про", "с", "сквозь", "со", "спустя", "через", "чрез", "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по", "при", "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "среди", "средь", "супротив", "у", "в связи с", "в соответствии с", "вслед за", "лицом к лицу с", "над", "надо", "наряду с", "перед", "передо", "по сравнению с", "по-над", "пред", "предо", "рядом с", "следом за" ], exports.prepositionSimple = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionAcusative = [ "в", "включая", "во", "за", "на", "не в", "не за", "невзирая на", "несмотря на", "о", "об", "обо", "по", "по-за", "под", "подо", "про", "с", "сквозь", "со", "спустя", "через", "чрез" ], exports.prepositionDative = [ "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по" ], exports.prepositionPrepositional = [ "в", "во", "на", "не в", "о", "об", "обо", "по", "при" ], exports.prepositionGenetive = [ "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "меж", "между", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "со", "среди", "средь", "супротив", "у" ], exports.prepositionInstrumental = [ "в связи с", "в соответствии с", "вслед за", "за", "лицом к лицу с", "меж", "между", "над", "надо", "наряду с", "не за", "перед", "передо", "по сравнению с", "по-над", "под", "подо", "пред", "предо", "рядом с", "с", "следом за", "со" ], exports.prepositionWithSingleCase = [ "без", "без ведома", "безо", "благодаря", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в связи с", "в силу", "в соответствии с", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "вдоль по", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "вопреки", "впереди", "впредь до", "вроде", "вслед", "вслед за", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "к", "ко", "кроме", "кругом", "лицом к", "лицом к лицу с", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду с", "насупротив", "насчёт", "начиная с", "не без", "не считая", "невзирая на", "недалеко от", "независимо от", "несмотря на", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "перед", "передо", "по линии", "по мере", "по направлению к", "по отношению к", "по поводу", "по причине", "по случаю", "по сравнению с", "по-за", "по-над", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "подобно", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "при помощи", "применительно к", "про", "против", "путём", "ради", "рядом с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "согласно", "спустя", "среди", "средь", "сродни", "судя по", "супротив", "у", "через", "чрез" ], exports.prepositionWith2Cases = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionWith3Cases = [ "по", "с", "со" ];
}(exports);

var exports, ref, util, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.dates = {}, exports = window.lastName.plugins.ru.dates, ref = window.lastName.plugins.ru.ref, util = window.lastName.util) : (exports = module.exports, ref = require("./ref"), util = require("../../util")), function(exports, util, ref) {
  var dateObjectToString, extractDates, getRuMonthIndex, getValidDate, packDates, packIntervals, ruMonthInDates;
  return ruMonthInDates = [ "января", "февраля", "марта", "аперля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря" ], dateObjectToString = function(dateObj) {
    var d, m, y, _ref;
    return y = ((_ref = typeof dateObj.y) === "number" || _ref === "string") && dateObj.y || "", m = dateObj.m + 1, m = m > 9 && m || "0" + m, d = dateObj.d > 9 && dateObj.d || "0" + dateObj.d, "" + d + "." + m + "." + y;
  }, getValidDate = function(dateObj) {
    var defaultYear, dt;
    defaultYear = dateObj.y;
    if (void 0 === dateObj.y || dateObj.y < 1970 || dateObj.y > 2038) dateObj.y = 2e3;
    return dt = new Date(Date.UTC(dateObj.y, dateObj.m, dateObj.d)), dt.getMonth() === dateObj.m && dt.getDate() === dateObj.d ? (dateObj.y = defaultYear, dateObj) : null;
  }, getRuMonthIndex = function(str) {
    var m;
    return m = str.toLowerCase().match(/(\s|^)(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s|$)/g), m ? ruMonthInDates.indexOf(m[0].replace(/\s/g, "")) : -1;
  }, exports.extractDates = extractDates = function(strArr) {
    var dates, intervals, sources;
    return dates = {}, sources = [], intervals = {}, strArr instanceof Array || (strArr = [ strArr ]), strArr.map(function(str) {
      var dStr, date, found, from, fromDate, fromMonth, fromYear, id, intObject, mIndex, sourceStr, to, toDate, toYear, verboseMatch, wordsArr, _ref, _results;
      verboseMatch = str.match(/\s+\d{1,2}\s+((января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)\s+|)(\d{2,4}(\s+года|)\s+|)по\s+\d{1,2}\s+(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s+\d{2,4}|)(\s+|$)/mig);
      if (!verboseMatch) {
        wordsArr = str.split(" "), found = !1, _results = [];
        while (wordsArr.length > 2 && !found) /^\d[\d]$/.test(wordsArr[0]) && (mIndex = ruMonthInDates.indexOf(wordsArr[1].toLowerCase()), mIndex >= 0 ? (date = {
          d: parseInt(wordsArr[0], 10),
          m: mIndex
        }, /^\d{2,4}$/.test(wordsArr[2]) ? (date.y = parseInt(wordsArr[2], 10), sourceStr = wordsArr.slice(0, 3).join(" ")) : sourceStr = wordsArr.slice(0, 2).join(" ")) : /^\d\d\.\d\d.\d{2,4}$/.test(wordsArr[0] || /^\d\d\.\d\d$/.test(wordsArr[0])) ? (date = {
          d: parseInt(wordsArr[0].slice(0, 3), 10),
          m: parseInt(wordsArr[0].slice(3, 6), 10),
          y: parseInt(wordsArr[0].slice(6), 10) || void 0
        }, sourceStr = wordsArr[0]) : date = {}, date = getValidDate(date), date && (found = !0, sources.push(sourceStr), dStr = dateObjectToString(date), dates[dStr] ? dates[dStr].count++ : dates[dStr] = {
          count: 1,
          value: date
        })), _results.push(wordsArr.shift());
        return _results;
      }
      _ref = verboseMatch[0].toLowerCase().split("по"), from = _ref[0], to = _ref[1], toYear = to.replace(/\d{1,2}/, "").match(/\d+/g), toYear ? toYear = parseInt(toYear[0], 10) : toYear = void 0, toDate = {
        d: parseInt(to.match(/\d{1,2}/g)[0], 10),
        m: getRuMonthIndex(to),
        y: toYear
      }, fromYear = from.replace(/\d{1,2}/, "").match(/\d+/g), fromMonth = getRuMonthIndex(from), fromYear ? fromYear = parseInt(fromYear[0], 10) : fromYear = toYear, fromMonth === -1 && (fromMonth = toDate.m), fromDate = {
        d: parseInt(from.match(/\d{1,2}/g)[0], 10),
        m: fromMonth,
        y: fromYear
      }, toDate = getValidDate(toDate), fromDate = getValidDate(fromDate);
      if (toDate && fromDate) return intObject = {
        from: dateObjectToString(fromDate),
        from_value: fromDate,
        to: dateObjectToString(toDate),
        to_value: toDate
      }, id = "" + intObject.from + "-" + intObject.to, intervals[id] ? intervals[id].count++ : (intObject.count = 1, intervals[id] = intObject), sources.push(verboseMatch[0]);
    }), {
      dates: dates,
      sources: sources,
      intervals: intervals
    };
  }, exports.packDates = packDates = function(dates, defaultYear) {
    var dateObj, id, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in dates) dateObj = dates[id], "undefined" != typeof dateObj.value.y && years.push(dateObj.value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in dates) dateObj = dates[id], "undefined" == typeof dateObj.value.y && (dateObj.value.y = defaultYear), out["" + dateObjectToString(dateObj.value)] = dateObj.count;
    return out;
  }, exports.packIntervals = packIntervals = function(intervals, defaultYear) {
    var id, interval, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in intervals) interval = intervals[id], "undefined" != typeof interval.from_value.y && years.push(interval.from_value.y), "undefined" != typeof interval.to_value.y && years.push(interval.to_value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in intervals) interval = intervals[id], "undefined" == typeof interval.from_value.y && (interval.from_value.y = defaultYear), "undefined" == typeof interval.to_value.y && (interval.to_value.y = defaultYear), out["" + dateObjectToString(interval.from_value) + "-" + dateObjectToString(interval.to_value)] = interval.count;
    return out;
  }, exports.preFilter = function(text, result) {
    var dates, numRe;
    numRe = /((([а-яё]+)\s+){0,1}\d[\.\d]{0,}(\s+(([a-яё]+)|([\.\d]+))){1,6})|([12]\d\d\d)/mig, dates = extractDates(util.unique(text.match(numRe) || [])), util.dictKeys(dates.dates).length > 0 && (result.dates = packDates(dates.dates)), util.dictKeys(dates.intervals).length > 0 && (result.intervals = packIntervals(dates.intervals));
    if (dates.sources.length > 0) return result.date_sources = dates.sources;
  };
}(exports, util, ref);

var exports, ref, util, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.inclines = {}, exports = window.lastName.plugins.ru.inclines, util = window.lastName.util, ref = window.lastName.plugins.ru.ref) : (exports = module.exports, util = require("../../util"), ref = require("./ref")), function(exports, util, ref) {
  var cases, doInclineFemaleName, doInclineMaleName, findProperName, genderMatch, getNominative, inclineAndGetResult, inclineFemMiddleName, inclineFemaleName, inclineFemaleNameAndGetResult, inclineFemaleSurname, inclineMaleMiddleName, inclineMaleName, inclineMaleNameAndGetResult, inclineMaleSurname, inclineMiddleName, inclineMiddleNameOrSurname, inclineName, inclinePersonSurname, inclineSurname, matchCase, matchNameAndSurname, matchNameParts;
  return cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ], exports.doInclineFemaleName = doInclineFemaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, aUnstressedRe, name2;
    return aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, aUnstressedRe = /ца$/g, name2 = name.slice(0, -1), aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aUnstressedRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ей", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /ия$/g.test(name) && name.length > 3 ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "и" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ь", "" + name2 + "ью", "" + name2 + "и" ] : /[жшщцч]$/g.test(name) ? [ "" + name, "" + name + "и", "" + name + "и", "" + name, "" + name + "ью", "" + name + "и" ] : [ name, name, name, name, name, name ];
  }, exports.doInclineMaleName = doInclineMaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, hardConsonants, hissingAndChe, ishortRe, name2;
    return hardConsonants = /[бвгдзклмнпрстфх]$/g, hissingAndChe = /[жшщцч]$/g, ishortRe = /((ай)|(ей)|(ой)|(уй)|(яй)|(юй)|(ий))$/g, aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, name2 = name.slice(0, -1), name === "Лев" ? [ "Лев", "Льва", "Льву", "Льва", "Львом", "Льве" ] : name === "Павел" ? [ "Павел", "Павла", "Павлу", "Павла", "Павлом", "Павле" ] : /и$/g.test(name) ? [ name, name, name, name, name, name ] : hissingAndChe.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ем", "" + name + "е" ] : hardConsonants.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ом", "" + name + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : ishortRe.test(name) ? [ "" + name2 + "й", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ко$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /о$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : null;
  }, inclineAndGetResult = function(fn, args) {
    var i, name, r;
    r = null;
    for (i in args) {
      name = args[i], r = fn(name, !0);
      if (r.found) break;
    }
    return r;
  }, inclineFemaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineFemaleName, arguments);
  }, inclineMaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineMaleName, arguments);
  }, exports.inclineFemaleName = inclineFemaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name3, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), nl = name.toLowerCase(), nominativeRe = /[адежзийклмнорстуьэя]$/g, canInclineRe = /[жшщцчаяь]$/g, genitiveRe = /[иы]$/g, dativeRe = /[еи]$/g, accusativeRe = /[жшщцчьую]$/g, instrumentalRe = /((ой)|(ей)|(еи)|(ью))$/g, prepositionalRe = /[еи]$/g, result = r = null, nominativeRe.test(nl) && ref.ruFemaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineFemaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "female",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name2 = name.slice(0, -1), name_cases = [], genitiveRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("dative"))), prepositionalRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("prepositional"))), accusativeRe.test(nl) && (/[ую]$/g.test(nl) ? r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а") : r = inclineFemaleNameAndGetResult(name), r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (name3 = name.slice(0, -2), r = inclineFemaleNameAndGetResult("" + name3 + "я", "" + name3 + "а", "" + name3 + "ь", "" + name3), r && r.found && (result = r, name_cases.push("instrumental"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineMaleName = inclineMaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), name === "Льв" && (name = "Лев"), name === "Павл" && (name = "Павел"), nl = name.toLowerCase(), nominativeRe = /([вгдзклмнпрстфхжшцьй]|(ба)|(ва)|(да)|(за)|(ла)|(ма)|(на)|(па)|(ра)|(са)|(та)|(фа)|(га)|(ка)|(ха)|(жа)|(ша)|(ща)|(ца)|(ча)|(я)|(ло)|(ко))$/g, canInclineRe = /([бвгдзклмнпрстфхжшцьая]|(ия)|(ья)|(ея)|(ий)|(ей))$/g, genitiveRe = /[аяыи]$/g, dativeRe = /(([еую])|(ии))$/g, accusativeRe = /[аяую]$/g, instrumentalRe = /((ом)|(ем)|(ой)|(ей)|(ёй))$/g, prepositionalRe = /((е)|(ии))$/g, name2 = name.slice(0, -1), result = r = null, nominativeRe.test(nl) && ref.ruMaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineMaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "male",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name_cases = [], genitiveRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /ы$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "о", "" + name2 + "а") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "а", "" + name.slice(0, -1) + "я", "" + name.slice(0, -1) + "о") : r = null, r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (/у$/g.test(nl) ? r = inclineMaleName(name2) : /[аеиоуя]ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "й") : /ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "ь") : /е$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "и", "" + name2 + "я", "" + name2 + "o") : /ии$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я") : r = null, r && r.found && (result = r, name_cases.push("dative"))), accusativeRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /у$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а") : /[ую]$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : r = null, r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (/ом$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2)) : /ем$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2), "" + name.slice(0, -2) + "ь", "" + name.slice(0, -2) + "й") : /ой$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "а", "" + name.slice(0, -2) + "о") : /((ей)|(ёй))$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "я", "" + name.slice(0, -2) + "а") : r = null, r && r.found && (result = r, name_cases.push("instrumental"))), prepositionalRe.test(nl) && (/е$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2, "" + name2 + "ь", "" + name2 + "й", "" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я", "" + name2 + "й") : r = null, r && r.found && (result = r, name_cases.push("prepositional"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineName = inclineName = function(name) {
    var fn, mn, result;
    return fn = inclineFemaleName(name), mn = inclineMaleName(name), fn.found ? result = {
      found: !0,
      src: name,
      gender: "female",
      guess_case: fn.guess_case,
      female_cases: fn.cases,
      possible_cases: fn.possible_cases,
      nominative: fn.nominative
    } : mn.found ? result = {
      found: !0,
      src: name,
      gender: "male",
      guess_case: mn.guess_case,
      male_cases: mn.cases,
      possible_cases: mn.possible_cases,
      nominative: mn.nominative
    } : fn.possible_yes && mn.possible_yes ? (result = {
      found: "maybe",
      src: name,
      gender: [ "male", "female" ],
      female_cases: fn.cases,
      male_cases: mn.cases,
      possible_cases: util.merge(fn.possible_cases, mn.possible_cases)
    }, result.guess_case = fn.guess_case_index <= mn.guess_case_index ? fn.guess_case : mn.guess_case) : fn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "female",
      female_cases: fn.cases,
      guess_case: fn.cases,
      possible_cases: fn.possible_cases
    } : mn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "male",
      male_cases: mn.cases,
      guess_case: mn.cases,
      possible_cases: mn.possible_cases
    } : result = {
      found: !1,
      src: name
    }, result;
  }, inclineSurname = function(surname, noInclinesRe, inclineRe, casesRe) {
    var c, cases_index, check, i, result, surname_cases, _i, _j, _len, _len2;
    result = {
      found: null,
      src: surname,
      cases: null,
      cases_index: null
    };
    if (noInclinesRe && noInclinesRe.test(surname)) result = {
      found: surname,
      src: surname,
      cases: [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ],
      cases_index: [ 0, 1, 2, 3, 4, 5 ]
    }; else for (_i = 0, _len = inclineRe.length; _i < _len; _i++) {
      check = inclineRe[_i];
      if (check[0].test(surname)) {
        result = {
          found: surname.replace(check[0], check[1]),
          src: surname
        }, cases_index = [], surname_cases = [], i = 0;
        for (_j = 0, _len2 = casesRe.length; _j < _len2; _j++) c = casesRe[_j], c.test(surname) && (cases_index.push(i), surname_cases.push(cases[i])), i++;
        surname_cases.length === 0 ? (result.found = null, result.cases = null) : result.cases = surname_cases, result.cases_index = cases_index;
        break;
      }
    }
    return result.surname_cases && (result.guess_case = result.surname_cases[0]), result;
  }, exports.inclineFemaleSurname = inclineFemaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(е)|(о)|(э)|(и)|(ы)|(^[нв]у)|(^ую)|(уа)|(иа)|(ман)|(вич)|(ян))$/g, inclineRe = [ [ /((ова)|(овой)|(ову))$/g, "ова" ], [ /((ева)|(евой)|(еву))$/g, "ева" ], [ /((ёва)|(ёвой)|(ёву))$/g, "ёва" ], [ /((ина)|(иной)|(ину))$/g, "ина" ], [ /((ая)|(ой)|(ую))$/g, "ая" ] ], casesRe = [ /((ова)|(ева)|(ёва)|(ина)|(ая))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((ову)|(еву)|(ёву)|(ину)|(ую))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, exports.inclineMaleSurname = inclineMaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(^ве)|(^го)|(э)|(и)|(ы)|(^му)|(ю)|(уа)|(иа))$/g, inclineRe = [ [ /((ов)|(ова)|(ову)|(овым)|(ове))$/g, "ов" ], [ /((ев)|(ева)|(еву)|(евым)|(еве))$/g, "ев" ], [ /((ёв)|(ёва)|(ёву)|(ёвым)|(ёве))$/g, "ёв" ], [ /((ин)|(ина)|(ину)|(иным)|(ине))$/g, "ин" ], [ /((ский)|(ского)|(скому)|(ским)|(ском))$/g, "ский" ], [ /((ской)|(ского)|(скому)|(ским)|(ском))$/g, "ской" ], [ /((ман)|(мана)|(ману)|(маном)|(мане))$/g, "ман" ], [ /((ой)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ой" ], [ /((ий)|(ого)|(ому)|(ого)|(им)|(ом))$/g, "ий" ], [ /((ый)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ый" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ], [ /((ян)|(яна)|(яну)|(яна)|(яном)|(яне))$/g, "ян" ] ], casesRe = [ /((ов)|(ев)|(ёв)|(ин)|(ский)|(ской)|(ой)|(ий)|(ый)|(ман)|(ич)|(ян))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((ову)|(еву)|(ёву)|(ину)|(скому)|(ому)|(ману)|(ичу)|(яну))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((овым)|(евым)|(ёвым)|(иным)|(ским)|(им)|(ым)|(маном)|(ичем)|(яном))$/g, /((ове)|(еве)|(ёве)|(ине)|(ском)|(ом)|(мане)|(иче)|(яне))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, inclineMiddleNameOrSurname = function(src, fem, male) {
    var result, _ref;
    return fem.found === (_ref = male.found) && _ref === null ? result = {
      found: !1,
      src: src,
      value: null,
      gender: null
    } : fem.found && male.found ? (result = {
      found: !0,
      src: src,
      gender: [ "male", "female" ]
    }, result.nominative_male = male.found, result.nominative_female = fem.found, result.female_cases = fem.cases, result.male_cases = male.cases, fem.cases.length === 6 ? male.cases.length === 6 ? (result.guess_sex = "unknown", result.possible_cases = util.merge(fem.cases, male.cases)) : (result.guess_sex = "male", result.nominative = male.found, result.possible_cases = male.cases) : fem.cases.length === 1 && male.cases.length > 1 ? (result.guess_sex = "female", result.nominative = fem.found, result.possible_cases = fem.cases) : result.possible_cases = util.merge(fem.cases, male.cases)) : fem.found ? male.found || (result = {
      found: !0,
      src: src,
      gender: "female",
      female_cases: fem.cases,
      guess_case: fem.guess_case,
      nominative: fem.found,
      possible_cases: fem.cases
    }) : result = {
      found: !0,
      src: src,
      gender: "male",
      male_cases: male.cases,
      guess_case: male.guess_case,
      nominative: male.found,
      possible_cases: male.cases
    }, result;
  }, exports.inclineSurname = inclinePersonSurname = function(surname) {
    return inclineMiddleNameOrSurname(surname, inclineFemaleSurname(surname), inclineMaleSurname(surname));
  }, exports.inclineMaleMiddleName = inclineMaleMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((евич)|(евича)|(евичу)|(евича)|(евичем)|(евиче))$/g, "евич" ], [ /((ович)|(овича)|(овичу)|(овича)|(овичем)|(овиче))$/g, "ович" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ] ], casesRe = [ /((евич)|(ович)|(ич))$/g, /((евича)|(овича)|(ича))$/g, /((евичу)|(овичу)|(ичу))$/g, /((евича)|(овича)|(ича))$/g, /((евичем)|(овичем)|(ичем))$/g, /((евиче)|(овиче)|(иче))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineFemMiddleName = inclineFemMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((вна)|(вны)|(вне)|(вну)|(вной)|(вне))$/g, "вна" ], [ /((чна)|(чны)|(чне)|(чну)|(чной)|(чне))$/g, "чна" ] ], casesRe = [ /((вна)|(чна))$/g, /((вны)|(чны))$/g, /((вне)|(чне))$/g, /((вну)|(чну))$/g, /((вной)|(чной))$/g, /((вне)|(чне))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineMiddleName = inclineMiddleName = function(mname) {
    return inclineMiddleNameOrSurname(mname, inclineFemMiddleName(mname), inclineMaleMiddleName(mname));
  }, genderMatch = function(g1, g2) {
    return g1 === g2 || __indexOf.call(g2, g1) >= 0 ? g1 : __indexOf.call(g1, g2) >= 0 ? g2 : null;
  }, matchNameParts = function(fn, mn, sn) {
    var overallGender, surname, theCase;
    return theCase = util.intersection(fn.possible_cases, mn.possible_cases), overallGender = genderMatch(genderMatch(fn.gender, mn.gender), sn.gender), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: mn.nominative,
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchNameAndSurname = function(fn, sn) {
    var overallGender, surname, theCase;
    return overallGender = genderMatch(fn.gender, sn.gender), theCase = util.intersection(fn.possible_cases, sn.possible_cases), theCase || (sn.possible_cases = sn["" + overallGender + "_cases"], sn.nominative = sn["nominative_" + overallGender], theCase = util.intersection(fn.possible_cases, sn.possible_cases)), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: "",
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchCase = function(pObj, target_case, gender) {
    return __indexOf.call(pObj["" + gender + "_cases"], target_case) >= 0;
  }, getNominative = function(pObj, gender) {
    var gnstr, nom;
    return gnstr = "nominative_" + gender, nom = pObj.nominative && pObj.nominative || pObj[gnstr], nom;
  }, exports.findProperName = findProperName = function(listOfWords, opts) {
    var mnr2, mnr3, nr1, nr2, nr3, result, sr1, sr2, sr3;
    opts == null && (opts = {}), result = {
      found: !1
    };
    switch (listOfWords.length) {
     case 1:
      result = inclineName(listOfWords[0]), result.found ? result.first_name = result.nominative : (result = inclinePersonSurname(listOfWords[0]), result.found && (result.surname = result.nominative));
      break;
     case 2:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr1.found && sr2.found && (result = matchNameAndSurname(nr1, sr2)), !result.found && sr1.found && nr2.found && (result = matchNameAndSurname(sr1, nr2));
      break;
     case 3:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), sr3 = inclinePersonSurname(listOfWords[2]), mnr2 = inclineMiddleName(listOfWords[1]), mnr3 = inclineMiddleName(listOfWords[2]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr3 = inclineName(listOfWords[2]), nr3.found ? result = {
        found: !1,
        error: "name at the end of 3-component proper name"
      } : nr1.found ? (mnr2.found && sr3.found && (result = matchNameParts(nr1, mnr2, sr3)), !result.found && sr2.found && (result = matchNameAndSurname(nr1, sr2))) : sr1.found && nr2.found && mnr3.found ? result = matchNameParts(nr2, mnr3, sr1) : nr2.found && sr3.found && (result = matchNameAndSurname(nr2, sr3));
    }
    return result.first_name || (result.first_name = ""), result.middle_name || (result.middle_name = ""), result.surname || (result.surname = ""), result.first_name || result.middle_name || result.surname || (result = {
      found: !1,
      error: "person not found"
    }), result.src = listOfWords.join(" "), result;
  }, exports.getInitialFormOfAdjective = function(adj) {
    var base;
    return adj = adj.toLowerCase(), /^[а-яё]{2,}(ая|ее|ие|ий|им|ими|их|ого|его|ое|ой|ом|ому|ою|ую|ые|ый|ым|ыми|ых|юю|яя)$/.test(adj) ? (/^[а-яё]{2,}(ими|ого|его|ому|ыми)$/gi.test(adj) ? base = adj.slice(0, -3) : base = adj.slice(0, -2), [ "" + base + "ый", "" + base + "ий", "" + base + "ой" ]) : null;
  }, exports.getVerbInfinitive = function(verb) {
    var pastTime, result, verbEnd;
    return verb = verb.toLowerCase(), /^[а-яё]{3,}(ать|аться|ить|иться|еть|еться|оть|оться|уть|утся|ются|ть|ться)$/.test(verb) ? verb : (/^[а-яё]{3,}(сь|ся)$/.test(verb) ? (verbEnd = verb.slice(-2), verb = verb.slice(0, -2)) : verbEnd = "", pastTime = verb.match(/^[а-яё]{3,}(л|ла|ло|ли)$/), pastTime ? result = verb.slice(0, -(1 + pastTime[1].length) + 1 || 9e9) + "ть" : /[а-яё]{3,}(у|ю|ем|ешь|ете|ет|ут|ют|им|ишь|ите|ит|ат|ят)$/.test(verb) && (/[а-яё]{3,}(ишь|ит|им|ите|ат|ят)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd ] : /[а-яё]{3,}(у|ю|ешь|ет|ем|ете|ут|ют)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd, "" + verb + "оть" + verbEnd, "" + verb + "уть" + verbEnd, "" + verb + "ть" + verbEnd ] : result = null), result);
  };
}(exports, util, ref);

var exports, ruWords, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.morpho = {}, exports = window.lastName.plugins.ru.morpho, ruWords = window.lastName.plugins.ru.words) : (exports = module.exports, ruWords = require("./words")), function(exports, ruWords) {
  var exceptions, getRulesAdjective, getRulesVerb, morphoRu;
  return exports.getWordRe = function() {
    return /^[а-я\-ё\d]+$/ig;
  }, exports.getAdjectiveEnds = function() {
    return {
      feminine: {
        ends: /((ая)|(ой)|(ую)|(яя)|(ей)|(юю))$/g,
        hard: /((ая)|(ой)|(ую))$/g,
        sort: /((яя)|(ей)|(юю))$/g,
        hardNominativeEnd: "ая",
        softNominativeEnd: "яя",
        gender: "feminine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ая" ? [ "" + word + "ая", "" + word + "ой", "" + word + "ой", "" + word + "ую", "" + word + "ой", "" + word + "ой" ] : [ "" + word + "яя", "" + word + "ей", "" + word + "ей", "" + word + "юю", "" + word + "ей", "" + word + "ей" ];
        }
      },
      masculine: {
        ends: /((ый)|(ого)|(ому)|(ым)|(ом)|(ий)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ый)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ий)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ый",
        softNominativeEnd: "ий",
        gender: "masculine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ый" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ий", "" + word + "ого", "" + word + "ому", "" + word + "ий", "" + word + "им", "" + word + "ом" ] : [ "" + word + "ый", "" + word + "ого", "" + word + "ому", "" + word + "ый", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ий", "" + word + "его", "" + word + "ему", "" + word + "ий", "" + word + "им", "" + word + "ем" ];
        }
      },
      neuter: {
        ends: /((ое)|(ого)|(ому)|(ым)|(ом)|(ее)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ое)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ее)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ое",
        softNominativeEnd: "ее",
        gender: "neuter",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ое" ? [ "" + word + "ое", "" + word + "ого", "" + word + "ому", "" + word + "ое", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ее", "" + word + "его", "" + word + "ему", "" + word + "ее", "" + word + "им", "" + word + "ем" ];
        }
      },
      plural: {
        ends: /((ые)|(ых)|(ым)|(ыми)|(ых)|(ие)|(их)|(им)|(ими)|(их))$/g,
        hard: /((ые)|(ых)|(ым)|(ыми)|(ых))$/g,
        soft: /((ие)|(их)|(им)|(ими)|(их))$/g,
        hardNominativeEnd: "ые",
        softNominativeEnd: "ие",
        gender: "unknown",
        singular: !1,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ые" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ] : [ "" + word + "ые", "" + word + "ых", "" + word + "ым", "" + word + "ые", "" + word + "ыми", "" + word + "ых" ] : [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ];
        }
      }
    };
  }, exceptions = function(word) {}, getRulesVerb = function() {
    return [ [ /нул[aи]{0,1}$/g, "ать" ], [ /еть$/g, "ать" ], [ /(ает)|(ают)$/g, "ать" ], [ /ал[aи]{0,1}$/g, "ать" ], [ /ул[aи]{0,1}$/g, "ать" ], [ /((ить)|(ать))$/g, "ать" ], [ /ая$/g, "ать" ], [ /((ил)|(или)|(ила)|(ило))$/g, "лять" ], [ /(ятся)|(ится)|(ился)|(илась)|(илось)$/g, "ится" ], [ /(яться)|(иться)$/g, "иться" ] ];
  }, getRulesAdjective = function() {
    return [ [ /в((ая)|(ые)|(ый)|(ое))$/, "вый" ], [ /((ая)|(ой)|(ие)|(ые)|(ый)|(ую))$/, "ый" ], [ /((яя)|(ее)|(ий)|(юю))$/, "ий" ] ];
  }, exports.morpho = morphoRu = function(word) {
    var adj, adjective, result, rule, verb, _i, _j, _len, _len2, _ref, _ref2;
    if (__indexOf.call(ruWords.adverbs, word) >= 0) return {
      type: "abverb",
      value: word
    };
    if (__indexOf.call(ruWords.prepositionAll, word) >= 0) return {
      type: "preposition",
      value: word
    };
    if (__indexOf.call(ruWords.unions, word) >= 0) return {
      type: "union",
      value: word
    };
    result = {
      type: "",
      value: ""
    }, verb = null, adjective = null, _ref = getRulesVerb();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      rule = _ref[_i];
      if (rule[0].test(word)) {
        result = {
          type: verb,
          value: word.replace(rule[0], rule[1])
        };
        break;
      }
    }
    _ref2 = getRulesAdjective();
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      rule = _ref2[_j];
      if (rule[0].test(word)) {
        adj = word.replace(rule[0], rule[1]), result.type ? (result.type += " adjective", result.value = [ result.value, adj ]) : result = {
          type: "adjective",
          value: adj
        };
        break;
      }
    }
    return result;
  }, exports.analyseText = function(text) {
    var doubleSpaceRe, enRe, punctuationRe, r, result, ruRe, t, wordRe, _i, _len, _ref;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&№“”\—]/g, doubleSpaceRe = /\s+/g, text = text.replace(punctuationRe, " $& ").replace(doubleSpaceRe, " ") + " .", result = [], _ref = text.split(" ");
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      t = _ref[_i], ruRe = /^[а-я\-ё]+$/ig, enRe = /^[a-z\-]+$/ig, wordRe = /^[а-яё\-\da-z]+$/ig, r = morphoRu(t.toLowerCase());
      switch (r.type) {
       case "adverb":
        result.push("[ADV " + t + "]");
        break;
       case "verb":
       case "adjective":
        result.push("[ " + r.value + " ]");
        break;
       case "verb adjective":
        result.push("[#VA " + r.value[0] + "]");
        break;
       case "union":
        result.push("[U " + t + "]");
        break;
       case "preposition":
        result.push("[PP " + t + "]");
        break;
       default:
        result.push(t);
      }
      t === "." && result.push("\n");
    }
    return result;
  }, exports.parseRuSentence = function(sentences) {
    var abbrevs, common_used_words, digits, regular_words, special_words, total_words;
    return sentences instanceof Array || (sentences = [ sentences ]), abbrevs = {}, special_words = {}, digits = {}, common_used_words = {}, regular_words = {}, total_words = 0, sentences.map(function(sent) {
      var i, result, w, word, words, _len, _ref, _results;
      words = sent.split(" "), _results = [];
      for (i = 0, _len = words.length; i < _len; i++) word = words[i], /^[[,:\/\\\?!\+\-\*\(\)\[\]\&\№\—]]+$/.test(words) || total_words++, /^(\d+(|(\.(|\d+))))$/.test(word) ? digits[word] ? _results.push(digits[word]++) : _results.push(digits[word] = 1) : isUpperCase(word) && /^[а-яё\-]{2,}$/i.test(word) ? abbrevs[word] ? _results.push(abbrevs[word]++) : _results.push(abbrevs[word] = 1) : i > 0 && isCapitalized(word) && /^[а-яё\-]{2,}$/i.test(word) ? special_words[word] ? _results.push(special_words[word]++) : _results.push(special_words[word] = 1) : /^[а-яё\-]+$/i.test(word) && !/^\-+$/.test(word) ? (w = word.toLowerCase(), result = morphoRu(w), (_ref = result.type) !== "adverb" && _ref !== "preposition" && _ref !== "union" ? regular_words[w] ? _results.push(regular_words[w]++) : _results.push(regular_words[w] = 1) : common_used_words[w] ? _results.push(common_used_words[w]++) : _results.push(common_used_words[w] = 1)) : _results.push(void 0);
      return _results;
    }), {
      abbrevs: abbrevs,
      common_used_words: common_used_words,
      special_words: special_words,
      regular_words: regular_words,
      digits: digits,
      total_words: total_words
    };
  };
}(exports, ruWords);

var exports, inclines, morpho, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.propernames = {}, exports = window.lastName.plugins.ru.propernames, morpho = window.lastName.plugins.ru.morpho, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, morpho = require("./morpho"), inclines = require("./inclines")), function(exports, morpho, inclines) {
  return exports.postFilter = function(text, result) {
    var curProperName, id, p, pn, pnDict, properNames, properNamesRe, punctuationRe, _i, _j, _len, _len2, _ref, _ref2;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&\№“”\—]/g, properNames = [], curProperName = [], properNamesRe = /[А-Я][а-яё]+(\s+[А-Я][а-яё]+){0,2}/gm, _ref = text.match(properNamesRe);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) pn = _ref[_i], curProperName = pn.replace(/\s+/g, " ").split(" "), curProperName && (pn = inclines.findProperName(curProperName), pn && pn.found && properNames.push(pn));
    pnDict = {};
    for (_j = 0, _len2 = properNames.length; _j < _len2; _j++) p = properNames[_j], id = "" + (p.first_name || "") + "-" + (p.middle_name || "") + "-" + (p.surname || ""), pnDict[id] ? (pnDict[id].count += 1, (_ref2 = p.src, __indexOf.call(pnDict[id].src, _ref2) < 0) && pnDict[id].src.push(p.src)) : (pnDict[id] = p, pnDict[id].src = [ p.src ], pnDict[id].count = 1);
    return result.propernames = pnDict;
  };
}(exports, morpho, inclines);

var exports, inclines, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName.plugins.ru.feelings = {}, exports = window.lastName.plugins.ru.feelings, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, inclines = require("./inclines")), function(exports, inclines) {
  var evaluateSentenceNeutrality, getNegativePhrasesRe, negativeAdjectives, negativeVerbs, negativeWordsIncline;
  return exports.positive = [], negativeAdjectives = {
    "агрессивный": 3,
    "атакованный": 2,
    "бедный": 2,
    "беззащитный": 2,
    "безнадежный": 3,
    "безрадостный": 2,
    "бесплодный": 3,
    "беспомощный": 3,
    "бесправный": 2,
    "бессердечный": 1,
    "бессильный": 1,
    "бесцельный": 2,
    "бесчестный": 2,
    "вздорный": 1,
    "виновный": 1,
    "ворчливый": 1,
    "враждебный": 2,
    "вспыльчивый": 1,
    "выпученный": 1,
    "выселенный": 3,
    "высмеянный": 2,
    "выхолощенный": 1,
    "глубокий": 1,
    "глупый": 2,
    "горький": 2,
    "готический": 2,
    "гротескный": 1,
    "грустный": 1,
    "грязный": 1,
    "девальвированный": 2,
    "деградировавший": 2,
    "дегуманизированный": 2,
    "дезорганизованный": 2,
    "дезориентированный": 2,
    "деморализованный": 3,
    "дерзкий": 1,
    "дерьмовый": 3,
    "дефектный": 3,
    "драматический": 3,
    "жалкий": 3,
    "жесткий": 2,
    "жестокосердный": 2,
    "заброшенный": 1,
    "забываемый": 1,
    "забывчивый": 1,
    "забытый": 2,
    "зависимый": 1,
    "заинтересованный": 1,
    "запрещенный": 3,
    "запутанный": 2,
    "застенчивый": 1,
    "застрявший": 1,
    "затравленный": 2,
    "зверский": 3,
    "злобный": 2,
    "идиотский": 3,
    "измельченный": 2,
    "измученный": 2,
    "изнасилованный": 3,
    "изолированный": 3,
    "изумленный": 1,
    "интенсивный": 1,
    "иррациональный": 2,
    "исключенный": 2,
    "искусственный": 2,
    "испуганный": 2,
    "истерический": 3,
    "исчерпанный": 2,
    "капризный": 2,
    "контролируемый": 1,
    "критический": 1,
    "ленивый": 2,
    "лишенный": 2,
    "ложный": 2,
    "мазохистский": 1,
    "мертвый": 3,
    "меченый": 2,
    "мрачный": 2,
    "мстительный": 2,
    "навязчивый": 2,
    "надоедливый": 2,
    "наказанный": 2,
    "нарушенный": 2,
    "натянутый": 2,
    "неадекватный": 2,
    "неактивный": 1,
    "небезопасный": 2,
    "небрежный": 1,
    "невежественный": 1,
    "невидимый": 1,
    "невротический": 2,
    "негуманный": 2,
    "недействительный": 1,
    "недовольный": 2,
    "недостаточный": 1,
    "недоуменный": 1,
    "незаземленный": 1,
    "незначительный": 1,
    "неискренний": 1,
    "некомпетентный": 2,
    "ненавистный": 3,
    "необщительный": 2,
    "неполный": 2,
    "неправильный": 2,
    "неприятный": 2,
    "нервный": 2,
    "нерешительный": 1,
    "несбалансированный": 1,
    "несовместимый": 2,
    "несоответствующий": 2,
    "неспособный": 3,
    "несчастный": 2,
    "неуклюжий": 2,
    "неуловимый": 1,
    "неуместный": 2,
    "нечестный": 2,
    "неэффективный": 2,
    "низкий": 1,
    "обвиняемый": 3,
    "обедненный": 1,
    "обезумевший": 3,
    "обиженный": 2,
    "обманутый": 2,
    "обозленный": 2,
    "оборонительный": 1,
    "обремененный": 1,
    "обременительный": 1,
    "обреченный": 2,
    "ограниченный": 1,
    "одержимый": 3,
    "одинокий": 2,
    "одноразовый": 1,
    "озабоченный": 2,
    "окаменелый": 1,
    "онемелый": 1,
    "опальный": 2,
    "опасный": 3,
    "опустошенный": 1,
    "опущенный": 2,
    "опьяненный": 1,
    "оскорбленный": 2,
    "осмеянный": 2,
    "острый": 1,
    "осужденный": 3,
    "осушенный": 2,
    "ответственный": 2,
    "отвратительный": 3,
    "отдаленный": 1,
    "отдельный": 1,
    "отрицательный": 2,
    "отсталый": 2,
    "отчаянный": 1,
    "ошибочный": 1,
    "параноидальный": 2,
    "паршивый": 2,
    "пассивный": 1,
    "переполненный": 2,
    "пессимистический": 2,
    "печальный": 2,
    "побежденный": 3,
    "поверхностный": 2,
    "поврежденный": 3,
    "подавленный": 2,
    "поддельный": 3,
    "покинутый": 2,
    "покорный": 1,
    "порабощенный": 3,
    "потерянный": 2,
    "потерпевший": 2,
    "потребленный": 1,
    "презираемый": 2,
    "презренный": 3,
    "презрительный": 2,
    "прерванный": 1,
    "принудительный": 2,
    "психотический": 2,
    "пустынный": 1,
    "пьяный": 2,
    "равнодушный": 1,
    "развращенный": 3,
    "раздраженный": 2,
    "раздражительный": 2,
    "разочарованный": 2,
    "разочаровывающий": 3,
    "разрушенный": 3,
    "разрушительный": 2,
    "разъяренный": 3,
    "раненый": 2,
    "ревнивый": 2,
    "садистский": 2,
    "самоубийственный": 3,
    "саркастический": 1,
    "сварливый": 1,
    "сгоревший": 3,
    "сердитый": 2,
    "серый": 1,
    "скучающий": 1,
    "скучный": 1,
    "сломанный": 2,
    "смущенный": 1,
    "созерцательный": 1,
    "сомнительный": 2,
    "спорный": 2,
    "спровоцированный": 2,
    "спутанный": 2,
    "спущенный": 2,
    "стереотипный": 1,
    "стесненный": 1,
    "странный": 1,
    "страшный": 2,
    "сумасшедший": 2,
    "тихий": 1,
    "тормозящий": 2,
    "торопливый": 2,
    "тоскливый": 3,
    "требовательный": 2,
    "тревожный": 2,
    "трудный": 2,
    "трусливый": 2,
    "тупой": 1,
    "тщеславный": 2,
    "угнетенный": 2,
    "угрюмый": 2,
    "удаляемый": 2,
    "удрученный": 2,
    "ужасный": 3,
    "уклончивый": 2,
    "униженный": 3,
    "унылый": 3,
    "урезанный": 2,
    "фальшивый": 3,
    "хаотический": 2,
    "холодный": 1,
    "хрупкий": 1,
    "цепкий": 2,
    "циничный": 2,
    "чертовский": 2,
    "чрезмерный": 2,
    "чувствительный": 2,
    "эгоистичный": 2,
    "эгоцентричный": 3,
    "эксплуатируемый": 2,
    "эмансипированный": 2,
    "эмоциональный": 1,
    "яростный": 3
  }, negativeVerbs = {
    "беспокоить": 2,
    "бить": 2,
    "внушать": 2,
    "волноваться": 2,
    "высмеивать": 2,
    "грызть": 1,
    "диктовать": 2,
    "дребезжать": 1,
    "дрожать": 1,
    "дрогнуть": 2,
    "загнать": 2,
    "запугивать": 3,
    "запутаться": 2,
    "злоупотреблять": 2,
    "игнорировать": 1,
    "избегать": 1,
    "издеваться": 3,
    "изменять": 2,
    "командовать": 1,
    "лгать": 2,
    "лишить": 2,
    "манипулировать": 2,
    "молчать": 1,
    "надувать": 1,
    "ненавидеть": 3,
    "обвинять": 2,
    "обидеть": 2,
    "опорочить": 3,
    "освистать": 3,
    "отбрасывать": 1,
    "отвлекаться": 2,
    "отклонить": 2,
    "отрекаться": 3,
    "оттолкнуть": 2,
    "паниковать": 2,
    "перепутаться": 2,
    "подавить": 3,
    "подвергаться": 2,
    "пострадать": 2,
    "предавать": 3,
    "пренебрегать": 2,
    "препятствовать": 2,
    "преследовать": 2,
    "принижаться": 2,
    "приставать": 2,
    "прослушивать": 2,
    "разгромить": 2,
    "раздражаться": 2,
    "растаскивать": 2,
    "рисковать": 2,
    "ругать": 2,
    "сдуваться": 1,
    "смолчать": 2,
    "снизиться": 1,
    "сорвать": 1,
    "сожалеть": 2,
    "соизволить": 2,
    "солгать": 2,
    "сомневаться": 2,
    "споткнуться": 1,
    "столкнуться": 2,
    "страдать": 2,
    "стрелять": 3,
    "судить": 2,
    "толкнуть": 1,
    "убить": 3,
    "убивать": 3,
    "уговаривать": 1,
    "удалять": 2,
    "уклоняться": 2,
    "унижать": 3,
    "шантажировать": 2
  }, negativeWordsIncline = {
    "боль": 2,
    "вниз": 1,
    "горе": 3,
    "дно": 2,
    "мало": 1,
    "мучение": 2,
    "недовольство": 2,
    "плохо": 2,
    "противно": 3,
    "совестно": 2,
    "только": 1,
    "ужас": 3,
    "смерть": 3,
    "неодобрительно": 2,
    "разгром": 2,
    "отчаяние": 3
  }, exports.getNegativePhrasesRe = getNegativePhrasesRe = function() {
    return [ [ /[^а-яё]при\sотягчающих\sобстоятельствах[^а-яё]/ig, 2 ], [ /[^а-яё]ненависть\sк[^а-яё]/ig, 3 ], [ /[^а-яё]в\sубыток[^а-яё]/ig, 2 ], [ /[^а-яё]сыт[аы]?\sпо\sгорло[^а-яё]/ig, 3 ], [ /[^а-яё]заслужива[ею]т\sнаказания[^а-яё]/ig, 2 ], [ /[^а-яё]находящ(егося|ейся|емся|ихся)\sпод\sугрозой\sисчезновения[^а-яё]/ig, 3 ], [ /[^а-яё]в\sзаблуждение[^а-яё]/ig, 2 ], [ /[^а-яё]сбит[аы]?\sс\sтолку[^а-яё]/ig, 2 ], [ /[^а-яё]в\sужасе[^а-яё]/ig, 3 ], [ /[^а-яё]не\sрекоменд(ую|уем|уется|овал|овала|овали)[^а-яё]/ig, 2 ], [ /[^а-яё]не\sодобря(ю|ем|л|ла|ли|ется)[^а-яё]/ig, 2 ], [ /[^а-яё]пятно\sна[^а-яё]/ig, 2 ], [ /[^а-яё]в\sклетке[^а-яё]/ig, 1 ], [ /[^а-яё]неправильно\sпонял[аи]?[^а-яё]/ig, 2 ], [ /[^а-яё]вне\sпределов\sдосягаемости[^а-яё]/ig, 1 ], [ /[^а-яё]взял[аи]?\sна[^а-яё]/ig, 2 ], [ /[^а-яё]играл[аи]?\sс[^а-яё]/ig, 2 ], [ /[^а-яё]черный\sсписок[^а-яё]/ig, 3 ], [ /[^а-яё]возбужден[оы]\sуголовн(ое|ые)\sдел[оа][^а-яё]/ig, 8 ], [ /[^а-яё]жертв(|а|ы|ам|ами)[^а-яё]/ig, 3 ] ];
  }, exports.evaluateSentenceNeutrality = evaluateSentenceNeutrality = function(sentence) {
    var adj, adjArray, adjIndex, curWords, cur_index, ind, index, m, nr, resetCurIndex, vIndex, verb, words, wrd, _i, _j, _k, _len, _len2, _len3, _ref, _ref2;
    index = 0, cur_index = 0, words = [], curWords = [], _ref = getNegativePhrasesRe();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) nr = _ref[_i], m = sentence.match(nr[0]), m && (m.map(function(wordsSequence) {
      return words.push(wordsSequence);
    }), index -= nr[1] * m.length);
    resetCurIndex = function() {
      if (cur_index) return index += cur_index, words.push(curWords), curWords = [], cur_index = 0;
    }, _ref2 = sentence.split(/\s/);
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      wrd = _ref2[_j];
      if (__indexOf.call(".,-—!?()[]", wrd) >= 0) {
        cur_index = -cur_index, resetCurIndex();
        continue;
      }
      ind = negativeWordsIncline[wrd.toLowerCase()];
      if (ind) curWords.push(wrd), cur_index = cur_index * ind || ind; else {
        adjArray = inclines.getInitialFormOfAdjective(wrd);
        if (!adjArray) verb = inclines.getVerbInfinitive(wrd), vIndex = negativeVerbs[verb], vIndex ? (curWords.push(wrd), cur_index = cur_index * vIndex || vIndex) : (cur_index = -cur_index, resetCurIndex()); else for (_k = 0, _len3 = adjArray.length; _k < _len3; _k++) {
          adj = adjArray[_k], adjIndex = negativeAdjectives[adj];
          if (adjIndex) {
            curWords.push(wrd), cur_index = cur_index * adjIndex || adjIndex;
            break;
          }
        }
      }
    }
    return resetCurIndex(-cur_index), [ index, words ];
  }, exports.postFilter = function(text, result) {
    var emoIndex, emoWords, i, index, overallIndex, s, _len, _ref, _ref2;
    emoIndex = [], overallIndex = 0, _ref = result.misc.sentences;
    for (i = 0, _len = _ref.length; i < _len; i++) s = _ref[i], _ref2 = evaluateSentenceNeutrality(s), index = _ref2[0], emoWords = _ref2[1], emoIndex.push([ index, emoWords ]), overallIndex += index;
    return result.feelings = {
      emoIndex: emoIndex,
      overallIndex: overallIndex,
      emoScore: overallIndex / result.counters.words_total || 1
    };
  };
}(exports, inclines);

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).analysis || (_base.analysis = {}), exports = window.lastName.analysis) : exports = module.exports, function(exports) {
  return exports.analyse = function(text, plugins) {
    var f, misc, postFilter, preFilters, result, util, _i, _j, _len, _len2;
    plugins == null && (plugins = []), "undefined" == typeof global ? (misc = window.lastName.misc, util = window.lastName.util) : (misc = require("./misc"), util = require("./util")), result = {}, misc.preFilter(text, result), preFilters = plugins.filter(function(plugin) {
      return "function" == typeof plugin.preFilter;
    }), postFilter = plugins.filter(function(plugin) {
      return "function" == typeof plugin.postFilter;
    });
    for (_i = 0, _len = preFilters.length; _i < _len; _i++) f = preFilters[_i], f.preFilter(text, result);
    for (_j = 0, _len2 = postFilter.length; _j < _len2; _j++) f = postFilter[_j], f.postFilter(text, result);
    return result.version = util.version, result;
  };
}(exports);

var __slice = Array.prototype.slice;

(function(lastname) {
  return lastname.version = "0.3.5", lastname.findProperName = function() {
    var args, inclines, lang;
    return lang = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [], inclines = lastname.plugins["" + lang].inclines, inclines.findProperName.apply(this, args);
  };
})(window.lastName || (window.lastName = {}));

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).misc || (_base.misc = {}), exports = window.lastName.misc) : exports = module.exports, function(exports) {
  return exports.preFilter = function(text, result) {
    var chars_total, emo, emoticons, findEmo, ind, punctuationRe, sentences, signs, signs_total, spaces_total, tempTxt, word_length_mid, words_total, _i, _len;
    signs = text.match(/[-\+=\/\.,\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]{1}/g), signs_total = signs && signs.length || 0, spaces_total = /\s/.test(text) ? text.match(/\s/g).length : 0, chars_total = text.length, words_total = text.split(/\s/).filter(function(wrd) {
      return wrd.length > 0 && !/^[-\+=\/\.\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]+$/.test(wrd);
    }).length, word_length_mid = words_total ? (chars_total - spaces_total - signs_total) / words_total : 0, emoticons = [ ":-)", "(-:", ":o)", ":)", "(:", ":->", ":-}", ":-t", ":*)", ":-)))", ":-D", "(-D", ":'-)", "%-)", ":-/", ":-I", ":~)", "(:-(", ":-(", ":-c", ":-(((", ":-<", ">:-(", ":-[", "(:-&", "%-(", ">:-<", "~ :-(", "%-(", ":/)", ":-|", ":-e", ":-X", ":-v", ":-I", ":-8(", ":-O", ":-@", ":,-(", ":'-(", "~:-o", "]:-)>", "):-)", ";->", ":-x", ":-*", "8-]", ":-J", ":-&", ":-p", ":-P", ";-)", ";)", "'-)", ":-7", "?-(", "B-D", ":-B", ":-*)", ":-9", "|-p", ":-b", "-]:-)[-", "8-I", "8-|", "|:-|", ":-]", "|-)", "|-I", "I^o", "|-O", ':-"', ":-s", ":-#", ":-!", ":-()", ":-D", "(:-$", ":-(*)", ":-')", ":-R", "%+|", "%+{", "X-(", "<:-)", "*:o)", "@;-)", "X:-)", ":>)", "&:-)", "#:-)", "8-)", "8:-)", "B-)", "B-]", "O:-)", "&8-|", ":-{", ":-)}", ":-)#", ":-Q", ":-I", ":-d~", ":-?", ":-/I", ":-) X", "{(:-)", ":-{}", "[:-)", "d :-o", "~:-(", "~~:-(", "))", "(:-I", "3:-o", "[: |]", "M-)", ":X)", ":-M", "*8((:", "O+", "O->", "||*(", "||*)", "<{:-)}", "(-: :-)", "@->-", "@==", "<')))))- <" ], emoticons.sort(function(a, b) {
      return b.length - a.length;
    }), tempTxt = text.slice(0), findEmo = [];
    for (_i = 0, _len = emoticons.length; _i < _len; _i++) {
      emo = emoticons[_i], ind = 0;
      while (ind >= 0) ind = tempTxt.indexOf(emo, ind), ind !== -1 && (findEmo.push(emo), tempTxt = tempTxt.replace(emo, ""), ind -= emo.length + 2);
    }
    return punctuationRe = /(https?\:\/\/.*[\s$])|(\.\s)|(,\s)|(\s\:)|(:\s)|(\s\/)|(\/\s)|(\s\\)(\\\s)|\?|!|\+|\'|\"|«|»|\*|\(|\)|\[|\]|\&|\№|“|”|\—/g, tempTxt = text.replace(punctuationRe, " $& ").replace(/\s+/g, " "), /[\?\!\.]\s{0,}$/.test(tempTxt) || (tempTxt += " . "), sentences = tempTxt.replace(/\s\?\s/gm, " ?? ").replace(/\s\!\s/gm, " !! ").replace(/\s\.\s/gm, " .. ").split(/[\?\!\.](\s+|$)/gm).filter(function(s) {
      return !/^\s{0,}$/.test(s);
    }), result.misc = {
      digits: util.arrayToDict(text.match(/-?((\d+[\.,]\d+)|(\d+))/ig) || []),
      emoticons: util.arrayToDict(findEmo),
      romans: util.arrayToDict(text.match(/([X]{0,3}I[VX])(M*(D?C{0,3}|C[DM])(L?X{0,3}|X[LC])(V?I{0,3}|I[VX]))/g) || []),
      sentences: sentences
    }, result.counters = {
      chars_total: chars_total,
      words_total: words_total,
      signs_total: signs_total,
      spaces_total: spaces_total,
      word_length_mid: word_length_mid,
      words_in_sentence_mid: sentences.length ? words_total / sentences.length : 0
    }, result;
  };
}(exports);

var exports, _base, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).util || (_base.util = {}), exports = window.lastName.util) : exports = module.exports, function(exports) {
  var capitalize, dictKeys, intersection, isCapitalized, isLowerCase, isUpperCase, merge, unique;
  return exports.version = "0.3.17", exports.capitalize = capitalize = function(s) {
    if (s) return "" + s[0].toUpperCase() + s.slice(1).toLowerCase();
  }, exports.dictKeys = dictKeys = function(dict) {
    var k, keys, v;
    keys = [];
    for (k in dict) v = dict[k], keys.push(k);
    return keys;
  }, exports.isCapitalized = isCapitalized = function(word) {
    var cap;
    return 0 <= word.indexOf("-") ? (cap = !0, word.split("-").map(function(wrd) {
      return cap && (cap = isCapitalized(wrd));
    }), cap) : word && word === capitalize(word) || !1;
  }, exports.isUpperCase = isUpperCase = function(word) {
    return word === word.toUpperCase();
  }, exports.isLowerCase = isLowerCase = function(word) {
    return word === word.toLowerCase();
  }, exports.unique = unique = function(array) {
    var key, output, value, _ref, _results;
    output = {};
    for (key = 0, _ref = array.length; 0 <= _ref ? key < _ref : key > _ref; 0 <= _ref ? key++ : key--) output[array[key]] = array[key];
    _results = [];
    for (key in output) value = output[key], _results.push(value);
    return _results;
  }, exports.merge = merge = function(l1, l2) {
    var l;
    return l = [], l1.map(function(x) {
      return l.push(x);
    }), l2.map(function(x) {
      return l.push(x);
    }), unique(l);
  }, exports.intersection = intersection = function(l1, l2) {
    var i, _i, _len;
    for (_i = 0, _len = l1.length; _i < _len; _i++) {
      i = l1[_i];
      if (__indexOf.call(l2, i) >= 0) return i;
    }
    return null;
  }, exports.arrayToDict = function(arr) {
    var d, i, _i, _len;
    d = {};
    for (_i = 0, _len = arr.length; _i < _len; _i++) i = arr[_i], d[i] ? d[i]++ : d[i] = 1;
    return d;
  };
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.ref = {}, exports = window.lastName.plugins.ru.ref) : exports = module.exports, function(exports) {
  return exports.ruFemaleNamesDict = {
    "альвина": 1,
    "анелия": 1,
    "августа": 1,
    "августина": 1,
    "авдотья": 1,
    "авелина": 1,
    "аврелия": 1,
    "аврора": 1,
    "агапия": 1,
    "агата": 1,
    "агафья": 1,
    "агафия": 1,
    "аглаида": 1,
    "аглая": 1,
    "агнеса": 1,
    "агнесса": 1,
    "агния": 1,
    "агриппмеа": 1,
    "агрефена": 1,
    "ада": 1,
    "адина": 1,
    "адель": 1,
    "аделия": 1,
    "аделаида": 1,
    "аза": 1,
    "азалия": 1,
    "аида": 1,
    "айседора": 1,
    "айсылу": 1,
    "акилина": 1,
    "акулина": 1,
    "аксинья": 1,
    "алевтина": 1,
    "александра": 1,
    "алеся": 1,
    "алена": 1,
    "алина": 1,
    "алиса": 1,
    "алия": 1,
    "алла": 1,
    "алика": 1,
    "альбина": 1,
    "альмир": 1,
    "альфия": 1,
    "амина": 1,
    "анастасия": 1,
    "анатолия": 1,
    "ангелина": 1,
    "анжела": 1,
    "анимаиса": 1,
    "анисия": 1,
    "анисья": 1,
    "анна": 1,
    "анита": 1,
    "антонина": 1,
    "антонида": 1,
    "антония": 1,
    "анфиса": 1,
    "анфуса": 1,
    "анфия": 1,
    "амира": 1,
    "аполлинария": 1,
    "аревик": 1,
    "ариадна": 1,
    "арина": 1,
    "аркадия": 1,
    "арсения": 1,
    "арсиана": 1,
    "артемия": 1,
    "асель": 1,
    "аста": 1,
    "астра": 1,
    "астрид": 1,
    "афанасия": 1,
    "афродита": 1,
    "аэлита": 1,
    "аэлла": 1,
    "амалия": 1,
    "бажена": 1,
    "беата": 1,
    "беатриса": 1,
    "бела": 1,
    "белла": 1,
    "беллатриса": 1,
    "берта": 1,
    "богдана": 1,
    "божена": 1,
    "болеслава": 1,
    "борислава": 1,
    "бриджет": 1,
    "бронислава": 1,
    "валентина": 1,
    "валерия": 1,
    "ванда": 1,
    "варвара": 1,
    "василина": 1,
    "василиса": 1,
    "васса": 1,
    "вацлава": 1,
    "вевея": 1,
    "велора": 1,
    "велория": 1,
    "венера": 1,
    "вера": 1,
    "вероника": 1,
    "веселина": 1,
    "веста": 1,
    "видана": 1,
    "викторина": 1,
    "виктория": 1,
    "вилена": 1,
    "виола": 1,
    "виолетта": 1,
    "виоланта": 1,
    "виринея": 1,
    "вита": 1,
    "виталия": 1,
    "виталина": 1,
    "виулена": 1,
    "влада": 1,
    "владилена": 1,
    "владимира": 1,
    "владислава": 1,
    "владлена": 1,
    "власта": 1,
    "воля": 1,
    "всеслава": 1,
    "гайя": 1,
    "гали": 1,
    "галина": 1,
    "ганна": 1,
    "гаяна": 1,
    "гаяния": 1,
    "гвинет": 1,
    "гелена": 1,
    "гелия": 1,
    "гелла": 1,
    "генриетта": 1,
    "гертруда": 1,
    "глафира": 1,
    "гликерия": 1,
    "глория": 1,
    "голуба": 1,
    "горислава": 1,
    "гюльанэ": 1,
    "гюльнара": 1,
    "гюльчитай": 1,
    "даздраперма": 1,
    "дайна": 1,
    "дана": 1,
    "дарья": 1,
    "дария": 1,
    "дарина": 1,
    "дарьяна": 1,
    "декабрина": 1,
    "дея": 1,
    "дия": 1,
    "джиневра": 1,
    "дженнифер": 1,
    "джульета": 1,
    "дианна": 1,
    "дилия": 1,
    "диля": 1,
    "дильфуза": 1,
    "дина": 1,
    "диния": 1,
    "диодора": 1,
    "дионисия": 1,
    "добрава": 1,
    "домна": 1,
    "домина": 1,
    "домника": 1,
    "доминика": 1,
    "донара": 1,
    "дорофея": 1,
    "доротея": 1,
    "ева": 1,
    "евгения": 1,
    "евдокия": 1,
    "евлалия": 1,
    "евлампия": 1,
    "евпраксия": 1,
    "евстолия": 1,
    "евфалия": 1,
    "евфросиния": 1,
    "екатерина": 1,
    "елена": 1,
    "елизавета": 1,
    "еликонида": 1,
    "ермиония": 1,
    "есения": 1,
    "ефимия": 1,
    "евфремия": 1,
    "жанна": 1,
    "ждана": 1,
    "жаннэ": 1,
    "жасмина": 1,
    "забава": 1,
    "заира": 1,
    "зара": 1,
    "зарема": 1,
    "зарина": 1,
    "зорина": 1,
    "заряна": 1,
    "зауре": 1,
    "звенислава": 1,
    "земфира": 1,
    "зиля": 1,
    "зинаида": 1,
    "зиновия": 1,
    "злата": 1,
    "зозан": 1,
    "зоя": 1,
    "зульфия": 1,
    "иванна": 1,
    "ида": 1,
    "илария": 1,
    "илиана": 1,
    "илона": 1,
    "ильмира": 1,
    "инга": 1,
    "индира": 1,
    "инесса": 1,
    "инна": 1,
    "иоанна": 1,
    "иона": 1,
    "ипатия": 1,
    "ипполита": 1,
    "ирада": 1,
    "ираида": 1,
    "ирена": 1,
    "ироида": 1,
    "ираклия": 1,
    "ирина": 1,
    "исидора": 1,
    "искра": 1,
    "ифигения": 1,
    "ия": 1,
    "кадрия": 1,
    "кермен": 1,
    "калиса": 1,
    "каллиста": 1,
    "камилла": 1,
    "камила": 1,
    "капитолина": 1,
    "карина": 1,
    "каролина": 1,
    "катерина": 1,
    "кира": 1,
    "кирилла": 1,
    "клавдия": 1,
    "клара": 1,
    "клариса": 1,
    "кларисса": 1,
    "клеопатра": 1,
    "клио": 1,
    "клер": 1,
    "конкордия": 1,
    "констанция": 1,
    "кристина": 1,
    "ксения": 1,
    "лавиния": 1,
    "лада": 1,
    "лана": 1,
    "лариса": 1,
    "лаура": 1,
    "лейла": 1,
    "лема": 1,
    "лена": 1,
    "лениана": 1,
    "ленина": 1,
    "леонида": 1,
    "леонила": 1,
    "леонтия": 1,
    "леся": 1,
    "ливия": 1,
    "лидия": 1,
    "лилиана": 1,
    "лилия": 1,
    "лилит": 1,
    "лина": 1,
    "лира": 1,
    "лия": 1,
    "лея": 1,
    "лора": 1,
    "луиза": 1,
    "лукерия": 1,
    "лукиана": 1,
    "лукина": 1,
    "люцина": 1,
    "лусинэ": 1,
    "любава": 1,
    "любовь": 1,
    "любомира": 1,
    "людмила": 1,
    "ляля": 1,
    "мавра": 1,
    "магда": 1,
    "магдалина": 1,
    "мадлен": 1,
    "майя": 1,
    "мая": 1,
    "мальвина": 1,
    "маргарита": 1,
    "мариана": 1,
    "марьяна": 1,
    "марианна": 1,
    "мариетта": 1,
    "мариэтта": 1,
    "марика": 1,
    "марина": 1,
    "мария": 1,
    "марья": 1,
    "мари": 1,
    "марлен": 1,
    "марлена": 1,
    "марта": 1,
    "марфа": 1,
    "матильда": 1,
    "матрена": 1,
    "матрёна": 1,
    "матрона": 1,
    "мелания": 1,
    "меланья": 1,
    "мелитина": 1,
    "милада": 1,
    "милана": 1,
    "милен": 1,
    "милица": 1,
    "милия": 1,
    "милослава": 1,
    "мира": 1,
    "мирра": 1,
    "мирослава": 1,
    "митродора": 1,
    "млада": 1,
    "мстислава": 1,
    "нада": 1,
    "надежда": 1,
    "надия": 1,
    "наина": 1,
    "наира": 1,
    "нана": 1,
    "настасья": 1,
    "наталья": 1,
    "наталия": 1,
    "нелли": 1,
    "неонила": 1,
    "ника": 1,
    "нина": 1,
    "нинелла": 1,
    "нинель": 1,
    "новелла": 1,
    "нонна": 1,
    "нора": 1,
    "нуркыз": 1,
    "насиба": 1,
    "оксана": 1,
    "октавия": 1,
    "октябрина": 1,
    "олеся": 1,
    "оливия": 1,
    "олимпиада": 1,
    "олимпия": 1,
    "ольга": 1,
    "офелия": 1,
    "павла": 1,
    "павлина": 1,
    "патриция": 1,
    "пелагея": 1,
    "платонида": 1,
    "поликсена": 1,
    "полина": 1,
    "правдина": 1,
    "прасковья": 1,
    "пенелопа": 1,
    "полислава": 1,
    "рада": 1,
    "радмила": 1,
    "раиса": 1,
    "раймонда": 1,
    "раялла": 1,
    "ревмира": 1,
    "регина": 1,
    "рената": 1,
    "римма": 1,
    "рогнеда": 1,
    "роза": 1,
    "розалина": 1,
    "розалия": 1,
    "розана": 1,
    "роксан": 1,
    "ростислава": 1,
    "руслана": 1,
    "руфина": 1,
    "руфь": 1,
    "раида": 1,
    "сабина": 1,
    "сабрина": 1,
    "саломея": 1,
    "соломея": 1,
    "самира": 1,
    "светлана": 1,
    "светозара": 1,
    "светослава": 1,
    "свобода": 1,
    "святослава": 1,
    "севастьяна": 1,
    "северина": 1,
    "селена": 1,
    "селина": 1,
    "селестина": 1,
    "серафима": 1,
    "сергияна": 1,
    "сильва": 1,
    "агриппина": 1,
    "алёна": 1,
    "вилора": 1,
    "вилория": 1,
    "джульетта": 1,
    "диана": 1,
    "евфимия": 1,
    "ефросиния": 1,
    "калерия": 1,
    "милена": 1,
    "муза": 1,
    "савина": 1,
    "сильвия": 1,
    "симона": 1,
    "слава": 1,
    "славяна": 1,
    "снежана": 1,
    "софья": 1,
    "софия": 1,
    "станислава": 1,
    "стелла": 1,
    "степанида": 1,
    "стефанида": 1,
    "стефания": 1,
    "сусанна": 1,
    "сосанна": 1,
    "сюзанна": 1,
    "таира": 1,
    "таисия": 1,
    "тальяна": 1,
    "тамара": 1,
    "тамила": 1,
    "томила": 1,
    "татьяна": 1,
    "текуса": 1,
    "тереза": 1,
    "улита": 1,
    "ульяна": 1,
    "услада": 1,
    "устинья": 1,
    "фаина": 1,
    "февронья": 1,
    "феликсана": 1,
    "фелицата": 1,
    "фелицитата": 1,
    "фелиция": 1,
    "федора": 1,
    "феодора": 1,
    "феодосия": 1,
    "феодосья": 1,
    "феоктиста": 1,
    "феофания": 1,
    "феона": 1,
    "флавия": 1,
    "флора": 1,
    "флория": 1,
    "флорентина": 1,
    "флоренция": 1,
    "флориана": 1,
    "фотина": 1,
    "харита": 1,
    "харитина": 1,
    "хиония": 1,
    "христина": 1,
    "цецилия": 1,
    "чеслава": 1,
    "эвелина": 1,
    "эвридика": 1,
    "эдда": 1,
    "элеонора": 1,
    "элина": 1,
    "эльвира": 1,
    "эльмира": 1,
    "эльза": 1,
    "эмилия": 1,
    "эмма": 1,
    "эрика": 1,
    "эсфирь": 1,
    "юдифь": 1,
    "юзефа": 1,
    "юлиана": 1,
    "юлитта": 1,
    "юлия": 1,
    "юманита": 1,
    "юния": 1,
    "юнона": 1,
    "юстина": 1,
    "ядвига": 1,
    "яна": 1,
    "янина": 1,
    "яромира": 1,
    "ярослава": 1
  }, exports.ruMaleNamesDict = {
    "ааран": 1,
    "аарен": 1,
    "ааррон": 1,
    "аб": 1,
    "аббат": 1,
    "абботт": 1,
    "абей": 1,
    "абелл": 1,
    "абель": 1,
    "абнар": 1,
    "абнер": 1,
    "абнор": 1,
    "абот": 1,
    "аботт": 1,
    "абрам": 1,
    "абран": 1,
    "абрахам": 1,
    "абсалон": 1,
    "авангард": 1,
    "август": 1,
    "августин": 1,
    "авдей": 1,
    "авдий": 1,
    "авенир": 1,
    "аверилл": 1,
    "аверкий": 1,
    "авксентий": 1,
    "аврам": 1,
    "аврор": 1,
    "аврорий": 1,
    "агап": 1,
    "аггей": 1,
    "агей": 1,
    "адам": 1,
    "аддам": 1,
    "аддисон": 1,
    "аден": 1,
    "адий": 1,
    "адисон": 1,
    "адиссон": 1,
    "адлэй": 1,
    "адней": 1,
    "адольф": 1,
    "адонис": 1,
    "адриан": 1,
    "адэйр": 1,
    "адэр": 1,
    "азия": 1,
    "азэлстан": 1,
    "айбл": 1,
    "айзек": 1,
    "айк": 1,
    "ак": 1,
    "акей": 1,
    "акерлеа": 1,
    "акерлей": 1,
    "акерли": 1,
    "аки": 1,
    "аким": 1,
    "аклеа": 1,
    "аклей": 1,
    "акли": 1,
    "аксён": 1,
    "актон": 1,
    "акэль": 1,
    "алан": 1,
    "аластеир": 1,
    "аластэйр": 1,
    "алвар": 1,
    "алвен": 1,
    "алви": 1,
    "алвин": 1,
    "алвис": 1,
    "алгар": 1,
    "алджернон": 1,
    "алевтин": 1,
    "алеистер": 1,
    "алек": 1,
    "алекс": 1,
    "александр": 1,
    "алексей": 1,
    "ален": 1,
    "алестер": 1,
    "алжир": 1,
    "алик": 1,
    "аликс": 1,
    "алим": 1,
    "алисандр": 1,
    "алисдэйр": 1,
    "алиссандр": 1,
    "алистер": 1,
    "алистэйр": 1,
    "аллан": 1,
    "аллен": 1,
    "аллин": 1,
    "аллистер": 1,
    "аллистир": 1,
    "аллистэйр": 1,
    "алтон": 1,
    "алф": 1,
    "алфонзо": 1,
    "алфорд": 1,
    "алфрид": 1,
    "альберт": 1,
    "альбин": 1,
    "альвиан": 1,
    "альвин": 1,
    "альдина": 1,
    "альпин": 1,
    "альтаир": 1,
    "альфа": 1,
    "альфи": 1,
    "альфред": 1,
    "алэйстер": 1,
    "алэйстэйр": 1,
    "амби": 1,
    "амброуз": 1,
    "амедеус": 1,
    "амиас": 1,
    "амори": 1,
    "амос": 1,
    "амьяс": 1,
    "анакин": 1,
    "ананий": 1,
    "анастасий": 1,
    "анатолий": 1,
    "анвар": 1,
    "ангел": 1,
    "ангес": 1,
    "андерсон": 1,
    "анджелл": 1,
    "андрей": 1,
    "андреян": 1,
    "андриан": 1,
    "андрон": 1,
    "анж": 1,
    "анис": 1,
    "анисий": 1,
    "анисим": 1,
    "анри": 1,
    "анском": 1,
    "анскомб": 1,
    "ансон": 1,
    "антван": 1,
    "антип": 1,
    "антон": 1,
    "антоний": 1,
    "антонин": 1,
    "антуан": 1,
    "аполлинарий": 1,
    "аполлон": 1,
    "арам": 1,
    "арвид": 1,
    "аргент": 1,
    "арден": 1,
    "арефий": 1,
    "арий": 1,
    "арик": 1,
    "арил": 1,
    "арин": 1,
    "аристарх": 1,
    "аркадий": 1,
    "аркелл": 1,
    "арлен": 1,
    "арли": 1,
    "арман": 1,
    "армен": 1,
    "арн": 1,
    "арне": 1,
    "арни": 1,
    "арнольд": 1,
    "арран": 1,
    "аррин": 1,
    "аррон": 1,
    "арсен": 1,
    "арсений": 1,
    "арт": 1,
    "артамон": 1,
    "артемий": 1,
    "арти": 1,
    "артур": 1,
    "артём": 1,
    "архип": 1,
    "арчи": 1,
    "арчибальд": 1,
    "аселет": 1,
    "аселин": 1,
    "асер": 1,
    "аскольд": 1,
    "астон": 1,
    "атеист": 1,
    "афанасий": 1,
    "афиноген": 1,
    "афтон": 1,
    "аффтон": 1,
    "ахмат": 1,
    "ахмет": 1,
    "ачилл": 1,
    "аш": 1,
    "ашер": 1,
    "ашот": 1,
    "аштон": 1,
    "баграт": 1,
    "бад": 1,
    "бадди": 1,
    "бажен": 1,
    "баз": 1,
    "базилик": 1,
    "байрон": 1,
    "байярд": 1,
    "бак": 1,
    "бакстер": 1,
    "балдер": 1,
    "балдрик": 1,
    "бамби": 1,
    "баптист": 1,
    "бардолф": 1,
    "барии": 1,
    "барклей": 1,
    "барнабас": 1,
    "барни": 1,
    "барнэби": 1,
    "барретт": 1,
    "барри": 1,
    "барт": 1,
    "бартоломей": 1,
    "бассетт": 1,
    "бастер": 1,
    "бастиан": 1,
    "батч": 1,
    "баян": 1,
    "беван": 1,
    "беверли": 1,
    "бевис": 1,
    "бедивир": 1,
    "бейб": 1,
    "бейлей": 1,
    "бейлие": 1,
    "бен": 1,
    "бенджамин": 1,
    "бенджи": 1,
    "бенедикт": 1,
    "бенет": 1,
    "беннетт": 1,
    "бенни": 1,
    "бенние": 1,
    "бенсон": 1,
    "бентлей": 1,
    "бентон": 1,
    "беорегард": 1,
    "бердт": 1,
    "беренгар": 1,
    "беренджер": 1,
    "берет": 1,
    "бернард": 1,
    "берни": 1,
    "берри": 1,
    "берт": 1,
    "берти": 1,
    "бертольд": 1,
    "бертон": 1,
    "бертрам": 1,
    "бертран": 1,
    "бивис": 1,
    "билл": 1,
    "билли": 1,
    "бисш": 1,
    "биф": 1,
    "блейн": 1,
    "близэ": 1,
    "блисс": 1,
    "блэйз": 1,
    "блэйк": 1,
    "блэйн": 1,
    "блэр": 1,
    "боб": 1,
    "бобби": 1,
    "богдан": 1,
    "боеслав": 1,
    "болдуин": 1,
    "болеслав": 1,
    "боллард": 1,
    "бомонт": 1,
    "бонифэйс": 1,
    "боримир": 1,
    "борис": 1,
    "борислав": 1,
    "боян": 1,
    "брадлей": 1,
    "браеден": 1,
    "брайен": 1,
    "брайон": 1,
    "бранден": 1,
    "брандон": 1,
    "браннон": 1,
    "брейден": 1,
    "брейдн": 1,
    "брендан": 1,
    "бренден": 1,
    "брендон": 1,
    "бреннан": 1,
    "брент": 1,
    "брентон": 1,
    "брет": 1,
    "бретт": 1,
    "бриар": 1,
    "брион": 1,
    "брис": 1,
    "бриско": 1,
    "бриттон": 1,
    "бриэм": 1,
    "бродерик": 1,
    "броди": 1,
    "броз": 1,
    "брок": 1,
    "бронислав": 1,
    "бронт": 1,
    "броуди": 1,
    "броук": 1,
    "брук": 1,
    "брукс": 1,
    "бруно": 1,
    "брутус": 1,
    "брьянт": 1,
    "брэд": 1,
    "брэди": 1,
    "брэдфорд": 1,
    "брэйден": 1,
    "брэйди": 1,
    "брэм": 1,
    "брэн": 1,
    "брюс": 1,
    "брююс": 1,
    "будимир": 1,
    "буз": 1,
    "букер": 1,
    "булат": 1,
    "бью": 1,
    "бэйли": 1,
    "вавила": 1,
    "вадим": 1,
    "вал": 1,
    "валентайн": 1,
    "валентин": 1,
    "валериан": 1,
    "валерий": 1,
    "валерьян": 1,
    "вальдемар": 1,
    "вальтер": 1,
    "ванадий": 1,
    "вард": 1,
    "варлаам": 1,
    "варлам": 1,
    "варлен": 1,
    "вартан": 1,
    "варфоломей": 1,
    "василий": 1,
    "василько": 1,
    "ваухан": 1,
    "вахтанг": 1,
    "вацлав": 1,
    "вашингтон": 1,
    "вебстер": 1,
    "велдон": 1,
    "велимир": 1,
    "велислав": 1,
    "велор": 1,
    "велорий": 1,
    "венедикт": 1,
    "вениамин": 1,
    "вер": 1,
    "вергилий": 1,
    "верджил": 1,
    "верн": 1,
    "вернон": 1,
    "вестер": 1,
    "вестлей": 1,
    "вестон": 1,
    "вик": 1,
    "викентий": 1,
    "виктор": 1,
    "вил": 1,
    "вилберн": 1,
    "вилей": 1,
    "вилен": 1,
    "вилий": 1,
    "вилиор": 1,
    "вилки": 1,
    "вилл": 1,
    "вилли": 1,
    "виллоби": 1,
    "вилмар": 1,
    "вилмер": 1,
    "вилмот": 1,
    "вилор": 1,
    "вилорг": 1,
    "вилорий": 1,
    "вилсон": 1,
    "вилф": 1,
    "вилфорд": 1,
    "виль": 1,
    "вильгельм": 1,
    "вильтон": 1,
    "вильям": 1,
    "вин": 1,
    "виндзор": 1,
    "винни": 1,
    "винс": 1,
    "винсент": 1,
    "винслоу": 1,
    "винтроп": 1,
    "винцент": 1,
    "виолен": 1,
    "вирджиль": 1,
    "виссарион": 1,
    "вистан": 1,
    "виталий": 1,
    "витейкр": 1,
    "витней": 1,
    "витольд": 1,
    "влад": 1,
    "владелин": 1,
    "владилен": 1,
    "владимир": 1,
    "владислав": 1,
    "владлен": 1,
    "влас": 1,
    "власий": 1,
    "воган": 1,
    "вогн": 1,
    "воин": 1,
    "воислав": 1,
    "волдо": 1,
    "волемир": 1,
    "волкер": 1,
    "воллис": 1,
    "володар": 1,
    "вольдемар": 1,
    "вольмир": 1,
    "вольт": 1,
    "вольф": 1,
    "вольфрам": 1,
    "воспой": 1,
    "всеволод": 1,
    "всемил": 1,
    "вуди": 1,
    "вудроу": 1,
    "вулф": 1,
    "вьятт": 1,
    "вэйд": 1,
    "вэйланд": 1,
    "вэнс": 1,
    "вячеслав": 1,
    "габби": 1,
    "габриель": 1,
    "габриэль": 1,
    "гавриил": 1,
    "гаврил": 1,
    "гаврила": 1,
    "гаврило": 1,
    "гай": 1,
    "гайдар": 1,
    "гайлс": 1,
    "галактион": 1,
    "гален": 1,
    "галий": 1,
    "гамильтон": 1,
    "гамлет": 1,
    "гантэр": 1,
    "гаральд": 1,
    "гарван": 1,
    "гарей": 1,
    "гарибальди": 1,
    "гарланд": 1,
    "гарнет": 1,
    "гарольд": 1,
    "гарри": 1,
    "гаррий": 1,
    "гарс": 1,
    "гарфилд": 1,
    "гас": 1,
    "гаспар": 1,
    "гваделупа": 1,
    "гвидон": 1,
    "гейб": 1,
    "гейл": 1,
    "гейр": 1,
    "гектор": 1,
    "гелеон": 1,
    "гелиан": 1,
    "гелий": 1,
    "ген": 1,
    "гений": 1,
    "геннадий": 1,
    "генри": 1,
    "генрих": 1,
    "геодар": 1,
    "георгий": 1,
    "геральд": 1,
    "герасим": 1,
    "герберт": 1,
    "герман": 1,
    "гермоген": 1,
    "герольд": 1,
    "геронт": 1,
    "геронтий": 1,
    "герт": 1,
    "гертруд": 1,
    "гидеон": 1,
    "гильберт": 1,
    "гисберт": 1,
    "гладвин": 1,
    "гланвилл": 1,
    "глеб": 1,
    "глендауэр": 1,
    "гленн": 1,
    "глэн": 1,
    "говард": 1,
    "годвин": 1,
    "годфри": 1,
    "голлагэр": 1,
    "голладжер": 1,
    "гомер": 1,
    "горазд": 1,
    "гораций": 1,
    "горд": 1,
    "гордей": 1,
    "горден": 1,
    "гордий": 1,
    "гордон": 1,
    "горимир": 1,
    "горислав": 1,
    "горн": 1,
    "граем": 1,
    "грай": 1,
    "гранвилл": 1,
    "гранд": 1,
    "гранит": 1,
    "грахэйм": 1,
    "грег": 1,
    "грей": 1,
    "гренвилл": 1,
    "григорий": 1,
    "гриир": 1,
    "грир": 1,
    "гриффин": 1,
    "гриффит": 1,
    "гровер": 1,
    "грэг": 1,
    "грэгори": 1,
    "грэди": 1,
    "грэм": 1,
    "гудвин": 1,
    "гудзон": 1,
    "гурий": 1,
    "густав": 1,
    "гэй": 1,
    "гэйбл": 1,
    "гэйг": 1,
    "гэйдж": 1,
    "гэйелорд": 1,
    "гэйл": 1,
    "гэйлон": 1,
    "гэйлорд": 1,
    "гэйр": 1,
    "гэлл": 1,
    "гэри": 1,
    "давей": 1,
    "дави": 1,
    "давид": 1,
    "давыд": 1,
    "дад": 1,
    "дадда": 1,
    "дадли": 1,
    "даймонд": 1,
    "дакей": 1,
    "дакота": 1,
    "дакс": 1,
    "далтон": 1,
    "дамайон": 1,
    "дамиан": 1,
    "дамир": 1,
    "дан": 1,
    "дана": 1,
    "дани": 1,
    "даниар": 1,
    "даниил": 1,
    "данил": 1,
    "данила": 1,
    "данило": 1,
    "даниэль": 1,
    "данки": 1,
    "данни": 1,
    "дар": 1,
    "дарби": 1,
    "дарвин": 1,
    "дарден": 1,
    "дарен": 1,
    "дариан": 1,
    "дарил": 1,
    "дарин": 1,
    "дарки": 1,
    "дарнелл": 1,
    "даррел": 1,
    "даррен": 1,
    "даррил": 1,
    "даррин": 1,
    "даррэль": 1,
    "дасти": 1,
    "дастин": 1,
    "дау": 1,
    "дафф": 1,
    "даффи": 1,
    "дашилл": 1,
    "дван": 1,
    "двэйн": 1,
    "деай": 1,
    "деван": 1,
    "девен": 1,
    "девереукс": 1,
    "девин": 1,
    "девон": 1,
    "дейв": 1,
    "дейл": 1,
    "дейрлл": 1,
    "дейрн": 1,
    "декабрий": 1,
    "деклан": 1,
    "декстер": 1,
    "делберт": 1,
    "делл": 1,
    "делмар": 1,
    "делрой": 1,
    "дементий": 1,
    "деметриус": 1,
    "демид": 1,
    "демократ": 1,
    "демон": 1,
    "демьян": 1,
    "ден": 1,
    "денвер": 1,
    "денеб": 1,
    "дензэль": 1,
    "дени": 1,
    "денил": 1,
    "денис": 1,
    "деннис": 1,
    "дентон": 1,
    "деон": 1,
    "деонн": 1,
    "деонт": 1,
    "дерби": 1,
    "дерек": 1,
    "дерик": 1,
    "дермот": 1,
    "дерок": 1,
    "деррен": 1,
    "дерри": 1,
    "деррил": 1,
    "дефорест": 1,
    "дефоррест": 1,
    "дешон": 1,
    "джадд": 1,
    "джадин": 1,
    "джай": 1,
    "джайлс": 1,
    "джак": 1,
    "джамар": 1,
    "джамей": 1,
    "джамисон": 1,
    "джарвис": 1,
    "джаред": 1,
    "джарод": 1,
    "джарред": 1,
    "джарретт": 1,
    "джаррод": 1,
    "джаспер": 1,
    "джасти": 1,
    "джастин": 1,
    "джеб": 1,
    "джед": 1,
    "джедидиа": 1,
    "джейдн": 1,
    "джейк": 1,
    "джейлн": 1,
    "джейми": 1,
    "джеймс": 1,
    "джейрт": 1,
    "джейсон": 1,
    "джекки": 1,
    "джекоб": 1,
    "джем": 1,
    "дженкин": 1,
    "джеп": 1,
    "джер": 1,
    "джералд": 1,
    "джеральд": 1,
    "джерард": 1,
    "джерваз": 1,
    "джервис": 1,
    "джереми": 1,
    "джери": 1,
    "джермэйн": 1,
    "джеролд": 1,
    "джером": 1,
    "джеррард": 1,
    "джерред": 1,
    "джерри": 1,
    "джеррод": 1,
    "джерролд": 1,
    "джес": 1,
    "джесси": 1,
    "джетро": 1,
    "джетт": 1,
    "джеф": 1,
    "джеффери": 1,
    "джефферсон": 1,
    "джеффрей": 1,
    "джеффри": 1,
    "джиб": 1,
    "джид": 1,
    "джиди": 1,
    "джил": 1,
    "джим": 1,
    "джими": 1,
    "джимми": 1,
    "джисберт": 1,
    "джиффард": 1,
    "джо": 1,
    "джоб": 1,
    "джоби": 1,
    "джоджо": 1,
    "джоди": 1,
    "джозеф": 1,
    "джой": 1,
    "джойс": 1,
    "джон": 1,
    "джоназан": 1,
    "джоназон": 1,
    "джонасон": 1,
    "джонатан": 1,
    "джоней": 1,
    "джони": 1,
    "джонни": 1,
    "джонти": 1,
    "джорги": 1,
    "джордан": 1,
    "джордж": 1,
    "джорди": 1,
    "джордон": 1,
    "джосс": 1,
    "джоул": 1,
    "джош": 1,
    "джошоа": 1,
    "джошуа": 1,
    "джулс": 1,
    "джульян": 1,
    "джустис": 1,
    "джьюд": 1,
    "джэй": 1,
    "джэйд": 1,
    "джэйда": 1,
    "джэйден": 1,
    "джэйдон": 1,
    "джэйкоб": 1,
    "джэйлен": 1,
    "джэйлин": 1,
    "джэйлон": 1,
    "джэймес": 1,
    "джэйсон": 1,
    "джэксон": 1,
    "джэмини": 1,
    "джэмми": 1,
    "джэн": 1,
    "ди": 1,
    "диакон": 1,
    "дигби": 1,
    "диггори": 1,
    "дигори": 1,
    "дидим": 1,
    "дизон": 1,
    "дик": 1,
    "дики": 1,
    "дикки": 1,
    "дил": 1,
    "дилан": 1,
    "дилберт": 1,
    "димер": 1,
    "димитрий": 1,
    "дин": 1,
    "диндр": 1,
    "дионис": 1,
    "дионисий": 1,
    "дирк": 1,
    "дмитрий": 1,
    "доб": 1,
    "добрыня": 1,
    "додж": 1,
    "дольф": 1,
    "дом": 1,
    "доменик": 1,
    "доминик": 1,
    "дон": 1,
    "дональд": 1,
    "дональт": 1,
    "донат": 1,
    "донни": 1,
    "донован": 1,
    "дор": 1,
    "дориан": 1,
    "дорофей": 1,
    "доусон": 1,
    "драйк": 1,
    "древ": 1,
    "дрейвн": 1,
    "дуайт": 1,
    "дуан": 1,
    "дуг": 1,
    "дуги": 1,
    "дуглас": 1,
    "дункан": 1,
    "дунстан": 1,
    "дью": 1,
    "дьюей": 1,
    "дьюэйн": 1,
    "дэвид": 1,
    "дэвис": 1,
    "дэй": 1,
    "дэйви": 1,
    "дэйн": 1,
    "дэйтон": 1,
    "дэн": 1,
    "дэни": 1,
    "дэниел": 1,
    "дэнни": 1,
    "дэррик": 1,
    "дэшон": 1,
    "дюк": 1,
    "евгений": 1,
    "евграф": 1,
    "евдоким": 1,
    "евлампий": 1,
    "евлогий": 1,
    "евсей": 1,
    "евстафий": 1,
    "егор": 1,
    "елеазар": 1,
    "елизар": 1,
    "елисей": 1,
    "емельян": 1,
    "епифан": 1,
    "еремей": 1,
    "ермак": 1,
    "ермил": 1,
    "ермолай": 1,
    "ерофей": 1,
    "еруслан": 1,
    "ефим": 1,
    "ефрем": 1,
    "ждан": 1,
    "жерар": 1,
    "жозеф": 1,
    "жорес": 1,
    "жюль": 1,
    "завир": 1,
    "зак": 1,
    "закери": 1,
    "зандер": 1,
    "захар": 1,
    "захарий": 1,
    "зачариа": 1,
    "зачэри": 1,
    "зед": 1,
    "зедекиа": 1,
    "зек": 1,
    "зигмунд": 1,
    "зигфрид": 1,
    "зиновий": 1,
    "зорий": 1,
    "зосим": 1,
    "зосима": 1,
    "зот": 1,
    "зубин": 1,
    "зэофилус": 1,
    "иб": 1,
    "ибрагим": 1,
    "иван": 1,
    "игнат": 1,
    "игнатий": 1,
    "игнатиус": 1,
    "игорь": 1,
    "ид": 1,
    "иероним": 1,
    "иззи": 1,
    "изидор": 1,
    "измаил": 1,
    "измайло": 1,
    "изяслав": 1,
    "ий": 1,
    "икар": 1,
    "илар": 1,
    "иларий": 1,
    "иларион": 1,
    "илий": 1,
    "илиодор": 1,
    "илларион": 1,
    "илья": 1,
    "имон": 1,
    "инглеберт": 1,
    "инграм": 1,
    "инди": 1,
    "индиана": 1,
    "индиго": 1,
    "инесент": 1,
    "иниго": 1,
    "иннокентий": 1,
    "иоанн": 1,
    "иорик": 1,
    "иосиф": 1,
    "ипат": 1,
    "ипатий": 1,
    "ипполит": 1,
    "ираклий": 1,
    "ирвайн": 1,
    "ирвин": 1,
    "ирвинг": 1,
    "ириней": 1,
    "ириний": 1,
    "ирл": 1,
    "ирм": 1,
    "ирнест": 1,
    "исай": 1,
    "исайя": 1,
    "исак": 1,
    "исакий": 1,
    "исей": 1,
    "исидор": 1,
    "иссак": 1,
    "исси": 1,
    "истер": 1,
    "июлий": 1,
    "йорк": 1,
    "ка": 1,
    "кадмус": 1,
    "казимир": 1,
    "каин": 1,
    "каир": 1,
    "кайд": 1,
    "кайл": 1,
    "кал": 1,
    "калин": 1,
    "калина": 1,
    "каллен": 1,
    "кам": 1,
    "камден": 1,
    "камиль": 1,
    "камрон": 1,
    "капитон": 1,
    "карбрей": 1,
    "карбри": 1,
    "карвер": 1,
    "карей": 1,
    "карен": 1,
    "карл": 1,
    "карлайл": 1,
    "карлейл": 1,
    "карлин": 1,
    "карлтон": 1,
    "карм": 1,
    "кармий": 1,
    "карп": 1,
    "каррол": 1,
    "картер": 1,
    "касиди": 1,
    "каспар": 1,
    "каспер": 1,
    "кассиди": 1,
    "касьян": 1,
    "квентин": 1,
    "квинтин": 1,
    "кеван": 1,
    "кевин": 1,
    "кей": 1,
    "кейденс": 1,
    "кейдн": 1,
    "кейлб": 1,
    "кеймрон": 1,
    "кейси": 1,
    "келвин": 1,
    "келкей": 1,
    "келл": 1,
    "келли": 1,
    "келсей": 1,
    "кемп": 1,
    "кен": 1,
    "кендал": 1,
    "кендол": 1,
    "кендрик": 1,
    "кенелм": 1,
    "кензи": 1,
    "кенит": 1,
    "кеннеди": 1,
    "кеннет": 1,
    "кенни": 1,
    "кеннит": 1,
    "кенрик": 1,
    "кент": 1,
    "кентиджерн": 1,
    "кентон": 1,
    "кермит": 1,
    "керней": 1,
    "керр": 1,
    "керри": 1,
    "керт": 1,
    "кертис": 1,
    "кешон": 1,
    "ки": 1,
    "киаран": 1,
    "килан": 1,
    "килер": 1,
    "килиан": 1,
    "киллиан": 1,
    "ким": 1,
    "кимбелайн": 1,
    "кимберли": 1,
    "кимбол": 1,
    "кимбэль": 1,
    "кин": 1,
    "кинан": 1,
    "кинастон": 1,
    "кинг": 1,
    "кингслей": 1,
    "кип": 1,
    "киприан": 1,
    "кир": 1,
    "киран": 1,
    "кирби": 1,
    "кирилл": 1,
    "кирк": 1,
    "кирон": 1,
    "кирус": 1,
    "кит": 1,
    "китон": 1,
    "киф": 1,
    "клавдий": 1,
    "клайв": 1,
    "клайд": 1,
    "кланкей": 1,
    "кланки": 1,
    "кларенс": 1,
    "кларк": 1,
    "клев": 1,
    "клей": 1,
    "клейтон": 1,
    "клем": 1,
    "клемент": 1,
    "клементий": 1,
    "клемми": 1,
    "клетис": 1,
    "клетус": 1,
    "кливленд": 1,
    "клим": 1,
    "климент": 1,
    "климентий": 1,
    "клинт": 1,
    "клинтон": 1,
    "клифтон": 1,
    "клифф": 1,
    "клиффорд": 1,
    "клод": 1,
    "клэйрк": 1,
    "клэр": 1,
    "кодей": 1,
    "коди": 1,
    "коертней": 1,
    "козьма": 1,
    "кола": 1,
    "коламбан": 1,
    "колберт": 1,
    "колби": 1,
    "колдер": 1,
    "колин": 1,
    "коллахан": 1,
    "коллин": 1,
    "коллум": 1,
    "колтен": 1,
    "колтон": 1,
    "колумбий": 1,
    "кольт": 1,
    "конан": 1,
    "конвей": 1,
    "кондрат": 1,
    "кондратий": 1,
    "конлей": 1,
    "коннелл": 1,
    "коннер": 1,
    "коннор": 1,
    "конон": 1,
    "конор": 1,
    "конрад": 1,
    "константин": 1,
    "конфуций": 1,
    "корбин": 1,
    "корделл": 1,
    "корей": 1,
    "кори": 1,
    "корней": 1,
    "корнелий": 1,
    "корнелиус": 1,
    "корнил": 1,
    "кортней": 1,
    "кортни": 1,
    "корэй": 1,
    "коти": 1,
    "коул": 1,
    "коулман": 1,
    "краснослав": 1,
    "крис": 1,
    "криспиан": 1,
    "криспин": 1,
    "кристи": 1,
    "кристиан": 1,
    "кристопэр": 1,
    "кристоф": 1,
    "кристофер": 1,
    "крофорд": 1,
    "крофтон": 1,
    "крэйг": 1,
    "ксавайор": 1,
    "ксавьер": 1,
    "ксан": 1,
    "ксенофонт": 1,
    "ксзавир": 1,
    "кузьма": 1,
    "куин": 1,
    "куинкей": 1,
    "куинси": 1,
    "куинтон": 1,
    "купер": 1,
    "куприян": 1,
    "курт": 1,
    "куртис": 1,
    "кэйд": 1,
    "кэйдн": 1,
    "кэйл": 1,
    "кэйлб": 1,
    "кэймрон": 1,
    "кэйн": 1,
    "кэйси": 1,
    "кэлвин": 1,
    "кэм": 1,
    "кэмп": 1,
    "кэмпбэл": 1,
    "кэри": 1,
    "кюри": 1,
    "лаверн": 1,
    "лавлл": 1,
    "лавр": 1,
    "лаврентий": 1,
    "лаз": 1,
    "лазарь": 1,
    "лайл": 1,
    "лайонел": 1,
    "лаки": 1,
    "ланни": 1,
    "ланфорд": 1,
    "ларион": 1,
    "ларк": 1,
    "ларкин": 1,
    "ларри": 1,
    "лаэрт": 1,
    "лев": 1,
    "леви": 1,
    "левкий": 1,
    "лейврн": 1,
    "лейн": 1,
    "лейтон": 1,
    "лекс": 1,
    "леланд": 1,
    "лель": 1,
    "лем": 1,
    "лемми": 1,
    "лемюэль": 1,
    "лен": 1,
    "ленар": 1,
    "ленард": 1,
    "лени": 1,
    "лениан": 1,
    "леннард": 1,
    "ленни": 1,
    "лео": 1,
    "леон": 1,
    "леонард": 1,
    "леонид": 1,
    "леонтий": 1,
    "леопольд": 1,
    "лермонт": 1,
    "лерой": 1,
    "лес": 1,
    "лесли": 1,
    "лестер": 1,
    "ли": 1,
    "либерт": 1,
    "ливадий": 1,
    "лии": 1,
    "лин": 1,
    "линдон": 1,
    "линдсей": 1,
    "линдси": 1,
    "линкольн": 1,
    "линн": 1,
    "линсей": 1,
    "линтон": 1,
    "линус": 1,
    "линфорд": 1,
    "лионель": 1,
    "лир": 1,
    "лирой": 1,
    "лисандр": 1,
    "литон": 1,
    "лихнис": 1,
    "ллойд": 1,
    "ллью": 1,
    "лльюелин": 1,
    "лльюеллин": 1,
    "ло": 1,
    "ловэль": 1,
    "лойд": 1,
    "лон": 1,
    "лондон": 1,
    "лонни": 1,
    "лонс": 1,
    "лор": 1,
    "лорен": 1,
    "лоренс": 1,
    "лори": 1,
    "лорин": 1,
    "лорис": 1,
    "лорни": 1,
    "лоррин": 1,
    "лосон": 1,
    "лоуэлл": 1,
    "лоэнгрин": 1,
    "лу": 1,
    "лудо": 1,
    "луи": 1,
    "лука": 1,
    "лукиан": 1,
    "лукьян": 1,
    "льюин": 1,
    "льюис": 1,
    "лэйк": 1,
    "лэйн": 1,
    "лэйтон": 1,
    "лэндон": 1,
    "лэнс": 1,
    "лэрри": 1,
    "любим": 1,
    "любомир": 1,
    "людвиг": 1,
    "людовик": 1,
    "люк": 1,
    "люкс": 1,
    "люксен": 1,
    "люсьен": 1,
    "лютер": 1,
    "люциан": 1,
    "маверик": 1,
    "маврикий": 1,
    "мадисон": 1,
    "маеслав": 1,
    "май": 1,
    "майк": 1,
    "майкл": 1,
    "майлз": 1,
    "майрон": 1,
    "майслав": 1,
    "макар": 1,
    "макарий": 1,
    "макей": 1,
    "макензи": 1,
    "маки": 1,
    "макинтош": 1,
    "маккензи": 1,
    "макс": 1,
    "максвелл": 1,
    "максим": 1,
    "максимилиан": 1,
    "максимиллиан": 1,
    "максимильян": 1,
    "малачи": 1,
    "малком": 1,
    "малоун": 1,
    "манлей": 1,
    "манни": 1,
    "манникс": 1,
    "мануил": 1,
    "мануйло": 1,
    "манфред": 1,
    "марат": 1,
    "марвин": 1,
    "мариан": 1,
    "марин": 1,
    "мариус": 1,
    "марк": 1,
    "марка": 1,
    "маркел": 1,
    "маркиан": 1,
    "марко": 1,
    "маркус": 1,
    "марлен": 1,
    "марлин": 1,
    "марлон": 1,
    "марлоу": 1,
    "мармадьюк": 1,
    "марри": 1,
    "марс": 1,
    "марсен": 1,
    "марти": 1,
    "мартиал": 1,
    "мартин": 1,
    "мартын": 1,
    "маршал": 1,
    "маршалл": 1,
    "марьян": 1,
    "масон": 1,
    "мастерман": 1,
    "матвей": 1,
    "матти": 1,
    "мед": 1,
    "мелвилль": 1,
    "мелвин": 1,
    "мельбурн": 1,
    "мерв": 1,
    "мервин": 1,
    "мерди": 1,
    "мердо": 1,
    "мердок": 1,
    "мередит": 1,
    "мерит": 1,
    "меркурий": 1,
    "мерл": 1,
    "мерлин": 1,
    "меррилл": 1,
    "мерритт": 1,
    "мертон": 1,
    "мерфи": 1,
    "мефодий": 1,
    "мечеслав": 1,
    "мечислав": 1,
    "мид": 1,
    "миид": 1,
    "мик": 1,
    "мика": 1,
    "мики": 1,
    "микки": 1,
    "милад": 1,
    "милан": 1,
    "милберн": 1,
    "милен": 1,
    "милий": 1,
    "миллард": 1,
    "мило": 1,
    "милонег": 1,
    "милослав": 1,
    "милтон": 1,
    "милфорд": 1,
    "мир": 1,
    "мирон": 1,
    "мирослав": 1,
    "митчелл": 1,
    "михаил": 1,
    "михайло": 1,
    "мич": 1,
    "мича": 1,
    "мичил": 1,
    "мо": 1,
    "модест": 1,
    "моз": 1,
    "моисей": 1,
    "молком": 1,
    "монолит": 1,
    "монро": 1,
    "монтагью": 1,
    "монтгомери": 1,
    "монте": 1,
    "монти": 1,
    "монтморенки": 1,
    "морган": 1,
    "морген": 1,
    "мордекэй": 1,
    "морис": 1,
    "морлей": 1,
    "моррис": 1,
    "морт": 1,
    "морти": 1,
    "мортимер": 1,
    "мортон": 1,
    "мосс": 1,
    "моэ": 1,
    "мстислав": 1,
    "мулава": 1,
    "мурат": 1,
    "мэйнард": 1,
    "мэйнерд": 1,
    "мэйор": 1,
    "мэйсон": 1,
    "мэйтланд": 1,
    "мэлори": 1,
    "мэль": 1,
    "мэриан": 1,
    "мэрион": 1,
    "мэт": 1,
    "мэтт": 1,
    "мэтти": 1,
    "мэтью": 1,
    "мюд": 1,
    "надир": 1,
    "назаниль": 1,
    "назар": 1,
    "назарий": 1,
    "назим": 1,
    "найджел": 1,
    "найлс": 1,
    "наль": 1,
    "нанди": 1,
    "нат": 1,
    "натан": 1,
    "наум": 1,
    "науэлл": 1,
    "наш": 1,
    "невада": 1,
    "неван": 1,
    "невил": 1,
    "невилл": 1,
    "нед": 1,
    "нейл": 1,
    "нейлл": 1,
    "нейт": 1,
    "нельсон": 1,
    "нео": 1,
    "неон": 1,
    "неонил": 1,
    "нестер": 1,
    "нестор": 1,
    "нивек": 1,
    "нивен": 1,
    "ник": 1,
    "никандр": 1,
    "никанор": 1,
    "никита": 1,
    "никифор": 1,
    "никк": 1,
    "никки": 1,
    "никодим": 1,
    "никола": 1,
    "николай": 1,
    "николас": 1,
    "никон": 1,
    "нил": 1,
    "нили": 1,
    "нимбус": 1,
    "нинел": 1,
    "нинель": 1,
    "нисон": 1,
    "нифонт": 1,
    "ноа": 1,
    "новомир": 1,
    "нодар": 1,
    "ной": 1,
    "нолан": 1,
    "нолл": 1,
    "норберт": 1,
    "норвуд": 1,
    "норд": 1,
    "норм": 1,
    "норман": 1,
    "норманд": 1,
    "норрис": 1,
    "нортон": 1,
    "ноубль": 1,
    "ноэль": 1,
    "ньют": 1,
    "ньютон": 1,
    "оберон": 1,
    "обин": 1,
    "обри": 1,
    "овидий": 1,
    "огастин": 1,
    "огден": 1,
    "огэст": 1,
    "оделл": 1,
    "одиссей": 1,
    "одлей": 1,
    "одран": 1,
    "оз": 1,
    "оззи": 1,
    "океан": 1,
    "оксар": 1,
    "октавиан": 1,
    "октябрин": 1,
    "октябрь": 1,
    "олби": 1,
    "олбэйн": 1,
    "олдвен": 1,
    "олдвин": 1,
    "олден": 1,
    "олдин": 1,
    "олдис": 1,
    "олдон": 1,
    "олдос": 1,
    "олдред": 1,
    "олдус": 1,
    "олдфорд": 1,
    "олег": 1,
    "олей": 1,
    "оли": 1,
    "оливер": 1,
    "олимпий": 1,
    "олластер": 1,
    "олластир": 1,
    "оллгар": 1,
    "оллджер": 1,
    "олли": 1,
    "оллин": 1,
    "оллисдэйр": 1,
    "оллистер": 1,
    "оллистэйр": 1,
    "оллон": 1,
    "оллэйстар": 1,
    "ольгерд": 1,
    "омар": 1,
    "омега": 1,
    "онисим": 1,
    "ора": 1,
    "оран": 1,
    "орвал": 1,
    "орвилл": 1,
    "орест": 1,
    "ориан": 1,
    "ормерод": 1,
    "оррелл": 1,
    "оррин": 1,
    "орсон": 1,
    "осберт": 1,
    "осбоерн": 1,
    "осборн": 1,
    "освальд": 1,
    "осень": 1,
    "осип": 1,
    "оскар": 1,
    "остап": 1,
    "остен": 1,
    "остин": 1,
    "остромир": 1,
    "отис": 1,
    "оттис": 1,
    "отто": 1,
    "оттон": 1,
    "оуин": 1,
    "оуэн": 1,
    "ошин": 1,
    "павел": 1,
    "пайс": 1,
    "палладий": 1,
    "палмер": 1,
    "панкрас": 1,
    "пантелей": 1,
    "пантелеймон": 1,
    "панфил": 1,
    "парамон": 1,
    "паркер": 1,
    "паррис": 1,
    "партизан": 1,
    "пат": 1,
    "патрик": 1,
    "патси": 1,
    "пахом": 1,
    "пеитон": 1,
    "пепин": 1,
    "пересвет": 1,
    "перри": 1,
    "перс": 1,
    "перси": 1,
    "персиваль": 1,
    "петеркин": 1,
    "пимен": 1,
    "пип": 1,
    "пипер": 1,
    "пирр": 1,
    "пирс": 1,
    "пит": 1,
    "питер": 1,
    "платон": 1,
    "пол": 1,
    "поли": 1,
    "поликарп": 1,
    "помпей": 1,
    "портер": 1,
    "порфирий": 1,
    "потап": 1,
    "престон": 1,
    "приам": 1,
    "принц": 1,
    "пров": 1,
    "прозор": 1,
    "прокопий": 1,
    "прокофий": 1,
    "проспер": 1,
    "протас": 1,
    "прохор": 1,
    "пэйс": 1,
    "пэйси": 1,
    "пэйтон": 1,
    "пётр": 1,
    "петр": 1,
    "равель": 1,
    "равен": 1,
    "равиль": 1,
    "радамес": 1,
    "радий": 1,
    "радим": 1,
    "радислав": 1,
    "радомир": 1,
    "раз": 1,
    "раймонд": 1,
    "раймунд": 1,
    "райордан": 1,
    "райт": 1,
    "ралф": 1,
    "ралфи": 1,
    "ральф": 1,
    "ранделл": 1,
    "ранди": 1,
    "рандолф": 1,
    "рандольф": 1,
    "расс": 1,
    "рассел": 1,
    "рассэль": 1,
    "расти": 1,
    "растус": 1,
    "ратмир": 1,
    "рауль": 1,
    "рафаил": 1,
    "рафаэль": 1,
    "рашид": 1,
    "раян": 1,
    "реарден": 1,
    "ревмир": 1,
    "реган": 1,
    "редд": 1,
    "редж": 1,
    "реджи": 1,
    "реджинальд": 1,
    "редклиф": 1,
    "редклифф": 1,
    "редлей": 1,
    "редманд": 1,
    "редмонд": 1,
    "реид": 1,
    "рей": 1,
    "рейли": 1,
    "рейнард": 1,
    "рейнольд": 1,
    "рекс": 1,
    "рем": 1,
    "ренальд": 1,
    "ренат": 1,
    "риган": 1,
    "ригби": 1,
    "рид": 1,
    "ридлей": 1,
    "риель": 1,
    "рик": 1,
    "рикей": 1,
    "рики": 1,
    "рилан": 1,
    "рилей": 1,
    "рили": 1,
    "ринат": 1,
    "рио": 1,
    "риплей": 1,
    "рис": 1,
    "рихард": 1,
    "рич": 1,
    "ричард": 1,
    "ричи": 1,
    "роальд": 1,
    "роб": 1,
    "робби": 1,
    "роберт": 1,
    "робеспьер": 1,
    "роби": 1,
    "робин": 1,
    "робинзон": 1,
    "рован": 1,
    "род": 1,
    "роддж": 1,
    "родджер": 1,
    "родди": 1,
    "родерик": 1,
    "роджер": 1,
    "родион": 1,
    "родни": 1,
    "родолф": 1,
    "рождеро": 1,
    "рой": 1,
    "ройл": 1,
    "ройс": 1,
    "ройстон": 1,
    "роки": 1,
    "ролан": 1,
    "роланд": 1,
    "роли": 1,
    "ролланд": 1,
    "ролли": 1,
    "роман": 1,
    "ромен": 1,
    "ромуальд": 1,
    "рон": 1,
    "рональд": 1,
    "ронни": 1,
    "рори": 1,
    "роско": 1,
    "росс": 1,
    "ростислав": 1,
    "роуланд": 1,
    "роулей": 1,
    "роял": 1,
    "рубен": 1,
    "рубин": 1,
    "руди": 1,
    "рудольф": 1,
    "рудьярд": 1,
    "рунар": 1,
    "руслан": 1,
    "руссо": 1,
    "рустам": 1,
    "рустем": 1,
    "рхетт": 1,
    "рьюб": 1,
    "рэд": 1,
    "рэй": 1,
    "рэйнард": 1,
    "рэйнер": 1,
    "рэйф": 1,
    "рэм": 1,
    "рэндал": 1,
    "рэндалл": 1,
    "рюрик": 1,
    "сава": 1,
    "савва": 1,
    "савелий": 1,
    "савьер": 1,
    "сайг": 1,
    "саймон": 1,
    "салал": 1,
    "салливан": 1,
    "самми": 1,
    "самойло": 1,
    "самсон": 1,
    "самуил": 1,
    "сандфорд": 1,
    "санни": 1,
    "санфорд": 1,
    "свет": 1,
    "светлан": 1,
    "светозар": 1,
    "светослав": 1,
    "свизин": 1,
    "свизун": 1,
    "свиней": 1,
    "святогор": 1,
    "святополк": 1,
    "святослав": 1,
    "себастьян": 1,
    "севард": 1,
    "севастиан": 1,
    "севастьян": 1,
    "север": 1,
    "севериан": 1,
    "северин": 1,
    "северьян": 1,
    "северян": 1,
    "седрик": 1,
    "сеймур": 1,
    "селби": 1,
    "семён": 1,
    "септембер": 1,
    "серапион": 1,
    "серафим": 1,
    "сергей": 1,
    "сесил": 1,
    "сет": 1,
    "сефтон": 1,
    "сивард": 1,
    "сигизмунд": 1,
    "сигманд": 1,
    "сид": 1,
    "сидней": 1,
    "сидор": 1,
    "сила": 1,
    "силас": 1,
    "силвестр": 1,
    "сильвер": 1,
    "сильвест": 1,
    "сильвестр": 1,
    "симеон": 1,
    "симон": 1,
    "синклэйр": 1,
    "сирил": 1,
    "сисар": 1,
    "скай": 1,
    "скилар": 1,
    "скилер": 1,
    "скот": 1,
    "скотти": 1,
    "скуилер": 1,
    "слава": 1,
    "слай": 1,
    "слэйд": 1,
    "совет": 1,
    "сократ": 1,
    "соломон": 1,
    "сони": 1,
    "сонни": 1,
    "софокл": 1,
    "софон": 1,
    "спайк": 1,
    "спарроу": 1,
    "спартак": 1,
    "спенсер": 1,
    "спиридон": 1,
    "спиро": 1,
    "стакей": 1,
    "сталий": 1,
    "сталь": 1,
    "станислав": 1,
    "стаффорд": 1,
    "степан": 1,
    "стерлинг": 1,
    "стеф": 1,
    "стефан": 1,
    "сти": 1,
    "стив": 1,
    "стивен": 1,
    "стиви": 1,
    "стиу": 1,
    "сторм": 1,
    "стратон": 1,
    "сту": 1,
    "стэки": 1,
    "стэн": 1,
    "стэнли": 1,
    "стэнфорд": 1,
    "стюарт": 1,
    "сурен": 1,
    "сэм": 1,
    "сэмюэль": 1,
    "сэнди": 1,
    "тад": 1,
    "таддеус": 1,
    "таир": 1,
    "тай": 1,
    "такер": 1,
    "тал": 1,
    "талбот": 1,
    "таннер": 1,
    "тарас": 1,
    "таскилл": 1,
    "таффи": 1,
    "тед": 1,
    "тейгу": 1,
    "тейдж": 1,
    "теймураз": 1,
    "тейрк": 1,
    "текс": 1,
    "тельнан": 1,
    "тенгиз": 1,
    "тенней": 1,
    "теннизон": 1,
    "тео": 1,
    "теобальд": 1,
    "теодор": 1,
    "теранс": 1,
    "теренс": 1,
    "терентий": 1,
    "терло": 1,
    "терранс": 1,
    "террелл": 1,
    "терренс": 1,
    "терстон": 1,
    "ти": 1,
    "тиарнак": 1,
    "тиарнан": 1,
    "тибалт": 1,
    "тибби": 1,
    "тигран": 1,
    "тигу": 1,
    "тизон": 1,
    "тилар": 1,
    "тилер": 1,
    "тилор": 1,
    "тим": 1,
    "тимми": 1,
    "тимоти": 1,
    "тимофей": 1,
    "тимур": 1,
    "тирелл": 1,
    "тирнан": 1,
    "тирней": 1,
    "тирон": 1,
    "тироун": 1,
    "тиррелл": 1,
    "тит": 1,
    "тихомир": 1,
    "тихон": 1,
    "тоал": 1,
    "тоби": 1,
    "тобиас": 1,
    "тобин": 1,
    "товий": 1,
    "тод": 1,
    "тодд": 1,
    "толли": 1,
    "том": 1,
    "томас": 1,
    "томми": 1,
    "тон": 1,
    "тони": 1,
    "топэр": 1,
    "торез": 1,
    "торий": 1,
    "торлей": 1,
    "торнтон": 1,
    "травис": 1,
    "тракей": 1,
    "трантер": 1,
    "траффорд": 1,
    "траэрн": 1,
    "трев": 1,
    "тревельян": 1,
    "тревор": 1,
    "трейврс": 1,
    "трейс": 1,
    "трейси": 1,
    "трент": 1,
    "трентон": 1,
    "тристан": 1,
    "тристрам": 1,
    "трифон": 1,
    "трой": 1,
    "трофим": 1,
    "труман": 1,
    "туллий": 1,
    "тусон": 1,
    "тэдди": 1,
    "тэди": 1,
    "тэйлер": 1,
    "тэйлор": 1,
    "тэйн": 1,
    "тэйт": 1,
    "тэл": 1,
    "тэмпл": 1,
    "тэрри": 1,
    "уилбер": 1,
    "уиллард": 1,
    "уиллис": 1,
    "уилфред": 1,
    "уилфрид": 1,
    "уильям": 1,
    "уинстон": 1,
    "уинфред": 1,
    "уисдом": 1,
    "улайксс": 1,
    "улиссес": 1,
    "ульяна": 1,
    "уолли": 1,
    "уоллис": 1,
    "уолт": 1,
    "уолтер": 1,
    "уолтон": 1,
    "уорик": 1,
    "уорнер": 1,
    "уоррен": 1,
    "уот": 1,
    "уоткин": 1,
    "уптон": 1,
    "урбан": 1,
    "уриах": 1,
    "устин": 1,
    "уэйн": 1,
    "уэсли": 1,
    "фабиан": 1,
    "фаддей": 1,
    "фадей": 1,
    "фалк": 1,
    "фарид": 1,
    "фарлей": 1,
    "фарон": 1,
    "фарран": 1,
    "февралин": 1,
    "федор": 1,
    "федосий": 1,
    "фелан": 1,
    "фелиз": 1,
    "феликс": 1,
    "фелим": 1,
    "фелис": 1,
    "фентон": 1,
    "феодосий": 1,
    "феофан": 1,
    "ферги": 1,
    "фергус": 1,
    "ферд": 1,
    "ферди": 1,
    "фердинанд": 1,
    "фернан": 1,
    "фернанд": 1,
    "фестер": 1,
    "фестус": 1,
    "фидель": 1,
    "фидо": 1,
    "фил": 1,
    "филайп": 1,
    "филандр": 1,
    "филарет": 1,
    "филат": 1,
    "филберт": 1,
    "филимон": 1,
    "филип": 1,
    "филипп": 1,
    "фило": 1,
    "финикс": 1,
    "финис": 1,
    "флегонт": 1,
    "флемминг": 1,
    "флечер": 1,
    "флинн": 1,
    "флинт": 1,
    "флойд": 1,
    "флорентий": 1,
    "флоренц": 1,
    "флорин": 1,
    "флорри": 1,
    "флурри": 1,
    "фок": 1,
    "фокс": 1,
    "фома": 1,
    "фонз": 1,
    "фонзи": 1,
    "форбес": 1,
    "форд": 1,
    "форест": 1,
    "форрест": 1,
    "фостер": 1,
    "фот": 1,
    "фотий": 1,
    "фоук": 1,
    "фразир": 1,
    "франклин": 1,
    "франц": 1,
    "фред": 1,
    "фредди": 1,
    "фредерик": 1,
    "фредрик": 1,
    "фрейзер": 1,
    "фрейзр": 1,
    "фридрих": 1,
    "фримэн": 1,
    "фритс": 1,
    "фродо": 1,
    "фрол": 1,
    "фрэнк": 1,
    "фрэнки": 1,
    "фрэнклин": 1,
    "фрэнс": 1,
    "фрэнсис": 1,
    "фёдор": 1,
    "хавелок": 1,
    "хадвин": 1,
    "хадлей": 1,
    "хал": 1,
    "хам": 1,
    "хамиш": 1,
    "хамлет": 1,
    "хаммонд": 1,
    "ханк": 1,
    "ханлей": 1,
    "хантер": 1,
    "харв": 1,
    "харви": 1,
    "харди": 1,
    "хардинг": 1,
    "харитон": 1,
    "харкоерт": 1,
    "харлан": 1,
    "харланд": 1,
    "харлей": 1,
    "харлин": 1,
    "хармон": 1,
    "харпер": 1,
    "харрис": 1,
    "харрисон": 1,
    "хартлей": 1,
    "хауелл": 1,
    "хедлей": 1,
    "хек": 1,
    "хендерсон": 1,
    "хендрик": 1,
    "хенрай": 1,
    "хенри": 1,
    "херб": 1,
    "херби": 1,
    "хервей": 1,
    "херлей": 1,
    "хиацинт": 1,
    "хилари": 1,
    "хиллэри": 1,
    "хирам": 1,
    "хис": 1,
    "хитклифф": 1,
    "хию": 1,
    "хоард": 1,
    "хоб": 1,
    "ходдж": 1,
    "хойт": 1,
    "холден": 1,
    "холл": 1,
    "холлис": 1,
    "хомер": 1,
    "хопкин": 1,
    "хорас": 1,
    "хоратайо": 1,
    "хоуи": 1,
    "храбр": 1,
    "христоф": 1,
    "христофор": 1,
    "худд": 1,
    "хуей": 1,
    "хует": 1,
    "хукк": 1,
    "хукслей": 1,
    "хумберт": 1,
    "хунтлей": 1,
    "хуффи": 1,
    "хью": 1,
    "хьюберт": 1,
    "хьюго": 1,
    "хьюи": 1,
    "хэвен": 1,
    "хэдлей": 1,
    "хэйвуд": 1,
    "хэйден": 1,
    "хэйл": 1,
    "хэмфри": 1,
    "хэппи": 1,
    "хюи": 1,
    "цезарь": 1,
    "чад": 1,
    "чадвик": 1,
    "чаз": 1,
    "чак": 1,
    "чакки": 1,
    "чарлз": 1,
    "чарли": 1,
    "чарлтон": 1,
    "чарльз": 1,
    "час": 1,
    "чейз": 1,
    "чендлер": 1,
    "ченс": 1,
    "черокез": 1,
    "чеслав": 1,
    "честер": 1,
    "чеьянн": 1,
    "чип": 1,
    "чонки": 1,
    "чонси": 1,
    "ша": 1,
    "шад": 1,
    "шаи": 1,
    "шайенн": 1,
    "шакуилл": 1,
    "шамиль": 1,
    "шамус": 1,
    "шан": 1,
    "шаннен": 1,
    "шаннон": 1,
    "шау": 1,
    "шеврон": 1,
    "шелби": 1,
    "шелдон": 1,
    "шеллей": 1,
    "шелтон": 1,
    "шем": 1,
    "шервуд": 1,
    "шеридан": 1,
    "шерлок": 1,
    "шерман": 1,
    "ши": 1,
    "шилох": 1,
    "шимус": 1,
    "шмидт": 1,
    "шолто": 1,
    "шон": 1,
    "шэй": 1,
    "шэйн": 1,
    "эбби": 1,
    "эбен": 1,
    "эбенезер": 1,
    "эвальд": 1,
    "эван": 1,
    "эвелин": 1,
    "эверард": 1,
    "эверетт": 1,
    "эверитт": 1,
    "эвот": 1,
    "эгберт": 1,
    "эд": 1,
    "эдан": 1,
    "эдвард": 1,
    "эдвин": 1,
    "эдгар": 1,
    "эдди": 1,
    "эдип": 1,
    "эдисон": 1,
    "эдмонд": 1,
    "эдмунд": 1,
    "эдон": 1,
    "эдуард": 1,
    "эдун": 1,
    "эзраа": 1,
    "эзэлстан": 1,
    "эзэлуолф": 1,
    "эйб": 1,
    "эйби": 1,
    "эйвери": 1,
    "эйден": 1,
    "эйлберт": 1,
    "эйлвард": 1,
    "эймерей": 1,
    "эймери": 1,
    "эйнар": 1,
    "эйнслей": 1,
    "эйнсли": 1,
    "эйс": 1,
    "элайотт": 1,
    "элбан": 1,
    "элвин": 1,
    "элвис": 1,
    "элвуд": 1,
    "элгар": 1,
    "элдвен": 1,
    "элдвин": 1,
    "элден": 1,
    "элджер": 1,
    "элдин": 1,
    "элдис": 1,
    "элдон": 1,
    "элдред": 1,
    "элдус": 1,
    "электрон": 1,
    "эли": 1,
    "элиас": 1,
    "элиджа": 1,
    "элиот": 1,
    "элла": 1,
    "эллгар": 1,
    "эллджер": 1,
    "эллери": 1,
    "эллиот": 1,
    "эллис": 1,
    "элмер": 1,
    "элрик": 1,
    "элрой": 1,
    "элсдон": 1,
    "эль": 1,
    "эльберт": 1,
    "эльбрус": 1,
    "эльдар": 1,
    "эльмар": 1,
    "эльмир": 1,
    "эльтон": 1,
    "эмерсон": 1,
    "эмилиан": 1,
    "эмилий": 1,
    "эмиль": 1,
    "эммануель": 1,
    "эммануил": 1,
    "эммерсон": 1,
    "эммет": 1,
    "эмметт": 1,
    "эмори": 1,
    "эмэри": 1,
    "энвер": 1,
    "энгель": 1,
    "энджелберт": 1,
    "энди": 1,
    "эндрю": 1,
    "энергий": 1,
    "энтони": 1,
    "эразм": 1,
    "эраст": 1,
    "эрван": 1,
    "эрвин": 1,
    "эрг": 1,
    "эрек": 1,
    "эрий": 1,
    "эрик": 1,
    "эрих": 1,
    "эрл": 1,
    "эрлен": 1,
    "эрн": 1,
    "эрнест": 1,
    "эрни": 1,
    "эрнст": 1,
    "эрон": 1,
    "эррол": 1,
    "эрролл": 1,
    "этан": 1,
    "этелберт": 1,
    "этелред": 1,
    "этелрик": 1,
    "этелхард": 1,
    "эшли": 1,
    "эюзби": 1,
    "ювеналий": 1,
    "юджин": 1,
    "юлиан": 1,
    "юлий": 1,
    "юлиус": 1,
    "юм": 1,
    "юниор": 1,
    "юпитер": 1,
    "юрий": 1,
    "юстас": 1,
    "юстин": 1,
    "яков": 1,
    "ян": 1,
    "янкей": 1,
    "янки": 1,
    "януарий": 1,
    "ярвуд": 1,
    "яромир": 1,
    "ярополк": 1,
    "ярослав": 1
  }, exports.ruBindingWords = [ "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "пота", "потому", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "тож", "только", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы", "а-ля", "без", "безо", "благодаря", "близ", "в", "ввиду", "вглубь", "вдоль", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "во", "возле", "вокруг", "вопреки", "впереди", "вразрез", "вроде", "вслед", "вследствие", "для", "до", "за", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "к", "ко", "кроме", "кругом", "меж", "между", "мимо", "на", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду", "насупротив", "насчёт", "не", "ниже", "о", "об", "обо", "обок", "около", "окромя", "округ", "от", "относительно", "ото", "перед", "передо", "по", "по-за", "по-над", "поверх", "под", "подле", "подо", "подобно", "позади", "помимо", "поперёк", "порядка", "посередине", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "применительно", "про", "против", "путём", "ради", "с", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "со", "согласно", "спустя", "среди", "средь", "сродни", "судя", "супротив", "у", "через", "чрез", "иже", "какой-либо", "какой-то", "кое-кто", "кой", "кто", "кто-либо", "многий", "мя", "насколько", "немногий", "нещечко", "никой", "ничегошеньки", "се", "сё", "такой-то", "тот-то", "чё", "чево", "чей-либо", "чей-нибудь", "чей-то", "шо", "эта", "кем", "ком", "кому", "нахуя", "чей", "чему", "вам", "вами", "вас", "вы", "Вы", "ее", "её", "его", "ей", "ему", "ею", "им", "ими", "их", "меня", "мне", "мной", "мною", "мы", "нём", "нем", "нам", "нами", "неё", "него", "ней", "нему", "нею", "ним", "ними", "них", "он", "она", "оне", "они", "оно", "тебе", "тебя", "тобой", "тобою", "ты", "я", "иной", "кое-какой", "кое-чей", "кое-что", "кой-какой", "кой-кто", "кто-нибудь", "кто-то", "куда-нибудь", "некто", "нечто", "что-либо", "что-нибудь", "что-то", "весь", "всякий", "любой", "сам", "самый", "таков", "этакий", "другой", "некем", "некому", "нечего", "нечем", "нечему", "никакой", "никто", "ничего", "ничей", "ничем", "ничему", "ничто", "ваш", "ихний", "моё", "мой", "моя", "наш", "свой", "твой", "оный", "сей", "сие", "сии", "сия", "та", "такой", "тот", "ту", "эдакий", "эти", "это", "этот", "ась", "аюшки", "таки", "а", "авось-либо", "ага", "аминь", "б", "бишь", "буквально", "бы", "было", "вишь", "вон", "вот", "вот-вот", "вряд", "всего", "давай", "де", "действительно", "дескать", "добро", "довольно", "ещё", "исключительно", "ить", "ишь", "ка", "кажется", "конечно", "ладно", "лих", "лучше", "мол", "навряд", "наоборот", "небось", "нет", "неужели", "нехай", "никак", "ну", "ну-с", "по-видимому", "пожалуй", "пожалуйста", "полно", "положительно", "предовольно", "простите", "просто-напросто", "пускай", "разумеется", "сём-ка", "сем", "скорее", "спасибо", "так", "то-то", "тоже", "уж", "уже", "ужели", "ужли", "фон", "хорошо", "эдак", "эк", "этак" ];
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.words = {}, exports = window.lastName.plugins.ru.words) : exports = module.exports, function(exports) {
  return exports.adverbs = [ "абсолютно", "адски", "азартно", "активно", "аспидно", "баснословно", "бдительно", "безапелляционно", "безбожно", "безвозвратно", "безгранично", "безжалостно", "беззаветно", "беззастенчиво", "безмерно", "безмятежно", "безнадежно", "безоговорочно", "безраздельно", "безропотно", "безудержно", "безукоризненно", "безумно", "безупречно", "безусловно", "безустанно", "безутешно", "бескомпромиссно", "бесконечно", "беспардонно", "бесповоротно", "беспощадно", "беспредельно", "беспрекословно", "бесследно", "бессовестно", "бесстыдно", "бесчеловечно", "бешено", "бурно", "вдребезги", "вконец", "вовсю", "всемерно", "всесторонне", "всецело", "всячески", "высоко", "глубоко", "горько", "горячо", "грубо", "густо", "диаметрально", "дико", "досконально", "досыта", "дотошно", "дьявольски", "жарко", "жгуче", "железно", "жестко", "жестоко", "живо", "жизненно", "жутко", "запоем", "запредельно", "зверски", "здорово", "злостно", "идеально", "излишне", "изрядно", "изумительно", "исключительно", "исступленно", "истово", "истошно", "исчерпывающе", "кардинально", "катастрофически", "категорически", "клятвенно", "колоссально", "крайне", "крепко", "кристально", "кровно", "крупно", "круто", "люто", "максимально", "мертвецки", "мучительно", "навзрыд", "нагло", "наглухо", "наглядно", "наголову", "надежно", "надрывно", "назубок", "намертво", "наотрез", "напрочь", "нарочито", "насквозь", "настоятельно", "насущно", "начисто", "небывало", "невероятно", "невиданно", "невообразимо", "невыносимо", "невыразимо", "недопустимо", "неизмеримо", "неимоверно", "неистово", "немилосердно", "немыслимо", "необыкновенно", "необычайно", "неописуемо", "неопровержимо", "непомерно", "непоправимо", "непостижимо", "непримиримо", "непробудно", "непроходимо", "неразрывно", "несказанно", "неслыханно", "несметно", "несравненно", "нестерпимо", "неудержимо", "неузнаваемо", "неуклонно", "неукоснительно", "неустанно", "неусыпно", "неутешно", "неутомимо", "нещадно", "оглушительно", "ожесточенно", "ослепительно", "основательно", "остро", "откровенно", "открыто", "отлично", "отменно", "отчаянно", "очень", "панически", "патологически", "пламенно", "плотно", "по-настоящему", "по-собачьи", "подлинно", "подчеркнуто", "позарез", "поистине", "полностью", "поразительно", "порядком", "порядочно", "потрясающе", "предельно", "прекрасно", "преступно", "прилично", "примитивно", "принципиально", "приторно", "пронзительно", "радикально", "разительно", "редкостно", "резко", "рекордно", "свято", "серьезно", "сильно", "слепо", "смертельно", "совершенно", "совсем", "страстно", "страшно", "строго", "строго-настрого", "существенно", "твердо", "тяжело", "тяжко", "убийственно", "удивительно", "ужасающе", "ужасно", "фанатически", "фанатично", "фантастически", "феноменально", "хорошенько", "хорошо", "чертовски", "чрезвычайно", "чрезмерно", "чудовищно", "широко", "шумно", "щедро", "ярко", "яростно" ], exports.unions = [ "а", "а именно", "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "все-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как бы", "как то", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "после того как", "пота", "потому", "потому как", "потому что", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "то есть", "тож", "только", "только что", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы" ], exports.prepositionAll = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо", "включая", "невзирая на", "несмотря на", "по", "по-за", "про", "с", "сквозь", "со", "спустя", "через", "чрез", "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по", "при", "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "среди", "средь", "супротив", "у", "в связи с", "в соответствии с", "вслед за", "лицом к лицу с", "над", "надо", "наряду с", "перед", "передо", "по сравнению с", "по-над", "пред", "предо", "рядом с", "следом за" ], exports.prepositionSimple = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionAcusative = [ "в", "включая", "во", "за", "на", "не в", "не за", "невзирая на", "несмотря на", "о", "об", "обо", "по", "по-за", "под", "подо", "про", "с", "сквозь", "со", "спустя", "через", "чрез" ], exports.prepositionDative = [ "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по" ], exports.prepositionPrepositional = [ "в", "во", "на", "не в", "о", "об", "обо", "по", "при" ], exports.prepositionGenetive = [ "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "меж", "между", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "со", "среди", "средь", "супротив", "у" ], exports.prepositionInstrumental = [ "в связи с", "в соответствии с", "вслед за", "за", "лицом к лицу с", "меж", "между", "над", "надо", "наряду с", "не за", "перед", "передо", "по сравнению с", "по-над", "под", "подо", "пред", "предо", "рядом с", "с", "следом за", "со" ], exports.prepositionWithSingleCase = [ "без", "без ведома", "безо", "благодаря", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в связи с", "в силу", "в соответствии с", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "вдоль по", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "вопреки", "впереди", "впредь до", "вроде", "вслед", "вслед за", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "к", "ко", "кроме", "кругом", "лицом к", "лицом к лицу с", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду с", "насупротив", "насчёт", "начиная с", "не без", "не считая", "невзирая на", "недалеко от", "независимо от", "несмотря на", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "перед", "передо", "по линии", "по мере", "по направлению к", "по отношению к", "по поводу", "по причине", "по случаю", "по сравнению с", "по-за", "по-над", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "подобно", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "при помощи", "применительно к", "про", "против", "путём", "ради", "рядом с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "согласно", "спустя", "среди", "средь", "сродни", "судя по", "супротив", "у", "через", "чрез" ], exports.prepositionWith2Cases = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionWith3Cases = [ "по", "с", "со" ];
}(exports);

var exports, ref, util, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.dates = {}, exports = window.lastName.plugins.ru.dates, ref = window.lastName.plugins.ru.ref, util = window.lastName.util) : (exports = module.exports, ref = require("./ref"), util = require("../../util")), function(exports, util, ref) {
  var dateObjectToString, extractDates, getRuMonthIndex, getValidDate, packDates, packIntervals, ruMonthInDates;
  return ruMonthInDates = [ "января", "февраля", "марта", "аперля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря" ], dateObjectToString = function(dateObj) {
    var d, m, y, _ref;
    return y = ((_ref = typeof dateObj.y) === "number" || _ref === "string") && dateObj.y || "", m = dateObj.m + 1, m = m > 9 && m || "0" + m, d = dateObj.d > 9 && dateObj.d || "0" + dateObj.d, "" + d + "." + m + "." + y;
  }, getValidDate = function(dateObj) {
    var defaultYear, dt;
    defaultYear = dateObj.y;
    if (void 0 === dateObj.y || dateObj.y < 1970 || dateObj.y > 2038) dateObj.y = 2e3;
    return dt = new Date(Date.UTC(dateObj.y, dateObj.m, dateObj.d)), dt.getMonth() === dateObj.m && dt.getDate() === dateObj.d ? (dateObj.y = defaultYear, dateObj) : null;
  }, getRuMonthIndex = function(str) {
    var m;
    return m = str.toLowerCase().match(/(\s|^)(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s|$)/g), m ? ruMonthInDates.indexOf(m[0].replace(/\s/g, "")) : -1;
  }, exports.extractDates = extractDates = function(strArr) {
    var dates, intervals, sources;
    return dates = {}, sources = [], intervals = {}, strArr instanceof Array || (strArr = [ strArr ]), strArr.map(function(str) {
      var dStr, date, found, from, fromDate, fromMonth, fromYear, id, intObject, mIndex, sourceStr, to, toDate, toYear, verboseMatch, wordsArr, _ref, _results;
      verboseMatch = str.match(/\s+\d{1,2}\s+((января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)\s+|)(\d{2,4}(\s+года|)\s+|)по\s+\d{1,2}\s+(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s+\d{2,4}|)(\s+|$)/mig);
      if (!verboseMatch) {
        wordsArr = str.split(" "), found = !1, _results = [];
        while (wordsArr.length > 2 && !found) /^\d[\d]$/.test(wordsArr[0]) && (mIndex = ruMonthInDates.indexOf(wordsArr[1].toLowerCase()), mIndex >= 0 ? (date = {
          d: parseInt(wordsArr[0], 10),
          m: mIndex
        }, /^\d{2,4}$/.test(wordsArr[2]) ? (date.y = parseInt(wordsArr[2], 10), sourceStr = wordsArr.slice(0, 3).join(" ")) : sourceStr = wordsArr.slice(0, 2).join(" ")) : /^\d\d\.\d\d.\d{2,4}$/.test(wordsArr[0] || /^\d\d\.\d\d$/.test(wordsArr[0])) ? (date = {
          d: parseInt(wordsArr[0].slice(0, 3), 10),
          m: parseInt(wordsArr[0].slice(3, 6), 10),
          y: parseInt(wordsArr[0].slice(6), 10) || void 0
        }, sourceStr = wordsArr[0]) : date = {}, date = getValidDate(date), date && (found = !0, sources.push(sourceStr), dStr = dateObjectToString(date), dates[dStr] ? dates[dStr].count++ : dates[dStr] = {
          count: 1,
          value: date
        })), _results.push(wordsArr.shift());
        return _results;
      }
      _ref = verboseMatch[0].toLowerCase().split("по"), from = _ref[0], to = _ref[1], toYear = to.replace(/\d{1,2}/, "").match(/\d+/g), toYear ? toYear = parseInt(toYear[0], 10) : toYear = void 0, toDate = {
        d: parseInt(to.match(/\d{1,2}/g)[0], 10),
        m: getRuMonthIndex(to),
        y: toYear
      }, fromYear = from.replace(/\d{1,2}/, "").match(/\d+/g), fromMonth = getRuMonthIndex(from), fromYear ? fromYear = parseInt(fromYear[0], 10) : fromYear = toYear, fromMonth === -1 && (fromMonth = toDate.m), fromDate = {
        d: parseInt(from.match(/\d{1,2}/g)[0], 10),
        m: fromMonth,
        y: fromYear
      }, toDate = getValidDate(toDate), fromDate = getValidDate(fromDate);
      if (toDate && fromDate) return intObject = {
        from: dateObjectToString(fromDate),
        from_value: fromDate,
        to: dateObjectToString(toDate),
        to_value: toDate
      }, id = "" + intObject.from + "-" + intObject.to, intervals[id] ? intervals[id].count++ : (intObject.count = 1, intervals[id] = intObject), sources.push(verboseMatch[0]);
    }), {
      dates: dates,
      sources: sources,
      intervals: intervals
    };
  }, exports.packDates = packDates = function(dates, defaultYear) {
    var dateObj, id, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in dates) dateObj = dates[id], "undefined" != typeof dateObj.value.y && years.push(dateObj.value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in dates) dateObj = dates[id], "undefined" == typeof dateObj.value.y && (dateObj.value.y = defaultYear), out["" + dateObjectToString(dateObj.value)] = dateObj.count;
    return out;
  }, exports.packIntervals = packIntervals = function(intervals, defaultYear) {
    var id, interval, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in intervals) interval = intervals[id], "undefined" != typeof interval.from_value.y && years.push(interval.from_value.y), "undefined" != typeof interval.to_value.y && years.push(interval.to_value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in intervals) interval = intervals[id], "undefined" == typeof interval.from_value.y && (interval.from_value.y = defaultYear), "undefined" == typeof interval.to_value.y && (interval.to_value.y = defaultYear), out["" + dateObjectToString(interval.from_value) + "-" + dateObjectToString(interval.to_value)] = interval.count;
    return out;
  }, exports.preFilter = function(text, result) {
    var dates, numRe;
    numRe = /((([а-яё]+)\s+){0,1}\d[\.\d]{0,}(\s+(([a-яё]+)|([\.\d]+))){1,6})|([12]\d\d\d)/mig, dates = extractDates(util.unique(text.match(numRe) || [])), util.dictKeys(dates.dates).length > 0 && (result.dates = packDates(dates.dates)), util.dictKeys(dates.intervals).length > 0 && (result.intervals = packIntervals(dates.intervals));
    if (dates.sources.length > 0) return result.date_sources = dates.sources;
  };
}(exports, util, ref);

var exports, ref, util, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.inclines = {}, exports = window.lastName.plugins.ru.inclines, util = window.lastName.util, ref = window.lastName.plugins.ru.ref) : (exports = module.exports, util = require("../../util"), ref = require("./ref")), function(exports, util, ref) {
  var cases, doInclineFemaleName, doInclineMaleName, findProperName, genderMatch, getNominative, inclineAndGetResult, inclineFemMiddleName, inclineFemaleName, inclineFemaleNameAndGetResult, inclineFemaleSurname, inclineMaleMiddleName, inclineMaleName, inclineMaleNameAndGetResult, inclineMaleSurname, inclineMiddleName, inclineMiddleNameOrSurname, inclineName, inclinePersonSurname, inclineSurname, matchCase, matchNameAndSurname, matchNameParts;
  return cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ], exports.doInclineFemaleName = doInclineFemaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, aUnstressedRe, name2;
    return aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, aUnstressedRe = /ца$/g, name2 = name.slice(0, -1), aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aUnstressedRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ей", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /ия$/g.test(name) && name.length > 3 ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "и" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ь", "" + name2 + "ью", "" + name2 + "и" ] : /[жшщцч]$/g.test(name) ? [ "" + name, "" + name + "и", "" + name + "и", "" + name, "" + name + "ью", "" + name + "и" ] : [ name, name, name, name, name, name ];
  }, exports.doInclineMaleName = doInclineMaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, hardConsonants, hissingAndChe, ishortRe, name2;
    return hardConsonants = /[бвгдзклмнпрстфх]$/g, hissingAndChe = /[жшщцч]$/g, ishortRe = /((ай)|(ей)|(ой)|(уй)|(яй)|(юй)|(ий))$/g, aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, name2 = name.slice(0, -1), name === "Лев" ? [ "Лев", "Льва", "Льву", "Льва", "Львом", "Льве" ] : name === "Павел" ? [ "Павел", "Павла", "Павлу", "Павла", "Павлом", "Павле" ] : /и$/g.test(name) ? [ name, name, name, name, name, name ] : hissingAndChe.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ем", "" + name + "е" ] : hardConsonants.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ом", "" + name + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : ishortRe.test(name) ? [ "" + name2 + "й", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ко$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /о$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : null;
  }, inclineAndGetResult = function(fn, args) {
    var i, name, r;
    r = null;
    for (i in args) {
      name = args[i], r = fn(name, !0);
      if (r.found) break;
    }
    return r;
  }, inclineFemaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineFemaleName, arguments);
  }, inclineMaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineMaleName, arguments);
  }, exports.inclineFemaleName = inclineFemaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name3, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), nl = name.toLowerCase(), nominativeRe = /[адежзийклмнорстуьэя]$/g, canInclineRe = /[жшщцчаяь]$/g, genitiveRe = /[иы]$/g, dativeRe = /[еи]$/g, accusativeRe = /[жшщцчьую]$/g, instrumentalRe = /((ой)|(ей)|(еи)|(ью))$/g, prepositionalRe = /[еи]$/g, result = r = null, nominativeRe.test(nl) && ref.ruFemaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineFemaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "female",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name2 = name.slice(0, -1), name_cases = [], genitiveRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("dative"))), prepositionalRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("prepositional"))), accusativeRe.test(nl) && (/[ую]$/g.test(nl) ? r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а") : r = inclineFemaleNameAndGetResult(name), r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (name3 = name.slice(0, -2), r = inclineFemaleNameAndGetResult("" + name3 + "я", "" + name3 + "а", "" + name3 + "ь", "" + name3), r && r.found && (result = r, name_cases.push("instrumental"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineMaleName = inclineMaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), name === "Льв" && (name = "Лев"), name === "Павл" && (name = "Павел"), nl = name.toLowerCase(), nominativeRe = /([вгдзклмнпрстфхжшцьй]|(ба)|(ва)|(да)|(за)|(ла)|(ма)|(на)|(па)|(ра)|(са)|(та)|(фа)|(га)|(ка)|(ха)|(жа)|(ша)|(ща)|(ца)|(ча)|(я)|(ло)|(ко))$/g, canInclineRe = /([бвгдзклмнпрстфхжшцьая]|(ия)|(ья)|(ея)|(ий)|(ей))$/g, genitiveRe = /[аяыи]$/g, dativeRe = /(([еую])|(ии))$/g, accusativeRe = /[аяую]$/g, instrumentalRe = /((ом)|(ем)|(ой)|(ей)|(ёй))$/g, prepositionalRe = /((е)|(ии))$/g, name2 = name.slice(0, -1), result = r = null, nominativeRe.test(nl) && ref.ruMaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineMaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "male",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name_cases = [], genitiveRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /ы$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "о", "" + name2 + "а") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "а", "" + name.slice(0, -1) + "я", "" + name.slice(0, -1) + "о") : r = null, r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (/у$/g.test(nl) ? r = inclineMaleName(name2) : /[аеиоуя]ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "й") : /ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "ь") : /е$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "и", "" + name2 + "я", "" + name2 + "o") : /ии$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я") : r = null, r && r.found && (result = r, name_cases.push("dative"))), accusativeRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /у$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а") : /[ую]$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : r = null, r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (/ом$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2)) : /ем$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2), "" + name.slice(0, -2) + "ь", "" + name.slice(0, -2) + "й") : /ой$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "а", "" + name.slice(0, -2) + "о") : /((ей)|(ёй))$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "я", "" + name.slice(0, -2) + "а") : r = null, r && r.found && (result = r, name_cases.push("instrumental"))), prepositionalRe.test(nl) && (/е$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2, "" + name2 + "ь", "" + name2 + "й", "" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я", "" + name2 + "й") : r = null, r && r.found && (result = r, name_cases.push("prepositional"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineName = inclineName = function(name) {
    var fn, mn, result;
    return fn = inclineFemaleName(name), mn = inclineMaleName(name), fn.found ? result = {
      found: !0,
      src: name,
      gender: "female",
      guess_case: fn.guess_case,
      female_cases: fn.cases,
      possible_cases: fn.possible_cases,
      nominative: fn.nominative
    } : mn.found ? result = {
      found: !0,
      src: name,
      gender: "male",
      guess_case: mn.guess_case,
      male_cases: mn.cases,
      possible_cases: mn.possible_cases,
      nominative: mn.nominative
    } : fn.possible_yes && mn.possible_yes ? (result = {
      found: "maybe",
      src: name,
      gender: [ "male", "female" ],
      female_cases: fn.cases,
      male_cases: mn.cases,
      possible_cases: util.merge(fn.possible_cases, mn.possible_cases)
    }, result.guess_case = fn.guess_case_index <= mn.guess_case_index ? fn.guess_case : mn.guess_case) : fn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "female",
      female_cases: fn.cases,
      guess_case: fn.cases,
      possible_cases: fn.possible_cases
    } : mn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "male",
      male_cases: mn.cases,
      guess_case: mn.cases,
      possible_cases: mn.possible_cases
    } : result = {
      found: !1,
      src: name
    }, result;
  }, inclineSurname = function(surname, noInclinesRe, inclineRe, casesRe) {
    var c, cases_index, check, i, result, surname_cases, _i, _j, _len, _len2;
    result = {
      found: null,
      src: surname,
      cases: null,
      cases_index: null
    };
    if (noInclinesRe && noInclinesRe.test(surname)) result = {
      found: surname,
      src: surname,
      cases: [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ],
      cases_index: [ 0, 1, 2, 3, 4, 5 ]
    }; else for (_i = 0, _len = inclineRe.length; _i < _len; _i++) {
      check = inclineRe[_i];
      if (check[0].test(surname)) {
        result = {
          found: surname.replace(check[0], check[1]),
          src: surname
        }, cases_index = [], surname_cases = [], i = 0;
        for (_j = 0, _len2 = casesRe.length; _j < _len2; _j++) c = casesRe[_j], c.test(surname) && (cases_index.push(i), surname_cases.push(cases[i])), i++;
        surname_cases.length === 0 ? (result.found = null, result.cases = null) : result.cases = surname_cases, result.cases_index = cases_index;
        break;
      }
    }
    return result.surname_cases && (result.guess_case = result.surname_cases[0]), result;
  }, exports.inclineFemaleSurname = inclineFemaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(е)|(о)|(э)|(и)|(ы)|(^[нв]у)|(^ую)|(уа)|(иа)|(ман)|(вич)|(ян))$/g, inclineRe = [ [ /((ова)|(овой)|(ову))$/g, "ова" ], [ /((ева)|(евой)|(еву))$/g, "ева" ], [ /((ёва)|(ёвой)|(ёву))$/g, "ёва" ], [ /((ина)|(иной)|(ину))$/g, "ина" ], [ /((ая)|(ой)|(ую))$/g, "ая" ] ], casesRe = [ /((ова)|(ева)|(ёва)|(ина)|(ая))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((ову)|(еву)|(ёву)|(ину)|(ую))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, exports.inclineMaleSurname = inclineMaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(^ве)|(^го)|(э)|(и)|(ы)|(^му)|(ю)|(уа)|(иа))$/g, inclineRe = [ [ /((ов)|(ова)|(ову)|(овым)|(ове))$/g, "ов" ], [ /((ев)|(ева)|(еву)|(евым)|(еве))$/g, "ев" ], [ /((ёв)|(ёва)|(ёву)|(ёвым)|(ёве))$/g, "ёв" ], [ /((ин)|(ина)|(ину)|(иным)|(ине))$/g, "ин" ], [ /((ский)|(ского)|(скому)|(ским)|(ском))$/g, "ский" ], [ /((ской)|(ского)|(скому)|(ским)|(ском))$/g, "ской" ], [ /((ман)|(мана)|(ману)|(маном)|(мане))$/g, "ман" ], [ /((ой)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ой" ], [ /((ий)|(ого)|(ому)|(ого)|(им)|(ом))$/g, "ий" ], [ /((ый)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ый" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ], [ /((ян)|(яна)|(яну)|(яна)|(яном)|(яне))$/g, "ян" ] ], casesRe = [ /((ов)|(ев)|(ёв)|(ин)|(ский)|(ской)|(ой)|(ий)|(ый)|(ман)|(ич)|(ян))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((ову)|(еву)|(ёву)|(ину)|(скому)|(ому)|(ману)|(ичу)|(яну))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((овым)|(евым)|(ёвым)|(иным)|(ским)|(им)|(ым)|(маном)|(ичем)|(яном))$/g, /((ове)|(еве)|(ёве)|(ине)|(ском)|(ом)|(мане)|(иче)|(яне))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, inclineMiddleNameOrSurname = function(src, fem, male) {
    var result, _ref;
    return fem.found === (_ref = male.found) && _ref === null ? result = {
      found: !1,
      src: src,
      value: null,
      gender: null
    } : fem.found && male.found ? (result = {
      found: !0,
      src: src,
      gender: [ "male", "female" ]
    }, result.nominative_male = male.found, result.nominative_female = fem.found, result.female_cases = fem.cases, result.male_cases = male.cases, fem.cases.length === 6 ? male.cases.length === 6 ? (result.guess_sex = "unknown", result.possible_cases = util.merge(fem.cases, male.cases)) : (result.guess_sex = "male", result.nominative = male.found, result.possible_cases = male.cases) : fem.cases.length === 1 && male.cases.length > 1 ? (result.guess_sex = "female", result.nominative = fem.found, result.possible_cases = fem.cases) : result.possible_cases = util.merge(fem.cases, male.cases)) : fem.found ? male.found || (result = {
      found: !0,
      src: src,
      gender: "female",
      female_cases: fem.cases,
      guess_case: fem.guess_case,
      nominative: fem.found,
      possible_cases: fem.cases
    }) : result = {
      found: !0,
      src: src,
      gender: "male",
      male_cases: male.cases,
      guess_case: male.guess_case,
      nominative: male.found,
      possible_cases: male.cases
    }, result;
  }, exports.inclineSurname = inclinePersonSurname = function(surname) {
    return inclineMiddleNameOrSurname(surname, inclineFemaleSurname(surname), inclineMaleSurname(surname));
  }, exports.inclineMaleMiddleName = inclineMaleMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((евич)|(евича)|(евичу)|(евича)|(евичем)|(евиче))$/g, "евич" ], [ /((ович)|(овича)|(овичу)|(овича)|(овичем)|(овиче))$/g, "ович" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ] ], casesRe = [ /((евич)|(ович)|(ич))$/g, /((евича)|(овича)|(ича))$/g, /((евичу)|(овичу)|(ичу))$/g, /((евича)|(овича)|(ича))$/g, /((евичем)|(овичем)|(ичем))$/g, /((евиче)|(овиче)|(иче))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineFemMiddleName = inclineFemMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((вна)|(вны)|(вне)|(вну)|(вной)|(вне))$/g, "вна" ], [ /((чна)|(чны)|(чне)|(чну)|(чной)|(чне))$/g, "чна" ] ], casesRe = [ /((вна)|(чна))$/g, /((вны)|(чны))$/g, /((вне)|(чне))$/g, /((вну)|(чну))$/g, /((вной)|(чной))$/g, /((вне)|(чне))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineMiddleName = inclineMiddleName = function(mname) {
    return inclineMiddleNameOrSurname(mname, inclineFemMiddleName(mname), inclineMaleMiddleName(mname));
  }, genderMatch = function(g1, g2) {
    return g1 === g2 || __indexOf.call(g2, g1) >= 0 ? g1 : __indexOf.call(g1, g2) >= 0 ? g2 : null;
  }, matchNameParts = function(fn, mn, sn) {
    var overallGender, surname, theCase;
    return theCase = util.intersection(fn.possible_cases, mn.possible_cases), overallGender = genderMatch(genderMatch(fn.gender, mn.gender), sn.gender), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: mn.nominative,
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchNameAndSurname = function(fn, sn) {
    var overallGender, surname, theCase;
    return overallGender = genderMatch(fn.gender, sn.gender), theCase = util.intersection(fn.possible_cases, sn.possible_cases), theCase || (sn.possible_cases = sn["" + overallGender + "_cases"], sn.nominative = sn["nominative_" + overallGender], theCase = util.intersection(fn.possible_cases, sn.possible_cases)), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: "",
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchCase = function(pObj, target_case, gender) {
    return __indexOf.call(pObj["" + gender + "_cases"], target_case) >= 0;
  }, getNominative = function(pObj, gender) {
    var gnstr, nom;
    return gnstr = "nominative_" + gender, nom = pObj.nominative && pObj.nominative || pObj[gnstr], nom;
  }, exports.findProperName = findProperName = function(listOfWords, opts) {
    var mnr2, mnr3, nr1, nr2, nr3, result, sr1, sr2, sr3;
    opts == null && (opts = {}), result = {
      found: !1
    };
    switch (listOfWords.length) {
     case 1:
      result = inclineName(listOfWords[0]), result.found ? result.first_name = result.nominative : (result = inclinePersonSurname(listOfWords[0]), result.found && (result.surname = result.nominative));
      break;
     case 2:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr1.found && sr2.found && (result = matchNameAndSurname(nr1, sr2)), !result.found && sr1.found && nr2.found && (result = matchNameAndSurname(sr1, nr2));
      break;
     case 3:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), sr3 = inclinePersonSurname(listOfWords[2]), mnr2 = inclineMiddleName(listOfWords[1]), mnr3 = inclineMiddleName(listOfWords[2]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr3 = inclineName(listOfWords[2]), nr3.found ? result = {
        found: !1,
        error: "name at the end of 3-component proper name"
      } : nr1.found ? (mnr2.found && sr3.found && (result = matchNameParts(nr1, mnr2, sr3)), !result.found && sr2.found && (result = matchNameAndSurname(nr1, sr2))) : sr1.found && nr2.found && mnr3.found ? result = matchNameParts(nr2, mnr3, sr1) : nr2.found && sr3.found && (result = matchNameAndSurname(nr2, sr3));
    }
    return result.first_name || (result.first_name = ""), result.middle_name || (result.middle_name = ""), result.surname || (result.surname = ""), result.first_name || result.middle_name || result.surname || (result = {
      found: !1,
      error: "person not found"
    }), result.src = listOfWords.join(" "), result;
  }, exports.getInitialFormOfAdjective = function(adj) {
    var base;
    return adj = adj.toLowerCase(), /^[а-яё]{2,}(ая|ее|ие|ий|им|ими|их|ого|его|ое|ой|ом|ому|ою|ую|ые|ый|ым|ыми|ых|юю|яя)$/.test(adj) ? (/^[а-яё]{2,}(ими|ого|его|ому|ыми)$/gi.test(adj) ? base = adj.slice(0, -3) : base = adj.slice(0, -2), [ "" + base + "ый", "" + base + "ий", "" + base + "ой" ]) : null;
  }, exports.getVerbInfinitive = function(verb) {
    var pastTime, result, verbEnd;
    return verb = verb.toLowerCase(), /^[а-яё]{3,}(ать|аться|ить|иться|еть|еться|оть|оться|уть|утся|ются|ть|ться)$/.test(verb) ? verb : (/^[а-яё]{3,}(сь|ся)$/.test(verb) ? (verbEnd = verb.slice(-2), verb = verb.slice(0, -2)) : verbEnd = "", pastTime = verb.match(/^[а-яё]{3,}(л|ла|ло|ли)$/), pastTime ? result = verb.slice(0, -(1 + pastTime[1].length) + 1 || 9e9) + "ть" : /[а-яё]{3,}(у|ю|ем|ешь|ете|ет|ут|ют|им|ишь|ите|ит|ат|ят)$/.test(verb) && (/[а-яё]{3,}(ишь|ит|им|ите|ат|ят)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd ] : /[а-яё]{3,}(у|ю|ешь|ет|ем|ете|ут|ют)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd, "" + verb + "оть" + verbEnd, "" + verb + "уть" + verbEnd, "" + verb + "ть" + verbEnd ] : result = null), result);
  };
}(exports, util, ref);

var exports, ruWords, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.morpho = {}, exports = window.lastName.plugins.ru.morpho, ruWords = window.lastName.plugins.ru.words) : (exports = module.exports, ruWords = require("./words")), function(exports, ruWords) {
  var exceptions, getRulesAdjective, getRulesVerb, morphoRu;
  return exports.getWordRe = function() {
    return /^[а-я\-ё\d]+$/ig;
  }, exports.getAdjectiveEnds = function() {
    return {
      feminine: {
        ends: /((ая)|(ой)|(ую)|(яя)|(ей)|(юю))$/g,
        hard: /((ая)|(ой)|(ую))$/g,
        sort: /((яя)|(ей)|(юю))$/g,
        hardNominativeEnd: "ая",
        softNominativeEnd: "яя",
        gender: "feminine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ая" ? [ "" + word + "ая", "" + word + "ой", "" + word + "ой", "" + word + "ую", "" + word + "ой", "" + word + "ой" ] : [ "" + word + "яя", "" + word + "ей", "" + word + "ей", "" + word + "юю", "" + word + "ей", "" + word + "ей" ];
        }
      },
      masculine: {
        ends: /((ый)|(ого)|(ому)|(ым)|(ом)|(ий)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ый)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ий)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ый",
        softNominativeEnd: "ий",
        gender: "masculine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ый" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ий", "" + word + "ого", "" + word + "ому", "" + word + "ий", "" + word + "им", "" + word + "ом" ] : [ "" + word + "ый", "" + word + "ого", "" + word + "ому", "" + word + "ый", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ий", "" + word + "его", "" + word + "ему", "" + word + "ий", "" + word + "им", "" + word + "ем" ];
        }
      },
      neuter: {
        ends: /((ое)|(ого)|(ому)|(ым)|(ом)|(ее)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ое)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ее)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ое",
        softNominativeEnd: "ее",
        gender: "neuter",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ое" ? [ "" + word + "ое", "" + word + "ого", "" + word + "ому", "" + word + "ое", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ее", "" + word + "его", "" + word + "ему", "" + word + "ее", "" + word + "им", "" + word + "ем" ];
        }
      },
      plural: {
        ends: /((ые)|(ых)|(ым)|(ыми)|(ых)|(ие)|(их)|(им)|(ими)|(их))$/g,
        hard: /((ые)|(ых)|(ым)|(ыми)|(ых))$/g,
        soft: /((ие)|(их)|(им)|(ими)|(их))$/g,
        hardNominativeEnd: "ые",
        softNominativeEnd: "ие",
        gender: "unknown",
        singular: !1,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ые" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ] : [ "" + word + "ые", "" + word + "ых", "" + word + "ым", "" + word + "ые", "" + word + "ыми", "" + word + "ых" ] : [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ];
        }
      }
    };
  }, exceptions = function(word) {}, getRulesVerb = function() {
    return [ [ /нул[aи]{0,1}$/g, "ать" ], [ /еть$/g, "ать" ], [ /(ает)|(ают)$/g, "ать" ], [ /ал[aи]{0,1}$/g, "ать" ], [ /ул[aи]{0,1}$/g, "ать" ], [ /((ить)|(ать))$/g, "ать" ], [ /ая$/g, "ать" ], [ /((ил)|(или)|(ила)|(ило))$/g, "лять" ], [ /(ятся)|(ится)|(ился)|(илась)|(илось)$/g, "ится" ], [ /(яться)|(иться)$/g, "иться" ] ];
  }, getRulesAdjective = function() {
    return [ [ /в((ая)|(ые)|(ый)|(ое))$/, "вый" ], [ /((ая)|(ой)|(ие)|(ые)|(ый)|(ую))$/, "ый" ], [ /((яя)|(ее)|(ий)|(юю))$/, "ий" ] ];
  }, exports.morpho = morphoRu = function(word) {
    var adj, adjective, result, rule, verb, _i, _j, _len, _len2, _ref, _ref2;
    if (__indexOf.call(ruWords.adverbs, word) >= 0) return {
      type: "abverb",
      value: word
    };
    if (__indexOf.call(ruWords.prepositionAll, word) >= 0) return {
      type: "preposition",
      value: word
    };
    if (__indexOf.call(ruWords.unions, word) >= 0) return {
      type: "union",
      value: word
    };
    result = {
      type: "",
      value: ""
    }, verb = null, adjective = null, _ref = getRulesVerb();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      rule = _ref[_i];
      if (rule[0].test(word)) {
        result = {
          type: verb,
          value: word.replace(rule[0], rule[1])
        };
        break;
      }
    }
    _ref2 = getRulesAdjective();
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      rule = _ref2[_j];
      if (rule[0].test(word)) {
        adj = word.replace(rule[0], rule[1]), result.type ? (result.type += " adjective", result.value = [ result.value, adj ]) : result = {
          type: "adjective",
          value: adj
        };
        break;
      }
    }
    return result;
  }, exports.analyseText = function(text) {
    var doubleSpaceRe, enRe, punctuationRe, r, result, ruRe, t, wordRe, _i, _len, _ref;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&№“”\—]/g, doubleSpaceRe = /\s+/g, text = text.replace(punctuationRe, " $& ").replace(doubleSpaceRe, " ") + " .", result = [], _ref = text.split(" ");
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      t = _ref[_i], ruRe = /^[а-я\-ё]+$/ig, enRe = /^[a-z\-]+$/ig, wordRe = /^[а-яё\-\da-z]+$/ig, r = morphoRu(t.toLowerCase());
      switch (r.type) {
       case "adverb":
        result.push("[ADV " + t + "]");
        break;
       case "verb":
       case "adjective":
        result.push("[ " + r.value + " ]");
        break;
       case "verb adjective":
        result.push("[#VA " + r.value[0] + "]");
        break;
       case "union":
        result.push("[U " + t + "]");
        break;
       case "preposition":
        result.push("[PP " + t + "]");
        break;
       default:
        result.push(t);
      }
      t === "." && result.push("\n");
    }
    return result;
  }, exports.parseRuSentence = function(sentences) {
    var abbrevs, common_used_words, digits, regular_words, special_words, total_words;
    return sentences instanceof Array || (sentences = [ sentences ]), abbrevs = {}, special_words = {}, digits = {}, common_used_words = {}, regular_words = {}, total_words = 0, sentences.map(function(sent) {
      var i, result, w, word, words, _len, _ref, _results;
      words = sent.split(" "), _results = [];
      for (i = 0, _len = words.length; i < _len; i++) word = words[i], /^[[,:\/\\\?!\+\-\*\(\)\[\]\&\№\—]]+$/.test(words) || total_words++, /^(\d+(|(\.(|\d+))))$/.test(word) ? digits[word] ? _results.push(digits[word]++) : _results.push(digits[word] = 1) : isUpperCase(word) && /^[а-яё\-]{2,}$/i.test(word) ? abbrevs[word] ? _results.push(abbrevs[word]++) : _results.push(abbrevs[word] = 1) : i > 0 && isCapitalized(word) && /^[а-яё\-]{2,}$/i.test(word) ? special_words[word] ? _results.push(special_words[word]++) : _results.push(special_words[word] = 1) : /^[а-яё\-]+$/i.test(word) && !/^\-+$/.test(word) ? (w = word.toLowerCase(), result = morphoRu(w), (_ref = result.type) !== "adverb" && _ref !== "preposition" && _ref !== "union" ? regular_words[w] ? _results.push(regular_words[w]++) : _results.push(regular_words[w] = 1) : common_used_words[w] ? _results.push(common_used_words[w]++) : _results.push(common_used_words[w] = 1)) : _results.push(void 0);
      return _results;
    }), {
      abbrevs: abbrevs,
      common_used_words: common_used_words,
      special_words: special_words,
      regular_words: regular_words,
      digits: digits,
      total_words: total_words
    };
  };
}(exports, ruWords);

var exports, inclines, morpho, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.propernames = {}, exports = window.lastName.plugins.ru.propernames, morpho = window.lastName.plugins.ru.morpho, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, morpho = require("./morpho"), inclines = require("./inclines")), function(exports, morpho, inclines) {
  return exports.postFilter = function(text, result) {
    var curProperName, id, p, pn, pnDict, properNames, properNamesRe, punctuationRe, _i, _j, _len, _len2, _ref, _ref2;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&\№“”\—]/g, properNames = [], curProperName = [], properNamesRe = /[А-Я][а-яё]+(\s+[А-Я][а-яё]+){0,2}/gm, _ref = text.match(properNamesRe);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) pn = _ref[_i], curProperName = pn.replace(/\s+/g, " ").split(" "), curProperName && (pn = inclines.findProperName(curProperName), pn && pn.found && properNames.push(pn));
    pnDict = {};
    for (_j = 0, _len2 = properNames.length; _j < _len2; _j++) p = properNames[_j], id = "" + (p.first_name || "") + "-" + (p.middle_name || "") + "-" + (p.surname || ""), pnDict[id] ? (pnDict[id].count += 1, (_ref2 = p.src, __indexOf.call(pnDict[id].src, _ref2) < 0) && pnDict[id].src.push(p.src)) : (pnDict[id] = p, pnDict[id].src = [ p.src ], pnDict[id].count = 1);
    return result.propernames = pnDict;
  };
}(exports, morpho, inclines);

var exports, inclines, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName.plugins.ru.feelings = {}, exports = window.lastName.plugins.ru.feelings, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, inclines = require("./inclines")), function(exports, inclines) {
  var evaluateSentenceNeutrality, getNegativePhrasesRe, negativeAdjectives, negativeVerbs, negativeWordsIncline;
  return exports.positive = [], negativeAdjectives = {
    "агрессивный": 3,
    "атакованный": 2,
    "бедный": 2,
    "беззащитный": 2,
    "безнадежный": 3,
    "безрадостный": 2,
    "бесплодный": 3,
    "беспомощный": 3,
    "бесправный": 2,
    "бессердечный": 1,
    "бессильный": 1,
    "бесцельный": 2,
    "бесчестный": 2,
    "вздорный": 1,
    "виновный": 1,
    "ворчливый": 1,
    "враждебный": 2,
    "вспыльчивый": 1,
    "выпученный": 1,
    "выселенный": 3,
    "высмеянный": 2,
    "выхолощенный": 1,
    "глубокий": 1,
    "глупый": 2,
    "горький": 2,
    "готический": 2,
    "гротескный": 1,
    "грустный": 1,
    "грязный": 1,
    "девальвированный": 2,
    "деградировавший": 2,
    "дегуманизированный": 2,
    "дезорганизованный": 2,
    "дезориентированный": 2,
    "деморализованный": 3,
    "дерзкий": 1,
    "дерьмовый": 3,
    "дефектный": 3,
    "драматический": 3,
    "жалкий": 3,
    "жесткий": 2,
    "жестокосердный": 2,
    "заброшенный": 1,
    "забываемый": 1,
    "забывчивый": 1,
    "забытый": 2,
    "зависимый": 1,
    "заинтересованный": 1,
    "запрещенный": 3,
    "запутанный": 2,
    "застенчивый": 1,
    "застрявший": 1,
    "затравленный": 2,
    "зверский": 3,
    "злобный": 2,
    "идиотский": 3,
    "измельченный": 2,
    "измученный": 2,
    "изнасилованный": 3,
    "изолированный": 3,
    "изумленный": 1,
    "интенсивный": 1,
    "иррациональный": 2,
    "исключенный": 2,
    "искусственный": 2,
    "испуганный": 2,
    "истерический": 3,
    "исчерпанный": 2,
    "капризный": 2,
    "контролируемый": 1,
    "критический": 1,
    "ленивый": 2,
    "лишенный": 2,
    "ложный": 2,
    "мазохистский": 1,
    "мертвый": 3,
    "меченый": 2,
    "мрачный": 2,
    "мстительный": 2,
    "навязчивый": 2,
    "надоедливый": 2,
    "наказанный": 2,
    "нарушенный": 2,
    "натянутый": 2,
    "неадекватный": 2,
    "неактивный": 1,
    "небезопасный": 2,
    "небрежный": 1,
    "невежественный": 1,
    "невидимый": 1,
    "невротический": 2,
    "негуманный": 2,
    "недействительный": 1,
    "недовольный": 2,
    "недостаточный": 1,
    "недоуменный": 1,
    "незаземленный": 1,
    "незначительный": 1,
    "неискренний": 1,
    "некомпетентный": 2,
    "ненавистный": 3,
    "необщительный": 2,
    "неполный": 2,
    "неправильный": 2,
    "неприятный": 2,
    "нервный": 2,
    "нерешительный": 1,
    "несбалансированный": 1,
    "несовместимый": 2,
    "несоответствующий": 2,
    "неспособный": 3,
    "несчастный": 2,
    "неуклюжий": 2,
    "неуловимый": 1,
    "неуместный": 2,
    "нечестный": 2,
    "неэффективный": 2,
    "низкий": 1,
    "обвиняемый": 3,
    "обедненный": 1,
    "обезумевший": 3,
    "обиженный": 2,
    "обманутый": 2,
    "обозленный": 2,
    "оборонительный": 1,
    "обремененный": 1,
    "обременительный": 1,
    "обреченный": 2,
    "ограниченный": 1,
    "одержимый": 3,
    "одинокий": 2,
    "одноразовый": 1,
    "озабоченный": 2,
    "окаменелый": 1,
    "онемелый": 1,
    "опальный": 2,
    "опасный": 3,
    "опустошенный": 1,
    "опущенный": 2,
    "опьяненный": 1,
    "оскорбленный": 2,
    "осмеянный": 2,
    "острый": 1,
    "осужденный": 3,
    "осушенный": 2,
    "ответственный": 2,
    "отвратительный": 3,
    "отдаленный": 1,
    "отдельный": 1,
    "отрицательный": 2,
    "отсталый": 2,
    "отчаянный": 1,
    "ошибочный": 1,
    "параноидальный": 2,
    "паршивый": 2,
    "пассивный": 1,
    "переполненный": 2,
    "пессимистический": 2,
    "печальный": 2,
    "побежденный": 3,
    "поверхностный": 2,
    "поврежденный": 3,
    "подавленный": 2,
    "поддельный": 3,
    "покинутый": 2,
    "покорный": 1,
    "порабощенный": 3,
    "потерянный": 2,
    "потерпевший": 2,
    "потребленный": 1,
    "презираемый": 2,
    "презренный": 3,
    "презрительный": 2,
    "прерванный": 1,
    "принудительный": 2,
    "психотический": 2,
    "пустынный": 1,
    "пьяный": 2,
    "равнодушный": 1,
    "развращенный": 3,
    "раздраженный": 2,
    "раздражительный": 2,
    "разочарованный": 2,
    "разочаровывающий": 3,
    "разрушенный": 3,
    "разрушительный": 2,
    "разъяренный": 3,
    "раненый": 2,
    "ревнивый": 2,
    "садистский": 2,
    "самоубийственный": 3,
    "саркастический": 1,
    "сварливый": 1,
    "сгоревший": 3,
    "сердитый": 2,
    "серый": 1,
    "скучающий": 1,
    "скучный": 1,
    "сломанный": 2,
    "смущенный": 1,
    "созерцательный": 1,
    "сомнительный": 2,
    "спорный": 2,
    "спровоцированный": 2,
    "спутанный": 2,
    "спущенный": 2,
    "стереотипный": 1,
    "стесненный": 1,
    "странный": 1,
    "страшный": 2,
    "сумасшедший": 2,
    "тихий": 1,
    "тормозящий": 2,
    "торопливый": 2,
    "тоскливый": 3,
    "требовательный": 2,
    "тревожный": 2,
    "трудный": 2,
    "трусливый": 2,
    "тупой": 1,
    "тщеславный": 2,
    "угнетенный": 2,
    "угрюмый": 2,
    "удаляемый": 2,
    "удрученный": 2,
    "ужасный": 3,
    "уклончивый": 2,
    "униженный": 3,
    "унылый": 3,
    "урезанный": 2,
    "фальшивый": 3,
    "хаотический": 2,
    "холодный": 1,
    "хрупкий": 1,
    "цепкий": 2,
    "циничный": 2,
    "чертовский": 2,
    "чрезмерный": 2,
    "чувствительный": 2,
    "эгоистичный": 2,
    "эгоцентричный": 3,
    "эксплуатируемый": 2,
    "эмансипированный": 2,
    "эмоциональный": 1,
    "яростный": 3
  }, negativeVerbs = {
    "беспокоить": 2,
    "бить": 2,
    "внушать": 2,
    "волноваться": 2,
    "высмеивать": 2,
    "грызть": 1,
    "диктовать": 2,
    "дребезжать": 1,
    "дрожать": 1,
    "дрогнуть": 2,
    "загнать": 2,
    "запугивать": 3,
    "запутаться": 2,
    "злоупотреблять": 2,
    "игнорировать": 1,
    "избегать": 1,
    "издеваться": 3,
    "изменять": 2,
    "командовать": 1,
    "лгать": 2,
    "лишить": 2,
    "манипулировать": 2,
    "молчать": 1,
    "надувать": 1,
    "ненавидеть": 3,
    "обвинять": 2,
    "обидеть": 2,
    "опорочить": 3,
    "освистать": 3,
    "отбрасывать": 1,
    "отвлекаться": 2,
    "отклонить": 2,
    "отрекаться": 3,
    "оттолкнуть": 2,
    "паниковать": 2,
    "перепутаться": 2,
    "подавить": 3,
    "подвергаться": 2,
    "пострадать": 2,
    "предавать": 3,
    "пренебрегать": 2,
    "препятствовать": 2,
    "преследовать": 2,
    "принижаться": 2,
    "приставать": 2,
    "прослушивать": 2,
    "разгромить": 2,
    "раздражаться": 2,
    "растаскивать": 2,
    "рисковать": 2,
    "ругать": 2,
    "сдуваться": 1,
    "смолчать": 2,
    "снизиться": 1,
    "сорвать": 1,
    "сожалеть": 2,
    "соизволить": 2,
    "солгать": 2,
    "сомневаться": 2,
    "споткнуться": 1,
    "столкнуться": 2,
    "страдать": 2,
    "стрелять": 3,
    "судить": 2,
    "толкнуть": 1,
    "убить": 3,
    "убивать": 3,
    "уговаривать": 1,
    "удалять": 2,
    "уклоняться": 2,
    "унижать": 3,
    "шантажировать": 2
  }, negativeWordsIncline = {
    "боль": 2,
    "вниз": 1,
    "горе": 3,
    "дно": 2,
    "мало": 1,
    "мучение": 2,
    "недовольство": 2,
    "плохо": 2,
    "противно": 3,
    "совестно": 2,
    "только": 1,
    "ужас": 3,
    "смерть": 3,
    "неодобрительно": 2,
    "разгром": 2,
    "отчаяние": 3
  }, exports.getNegativePhrasesRe = getNegativePhrasesRe = function() {
    return [ [ /[^а-яё]при\sотягчающих\sобстоятельствах[^а-яё]/ig, 2 ], [ /[^а-яё]ненависть\sк[^а-яё]/ig, 3 ], [ /[^а-яё]в\sубыток[^а-яё]/ig, 2 ], [ /[^а-яё]сыт[аы]?\sпо\sгорло[^а-яё]/ig, 3 ], [ /[^а-яё]заслужива[ею]т\sнаказания[^а-яё]/ig, 2 ], [ /[^а-яё]находящ(егося|ейся|емся|ихся)\sпод\sугрозой\sисчезновения[^а-яё]/ig, 3 ], [ /[^а-яё]в\sзаблуждение[^а-яё]/ig, 2 ], [ /[^а-яё]сбит[аы]?\sс\sтолку[^а-яё]/ig, 2 ], [ /[^а-яё]в\sужасе[^а-яё]/ig, 3 ], [ /[^а-яё]не\sрекоменд(ую|уем|уется|овал|овала|овали)[^а-яё]/ig, 2 ], [ /[^а-яё]не\sодобря(ю|ем|л|ла|ли|ется)[^а-яё]/ig, 2 ], [ /[^а-яё]пятно\sна[^а-яё]/ig, 2 ], [ /[^а-яё]в\sклетке[^а-яё]/ig, 1 ], [ /[^а-яё]неправильно\sпонял[аи]?[^а-яё]/ig, 2 ], [ /[^а-яё]вне\sпределов\sдосягаемости[^а-яё]/ig, 1 ], [ /[^а-яё]взял[аи]?\sна[^а-яё]/ig, 2 ], [ /[^а-яё]играл[аи]?\sс[^а-яё]/ig, 2 ], [ /[^а-яё]черный\sсписок[^а-яё]/ig, 3 ], [ /[^а-яё]возбужден[оы]\sуголовн(ое|ые)\sдел[оа][^а-яё]/ig, 8 ], [ /[^а-яё]жертв(|а|ы|ам|ами)[^а-яё]/ig, 3 ] ];
  }, exports.evaluateSentenceNeutrality = evaluateSentenceNeutrality = function(sentence) {
    var adj, adjArray, adjIndex, curWords, cur_index, ind, index, m, nr, resetCurIndex, vIndex, verb, words, wrd, _i, _j, _k, _len, _len2, _len3, _ref, _ref2;
    index = 0, cur_index = 0, words = [], curWords = [], _ref = getNegativePhrasesRe();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) nr = _ref[_i], m = sentence.match(nr[0]), m && (m.map(function(wordsSequence) {
      return words.push(wordsSequence);
    }), index -= nr[1] * m.length);
    resetCurIndex = function() {
      if (cur_index) return index += cur_index, words.push(curWords), curWords = [], cur_index = 0;
    }, _ref2 = sentence.split(/\s/);
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      wrd = _ref2[_j];
      if (__indexOf.call(".,-—!?()[]", wrd) >= 0) {
        cur_index = -cur_index, resetCurIndex();
        continue;
      }
      ind = negativeWordsIncline[wrd.toLowerCase()];
      if (ind) curWords.push(wrd), cur_index = cur_index * ind || ind; else {
        adjArray = inclines.getInitialFormOfAdjective(wrd);
        if (!adjArray) verb = inclines.getVerbInfinitive(wrd), vIndex = negativeVerbs[verb], vIndex ? (curWords.push(wrd), cur_index = cur_index * vIndex || vIndex) : (cur_index = -cur_index, resetCurIndex()); else for (_k = 0, _len3 = adjArray.length; _k < _len3; _k++) {
          adj = adjArray[_k], adjIndex = negativeAdjectives[adj];
          if (adjIndex) {
            curWords.push(wrd), cur_index = cur_index * adjIndex || adjIndex;
            break;
          }
        }
      }
    }
    return resetCurIndex(-cur_index), [ index, words ];
  }, exports.postFilter = function(text, result) {
    var emoIndex, emoWords, i, index, overallIndex, s, _len, _ref, _ref2;
    emoIndex = [], overallIndex = 0, _ref = result.misc.sentences;
    for (i = 0, _len = _ref.length; i < _len; i++) s = _ref[i], _ref2 = evaluateSentenceNeutrality(s), index = _ref2[0], emoWords = _ref2[1], emoIndex.push([ index, emoWords ]), overallIndex += index;
    return result.feelings = {
      emoIndex: emoIndex,
      overallIndex: overallIndex,
      emoScore: overallIndex / result.counters.words_total || 1
    };
  };
}(exports, inclines);

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).analysis || (_base.analysis = {}), exports = window.lastName.analysis) : exports = module.exports, function(exports) {
  return exports.analyse = function(text, plugins) {
    var f, misc, postFilter, preFilters, result, util, _i, _j, _len, _len2;
    plugins == null && (plugins = []), "undefined" == typeof global ? (misc = window.lastName.misc, util = window.lastName.util) : (misc = require("./misc"), util = require("./util")), result = {}, misc.preFilter(text, result), preFilters = plugins.filter(function(plugin) {
      return "function" == typeof plugin.preFilter;
    }), postFilter = plugins.filter(function(plugin) {
      return "function" == typeof plugin.postFilter;
    });
    for (_i = 0, _len = preFilters.length; _i < _len; _i++) f = preFilters[_i], f.preFilter(text, result);
    for (_j = 0, _len2 = postFilter.length; _j < _len2; _j++) f = postFilter[_j], f.postFilter(text, result);
    return result.version = util.version, result;
  };
}(exports);

var __slice = Array.prototype.slice;

(function(lastname) {
  return lastname.version = "0.3.5", lastname.findProperName = function() {
    var args, inclines, lang;
    return lang = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [], inclines = lastname.plugins["" + lang].inclines, inclines.findProperName.apply(this, args);
  };
})(window.lastName || (window.lastName = {}));

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).misc || (_base.misc = {}), exports = window.lastName.misc) : exports = module.exports, function(exports) {
  return exports.preFilter = function(text, result) {
    var chars_total, emo, emoticons, findEmo, ind, punctuationRe, sentences, signs, signs_total, spaces_total, tempTxt, word_length_mid, words_total, _i, _len;
    signs = text.match(/[-\+=\/\.,\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]{1}/g), signs_total = signs && signs.length || 0, spaces_total = /\s/.test(text) ? text.match(/\s/g).length : 0, chars_total = text.length, words_total = text.split(/\s/).filter(function(wrd) {
      return wrd.length > 0 && !/^[-\+=\/\.\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]+$/.test(wrd);
    }).length, word_length_mid = words_total ? (chars_total - spaces_total - signs_total) / words_total : 0, emoticons = [ ":-)", "(-:", ":o)", ":)", "(:", ":->", ":-}", ":-t", ":*)", ":-)))", ":-D", "(-D", ":'-)", "%-)", ":-/", ":-I", ":~)", "(:-(", ":-(", ":-c", ":-(((", ":-<", ">:-(", ":-[", "(:-&", "%-(", ">:-<", "~ :-(", "%-(", ":/)", ":-|", ":-e", ":-X", ":-v", ":-I", ":-8(", ":-O", ":-@", ":,-(", ":'-(", "~:-o", "]:-)>", "):-)", ";->", ":-x", ":-*", "8-]", ":-J", ":-&", ":-p", ":-P", ";-)", ";)", "'-)", ":-7", "?-(", "B-D", ":-B", ":-*)", ":-9", "|-p", ":-b", "-]:-)[-", "8-I", "8-|", "|:-|", ":-]", "|-)", "|-I", "I^o", "|-O", ':-"', ":-s", ":-#", ":-!", ":-()", ":-D", "(:-$", ":-(*)", ":-')", ":-R", "%+|", "%+{", "X-(", "<:-)", "*:o)", "@;-)", "X:-)", ":>)", "&:-)", "#:-)", "8-)", "8:-)", "B-)", "B-]", "O:-)", "&8-|", ":-{", ":-)}", ":-)#", ":-Q", ":-I", ":-d~", ":-?", ":-/I", ":-) X", "{(:-)", ":-{}", "[:-)", "d :-o", "~:-(", "~~:-(", "))", "(:-I", "3:-o", "[: |]", "M-)", ":X)", ":-M", "*8((:", "O+", "O->", "||*(", "||*)", "<{:-)}", "(-: :-)", "@->-", "@==", "<')))))- <" ], emoticons.sort(function(a, b) {
      return b.length - a.length;
    }), tempTxt = text.slice(0), findEmo = [];
    for (_i = 0, _len = emoticons.length; _i < _len; _i++) {
      emo = emoticons[_i], ind = 0;
      while (ind >= 0) ind = tempTxt.indexOf(emo, ind), ind !== -1 && (findEmo.push(emo), tempTxt = tempTxt.replace(emo, ""), ind -= emo.length + 2);
    }
    return punctuationRe = /(https?\:\/\/.*[\s$])|(\.\s)|(,\s)|(\s\:)|(:\s)|(\s\/)|(\/\s)|(\s\\)(\\\s)|\?|!|\+|\'|\"|«|»|\*|\(|\)|\[|\]|\&|\№|“|”|\—/g, tempTxt = text.replace(punctuationRe, " $& ").replace(/\s+/g, " "), /[\?\!\.]\s{0,}$/.test(tempTxt) || (tempTxt += " . "), sentences = tempTxt.replace(/\s\?\s/gm, " ?? ").replace(/\s\!\s/gm, " !! ").replace(/\s\.\s/gm, " .. ").split(/[\?\!\.](\s+|$)/gm).filter(function(s) {
      return !/^\s{0,}$/.test(s);
    }), result.misc = {
      digits: util.arrayToDict(text.match(/-?((\d+[\.,]\d+)|(\d+))/ig) || []),
      emoticons: util.arrayToDict(findEmo),
      romans: util.arrayToDict(text.match(/([X]{0,3}I[VX])|(M*(D?C{0,3}|C[DM])(L?X{0,3}|X[LC])(V?I{0,3}|I[VX]))/g) || []),
      sentences: sentences
    }, result.counters = {
      chars_total: chars_total,
      words_total: words_total,
      signs_total: signs_total,
      spaces_total: spaces_total,
      word_length_mid: word_length_mid,
      words_in_sentence_mid: sentences.length ? words_total / sentences.length : 0
    }, result;
  };
}(exports);

var exports, _base, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).util || (_base.util = {}), exports = window.lastName.util) : exports = module.exports, function(exports) {
  var capitalize, dictKeys, intersection, isCapitalized, isLowerCase, isUpperCase, merge, unique;
  return exports.version = "0.3.17", exports.capitalize = capitalize = function(s) {
    if (s) return "" + s[0].toUpperCase() + s.slice(1).toLowerCase();
  }, exports.dictKeys = dictKeys = function(dict) {
    var k, keys, v;
    keys = [];
    for (k in dict) v = dict[k], keys.push(k);
    return keys;
  }, exports.isCapitalized = isCapitalized = function(word) {
    var cap;
    return 0 <= word.indexOf("-") ? (cap = !0, word.split("-").map(function(wrd) {
      return cap && (cap = isCapitalized(wrd));
    }), cap) : word && word === capitalize(word) || !1;
  }, exports.isUpperCase = isUpperCase = function(word) {
    return word === word.toUpperCase();
  }, exports.isLowerCase = isLowerCase = function(word) {
    return word === word.toLowerCase();
  }, exports.unique = unique = function(array) {
    var key, output, value, _ref, _results;
    output = {};
    for (key = 0, _ref = array.length; 0 <= _ref ? key < _ref : key > _ref; 0 <= _ref ? key++ : key--) output[array[key]] = array[key];
    _results = [];
    for (key in output) value = output[key], _results.push(value);
    return _results;
  }, exports.merge = merge = function(l1, l2) {
    var l;
    return l = [], l1.map(function(x) {
      return l.push(x);
    }), l2.map(function(x) {
      return l.push(x);
    }), unique(l);
  }, exports.intersection = intersection = function(l1, l2) {
    var i, _i, _len;
    for (_i = 0, _len = l1.length; _i < _len; _i++) {
      i = l1[_i];
      if (__indexOf.call(l2, i) >= 0) return i;
    }
    return null;
  }, exports.arrayToDict = function(arr) {
    var d, i, _i, _len;
    d = {};
    for (_i = 0, _len = arr.length; _i < _len; _i++) i = arr[_i], d[i] ? d[i]++ : d[i] = 1;
    return d;
  };
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.ref = {}, exports = window.lastName.plugins.ru.ref) : exports = module.exports, function(exports) {
  return exports.ruFemaleNamesDict = {
    "альвина": 1,
    "анелия": 1,
    "августа": 1,
    "августина": 1,
    "авдотья": 1,
    "авелина": 1,
    "аврелия": 1,
    "аврора": 1,
    "агапия": 1,
    "агата": 1,
    "агафья": 1,
    "агафия": 1,
    "аглаида": 1,
    "аглая": 1,
    "агнеса": 1,
    "агнесса": 1,
    "агния": 1,
    "агриппмеа": 1,
    "агрефена": 1,
    "ада": 1,
    "адина": 1,
    "адель": 1,
    "аделия": 1,
    "аделаида": 1,
    "аза": 1,
    "азалия": 1,
    "аида": 1,
    "айседора": 1,
    "айсылу": 1,
    "акилина": 1,
    "акулина": 1,
    "аксинья": 1,
    "алевтина": 1,
    "александра": 1,
    "алеся": 1,
    "алена": 1,
    "алина": 1,
    "алиса": 1,
    "алия": 1,
    "алла": 1,
    "алика": 1,
    "альбина": 1,
    "альмир": 1,
    "альфия": 1,
    "амина": 1,
    "анастасия": 1,
    "анатолия": 1,
    "ангелина": 1,
    "анжела": 1,
    "анимаиса": 1,
    "анисия": 1,
    "анисья": 1,
    "анна": 1,
    "анита": 1,
    "антонина": 1,
    "антонида": 1,
    "антония": 1,
    "анфиса": 1,
    "анфуса": 1,
    "анфия": 1,
    "амира": 1,
    "аполлинария": 1,
    "аревик": 1,
    "ариадна": 1,
    "арина": 1,
    "аркадия": 1,
    "арсения": 1,
    "арсиана": 1,
    "артемия": 1,
    "асель": 1,
    "аста": 1,
    "астра": 1,
    "астрид": 1,
    "афанасия": 1,
    "афродита": 1,
    "аэлита": 1,
    "аэлла": 1,
    "амалия": 1,
    "бажена": 1,
    "беата": 1,
    "беатриса": 1,
    "бела": 1,
    "белла": 1,
    "беллатриса": 1,
    "берта": 1,
    "богдана": 1,
    "божена": 1,
    "болеслава": 1,
    "борислава": 1,
    "бриджет": 1,
    "бронислава": 1,
    "валентина": 1,
    "валерия": 1,
    "ванда": 1,
    "варвара": 1,
    "василина": 1,
    "василиса": 1,
    "васса": 1,
    "вацлава": 1,
    "вевея": 1,
    "велора": 1,
    "велория": 1,
    "венера": 1,
    "вера": 1,
    "вероника": 1,
    "веселина": 1,
    "веста": 1,
    "видана": 1,
    "викторина": 1,
    "виктория": 1,
    "вилена": 1,
    "виола": 1,
    "виолетта": 1,
    "виоланта": 1,
    "виринея": 1,
    "вита": 1,
    "виталия": 1,
    "виталина": 1,
    "виулена": 1,
    "влада": 1,
    "владилена": 1,
    "владимира": 1,
    "владислава": 1,
    "владлена": 1,
    "власта": 1,
    "воля": 1,
    "всеслава": 1,
    "гайя": 1,
    "гали": 1,
    "галина": 1,
    "ганна": 1,
    "гаяна": 1,
    "гаяния": 1,
    "гвинет": 1,
    "гелена": 1,
    "гелия": 1,
    "гелла": 1,
    "генриетта": 1,
    "гертруда": 1,
    "глафира": 1,
    "гликерия": 1,
    "глория": 1,
    "голуба": 1,
    "горислава": 1,
    "гюльанэ": 1,
    "гюльнара": 1,
    "гюльчитай": 1,
    "даздраперма": 1,
    "дайна": 1,
    "дана": 1,
    "дарья": 1,
    "дария": 1,
    "дарина": 1,
    "дарьяна": 1,
    "декабрина": 1,
    "дея": 1,
    "дия": 1,
    "джиневра": 1,
    "дженнифер": 1,
    "джульета": 1,
    "дианна": 1,
    "дилия": 1,
    "диля": 1,
    "дильфуза": 1,
    "дина": 1,
    "диния": 1,
    "диодора": 1,
    "дионисия": 1,
    "добрава": 1,
    "домна": 1,
    "домина": 1,
    "домника": 1,
    "доминика": 1,
    "донара": 1,
    "дорофея": 1,
    "доротея": 1,
    "ева": 1,
    "евгения": 1,
    "евдокия": 1,
    "евлалия": 1,
    "евлампия": 1,
    "евпраксия": 1,
    "евстолия": 1,
    "евфалия": 1,
    "евфросиния": 1,
    "екатерина": 1,
    "елена": 1,
    "елизавета": 1,
    "еликонида": 1,
    "ермиония": 1,
    "есения": 1,
    "ефимия": 1,
    "евфремия": 1,
    "жанна": 1,
    "ждана": 1,
    "жаннэ": 1,
    "жасмина": 1,
    "забава": 1,
    "заира": 1,
    "зара": 1,
    "зарема": 1,
    "зарина": 1,
    "зорина": 1,
    "заряна": 1,
    "зауре": 1,
    "звенислава": 1,
    "земфира": 1,
    "зиля": 1,
    "зинаида": 1,
    "зиновия": 1,
    "злата": 1,
    "зозан": 1,
    "зоя": 1,
    "зульфия": 1,
    "иванна": 1,
    "ида": 1,
    "илария": 1,
    "илиана": 1,
    "илона": 1,
    "ильмира": 1,
    "инга": 1,
    "индира": 1,
    "инесса": 1,
    "инна": 1,
    "иоанна": 1,
    "иона": 1,
    "ипатия": 1,
    "ипполита": 1,
    "ирада": 1,
    "ираида": 1,
    "ирена": 1,
    "ироида": 1,
    "ираклия": 1,
    "ирина": 1,
    "исидора": 1,
    "искра": 1,
    "ифигения": 1,
    "ия": 1,
    "кадрия": 1,
    "кермен": 1,
    "калиса": 1,
    "каллиста": 1,
    "камилла": 1,
    "камила": 1,
    "капитолина": 1,
    "карина": 1,
    "каролина": 1,
    "катерина": 1,
    "кира": 1,
    "кирилла": 1,
    "клавдия": 1,
    "клара": 1,
    "клариса": 1,
    "кларисса": 1,
    "клеопатра": 1,
    "клио": 1,
    "клер": 1,
    "конкордия": 1,
    "констанция": 1,
    "кристина": 1,
    "ксения": 1,
    "лавиния": 1,
    "лада": 1,
    "лана": 1,
    "лариса": 1,
    "лаура": 1,
    "лейла": 1,
    "лема": 1,
    "лена": 1,
    "лениана": 1,
    "ленина": 1,
    "леонида": 1,
    "леонила": 1,
    "леонтия": 1,
    "леся": 1,
    "ливия": 1,
    "лидия": 1,
    "лилиана": 1,
    "лилия": 1,
    "лилит": 1,
    "лина": 1,
    "лира": 1,
    "лия": 1,
    "лея": 1,
    "лора": 1,
    "луиза": 1,
    "лукерия": 1,
    "лукиана": 1,
    "лукина": 1,
    "люцина": 1,
    "лусинэ": 1,
    "любава": 1,
    "любовь": 1,
    "любомира": 1,
    "людмила": 1,
    "ляля": 1,
    "мавра": 1,
    "магда": 1,
    "магдалина": 1,
    "мадлен": 1,
    "майя": 1,
    "мая": 1,
    "мальвина": 1,
    "маргарита": 1,
    "мариана": 1,
    "марьяна": 1,
    "марианна": 1,
    "мариетта": 1,
    "мариэтта": 1,
    "марика": 1,
    "марина": 1,
    "мария": 1,
    "марья": 1,
    "мари": 1,
    "марлен": 1,
    "марлена": 1,
    "марта": 1,
    "марфа": 1,
    "матильда": 1,
    "матрена": 1,
    "матрёна": 1,
    "матрона": 1,
    "мелания": 1,
    "меланья": 1,
    "мелитина": 1,
    "милада": 1,
    "милана": 1,
    "милен": 1,
    "милица": 1,
    "милия": 1,
    "милослава": 1,
    "мира": 1,
    "мирра": 1,
    "мирослава": 1,
    "митродора": 1,
    "млада": 1,
    "мстислава": 1,
    "нада": 1,
    "надежда": 1,
    "надия": 1,
    "наина": 1,
    "наира": 1,
    "нана": 1,
    "настасья": 1,
    "наталья": 1,
    "наталия": 1,
    "нелли": 1,
    "неонила": 1,
    "ника": 1,
    "нина": 1,
    "нинелла": 1,
    "нинель": 1,
    "новелла": 1,
    "нонна": 1,
    "нора": 1,
    "нуркыз": 1,
    "насиба": 1,
    "оксана": 1,
    "октавия": 1,
    "октябрина": 1,
    "олеся": 1,
    "оливия": 1,
    "олимпиада": 1,
    "олимпия": 1,
    "ольга": 1,
    "офелия": 1,
    "павла": 1,
    "павлина": 1,
    "патриция": 1,
    "пелагея": 1,
    "платонида": 1,
    "поликсена": 1,
    "полина": 1,
    "правдина": 1,
    "прасковья": 1,
    "пенелопа": 1,
    "полислава": 1,
    "рада": 1,
    "радмила": 1,
    "раиса": 1,
    "раймонда": 1,
    "раялла": 1,
    "ревмира": 1,
    "регина": 1,
    "рената": 1,
    "римма": 1,
    "рогнеда": 1,
    "роза": 1,
    "розалина": 1,
    "розалия": 1,
    "розана": 1,
    "роксан": 1,
    "ростислава": 1,
    "руслана": 1,
    "руфина": 1,
    "руфь": 1,
    "раида": 1,
    "сабина": 1,
    "сабрина": 1,
    "саломея": 1,
    "соломея": 1,
    "самира": 1,
    "светлана": 1,
    "светозара": 1,
    "светослава": 1,
    "свобода": 1,
    "святослава": 1,
    "севастьяна": 1,
    "северина": 1,
    "селена": 1,
    "селина": 1,
    "селестина": 1,
    "серафима": 1,
    "сергияна": 1,
    "сильва": 1,
    "агриппина": 1,
    "алёна": 1,
    "вилора": 1,
    "вилория": 1,
    "джульетта": 1,
    "диана": 1,
    "евфимия": 1,
    "ефросиния": 1,
    "калерия": 1,
    "милена": 1,
    "муза": 1,
    "савина": 1,
    "сильвия": 1,
    "симона": 1,
    "слава": 1,
    "славяна": 1,
    "снежана": 1,
    "софья": 1,
    "софия": 1,
    "станислава": 1,
    "стелла": 1,
    "степанида": 1,
    "стефанида": 1,
    "стефания": 1,
    "сусанна": 1,
    "сосанна": 1,
    "сюзанна": 1,
    "таира": 1,
    "таисия": 1,
    "тальяна": 1,
    "тамара": 1,
    "тамила": 1,
    "томила": 1,
    "татьяна": 1,
    "текуса": 1,
    "тереза": 1,
    "улита": 1,
    "ульяна": 1,
    "услада": 1,
    "устинья": 1,
    "фаина": 1,
    "февронья": 1,
    "феликсана": 1,
    "фелицата": 1,
    "фелицитата": 1,
    "фелиция": 1,
    "федора": 1,
    "феодора": 1,
    "феодосия": 1,
    "феодосья": 1,
    "феоктиста": 1,
    "феофания": 1,
    "феона": 1,
    "флавия": 1,
    "флора": 1,
    "флория": 1,
    "флорентина": 1,
    "флоренция": 1,
    "флориана": 1,
    "фотина": 1,
    "харита": 1,
    "харитина": 1,
    "хиония": 1,
    "христина": 1,
    "цецилия": 1,
    "чеслава": 1,
    "эвелина": 1,
    "эвридика": 1,
    "эдда": 1,
    "элеонора": 1,
    "элина": 1,
    "эльвира": 1,
    "эльмира": 1,
    "эльза": 1,
    "эмилия": 1,
    "эмма": 1,
    "эрика": 1,
    "эсфирь": 1,
    "юдифь": 1,
    "юзефа": 1,
    "юлиана": 1,
    "юлитта": 1,
    "юлия": 1,
    "юманита": 1,
    "юния": 1,
    "юнона": 1,
    "юстина": 1,
    "ядвига": 1,
    "яна": 1,
    "янина": 1,
    "яромира": 1,
    "ярослава": 1
  }, exports.ruMaleNamesDict = {
    "ааран": 1,
    "аарен": 1,
    "ааррон": 1,
    "аб": 1,
    "аббат": 1,
    "абботт": 1,
    "абей": 1,
    "абелл": 1,
    "абель": 1,
    "абнар": 1,
    "абнер": 1,
    "абнор": 1,
    "абот": 1,
    "аботт": 1,
    "абрам": 1,
    "абран": 1,
    "абрахам": 1,
    "абсалон": 1,
    "авангард": 1,
    "август": 1,
    "августин": 1,
    "авдей": 1,
    "авдий": 1,
    "авенир": 1,
    "аверилл": 1,
    "аверкий": 1,
    "авксентий": 1,
    "аврам": 1,
    "аврор": 1,
    "аврорий": 1,
    "агап": 1,
    "аггей": 1,
    "агей": 1,
    "адам": 1,
    "аддам": 1,
    "аддисон": 1,
    "аден": 1,
    "адий": 1,
    "адисон": 1,
    "адиссон": 1,
    "адлэй": 1,
    "адней": 1,
    "адольф": 1,
    "адонис": 1,
    "адриан": 1,
    "адэйр": 1,
    "адэр": 1,
    "азия": 1,
    "азэлстан": 1,
    "айбл": 1,
    "айзек": 1,
    "айк": 1,
    "ак": 1,
    "акей": 1,
    "акерлеа": 1,
    "акерлей": 1,
    "акерли": 1,
    "аки": 1,
    "аким": 1,
    "аклеа": 1,
    "аклей": 1,
    "акли": 1,
    "аксён": 1,
    "актон": 1,
    "акэль": 1,
    "алан": 1,
    "аластеир": 1,
    "аластэйр": 1,
    "алвар": 1,
    "алвен": 1,
    "алви": 1,
    "алвин": 1,
    "алвис": 1,
    "алгар": 1,
    "алджернон": 1,
    "алевтин": 1,
    "алеистер": 1,
    "алек": 1,
    "алекс": 1,
    "александр": 1,
    "алексей": 1,
    "ален": 1,
    "алестер": 1,
    "алжир": 1,
    "алик": 1,
    "аликс": 1,
    "алим": 1,
    "алисандр": 1,
    "алисдэйр": 1,
    "алиссандр": 1,
    "алистер": 1,
    "алистэйр": 1,
    "аллан": 1,
    "аллен": 1,
    "аллин": 1,
    "аллистер": 1,
    "аллистир": 1,
    "аллистэйр": 1,
    "алтон": 1,
    "алф": 1,
    "алфонзо": 1,
    "алфорд": 1,
    "алфрид": 1,
    "альберт": 1,
    "альбин": 1,
    "альвиан": 1,
    "альвин": 1,
    "альдина": 1,
    "альпин": 1,
    "альтаир": 1,
    "альфа": 1,
    "альфи": 1,
    "альфред": 1,
    "алэйстер": 1,
    "алэйстэйр": 1,
    "амби": 1,
    "амброуз": 1,
    "амедеус": 1,
    "амиас": 1,
    "амори": 1,
    "амос": 1,
    "амьяс": 1,
    "анакин": 1,
    "ананий": 1,
    "анастасий": 1,
    "анатолий": 1,
    "анвар": 1,
    "ангел": 1,
    "ангес": 1,
    "андерсон": 1,
    "анджелл": 1,
    "андрей": 1,
    "андреян": 1,
    "андриан": 1,
    "андрон": 1,
    "анж": 1,
    "анис": 1,
    "анисий": 1,
    "анисим": 1,
    "анри": 1,
    "анском": 1,
    "анскомб": 1,
    "ансон": 1,
    "антван": 1,
    "антип": 1,
    "антон": 1,
    "антоний": 1,
    "антонин": 1,
    "антуан": 1,
    "аполлинарий": 1,
    "аполлон": 1,
    "арам": 1,
    "арвид": 1,
    "аргент": 1,
    "арден": 1,
    "арефий": 1,
    "арий": 1,
    "арик": 1,
    "арил": 1,
    "арин": 1,
    "аристарх": 1,
    "аркадий": 1,
    "аркелл": 1,
    "арлен": 1,
    "арли": 1,
    "арман": 1,
    "армен": 1,
    "арн": 1,
    "арне": 1,
    "арни": 1,
    "арнольд": 1,
    "арран": 1,
    "аррин": 1,
    "аррон": 1,
    "арсен": 1,
    "арсений": 1,
    "арт": 1,
    "артамон": 1,
    "артемий": 1,
    "арти": 1,
    "артур": 1,
    "артём": 1,
    "архип": 1,
    "арчи": 1,
    "арчибальд": 1,
    "аселет": 1,
    "аселин": 1,
    "асер": 1,
    "аскольд": 1,
    "астон": 1,
    "атеист": 1,
    "афанасий": 1,
    "афиноген": 1,
    "афтон": 1,
    "аффтон": 1,
    "ахмат": 1,
    "ахмет": 1,
    "ачилл": 1,
    "аш": 1,
    "ашер": 1,
    "ашот": 1,
    "аштон": 1,
    "баграт": 1,
    "бад": 1,
    "бадди": 1,
    "бажен": 1,
    "баз": 1,
    "базилик": 1,
    "байрон": 1,
    "байярд": 1,
    "бак": 1,
    "бакстер": 1,
    "балдер": 1,
    "балдрик": 1,
    "бамби": 1,
    "баптист": 1,
    "бардолф": 1,
    "барии": 1,
    "барклей": 1,
    "барнабас": 1,
    "барни": 1,
    "барнэби": 1,
    "барретт": 1,
    "барри": 1,
    "барт": 1,
    "бартоломей": 1,
    "бассетт": 1,
    "бастер": 1,
    "бастиан": 1,
    "батч": 1,
    "баян": 1,
    "беван": 1,
    "беверли": 1,
    "бевис": 1,
    "бедивир": 1,
    "бейб": 1,
    "бейлей": 1,
    "бейлие": 1,
    "бен": 1,
    "бенджамин": 1,
    "бенджи": 1,
    "бенедикт": 1,
    "бенет": 1,
    "беннетт": 1,
    "бенни": 1,
    "бенние": 1,
    "бенсон": 1,
    "бентлей": 1,
    "бентон": 1,
    "беорегард": 1,
    "бердт": 1,
    "беренгар": 1,
    "беренджер": 1,
    "берет": 1,
    "бернард": 1,
    "берни": 1,
    "берри": 1,
    "берт": 1,
    "берти": 1,
    "бертольд": 1,
    "бертон": 1,
    "бертрам": 1,
    "бертран": 1,
    "бивис": 1,
    "билл": 1,
    "билли": 1,
    "бисш": 1,
    "биф": 1,
    "блейн": 1,
    "близэ": 1,
    "блисс": 1,
    "блэйз": 1,
    "блэйк": 1,
    "блэйн": 1,
    "блэр": 1,
    "боб": 1,
    "бобби": 1,
    "богдан": 1,
    "боеслав": 1,
    "болдуин": 1,
    "болеслав": 1,
    "боллард": 1,
    "бомонт": 1,
    "бонифэйс": 1,
    "боримир": 1,
    "борис": 1,
    "борислав": 1,
    "боян": 1,
    "брадлей": 1,
    "браеден": 1,
    "брайен": 1,
    "брайон": 1,
    "бранден": 1,
    "брандон": 1,
    "браннон": 1,
    "брейден": 1,
    "брейдн": 1,
    "брендан": 1,
    "бренден": 1,
    "брендон": 1,
    "бреннан": 1,
    "брент": 1,
    "брентон": 1,
    "брет": 1,
    "бретт": 1,
    "бриар": 1,
    "брион": 1,
    "брис": 1,
    "бриско": 1,
    "бриттон": 1,
    "бриэм": 1,
    "бродерик": 1,
    "броди": 1,
    "броз": 1,
    "брок": 1,
    "бронислав": 1,
    "бронт": 1,
    "броуди": 1,
    "броук": 1,
    "брук": 1,
    "брукс": 1,
    "бруно": 1,
    "брутус": 1,
    "брьянт": 1,
    "брэд": 1,
    "брэди": 1,
    "брэдфорд": 1,
    "брэйден": 1,
    "брэйди": 1,
    "брэм": 1,
    "брэн": 1,
    "брюс": 1,
    "брююс": 1,
    "будимир": 1,
    "буз": 1,
    "букер": 1,
    "булат": 1,
    "бью": 1,
    "бэйли": 1,
    "вавила": 1,
    "вадим": 1,
    "вал": 1,
    "валентайн": 1,
    "валентин": 1,
    "валериан": 1,
    "валерий": 1,
    "валерьян": 1,
    "вальдемар": 1,
    "вальтер": 1,
    "ванадий": 1,
    "вард": 1,
    "варлаам": 1,
    "варлам": 1,
    "варлен": 1,
    "вартан": 1,
    "варфоломей": 1,
    "василий": 1,
    "василько": 1,
    "ваухан": 1,
    "вахтанг": 1,
    "вацлав": 1,
    "вашингтон": 1,
    "вебстер": 1,
    "велдон": 1,
    "велимир": 1,
    "велислав": 1,
    "велор": 1,
    "велорий": 1,
    "венедикт": 1,
    "вениамин": 1,
    "вер": 1,
    "вергилий": 1,
    "верджил": 1,
    "верн": 1,
    "вернон": 1,
    "вестер": 1,
    "вестлей": 1,
    "вестон": 1,
    "вик": 1,
    "викентий": 1,
    "виктор": 1,
    "вил": 1,
    "вилберн": 1,
    "вилей": 1,
    "вилен": 1,
    "вилий": 1,
    "вилиор": 1,
    "вилки": 1,
    "вилл": 1,
    "вилли": 1,
    "виллоби": 1,
    "вилмар": 1,
    "вилмер": 1,
    "вилмот": 1,
    "вилор": 1,
    "вилорг": 1,
    "вилорий": 1,
    "вилсон": 1,
    "вилф": 1,
    "вилфорд": 1,
    "виль": 1,
    "вильгельм": 1,
    "вильтон": 1,
    "вильям": 1,
    "вин": 1,
    "виндзор": 1,
    "винни": 1,
    "винс": 1,
    "винсент": 1,
    "винслоу": 1,
    "винтроп": 1,
    "винцент": 1,
    "виолен": 1,
    "вирджиль": 1,
    "виссарион": 1,
    "вистан": 1,
    "виталий": 1,
    "витейкр": 1,
    "витней": 1,
    "витольд": 1,
    "влад": 1,
    "владелин": 1,
    "владилен": 1,
    "владимир": 1,
    "владислав": 1,
    "владлен": 1,
    "влас": 1,
    "власий": 1,
    "воган": 1,
    "вогн": 1,
    "воин": 1,
    "воислав": 1,
    "волдо": 1,
    "волемир": 1,
    "волкер": 1,
    "воллис": 1,
    "володар": 1,
    "вольдемар": 1,
    "вольмир": 1,
    "вольт": 1,
    "вольф": 1,
    "вольфрам": 1,
    "воспой": 1,
    "всеволод": 1,
    "всемил": 1,
    "вуди": 1,
    "вудроу": 1,
    "вулф": 1,
    "вьятт": 1,
    "вэйд": 1,
    "вэйланд": 1,
    "вэнс": 1,
    "вячеслав": 1,
    "габби": 1,
    "габриель": 1,
    "габриэль": 1,
    "гавриил": 1,
    "гаврил": 1,
    "гаврила": 1,
    "гаврило": 1,
    "гай": 1,
    "гайдар": 1,
    "гайлс": 1,
    "галактион": 1,
    "гален": 1,
    "галий": 1,
    "гамильтон": 1,
    "гамлет": 1,
    "гантэр": 1,
    "гаральд": 1,
    "гарван": 1,
    "гарей": 1,
    "гарибальди": 1,
    "гарланд": 1,
    "гарнет": 1,
    "гарольд": 1,
    "гарри": 1,
    "гаррий": 1,
    "гарс": 1,
    "гарфилд": 1,
    "гас": 1,
    "гаспар": 1,
    "гваделупа": 1,
    "гвидон": 1,
    "гейб": 1,
    "гейл": 1,
    "гейр": 1,
    "гектор": 1,
    "гелеон": 1,
    "гелиан": 1,
    "гелий": 1,
    "ген": 1,
    "гений": 1,
    "геннадий": 1,
    "генри": 1,
    "генрих": 1,
    "геодар": 1,
    "георгий": 1,
    "геральд": 1,
    "герасим": 1,
    "герберт": 1,
    "герман": 1,
    "гермоген": 1,
    "герольд": 1,
    "геронт": 1,
    "геронтий": 1,
    "герт": 1,
    "гертруд": 1,
    "гидеон": 1,
    "гильберт": 1,
    "гисберт": 1,
    "гладвин": 1,
    "гланвилл": 1,
    "глеб": 1,
    "глендауэр": 1,
    "гленн": 1,
    "глэн": 1,
    "говард": 1,
    "годвин": 1,
    "годфри": 1,
    "голлагэр": 1,
    "голладжер": 1,
    "гомер": 1,
    "горазд": 1,
    "гораций": 1,
    "горд": 1,
    "гордей": 1,
    "горден": 1,
    "гордий": 1,
    "гордон": 1,
    "горимир": 1,
    "горислав": 1,
    "горн": 1,
    "граем": 1,
    "грай": 1,
    "гранвилл": 1,
    "гранд": 1,
    "гранит": 1,
    "грахэйм": 1,
    "грег": 1,
    "грей": 1,
    "гренвилл": 1,
    "григорий": 1,
    "гриир": 1,
    "грир": 1,
    "гриффин": 1,
    "гриффит": 1,
    "гровер": 1,
    "грэг": 1,
    "грэгори": 1,
    "грэди": 1,
    "грэм": 1,
    "гудвин": 1,
    "гудзон": 1,
    "гурий": 1,
    "густав": 1,
    "гэй": 1,
    "гэйбл": 1,
    "гэйг": 1,
    "гэйдж": 1,
    "гэйелорд": 1,
    "гэйл": 1,
    "гэйлон": 1,
    "гэйлорд": 1,
    "гэйр": 1,
    "гэлл": 1,
    "гэри": 1,
    "давей": 1,
    "дави": 1,
    "давид": 1,
    "давыд": 1,
    "дад": 1,
    "дадда": 1,
    "дадли": 1,
    "даймонд": 1,
    "дакей": 1,
    "дакота": 1,
    "дакс": 1,
    "далтон": 1,
    "дамайон": 1,
    "дамиан": 1,
    "дамир": 1,
    "дан": 1,
    "дана": 1,
    "дани": 1,
    "даниар": 1,
    "даниил": 1,
    "данил": 1,
    "данила": 1,
    "данило": 1,
    "даниэль": 1,
    "данки": 1,
    "данни": 1,
    "дар": 1,
    "дарби": 1,
    "дарвин": 1,
    "дарден": 1,
    "дарен": 1,
    "дариан": 1,
    "дарил": 1,
    "дарин": 1,
    "дарки": 1,
    "дарнелл": 1,
    "даррел": 1,
    "даррен": 1,
    "даррил": 1,
    "даррин": 1,
    "даррэль": 1,
    "дасти": 1,
    "дастин": 1,
    "дау": 1,
    "дафф": 1,
    "даффи": 1,
    "дашилл": 1,
    "дван": 1,
    "двэйн": 1,
    "деай": 1,
    "деван": 1,
    "девен": 1,
    "девереукс": 1,
    "девин": 1,
    "девон": 1,
    "дейв": 1,
    "дейл": 1,
    "дейрлл": 1,
    "дейрн": 1,
    "декабрий": 1,
    "деклан": 1,
    "декстер": 1,
    "делберт": 1,
    "делл": 1,
    "делмар": 1,
    "делрой": 1,
    "дементий": 1,
    "деметриус": 1,
    "демид": 1,
    "демократ": 1,
    "демон": 1,
    "демьян": 1,
    "ден": 1,
    "денвер": 1,
    "денеб": 1,
    "дензэль": 1,
    "дени": 1,
    "денил": 1,
    "денис": 1,
    "деннис": 1,
    "дентон": 1,
    "деон": 1,
    "деонн": 1,
    "деонт": 1,
    "дерби": 1,
    "дерек": 1,
    "дерик": 1,
    "дермот": 1,
    "дерок": 1,
    "деррен": 1,
    "дерри": 1,
    "деррил": 1,
    "дефорест": 1,
    "дефоррест": 1,
    "дешон": 1,
    "джадд": 1,
    "джадин": 1,
    "джай": 1,
    "джайлс": 1,
    "джак": 1,
    "джамар": 1,
    "джамей": 1,
    "джамисон": 1,
    "джарвис": 1,
    "джаред": 1,
    "джарод": 1,
    "джарред": 1,
    "джарретт": 1,
    "джаррод": 1,
    "джаспер": 1,
    "джасти": 1,
    "джастин": 1,
    "джеб": 1,
    "джед": 1,
    "джедидиа": 1,
    "джейдн": 1,
    "джейк": 1,
    "джейлн": 1,
    "джейми": 1,
    "джеймс": 1,
    "джейрт": 1,
    "джейсон": 1,
    "джекки": 1,
    "джекоб": 1,
    "джем": 1,
    "дженкин": 1,
    "джеп": 1,
    "джер": 1,
    "джералд": 1,
    "джеральд": 1,
    "джерард": 1,
    "джерваз": 1,
    "джервис": 1,
    "джереми": 1,
    "джери": 1,
    "джермэйн": 1,
    "джеролд": 1,
    "джером": 1,
    "джеррард": 1,
    "джерред": 1,
    "джерри": 1,
    "джеррод": 1,
    "джерролд": 1,
    "джес": 1,
    "джесси": 1,
    "джетро": 1,
    "джетт": 1,
    "джеф": 1,
    "джеффери": 1,
    "джефферсон": 1,
    "джеффрей": 1,
    "джеффри": 1,
    "джиб": 1,
    "джид": 1,
    "джиди": 1,
    "джил": 1,
    "джим": 1,
    "джими": 1,
    "джимми": 1,
    "джисберт": 1,
    "джиффард": 1,
    "джо": 1,
    "джоб": 1,
    "джоби": 1,
    "джоджо": 1,
    "джоди": 1,
    "джозеф": 1,
    "джой": 1,
    "джойс": 1,
    "джон": 1,
    "джоназан": 1,
    "джоназон": 1,
    "джонасон": 1,
    "джонатан": 1,
    "джоней": 1,
    "джони": 1,
    "джонни": 1,
    "джонти": 1,
    "джорги": 1,
    "джордан": 1,
    "джордж": 1,
    "джорди": 1,
    "джордон": 1,
    "джосс": 1,
    "джоул": 1,
    "джош": 1,
    "джошоа": 1,
    "джошуа": 1,
    "джулс": 1,
    "джульян": 1,
    "джустис": 1,
    "джьюд": 1,
    "джэй": 1,
    "джэйд": 1,
    "джэйда": 1,
    "джэйден": 1,
    "джэйдон": 1,
    "джэйкоб": 1,
    "джэйлен": 1,
    "джэйлин": 1,
    "джэйлон": 1,
    "джэймес": 1,
    "джэйсон": 1,
    "джэксон": 1,
    "джэмини": 1,
    "джэмми": 1,
    "джэн": 1,
    "ди": 1,
    "диакон": 1,
    "дигби": 1,
    "диггори": 1,
    "дигори": 1,
    "дидим": 1,
    "дизон": 1,
    "дик": 1,
    "дики": 1,
    "дикки": 1,
    "дил": 1,
    "дилан": 1,
    "дилберт": 1,
    "димер": 1,
    "димитрий": 1,
    "дин": 1,
    "диндр": 1,
    "дионис": 1,
    "дионисий": 1,
    "дирк": 1,
    "дмитрий": 1,
    "доб": 1,
    "добрыня": 1,
    "додж": 1,
    "дольф": 1,
    "дом": 1,
    "доменик": 1,
    "доминик": 1,
    "дон": 1,
    "дональд": 1,
    "дональт": 1,
    "донат": 1,
    "донни": 1,
    "донован": 1,
    "дор": 1,
    "дориан": 1,
    "дорофей": 1,
    "доусон": 1,
    "драйк": 1,
    "древ": 1,
    "дрейвн": 1,
    "дуайт": 1,
    "дуан": 1,
    "дуг": 1,
    "дуги": 1,
    "дуглас": 1,
    "дункан": 1,
    "дунстан": 1,
    "дью": 1,
    "дьюей": 1,
    "дьюэйн": 1,
    "дэвид": 1,
    "дэвис": 1,
    "дэй": 1,
    "дэйви": 1,
    "дэйн": 1,
    "дэйтон": 1,
    "дэн": 1,
    "дэни": 1,
    "дэниел": 1,
    "дэнни": 1,
    "дэррик": 1,
    "дэшон": 1,
    "дюк": 1,
    "евгений": 1,
    "евграф": 1,
    "евдоким": 1,
    "евлампий": 1,
    "евлогий": 1,
    "евсей": 1,
    "евстафий": 1,
    "егор": 1,
    "елеазар": 1,
    "елизар": 1,
    "елисей": 1,
    "емельян": 1,
    "епифан": 1,
    "еремей": 1,
    "ермак": 1,
    "ермил": 1,
    "ермолай": 1,
    "ерофей": 1,
    "еруслан": 1,
    "ефим": 1,
    "ефрем": 1,
    "ждан": 1,
    "жерар": 1,
    "жозеф": 1,
    "жорес": 1,
    "жюль": 1,
    "завир": 1,
    "зак": 1,
    "закери": 1,
    "зандер": 1,
    "захар": 1,
    "захарий": 1,
    "зачариа": 1,
    "зачэри": 1,
    "зед": 1,
    "зедекиа": 1,
    "зек": 1,
    "зигмунд": 1,
    "зигфрид": 1,
    "зиновий": 1,
    "зорий": 1,
    "зосим": 1,
    "зосима": 1,
    "зот": 1,
    "зубин": 1,
    "зэофилус": 1,
    "иб": 1,
    "ибрагим": 1,
    "иван": 1,
    "игнат": 1,
    "игнатий": 1,
    "игнатиус": 1,
    "игорь": 1,
    "ид": 1,
    "иероним": 1,
    "иззи": 1,
    "изидор": 1,
    "измаил": 1,
    "измайло": 1,
    "изяслав": 1,
    "ий": 1,
    "икар": 1,
    "илар": 1,
    "иларий": 1,
    "иларион": 1,
    "илий": 1,
    "илиодор": 1,
    "илларион": 1,
    "илья": 1,
    "имон": 1,
    "инглеберт": 1,
    "инграм": 1,
    "инди": 1,
    "индиана": 1,
    "индиго": 1,
    "инесент": 1,
    "иниго": 1,
    "иннокентий": 1,
    "иоанн": 1,
    "иорик": 1,
    "иосиф": 1,
    "ипат": 1,
    "ипатий": 1,
    "ипполит": 1,
    "ираклий": 1,
    "ирвайн": 1,
    "ирвин": 1,
    "ирвинг": 1,
    "ириней": 1,
    "ириний": 1,
    "ирл": 1,
    "ирм": 1,
    "ирнест": 1,
    "исай": 1,
    "исайя": 1,
    "исак": 1,
    "исакий": 1,
    "исей": 1,
    "исидор": 1,
    "иссак": 1,
    "исси": 1,
    "истер": 1,
    "июлий": 1,
    "йорк": 1,
    "ка": 1,
    "кадмус": 1,
    "казимир": 1,
    "каин": 1,
    "каир": 1,
    "кайд": 1,
    "кайл": 1,
    "кал": 1,
    "калин": 1,
    "калина": 1,
    "каллен": 1,
    "кам": 1,
    "камден": 1,
    "камиль": 1,
    "камрон": 1,
    "капитон": 1,
    "карбрей": 1,
    "карбри": 1,
    "карвер": 1,
    "карей": 1,
    "карен": 1,
    "карл": 1,
    "карлайл": 1,
    "карлейл": 1,
    "карлин": 1,
    "карлтон": 1,
    "карм": 1,
    "кармий": 1,
    "карп": 1,
    "каррол": 1,
    "картер": 1,
    "касиди": 1,
    "каспар": 1,
    "каспер": 1,
    "кассиди": 1,
    "касьян": 1,
    "квентин": 1,
    "квинтин": 1,
    "кеван": 1,
    "кевин": 1,
    "кей": 1,
    "кейденс": 1,
    "кейдн": 1,
    "кейлб": 1,
    "кеймрон": 1,
    "кейси": 1,
    "келвин": 1,
    "келкей": 1,
    "келл": 1,
    "келли": 1,
    "келсей": 1,
    "кемп": 1,
    "кен": 1,
    "кендал": 1,
    "кендол": 1,
    "кендрик": 1,
    "кенелм": 1,
    "кензи": 1,
    "кенит": 1,
    "кеннеди": 1,
    "кеннет": 1,
    "кенни": 1,
    "кеннит": 1,
    "кенрик": 1,
    "кент": 1,
    "кентиджерн": 1,
    "кентон": 1,
    "кермит": 1,
    "керней": 1,
    "керр": 1,
    "керри": 1,
    "керт": 1,
    "кертис": 1,
    "кешон": 1,
    "ки": 1,
    "киаран": 1,
    "килан": 1,
    "килер": 1,
    "килиан": 1,
    "киллиан": 1,
    "ким": 1,
    "кимбелайн": 1,
    "кимберли": 1,
    "кимбол": 1,
    "кимбэль": 1,
    "кин": 1,
    "кинан": 1,
    "кинастон": 1,
    "кинг": 1,
    "кингслей": 1,
    "кип": 1,
    "киприан": 1,
    "кир": 1,
    "киран": 1,
    "кирби": 1,
    "кирилл": 1,
    "кирк": 1,
    "кирон": 1,
    "кирус": 1,
    "кит": 1,
    "китон": 1,
    "киф": 1,
    "клавдий": 1,
    "клайв": 1,
    "клайд": 1,
    "кланкей": 1,
    "кланки": 1,
    "кларенс": 1,
    "кларк": 1,
    "клев": 1,
    "клей": 1,
    "клейтон": 1,
    "клем": 1,
    "клемент": 1,
    "клементий": 1,
    "клемми": 1,
    "клетис": 1,
    "клетус": 1,
    "кливленд": 1,
    "клим": 1,
    "климент": 1,
    "климентий": 1,
    "клинт": 1,
    "клинтон": 1,
    "клифтон": 1,
    "клифф": 1,
    "клиффорд": 1,
    "клод": 1,
    "клэйрк": 1,
    "клэр": 1,
    "кодей": 1,
    "коди": 1,
    "коертней": 1,
    "козьма": 1,
    "кола": 1,
    "коламбан": 1,
    "колберт": 1,
    "колби": 1,
    "колдер": 1,
    "колин": 1,
    "коллахан": 1,
    "коллин": 1,
    "коллум": 1,
    "колтен": 1,
    "колтон": 1,
    "колумбий": 1,
    "кольт": 1,
    "конан": 1,
    "конвей": 1,
    "кондрат": 1,
    "кондратий": 1,
    "конлей": 1,
    "коннелл": 1,
    "коннер": 1,
    "коннор": 1,
    "конон": 1,
    "конор": 1,
    "конрад": 1,
    "константин": 1,
    "конфуций": 1,
    "корбин": 1,
    "корделл": 1,
    "корей": 1,
    "кори": 1,
    "корней": 1,
    "корнелий": 1,
    "корнелиус": 1,
    "корнил": 1,
    "кортней": 1,
    "кортни": 1,
    "корэй": 1,
    "коти": 1,
    "коул": 1,
    "коулман": 1,
    "краснослав": 1,
    "крис": 1,
    "криспиан": 1,
    "криспин": 1,
    "кристи": 1,
    "кристиан": 1,
    "кристопэр": 1,
    "кристоф": 1,
    "кристофер": 1,
    "крофорд": 1,
    "крофтон": 1,
    "крэйг": 1,
    "ксавайор": 1,
    "ксавьер": 1,
    "ксан": 1,
    "ксенофонт": 1,
    "ксзавир": 1,
    "кузьма": 1,
    "куин": 1,
    "куинкей": 1,
    "куинси": 1,
    "куинтон": 1,
    "купер": 1,
    "куприян": 1,
    "курт": 1,
    "куртис": 1,
    "кэйд": 1,
    "кэйдн": 1,
    "кэйл": 1,
    "кэйлб": 1,
    "кэймрон": 1,
    "кэйн": 1,
    "кэйси": 1,
    "кэлвин": 1,
    "кэм": 1,
    "кэмп": 1,
    "кэмпбэл": 1,
    "кэри": 1,
    "кюри": 1,
    "лаверн": 1,
    "лавлл": 1,
    "лавр": 1,
    "лаврентий": 1,
    "лаз": 1,
    "лазарь": 1,
    "лайл": 1,
    "лайонел": 1,
    "лаки": 1,
    "ланни": 1,
    "ланфорд": 1,
    "ларион": 1,
    "ларк": 1,
    "ларкин": 1,
    "ларри": 1,
    "лаэрт": 1,
    "лев": 1,
    "леви": 1,
    "левкий": 1,
    "лейврн": 1,
    "лейн": 1,
    "лейтон": 1,
    "лекс": 1,
    "леланд": 1,
    "лель": 1,
    "лем": 1,
    "лемми": 1,
    "лемюэль": 1,
    "лен": 1,
    "ленар": 1,
    "ленард": 1,
    "лени": 1,
    "лениан": 1,
    "леннард": 1,
    "ленни": 1,
    "лео": 1,
    "леон": 1,
    "леонард": 1,
    "леонид": 1,
    "леонтий": 1,
    "леопольд": 1,
    "лермонт": 1,
    "лерой": 1,
    "лес": 1,
    "лесли": 1,
    "лестер": 1,
    "ли": 1,
    "либерт": 1,
    "ливадий": 1,
    "лии": 1,
    "лин": 1,
    "линдон": 1,
    "линдсей": 1,
    "линдси": 1,
    "линкольн": 1,
    "линн": 1,
    "линсей": 1,
    "линтон": 1,
    "линус": 1,
    "линфорд": 1,
    "лионель": 1,
    "лир": 1,
    "лирой": 1,
    "лисандр": 1,
    "литон": 1,
    "лихнис": 1,
    "ллойд": 1,
    "ллью": 1,
    "лльюелин": 1,
    "лльюеллин": 1,
    "ло": 1,
    "ловэль": 1,
    "лойд": 1,
    "лон": 1,
    "лондон": 1,
    "лонни": 1,
    "лонс": 1,
    "лор": 1,
    "лорен": 1,
    "лоренс": 1,
    "лори": 1,
    "лорин": 1,
    "лорис": 1,
    "лорни": 1,
    "лоррин": 1,
    "лосон": 1,
    "лоуэлл": 1,
    "лоэнгрин": 1,
    "лу": 1,
    "лудо": 1,
    "луи": 1,
    "лука": 1,
    "лукиан": 1,
    "лукьян": 1,
    "льюин": 1,
    "льюис": 1,
    "лэйк": 1,
    "лэйн": 1,
    "лэйтон": 1,
    "лэндон": 1,
    "лэнс": 1,
    "лэрри": 1,
    "любим": 1,
    "любомир": 1,
    "людвиг": 1,
    "людовик": 1,
    "люк": 1,
    "люкс": 1,
    "люксен": 1,
    "люсьен": 1,
    "лютер": 1,
    "люциан": 1,
    "маверик": 1,
    "маврикий": 1,
    "мадисон": 1,
    "маеслав": 1,
    "май": 1,
    "майк": 1,
    "майкл": 1,
    "майлз": 1,
    "майрон": 1,
    "майслав": 1,
    "макар": 1,
    "макарий": 1,
    "макей": 1,
    "макензи": 1,
    "маки": 1,
    "макинтош": 1,
    "маккензи": 1,
    "макс": 1,
    "максвелл": 1,
    "максим": 1,
    "максимилиан": 1,
    "максимиллиан": 1,
    "максимильян": 1,
    "малачи": 1,
    "малком": 1,
    "малоун": 1,
    "манлей": 1,
    "манни": 1,
    "манникс": 1,
    "мануил": 1,
    "мануйло": 1,
    "манфред": 1,
    "марат": 1,
    "марвин": 1,
    "мариан": 1,
    "марин": 1,
    "мариус": 1,
    "марк": 1,
    "марка": 1,
    "маркел": 1,
    "маркиан": 1,
    "марко": 1,
    "маркус": 1,
    "марлен": 1,
    "марлин": 1,
    "марлон": 1,
    "марлоу": 1,
    "мармадьюк": 1,
    "марри": 1,
    "марс": 1,
    "марсен": 1,
    "марти": 1,
    "мартиал": 1,
    "мартин": 1,
    "мартын": 1,
    "маршал": 1,
    "маршалл": 1,
    "марьян": 1,
    "масон": 1,
    "мастерман": 1,
    "матвей": 1,
    "матти": 1,
    "мед": 1,
    "мелвилль": 1,
    "мелвин": 1,
    "мельбурн": 1,
    "мерв": 1,
    "мервин": 1,
    "мерди": 1,
    "мердо": 1,
    "мердок": 1,
    "мередит": 1,
    "мерит": 1,
    "меркурий": 1,
    "мерл": 1,
    "мерлин": 1,
    "меррилл": 1,
    "мерритт": 1,
    "мертон": 1,
    "мерфи": 1,
    "мефодий": 1,
    "мечеслав": 1,
    "мечислав": 1,
    "мид": 1,
    "миид": 1,
    "мик": 1,
    "мика": 1,
    "мики": 1,
    "микки": 1,
    "милад": 1,
    "милан": 1,
    "милберн": 1,
    "милен": 1,
    "милий": 1,
    "миллард": 1,
    "мило": 1,
    "милонег": 1,
    "милослав": 1,
    "милтон": 1,
    "милфорд": 1,
    "мир": 1,
    "мирон": 1,
    "мирослав": 1,
    "митчелл": 1,
    "михаил": 1,
    "михайло": 1,
    "мич": 1,
    "мича": 1,
    "мичил": 1,
    "мо": 1,
    "модест": 1,
    "моз": 1,
    "моисей": 1,
    "молком": 1,
    "монолит": 1,
    "монро": 1,
    "монтагью": 1,
    "монтгомери": 1,
    "монте": 1,
    "монти": 1,
    "монтморенки": 1,
    "морган": 1,
    "морген": 1,
    "мордекэй": 1,
    "морис": 1,
    "морлей": 1,
    "моррис": 1,
    "морт": 1,
    "морти": 1,
    "мортимер": 1,
    "мортон": 1,
    "мосс": 1,
    "моэ": 1,
    "мстислав": 1,
    "мулава": 1,
    "мурат": 1,
    "мэйнард": 1,
    "мэйнерд": 1,
    "мэйор": 1,
    "мэйсон": 1,
    "мэйтланд": 1,
    "мэлори": 1,
    "мэль": 1,
    "мэриан": 1,
    "мэрион": 1,
    "мэт": 1,
    "мэтт": 1,
    "мэтти": 1,
    "мэтью": 1,
    "мюд": 1,
    "надир": 1,
    "назаниль": 1,
    "назар": 1,
    "назарий": 1,
    "назим": 1,
    "найджел": 1,
    "найлс": 1,
    "наль": 1,
    "нанди": 1,
    "нат": 1,
    "натан": 1,
    "наум": 1,
    "науэлл": 1,
    "наш": 1,
    "невада": 1,
    "неван": 1,
    "невил": 1,
    "невилл": 1,
    "нед": 1,
    "нейл": 1,
    "нейлл": 1,
    "нейт": 1,
    "нельсон": 1,
    "нео": 1,
    "неон": 1,
    "неонил": 1,
    "нестер": 1,
    "нестор": 1,
    "нивек": 1,
    "нивен": 1,
    "ник": 1,
    "никандр": 1,
    "никанор": 1,
    "никита": 1,
    "никифор": 1,
    "никк": 1,
    "никки": 1,
    "никодим": 1,
    "никола": 1,
    "николай": 1,
    "николас": 1,
    "никон": 1,
    "нил": 1,
    "нили": 1,
    "нимбус": 1,
    "нинел": 1,
    "нинель": 1,
    "нисон": 1,
    "нифонт": 1,
    "ноа": 1,
    "новомир": 1,
    "нодар": 1,
    "ной": 1,
    "нолан": 1,
    "нолл": 1,
    "норберт": 1,
    "норвуд": 1,
    "норд": 1,
    "норм": 1,
    "норман": 1,
    "норманд": 1,
    "норрис": 1,
    "нортон": 1,
    "ноубль": 1,
    "ноэль": 1,
    "ньют": 1,
    "ньютон": 1,
    "оберон": 1,
    "обин": 1,
    "обри": 1,
    "овидий": 1,
    "огастин": 1,
    "огден": 1,
    "огэст": 1,
    "оделл": 1,
    "одиссей": 1,
    "одлей": 1,
    "одран": 1,
    "оз": 1,
    "оззи": 1,
    "океан": 1,
    "оксар": 1,
    "октавиан": 1,
    "октябрин": 1,
    "октябрь": 1,
    "олби": 1,
    "олбэйн": 1,
    "олдвен": 1,
    "олдвин": 1,
    "олден": 1,
    "олдин": 1,
    "олдис": 1,
    "олдон": 1,
    "олдос": 1,
    "олдред": 1,
    "олдус": 1,
    "олдфорд": 1,
    "олег": 1,
    "олей": 1,
    "оли": 1,
    "оливер": 1,
    "олимпий": 1,
    "олластер": 1,
    "олластир": 1,
    "оллгар": 1,
    "оллджер": 1,
    "олли": 1,
    "оллин": 1,
    "оллисдэйр": 1,
    "оллистер": 1,
    "оллистэйр": 1,
    "оллон": 1,
    "оллэйстар": 1,
    "ольгерд": 1,
    "омар": 1,
    "омега": 1,
    "онисим": 1,
    "ора": 1,
    "оран": 1,
    "орвал": 1,
    "орвилл": 1,
    "орест": 1,
    "ориан": 1,
    "ормерод": 1,
    "оррелл": 1,
    "оррин": 1,
    "орсон": 1,
    "осберт": 1,
    "осбоерн": 1,
    "осборн": 1,
    "освальд": 1,
    "осень": 1,
    "осип": 1,
    "оскар": 1,
    "остап": 1,
    "остен": 1,
    "остин": 1,
    "остромир": 1,
    "отис": 1,
    "оттис": 1,
    "отто": 1,
    "оттон": 1,
    "оуин": 1,
    "оуэн": 1,
    "ошин": 1,
    "павел": 1,
    "пайс": 1,
    "палладий": 1,
    "палмер": 1,
    "панкрас": 1,
    "пантелей": 1,
    "пантелеймон": 1,
    "панфил": 1,
    "парамон": 1,
    "паркер": 1,
    "паррис": 1,
    "партизан": 1,
    "пат": 1,
    "патрик": 1,
    "патси": 1,
    "пахом": 1,
    "пеитон": 1,
    "пепин": 1,
    "пересвет": 1,
    "перри": 1,
    "перс": 1,
    "перси": 1,
    "персиваль": 1,
    "петеркин": 1,
    "пимен": 1,
    "пип": 1,
    "пипер": 1,
    "пирр": 1,
    "пирс": 1,
    "пит": 1,
    "питер": 1,
    "платон": 1,
    "пол": 1,
    "поли": 1,
    "поликарп": 1,
    "помпей": 1,
    "портер": 1,
    "порфирий": 1,
    "потап": 1,
    "престон": 1,
    "приам": 1,
    "принц": 1,
    "пров": 1,
    "прозор": 1,
    "прокопий": 1,
    "прокофий": 1,
    "проспер": 1,
    "протас": 1,
    "прохор": 1,
    "пэйс": 1,
    "пэйси": 1,
    "пэйтон": 1,
    "пётр": 1,
    "петр": 1,
    "равель": 1,
    "равен": 1,
    "равиль": 1,
    "радамес": 1,
    "радий": 1,
    "радим": 1,
    "радислав": 1,
    "радомир": 1,
    "раз": 1,
    "раймонд": 1,
    "раймунд": 1,
    "райордан": 1,
    "райт": 1,
    "ралф": 1,
    "ралфи": 1,
    "ральф": 1,
    "ранделл": 1,
    "ранди": 1,
    "рандолф": 1,
    "рандольф": 1,
    "расс": 1,
    "рассел": 1,
    "рассэль": 1,
    "расти": 1,
    "растус": 1,
    "ратмир": 1,
    "рауль": 1,
    "рафаил": 1,
    "рафаэль": 1,
    "рашид": 1,
    "раян": 1,
    "реарден": 1,
    "ревмир": 1,
    "реган": 1,
    "редд": 1,
    "редж": 1,
    "реджи": 1,
    "реджинальд": 1,
    "редклиф": 1,
    "редклифф": 1,
    "редлей": 1,
    "редманд": 1,
    "редмонд": 1,
    "реид": 1,
    "рей": 1,
    "рейли": 1,
    "рейнард": 1,
    "рейнольд": 1,
    "рекс": 1,
    "рем": 1,
    "ренальд": 1,
    "ренат": 1,
    "риган": 1,
    "ригби": 1,
    "рид": 1,
    "ридлей": 1,
    "риель": 1,
    "рик": 1,
    "рикей": 1,
    "рики": 1,
    "рилан": 1,
    "рилей": 1,
    "рили": 1,
    "ринат": 1,
    "рио": 1,
    "риплей": 1,
    "рис": 1,
    "рихард": 1,
    "рич": 1,
    "ричард": 1,
    "ричи": 1,
    "роальд": 1,
    "роб": 1,
    "робби": 1,
    "роберт": 1,
    "робеспьер": 1,
    "роби": 1,
    "робин": 1,
    "робинзон": 1,
    "рован": 1,
    "род": 1,
    "роддж": 1,
    "родджер": 1,
    "родди": 1,
    "родерик": 1,
    "роджер": 1,
    "родион": 1,
    "родни": 1,
    "родолф": 1,
    "рождеро": 1,
    "рой": 1,
    "ройл": 1,
    "ройс": 1,
    "ройстон": 1,
    "роки": 1,
    "ролан": 1,
    "роланд": 1,
    "роли": 1,
    "ролланд": 1,
    "ролли": 1,
    "роман": 1,
    "ромен": 1,
    "ромуальд": 1,
    "рон": 1,
    "рональд": 1,
    "ронни": 1,
    "рори": 1,
    "роско": 1,
    "росс": 1,
    "ростислав": 1,
    "роуланд": 1,
    "роулей": 1,
    "роял": 1,
    "рубен": 1,
    "рубин": 1,
    "руди": 1,
    "рудольф": 1,
    "рудьярд": 1,
    "рунар": 1,
    "руслан": 1,
    "руссо": 1,
    "рустам": 1,
    "рустем": 1,
    "рхетт": 1,
    "рьюб": 1,
    "рэд": 1,
    "рэй": 1,
    "рэйнард": 1,
    "рэйнер": 1,
    "рэйф": 1,
    "рэм": 1,
    "рэндал": 1,
    "рэндалл": 1,
    "рюрик": 1,
    "сава": 1,
    "савва": 1,
    "савелий": 1,
    "савьер": 1,
    "сайг": 1,
    "саймон": 1,
    "салал": 1,
    "салливан": 1,
    "самми": 1,
    "самойло": 1,
    "самсон": 1,
    "самуил": 1,
    "сандфорд": 1,
    "санни": 1,
    "санфорд": 1,
    "свет": 1,
    "светлан": 1,
    "светозар": 1,
    "светослав": 1,
    "свизин": 1,
    "свизун": 1,
    "свиней": 1,
    "святогор": 1,
    "святополк": 1,
    "святослав": 1,
    "себастьян": 1,
    "севард": 1,
    "севастиан": 1,
    "севастьян": 1,
    "север": 1,
    "севериан": 1,
    "северин": 1,
    "северьян": 1,
    "северян": 1,
    "седрик": 1,
    "сеймур": 1,
    "селби": 1,
    "семён": 1,
    "септембер": 1,
    "серапион": 1,
    "серафим": 1,
    "сергей": 1,
    "сесил": 1,
    "сет": 1,
    "сефтон": 1,
    "сивард": 1,
    "сигизмунд": 1,
    "сигманд": 1,
    "сид": 1,
    "сидней": 1,
    "сидор": 1,
    "сила": 1,
    "силас": 1,
    "силвестр": 1,
    "сильвер": 1,
    "сильвест": 1,
    "сильвестр": 1,
    "симеон": 1,
    "симон": 1,
    "синклэйр": 1,
    "сирил": 1,
    "сисар": 1,
    "скай": 1,
    "скилар": 1,
    "скилер": 1,
    "скот": 1,
    "скотти": 1,
    "скуилер": 1,
    "слава": 1,
    "слай": 1,
    "слэйд": 1,
    "совет": 1,
    "сократ": 1,
    "соломон": 1,
    "сони": 1,
    "сонни": 1,
    "софокл": 1,
    "софон": 1,
    "спайк": 1,
    "спарроу": 1,
    "спартак": 1,
    "спенсер": 1,
    "спиридон": 1,
    "спиро": 1,
    "стакей": 1,
    "сталий": 1,
    "сталь": 1,
    "станислав": 1,
    "стаффорд": 1,
    "степан": 1,
    "стерлинг": 1,
    "стеф": 1,
    "стефан": 1,
    "сти": 1,
    "стив": 1,
    "стивен": 1,
    "стиви": 1,
    "стиу": 1,
    "сторм": 1,
    "стратон": 1,
    "сту": 1,
    "стэки": 1,
    "стэн": 1,
    "стэнли": 1,
    "стэнфорд": 1,
    "стюарт": 1,
    "сурен": 1,
    "сэм": 1,
    "сэмюэль": 1,
    "сэнди": 1,
    "тад": 1,
    "таддеус": 1,
    "таир": 1,
    "тай": 1,
    "такер": 1,
    "тал": 1,
    "талбот": 1,
    "таннер": 1,
    "тарас": 1,
    "таскилл": 1,
    "таффи": 1,
    "тед": 1,
    "тейгу": 1,
    "тейдж": 1,
    "теймураз": 1,
    "тейрк": 1,
    "текс": 1,
    "тельнан": 1,
    "тенгиз": 1,
    "тенней": 1,
    "теннизон": 1,
    "тео": 1,
    "теобальд": 1,
    "теодор": 1,
    "теранс": 1,
    "теренс": 1,
    "терентий": 1,
    "терло": 1,
    "терранс": 1,
    "террелл": 1,
    "терренс": 1,
    "терстон": 1,
    "ти": 1,
    "тиарнак": 1,
    "тиарнан": 1,
    "тибалт": 1,
    "тибби": 1,
    "тигран": 1,
    "тигу": 1,
    "тизон": 1,
    "тилар": 1,
    "тилер": 1,
    "тилор": 1,
    "тим": 1,
    "тимми": 1,
    "тимоти": 1,
    "тимофей": 1,
    "тимур": 1,
    "тирелл": 1,
    "тирнан": 1,
    "тирней": 1,
    "тирон": 1,
    "тироун": 1,
    "тиррелл": 1,
    "тит": 1,
    "тихомир": 1,
    "тихон": 1,
    "тоал": 1,
    "тоби": 1,
    "тобиас": 1,
    "тобин": 1,
    "товий": 1,
    "тод": 1,
    "тодд": 1,
    "толли": 1,
    "том": 1,
    "томас": 1,
    "томми": 1,
    "тон": 1,
    "тони": 1,
    "топэр": 1,
    "торез": 1,
    "торий": 1,
    "торлей": 1,
    "торнтон": 1,
    "травис": 1,
    "тракей": 1,
    "трантер": 1,
    "траффорд": 1,
    "траэрн": 1,
    "трев": 1,
    "тревельян": 1,
    "тревор": 1,
    "трейврс": 1,
    "трейс": 1,
    "трейси": 1,
    "трент": 1,
    "трентон": 1,
    "тристан": 1,
    "тристрам": 1,
    "трифон": 1,
    "трой": 1,
    "трофим": 1,
    "труман": 1,
    "туллий": 1,
    "тусон": 1,
    "тэдди": 1,
    "тэди": 1,
    "тэйлер": 1,
    "тэйлор": 1,
    "тэйн": 1,
    "тэйт": 1,
    "тэл": 1,
    "тэмпл": 1,
    "тэрри": 1,
    "уилбер": 1,
    "уиллард": 1,
    "уиллис": 1,
    "уилфред": 1,
    "уилфрид": 1,
    "уильям": 1,
    "уинстон": 1,
    "уинфред": 1,
    "уисдом": 1,
    "улайксс": 1,
    "улиссес": 1,
    "ульяна": 1,
    "уолли": 1,
    "уоллис": 1,
    "уолт": 1,
    "уолтер": 1,
    "уолтон": 1,
    "уорик": 1,
    "уорнер": 1,
    "уоррен": 1,
    "уот": 1,
    "уоткин": 1,
    "уптон": 1,
    "урбан": 1,
    "уриах": 1,
    "устин": 1,
    "уэйн": 1,
    "уэсли": 1,
    "фабиан": 1,
    "фаддей": 1,
    "фадей": 1,
    "фалк": 1,
    "фарид": 1,
    "фарлей": 1,
    "фарон": 1,
    "фарран": 1,
    "февралин": 1,
    "федор": 1,
    "федосий": 1,
    "фелан": 1,
    "фелиз": 1,
    "феликс": 1,
    "фелим": 1,
    "фелис": 1,
    "фентон": 1,
    "феодосий": 1,
    "феофан": 1,
    "ферги": 1,
    "фергус": 1,
    "ферд": 1,
    "ферди": 1,
    "фердинанд": 1,
    "фернан": 1,
    "фернанд": 1,
    "фестер": 1,
    "фестус": 1,
    "фидель": 1,
    "фидо": 1,
    "фил": 1,
    "филайп": 1,
    "филандр": 1,
    "филарет": 1,
    "филат": 1,
    "филберт": 1,
    "филимон": 1,
    "филип": 1,
    "филипп": 1,
    "фило": 1,
    "финикс": 1,
    "финис": 1,
    "флегонт": 1,
    "флемминг": 1,
    "флечер": 1,
    "флинн": 1,
    "флинт": 1,
    "флойд": 1,
    "флорентий": 1,
    "флоренц": 1,
    "флорин": 1,
    "флорри": 1,
    "флурри": 1,
    "фок": 1,
    "фокс": 1,
    "фома": 1,
    "фонз": 1,
    "фонзи": 1,
    "форбес": 1,
    "форд": 1,
    "форест": 1,
    "форрест": 1,
    "фостер": 1,
    "фот": 1,
    "фотий": 1,
    "фоук": 1,
    "фразир": 1,
    "франклин": 1,
    "франц": 1,
    "фред": 1,
    "фредди": 1,
    "фредерик": 1,
    "фредрик": 1,
    "фрейзер": 1,
    "фрейзр": 1,
    "фридрих": 1,
    "фримэн": 1,
    "фритс": 1,
    "фродо": 1,
    "фрол": 1,
    "фрэнк": 1,
    "фрэнки": 1,
    "фрэнклин": 1,
    "фрэнс": 1,
    "фрэнсис": 1,
    "фёдор": 1,
    "хавелок": 1,
    "хадвин": 1,
    "хадлей": 1,
    "хал": 1,
    "хам": 1,
    "хамиш": 1,
    "хамлет": 1,
    "хаммонд": 1,
    "ханк": 1,
    "ханлей": 1,
    "хантер": 1,
    "харв": 1,
    "харви": 1,
    "харди": 1,
    "хардинг": 1,
    "харитон": 1,
    "харкоерт": 1,
    "харлан": 1,
    "харланд": 1,
    "харлей": 1,
    "харлин": 1,
    "хармон": 1,
    "харпер": 1,
    "харрис": 1,
    "харрисон": 1,
    "хартлей": 1,
    "хауелл": 1,
    "хедлей": 1,
    "хек": 1,
    "хендерсон": 1,
    "хендрик": 1,
    "хенрай": 1,
    "хенри": 1,
    "херб": 1,
    "херби": 1,
    "хервей": 1,
    "херлей": 1,
    "хиацинт": 1,
    "хилари": 1,
    "хиллэри": 1,
    "хирам": 1,
    "хис": 1,
    "хитклифф": 1,
    "хию": 1,
    "хоард": 1,
    "хоб": 1,
    "ходдж": 1,
    "хойт": 1,
    "холден": 1,
    "холл": 1,
    "холлис": 1,
    "хомер": 1,
    "хопкин": 1,
    "хорас": 1,
    "хоратайо": 1,
    "хоуи": 1,
    "храбр": 1,
    "христоф": 1,
    "христофор": 1,
    "худд": 1,
    "хуей": 1,
    "хует": 1,
    "хукк": 1,
    "хукслей": 1,
    "хумберт": 1,
    "хунтлей": 1,
    "хуффи": 1,
    "хью": 1,
    "хьюберт": 1,
    "хьюго": 1,
    "хьюи": 1,
    "хэвен": 1,
    "хэдлей": 1,
    "хэйвуд": 1,
    "хэйден": 1,
    "хэйл": 1,
    "хэмфри": 1,
    "хэппи": 1,
    "хюи": 1,
    "цезарь": 1,
    "чад": 1,
    "чадвик": 1,
    "чаз": 1,
    "чак": 1,
    "чакки": 1,
    "чарлз": 1,
    "чарли": 1,
    "чарлтон": 1,
    "чарльз": 1,
    "час": 1,
    "чейз": 1,
    "чендлер": 1,
    "ченс": 1,
    "черокез": 1,
    "чеслав": 1,
    "честер": 1,
    "чеьянн": 1,
    "чип": 1,
    "чонки": 1,
    "чонси": 1,
    "ша": 1,
    "шад": 1,
    "шаи": 1,
    "шайенн": 1,
    "шакуилл": 1,
    "шамиль": 1,
    "шамус": 1,
    "шан": 1,
    "шаннен": 1,
    "шаннон": 1,
    "шау": 1,
    "шеврон": 1,
    "шелби": 1,
    "шелдон": 1,
    "шеллей": 1,
    "шелтон": 1,
    "шем": 1,
    "шервуд": 1,
    "шеридан": 1,
    "шерлок": 1,
    "шерман": 1,
    "ши": 1,
    "шилох": 1,
    "шимус": 1,
    "шмидт": 1,
    "шолто": 1,
    "шон": 1,
    "шэй": 1,
    "шэйн": 1,
    "эбби": 1,
    "эбен": 1,
    "эбенезер": 1,
    "эвальд": 1,
    "эван": 1,
    "эвелин": 1,
    "эверард": 1,
    "эверетт": 1,
    "эверитт": 1,
    "эвот": 1,
    "эгберт": 1,
    "эд": 1,
    "эдан": 1,
    "эдвард": 1,
    "эдвин": 1,
    "эдгар": 1,
    "эдди": 1,
    "эдип": 1,
    "эдисон": 1,
    "эдмонд": 1,
    "эдмунд": 1,
    "эдон": 1,
    "эдуард": 1,
    "эдун": 1,
    "эзраа": 1,
    "эзэлстан": 1,
    "эзэлуолф": 1,
    "эйб": 1,
    "эйби": 1,
    "эйвери": 1,
    "эйден": 1,
    "эйлберт": 1,
    "эйлвард": 1,
    "эймерей": 1,
    "эймери": 1,
    "эйнар": 1,
    "эйнслей": 1,
    "эйнсли": 1,
    "эйс": 1,
    "элайотт": 1,
    "элбан": 1,
    "элвин": 1,
    "элвис": 1,
    "элвуд": 1,
    "элгар": 1,
    "элдвен": 1,
    "элдвин": 1,
    "элден": 1,
    "элджер": 1,
    "элдин": 1,
    "элдис": 1,
    "элдон": 1,
    "элдред": 1,
    "элдус": 1,
    "электрон": 1,
    "эли": 1,
    "элиас": 1,
    "элиджа": 1,
    "элиот": 1,
    "элла": 1,
    "эллгар": 1,
    "эллджер": 1,
    "эллери": 1,
    "эллиот": 1,
    "эллис": 1,
    "элмер": 1,
    "элрик": 1,
    "элрой": 1,
    "элсдон": 1,
    "эль": 1,
    "эльберт": 1,
    "эльбрус": 1,
    "эльдар": 1,
    "эльмар": 1,
    "эльмир": 1,
    "эльтон": 1,
    "эмерсон": 1,
    "эмилиан": 1,
    "эмилий": 1,
    "эмиль": 1,
    "эммануель": 1,
    "эммануил": 1,
    "эммерсон": 1,
    "эммет": 1,
    "эмметт": 1,
    "эмори": 1,
    "эмэри": 1,
    "энвер": 1,
    "энгель": 1,
    "энджелберт": 1,
    "энди": 1,
    "эндрю": 1,
    "энергий": 1,
    "энтони": 1,
    "эразм": 1,
    "эраст": 1,
    "эрван": 1,
    "эрвин": 1,
    "эрг": 1,
    "эрек": 1,
    "эрий": 1,
    "эрик": 1,
    "эрих": 1,
    "эрл": 1,
    "эрлен": 1,
    "эрн": 1,
    "эрнест": 1,
    "эрни": 1,
    "эрнст": 1,
    "эрон": 1,
    "эррол": 1,
    "эрролл": 1,
    "этан": 1,
    "этелберт": 1,
    "этелред": 1,
    "этелрик": 1,
    "этелхард": 1,
    "эшли": 1,
    "эюзби": 1,
    "ювеналий": 1,
    "юджин": 1,
    "юлиан": 1,
    "юлий": 1,
    "юлиус": 1,
    "юм": 1,
    "юниор": 1,
    "юпитер": 1,
    "юрий": 1,
    "юстас": 1,
    "юстин": 1,
    "яков": 1,
    "ян": 1,
    "янкей": 1,
    "янки": 1,
    "януарий": 1,
    "ярвуд": 1,
    "яромир": 1,
    "ярополк": 1,
    "ярослав": 1
  }, exports.ruBindingWords = [ "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "пота", "потому", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "тож", "только", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы", "а-ля", "без", "безо", "благодаря", "близ", "в", "ввиду", "вглубь", "вдоль", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "во", "возле", "вокруг", "вопреки", "впереди", "вразрез", "вроде", "вслед", "вследствие", "для", "до", "за", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "к", "ко", "кроме", "кругом", "меж", "между", "мимо", "на", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду", "насупротив", "насчёт", "не", "ниже", "о", "об", "обо", "обок", "около", "окромя", "округ", "от", "относительно", "ото", "перед", "передо", "по", "по-за", "по-над", "поверх", "под", "подле", "подо", "подобно", "позади", "помимо", "поперёк", "порядка", "посередине", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "применительно", "про", "против", "путём", "ради", "с", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "со", "согласно", "спустя", "среди", "средь", "сродни", "судя", "супротив", "у", "через", "чрез", "иже", "какой-либо", "какой-то", "кое-кто", "кой", "кто", "кто-либо", "многий", "мя", "насколько", "немногий", "нещечко", "никой", "ничегошеньки", "се", "сё", "такой-то", "тот-то", "чё", "чево", "чей-либо", "чей-нибудь", "чей-то", "шо", "эта", "кем", "ком", "кому", "нахуя", "чей", "чему", "вам", "вами", "вас", "вы", "Вы", "ее", "её", "его", "ей", "ему", "ею", "им", "ими", "их", "меня", "мне", "мной", "мною", "мы", "нём", "нем", "нам", "нами", "неё", "него", "ней", "нему", "нею", "ним", "ними", "них", "он", "она", "оне", "они", "оно", "тебе", "тебя", "тобой", "тобою", "ты", "я", "иной", "кое-какой", "кое-чей", "кое-что", "кой-какой", "кой-кто", "кто-нибудь", "кто-то", "куда-нибудь", "некто", "нечто", "что-либо", "что-нибудь", "что-то", "весь", "всякий", "любой", "сам", "самый", "таков", "этакий", "другой", "некем", "некому", "нечего", "нечем", "нечему", "никакой", "никто", "ничего", "ничей", "ничем", "ничему", "ничто", "ваш", "ихний", "моё", "мой", "моя", "наш", "свой", "твой", "оный", "сей", "сие", "сии", "сия", "та", "такой", "тот", "ту", "эдакий", "эти", "это", "этот", "ась", "аюшки", "таки", "а", "авось-либо", "ага", "аминь", "б", "бишь", "буквально", "бы", "было", "вишь", "вон", "вот", "вот-вот", "вряд", "всего", "давай", "де", "действительно", "дескать", "добро", "довольно", "ещё", "исключительно", "ить", "ишь", "ка", "кажется", "конечно", "ладно", "лих", "лучше", "мол", "навряд", "наоборот", "небось", "нет", "неужели", "нехай", "никак", "ну", "ну-с", "по-видимому", "пожалуй", "пожалуйста", "полно", "положительно", "предовольно", "простите", "просто-напросто", "пускай", "разумеется", "сём-ка", "сем", "скорее", "спасибо", "так", "то-то", "тоже", "уж", "уже", "ужели", "ужли", "фон", "хорошо", "эдак", "эк", "этак" ];
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.words = {}, exports = window.lastName.plugins.ru.words) : exports = module.exports, function(exports) {
  return exports.adverbs = [ "абсолютно", "адски", "азартно", "активно", "аспидно", "баснословно", "бдительно", "безапелляционно", "безбожно", "безвозвратно", "безгранично", "безжалостно", "беззаветно", "беззастенчиво", "безмерно", "безмятежно", "безнадежно", "безоговорочно", "безраздельно", "безропотно", "безудержно", "безукоризненно", "безумно", "безупречно", "безусловно", "безустанно", "безутешно", "бескомпромиссно", "бесконечно", "беспардонно", "бесповоротно", "беспощадно", "беспредельно", "беспрекословно", "бесследно", "бессовестно", "бесстыдно", "бесчеловечно", "бешено", "бурно", "вдребезги", "вконец", "вовсю", "всемерно", "всесторонне", "всецело", "всячески", "высоко", "глубоко", "горько", "горячо", "грубо", "густо", "диаметрально", "дико", "досконально", "досыта", "дотошно", "дьявольски", "жарко", "жгуче", "железно", "жестко", "жестоко", "живо", "жизненно", "жутко", "запоем", "запредельно", "зверски", "здорово", "злостно", "идеально", "излишне", "изрядно", "изумительно", "исключительно", "исступленно", "истово", "истошно", "исчерпывающе", "кардинально", "катастрофически", "категорически", "клятвенно", "колоссально", "крайне", "крепко", "кристально", "кровно", "крупно", "круто", "люто", "максимально", "мертвецки", "мучительно", "навзрыд", "нагло", "наглухо", "наглядно", "наголову", "надежно", "надрывно", "назубок", "намертво", "наотрез", "напрочь", "нарочито", "насквозь", "настоятельно", "насущно", "начисто", "небывало", "невероятно", "невиданно", "невообразимо", "невыносимо", "невыразимо", "недопустимо", "неизмеримо", "неимоверно", "неистово", "немилосердно", "немыслимо", "необыкновенно", "необычайно", "неописуемо", "неопровержимо", "непомерно", "непоправимо", "непостижимо", "непримиримо", "непробудно", "непроходимо", "неразрывно", "несказанно", "неслыханно", "несметно", "несравненно", "нестерпимо", "неудержимо", "неузнаваемо", "неуклонно", "неукоснительно", "неустанно", "неусыпно", "неутешно", "неутомимо", "нещадно", "оглушительно", "ожесточенно", "ослепительно", "основательно", "остро", "откровенно", "открыто", "отлично", "отменно", "отчаянно", "очень", "панически", "патологически", "пламенно", "плотно", "по-настоящему", "по-собачьи", "подлинно", "подчеркнуто", "позарез", "поистине", "полностью", "поразительно", "порядком", "порядочно", "потрясающе", "предельно", "прекрасно", "преступно", "прилично", "примитивно", "принципиально", "приторно", "пронзительно", "радикально", "разительно", "редкостно", "резко", "рекордно", "свято", "серьезно", "сильно", "слепо", "смертельно", "совершенно", "совсем", "страстно", "страшно", "строго", "строго-настрого", "существенно", "твердо", "тяжело", "тяжко", "убийственно", "удивительно", "ужасающе", "ужасно", "фанатически", "фанатично", "фантастически", "феноменально", "хорошенько", "хорошо", "чертовски", "чрезвычайно", "чрезмерно", "чудовищно", "широко", "шумно", "щедро", "ярко", "яростно" ], exports.unions = [ "а", "а именно", "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "все-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как бы", "как то", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "после того как", "пота", "потому", "потому как", "потому что", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "то есть", "тож", "только", "только что", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы" ], exports.prepositionAll = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо", "включая", "невзирая на", "несмотря на", "по", "по-за", "про", "с", "сквозь", "со", "спустя", "через", "чрез", "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по", "при", "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "среди", "средь", "супротив", "у", "в связи с", "в соответствии с", "вслед за", "лицом к лицу с", "над", "надо", "наряду с", "перед", "передо", "по сравнению с", "по-над", "пред", "предо", "рядом с", "следом за" ], exports.prepositionSimple = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionAcusative = [ "в", "включая", "во", "за", "на", "не в", "не за", "невзирая на", "несмотря на", "о", "об", "обо", "по", "по-за", "под", "подо", "про", "с", "сквозь", "со", "спустя", "через", "чрез" ], exports.prepositionDative = [ "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по" ], exports.prepositionPrepositional = [ "в", "во", "на", "не в", "о", "об", "обо", "по", "при" ], exports.prepositionGenetive = [ "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "меж", "между", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "со", "среди", "средь", "супротив", "у" ], exports.prepositionInstrumental = [ "в связи с", "в соответствии с", "вслед за", "за", "лицом к лицу с", "меж", "между", "над", "надо", "наряду с", "не за", "перед", "передо", "по сравнению с", "по-над", "под", "подо", "пред", "предо", "рядом с", "с", "следом за", "со" ], exports.prepositionWithSingleCase = [ "без", "без ведома", "безо", "благодаря", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в связи с", "в силу", "в соответствии с", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "вдоль по", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "вопреки", "впереди", "впредь до", "вроде", "вслед", "вслед за", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "к", "ко", "кроме", "кругом", "лицом к", "лицом к лицу с", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду с", "насупротив", "насчёт", "начиная с", "не без", "не считая", "невзирая на", "недалеко от", "независимо от", "несмотря на", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "перед", "передо", "по линии", "по мере", "по направлению к", "по отношению к", "по поводу", "по причине", "по случаю", "по сравнению с", "по-за", "по-над", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "подобно", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "при помощи", "применительно к", "про", "против", "путём", "ради", "рядом с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "согласно", "спустя", "среди", "средь", "сродни", "судя по", "супротив", "у", "через", "чрез" ], exports.prepositionWith2Cases = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionWith3Cases = [ "по", "с", "со" ];
}(exports);

var exports, ref, util, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.dates = {}, exports = window.lastName.plugins.ru.dates, ref = window.lastName.plugins.ru.ref, util = window.lastName.util) : (exports = module.exports, ref = require("./ref"), util = require("../../util")), function(exports, util, ref) {
  var dateObjectToString, extractDates, getRuMonthIndex, getValidDate, packDates, packIntervals, ruMonthInDates;
  return ruMonthInDates = [ "января", "февраля", "марта", "аперля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря" ], dateObjectToString = function(dateObj) {
    var d, m, y, _ref;
    return y = ((_ref = typeof dateObj.y) === "number" || _ref === "string") && dateObj.y || "", m = dateObj.m + 1, m = m > 9 && m || "0" + m, d = dateObj.d > 9 && dateObj.d || "0" + dateObj.d, "" + d + "." + m + "." + y;
  }, getValidDate = function(dateObj) {
    var defaultYear, dt;
    defaultYear = dateObj.y;
    if (void 0 === dateObj.y || dateObj.y < 1970 || dateObj.y > 2038) dateObj.y = 2e3;
    return dt = new Date(Date.UTC(dateObj.y, dateObj.m, dateObj.d)), dt.getMonth() === dateObj.m && dt.getDate() === dateObj.d ? (dateObj.y = defaultYear, dateObj) : null;
  }, getRuMonthIndex = function(str) {
    var m;
    return m = str.toLowerCase().match(/(\s|^)(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s|$)/g), m ? ruMonthInDates.indexOf(m[0].replace(/\s/g, "")) : -1;
  }, exports.extractDates = extractDates = function(strArr) {
    var dates, intervals, sources;
    return dates = {}, sources = [], intervals = {}, strArr instanceof Array || (strArr = [ strArr ]), strArr.map(function(str) {
      var dStr, date, found, from, fromDate, fromMonth, fromYear, id, intObject, mIndex, sourceStr, to, toDate, toYear, verboseMatch, wordsArr, _ref, _results;
      verboseMatch = str.match(/\s+\d{1,2}\s+((января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)\s+|)(\d{2,4}(\s+года|)\s+|)по\s+\d{1,2}\s+(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s+\d{2,4}|)(\s+|$)/mig);
      if (!verboseMatch) {
        wordsArr = str.split(" "), found = !1, _results = [];
        while (wordsArr.length > 2 && !found) /^\d[\d]$/.test(wordsArr[0]) && (mIndex = ruMonthInDates.indexOf(wordsArr[1].toLowerCase()), mIndex >= 0 ? (date = {
          d: parseInt(wordsArr[0], 10),
          m: mIndex
        }, /^\d{2,4}$/.test(wordsArr[2]) ? (date.y = parseInt(wordsArr[2], 10), sourceStr = wordsArr.slice(0, 3).join(" ")) : sourceStr = wordsArr.slice(0, 2).join(" ")) : /^\d\d\.\d\d.\d{2,4}$/.test(wordsArr[0] || /^\d\d\.\d\d$/.test(wordsArr[0])) ? (date = {
          d: parseInt(wordsArr[0].slice(0, 3), 10),
          m: parseInt(wordsArr[0].slice(3, 6), 10),
          y: parseInt(wordsArr[0].slice(6), 10) || void 0
        }, sourceStr = wordsArr[0]) : date = {}, date = getValidDate(date), date && (found = !0, sources.push(sourceStr), dStr = dateObjectToString(date), dates[dStr] ? dates[dStr].count++ : dates[dStr] = {
          count: 1,
          value: date
        })), _results.push(wordsArr.shift());
        return _results;
      }
      _ref = verboseMatch[0].toLowerCase().split("по"), from = _ref[0], to = _ref[1], toYear = to.replace(/\d{1,2}/, "").match(/\d+/g), toYear ? toYear = parseInt(toYear[0], 10) : toYear = void 0, toDate = {
        d: parseInt(to.match(/\d{1,2}/g)[0], 10),
        m: getRuMonthIndex(to),
        y: toYear
      }, fromYear = from.replace(/\d{1,2}/, "").match(/\d+/g), fromMonth = getRuMonthIndex(from), fromYear ? fromYear = parseInt(fromYear[0], 10) : fromYear = toYear, fromMonth === -1 && (fromMonth = toDate.m), fromDate = {
        d: parseInt(from.match(/\d{1,2}/g)[0], 10),
        m: fromMonth,
        y: fromYear
      }, toDate = getValidDate(toDate), fromDate = getValidDate(fromDate);
      if (toDate && fromDate) return intObject = {
        from: dateObjectToString(fromDate),
        from_value: fromDate,
        to: dateObjectToString(toDate),
        to_value: toDate
      }, id = "" + intObject.from + "-" + intObject.to, intervals[id] ? intervals[id].count++ : (intObject.count = 1, intervals[id] = intObject), sources.push(verboseMatch[0]);
    }), {
      dates: dates,
      sources: sources,
      intervals: intervals
    };
  }, exports.packDates = packDates = function(dates, defaultYear) {
    var dateObj, id, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in dates) dateObj = dates[id], "undefined" != typeof dateObj.value.y && years.push(dateObj.value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in dates) dateObj = dates[id], "undefined" == typeof dateObj.value.y && (dateObj.value.y = defaultYear), out["" + dateObjectToString(dateObj.value)] = dateObj.count;
    return out;
  }, exports.packIntervals = packIntervals = function(intervals, defaultYear) {
    var id, interval, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in intervals) interval = intervals[id], "undefined" != typeof interval.from_value.y && years.push(interval.from_value.y), "undefined" != typeof interval.to_value.y && years.push(interval.to_value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in intervals) interval = intervals[id], "undefined" == typeof interval.from_value.y && (interval.from_value.y = defaultYear), "undefined" == typeof interval.to_value.y && (interval.to_value.y = defaultYear), out["" + dateObjectToString(interval.from_value) + "-" + dateObjectToString(interval.to_value)] = interval.count;
    return out;
  }, exports.preFilter = function(text, result) {
    var dates, numRe;
    numRe = /((([а-яё]+)\s+){0,1}\d[\.\d]{0,}(\s+(([a-яё]+)|([\.\d]+))){1,6})|([12]\d\d\d)/mig, dates = extractDates(util.unique(text.match(numRe) || [])), util.dictKeys(dates.dates).length > 0 && (result.dates = packDates(dates.dates)), util.dictKeys(dates.intervals).length > 0 && (result.intervals = packIntervals(dates.intervals));
    if (dates.sources.length > 0) return result.date_sources = dates.sources;
  };
}(exports, util, ref);

var exports, ref, util, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.inclines = {}, exports = window.lastName.plugins.ru.inclines, util = window.lastName.util, ref = window.lastName.plugins.ru.ref) : (exports = module.exports, util = require("../../util"), ref = require("./ref")), function(exports, util, ref) {
  var cases, doInclineFemaleName, doInclineMaleName, findProperName, genderMatch, getNominative, inclineAndGetResult, inclineFemMiddleName, inclineFemaleName, inclineFemaleNameAndGetResult, inclineFemaleSurname, inclineMaleMiddleName, inclineMaleName, inclineMaleNameAndGetResult, inclineMaleSurname, inclineMiddleName, inclineMiddleNameOrSurname, inclineName, inclinePersonSurname, inclineSurname, matchCase, matchNameAndSurname, matchNameParts;
  return cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ], exports.doInclineFemaleName = doInclineFemaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, aUnstressedRe, name2;
    return aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, aUnstressedRe = /ца$/g, name2 = name.slice(0, -1), aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aUnstressedRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ей", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /ия$/g.test(name) && name.length > 3 ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "и" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ь", "" + name2 + "ью", "" + name2 + "и" ] : /[жшщцч]$/g.test(name) ? [ "" + name, "" + name + "и", "" + name + "и", "" + name, "" + name + "ью", "" + name + "и" ] : [ name, name, name, name, name, name ];
  }, exports.doInclineMaleName = doInclineMaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, hardConsonants, hissingAndChe, ishortRe, name2;
    return hardConsonants = /[бвгдзклмнпрстфх]$/g, hissingAndChe = /[жшщцч]$/g, ishortRe = /((ай)|(ей)|(ой)|(уй)|(яй)|(юй)|(ий))$/g, aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, name2 = name.slice(0, -1), name === "Лев" ? [ "Лев", "Льва", "Льву", "Льва", "Львом", "Льве" ] : name === "Павел" ? [ "Павел", "Павла", "Павлу", "Павла", "Павлом", "Павле" ] : /и$/g.test(name) ? [ name, name, name, name, name, name ] : hissingAndChe.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ем", "" + name + "е" ] : hardConsonants.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ом", "" + name + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : ishortRe.test(name) ? [ "" + name2 + "й", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ко$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /о$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : null;
  }, inclineAndGetResult = function(fn, args) {
    var i, name, r;
    r = null;
    for (i in args) {
      name = args[i], r = fn(name, !0);
      if (r.found) break;
    }
    return r;
  }, inclineFemaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineFemaleName, arguments);
  }, inclineMaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineMaleName, arguments);
  }, exports.inclineFemaleName = inclineFemaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name3, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), nl = name.toLowerCase(), nominativeRe = /[адежзийклмнорстуьэя]$/g, canInclineRe = /[жшщцчаяь]$/g, genitiveRe = /[иы]$/g, dativeRe = /[еи]$/g, accusativeRe = /[жшщцчьую]$/g, instrumentalRe = /((ой)|(ей)|(еи)|(ью))$/g, prepositionalRe = /[еи]$/g, result = r = null, nominativeRe.test(nl) && ref.ruFemaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineFemaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "female",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name2 = name.slice(0, -1), name_cases = [], genitiveRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("dative"))), prepositionalRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("prepositional"))), accusativeRe.test(nl) && (/[ую]$/g.test(nl) ? r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а") : r = inclineFemaleNameAndGetResult(name), r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (name3 = name.slice(0, -2), r = inclineFemaleNameAndGetResult("" + name3 + "я", "" + name3 + "а", "" + name3 + "ь", "" + name3), r && r.found && (result = r, name_cases.push("instrumental"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineMaleName = inclineMaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), name === "Льв" && (name = "Лев"), name === "Павл" && (name = "Павел"), nl = name.toLowerCase(), nominativeRe = /([вгдзклмнпрстфхжшцьй]|(ба)|(ва)|(да)|(за)|(ла)|(ма)|(на)|(па)|(ра)|(са)|(та)|(фа)|(га)|(ка)|(ха)|(жа)|(ша)|(ща)|(ца)|(ча)|(я)|(ло)|(ко))$/g, canInclineRe = /([бвгдзклмнпрстфхжшцьая]|(ия)|(ья)|(ея)|(ий)|(ей))$/g, genitiveRe = /[аяыи]$/g, dativeRe = /(([еую])|(ии))$/g, accusativeRe = /[аяую]$/g, instrumentalRe = /((ом)|(ем)|(ой)|(ей)|(ёй))$/g, prepositionalRe = /((е)|(ии))$/g, name2 = name.slice(0, -1), result = r = null, nominativeRe.test(nl) && ref.ruMaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineMaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "male",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name_cases = [], genitiveRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /ы$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "о", "" + name2 + "а") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "а", "" + name.slice(0, -1) + "я", "" + name.slice(0, -1) + "о") : r = null, r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (/у$/g.test(nl) ? r = inclineMaleName(name2) : /[аеиоуя]ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "й") : /ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "ь") : /е$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "и", "" + name2 + "я", "" + name2 + "o") : /ии$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я") : r = null, r && r.found && (result = r, name_cases.push("dative"))), accusativeRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /у$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а") : /[ую]$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : r = null, r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (/ом$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2)) : /ем$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2), "" + name.slice(0, -2) + "ь", "" + name.slice(0, -2) + "й") : /ой$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "а", "" + name.slice(0, -2) + "о") : /((ей)|(ёй))$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "я", "" + name.slice(0, -2) + "а") : r = null, r && r.found && (result = r, name_cases.push("instrumental"))), prepositionalRe.test(nl) && (/е$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2, "" + name2 + "ь", "" + name2 + "й", "" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я", "" + name2 + "й") : r = null, r && r.found && (result = r, name_cases.push("prepositional"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineName = inclineName = function(name) {
    var fn, mn, result;
    return fn = inclineFemaleName(name), mn = inclineMaleName(name), fn.found ? result = {
      found: !0,
      src: name,
      gender: "female",
      guess_case: fn.guess_case,
      female_cases: fn.cases,
      possible_cases: fn.possible_cases,
      nominative: fn.nominative
    } : mn.found ? result = {
      found: !0,
      src: name,
      gender: "male",
      guess_case: mn.guess_case,
      male_cases: mn.cases,
      possible_cases: mn.possible_cases,
      nominative: mn.nominative
    } : fn.possible_yes && mn.possible_yes ? (result = {
      found: "maybe",
      src: name,
      gender: [ "male", "female" ],
      female_cases: fn.cases,
      male_cases: mn.cases,
      possible_cases: util.merge(fn.possible_cases, mn.possible_cases)
    }, result.guess_case = fn.guess_case_index <= mn.guess_case_index ? fn.guess_case : mn.guess_case) : fn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "female",
      female_cases: fn.cases,
      guess_case: fn.cases,
      possible_cases: fn.possible_cases
    } : mn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "male",
      male_cases: mn.cases,
      guess_case: mn.cases,
      possible_cases: mn.possible_cases
    } : result = {
      found: !1,
      src: name
    }, result;
  }, inclineSurname = function(surname, noInclinesRe, inclineRe, casesRe) {
    var c, cases_index, check, i, result, surname_cases, _i, _j, _len, _len2;
    result = {
      found: null,
      src: surname,
      cases: null,
      cases_index: null
    };
    if (noInclinesRe && noInclinesRe.test(surname)) result = {
      found: surname,
      src: surname,
      cases: [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ],
      cases_index: [ 0, 1, 2, 3, 4, 5 ]
    }; else for (_i = 0, _len = inclineRe.length; _i < _len; _i++) {
      check = inclineRe[_i];
      if (check[0].test(surname)) {
        result = {
          found: surname.replace(check[0], check[1]),
          src: surname
        }, cases_index = [], surname_cases = [], i = 0;
        for (_j = 0, _len2 = casesRe.length; _j < _len2; _j++) c = casesRe[_j], c.test(surname) && (cases_index.push(i), surname_cases.push(cases[i])), i++;
        surname_cases.length === 0 ? (result.found = null, result.cases = null) : result.cases = surname_cases, result.cases_index = cases_index;
        break;
      }
    }
    return result.surname_cases && (result.guess_case = result.surname_cases[0]), result;
  }, exports.inclineFemaleSurname = inclineFemaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(е)|(о)|(э)|(и)|(ы)|(^[нв]у)|(^ую)|(уа)|(иа)|(ман)|(вич)|(ян))$/g, inclineRe = [ [ /((ова)|(овой)|(ову))$/g, "ова" ], [ /((ева)|(евой)|(еву))$/g, "ева" ], [ /((ёва)|(ёвой)|(ёву))$/g, "ёва" ], [ /((ина)|(иной)|(ину))$/g, "ина" ], [ /((ая)|(ой)|(ую))$/g, "ая" ] ], casesRe = [ /((ова)|(ева)|(ёва)|(ина)|(ая))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((ову)|(еву)|(ёву)|(ину)|(ую))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, exports.inclineMaleSurname = inclineMaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(^ве)|(^го)|(э)|(и)|(ы)|(^му)|(ю)|(уа)|(иа))$/g, inclineRe = [ [ /((ов)|(ова)|(ову)|(овым)|(ове))$/g, "ов" ], [ /((ев)|(ева)|(еву)|(евым)|(еве))$/g, "ев" ], [ /((ёв)|(ёва)|(ёву)|(ёвым)|(ёве))$/g, "ёв" ], [ /((ин)|(ина)|(ину)|(иным)|(ине))$/g, "ин" ], [ /((ский)|(ского)|(скому)|(ским)|(ском))$/g, "ский" ], [ /((ской)|(ского)|(скому)|(ским)|(ском))$/g, "ской" ], [ /((ман)|(мана)|(ману)|(маном)|(мане))$/g, "ман" ], [ /((ой)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ой" ], [ /((ий)|(ого)|(ому)|(ого)|(им)|(ом))$/g, "ий" ], [ /((ый)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ый" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ], [ /((ян)|(яна)|(яну)|(яна)|(яном)|(яне))$/g, "ян" ] ], casesRe = [ /((ов)|(ев)|(ёв)|(ин)|(ский)|(ской)|(ой)|(ий)|(ый)|(ман)|(ич)|(ян))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((ову)|(еву)|(ёву)|(ину)|(скому)|(ому)|(ману)|(ичу)|(яну))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((овым)|(евым)|(ёвым)|(иным)|(ским)|(им)|(ым)|(маном)|(ичем)|(яном))$/g, /((ове)|(еве)|(ёве)|(ине)|(ском)|(ом)|(мане)|(иче)|(яне))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, inclineMiddleNameOrSurname = function(src, fem, male) {
    var result, _ref;
    return fem.found === (_ref = male.found) && _ref === null ? result = {
      found: !1,
      src: src,
      value: null,
      gender: null
    } : fem.found && male.found ? (result = {
      found: !0,
      src: src,
      gender: [ "male", "female" ]
    }, result.nominative_male = male.found, result.nominative_female = fem.found, result.female_cases = fem.cases, result.male_cases = male.cases, fem.cases.length === 6 ? male.cases.length === 6 ? (result.guess_sex = "unknown", result.possible_cases = util.merge(fem.cases, male.cases)) : (result.guess_sex = "male", result.nominative = male.found, result.possible_cases = male.cases) : fem.cases.length === 1 && male.cases.length > 1 ? (result.guess_sex = "female", result.nominative = fem.found, result.possible_cases = fem.cases) : result.possible_cases = util.merge(fem.cases, male.cases)) : fem.found ? male.found || (result = {
      found: !0,
      src: src,
      gender: "female",
      female_cases: fem.cases,
      guess_case: fem.guess_case,
      nominative: fem.found,
      possible_cases: fem.cases
    }) : result = {
      found: !0,
      src: src,
      gender: "male",
      male_cases: male.cases,
      guess_case: male.guess_case,
      nominative: male.found,
      possible_cases: male.cases
    }, result;
  }, exports.inclineSurname = inclinePersonSurname = function(surname) {
    return inclineMiddleNameOrSurname(surname, inclineFemaleSurname(surname), inclineMaleSurname(surname));
  }, exports.inclineMaleMiddleName = inclineMaleMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((евич)|(евича)|(евичу)|(евича)|(евичем)|(евиче))$/g, "евич" ], [ /((ович)|(овича)|(овичу)|(овича)|(овичем)|(овиче))$/g, "ович" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ] ], casesRe = [ /((евич)|(ович)|(ич))$/g, /((евича)|(овича)|(ича))$/g, /((евичу)|(овичу)|(ичу))$/g, /((евича)|(овича)|(ича))$/g, /((евичем)|(овичем)|(ичем))$/g, /((евиче)|(овиче)|(иче))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineFemMiddleName = inclineFemMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((вна)|(вны)|(вне)|(вну)|(вной)|(вне))$/g, "вна" ], [ /((чна)|(чны)|(чне)|(чну)|(чной)|(чне))$/g, "чна" ] ], casesRe = [ /((вна)|(чна))$/g, /((вны)|(чны))$/g, /((вне)|(чне))$/g, /((вну)|(чну))$/g, /((вной)|(чной))$/g, /((вне)|(чне))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineMiddleName = inclineMiddleName = function(mname) {
    return inclineMiddleNameOrSurname(mname, inclineFemMiddleName(mname), inclineMaleMiddleName(mname));
  }, genderMatch = function(g1, g2) {
    return g1 === g2 || __indexOf.call(g2, g1) >= 0 ? g1 : __indexOf.call(g1, g2) >= 0 ? g2 : null;
  }, matchNameParts = function(fn, mn, sn) {
    var overallGender, surname, theCase;
    return theCase = util.intersection(fn.possible_cases, mn.possible_cases), overallGender = genderMatch(genderMatch(fn.gender, mn.gender), sn.gender), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: mn.nominative,
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchNameAndSurname = function(fn, sn) {
    var overallGender, surname, theCase;
    return overallGender = genderMatch(fn.gender, sn.gender), theCase = util.intersection(fn.possible_cases, sn.possible_cases), theCase || (sn.possible_cases = sn["" + overallGender + "_cases"], sn.nominative = sn["nominative_" + overallGender], theCase = util.intersection(fn.possible_cases, sn.possible_cases)), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: "",
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchCase = function(pObj, target_case, gender) {
    return __indexOf.call(pObj["" + gender + "_cases"], target_case) >= 0;
  }, getNominative = function(pObj, gender) {
    var gnstr, nom;
    return gnstr = "nominative_" + gender, nom = pObj.nominative && pObj.nominative || pObj[gnstr], nom;
  }, exports.findProperName = findProperName = function(listOfWords, opts) {
    var mnr2, mnr3, nr1, nr2, nr3, result, sr1, sr2, sr3;
    opts == null && (opts = {}), result = {
      found: !1
    };
    switch (listOfWords.length) {
     case 1:
      result = inclineName(listOfWords[0]), result.found ? result.first_name = result.nominative : (result = inclinePersonSurname(listOfWords[0]), result.found && (result.surname = result.nominative));
      break;
     case 2:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr1.found && sr2.found && (result = matchNameAndSurname(nr1, sr2)), !result.found && sr1.found && nr2.found && (result = matchNameAndSurname(sr1, nr2));
      break;
     case 3:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), sr3 = inclinePersonSurname(listOfWords[2]), mnr2 = inclineMiddleName(listOfWords[1]), mnr3 = inclineMiddleName(listOfWords[2]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr3 = inclineName(listOfWords[2]), nr3.found ? result = {
        found: !1,
        error: "name at the end of 3-component proper name"
      } : nr1.found ? (mnr2.found && sr3.found && (result = matchNameParts(nr1, mnr2, sr3)), !result.found && sr2.found && (result = matchNameAndSurname(nr1, sr2))) : sr1.found && nr2.found && mnr3.found ? result = matchNameParts(nr2, mnr3, sr1) : nr2.found && sr3.found && (result = matchNameAndSurname(nr2, sr3));
    }
    return result.first_name || (result.first_name = ""), result.middle_name || (result.middle_name = ""), result.surname || (result.surname = ""), result.first_name || result.middle_name || result.surname || (result = {
      found: !1,
      error: "person not found"
    }), result.src = listOfWords.join(" "), result;
  }, exports.getInitialFormOfAdjective = function(adj) {
    var base;
    return adj = adj.toLowerCase(), /^[а-яё]{2,}(ая|ее|ие|ий|им|ими|их|ого|его|ое|ой|ом|ому|ою|ую|ые|ый|ым|ыми|ых|юю|яя)$/.test(adj) ? (/^[а-яё]{2,}(ими|ого|его|ому|ыми)$/gi.test(adj) ? base = adj.slice(0, -3) : base = adj.slice(0, -2), [ "" + base + "ый", "" + base + "ий", "" + base + "ой" ]) : null;
  }, exports.getVerbInfinitive = function(verb) {
    var pastTime, result, verbEnd;
    return verb = verb.toLowerCase(), /^[а-яё]{3,}(ать|аться|ить|иться|еть|еться|оть|оться|уть|утся|ются|ть|ться)$/.test(verb) ? verb : (/^[а-яё]{3,}(сь|ся)$/.test(verb) ? (verbEnd = verb.slice(-2), verb = verb.slice(0, -2)) : verbEnd = "", pastTime = verb.match(/^[а-яё]{3,}(л|ла|ло|ли)$/), pastTime ? result = verb.slice(0, -(1 + pastTime[1].length) + 1 || 9e9) + "ть" : /[а-яё]{3,}(у|ю|ем|ешь|ете|ет|ут|ют|им|ишь|ите|ит|ат|ят)$/.test(verb) && (/[а-яё]{3,}(ишь|ит|им|ите|ат|ят)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd ] : /[а-яё]{3,}(у|ю|ешь|ет|ем|ете|ут|ют)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd, "" + verb + "оть" + verbEnd, "" + verb + "уть" + verbEnd, "" + verb + "ть" + verbEnd ] : result = null), result);
  };
}(exports, util, ref);

var exports, ruWords, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.morpho = {}, exports = window.lastName.plugins.ru.morpho, ruWords = window.lastName.plugins.ru.words) : (exports = module.exports, ruWords = require("./words")), function(exports, ruWords) {
  var exceptions, getRulesAdjective, getRulesVerb, morphoRu;
  return exports.getWordRe = function() {
    return /^[а-я\-ё\d]+$/ig;
  }, exports.getAdjectiveEnds = function() {
    return {
      feminine: {
        ends: /((ая)|(ой)|(ую)|(яя)|(ей)|(юю))$/g,
        hard: /((ая)|(ой)|(ую))$/g,
        sort: /((яя)|(ей)|(юю))$/g,
        hardNominativeEnd: "ая",
        softNominativeEnd: "яя",
        gender: "feminine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ая" ? [ "" + word + "ая", "" + word + "ой", "" + word + "ой", "" + word + "ую", "" + word + "ой", "" + word + "ой" ] : [ "" + word + "яя", "" + word + "ей", "" + word + "ей", "" + word + "юю", "" + word + "ей", "" + word + "ей" ];
        }
      },
      masculine: {
        ends: /((ый)|(ого)|(ому)|(ым)|(ом)|(ий)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ый)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ий)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ый",
        softNominativeEnd: "ий",
        gender: "masculine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ый" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ий", "" + word + "ого", "" + word + "ому", "" + word + "ий", "" + word + "им", "" + word + "ом" ] : [ "" + word + "ый", "" + word + "ого", "" + word + "ому", "" + word + "ый", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ий", "" + word + "его", "" + word + "ему", "" + word + "ий", "" + word + "им", "" + word + "ем" ];
        }
      },
      neuter: {
        ends: /((ое)|(ого)|(ому)|(ым)|(ом)|(ее)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ое)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ее)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ое",
        softNominativeEnd: "ее",
        gender: "neuter",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ое" ? [ "" + word + "ое", "" + word + "ого", "" + word + "ому", "" + word + "ое", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ее", "" + word + "его", "" + word + "ему", "" + word + "ее", "" + word + "им", "" + word + "ем" ];
        }
      },
      plural: {
        ends: /((ые)|(ых)|(ым)|(ыми)|(ых)|(ие)|(их)|(им)|(ими)|(их))$/g,
        hard: /((ые)|(ых)|(ым)|(ыми)|(ых))$/g,
        soft: /((ие)|(их)|(им)|(ими)|(их))$/g,
        hardNominativeEnd: "ые",
        softNominativeEnd: "ие",
        gender: "unknown",
        singular: !1,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ые" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ] : [ "" + word + "ые", "" + word + "ых", "" + word + "ым", "" + word + "ые", "" + word + "ыми", "" + word + "ых" ] : [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ];
        }
      }
    };
  }, exceptions = function(word) {}, getRulesVerb = function() {
    return [ [ /нул[aи]{0,1}$/g, "ать" ], [ /еть$/g, "ать" ], [ /(ает)|(ают)$/g, "ать" ], [ /ал[aи]{0,1}$/g, "ать" ], [ /ул[aи]{0,1}$/g, "ать" ], [ /((ить)|(ать))$/g, "ать" ], [ /ая$/g, "ать" ], [ /((ил)|(или)|(ила)|(ило))$/g, "лять" ], [ /(ятся)|(ится)|(ился)|(илась)|(илось)$/g, "ится" ], [ /(яться)|(иться)$/g, "иться" ] ];
  }, getRulesAdjective = function() {
    return [ [ /в((ая)|(ые)|(ый)|(ое))$/, "вый" ], [ /((ая)|(ой)|(ие)|(ые)|(ый)|(ую))$/, "ый" ], [ /((яя)|(ее)|(ий)|(юю))$/, "ий" ] ];
  }, exports.morpho = morphoRu = function(word) {
    var adj, adjective, result, rule, verb, _i, _j, _len, _len2, _ref, _ref2;
    if (__indexOf.call(ruWords.adverbs, word) >= 0) return {
      type: "abverb",
      value: word
    };
    if (__indexOf.call(ruWords.prepositionAll, word) >= 0) return {
      type: "preposition",
      value: word
    };
    if (__indexOf.call(ruWords.unions, word) >= 0) return {
      type: "union",
      value: word
    };
    result = {
      type: "",
      value: ""
    }, verb = null, adjective = null, _ref = getRulesVerb();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      rule = _ref[_i];
      if (rule[0].test(word)) {
        result = {
          type: verb,
          value: word.replace(rule[0], rule[1])
        };
        break;
      }
    }
    _ref2 = getRulesAdjective();
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      rule = _ref2[_j];
      if (rule[0].test(word)) {
        adj = word.replace(rule[0], rule[1]), result.type ? (result.type += " adjective", result.value = [ result.value, adj ]) : result = {
          type: "adjective",
          value: adj
        };
        break;
      }
    }
    return result;
  }, exports.analyseText = function(text) {
    var doubleSpaceRe, enRe, punctuationRe, r, result, ruRe, t, wordRe, _i, _len, _ref;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&№“”\—]/g, doubleSpaceRe = /\s+/g, text = text.replace(punctuationRe, " $& ").replace(doubleSpaceRe, " ") + " .", result = [], _ref = text.split(" ");
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      t = _ref[_i], ruRe = /^[а-я\-ё]+$/ig, enRe = /^[a-z\-]+$/ig, wordRe = /^[а-яё\-\da-z]+$/ig, r = morphoRu(t.toLowerCase());
      switch (r.type) {
       case "adverb":
        result.push("[ADV " + t + "]");
        break;
       case "verb":
       case "adjective":
        result.push("[ " + r.value + " ]");
        break;
       case "verb adjective":
        result.push("[#VA " + r.value[0] + "]");
        break;
       case "union":
        result.push("[U " + t + "]");
        break;
       case "preposition":
        result.push("[PP " + t + "]");
        break;
       default:
        result.push(t);
      }
      t === "." && result.push("\n");
    }
    return result;
  }, exports.parseRuSentence = function(sentences) {
    var abbrevs, common_used_words, digits, regular_words, special_words, total_words;
    return sentences instanceof Array || (sentences = [ sentences ]), abbrevs = {}, special_words = {}, digits = {}, common_used_words = {}, regular_words = {}, total_words = 0, sentences.map(function(sent) {
      var i, result, w, word, words, _len, _ref, _results;
      words = sent.split(" "), _results = [];
      for (i = 0, _len = words.length; i < _len; i++) word = words[i], /^[[,:\/\\\?!\+\-\*\(\)\[\]\&\№\—]]+$/.test(words) || total_words++, /^(\d+(|(\.(|\d+))))$/.test(word) ? digits[word] ? _results.push(digits[word]++) : _results.push(digits[word] = 1) : isUpperCase(word) && /^[а-яё\-]{2,}$/i.test(word) ? abbrevs[word] ? _results.push(abbrevs[word]++) : _results.push(abbrevs[word] = 1) : i > 0 && isCapitalized(word) && /^[а-яё\-]{2,}$/i.test(word) ? special_words[word] ? _results.push(special_words[word]++) : _results.push(special_words[word] = 1) : /^[а-яё\-]+$/i.test(word) && !/^\-+$/.test(word) ? (w = word.toLowerCase(), result = morphoRu(w), (_ref = result.type) !== "adverb" && _ref !== "preposition" && _ref !== "union" ? regular_words[w] ? _results.push(regular_words[w]++) : _results.push(regular_words[w] = 1) : common_used_words[w] ? _results.push(common_used_words[w]++) : _results.push(common_used_words[w] = 1)) : _results.push(void 0);
      return _results;
    }), {
      abbrevs: abbrevs,
      common_used_words: common_used_words,
      special_words: special_words,
      regular_words: regular_words,
      digits: digits,
      total_words: total_words
    };
  };
}(exports, ruWords);

var exports, inclines, morpho, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.propernames = {}, exports = window.lastName.plugins.ru.propernames, morpho = window.lastName.plugins.ru.morpho, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, morpho = require("./morpho"), inclines = require("./inclines")), function(exports, morpho, inclines) {
  return exports.postFilter = function(text, result) {
    var curProperName, id, p, pn, pnDict, properNames, properNamesRe, punctuationRe, _i, _j, _len, _len2, _ref, _ref2;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&\№“”\—]/g, properNames = [], curProperName = [], properNamesRe = /[А-Я][а-яё]+(\s+[А-Я][а-яё]+){0,2}/gm, _ref = text.match(properNamesRe);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) pn = _ref[_i], curProperName = pn.replace(/\s+/g, " ").split(" "), curProperName && (pn = inclines.findProperName(curProperName), pn && pn.found && properNames.push(pn));
    pnDict = {};
    for (_j = 0, _len2 = properNames.length; _j < _len2; _j++) p = properNames[_j], id = "" + (p.first_name || "") + "-" + (p.middle_name || "") + "-" + (p.surname || ""), pnDict[id] ? (pnDict[id].count += 1, (_ref2 = p.src, __indexOf.call(pnDict[id].src, _ref2) < 0) && pnDict[id].src.push(p.src)) : (pnDict[id] = p, pnDict[id].src = [ p.src ], pnDict[id].count = 1);
    return result.propernames = pnDict;
  };
}(exports, morpho, inclines);

var exports, inclines, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName.plugins.ru.feelings = {}, exports = window.lastName.plugins.ru.feelings, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, inclines = require("./inclines")), function(exports, inclines) {
  var evaluateSentenceNeutrality, getNegativePhrasesRe, negativeAdjectives, negativeVerbs, negativeWordsIncline;
  return exports.positive = [], negativeAdjectives = {
    "агрессивный": 3,
    "атакованный": 2,
    "бедный": 2,
    "беззащитный": 2,
    "безнадежный": 3,
    "безрадостный": 2,
    "бесплодный": 3,
    "беспомощный": 3,
    "бесправный": 2,
    "бессердечный": 1,
    "бессильный": 1,
    "бесцельный": 2,
    "бесчестный": 2,
    "вздорный": 1,
    "виновный": 1,
    "ворчливый": 1,
    "враждебный": 2,
    "вспыльчивый": 1,
    "выпученный": 1,
    "выселенный": 3,
    "высмеянный": 2,
    "выхолощенный": 1,
    "глубокий": 1,
    "глупый": 2,
    "горький": 2,
    "готический": 2,
    "гротескный": 1,
    "грустный": 1,
    "грязный": 1,
    "девальвированный": 2,
    "деградировавший": 2,
    "дегуманизированный": 2,
    "дезорганизованный": 2,
    "дезориентированный": 2,
    "деморализованный": 3,
    "дерзкий": 1,
    "дерьмовый": 3,
    "дефектный": 3,
    "драматический": 3,
    "жалкий": 3,
    "жесткий": 2,
    "жестокосердный": 2,
    "заброшенный": 1,
    "забываемый": 1,
    "забывчивый": 1,
    "забытый": 2,
    "зависимый": 1,
    "заинтересованный": 1,
    "запрещенный": 3,
    "запутанный": 2,
    "застенчивый": 1,
    "застрявший": 1,
    "затравленный": 2,
    "зверский": 3,
    "злобный": 2,
    "идиотский": 3,
    "измельченный": 2,
    "измученный": 2,
    "изнасилованный": 3,
    "изолированный": 3,
    "изумленный": 1,
    "интенсивный": 1,
    "иррациональный": 2,
    "исключенный": 2,
    "искусственный": 2,
    "испуганный": 2,
    "истерический": 3,
    "исчерпанный": 2,
    "капризный": 2,
    "контролируемый": 1,
    "критический": 1,
    "ленивый": 2,
    "лишенный": 2,
    "ложный": 2,
    "мазохистский": 1,
    "мертвый": 3,
    "меченый": 2,
    "мрачный": 2,
    "мстительный": 2,
    "навязчивый": 2,
    "надоедливый": 2,
    "наказанный": 2,
    "нарушенный": 2,
    "натянутый": 2,
    "неадекватный": 2,
    "неактивный": 1,
    "небезопасный": 2,
    "небрежный": 1,
    "невежественный": 1,
    "невидимый": 1,
    "невротический": 2,
    "негуманный": 2,
    "недействительный": 1,
    "недовольный": 2,
    "недостаточный": 1,
    "недоуменный": 1,
    "незаземленный": 1,
    "незначительный": 1,
    "неискренний": 1,
    "некомпетентный": 2,
    "ненавистный": 3,
    "необщительный": 2,
    "неполный": 2,
    "неправильный": 2,
    "неприятный": 2,
    "нервный": 2,
    "нерешительный": 1,
    "несбалансированный": 1,
    "несовместимый": 2,
    "несоответствующий": 2,
    "неспособный": 3,
    "несчастный": 2,
    "неуклюжий": 2,
    "неуловимый": 1,
    "неуместный": 2,
    "нечестный": 2,
    "неэффективный": 2,
    "низкий": 1,
    "обвиняемый": 3,
    "обедненный": 1,
    "обезумевший": 3,
    "обиженный": 2,
    "обманутый": 2,
    "обозленный": 2,
    "оборонительный": 1,
    "обремененный": 1,
    "обременительный": 1,
    "обреченный": 2,
    "ограниченный": 1,
    "одержимый": 3,
    "одинокий": 2,
    "одноразовый": 1,
    "озабоченный": 2,
    "окаменелый": 1,
    "онемелый": 1,
    "опальный": 2,
    "опасный": 3,
    "опустошенный": 1,
    "опущенный": 2,
    "опьяненный": 1,
    "оскорбленный": 2,
    "осмеянный": 2,
    "острый": 1,
    "осужденный": 3,
    "осушенный": 2,
    "ответственный": 2,
    "отвратительный": 3,
    "отдаленный": 1,
    "отдельный": 1,
    "отрицательный": 2,
    "отсталый": 2,
    "отчаянный": 1,
    "ошибочный": 1,
    "параноидальный": 2,
    "паршивый": 2,
    "пассивный": 1,
    "переполненный": 2,
    "пессимистический": 2,
    "печальный": 2,
    "побежденный": 3,
    "поверхностный": 2,
    "поврежденный": 3,
    "подавленный": 2,
    "поддельный": 3,
    "покинутый": 2,
    "покорный": 1,
    "порабощенный": 3,
    "потерянный": 2,
    "потерпевший": 2,
    "потребленный": 1,
    "презираемый": 2,
    "презренный": 3,
    "презрительный": 2,
    "прерванный": 1,
    "принудительный": 2,
    "психотический": 2,
    "пустынный": 1,
    "пьяный": 2,
    "равнодушный": 1,
    "развращенный": 3,
    "раздраженный": 2,
    "раздражительный": 2,
    "разочарованный": 2,
    "разочаровывающий": 3,
    "разрушенный": 3,
    "разрушительный": 2,
    "разъяренный": 3,
    "раненый": 2,
    "ревнивый": 2,
    "садистский": 2,
    "самоубийственный": 3,
    "саркастический": 1,
    "сварливый": 1,
    "сгоревший": 3,
    "сердитый": 2,
    "серый": 1,
    "скучающий": 1,
    "скучный": 1,
    "сломанный": 2,
    "смущенный": 1,
    "созерцательный": 1,
    "сомнительный": 2,
    "спорный": 2,
    "спровоцированный": 2,
    "спутанный": 2,
    "спущенный": 2,
    "стереотипный": 1,
    "стесненный": 1,
    "странный": 1,
    "страшный": 2,
    "сумасшедший": 2,
    "тихий": 1,
    "тормозящий": 2,
    "торопливый": 2,
    "тоскливый": 3,
    "требовательный": 2,
    "тревожный": 2,
    "трудный": 2,
    "трусливый": 2,
    "тупой": 1,
    "тщеславный": 2,
    "угнетенный": 2,
    "угрюмый": 2,
    "удаляемый": 2,
    "удрученный": 2,
    "ужасный": 3,
    "уклончивый": 2,
    "униженный": 3,
    "унылый": 3,
    "урезанный": 2,
    "фальшивый": 3,
    "хаотический": 2,
    "холодный": 1,
    "хрупкий": 1,
    "цепкий": 2,
    "циничный": 2,
    "чертовский": 2,
    "чрезмерный": 2,
    "чувствительный": 2,
    "эгоистичный": 2,
    "эгоцентричный": 3,
    "эксплуатируемый": 2,
    "эмансипированный": 2,
    "эмоциональный": 1,
    "яростный": 3
  }, negativeVerbs = {
    "беспокоить": 2,
    "бить": 2,
    "внушать": 2,
    "волноваться": 2,
    "высмеивать": 2,
    "грызть": 1,
    "диктовать": 2,
    "дребезжать": 1,
    "дрожать": 1,
    "дрогнуть": 2,
    "загнать": 2,
    "запугивать": 3,
    "запутаться": 2,
    "злоупотреблять": 2,
    "игнорировать": 1,
    "избегать": 1,
    "издеваться": 3,
    "изменять": 2,
    "командовать": 1,
    "лгать": 2,
    "лишить": 2,
    "манипулировать": 2,
    "молчать": 1,
    "надувать": 1,
    "ненавидеть": 3,
    "обвинять": 2,
    "обидеть": 2,
    "опорочить": 3,
    "освистать": 3,
    "отбрасывать": 1,
    "отвлекаться": 2,
    "отклонить": 2,
    "отрекаться": 3,
    "оттолкнуть": 2,
    "паниковать": 2,
    "перепутаться": 2,
    "подавить": 3,
    "подвергаться": 2,
    "пострадать": 2,
    "предавать": 3,
    "пренебрегать": 2,
    "препятствовать": 2,
    "преследовать": 2,
    "принижаться": 2,
    "приставать": 2,
    "прослушивать": 2,
    "разгромить": 2,
    "раздражаться": 2,
    "растаскивать": 2,
    "рисковать": 2,
    "ругать": 2,
    "сдуваться": 1,
    "смолчать": 2,
    "снизиться": 1,
    "сорвать": 1,
    "сожалеть": 2,
    "соизволить": 2,
    "солгать": 2,
    "сомневаться": 2,
    "споткнуться": 1,
    "столкнуться": 2,
    "страдать": 2,
    "стрелять": 3,
    "судить": 2,
    "толкнуть": 1,
    "убить": 3,
    "убивать": 3,
    "уговаривать": 1,
    "удалять": 2,
    "уклоняться": 2,
    "унижать": 3,
    "шантажировать": 2
  }, negativeWordsIncline = {
    "боль": 2,
    "вниз": 1,
    "горе": 3,
    "дно": 2,
    "мало": 1,
    "мучение": 2,
    "недовольство": 2,
    "плохо": 2,
    "противно": 3,
    "совестно": 2,
    "только": 1,
    "ужас": 3,
    "смерть": 3,
    "неодобрительно": 2,
    "разгром": 2,
    "отчаяние": 3
  }, exports.getNegativePhrasesRe = getNegativePhrasesRe = function() {
    return [ [ /[^а-яё]при\sотягчающих\sобстоятельствах[^а-яё]/ig, 2 ], [ /[^а-яё]ненависть\sк[^а-яё]/ig, 3 ], [ /[^а-яё]в\sубыток[^а-яё]/ig, 2 ], [ /[^а-яё]сыт[аы]?\sпо\sгорло[^а-яё]/ig, 3 ], [ /[^а-яё]заслужива[ею]т\sнаказания[^а-яё]/ig, 2 ], [ /[^а-яё]находящ(егося|ейся|емся|ихся)\sпод\sугрозой\sисчезновения[^а-яё]/ig, 3 ], [ /[^а-яё]в\sзаблуждение[^а-яё]/ig, 2 ], [ /[^а-яё]сбит[аы]?\sс\sтолку[^а-яё]/ig, 2 ], [ /[^а-яё]в\sужасе[^а-яё]/ig, 3 ], [ /[^а-яё]не\sрекоменд(ую|уем|уется|овал|овала|овали)[^а-яё]/ig, 2 ], [ /[^а-яё]не\sодобря(ю|ем|л|ла|ли|ется)[^а-яё]/ig, 2 ], [ /[^а-яё]пятно\sна[^а-яё]/ig, 2 ], [ /[^а-яё]в\sклетке[^а-яё]/ig, 1 ], [ /[^а-яё]неправильно\sпонял[аи]?[^а-яё]/ig, 2 ], [ /[^а-яё]вне\sпределов\sдосягаемости[^а-яё]/ig, 1 ], [ /[^а-яё]взял[аи]?\sна[^а-яё]/ig, 2 ], [ /[^а-яё]играл[аи]?\sс[^а-яё]/ig, 2 ], [ /[^а-яё]черный\sсписок[^а-яё]/ig, 3 ], [ /[^а-яё]возбужден[оы]\sуголовн(ое|ые)\sдел[оа][^а-яё]/ig, 8 ], [ /[^а-яё]жертв(|а|ы|ам|ами)[^а-яё]/ig, 3 ] ];
  }, exports.evaluateSentenceNeutrality = evaluateSentenceNeutrality = function(sentence) {
    var adj, adjArray, adjIndex, curWords, cur_index, ind, index, m, nr, resetCurIndex, vIndex, verb, words, wrd, _i, _j, _k, _len, _len2, _len3, _ref, _ref2;
    index = 0, cur_index = 0, words = [], curWords = [], _ref = getNegativePhrasesRe();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) nr = _ref[_i], m = sentence.match(nr[0]), m && (m.map(function(wordsSequence) {
      return words.push(wordsSequence);
    }), index -= nr[1] * m.length);
    resetCurIndex = function() {
      if (cur_index) return index += cur_index, words.push(curWords), curWords = [], cur_index = 0;
    }, _ref2 = sentence.split(/\s/);
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      wrd = _ref2[_j];
      if (__indexOf.call(".,-—!?()[]", wrd) >= 0) {
        cur_index = -cur_index, resetCurIndex();
        continue;
      }
      ind = negativeWordsIncline[wrd.toLowerCase()];
      if (ind) curWords.push(wrd), cur_index = cur_index * ind || ind; else {
        adjArray = inclines.getInitialFormOfAdjective(wrd);
        if (!adjArray) verb = inclines.getVerbInfinitive(wrd), vIndex = negativeVerbs[verb], vIndex ? (curWords.push(wrd), cur_index = cur_index * vIndex || vIndex) : (cur_index = -cur_index, resetCurIndex()); else for (_k = 0, _len3 = adjArray.length; _k < _len3; _k++) {
          adj = adjArray[_k], adjIndex = negativeAdjectives[adj];
          if (adjIndex) {
            curWords.push(wrd), cur_index = cur_index * adjIndex || adjIndex;
            break;
          }
        }
      }
    }
    return resetCurIndex(-cur_index), [ index, words ];
  }, exports.postFilter = function(text, result) {
    var emoIndex, emoWords, i, index, overallIndex, s, _len, _ref, _ref2;
    emoIndex = [], overallIndex = 0, _ref = result.misc.sentences;
    for (i = 0, _len = _ref.length; i < _len; i++) s = _ref[i], _ref2 = evaluateSentenceNeutrality(s), index = _ref2[0], emoWords = _ref2[1], emoIndex.push([ index, emoWords ]), overallIndex += index;
    return result.feelings = {
      emoIndex: emoIndex,
      overallIndex: overallIndex,
      emoScore: overallIndex / result.counters.words_total || 1
    };
  };
}(exports, inclines);

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).analysis || (_base.analysis = {}), exports = window.lastName.analysis) : exports = module.exports, function(exports) {
  return exports.analyse = function(text, plugins) {
    var f, misc, postFilter, preFilters, result, util, _i, _j, _len, _len2;
    plugins == null && (plugins = []), "undefined" == typeof global ? (misc = window.lastName.misc, util = window.lastName.util) : (misc = require("./misc"), util = require("./util")), result = {}, misc.preFilter(text, result), preFilters = plugins.filter(function(plugin) {
      return "function" == typeof plugin.preFilter;
    }), postFilter = plugins.filter(function(plugin) {
      return "function" == typeof plugin.postFilter;
    });
    for (_i = 0, _len = preFilters.length; _i < _len; _i++) f = preFilters[_i], f.preFilter(text, result);
    for (_j = 0, _len2 = postFilter.length; _j < _len2; _j++) f = postFilter[_j], f.postFilter(text, result);
    return result.version = util.version, result;
  };
}(exports);

var __slice = Array.prototype.slice;

(function(lastname) {
  return lastname.version = "0.3.5", lastname.findProperName = function() {
    var args, inclines, lang;
    return lang = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [], inclines = lastname.plugins["" + lang].inclines, inclines.findProperName.apply(this, args);
  };
})(window.lastName || (window.lastName = {}));

var exports, _base;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).misc || (_base.misc = {}), exports = window.lastName.misc) : exports = module.exports, function(exports) {
  return exports.preFilter = function(text, result) {
    var chars_total, emo, emoticons, findEmo, ind, punctuationRe, romans, sentences, signs, signs_total, spaces_total, tempTxt, word_length_mid, words_total, _i, _len;
    signs = text.match(/[-\+=\/\.,\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]{1}/g), signs_total = signs && signs.length || 0, spaces_total = /\s/.test(text) ? text.match(/\s/g).length : 0, chars_total = text.length, words_total = text.split(/\s/).filter(function(wrd) {
      return wrd.length > 0 && !/^[-\+=\/\.\!\?\@\#\$\%\^\&\*\(\)\[\]\{\}\<\>\`\~\"\':;\|\\_]+$/.test(wrd);
    }).length, word_length_mid = words_total ? (chars_total - spaces_total - signs_total) / words_total : 0, emoticons = [ ":-)", "(-:", ":o)", ":)", "(:", ":->", ":-}", ":-t", ":*)", ":-)))", ":-D", "(-D", ":'-)", "%-)", ":-/", ":-I", ":~)", "(:-(", ":-(", ":-c", ":-(((", ":-<", ">:-(", ":-[", "(:-&", "%-(", ">:-<", "~ :-(", "%-(", ":/)", ":-|", ":-e", ":-X", ":-v", ":-I", ":-8(", ":-O", ":-@", ":,-(", ":'-(", "~:-o", "]:-)>", "):-)", ";->", ":-x", ":-*", "8-]", ":-J", ":-&", ":-p", ":-P", ";-)", ";)", "'-)", ":-7", "?-(", "B-D", ":-B", ":-*)", ":-9", "|-p", ":-b", "-]:-)[-", "8-I", "8-|", "|:-|", ":-]", "|-)", "|-I", "I^o", "|-O", ':-"', ":-s", ":-#", ":-!", ":-()", ":-D", "(:-$", ":-(*)", ":-')", ":-R", "%+|", "%+{", "X-(", "<:-)", "*:o)", "@;-)", "X:-)", ":>)", "&:-)", "#:-)", "8-)", "8:-)", "B-)", "B-]", "O:-)", "&8-|", ":-{", ":-)}", ":-)#", ":-Q", ":-I", ":-d~", ":-?", ":-/I", ":-) X", "{(:-)", ":-{}", "[:-)", "d :-o", "~:-(", "~~:-(", "))", "(:-I", "3:-o", "[: |]", "M-)", ":X)", ":-M", "*8((:", "O+", "O->", "||*(", "||*)", "<{:-)}", "(-: :-)", "@->-", "@==", "<')))))- <" ], emoticons.sort(function(a, b) {
      return b.length - a.length;
    }), tempTxt = text.slice(0), findEmo = [];
    for (_i = 0, _len = emoticons.length; _i < _len; _i++) {
      emo = emoticons[_i], ind = 0;
      while (ind >= 0) ind = tempTxt.indexOf(emo, ind), ind !== -1 && (findEmo.push(emo), tempTxt = tempTxt.replace(emo, ""), ind -= emo.length + 2);
    }
    return punctuationRe = /(https?\:\/\/.*[\s$])|(\.\s)|(,\s)|(\s\:)|(:\s)|(\s\/)|(\/\s)|(\s\\)(\\\s)|\?|!|\+|\'|\"|«|»|\*|\(|\)|\[|\]|\&|\№|“|”|\—/g, tempTxt = text.replace(punctuationRe, " $& ").replace(/\s+/g, " "), /[\?\!\.]\s{0,}$/.test(tempTxt) || (tempTxt += " . "), sentences = tempTxt.replace(/\s\?\s/gm, " ?? ").replace(/\s\!\s/gm, " !! ").replace(/\s\.\s/gm, " .. ").split(/[\?\!\.](\s+|$)/gm).filter(function(s) {
      return !/^\s{0,}$/.test(s);
    }), romans = text.match(/([X]{0,3}I[VX])|(M*(D?C{0,3}|C[DM])(L?X{0,3}|X[LC])(V?I{0,3}|I[VX]))/g), romans = romans ? romans.filter(function(s) {
      return !/^\s{0,}$/.test(s);
    }) : [], result.misc = {
      digits: util.arrayToDict(text.match(/-?((\d+[\.,]\d+)|(\d+))/ig) || []),
      emoticons: util.arrayToDict(findEmo),
      romans: util.arrayToDict(romans),
      sentences: sentences
    }, result.counters = {
      chars_total: chars_total,
      words_total: words_total,
      signs_total: signs_total,
      spaces_total: spaces_total,
      word_length_mid: word_length_mid,
      words_in_sentence_mid: sentences.length ? words_total / sentences.length : 0
    }, result;
  };
}(exports);

var exports, _base, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).util || (_base.util = {}), exports = window.lastName.util) : exports = module.exports, function(exports) {
  var capitalize, dictKeys, intersection, isCapitalized, isLowerCase, isUpperCase, merge, unique;
  return exports.version = "0.3.17", exports.capitalize = capitalize = function(s) {
    if (s) return "" + s[0].toUpperCase() + s.slice(1).toLowerCase();
  }, exports.dictKeys = dictKeys = function(dict) {
    var k, keys, v;
    keys = [];
    for (k in dict) v = dict[k], keys.push(k);
    return keys;
  }, exports.isCapitalized = isCapitalized = function(word) {
    var cap;
    return 0 <= word.indexOf("-") ? (cap = !0, word.split("-").map(function(wrd) {
      return cap && (cap = isCapitalized(wrd));
    }), cap) : word && word === capitalize(word) || !1;
  }, exports.isUpperCase = isUpperCase = function(word) {
    return word === word.toUpperCase();
  }, exports.isLowerCase = isLowerCase = function(word) {
    return word === word.toLowerCase();
  }, exports.unique = unique = function(array) {
    var key, output, value, _ref, _results;
    output = {};
    for (key = 0, _ref = array.length; 0 <= _ref ? key < _ref : key > _ref; 0 <= _ref ? key++ : key--) output[array[key]] = array[key];
    _results = [];
    for (key in output) value = output[key], _results.push(value);
    return _results;
  }, exports.merge = merge = function(l1, l2) {
    var l;
    return l = [], l1.map(function(x) {
      return l.push(x);
    }), l2.map(function(x) {
      return l.push(x);
    }), unique(l);
  }, exports.intersection = intersection = function(l1, l2) {
    var i, _i, _len;
    for (_i = 0, _len = l1.length; _i < _len; _i++) {
      i = l1[_i];
      if (__indexOf.call(l2, i) >= 0) return i;
    }
    return null;
  }, exports.arrayToDict = function(arr) {
    var d, i, _i, _len;
    d = {};
    for (_i = 0, _len = arr.length; _i < _len; _i++) i = arr[_i], d[i] ? d[i]++ : d[i] = 1;
    return d;
  };
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.ref = {}, exports = window.lastName.plugins.ru.ref) : exports = module.exports, function(exports) {
  return exports.ruFemaleNamesDict = {
    "альвина": 1,
    "анелия": 1,
    "августа": 1,
    "августина": 1,
    "авдотья": 1,
    "авелина": 1,
    "аврелия": 1,
    "аврора": 1,
    "агапия": 1,
    "агата": 1,
    "агафья": 1,
    "агафия": 1,
    "аглаида": 1,
    "аглая": 1,
    "агнеса": 1,
    "агнесса": 1,
    "агния": 1,
    "агриппмеа": 1,
    "агрефена": 1,
    "ада": 1,
    "адина": 1,
    "адель": 1,
    "аделия": 1,
    "аделаида": 1,
    "аза": 1,
    "азалия": 1,
    "аида": 1,
    "айседора": 1,
    "айсылу": 1,
    "акилина": 1,
    "акулина": 1,
    "аксинья": 1,
    "алевтина": 1,
    "александра": 1,
    "алеся": 1,
    "алена": 1,
    "алина": 1,
    "алиса": 1,
    "алия": 1,
    "алла": 1,
    "алика": 1,
    "альбина": 1,
    "альмир": 1,
    "альфия": 1,
    "амина": 1,
    "анастасия": 1,
    "анатолия": 1,
    "ангелина": 1,
    "анжела": 1,
    "анимаиса": 1,
    "анисия": 1,
    "анисья": 1,
    "анна": 1,
    "анита": 1,
    "антонина": 1,
    "антонида": 1,
    "антония": 1,
    "анфиса": 1,
    "анфуса": 1,
    "анфия": 1,
    "амира": 1,
    "аполлинария": 1,
    "аревик": 1,
    "ариадна": 1,
    "арина": 1,
    "аркадия": 1,
    "арсения": 1,
    "арсиана": 1,
    "артемия": 1,
    "асель": 1,
    "аста": 1,
    "астра": 1,
    "астрид": 1,
    "афанасия": 1,
    "афродита": 1,
    "аэлита": 1,
    "аэлла": 1,
    "амалия": 1,
    "бажена": 1,
    "беата": 1,
    "беатриса": 1,
    "бела": 1,
    "белла": 1,
    "беллатриса": 1,
    "берта": 1,
    "богдана": 1,
    "божена": 1,
    "болеслава": 1,
    "борислава": 1,
    "бриджет": 1,
    "бронислава": 1,
    "валентина": 1,
    "валерия": 1,
    "ванда": 1,
    "варвара": 1,
    "василина": 1,
    "василиса": 1,
    "васса": 1,
    "вацлава": 1,
    "вевея": 1,
    "велора": 1,
    "велория": 1,
    "венера": 1,
    "вера": 1,
    "вероника": 1,
    "веселина": 1,
    "веста": 1,
    "видана": 1,
    "викторина": 1,
    "виктория": 1,
    "вилена": 1,
    "виола": 1,
    "виолетта": 1,
    "виоланта": 1,
    "виринея": 1,
    "вита": 1,
    "виталия": 1,
    "виталина": 1,
    "виулена": 1,
    "влада": 1,
    "владилена": 1,
    "владимира": 1,
    "владислава": 1,
    "владлена": 1,
    "власта": 1,
    "воля": 1,
    "всеслава": 1,
    "гайя": 1,
    "гали": 1,
    "галина": 1,
    "ганна": 1,
    "гаяна": 1,
    "гаяния": 1,
    "гвинет": 1,
    "гелена": 1,
    "гелия": 1,
    "гелла": 1,
    "генриетта": 1,
    "гертруда": 1,
    "глафира": 1,
    "гликерия": 1,
    "глория": 1,
    "голуба": 1,
    "горислава": 1,
    "гюльанэ": 1,
    "гюльнара": 1,
    "гюльчитай": 1,
    "даздраперма": 1,
    "дайна": 1,
    "дана": 1,
    "дарья": 1,
    "дария": 1,
    "дарина": 1,
    "дарьяна": 1,
    "декабрина": 1,
    "дея": 1,
    "дия": 1,
    "джиневра": 1,
    "дженнифер": 1,
    "джульета": 1,
    "дианна": 1,
    "дилия": 1,
    "диля": 1,
    "дильфуза": 1,
    "дина": 1,
    "диния": 1,
    "диодора": 1,
    "дионисия": 1,
    "добрава": 1,
    "домна": 1,
    "домина": 1,
    "домника": 1,
    "доминика": 1,
    "донара": 1,
    "дорофея": 1,
    "доротея": 1,
    "ева": 1,
    "евгения": 1,
    "евдокия": 1,
    "евлалия": 1,
    "евлампия": 1,
    "евпраксия": 1,
    "евстолия": 1,
    "евфалия": 1,
    "евфросиния": 1,
    "екатерина": 1,
    "елена": 1,
    "елизавета": 1,
    "еликонида": 1,
    "ермиония": 1,
    "есения": 1,
    "ефимия": 1,
    "евфремия": 1,
    "жанна": 1,
    "ждана": 1,
    "жаннэ": 1,
    "жасмина": 1,
    "забава": 1,
    "заира": 1,
    "зара": 1,
    "зарема": 1,
    "зарина": 1,
    "зорина": 1,
    "заряна": 1,
    "зауре": 1,
    "звенислава": 1,
    "земфира": 1,
    "зиля": 1,
    "зинаида": 1,
    "зиновия": 1,
    "злата": 1,
    "зозан": 1,
    "зоя": 1,
    "зульфия": 1,
    "иванна": 1,
    "ида": 1,
    "илария": 1,
    "илиана": 1,
    "илона": 1,
    "ильмира": 1,
    "инга": 1,
    "индира": 1,
    "инесса": 1,
    "инна": 1,
    "иоанна": 1,
    "иона": 1,
    "ипатия": 1,
    "ипполита": 1,
    "ирада": 1,
    "ираида": 1,
    "ирена": 1,
    "ироида": 1,
    "ираклия": 1,
    "ирина": 1,
    "исидора": 1,
    "искра": 1,
    "ифигения": 1,
    "ия": 1,
    "кадрия": 1,
    "кермен": 1,
    "калиса": 1,
    "каллиста": 1,
    "камилла": 1,
    "камила": 1,
    "капитолина": 1,
    "карина": 1,
    "каролина": 1,
    "катерина": 1,
    "кира": 1,
    "кирилла": 1,
    "клавдия": 1,
    "клара": 1,
    "клариса": 1,
    "кларисса": 1,
    "клеопатра": 1,
    "клио": 1,
    "клер": 1,
    "конкордия": 1,
    "констанция": 1,
    "кристина": 1,
    "ксения": 1,
    "лавиния": 1,
    "лада": 1,
    "лана": 1,
    "лариса": 1,
    "лаура": 1,
    "лейла": 1,
    "лема": 1,
    "лена": 1,
    "лениана": 1,
    "ленина": 1,
    "леонида": 1,
    "леонила": 1,
    "леонтия": 1,
    "леся": 1,
    "ливия": 1,
    "лидия": 1,
    "лилиана": 1,
    "лилия": 1,
    "лилит": 1,
    "лина": 1,
    "лира": 1,
    "лия": 1,
    "лея": 1,
    "лора": 1,
    "луиза": 1,
    "лукерия": 1,
    "лукиана": 1,
    "лукина": 1,
    "люцина": 1,
    "лусинэ": 1,
    "любава": 1,
    "любовь": 1,
    "любомира": 1,
    "людмила": 1,
    "ляля": 1,
    "мавра": 1,
    "магда": 1,
    "магдалина": 1,
    "мадлен": 1,
    "майя": 1,
    "мая": 1,
    "мальвина": 1,
    "маргарита": 1,
    "мариана": 1,
    "марьяна": 1,
    "марианна": 1,
    "мариетта": 1,
    "мариэтта": 1,
    "марика": 1,
    "марина": 1,
    "мария": 1,
    "марья": 1,
    "мари": 1,
    "марлен": 1,
    "марлена": 1,
    "марта": 1,
    "марфа": 1,
    "матильда": 1,
    "матрена": 1,
    "матрёна": 1,
    "матрона": 1,
    "мелания": 1,
    "меланья": 1,
    "мелитина": 1,
    "милада": 1,
    "милана": 1,
    "милен": 1,
    "милица": 1,
    "милия": 1,
    "милослава": 1,
    "мира": 1,
    "мирра": 1,
    "мирослава": 1,
    "митродора": 1,
    "млада": 1,
    "мстислава": 1,
    "нада": 1,
    "надежда": 1,
    "надия": 1,
    "наина": 1,
    "наира": 1,
    "нана": 1,
    "настасья": 1,
    "наталья": 1,
    "наталия": 1,
    "нелли": 1,
    "неонила": 1,
    "ника": 1,
    "нина": 1,
    "нинелла": 1,
    "нинель": 1,
    "новелла": 1,
    "нонна": 1,
    "нора": 1,
    "нуркыз": 1,
    "насиба": 1,
    "оксана": 1,
    "октавия": 1,
    "октябрина": 1,
    "олеся": 1,
    "оливия": 1,
    "олимпиада": 1,
    "олимпия": 1,
    "ольга": 1,
    "офелия": 1,
    "павла": 1,
    "павлина": 1,
    "патриция": 1,
    "пелагея": 1,
    "платонида": 1,
    "поликсена": 1,
    "полина": 1,
    "правдина": 1,
    "прасковья": 1,
    "пенелопа": 1,
    "полислава": 1,
    "рада": 1,
    "радмила": 1,
    "раиса": 1,
    "раймонда": 1,
    "раялла": 1,
    "ревмира": 1,
    "регина": 1,
    "рената": 1,
    "римма": 1,
    "рогнеда": 1,
    "роза": 1,
    "розалина": 1,
    "розалия": 1,
    "розана": 1,
    "роксан": 1,
    "ростислава": 1,
    "руслана": 1,
    "руфина": 1,
    "руфь": 1,
    "раида": 1,
    "сабина": 1,
    "сабрина": 1,
    "саломея": 1,
    "соломея": 1,
    "самира": 1,
    "светлана": 1,
    "светозара": 1,
    "светослава": 1,
    "свобода": 1,
    "святослава": 1,
    "севастьяна": 1,
    "северина": 1,
    "селена": 1,
    "селина": 1,
    "селестина": 1,
    "серафима": 1,
    "сергияна": 1,
    "сильва": 1,
    "агриппина": 1,
    "алёна": 1,
    "вилора": 1,
    "вилория": 1,
    "джульетта": 1,
    "диана": 1,
    "евфимия": 1,
    "ефросиния": 1,
    "калерия": 1,
    "милена": 1,
    "муза": 1,
    "савина": 1,
    "сильвия": 1,
    "симона": 1,
    "слава": 1,
    "славяна": 1,
    "снежана": 1,
    "софья": 1,
    "софия": 1,
    "станислава": 1,
    "стелла": 1,
    "степанида": 1,
    "стефанида": 1,
    "стефания": 1,
    "сусанна": 1,
    "сосанна": 1,
    "сюзанна": 1,
    "таира": 1,
    "таисия": 1,
    "тальяна": 1,
    "тамара": 1,
    "тамила": 1,
    "томила": 1,
    "татьяна": 1,
    "текуса": 1,
    "тереза": 1,
    "улита": 1,
    "ульяна": 1,
    "услада": 1,
    "устинья": 1,
    "фаина": 1,
    "февронья": 1,
    "феликсана": 1,
    "фелицата": 1,
    "фелицитата": 1,
    "фелиция": 1,
    "федора": 1,
    "феодора": 1,
    "феодосия": 1,
    "феодосья": 1,
    "феоктиста": 1,
    "феофания": 1,
    "феона": 1,
    "флавия": 1,
    "флора": 1,
    "флория": 1,
    "флорентина": 1,
    "флоренция": 1,
    "флориана": 1,
    "фотина": 1,
    "харита": 1,
    "харитина": 1,
    "хиония": 1,
    "христина": 1,
    "цецилия": 1,
    "чеслава": 1,
    "эвелина": 1,
    "эвридика": 1,
    "эдда": 1,
    "элеонора": 1,
    "элина": 1,
    "эльвира": 1,
    "эльмира": 1,
    "эльза": 1,
    "эмилия": 1,
    "эмма": 1,
    "эрика": 1,
    "эсфирь": 1,
    "юдифь": 1,
    "юзефа": 1,
    "юлиана": 1,
    "юлитта": 1,
    "юлия": 1,
    "юманита": 1,
    "юния": 1,
    "юнона": 1,
    "юстина": 1,
    "ядвига": 1,
    "яна": 1,
    "янина": 1,
    "яромира": 1,
    "ярослава": 1
  }, exports.ruMaleNamesDict = {
    "ааран": 1,
    "аарен": 1,
    "ааррон": 1,
    "аб": 1,
    "аббат": 1,
    "абботт": 1,
    "абей": 1,
    "абелл": 1,
    "абель": 1,
    "абнар": 1,
    "абнер": 1,
    "абнор": 1,
    "абот": 1,
    "аботт": 1,
    "абрам": 1,
    "абран": 1,
    "абрахам": 1,
    "абсалон": 1,
    "авангард": 1,
    "август": 1,
    "августин": 1,
    "авдей": 1,
    "авдий": 1,
    "авенир": 1,
    "аверилл": 1,
    "аверкий": 1,
    "авксентий": 1,
    "аврам": 1,
    "аврор": 1,
    "аврорий": 1,
    "агап": 1,
    "аггей": 1,
    "агей": 1,
    "адам": 1,
    "аддам": 1,
    "аддисон": 1,
    "аден": 1,
    "адий": 1,
    "адисон": 1,
    "адиссон": 1,
    "адлэй": 1,
    "адней": 1,
    "адольф": 1,
    "адонис": 1,
    "адриан": 1,
    "адэйр": 1,
    "адэр": 1,
    "азия": 1,
    "азэлстан": 1,
    "айбл": 1,
    "айзек": 1,
    "айк": 1,
    "ак": 1,
    "акей": 1,
    "акерлеа": 1,
    "акерлей": 1,
    "акерли": 1,
    "аки": 1,
    "аким": 1,
    "аклеа": 1,
    "аклей": 1,
    "акли": 1,
    "аксён": 1,
    "актон": 1,
    "акэль": 1,
    "алан": 1,
    "аластеир": 1,
    "аластэйр": 1,
    "алвар": 1,
    "алвен": 1,
    "алви": 1,
    "алвин": 1,
    "алвис": 1,
    "алгар": 1,
    "алджернон": 1,
    "алевтин": 1,
    "алеистер": 1,
    "алек": 1,
    "алекс": 1,
    "александр": 1,
    "алексей": 1,
    "ален": 1,
    "алестер": 1,
    "алжир": 1,
    "алик": 1,
    "аликс": 1,
    "алим": 1,
    "алисандр": 1,
    "алисдэйр": 1,
    "алиссандр": 1,
    "алистер": 1,
    "алистэйр": 1,
    "аллан": 1,
    "аллен": 1,
    "аллин": 1,
    "аллистер": 1,
    "аллистир": 1,
    "аллистэйр": 1,
    "алтон": 1,
    "алф": 1,
    "алфонзо": 1,
    "алфорд": 1,
    "алфрид": 1,
    "альберт": 1,
    "альбин": 1,
    "альвиан": 1,
    "альвин": 1,
    "альдина": 1,
    "альпин": 1,
    "альтаир": 1,
    "альфа": 1,
    "альфи": 1,
    "альфред": 1,
    "алэйстер": 1,
    "алэйстэйр": 1,
    "амби": 1,
    "амброуз": 1,
    "амедеус": 1,
    "амиас": 1,
    "амори": 1,
    "амос": 1,
    "амьяс": 1,
    "анакин": 1,
    "ананий": 1,
    "анастасий": 1,
    "анатолий": 1,
    "анвар": 1,
    "ангел": 1,
    "ангес": 1,
    "андерсон": 1,
    "анджелл": 1,
    "андрей": 1,
    "андреян": 1,
    "андриан": 1,
    "андрон": 1,
    "анж": 1,
    "анис": 1,
    "анисий": 1,
    "анисим": 1,
    "анри": 1,
    "анском": 1,
    "анскомб": 1,
    "ансон": 1,
    "антван": 1,
    "антип": 1,
    "антон": 1,
    "антоний": 1,
    "антонин": 1,
    "антуан": 1,
    "аполлинарий": 1,
    "аполлон": 1,
    "арам": 1,
    "арвид": 1,
    "аргент": 1,
    "арден": 1,
    "арефий": 1,
    "арий": 1,
    "арик": 1,
    "арил": 1,
    "арин": 1,
    "аристарх": 1,
    "аркадий": 1,
    "аркелл": 1,
    "арлен": 1,
    "арли": 1,
    "арман": 1,
    "армен": 1,
    "арн": 1,
    "арне": 1,
    "арни": 1,
    "арнольд": 1,
    "арран": 1,
    "аррин": 1,
    "аррон": 1,
    "арсен": 1,
    "арсений": 1,
    "арт": 1,
    "артамон": 1,
    "артемий": 1,
    "арти": 1,
    "артур": 1,
    "артём": 1,
    "архип": 1,
    "арчи": 1,
    "арчибальд": 1,
    "аселет": 1,
    "аселин": 1,
    "асер": 1,
    "аскольд": 1,
    "астон": 1,
    "атеист": 1,
    "афанасий": 1,
    "афиноген": 1,
    "афтон": 1,
    "аффтон": 1,
    "ахмат": 1,
    "ахмет": 1,
    "ачилл": 1,
    "аш": 1,
    "ашер": 1,
    "ашот": 1,
    "аштон": 1,
    "баграт": 1,
    "бад": 1,
    "бадди": 1,
    "бажен": 1,
    "баз": 1,
    "базилик": 1,
    "байрон": 1,
    "байярд": 1,
    "бак": 1,
    "бакстер": 1,
    "балдер": 1,
    "балдрик": 1,
    "бамби": 1,
    "баптист": 1,
    "бардолф": 1,
    "барии": 1,
    "барклей": 1,
    "барнабас": 1,
    "барни": 1,
    "барнэби": 1,
    "барретт": 1,
    "барри": 1,
    "барт": 1,
    "бартоломей": 1,
    "бассетт": 1,
    "бастер": 1,
    "бастиан": 1,
    "батч": 1,
    "баян": 1,
    "беван": 1,
    "беверли": 1,
    "бевис": 1,
    "бедивир": 1,
    "бейб": 1,
    "бейлей": 1,
    "бейлие": 1,
    "бен": 1,
    "бенджамин": 1,
    "бенджи": 1,
    "бенедикт": 1,
    "бенет": 1,
    "беннетт": 1,
    "бенни": 1,
    "бенние": 1,
    "бенсон": 1,
    "бентлей": 1,
    "бентон": 1,
    "беорегард": 1,
    "бердт": 1,
    "беренгар": 1,
    "беренджер": 1,
    "берет": 1,
    "бернард": 1,
    "берни": 1,
    "берри": 1,
    "берт": 1,
    "берти": 1,
    "бертольд": 1,
    "бертон": 1,
    "бертрам": 1,
    "бертран": 1,
    "бивис": 1,
    "билл": 1,
    "билли": 1,
    "бисш": 1,
    "биф": 1,
    "блейн": 1,
    "близэ": 1,
    "блисс": 1,
    "блэйз": 1,
    "блэйк": 1,
    "блэйн": 1,
    "блэр": 1,
    "боб": 1,
    "бобби": 1,
    "богдан": 1,
    "боеслав": 1,
    "болдуин": 1,
    "болеслав": 1,
    "боллард": 1,
    "бомонт": 1,
    "бонифэйс": 1,
    "боримир": 1,
    "борис": 1,
    "борислав": 1,
    "боян": 1,
    "брадлей": 1,
    "браеден": 1,
    "брайен": 1,
    "брайон": 1,
    "бранден": 1,
    "брандон": 1,
    "браннон": 1,
    "брейден": 1,
    "брейдн": 1,
    "брендан": 1,
    "бренден": 1,
    "брендон": 1,
    "бреннан": 1,
    "брент": 1,
    "брентон": 1,
    "брет": 1,
    "бретт": 1,
    "бриар": 1,
    "брион": 1,
    "брис": 1,
    "бриско": 1,
    "бриттон": 1,
    "бриэм": 1,
    "бродерик": 1,
    "броди": 1,
    "броз": 1,
    "брок": 1,
    "бронислав": 1,
    "бронт": 1,
    "броуди": 1,
    "броук": 1,
    "брук": 1,
    "брукс": 1,
    "бруно": 1,
    "брутус": 1,
    "брьянт": 1,
    "брэд": 1,
    "брэди": 1,
    "брэдфорд": 1,
    "брэйден": 1,
    "брэйди": 1,
    "брэм": 1,
    "брэн": 1,
    "брюс": 1,
    "брююс": 1,
    "будимир": 1,
    "буз": 1,
    "букер": 1,
    "булат": 1,
    "бью": 1,
    "бэйли": 1,
    "вавила": 1,
    "вадим": 1,
    "вал": 1,
    "валентайн": 1,
    "валентин": 1,
    "валериан": 1,
    "валерий": 1,
    "валерьян": 1,
    "вальдемар": 1,
    "вальтер": 1,
    "ванадий": 1,
    "вард": 1,
    "варлаам": 1,
    "варлам": 1,
    "варлен": 1,
    "вартан": 1,
    "варфоломей": 1,
    "василий": 1,
    "василько": 1,
    "ваухан": 1,
    "вахтанг": 1,
    "вацлав": 1,
    "вашингтон": 1,
    "вебстер": 1,
    "велдон": 1,
    "велимир": 1,
    "велислав": 1,
    "велор": 1,
    "велорий": 1,
    "венедикт": 1,
    "вениамин": 1,
    "вер": 1,
    "вергилий": 1,
    "верджил": 1,
    "верн": 1,
    "вернон": 1,
    "вестер": 1,
    "вестлей": 1,
    "вестон": 1,
    "вик": 1,
    "викентий": 1,
    "виктор": 1,
    "вил": 1,
    "вилберн": 1,
    "вилей": 1,
    "вилен": 1,
    "вилий": 1,
    "вилиор": 1,
    "вилки": 1,
    "вилл": 1,
    "вилли": 1,
    "виллоби": 1,
    "вилмар": 1,
    "вилмер": 1,
    "вилмот": 1,
    "вилор": 1,
    "вилорг": 1,
    "вилорий": 1,
    "вилсон": 1,
    "вилф": 1,
    "вилфорд": 1,
    "виль": 1,
    "вильгельм": 1,
    "вильтон": 1,
    "вильям": 1,
    "вин": 1,
    "виндзор": 1,
    "винни": 1,
    "винс": 1,
    "винсент": 1,
    "винслоу": 1,
    "винтроп": 1,
    "винцент": 1,
    "виолен": 1,
    "вирджиль": 1,
    "виссарион": 1,
    "вистан": 1,
    "виталий": 1,
    "витейкр": 1,
    "витней": 1,
    "витольд": 1,
    "влад": 1,
    "владелин": 1,
    "владилен": 1,
    "владимир": 1,
    "владислав": 1,
    "владлен": 1,
    "влас": 1,
    "власий": 1,
    "воган": 1,
    "вогн": 1,
    "воин": 1,
    "воислав": 1,
    "волдо": 1,
    "волемир": 1,
    "волкер": 1,
    "воллис": 1,
    "володар": 1,
    "вольдемар": 1,
    "вольмир": 1,
    "вольт": 1,
    "вольф": 1,
    "вольфрам": 1,
    "воспой": 1,
    "всеволод": 1,
    "всемил": 1,
    "вуди": 1,
    "вудроу": 1,
    "вулф": 1,
    "вьятт": 1,
    "вэйд": 1,
    "вэйланд": 1,
    "вэнс": 1,
    "вячеслав": 1,
    "габби": 1,
    "габриель": 1,
    "габриэль": 1,
    "гавриил": 1,
    "гаврил": 1,
    "гаврила": 1,
    "гаврило": 1,
    "гай": 1,
    "гайдар": 1,
    "гайлс": 1,
    "галактион": 1,
    "гален": 1,
    "галий": 1,
    "гамильтон": 1,
    "гамлет": 1,
    "гантэр": 1,
    "гаральд": 1,
    "гарван": 1,
    "гарей": 1,
    "гарибальди": 1,
    "гарланд": 1,
    "гарнет": 1,
    "гарольд": 1,
    "гарри": 1,
    "гаррий": 1,
    "гарс": 1,
    "гарфилд": 1,
    "гас": 1,
    "гаспар": 1,
    "гваделупа": 1,
    "гвидон": 1,
    "гейб": 1,
    "гейл": 1,
    "гейр": 1,
    "гектор": 1,
    "гелеон": 1,
    "гелиан": 1,
    "гелий": 1,
    "ген": 1,
    "гений": 1,
    "геннадий": 1,
    "генри": 1,
    "генрих": 1,
    "геодар": 1,
    "георгий": 1,
    "геральд": 1,
    "герасим": 1,
    "герберт": 1,
    "герман": 1,
    "гермоген": 1,
    "герольд": 1,
    "геронт": 1,
    "геронтий": 1,
    "герт": 1,
    "гертруд": 1,
    "гидеон": 1,
    "гильберт": 1,
    "гисберт": 1,
    "гладвин": 1,
    "гланвилл": 1,
    "глеб": 1,
    "глендауэр": 1,
    "гленн": 1,
    "глэн": 1,
    "говард": 1,
    "годвин": 1,
    "годфри": 1,
    "голлагэр": 1,
    "голладжер": 1,
    "гомер": 1,
    "горазд": 1,
    "гораций": 1,
    "горд": 1,
    "гордей": 1,
    "горден": 1,
    "гордий": 1,
    "гордон": 1,
    "горимир": 1,
    "горислав": 1,
    "горн": 1,
    "граем": 1,
    "грай": 1,
    "гранвилл": 1,
    "гранд": 1,
    "гранит": 1,
    "грахэйм": 1,
    "грег": 1,
    "грей": 1,
    "гренвилл": 1,
    "григорий": 1,
    "гриир": 1,
    "грир": 1,
    "гриффин": 1,
    "гриффит": 1,
    "гровер": 1,
    "грэг": 1,
    "грэгори": 1,
    "грэди": 1,
    "грэм": 1,
    "гудвин": 1,
    "гудзон": 1,
    "гурий": 1,
    "густав": 1,
    "гэй": 1,
    "гэйбл": 1,
    "гэйг": 1,
    "гэйдж": 1,
    "гэйелорд": 1,
    "гэйл": 1,
    "гэйлон": 1,
    "гэйлорд": 1,
    "гэйр": 1,
    "гэлл": 1,
    "гэри": 1,
    "давей": 1,
    "дави": 1,
    "давид": 1,
    "давыд": 1,
    "дад": 1,
    "дадда": 1,
    "дадли": 1,
    "даймонд": 1,
    "дакей": 1,
    "дакота": 1,
    "дакс": 1,
    "далтон": 1,
    "дамайон": 1,
    "дамиан": 1,
    "дамир": 1,
    "дан": 1,
    "дана": 1,
    "дани": 1,
    "даниар": 1,
    "даниил": 1,
    "данил": 1,
    "данила": 1,
    "данило": 1,
    "даниэль": 1,
    "данки": 1,
    "данни": 1,
    "дар": 1,
    "дарби": 1,
    "дарвин": 1,
    "дарден": 1,
    "дарен": 1,
    "дариан": 1,
    "дарил": 1,
    "дарин": 1,
    "дарки": 1,
    "дарнелл": 1,
    "даррел": 1,
    "даррен": 1,
    "даррил": 1,
    "даррин": 1,
    "даррэль": 1,
    "дасти": 1,
    "дастин": 1,
    "дау": 1,
    "дафф": 1,
    "даффи": 1,
    "дашилл": 1,
    "дван": 1,
    "двэйн": 1,
    "деай": 1,
    "деван": 1,
    "девен": 1,
    "девереукс": 1,
    "девин": 1,
    "девон": 1,
    "дейв": 1,
    "дейл": 1,
    "дейрлл": 1,
    "дейрн": 1,
    "декабрий": 1,
    "деклан": 1,
    "декстер": 1,
    "делберт": 1,
    "делл": 1,
    "делмар": 1,
    "делрой": 1,
    "дементий": 1,
    "деметриус": 1,
    "демид": 1,
    "демократ": 1,
    "демон": 1,
    "демьян": 1,
    "ден": 1,
    "денвер": 1,
    "денеб": 1,
    "дензэль": 1,
    "дени": 1,
    "денил": 1,
    "денис": 1,
    "деннис": 1,
    "дентон": 1,
    "деон": 1,
    "деонн": 1,
    "деонт": 1,
    "дерби": 1,
    "дерек": 1,
    "дерик": 1,
    "дермот": 1,
    "дерок": 1,
    "деррен": 1,
    "дерри": 1,
    "деррил": 1,
    "дефорест": 1,
    "дефоррест": 1,
    "дешон": 1,
    "джадд": 1,
    "джадин": 1,
    "джай": 1,
    "джайлс": 1,
    "джак": 1,
    "джамар": 1,
    "джамей": 1,
    "джамисон": 1,
    "джарвис": 1,
    "джаред": 1,
    "джарод": 1,
    "джарред": 1,
    "джарретт": 1,
    "джаррод": 1,
    "джаспер": 1,
    "джасти": 1,
    "джастин": 1,
    "джеб": 1,
    "джед": 1,
    "джедидиа": 1,
    "джейдн": 1,
    "джейк": 1,
    "джейлн": 1,
    "джейми": 1,
    "джеймс": 1,
    "джейрт": 1,
    "джейсон": 1,
    "джекки": 1,
    "джекоб": 1,
    "джем": 1,
    "дженкин": 1,
    "джеп": 1,
    "джер": 1,
    "джералд": 1,
    "джеральд": 1,
    "джерард": 1,
    "джерваз": 1,
    "джервис": 1,
    "джереми": 1,
    "джери": 1,
    "джермэйн": 1,
    "джеролд": 1,
    "джером": 1,
    "джеррард": 1,
    "джерред": 1,
    "джерри": 1,
    "джеррод": 1,
    "джерролд": 1,
    "джес": 1,
    "джесси": 1,
    "джетро": 1,
    "джетт": 1,
    "джеф": 1,
    "джеффери": 1,
    "джефферсон": 1,
    "джеффрей": 1,
    "джеффри": 1,
    "джиб": 1,
    "джид": 1,
    "джиди": 1,
    "джил": 1,
    "джим": 1,
    "джими": 1,
    "джимми": 1,
    "джисберт": 1,
    "джиффард": 1,
    "джо": 1,
    "джоб": 1,
    "джоби": 1,
    "джоджо": 1,
    "джоди": 1,
    "джозеф": 1,
    "джой": 1,
    "джойс": 1,
    "джон": 1,
    "джоназан": 1,
    "джоназон": 1,
    "джонасон": 1,
    "джонатан": 1,
    "джоней": 1,
    "джони": 1,
    "джонни": 1,
    "джонти": 1,
    "джорги": 1,
    "джордан": 1,
    "джордж": 1,
    "джорди": 1,
    "джордон": 1,
    "джосс": 1,
    "джоул": 1,
    "джош": 1,
    "джошоа": 1,
    "джошуа": 1,
    "джулс": 1,
    "джульян": 1,
    "джустис": 1,
    "джьюд": 1,
    "джэй": 1,
    "джэйд": 1,
    "джэйда": 1,
    "джэйден": 1,
    "джэйдон": 1,
    "джэйкоб": 1,
    "джэйлен": 1,
    "джэйлин": 1,
    "джэйлон": 1,
    "джэймес": 1,
    "джэйсон": 1,
    "джэксон": 1,
    "джэмини": 1,
    "джэмми": 1,
    "джэн": 1,
    "ди": 1,
    "диакон": 1,
    "дигби": 1,
    "диггори": 1,
    "дигори": 1,
    "дидим": 1,
    "дизон": 1,
    "дик": 1,
    "дики": 1,
    "дикки": 1,
    "дил": 1,
    "дилан": 1,
    "дилберт": 1,
    "димер": 1,
    "димитрий": 1,
    "дин": 1,
    "диндр": 1,
    "дионис": 1,
    "дионисий": 1,
    "дирк": 1,
    "дмитрий": 1,
    "доб": 1,
    "добрыня": 1,
    "додж": 1,
    "дольф": 1,
    "дом": 1,
    "доменик": 1,
    "доминик": 1,
    "дон": 1,
    "дональд": 1,
    "дональт": 1,
    "донат": 1,
    "донни": 1,
    "донован": 1,
    "дор": 1,
    "дориан": 1,
    "дорофей": 1,
    "доусон": 1,
    "драйк": 1,
    "древ": 1,
    "дрейвн": 1,
    "дуайт": 1,
    "дуан": 1,
    "дуг": 1,
    "дуги": 1,
    "дуглас": 1,
    "дункан": 1,
    "дунстан": 1,
    "дью": 1,
    "дьюей": 1,
    "дьюэйн": 1,
    "дэвид": 1,
    "дэвис": 1,
    "дэй": 1,
    "дэйви": 1,
    "дэйн": 1,
    "дэйтон": 1,
    "дэн": 1,
    "дэни": 1,
    "дэниел": 1,
    "дэнни": 1,
    "дэррик": 1,
    "дэшон": 1,
    "дюк": 1,
    "евгений": 1,
    "евграф": 1,
    "евдоким": 1,
    "евлампий": 1,
    "евлогий": 1,
    "евсей": 1,
    "евстафий": 1,
    "егор": 1,
    "елеазар": 1,
    "елизар": 1,
    "елисей": 1,
    "емельян": 1,
    "епифан": 1,
    "еремей": 1,
    "ермак": 1,
    "ермил": 1,
    "ермолай": 1,
    "ерофей": 1,
    "еруслан": 1,
    "ефим": 1,
    "ефрем": 1,
    "ждан": 1,
    "жерар": 1,
    "жозеф": 1,
    "жорес": 1,
    "жюль": 1,
    "завир": 1,
    "зак": 1,
    "закери": 1,
    "зандер": 1,
    "захар": 1,
    "захарий": 1,
    "зачариа": 1,
    "зачэри": 1,
    "зед": 1,
    "зедекиа": 1,
    "зек": 1,
    "зигмунд": 1,
    "зигфрид": 1,
    "зиновий": 1,
    "зорий": 1,
    "зосим": 1,
    "зосима": 1,
    "зот": 1,
    "зубин": 1,
    "зэофилус": 1,
    "иб": 1,
    "ибрагим": 1,
    "иван": 1,
    "игнат": 1,
    "игнатий": 1,
    "игнатиус": 1,
    "игорь": 1,
    "ид": 1,
    "иероним": 1,
    "иззи": 1,
    "изидор": 1,
    "измаил": 1,
    "измайло": 1,
    "изяслав": 1,
    "ий": 1,
    "икар": 1,
    "илар": 1,
    "иларий": 1,
    "иларион": 1,
    "илий": 1,
    "илиодор": 1,
    "илларион": 1,
    "илья": 1,
    "имон": 1,
    "инглеберт": 1,
    "инграм": 1,
    "инди": 1,
    "индиана": 1,
    "индиго": 1,
    "инесент": 1,
    "иниго": 1,
    "иннокентий": 1,
    "иоанн": 1,
    "иорик": 1,
    "иосиф": 1,
    "ипат": 1,
    "ипатий": 1,
    "ипполит": 1,
    "ираклий": 1,
    "ирвайн": 1,
    "ирвин": 1,
    "ирвинг": 1,
    "ириней": 1,
    "ириний": 1,
    "ирл": 1,
    "ирм": 1,
    "ирнест": 1,
    "исай": 1,
    "исайя": 1,
    "исак": 1,
    "исакий": 1,
    "исей": 1,
    "исидор": 1,
    "иссак": 1,
    "исси": 1,
    "истер": 1,
    "июлий": 1,
    "йорк": 1,
    "ка": 1,
    "кадмус": 1,
    "казимир": 1,
    "каин": 1,
    "каир": 1,
    "кайд": 1,
    "кайл": 1,
    "кал": 1,
    "калин": 1,
    "калина": 1,
    "каллен": 1,
    "кам": 1,
    "камден": 1,
    "камиль": 1,
    "камрон": 1,
    "капитон": 1,
    "карбрей": 1,
    "карбри": 1,
    "карвер": 1,
    "карей": 1,
    "карен": 1,
    "карл": 1,
    "карлайл": 1,
    "карлейл": 1,
    "карлин": 1,
    "карлтон": 1,
    "карм": 1,
    "кармий": 1,
    "карп": 1,
    "каррол": 1,
    "картер": 1,
    "касиди": 1,
    "каспар": 1,
    "каспер": 1,
    "кассиди": 1,
    "касьян": 1,
    "квентин": 1,
    "квинтин": 1,
    "кеван": 1,
    "кевин": 1,
    "кей": 1,
    "кейденс": 1,
    "кейдн": 1,
    "кейлб": 1,
    "кеймрон": 1,
    "кейси": 1,
    "келвин": 1,
    "келкей": 1,
    "келл": 1,
    "келли": 1,
    "келсей": 1,
    "кемп": 1,
    "кен": 1,
    "кендал": 1,
    "кендол": 1,
    "кендрик": 1,
    "кенелм": 1,
    "кензи": 1,
    "кенит": 1,
    "кеннеди": 1,
    "кеннет": 1,
    "кенни": 1,
    "кеннит": 1,
    "кенрик": 1,
    "кент": 1,
    "кентиджерн": 1,
    "кентон": 1,
    "кермит": 1,
    "керней": 1,
    "керр": 1,
    "керри": 1,
    "керт": 1,
    "кертис": 1,
    "кешон": 1,
    "ки": 1,
    "киаран": 1,
    "килан": 1,
    "килер": 1,
    "килиан": 1,
    "киллиан": 1,
    "ким": 1,
    "кимбелайн": 1,
    "кимберли": 1,
    "кимбол": 1,
    "кимбэль": 1,
    "кин": 1,
    "кинан": 1,
    "кинастон": 1,
    "кинг": 1,
    "кингслей": 1,
    "кип": 1,
    "киприан": 1,
    "кир": 1,
    "киран": 1,
    "кирби": 1,
    "кирилл": 1,
    "кирк": 1,
    "кирон": 1,
    "кирус": 1,
    "кит": 1,
    "китон": 1,
    "киф": 1,
    "клавдий": 1,
    "клайв": 1,
    "клайд": 1,
    "кланкей": 1,
    "кланки": 1,
    "кларенс": 1,
    "кларк": 1,
    "клев": 1,
    "клей": 1,
    "клейтон": 1,
    "клем": 1,
    "клемент": 1,
    "клементий": 1,
    "клемми": 1,
    "клетис": 1,
    "клетус": 1,
    "кливленд": 1,
    "клим": 1,
    "климент": 1,
    "климентий": 1,
    "клинт": 1,
    "клинтон": 1,
    "клифтон": 1,
    "клифф": 1,
    "клиффорд": 1,
    "клод": 1,
    "клэйрк": 1,
    "клэр": 1,
    "кодей": 1,
    "коди": 1,
    "коертней": 1,
    "козьма": 1,
    "кола": 1,
    "коламбан": 1,
    "колберт": 1,
    "колби": 1,
    "колдер": 1,
    "колин": 1,
    "коллахан": 1,
    "коллин": 1,
    "коллум": 1,
    "колтен": 1,
    "колтон": 1,
    "колумбий": 1,
    "кольт": 1,
    "конан": 1,
    "конвей": 1,
    "кондрат": 1,
    "кондратий": 1,
    "конлей": 1,
    "коннелл": 1,
    "коннер": 1,
    "коннор": 1,
    "конон": 1,
    "конор": 1,
    "конрад": 1,
    "константин": 1,
    "конфуций": 1,
    "корбин": 1,
    "корделл": 1,
    "корей": 1,
    "кори": 1,
    "корней": 1,
    "корнелий": 1,
    "корнелиус": 1,
    "корнил": 1,
    "кортней": 1,
    "кортни": 1,
    "корэй": 1,
    "коти": 1,
    "коул": 1,
    "коулман": 1,
    "краснослав": 1,
    "крис": 1,
    "криспиан": 1,
    "криспин": 1,
    "кристи": 1,
    "кристиан": 1,
    "кристопэр": 1,
    "кристоф": 1,
    "кристофер": 1,
    "крофорд": 1,
    "крофтон": 1,
    "крэйг": 1,
    "ксавайор": 1,
    "ксавьер": 1,
    "ксан": 1,
    "ксенофонт": 1,
    "ксзавир": 1,
    "кузьма": 1,
    "куин": 1,
    "куинкей": 1,
    "куинси": 1,
    "куинтон": 1,
    "купер": 1,
    "куприян": 1,
    "курт": 1,
    "куртис": 1,
    "кэйд": 1,
    "кэйдн": 1,
    "кэйл": 1,
    "кэйлб": 1,
    "кэймрон": 1,
    "кэйн": 1,
    "кэйси": 1,
    "кэлвин": 1,
    "кэм": 1,
    "кэмп": 1,
    "кэмпбэл": 1,
    "кэри": 1,
    "кюри": 1,
    "лаверн": 1,
    "лавлл": 1,
    "лавр": 1,
    "лаврентий": 1,
    "лаз": 1,
    "лазарь": 1,
    "лайл": 1,
    "лайонел": 1,
    "лаки": 1,
    "ланни": 1,
    "ланфорд": 1,
    "ларион": 1,
    "ларк": 1,
    "ларкин": 1,
    "ларри": 1,
    "лаэрт": 1,
    "лев": 1,
    "леви": 1,
    "левкий": 1,
    "лейврн": 1,
    "лейн": 1,
    "лейтон": 1,
    "лекс": 1,
    "леланд": 1,
    "лель": 1,
    "лем": 1,
    "лемми": 1,
    "лемюэль": 1,
    "лен": 1,
    "ленар": 1,
    "ленард": 1,
    "лени": 1,
    "лениан": 1,
    "леннард": 1,
    "ленни": 1,
    "лео": 1,
    "леон": 1,
    "леонард": 1,
    "леонид": 1,
    "леонтий": 1,
    "леопольд": 1,
    "лермонт": 1,
    "лерой": 1,
    "лес": 1,
    "лесли": 1,
    "лестер": 1,
    "ли": 1,
    "либерт": 1,
    "ливадий": 1,
    "лии": 1,
    "лин": 1,
    "линдон": 1,
    "линдсей": 1,
    "линдси": 1,
    "линкольн": 1,
    "линн": 1,
    "линсей": 1,
    "линтон": 1,
    "линус": 1,
    "линфорд": 1,
    "лионель": 1,
    "лир": 1,
    "лирой": 1,
    "лисандр": 1,
    "литон": 1,
    "лихнис": 1,
    "ллойд": 1,
    "ллью": 1,
    "лльюелин": 1,
    "лльюеллин": 1,
    "ло": 1,
    "ловэль": 1,
    "лойд": 1,
    "лон": 1,
    "лондон": 1,
    "лонни": 1,
    "лонс": 1,
    "лор": 1,
    "лорен": 1,
    "лоренс": 1,
    "лори": 1,
    "лорин": 1,
    "лорис": 1,
    "лорни": 1,
    "лоррин": 1,
    "лосон": 1,
    "лоуэлл": 1,
    "лоэнгрин": 1,
    "лу": 1,
    "лудо": 1,
    "луи": 1,
    "лука": 1,
    "лукиан": 1,
    "лукьян": 1,
    "льюин": 1,
    "льюис": 1,
    "лэйк": 1,
    "лэйн": 1,
    "лэйтон": 1,
    "лэндон": 1,
    "лэнс": 1,
    "лэрри": 1,
    "любим": 1,
    "любомир": 1,
    "людвиг": 1,
    "людовик": 1,
    "люк": 1,
    "люкс": 1,
    "люксен": 1,
    "люсьен": 1,
    "лютер": 1,
    "люциан": 1,
    "маверик": 1,
    "маврикий": 1,
    "мадисон": 1,
    "маеслав": 1,
    "май": 1,
    "майк": 1,
    "майкл": 1,
    "майлз": 1,
    "майрон": 1,
    "майслав": 1,
    "макар": 1,
    "макарий": 1,
    "макей": 1,
    "макензи": 1,
    "маки": 1,
    "макинтош": 1,
    "маккензи": 1,
    "макс": 1,
    "максвелл": 1,
    "максим": 1,
    "максимилиан": 1,
    "максимиллиан": 1,
    "максимильян": 1,
    "малачи": 1,
    "малком": 1,
    "малоун": 1,
    "манлей": 1,
    "манни": 1,
    "манникс": 1,
    "мануил": 1,
    "мануйло": 1,
    "манфред": 1,
    "марат": 1,
    "марвин": 1,
    "мариан": 1,
    "марин": 1,
    "мариус": 1,
    "марк": 1,
    "марка": 1,
    "маркел": 1,
    "маркиан": 1,
    "марко": 1,
    "маркус": 1,
    "марлен": 1,
    "марлин": 1,
    "марлон": 1,
    "марлоу": 1,
    "мармадьюк": 1,
    "марри": 1,
    "марс": 1,
    "марсен": 1,
    "марти": 1,
    "мартиал": 1,
    "мартин": 1,
    "мартын": 1,
    "маршал": 1,
    "маршалл": 1,
    "марьян": 1,
    "масон": 1,
    "мастерман": 1,
    "матвей": 1,
    "матти": 1,
    "мед": 1,
    "мелвилль": 1,
    "мелвин": 1,
    "мельбурн": 1,
    "мерв": 1,
    "мервин": 1,
    "мерди": 1,
    "мердо": 1,
    "мердок": 1,
    "мередит": 1,
    "мерит": 1,
    "меркурий": 1,
    "мерл": 1,
    "мерлин": 1,
    "меррилл": 1,
    "мерритт": 1,
    "мертон": 1,
    "мерфи": 1,
    "мефодий": 1,
    "мечеслав": 1,
    "мечислав": 1,
    "мид": 1,
    "миид": 1,
    "мик": 1,
    "мика": 1,
    "мики": 1,
    "микки": 1,
    "милад": 1,
    "милан": 1,
    "милберн": 1,
    "милен": 1,
    "милий": 1,
    "миллард": 1,
    "мило": 1,
    "милонег": 1,
    "милослав": 1,
    "милтон": 1,
    "милфорд": 1,
    "мир": 1,
    "мирон": 1,
    "мирослав": 1,
    "митчелл": 1,
    "михаил": 1,
    "михайло": 1,
    "мич": 1,
    "мича": 1,
    "мичил": 1,
    "мо": 1,
    "модест": 1,
    "моз": 1,
    "моисей": 1,
    "молком": 1,
    "монолит": 1,
    "монро": 1,
    "монтагью": 1,
    "монтгомери": 1,
    "монте": 1,
    "монти": 1,
    "монтморенки": 1,
    "морган": 1,
    "морген": 1,
    "мордекэй": 1,
    "морис": 1,
    "морлей": 1,
    "моррис": 1,
    "морт": 1,
    "морти": 1,
    "мортимер": 1,
    "мортон": 1,
    "мосс": 1,
    "моэ": 1,
    "мстислав": 1,
    "мулава": 1,
    "мурат": 1,
    "мэйнард": 1,
    "мэйнерд": 1,
    "мэйор": 1,
    "мэйсон": 1,
    "мэйтланд": 1,
    "мэлори": 1,
    "мэль": 1,
    "мэриан": 1,
    "мэрион": 1,
    "мэт": 1,
    "мэтт": 1,
    "мэтти": 1,
    "мэтью": 1,
    "мюд": 1,
    "надир": 1,
    "назаниль": 1,
    "назар": 1,
    "назарий": 1,
    "назим": 1,
    "найджел": 1,
    "найлс": 1,
    "наль": 1,
    "нанди": 1,
    "нат": 1,
    "натан": 1,
    "наум": 1,
    "науэлл": 1,
    "наш": 1,
    "невада": 1,
    "неван": 1,
    "невил": 1,
    "невилл": 1,
    "нед": 1,
    "нейл": 1,
    "нейлл": 1,
    "нейт": 1,
    "нельсон": 1,
    "нео": 1,
    "неон": 1,
    "неонил": 1,
    "нестер": 1,
    "нестор": 1,
    "нивек": 1,
    "нивен": 1,
    "ник": 1,
    "никандр": 1,
    "никанор": 1,
    "никита": 1,
    "никифор": 1,
    "никк": 1,
    "никки": 1,
    "никодим": 1,
    "никола": 1,
    "николай": 1,
    "николас": 1,
    "никон": 1,
    "нил": 1,
    "нили": 1,
    "нимбус": 1,
    "нинел": 1,
    "нинель": 1,
    "нисон": 1,
    "нифонт": 1,
    "ноа": 1,
    "новомир": 1,
    "нодар": 1,
    "ной": 1,
    "нолан": 1,
    "нолл": 1,
    "норберт": 1,
    "норвуд": 1,
    "норд": 1,
    "норм": 1,
    "норман": 1,
    "норманд": 1,
    "норрис": 1,
    "нортон": 1,
    "ноубль": 1,
    "ноэль": 1,
    "ньют": 1,
    "ньютон": 1,
    "оберон": 1,
    "обин": 1,
    "обри": 1,
    "овидий": 1,
    "огастин": 1,
    "огден": 1,
    "огэст": 1,
    "оделл": 1,
    "одиссей": 1,
    "одлей": 1,
    "одран": 1,
    "оз": 1,
    "оззи": 1,
    "океан": 1,
    "оксар": 1,
    "октавиан": 1,
    "октябрин": 1,
    "октябрь": 1,
    "олби": 1,
    "олбэйн": 1,
    "олдвен": 1,
    "олдвин": 1,
    "олден": 1,
    "олдин": 1,
    "олдис": 1,
    "олдон": 1,
    "олдос": 1,
    "олдред": 1,
    "олдус": 1,
    "олдфорд": 1,
    "олег": 1,
    "олей": 1,
    "оли": 1,
    "оливер": 1,
    "олимпий": 1,
    "олластер": 1,
    "олластир": 1,
    "оллгар": 1,
    "оллджер": 1,
    "олли": 1,
    "оллин": 1,
    "оллисдэйр": 1,
    "оллистер": 1,
    "оллистэйр": 1,
    "оллон": 1,
    "оллэйстар": 1,
    "ольгерд": 1,
    "омар": 1,
    "омега": 1,
    "онисим": 1,
    "ора": 1,
    "оран": 1,
    "орвал": 1,
    "орвилл": 1,
    "орест": 1,
    "ориан": 1,
    "ормерод": 1,
    "оррелл": 1,
    "оррин": 1,
    "орсон": 1,
    "осберт": 1,
    "осбоерн": 1,
    "осборн": 1,
    "освальд": 1,
    "осень": 1,
    "осип": 1,
    "оскар": 1,
    "остап": 1,
    "остен": 1,
    "остин": 1,
    "остромир": 1,
    "отис": 1,
    "оттис": 1,
    "отто": 1,
    "оттон": 1,
    "оуин": 1,
    "оуэн": 1,
    "ошин": 1,
    "павел": 1,
    "пайс": 1,
    "палладий": 1,
    "палмер": 1,
    "панкрас": 1,
    "пантелей": 1,
    "пантелеймон": 1,
    "панфил": 1,
    "парамон": 1,
    "паркер": 1,
    "паррис": 1,
    "партизан": 1,
    "пат": 1,
    "патрик": 1,
    "патси": 1,
    "пахом": 1,
    "пеитон": 1,
    "пепин": 1,
    "пересвет": 1,
    "перри": 1,
    "перс": 1,
    "перси": 1,
    "персиваль": 1,
    "петеркин": 1,
    "пимен": 1,
    "пип": 1,
    "пипер": 1,
    "пирр": 1,
    "пирс": 1,
    "пит": 1,
    "питер": 1,
    "платон": 1,
    "пол": 1,
    "поли": 1,
    "поликарп": 1,
    "помпей": 1,
    "портер": 1,
    "порфирий": 1,
    "потап": 1,
    "престон": 1,
    "приам": 1,
    "принц": 1,
    "пров": 1,
    "прозор": 1,
    "прокопий": 1,
    "прокофий": 1,
    "проспер": 1,
    "протас": 1,
    "прохор": 1,
    "пэйс": 1,
    "пэйси": 1,
    "пэйтон": 1,
    "пётр": 1,
    "петр": 1,
    "равель": 1,
    "равен": 1,
    "равиль": 1,
    "радамес": 1,
    "радий": 1,
    "радим": 1,
    "радислав": 1,
    "радомир": 1,
    "раз": 1,
    "раймонд": 1,
    "раймунд": 1,
    "райордан": 1,
    "райт": 1,
    "ралф": 1,
    "ралфи": 1,
    "ральф": 1,
    "ранделл": 1,
    "ранди": 1,
    "рандолф": 1,
    "рандольф": 1,
    "расс": 1,
    "рассел": 1,
    "рассэль": 1,
    "расти": 1,
    "растус": 1,
    "ратмир": 1,
    "рауль": 1,
    "рафаил": 1,
    "рафаэль": 1,
    "рашид": 1,
    "раян": 1,
    "реарден": 1,
    "ревмир": 1,
    "реган": 1,
    "редд": 1,
    "редж": 1,
    "реджи": 1,
    "реджинальд": 1,
    "редклиф": 1,
    "редклифф": 1,
    "редлей": 1,
    "редманд": 1,
    "редмонд": 1,
    "реид": 1,
    "рей": 1,
    "рейли": 1,
    "рейнард": 1,
    "рейнольд": 1,
    "рекс": 1,
    "рем": 1,
    "ренальд": 1,
    "ренат": 1,
    "риган": 1,
    "ригби": 1,
    "рид": 1,
    "ридлей": 1,
    "риель": 1,
    "рик": 1,
    "рикей": 1,
    "рики": 1,
    "рилан": 1,
    "рилей": 1,
    "рили": 1,
    "ринат": 1,
    "рио": 1,
    "риплей": 1,
    "рис": 1,
    "рихард": 1,
    "рич": 1,
    "ричард": 1,
    "ричи": 1,
    "роальд": 1,
    "роб": 1,
    "робби": 1,
    "роберт": 1,
    "робеспьер": 1,
    "роби": 1,
    "робин": 1,
    "робинзон": 1,
    "рован": 1,
    "род": 1,
    "роддж": 1,
    "родджер": 1,
    "родди": 1,
    "родерик": 1,
    "роджер": 1,
    "родион": 1,
    "родни": 1,
    "родолф": 1,
    "рождеро": 1,
    "рой": 1,
    "ройл": 1,
    "ройс": 1,
    "ройстон": 1,
    "роки": 1,
    "ролан": 1,
    "роланд": 1,
    "роли": 1,
    "ролланд": 1,
    "ролли": 1,
    "роман": 1,
    "ромен": 1,
    "ромуальд": 1,
    "рон": 1,
    "рональд": 1,
    "ронни": 1,
    "рори": 1,
    "роско": 1,
    "росс": 1,
    "ростислав": 1,
    "роуланд": 1,
    "роулей": 1,
    "роял": 1,
    "рубен": 1,
    "рубин": 1,
    "руди": 1,
    "рудольф": 1,
    "рудьярд": 1,
    "рунар": 1,
    "руслан": 1,
    "руссо": 1,
    "рустам": 1,
    "рустем": 1,
    "рхетт": 1,
    "рьюб": 1,
    "рэд": 1,
    "рэй": 1,
    "рэйнард": 1,
    "рэйнер": 1,
    "рэйф": 1,
    "рэм": 1,
    "рэндал": 1,
    "рэндалл": 1,
    "рюрик": 1,
    "сава": 1,
    "савва": 1,
    "савелий": 1,
    "савьер": 1,
    "сайг": 1,
    "саймон": 1,
    "салал": 1,
    "салливан": 1,
    "самми": 1,
    "самойло": 1,
    "самсон": 1,
    "самуил": 1,
    "сандфорд": 1,
    "санни": 1,
    "санфорд": 1,
    "свет": 1,
    "светлан": 1,
    "светозар": 1,
    "светослав": 1,
    "свизин": 1,
    "свизун": 1,
    "свиней": 1,
    "святогор": 1,
    "святополк": 1,
    "святослав": 1,
    "себастьян": 1,
    "севард": 1,
    "севастиан": 1,
    "севастьян": 1,
    "север": 1,
    "севериан": 1,
    "северин": 1,
    "северьян": 1,
    "северян": 1,
    "седрик": 1,
    "сеймур": 1,
    "селби": 1,
    "семён": 1,
    "септембер": 1,
    "серапион": 1,
    "серафим": 1,
    "сергей": 1,
    "сесил": 1,
    "сет": 1,
    "сефтон": 1,
    "сивард": 1,
    "сигизмунд": 1,
    "сигманд": 1,
    "сид": 1,
    "сидней": 1,
    "сидор": 1,
    "сила": 1,
    "силас": 1,
    "силвестр": 1,
    "сильвер": 1,
    "сильвест": 1,
    "сильвестр": 1,
    "симеон": 1,
    "симон": 1,
    "синклэйр": 1,
    "сирил": 1,
    "сисар": 1,
    "скай": 1,
    "скилар": 1,
    "скилер": 1,
    "скот": 1,
    "скотти": 1,
    "скуилер": 1,
    "слава": 1,
    "слай": 1,
    "слэйд": 1,
    "совет": 1,
    "сократ": 1,
    "соломон": 1,
    "сони": 1,
    "сонни": 1,
    "софокл": 1,
    "софон": 1,
    "спайк": 1,
    "спарроу": 1,
    "спартак": 1,
    "спенсер": 1,
    "спиридон": 1,
    "спиро": 1,
    "стакей": 1,
    "сталий": 1,
    "сталь": 1,
    "станислав": 1,
    "стаффорд": 1,
    "степан": 1,
    "стерлинг": 1,
    "стеф": 1,
    "стефан": 1,
    "сти": 1,
    "стив": 1,
    "стивен": 1,
    "стиви": 1,
    "стиу": 1,
    "сторм": 1,
    "стратон": 1,
    "сту": 1,
    "стэки": 1,
    "стэн": 1,
    "стэнли": 1,
    "стэнфорд": 1,
    "стюарт": 1,
    "сурен": 1,
    "сэм": 1,
    "сэмюэль": 1,
    "сэнди": 1,
    "тад": 1,
    "таддеус": 1,
    "таир": 1,
    "тай": 1,
    "такер": 1,
    "тал": 1,
    "талбот": 1,
    "таннер": 1,
    "тарас": 1,
    "таскилл": 1,
    "таффи": 1,
    "тед": 1,
    "тейгу": 1,
    "тейдж": 1,
    "теймураз": 1,
    "тейрк": 1,
    "текс": 1,
    "тельнан": 1,
    "тенгиз": 1,
    "тенней": 1,
    "теннизон": 1,
    "тео": 1,
    "теобальд": 1,
    "теодор": 1,
    "теранс": 1,
    "теренс": 1,
    "терентий": 1,
    "терло": 1,
    "терранс": 1,
    "террелл": 1,
    "терренс": 1,
    "терстон": 1,
    "ти": 1,
    "тиарнак": 1,
    "тиарнан": 1,
    "тибалт": 1,
    "тибби": 1,
    "тигран": 1,
    "тигу": 1,
    "тизон": 1,
    "тилар": 1,
    "тилер": 1,
    "тилор": 1,
    "тим": 1,
    "тимми": 1,
    "тимоти": 1,
    "тимофей": 1,
    "тимур": 1,
    "тирелл": 1,
    "тирнан": 1,
    "тирней": 1,
    "тирон": 1,
    "тироун": 1,
    "тиррелл": 1,
    "тит": 1,
    "тихомир": 1,
    "тихон": 1,
    "тоал": 1,
    "тоби": 1,
    "тобиас": 1,
    "тобин": 1,
    "товий": 1,
    "тод": 1,
    "тодд": 1,
    "толли": 1,
    "том": 1,
    "томас": 1,
    "томми": 1,
    "тон": 1,
    "тони": 1,
    "топэр": 1,
    "торез": 1,
    "торий": 1,
    "торлей": 1,
    "торнтон": 1,
    "травис": 1,
    "тракей": 1,
    "трантер": 1,
    "траффорд": 1,
    "траэрн": 1,
    "трев": 1,
    "тревельян": 1,
    "тревор": 1,
    "трейврс": 1,
    "трейс": 1,
    "трейси": 1,
    "трент": 1,
    "трентон": 1,
    "тристан": 1,
    "тристрам": 1,
    "трифон": 1,
    "трой": 1,
    "трофим": 1,
    "труман": 1,
    "туллий": 1,
    "тусон": 1,
    "тэдди": 1,
    "тэди": 1,
    "тэйлер": 1,
    "тэйлор": 1,
    "тэйн": 1,
    "тэйт": 1,
    "тэл": 1,
    "тэмпл": 1,
    "тэрри": 1,
    "уилбер": 1,
    "уиллард": 1,
    "уиллис": 1,
    "уилфред": 1,
    "уилфрид": 1,
    "уильям": 1,
    "уинстон": 1,
    "уинфред": 1,
    "уисдом": 1,
    "улайксс": 1,
    "улиссес": 1,
    "ульяна": 1,
    "уолли": 1,
    "уоллис": 1,
    "уолт": 1,
    "уолтер": 1,
    "уолтон": 1,
    "уорик": 1,
    "уорнер": 1,
    "уоррен": 1,
    "уот": 1,
    "уоткин": 1,
    "уптон": 1,
    "урбан": 1,
    "уриах": 1,
    "устин": 1,
    "уэйн": 1,
    "уэсли": 1,
    "фабиан": 1,
    "фаддей": 1,
    "фадей": 1,
    "фалк": 1,
    "фарид": 1,
    "фарлей": 1,
    "фарон": 1,
    "фарран": 1,
    "февралин": 1,
    "федор": 1,
    "федосий": 1,
    "фелан": 1,
    "фелиз": 1,
    "феликс": 1,
    "фелим": 1,
    "фелис": 1,
    "фентон": 1,
    "феодосий": 1,
    "феофан": 1,
    "ферги": 1,
    "фергус": 1,
    "ферд": 1,
    "ферди": 1,
    "фердинанд": 1,
    "фернан": 1,
    "фернанд": 1,
    "фестер": 1,
    "фестус": 1,
    "фидель": 1,
    "фидо": 1,
    "фил": 1,
    "филайп": 1,
    "филандр": 1,
    "филарет": 1,
    "филат": 1,
    "филберт": 1,
    "филимон": 1,
    "филип": 1,
    "филипп": 1,
    "фило": 1,
    "финикс": 1,
    "финис": 1,
    "флегонт": 1,
    "флемминг": 1,
    "флечер": 1,
    "флинн": 1,
    "флинт": 1,
    "флойд": 1,
    "флорентий": 1,
    "флоренц": 1,
    "флорин": 1,
    "флорри": 1,
    "флурри": 1,
    "фок": 1,
    "фокс": 1,
    "фома": 1,
    "фонз": 1,
    "фонзи": 1,
    "форбес": 1,
    "форд": 1,
    "форест": 1,
    "форрест": 1,
    "фостер": 1,
    "фот": 1,
    "фотий": 1,
    "фоук": 1,
    "фразир": 1,
    "франклин": 1,
    "франц": 1,
    "фред": 1,
    "фредди": 1,
    "фредерик": 1,
    "фредрик": 1,
    "фрейзер": 1,
    "фрейзр": 1,
    "фридрих": 1,
    "фримэн": 1,
    "фритс": 1,
    "фродо": 1,
    "фрол": 1,
    "фрэнк": 1,
    "фрэнки": 1,
    "фрэнклин": 1,
    "фрэнс": 1,
    "фрэнсис": 1,
    "фёдор": 1,
    "хавелок": 1,
    "хадвин": 1,
    "хадлей": 1,
    "хал": 1,
    "хам": 1,
    "хамиш": 1,
    "хамлет": 1,
    "хаммонд": 1,
    "ханк": 1,
    "ханлей": 1,
    "хантер": 1,
    "харв": 1,
    "харви": 1,
    "харди": 1,
    "хардинг": 1,
    "харитон": 1,
    "харкоерт": 1,
    "харлан": 1,
    "харланд": 1,
    "харлей": 1,
    "харлин": 1,
    "хармон": 1,
    "харпер": 1,
    "харрис": 1,
    "харрисон": 1,
    "хартлей": 1,
    "хауелл": 1,
    "хедлей": 1,
    "хек": 1,
    "хендерсон": 1,
    "хендрик": 1,
    "хенрай": 1,
    "хенри": 1,
    "херб": 1,
    "херби": 1,
    "хервей": 1,
    "херлей": 1,
    "хиацинт": 1,
    "хилари": 1,
    "хиллэри": 1,
    "хирам": 1,
    "хис": 1,
    "хитклифф": 1,
    "хию": 1,
    "хоард": 1,
    "хоб": 1,
    "ходдж": 1,
    "хойт": 1,
    "холден": 1,
    "холл": 1,
    "холлис": 1,
    "хомер": 1,
    "хопкин": 1,
    "хорас": 1,
    "хоратайо": 1,
    "хоуи": 1,
    "храбр": 1,
    "христоф": 1,
    "христофор": 1,
    "худд": 1,
    "хуей": 1,
    "хует": 1,
    "хукк": 1,
    "хукслей": 1,
    "хумберт": 1,
    "хунтлей": 1,
    "хуффи": 1,
    "хью": 1,
    "хьюберт": 1,
    "хьюго": 1,
    "хьюи": 1,
    "хэвен": 1,
    "хэдлей": 1,
    "хэйвуд": 1,
    "хэйден": 1,
    "хэйл": 1,
    "хэмфри": 1,
    "хэппи": 1,
    "хюи": 1,
    "цезарь": 1,
    "чад": 1,
    "чадвик": 1,
    "чаз": 1,
    "чак": 1,
    "чакки": 1,
    "чарлз": 1,
    "чарли": 1,
    "чарлтон": 1,
    "чарльз": 1,
    "час": 1,
    "чейз": 1,
    "чендлер": 1,
    "ченс": 1,
    "черокез": 1,
    "чеслав": 1,
    "честер": 1,
    "чеьянн": 1,
    "чип": 1,
    "чонки": 1,
    "чонси": 1,
    "ша": 1,
    "шад": 1,
    "шаи": 1,
    "шайенн": 1,
    "шакуилл": 1,
    "шамиль": 1,
    "шамус": 1,
    "шан": 1,
    "шаннен": 1,
    "шаннон": 1,
    "шау": 1,
    "шеврон": 1,
    "шелби": 1,
    "шелдон": 1,
    "шеллей": 1,
    "шелтон": 1,
    "шем": 1,
    "шервуд": 1,
    "шеридан": 1,
    "шерлок": 1,
    "шерман": 1,
    "ши": 1,
    "шилох": 1,
    "шимус": 1,
    "шмидт": 1,
    "шолто": 1,
    "шон": 1,
    "шэй": 1,
    "шэйн": 1,
    "эбби": 1,
    "эбен": 1,
    "эбенезер": 1,
    "эвальд": 1,
    "эван": 1,
    "эвелин": 1,
    "эверард": 1,
    "эверетт": 1,
    "эверитт": 1,
    "эвот": 1,
    "эгберт": 1,
    "эд": 1,
    "эдан": 1,
    "эдвард": 1,
    "эдвин": 1,
    "эдгар": 1,
    "эдди": 1,
    "эдип": 1,
    "эдисон": 1,
    "эдмонд": 1,
    "эдмунд": 1,
    "эдон": 1,
    "эдуард": 1,
    "эдун": 1,
    "эзраа": 1,
    "эзэлстан": 1,
    "эзэлуолф": 1,
    "эйб": 1,
    "эйби": 1,
    "эйвери": 1,
    "эйден": 1,
    "эйлберт": 1,
    "эйлвард": 1,
    "эймерей": 1,
    "эймери": 1,
    "эйнар": 1,
    "эйнслей": 1,
    "эйнсли": 1,
    "эйс": 1,
    "элайотт": 1,
    "элбан": 1,
    "элвин": 1,
    "элвис": 1,
    "элвуд": 1,
    "элгар": 1,
    "элдвен": 1,
    "элдвин": 1,
    "элден": 1,
    "элджер": 1,
    "элдин": 1,
    "элдис": 1,
    "элдон": 1,
    "элдред": 1,
    "элдус": 1,
    "электрон": 1,
    "эли": 1,
    "элиас": 1,
    "элиджа": 1,
    "элиот": 1,
    "элла": 1,
    "эллгар": 1,
    "эллджер": 1,
    "эллери": 1,
    "эллиот": 1,
    "эллис": 1,
    "элмер": 1,
    "элрик": 1,
    "элрой": 1,
    "элсдон": 1,
    "эль": 1,
    "эльберт": 1,
    "эльбрус": 1,
    "эльдар": 1,
    "эльмар": 1,
    "эльмир": 1,
    "эльтон": 1,
    "эмерсон": 1,
    "эмилиан": 1,
    "эмилий": 1,
    "эмиль": 1,
    "эммануель": 1,
    "эммануил": 1,
    "эммерсон": 1,
    "эммет": 1,
    "эмметт": 1,
    "эмори": 1,
    "эмэри": 1,
    "энвер": 1,
    "энгель": 1,
    "энджелберт": 1,
    "энди": 1,
    "эндрю": 1,
    "энергий": 1,
    "энтони": 1,
    "эразм": 1,
    "эраст": 1,
    "эрван": 1,
    "эрвин": 1,
    "эрг": 1,
    "эрек": 1,
    "эрий": 1,
    "эрик": 1,
    "эрих": 1,
    "эрл": 1,
    "эрлен": 1,
    "эрн": 1,
    "эрнест": 1,
    "эрни": 1,
    "эрнст": 1,
    "эрон": 1,
    "эррол": 1,
    "эрролл": 1,
    "этан": 1,
    "этелберт": 1,
    "этелред": 1,
    "этелрик": 1,
    "этелхард": 1,
    "эшли": 1,
    "эюзби": 1,
    "ювеналий": 1,
    "юджин": 1,
    "юлиан": 1,
    "юлий": 1,
    "юлиус": 1,
    "юм": 1,
    "юниор": 1,
    "юпитер": 1,
    "юрий": 1,
    "юстас": 1,
    "юстин": 1,
    "яков": 1,
    "ян": 1,
    "янкей": 1,
    "янки": 1,
    "януарий": 1,
    "ярвуд": 1,
    "яромир": 1,
    "ярополк": 1,
    "ярослав": 1
  }, exports.ruBindingWords = [ "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "пота", "потому", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "тож", "только", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы", "а-ля", "без", "безо", "благодаря", "близ", "в", "ввиду", "вглубь", "вдоль", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "во", "возле", "вокруг", "вопреки", "впереди", "вразрез", "вроде", "вслед", "вследствие", "для", "до", "за", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "к", "ко", "кроме", "кругом", "меж", "между", "мимо", "на", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду", "насупротив", "насчёт", "не", "ниже", "о", "об", "обо", "обок", "около", "окромя", "округ", "от", "относительно", "ото", "перед", "передо", "по", "по-за", "по-над", "поверх", "под", "подле", "подо", "подобно", "позади", "помимо", "поперёк", "порядка", "посередине", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "применительно", "про", "против", "путём", "ради", "с", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "со", "согласно", "спустя", "среди", "средь", "сродни", "судя", "супротив", "у", "через", "чрез", "иже", "какой-либо", "какой-то", "кое-кто", "кой", "кто", "кто-либо", "многий", "мя", "насколько", "немногий", "нещечко", "никой", "ничегошеньки", "се", "сё", "такой-то", "тот-то", "чё", "чево", "чей-либо", "чей-нибудь", "чей-то", "шо", "эта", "кем", "ком", "кому", "нахуя", "чей", "чему", "вам", "вами", "вас", "вы", "Вы", "ее", "её", "его", "ей", "ему", "ею", "им", "ими", "их", "меня", "мне", "мной", "мною", "мы", "нём", "нем", "нам", "нами", "неё", "него", "ней", "нему", "нею", "ним", "ними", "них", "он", "она", "оне", "они", "оно", "тебе", "тебя", "тобой", "тобою", "ты", "я", "иной", "кое-какой", "кое-чей", "кое-что", "кой-какой", "кой-кто", "кто-нибудь", "кто-то", "куда-нибудь", "некто", "нечто", "что-либо", "что-нибудь", "что-то", "весь", "всякий", "любой", "сам", "самый", "таков", "этакий", "другой", "некем", "некому", "нечего", "нечем", "нечему", "никакой", "никто", "ничего", "ничей", "ничем", "ничему", "ничто", "ваш", "ихний", "моё", "мой", "моя", "наш", "свой", "твой", "оный", "сей", "сие", "сии", "сия", "та", "такой", "тот", "ту", "эдакий", "эти", "это", "этот", "ась", "аюшки", "таки", "а", "авось-либо", "ага", "аминь", "б", "бишь", "буквально", "бы", "было", "вишь", "вон", "вот", "вот-вот", "вряд", "всего", "давай", "де", "действительно", "дескать", "добро", "довольно", "ещё", "исключительно", "ить", "ишь", "ка", "кажется", "конечно", "ладно", "лих", "лучше", "мол", "навряд", "наоборот", "небось", "нет", "неужели", "нехай", "никак", "ну", "ну-с", "по-видимому", "пожалуй", "пожалуйста", "полно", "положительно", "предовольно", "простите", "просто-напросто", "пускай", "разумеется", "сём-ка", "сем", "скорее", "спасибо", "так", "то-то", "тоже", "уж", "уже", "ужели", "ужли", "фон", "хорошо", "эдак", "эк", "этак" ];
}(exports);

var exports, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.words = {}, exports = window.lastName.plugins.ru.words) : exports = module.exports, function(exports) {
  return exports.adverbs = [ "абсолютно", "адски", "азартно", "активно", "аспидно", "баснословно", "бдительно", "безапелляционно", "безбожно", "безвозвратно", "безгранично", "безжалостно", "беззаветно", "беззастенчиво", "безмерно", "безмятежно", "безнадежно", "безоговорочно", "безраздельно", "безропотно", "безудержно", "безукоризненно", "безумно", "безупречно", "безусловно", "безустанно", "безутешно", "бескомпромиссно", "бесконечно", "беспардонно", "бесповоротно", "беспощадно", "беспредельно", "беспрекословно", "бесследно", "бессовестно", "бесстыдно", "бесчеловечно", "бешено", "бурно", "вдребезги", "вконец", "вовсю", "всемерно", "всесторонне", "всецело", "всячески", "высоко", "глубоко", "горько", "горячо", "грубо", "густо", "диаметрально", "дико", "досконально", "досыта", "дотошно", "дьявольски", "жарко", "жгуче", "железно", "жестко", "жестоко", "живо", "жизненно", "жутко", "запоем", "запредельно", "зверски", "здорово", "злостно", "идеально", "излишне", "изрядно", "изумительно", "исключительно", "исступленно", "истово", "истошно", "исчерпывающе", "кардинально", "катастрофически", "категорически", "клятвенно", "колоссально", "крайне", "крепко", "кристально", "кровно", "крупно", "круто", "люто", "максимально", "мертвецки", "мучительно", "навзрыд", "нагло", "наглухо", "наглядно", "наголову", "надежно", "надрывно", "назубок", "намертво", "наотрез", "напрочь", "нарочито", "насквозь", "настоятельно", "насущно", "начисто", "небывало", "невероятно", "невиданно", "невообразимо", "невыносимо", "невыразимо", "недопустимо", "неизмеримо", "неимоверно", "неистово", "немилосердно", "немыслимо", "необыкновенно", "необычайно", "неописуемо", "неопровержимо", "непомерно", "непоправимо", "непостижимо", "непримиримо", "непробудно", "непроходимо", "неразрывно", "несказанно", "неслыханно", "несметно", "несравненно", "нестерпимо", "неудержимо", "неузнаваемо", "неуклонно", "неукоснительно", "неустанно", "неусыпно", "неутешно", "неутомимо", "нещадно", "оглушительно", "ожесточенно", "ослепительно", "основательно", "остро", "откровенно", "открыто", "отлично", "отменно", "отчаянно", "очень", "панически", "патологически", "пламенно", "плотно", "по-настоящему", "по-собачьи", "подлинно", "подчеркнуто", "позарез", "поистине", "полностью", "поразительно", "порядком", "порядочно", "потрясающе", "предельно", "прекрасно", "преступно", "прилично", "примитивно", "принципиально", "приторно", "пронзительно", "радикально", "разительно", "редкостно", "резко", "рекордно", "свято", "серьезно", "сильно", "слепо", "смертельно", "совершенно", "совсем", "страстно", "страшно", "строго", "строго-настрого", "существенно", "твердо", "тяжело", "тяжко", "убийственно", "удивительно", "ужасающе", "ужасно", "фанатически", "фанатично", "фантастически", "феноменально", "хорошенько", "хорошо", "чертовски", "чрезвычайно", "чрезмерно", "чудовищно", "широко", "шумно", "щедро", "ярко", "яростно" ], exports.unions = [ "а", "а именно", "абы", "аж", "ажно", "аки", "али", "аль", "аще", "благо", "будто", "ведь", "всё", "всё-таки", "все-таки", "где", "где-то", "да", "дабы", "даже", "дотоле", "едва", "если", "ж", "же", "зане", "зато", "зачем", "и", "или", "именно", "иначе", "инда", "итак", "как", "как бы", "как то", "как-то", "каков", "какой", "когда", "коли", "коль", "который", "куда", "ли", "либо", "лишь", "ль", "настолько", "нежели", "ни", "но", "однако", "откуда", "поелику", "пока", "покамест", "покаместь", "понеже", "поскольку", "после того как", "пота", "потому", "потому как", "потому что", "почём", "почему", "поэтому", "правда", "притом", "причём", "просто", "пусть", "раз", "разве", "сиречь", "сколько", "следовательно", "словно", "столько", "так как", "также", "теперь", "то", "то есть", "тож", "только", "только что", "хоть", "хотя", "хуле", "чем", "что", "чтоб", "чтобы", "чуть", "яко", "якобы" ], exports.prepositionAll = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо", "включая", "невзирая на", "несмотря на", "по", "по-за", "про", "с", "сквозь", "со", "спустя", "через", "чрез", "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по", "при", "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "среди", "средь", "супротив", "у", "в связи с", "в соответствии с", "вслед за", "лицом к лицу с", "над", "надо", "наряду с", "перед", "передо", "по сравнению с", "по-над", "пред", "предо", "рядом с", "следом за" ], exports.prepositionSimple = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionAcusative = [ "в", "включая", "во", "за", "на", "не в", "не за", "невзирая на", "несмотря на", "о", "об", "обо", "по", "по-за", "под", "подо", "про", "с", "сквозь", "со", "спустя", "через", "чрез" ], exports.prepositionDative = [ "благодаря", "вдоль по", "вопреки", "вслед", "к", "ко", "лицом к", "навстречу", "наперекор", "наперерез", "по", "по направлению к", "по отношению к", "подобно", "применительно к", "смотря по", "согласно", "сродни", "судя по" ], exports.prepositionPrepositional = [ "в", "во", "на", "не в", "о", "об", "обо", "по", "при" ], exports.prepositionGenetive = [ "без", "без ведома", "безо", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в силу", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "взамен", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "впереди", "впредь до", "вроде", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "кроме", "кругом", "меж", "между", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "накануне", "наподобие", "напротив", "насупротив", "насчёт", "начиная с", "не без", "не считая", "недалеко от", "независимо от", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "по линии", "по мере", "по поводу", "по причине", "по случаю", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "прежде", "при помощи", "против", "путём", "ради", "с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "снизу", "со", "среди", "средь", "супротив", "у" ], exports.prepositionInstrumental = [ "в связи с", "в соответствии с", "вслед за", "за", "лицом к лицу с", "меж", "между", "над", "надо", "наряду с", "не за", "перед", "передо", "по сравнению с", "по-над", "под", "подо", "пред", "предо", "рядом с", "с", "следом за", "со" ], exports.prepositionWithSingleCase = [ "без", "без ведома", "безо", "благодаря", "близ", "близко от", "в виде", "в зависимости от", "в качестве", "в лице", "в отличие от", "в отношении", "в преддверии", "в продолжение", "в результате", "в роли", "в связи с", "в силу", "в соответствии с", "в течение", "в целях", "ввиду", "вглубь", "вдоль", "вдоль по", "взамен", "включая", "вместо", "вне", "внизу", "внутри", "внутрь", "возле", "вокруг", "вопреки", "впереди", "впредь до", "вроде", "вслед", "вслед за", "вследствие", "для", "до", "за вычетом", "за исключением", "за счёт", "заместо", "из", "из-за", "из-под", "изнутри", "изо", "исходя из", "к", "ко", "кроме", "кругом", "лицом к", "лицом к лицу с", "мимо", "на виду у", "на глазах у", "на предмет", "наверху", "навстречу", "над", "надо", "накануне", "наперекор", "наперерез", "наподобие", "напротив", "наряду с", "насупротив", "насчёт", "начиная с", "не без", "не считая", "невзирая на", "недалеко от", "независимо от", "несмотря на", "ниже", "обок", "около", "окромя", "округ", "от", "от имени", "от лица", "относительно", "ото", "перед", "передо", "по линии", "по мере", "по направлению к", "по отношению к", "по поводу", "по причине", "по случаю", "по сравнению с", "по-за", "по-над", "поблизости от", "поверх", "под видом", "под эгидой", "подле", "подобно", "позади", "помимо", "поперёк", "после", "посреди", "посредине", "посредством", "пред", "предо", "прежде", "при", "при помощи", "применительно к", "про", "против", "путём", "ради", "рядом с", "с ведома", "с помощью", "с точки зрения", "с целью", "сверх", "свыше", "сзади", "сквозь", "следом за", "смотря по", "снизу", "согласно", "спустя", "среди", "средь", "сродни", "судя по", "супротив", "у", "через", "чрез" ], exports.prepositionWith2Cases = [ "в", "во", "за", "меж", "между", "на", "не в", "не за", "о", "об", "обо", "под", "подо" ], exports.prepositionWith3Cases = [ "по", "с", "со" ];
}(exports);

var exports, ref, util, _base, _base2;

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.dates = {}, exports = window.lastName.plugins.ru.dates, ref = window.lastName.plugins.ru.ref, util = window.lastName.util) : (exports = module.exports, ref = require("./ref"), util = require("../../util")), function(exports, util, ref) {
  var dateObjectToString, extractDates, getRuMonthIndex, getValidDate, packDates, packIntervals, ruMonthInDates;
  return ruMonthInDates = [ "января", "февраля", "марта", "аперля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря" ], dateObjectToString = function(dateObj) {
    var d, m, y, _ref;
    return y = ((_ref = typeof dateObj.y) === "number" || _ref === "string") && dateObj.y || "", m = dateObj.m + 1, m = m > 9 && m || "0" + m, d = dateObj.d > 9 && dateObj.d || "0" + dateObj.d, "" + d + "." + m + "." + y;
  }, getValidDate = function(dateObj) {
    var defaultYear, dt;
    defaultYear = dateObj.y;
    if (void 0 === dateObj.y || dateObj.y < 1970 || dateObj.y > 2038) dateObj.y = 2e3;
    return dt = new Date(Date.UTC(dateObj.y, dateObj.m, dateObj.d)), dt.getMonth() === dateObj.m && dt.getDate() === dateObj.d ? (dateObj.y = defaultYear, dateObj) : null;
  }, getRuMonthIndex = function(str) {
    var m;
    return m = str.toLowerCase().match(/(\s|^)(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s|$)/g), m ? ruMonthInDates.indexOf(m[0].replace(/\s/g, "")) : -1;
  }, exports.extractDates = extractDates = function(strArr) {
    var dates, intervals, sources;
    return dates = {}, sources = [], intervals = {}, strArr instanceof Array || (strArr = [ strArr ]), strArr.map(function(str) {
      var dStr, date, found, from, fromDate, fromMonth, fromYear, id, intObject, mIndex, sourceStr, to, toDate, toYear, verboseMatch, wordsArr, _ref, _results;
      verboseMatch = str.match(/\s+\d{1,2}\s+((января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)\s+|)(\d{2,4}(\s+года|)\s+|)по\s+\d{1,2}\s+(января|февраля|марта|апреля|мая|июня|июля|августа|сентября|октября|ноября|декабря)(\s+\d{2,4}|)(\s+|$)/mig);
      if (!verboseMatch) {
        wordsArr = str.split(" "), found = !1, _results = [];
        while (wordsArr.length > 2 && !found) /^\d[\d]$/.test(wordsArr[0]) && (mIndex = ruMonthInDates.indexOf(wordsArr[1].toLowerCase()), mIndex >= 0 ? (date = {
          d: parseInt(wordsArr[0], 10),
          m: mIndex
        }, /^\d{2,4}$/.test(wordsArr[2]) ? (date.y = parseInt(wordsArr[2], 10), sourceStr = wordsArr.slice(0, 3).join(" ")) : sourceStr = wordsArr.slice(0, 2).join(" ")) : /^\d\d\.\d\d.\d{2,4}$/.test(wordsArr[0] || /^\d\d\.\d\d$/.test(wordsArr[0])) ? (date = {
          d: parseInt(wordsArr[0].slice(0, 3), 10),
          m: parseInt(wordsArr[0].slice(3, 6), 10),
          y: parseInt(wordsArr[0].slice(6), 10) || void 0
        }, sourceStr = wordsArr[0]) : date = {}, date = getValidDate(date), date && (found = !0, sources.push(sourceStr), dStr = dateObjectToString(date), dates[dStr] ? dates[dStr].count++ : dates[dStr] = {
          count: 1,
          value: date
        })), _results.push(wordsArr.shift());
        return _results;
      }
      _ref = verboseMatch[0].toLowerCase().split("по"), from = _ref[0], to = _ref[1], toYear = to.replace(/\d{1,2}/, "").match(/\d+/g), toYear ? toYear = parseInt(toYear[0], 10) : toYear = void 0, toDate = {
        d: parseInt(to.match(/\d{1,2}/g)[0], 10),
        m: getRuMonthIndex(to),
        y: toYear
      }, fromYear = from.replace(/\d{1,2}/, "").match(/\d+/g), fromMonth = getRuMonthIndex(from), fromYear ? fromYear = parseInt(fromYear[0], 10) : fromYear = toYear, fromMonth === -1 && (fromMonth = toDate.m), fromDate = {
        d: parseInt(from.match(/\d{1,2}/g)[0], 10),
        m: fromMonth,
        y: fromYear
      }, toDate = getValidDate(toDate), fromDate = getValidDate(fromDate);
      if (toDate && fromDate) return intObject = {
        from: dateObjectToString(fromDate),
        from_value: fromDate,
        to: dateObjectToString(toDate),
        to_value: toDate
      }, id = "" + intObject.from + "-" + intObject.to, intervals[id] ? intervals[id].count++ : (intObject.count = 1, intervals[id] = intObject), sources.push(verboseMatch[0]);
    }), {
      dates: dates,
      sources: sources,
      intervals: intervals
    };
  }, exports.packDates = packDates = function(dates, defaultYear) {
    var dateObj, id, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in dates) dateObj = dates[id], "undefined" != typeof dateObj.value.y && years.push(dateObj.value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in dates) dateObj = dates[id], "undefined" == typeof dateObj.value.y && (dateObj.value.y = defaultYear), out["" + dateObjectToString(dateObj.value)] = dateObj.count;
    return out;
  }, exports.packIntervals = packIntervals = function(intervals, defaultYear) {
    var id, interval, out, years;
    defaultYear == null && (defaultYear = null), out = {};
    if (defaultYear === null) {
      years = [];
      for (id in intervals) interval = intervals[id], "undefined" != typeof interval.from_value.y && years.push(interval.from_value.y), "undefined" != typeof interval.to_value.y && years.push(interval.to_value.y);
      years = util.unique(years.sort()), years.length > 1 ? defaultYear = "????[" + years.join(",") + "]" : years.length === 1 ? defaultYear = years[0] : defaultYear = "????";
    }
    for (id in intervals) interval = intervals[id], "undefined" == typeof interval.from_value.y && (interval.from_value.y = defaultYear), "undefined" == typeof interval.to_value.y && (interval.to_value.y = defaultYear), out["" + dateObjectToString(interval.from_value) + "-" + dateObjectToString(interval.to_value)] = interval.count;
    return out;
  }, exports.preFilter = function(text, result) {
    var dates, numRe;
    numRe = /((([а-яё]+)\s+){0,1}\d[\.\d]{0,}(\s+(([a-яё]+)|([\.\d]+))){1,6})|([12]\d\d\d)/mig, dates = extractDates(util.unique(text.match(numRe) || [])), util.dictKeys(dates.dates).length > 0 && (result.dates = packDates(dates.dates)), util.dictKeys(dates.intervals).length > 0 && (result.intervals = packIntervals(dates.intervals));
    if (dates.sources.length > 0) return result.date_sources = dates.sources;
  };
}(exports, util, ref);

var exports, ref, util, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.inclines = {}, exports = window.lastName.plugins.ru.inclines, util = window.lastName.util, ref = window.lastName.plugins.ru.ref) : (exports = module.exports, util = require("../../util"), ref = require("./ref")), function(exports, util, ref) {
  var cases, doInclineFemaleName, doInclineMaleName, findProperName, genderMatch, getNominative, inclineAndGetResult, inclineFemMiddleName, inclineFemaleName, inclineFemaleNameAndGetResult, inclineFemaleSurname, inclineMaleMiddleName, inclineMaleName, inclineMaleNameAndGetResult, inclineMaleSurname, inclineMiddleName, inclineMiddleNameOrSurname, inclineName, inclinePersonSurname, inclineSurname, matchCase, matchNameAndSurname, matchNameParts;
  return cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ], exports.doInclineFemaleName = doInclineFemaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, aUnstressedRe, name2;
    return aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, aUnstressedRe = /ца$/g, name2 = name.slice(0, -1), aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aUnstressedRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ей", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /ия$/g.test(name) && name.length > 3 ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "и" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "и", "" + name2 + "и", "" + name2 + "ь", "" + name2 + "ью", "" + name2 + "и" ] : /[жшщцч]$/g.test(name) ? [ "" + name, "" + name + "и", "" + name + "и", "" + name, "" + name + "ью", "" + name + "и" ] : [ name, name, name, name, name, name ];
  }, exports.doInclineMaleName = doInclineMaleName = function(name) {
    var aAfterHissingAndOthersRe, aNotAfterHissingAndOthersRe, hardConsonants, hissingAndChe, ishortRe, name2;
    return hardConsonants = /[бвгдзклмнпрстфх]$/g, hissingAndChe = /[жшщцч]$/g, ishortRe = /((ай)|(ей)|(ой)|(уй)|(яй)|(юй)|(ий))$/g, aNotAfterHissingAndOthersRe = /[^жшщцгкхч]а$/g, aAfterHissingAndOthersRe = /[жшщцгкхч]а$/g, name2 = name.slice(0, -1), name === "Лев" ? [ "Лев", "Льва", "Льву", "Льва", "Львом", "Льве" ] : name === "Павел" ? [ "Павел", "Павла", "Павлу", "Павла", "Павлом", "Павле" ] : /и$/g.test(name) ? [ name, name, name, name, name, name ] : hissingAndChe.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ем", "" + name + "е" ] : hardConsonants.test(name) ? [ name, "" + name + "а", "" + name + "у", "" + name + "а", "" + name + "ом", "" + name + "е" ] : /ь$/g.test(name) ? [ "" + name2 + "ь", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : ishortRe.test(name) ? [ "" + name2 + "й", "" + name2 + "я", "" + name2 + "ю", "" + name2 + "я", "" + name2 + "ем", "" + name2 + "е" ] : aNotAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : aAfterHissingAndOthersRe.test(name) ? [ "" + name2 + "а", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /я$/g.test(name) ? [ "" + name2 + "я", "" + name2 + "и", "" + name2 + "е", "" + name2 + "ю", "" + name2 + "ей", "" + name2 + "е" ] : /ко$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "и", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : /о$/g.test(name) ? [ "" + name2 + "о", "" + name2 + "ы", "" + name2 + "е", "" + name2 + "у", "" + name2 + "ой", "" + name2 + "е" ] : null;
  }, inclineAndGetResult = function(fn, args) {
    var i, name, r;
    r = null;
    for (i in args) {
      name = args[i], r = fn(name, !0);
      if (r.found) break;
    }
    return r;
  }, inclineFemaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineFemaleName, arguments);
  }, inclineMaleNameAndGetResult = function() {
    return inclineAndGetResult(inclineMaleName, arguments);
  }, exports.inclineFemaleName = inclineFemaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name3, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), nl = name.toLowerCase(), nominativeRe = /[адежзийклмнорстуьэя]$/g, canInclineRe = /[жшщцчаяь]$/g, genitiveRe = /[иы]$/g, dativeRe = /[еи]$/g, accusativeRe = /[жшщцчьую]$/g, instrumentalRe = /((ой)|(ей)|(еи)|(ью))$/g, prepositionalRe = /[еи]$/g, result = r = null, nominativeRe.test(nl) && ref.ruFemaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineFemaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "female",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name2 = name.slice(0, -1), name_cases = [], genitiveRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("dative"))), prepositionalRe.test(nl) && (r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а", "" + name2 + "ь", "" + name2), r && r.found && (result = r, name_cases.push("prepositional"))), accusativeRe.test(nl) && (/[ую]$/g.test(nl) ? r = inclineFemaleNameAndGetResult("" + name2 + "я", "" + name2 + "а") : r = inclineFemaleNameAndGetResult(name), r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (name3 = name.slice(0, -2), r = inclineFemaleNameAndGetResult("" + name3 + "я", "" + name3 + "а", "" + name3 + "ь", "" + name3), r && r.found && (result = r, name_cases.push("instrumental"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineMaleName = inclineMaleName = function(name, nominativeOnly) {
    var accusativeRe, canInclineRe, dativeRe, genitiveRe, instrumentalRe, name2, name_cases, nl, nominativeRe, possible_cases, prepositionalRe, r, result;
    return nominativeOnly == null && (nominativeOnly = !1), name === "Льв" && (name = "Лев"), name === "Павл" && (name = "Павел"), nl = name.toLowerCase(), nominativeRe = /([вгдзклмнпрстфхжшцьй]|(ба)|(ва)|(да)|(за)|(ла)|(ма)|(на)|(па)|(ра)|(са)|(та)|(фа)|(га)|(ка)|(ха)|(жа)|(ша)|(ща)|(ца)|(ча)|(я)|(ло)|(ко))$/g, canInclineRe = /([бвгдзклмнпрстфхжшцьая]|(ия)|(ья)|(ея)|(ий)|(ей))$/g, genitiveRe = /[аяыи]$/g, dativeRe = /(([еую])|(ии))$/g, accusativeRe = /[аяую]$/g, instrumentalRe = /((ом)|(ем)|(ой)|(ей)|(ёй))$/g, prepositionalRe = /((е)|(ии))$/g, name2 = name.slice(0, -1), result = r = null, nominativeRe.test(nl) && ref.ruMaleNamesDict[nl] ? (canInclineRe.test(nl) ? (name_cases = doInclineMaleName(name), possible_cases = [ "nominative" ]) : (name_cases = [ name, name, name, name, name, name ], possible_cases = [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ]), {
      found: !0,
      gender: "male",
      src: name,
      cases: name_cases,
      guess_case: "nominative",
      nominative: name,
      possible_cases: possible_cases
    }) : nominativeOnly ? {
      found: !1,
      src: name
    } : (name_cases = [], genitiveRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /ы$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "о", "" + name2 + "а") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "а", "" + name.slice(0, -1) + "я", "" + name.slice(0, -1) + "о") : r = null, r && r.found && (result = r, name_cases.push("genitive"))), dativeRe.test(nl) && (/у$/g.test(nl) ? r = inclineMaleName(name2) : /[аеиоуя]ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "й") : /ю$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "ь") : /е$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "и", "" + name2 + "я", "" + name2 + "o") : /ии$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я") : r = null, r && r.found && (result = r, name_cases.push("dative"))), accusativeRe.test(nl) && (/[а]$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2) : /[аеуоия]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "й") : /[бвдзмнпрлс]я$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -1) + "ь") : /у$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а") : /[ую]$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : r = null, r && r.found && (result = r, name_cases.push("accusative"))), instrumentalRe.test(nl) && (/ом$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2)) : /ем$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2), "" + name.slice(0, -2) + "ь", "" + name.slice(0, -2) + "й") : /ой$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "а", "" + name.slice(0, -2) + "о") : /((ей)|(ёй))$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name.slice(0, -2) + "я", "" + name.slice(0, -2) + "а") : r = null, r && r.found && (result = r, name_cases.push("instrumental"))), prepositionalRe.test(nl) && (/е$/g.test(nl) ? r = inclineMaleNameAndGetResult(name2, "" + name2 + "ь", "" + name2 + "й", "" + name2 + "а", "" + name2 + "я", "" + name2 + "о") : /и$/g.test(nl) ? r = inclineMaleNameAndGetResult("" + name2 + "я", "" + name2 + "й") : r = null, r && r.found && (result = r, name_cases.push("prepositional"))), result || (result = r || {
      found: !1
    }), result.src = name, result.possible_cases = name_cases, result.guess_case = name_cases[0], result);
  }, exports.inclineName = inclineName = function(name) {
    var fn, mn, result;
    return fn = inclineFemaleName(name), mn = inclineMaleName(name), fn.found ? result = {
      found: !0,
      src: name,
      gender: "female",
      guess_case: fn.guess_case,
      female_cases: fn.cases,
      possible_cases: fn.possible_cases,
      nominative: fn.nominative
    } : mn.found ? result = {
      found: !0,
      src: name,
      gender: "male",
      guess_case: mn.guess_case,
      male_cases: mn.cases,
      possible_cases: mn.possible_cases,
      nominative: mn.nominative
    } : fn.possible_yes && mn.possible_yes ? (result = {
      found: "maybe",
      src: name,
      gender: [ "male", "female" ],
      female_cases: fn.cases,
      male_cases: mn.cases,
      possible_cases: util.merge(fn.possible_cases, mn.possible_cases)
    }, result.guess_case = fn.guess_case_index <= mn.guess_case_index ? fn.guess_case : mn.guess_case) : fn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "female",
      female_cases: fn.cases,
      guess_case: fn.cases,
      possible_cases: fn.possible_cases
    } : mn.possible_yes ? result = {
      found: "maybe",
      src: name,
      gender: "male",
      male_cases: mn.cases,
      guess_case: mn.cases,
      possible_cases: mn.possible_cases
    } : result = {
      found: !1,
      src: name
    }, result;
  }, inclineSurname = function(surname, noInclinesRe, inclineRe, casesRe) {
    var c, cases_index, check, i, result, surname_cases, _i, _j, _len, _len2;
    result = {
      found: null,
      src: surname,
      cases: null,
      cases_index: null
    };
    if (noInclinesRe && noInclinesRe.test(surname)) result = {
      found: surname,
      src: surname,
      cases: [ "nominative", "genitive", "dative", "accusative", "instrumental", "prepositional" ],
      cases_index: [ 0, 1, 2, 3, 4, 5 ]
    }; else for (_i = 0, _len = inclineRe.length; _i < _len; _i++) {
      check = inclineRe[_i];
      if (check[0].test(surname)) {
        result = {
          found: surname.replace(check[0], check[1]),
          src: surname
        }, cases_index = [], surname_cases = [], i = 0;
        for (_j = 0, _len2 = casesRe.length; _j < _len2; _j++) c = casesRe[_j], c.test(surname) && (cases_index.push(i), surname_cases.push(cases[i])), i++;
        surname_cases.length === 0 ? (result.found = null, result.cases = null) : result.cases = surname_cases, result.cases_index = cases_index;
        break;
      }
    }
    return result.surname_cases && (result.guess_case = result.surname_cases[0]), result;
  }, exports.inclineFemaleSurname = inclineFemaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(е)|(о)|(э)|(и)|(ы)|(^[нв]у)|(^ую)|(уа)|(иа)|(ман)|(вич)|(ян))$/g, inclineRe = [ [ /((ова)|(овой)|(ову))$/g, "ова" ], [ /((ева)|(евой)|(еву))$/g, "ева" ], [ /((ёва)|(ёвой)|(ёву))$/g, "ёва" ], [ /((ина)|(иной)|(ину))$/g, "ина" ], [ /((ая)|(ой)|(ую))$/g, "ая" ] ], casesRe = [ /((ова)|(ева)|(ёва)|(ина)|(ая))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((ову)|(еву)|(ёву)|(ину)|(ую))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g, /((овой)|(евой)|(ёвой)|(иной)|(ой))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, exports.inclineMaleSurname = inclineMaleSurname = function(surname) {
    var casesRe, inclineRe, noInclinesRe;
    return noInclinesRe = /((их)|(ых)|(^ве)|(^го)|(э)|(и)|(ы)|(^му)|(ю)|(уа)|(иа))$/g, inclineRe = [ [ /((ов)|(ова)|(ову)|(овым)|(ове))$/g, "ов" ], [ /((ев)|(ева)|(еву)|(евым)|(еве))$/g, "ев" ], [ /((ёв)|(ёва)|(ёву)|(ёвым)|(ёве))$/g, "ёв" ], [ /((ин)|(ина)|(ину)|(иным)|(ине))$/g, "ин" ], [ /((ский)|(ского)|(скому)|(ским)|(ском))$/g, "ский" ], [ /((ской)|(ского)|(скому)|(ским)|(ском))$/g, "ской" ], [ /((ман)|(мана)|(ману)|(маном)|(мане))$/g, "ман" ], [ /((ой)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ой" ], [ /((ий)|(ого)|(ому)|(ого)|(им)|(ом))$/g, "ий" ], [ /((ый)|(ого)|(ому)|(ого)|(ым)|(ом))$/g, "ый" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ], [ /((ян)|(яна)|(яну)|(яна)|(яном)|(яне))$/g, "ян" ] ], casesRe = [ /((ов)|(ев)|(ёв)|(ин)|(ский)|(ской)|(ой)|(ий)|(ый)|(ман)|(ич)|(ян))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((ову)|(еву)|(ёву)|(ину)|(скому)|(ому)|(ману)|(ичу)|(яну))$/g, /((ова)|(ева)|(ёва)|(ина)|(ского)|(ого)|(мана)|(ича)|(яна))$/g, /((овым)|(евым)|(ёвым)|(иным)|(ским)|(им)|(ым)|(маном)|(ичем)|(яном))$/g, /((ове)|(еве)|(ёве)|(ине)|(ском)|(ом)|(мане)|(иче)|(яне))$/g ], inclineSurname(surname, noInclinesRe, inclineRe, casesRe);
  }, inclineMiddleNameOrSurname = function(src, fem, male) {
    var result, _ref;
    return fem.found === (_ref = male.found) && _ref === null ? result = {
      found: !1,
      src: src,
      value: null,
      gender: null
    } : fem.found && male.found ? (result = {
      found: !0,
      src: src,
      gender: [ "male", "female" ]
    }, result.nominative_male = male.found, result.nominative_female = fem.found, result.female_cases = fem.cases, result.male_cases = male.cases, fem.cases.length === 6 ? male.cases.length === 6 ? (result.guess_sex = "unknown", result.possible_cases = util.merge(fem.cases, male.cases)) : (result.guess_sex = "male", result.nominative = male.found, result.possible_cases = male.cases) : fem.cases.length === 1 && male.cases.length > 1 ? (result.guess_sex = "female", result.nominative = fem.found, result.possible_cases = fem.cases) : result.possible_cases = util.merge(fem.cases, male.cases)) : fem.found ? male.found || (result = {
      found: !0,
      src: src,
      gender: "female",
      female_cases: fem.cases,
      guess_case: fem.guess_case,
      nominative: fem.found,
      possible_cases: fem.cases
    }) : result = {
      found: !0,
      src: src,
      gender: "male",
      male_cases: male.cases,
      guess_case: male.guess_case,
      nominative: male.found,
      possible_cases: male.cases
    }, result;
  }, exports.inclineSurname = inclinePersonSurname = function(surname) {
    return inclineMiddleNameOrSurname(surname, inclineFemaleSurname(surname), inclineMaleSurname(surname));
  }, exports.inclineMaleMiddleName = inclineMaleMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((евич)|(евича)|(евичу)|(евича)|(евичем)|(евиче))$/g, "евич" ], [ /((ович)|(овича)|(овичу)|(овича)|(овичем)|(овиче))$/g, "ович" ], [ /((ич)|(ича)|(ичу)|(ича)|(ичем)|(иче))$/g, "ич" ] ], casesRe = [ /((евич)|(ович)|(ич))$/g, /((евича)|(овича)|(ича))$/g, /((евичу)|(овичу)|(ичу))$/g, /((евича)|(овича)|(ича))$/g, /((евичем)|(овичем)|(ичем))$/g, /((евиче)|(овиче)|(иче))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineFemMiddleName = inclineFemMiddleName = function(mname) {
    var casesRe, inclineRe;
    return inclineRe = [ [ /((вна)|(вны)|(вне)|(вну)|(вной)|(вне))$/g, "вна" ], [ /((чна)|(чны)|(чне)|(чну)|(чной)|(чне))$/g, "чна" ] ], casesRe = [ /((вна)|(чна))$/g, /((вны)|(чны))$/g, /((вне)|(чне))$/g, /((вну)|(чну))$/g, /((вной)|(чной))$/g, /((вне)|(чне))$/g ], inclineSurname(mname, null, inclineRe, casesRe);
  }, exports.inclineMiddleName = inclineMiddleName = function(mname) {
    return inclineMiddleNameOrSurname(mname, inclineFemMiddleName(mname), inclineMaleMiddleName(mname));
  }, genderMatch = function(g1, g2) {
    return g1 === g2 || __indexOf.call(g2, g1) >= 0 ? g1 : __indexOf.call(g1, g2) >= 0 ? g2 : null;
  }, matchNameParts = function(fn, mn, sn) {
    var overallGender, surname, theCase;
    return theCase = util.intersection(fn.possible_cases, mn.possible_cases), overallGender = genderMatch(genderMatch(fn.gender, mn.gender), sn.gender), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: mn.nominative,
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchNameAndSurname = function(fn, sn) {
    var overallGender, surname, theCase;
    return overallGender = genderMatch(fn.gender, sn.gender), theCase = util.intersection(fn.possible_cases, sn.possible_cases), theCase || (sn.possible_cases = sn["" + overallGender + "_cases"], sn.nominative = sn["nominative_" + overallGender], theCase = util.intersection(fn.possible_cases, sn.possible_cases)), overallGender && __indexOf.call(sn.possible_cases, theCase) >= 0 || __indexOf.call(sn["" + overallGender + "_cases"], theCase) >= 0 ? (surname = sn.nominative || sn["nominative_" + overallGender], {
      first_name: fn.nominative,
      middle_name: "",
      surname: surname,
      gender: overallGender,
      found: !0,
      "case": theCase
    }) : {
      found: !1
    };
  }, matchCase = function(pObj, target_case, gender) {
    return __indexOf.call(pObj["" + gender + "_cases"], target_case) >= 0;
  }, getNominative = function(pObj, gender) {
    var gnstr, nom;
    return gnstr = "nominative_" + gender, nom = pObj.nominative && pObj.nominative || pObj[gnstr], nom;
  }, exports.findProperName = findProperName = function(listOfWords, opts) {
    var mnr2, mnr3, nr1, nr2, nr3, result, sr1, sr2, sr3;
    opts == null && (opts = {}), result = {
      found: !1
    };
    switch (listOfWords.length) {
     case 1:
      result = inclineName(listOfWords[0]), result.found ? result.first_name = result.nominative : (result = inclinePersonSurname(listOfWords[0]), result.found && (result.surname = result.nominative));
      break;
     case 2:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr1.found && sr2.found && (result = matchNameAndSurname(nr1, sr2)), !result.found && sr1.found && nr2.found && (result = matchNameAndSurname(sr1, nr2));
      break;
     case 3:
      sr1 = inclinePersonSurname(listOfWords[0]), sr2 = inclinePersonSurname(listOfWords[1]), sr3 = inclinePersonSurname(listOfWords[2]), mnr2 = inclineMiddleName(listOfWords[1]), mnr3 = inclineMiddleName(listOfWords[2]), nr1 = inclineName(listOfWords[0]), nr2 = inclineName(listOfWords[1]), nr3 = inclineName(listOfWords[2]), nr3.found ? result = {
        found: !1,
        error: "name at the end of 3-component proper name"
      } : nr1.found ? (mnr2.found && sr3.found && (result = matchNameParts(nr1, mnr2, sr3)), !result.found && sr2.found && (result = matchNameAndSurname(nr1, sr2))) : sr1.found && nr2.found && mnr3.found ? result = matchNameParts(nr2, mnr3, sr1) : nr2.found && sr3.found && (result = matchNameAndSurname(nr2, sr3));
    }
    return result.first_name || (result.first_name = ""), result.middle_name || (result.middle_name = ""), result.surname || (result.surname = ""), result.first_name || result.middle_name || result.surname || (result = {
      found: !1,
      error: "person not found"
    }), result.src = listOfWords.join(" "), result;
  }, exports.getInitialFormOfAdjective = function(adj) {
    var base;
    return adj = adj.toLowerCase(), /^[а-яё]{2,}(ая|ее|ие|ий|им|ими|их|ого|его|ое|ой|ом|ому|ою|ую|ые|ый|ым|ыми|ых|юю|яя)$/.test(adj) ? (/^[а-яё]{2,}(ими|ого|его|ому|ыми)$/gi.test(adj) ? base = adj.slice(0, -3) : base = adj.slice(0, -2), [ "" + base + "ый", "" + base + "ий", "" + base + "ой" ]) : null;
  }, exports.getVerbInfinitive = function(verb) {
    var pastTime, result, verbEnd;
    return verb = verb.toLowerCase(), /^[а-яё]{3,}(ать|аться|ить|иться|еть|еться|оть|оться|уть|утся|ются|ть|ться)$/.test(verb) ? verb : (/^[а-яё]{3,}(сь|ся)$/.test(verb) ? (verbEnd = verb.slice(-2), verb = verb.slice(0, -2)) : verbEnd = "", pastTime = verb.match(/^[а-яё]{3,}(л|ла|ло|ли)$/), pastTime ? result = verb.slice(0, -(1 + pastTime[1].length) + 1 || 9e9) + "ть" : /[а-яё]{3,}(у|ю|ем|ешь|ете|ет|ут|ют|им|ишь|ите|ит|ат|ят)$/.test(verb) && (/[а-яё]{3,}(ишь|ит|им|ите|ат|ят)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd ] : /[а-яё]{3,}(у|ю|ешь|ет|ем|ете|ут|ют)$/.test(verb) ? result = [ "" + verb + "ить" + verbEnd, "" + verb + "ать" + verbEnd, "" + verb + "еть" + verbEnd, "" + verb + "оть" + verbEnd, "" + verb + "уть" + verbEnd, "" + verb + "ть" + verbEnd ] : result = null), result);
  };
}(exports, util, ref);

var exports, ruWords, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.morpho = {}, exports = window.lastName.plugins.ru.morpho, ruWords = window.lastName.plugins.ru.words) : (exports = module.exports, ruWords = require("./words")), function(exports, ruWords) {
  var exceptions, getRulesAdjective, getRulesVerb, morphoRu;
  return exports.getWordRe = function() {
    return /^[а-я\-ё\d]+$/ig;
  }, exports.getAdjectiveEnds = function() {
    return {
      feminine: {
        ends: /((ая)|(ой)|(ую)|(яя)|(ей)|(юю))$/g,
        hard: /((ая)|(ой)|(ую))$/g,
        sort: /((яя)|(ей)|(юю))$/g,
        hardNominativeEnd: "ая",
        softNominativeEnd: "яя",
        gender: "feminine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ая" ? [ "" + word + "ая", "" + word + "ой", "" + word + "ой", "" + word + "ую", "" + word + "ой", "" + word + "ой" ] : [ "" + word + "яя", "" + word + "ей", "" + word + "ей", "" + word + "юю", "" + word + "ей", "" + word + "ей" ];
        }
      },
      masculine: {
        ends: /((ый)|(ого)|(ому)|(ым)|(ом)|(ий)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ый)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ий)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ый",
        softNominativeEnd: "ий",
        gender: "masculine",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ый" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ий", "" + word + "ого", "" + word + "ому", "" + word + "ий", "" + word + "им", "" + word + "ом" ] : [ "" + word + "ый", "" + word + "ого", "" + word + "ому", "" + word + "ый", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ий", "" + word + "его", "" + word + "ему", "" + word + "ий", "" + word + "им", "" + word + "ем" ];
        }
      },
      neuter: {
        ends: /((ое)|(ого)|(ому)|(ым)|(ом)|(ее)|(его)|(ему)|(им)|(ем))$/g,
        hard: /((ое)|(ого)|(ому)|(ым)|(ом))$/g,
        soft: /((ее)|(его)|(ему)|(им)|(ем))$/g,
        hardNominativeEnd: "ое",
        softNominativeEnd: "ее",
        gender: "neuter",
        singular: !0,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ое" ? [ "" + word + "ое", "" + word + "ого", "" + word + "ому", "" + word + "ое", "" + word + "ым", "" + word + "ом" ] : [ "" + word + "ее", "" + word + "его", "" + word + "ему", "" + word + "ее", "" + word + "им", "" + word + "ем" ];
        }
      },
      plural: {
        ends: /((ые)|(ых)|(ым)|(ыми)|(ых)|(ие)|(их)|(им)|(ими)|(их))$/g,
        hard: /((ые)|(ых)|(ым)|(ыми)|(ых))$/g,
        soft: /((ие)|(их)|(им)|(ими)|(их))$/g,
        hardNominativeEnd: "ые",
        softNominativeEnd: "ие",
        gender: "unknown",
        singular: !1,
        incline: function(word) {
          var end;
          return end = word.slice(-2), word = word.slice(0, -2), end === "ые" ? /[жшцчщгкх]$/.test(word) ? [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ] : [ "" + word + "ые", "" + word + "ых", "" + word + "ым", "" + word + "ые", "" + word + "ыми", "" + word + "ых" ] : [ "" + word + "ие", "" + word + "их", "" + word + "им", "" + word + "ие", "" + word + "ими", "" + word + "их" ];
        }
      }
    };
  }, exceptions = function(word) {}, getRulesVerb = function() {
    return [ [ /нул[aи]{0,1}$/g, "ать" ], [ /еть$/g, "ать" ], [ /(ает)|(ают)$/g, "ать" ], [ /ал[aи]{0,1}$/g, "ать" ], [ /ул[aи]{0,1}$/g, "ать" ], [ /((ить)|(ать))$/g, "ать" ], [ /ая$/g, "ать" ], [ /((ил)|(или)|(ила)|(ило))$/g, "лять" ], [ /(ятся)|(ится)|(ился)|(илась)|(илось)$/g, "ится" ], [ /(яться)|(иться)$/g, "иться" ] ];
  }, getRulesAdjective = function() {
    return [ [ /в((ая)|(ые)|(ый)|(ое))$/, "вый" ], [ /((ая)|(ой)|(ие)|(ые)|(ый)|(ую))$/, "ый" ], [ /((яя)|(ее)|(ий)|(юю))$/, "ий" ] ];
  }, exports.morpho = morphoRu = function(word) {
    var adj, adjective, result, rule, verb, _i, _j, _len, _len2, _ref, _ref2;
    if (__indexOf.call(ruWords.adverbs, word) >= 0) return {
      type: "abverb",
      value: word
    };
    if (__indexOf.call(ruWords.prepositionAll, word) >= 0) return {
      type: "preposition",
      value: word
    };
    if (__indexOf.call(ruWords.unions, word) >= 0) return {
      type: "union",
      value: word
    };
    result = {
      type: "",
      value: ""
    }, verb = null, adjective = null, _ref = getRulesVerb();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      rule = _ref[_i];
      if (rule[0].test(word)) {
        result = {
          type: verb,
          value: word.replace(rule[0], rule[1])
        };
        break;
      }
    }
    _ref2 = getRulesAdjective();
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      rule = _ref2[_j];
      if (rule[0].test(word)) {
        adj = word.replace(rule[0], rule[1]), result.type ? (result.type += " adjective", result.value = [ result.value, adj ]) : result = {
          type: "adjective",
          value: adj
        };
        break;
      }
    }
    return result;
  }, exports.analyseText = function(text) {
    var doubleSpaceRe, enRe, punctuationRe, r, result, ruRe, t, wordRe, _i, _len, _ref;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&№“”\—]/g, doubleSpaceRe = /\s+/g, text = text.replace(punctuationRe, " $& ").replace(doubleSpaceRe, " ") + " .", result = [], _ref = text.split(" ");
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      t = _ref[_i], ruRe = /^[а-я\-ё]+$/ig, enRe = /^[a-z\-]+$/ig, wordRe = /^[а-яё\-\da-z]+$/ig, r = morphoRu(t.toLowerCase());
      switch (r.type) {
       case "adverb":
        result.push("[ADV " + t + "]");
        break;
       case "verb":
       case "adjective":
        result.push("[ " + r.value + " ]");
        break;
       case "verb adjective":
        result.push("[#VA " + r.value[0] + "]");
        break;
       case "union":
        result.push("[U " + t + "]");
        break;
       case "preposition":
        result.push("[PP " + t + "]");
        break;
       default:
        result.push(t);
      }
      t === "." && result.push("\n");
    }
    return result;
  }, exports.parseRuSentence = function(sentences) {
    var abbrevs, common_used_words, digits, regular_words, special_words, total_words;
    return sentences instanceof Array || (sentences = [ sentences ]), abbrevs = {}, special_words = {}, digits = {}, common_used_words = {}, regular_words = {}, total_words = 0, sentences.map(function(sent) {
      var i, result, w, word, words, _len, _ref, _results;
      words = sent.split(" "), _results = [];
      for (i = 0, _len = words.length; i < _len; i++) word = words[i], /^[[,:\/\\\?!\+\-\*\(\)\[\]\&\№\—]]+$/.test(words) || total_words++, /^(\d+(|(\.(|\d+))))$/.test(word) ? digits[word] ? _results.push(digits[word]++) : _results.push(digits[word] = 1) : isUpperCase(word) && /^[а-яё\-]{2,}$/i.test(word) ? abbrevs[word] ? _results.push(abbrevs[word]++) : _results.push(abbrevs[word] = 1) : i > 0 && isCapitalized(word) && /^[а-яё\-]{2,}$/i.test(word) ? special_words[word] ? _results.push(special_words[word]++) : _results.push(special_words[word] = 1) : /^[а-яё\-]+$/i.test(word) && !/^\-+$/.test(word) ? (w = word.toLowerCase(), result = morphoRu(w), (_ref = result.type) !== "adverb" && _ref !== "preposition" && _ref !== "union" ? regular_words[w] ? _results.push(regular_words[w]++) : _results.push(regular_words[w] = 1) : common_used_words[w] ? _results.push(common_used_words[w]++) : _results.push(common_used_words[w] = 1)) : _results.push(void 0);
      return _results;
    }), {
      abbrevs: abbrevs,
      common_used_words: common_used_words,
      special_words: special_words,
      regular_words: regular_words,
      digits: digits,
      total_words: total_words
    };
  };
}(exports, ruWords);

var exports, inclines, morpho, _base, _base2, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName || (window.lastName = {}), (_base = window.lastName).plugins || (_base.plugins = {}), (_base2 = window.lastName.plugins).ru || (_base2.ru = {}), window.lastName.plugins.ru.propernames = {}, exports = window.lastName.plugins.ru.propernames, morpho = window.lastName.plugins.ru.morpho, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, morpho = require("./morpho"), inclines = require("./inclines")), function(exports, morpho, inclines) {
  return exports.postFilter = function(text, result) {
    var curProperName, id, p, pn, pnDict, properNames, properNamesRe, punctuationRe, _i, _j, _len, _len2, _ref, _ref2;
    punctuationRe = /[\.,:\/\\\?!\+\'\"«»\*\(\)\[\]\&\№“”\—]/g, properNames = [], curProperName = [], properNamesRe = /[А-Я][а-яё]+(\s+[А-Я][а-яё]+){0,2}/gm, _ref = text.match(properNamesRe);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) pn = _ref[_i], curProperName = pn.replace(/\s+/g, " ").split(" "), curProperName && (pn = inclines.findProperName(curProperName), pn && pn.found && properNames.push(pn));
    pnDict = {};
    for (_j = 0, _len2 = properNames.length; _j < _len2; _j++) p = properNames[_j], id = "" + (p.first_name || "") + "-" + (p.middle_name || "") + "-" + (p.surname || ""), pnDict[id] ? (pnDict[id].count += 1, (_ref2 = p.src, __indexOf.call(pnDict[id].src, _ref2) < 0) && pnDict[id].src.push(p.src)) : (pnDict[id] = p, pnDict[id].src = [ p.src ], pnDict[id].count = 1);
    return result.propernames = pnDict;
  };
}(exports, morpho, inclines);

var exports, inclines, __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) if (__hasProp.call(this, i) && this[i] === item) return i;
  return -1;
};

"undefined" == typeof global ? (window.lastName.plugins.ru.feelings = {}, exports = window.lastName.plugins.ru.feelings, inclines = window.lastName.plugins.ru.inclines) : (exports = module.exports, inclines = require("./inclines")), function(exports, inclines) {
  var evaluateSentenceNeutrality, getNegativePhrasesRe, negativeAdjectives, negativeVerbs, negativeWordsIncline;
  return exports.positive = [], negativeAdjectives = {
    "агрессивный": 3,
    "атакованный": 2,
    "бедный": 2,
    "беззащитный": 2,
    "безнадежный": 3,
    "безрадостный": 2,
    "бесплодный": 3,
    "беспомощный": 3,
    "бесправный": 2,
    "бессердечный": 1,
    "бессильный": 1,
    "бесцельный": 2,
    "бесчестный": 2,
    "вздорный": 1,
    "виновный": 1,
    "ворчливый": 1,
    "враждебный": 2,
    "вспыльчивый": 1,
    "выпученный": 1,
    "выселенный": 3,
    "высмеянный": 2,
    "выхолощенный": 1,
    "глубокий": 1,
    "глупый": 2,
    "горький": 2,
    "готический": 2,
    "гротескный": 1,
    "грустный": 1,
    "грязный": 1,
    "девальвированный": 2,
    "деградировавший": 2,
    "дегуманизированный": 2,
    "дезорганизованный": 2,
    "дезориентированный": 2,
    "деморализованный": 3,
    "дерзкий": 1,
    "дерьмовый": 3,
    "дефектный": 3,
    "драматический": 3,
    "жалкий": 3,
    "жесткий": 2,
    "жестокосердный": 2,
    "заброшенный": 1,
    "забываемый": 1,
    "забывчивый": 1,
    "забытый": 2,
    "зависимый": 1,
    "заинтересованный": 1,
    "запрещенный": 3,
    "запутанный": 2,
    "застенчивый": 1,
    "застрявший": 1,
    "затравленный": 2,
    "зверский": 3,
    "злобный": 2,
    "идиотский": 3,
    "измельченный": 2,
    "измученный": 2,
    "изнасилованный": 3,
    "изолированный": 3,
    "изумленный": 1,
    "интенсивный": 1,
    "иррациональный": 2,
    "исключенный": 2,
    "искусственный": 2,
    "испуганный": 2,
    "истерический": 3,
    "исчерпанный": 2,
    "капризный": 2,
    "контролируемый": 1,
    "критический": 1,
    "ленивый": 2,
    "лишенный": 2,
    "ложный": 2,
    "мазохистский": 1,
    "мертвый": 3,
    "меченый": 2,
    "мрачный": 2,
    "мстительный": 2,
    "навязчивый": 2,
    "надоедливый": 2,
    "наказанный": 2,
    "нарушенный": 2,
    "натянутый": 2,
    "неадекватный": 2,
    "неактивный": 1,
    "небезопасный": 2,
    "небрежный": 1,
    "невежественный": 1,
    "невидимый": 1,
    "невротический": 2,
    "негуманный": 2,
    "недействительный": 1,
    "недовольный": 2,
    "недостаточный": 1,
    "недоуменный": 1,
    "незаземленный": 1,
    "незначительный": 1,
    "неискренний": 1,
    "некомпетентный": 2,
    "ненавистный": 3,
    "необщительный": 2,
    "неполный": 2,
    "неправильный": 2,
    "неприятный": 2,
    "нервный": 2,
    "нерешительный": 1,
    "несбалансированный": 1,
    "несовместимый": 2,
    "несоответствующий": 2,
    "неспособный": 3,
    "несчастный": 2,
    "неуклюжий": 2,
    "неуловимый": 1,
    "неуместный": 2,
    "нечестный": 2,
    "неэффективный": 2,
    "низкий": 1,
    "обвиняемый": 3,
    "обедненный": 1,
    "обезумевший": 3,
    "обиженный": 2,
    "обманутый": 2,
    "обозленный": 2,
    "оборонительный": 1,
    "обремененный": 1,
    "обременительный": 1,
    "обреченный": 2,
    "ограниченный": 1,
    "одержимый": 3,
    "одинокий": 2,
    "одноразовый": 1,
    "озабоченный": 2,
    "окаменелый": 1,
    "онемелый": 1,
    "опальный": 2,
    "опасный": 3,
    "опустошенный": 1,
    "опущенный": 2,
    "опьяненный": 1,
    "оскорбленный": 2,
    "осмеянный": 2,
    "острый": 1,
    "осужденный": 3,
    "осушенный": 2,
    "ответственный": 2,
    "отвратительный": 3,
    "отдаленный": 1,
    "отдельный": 1,
    "отрицательный": 2,
    "отсталый": 2,
    "отчаянный": 1,
    "ошибочный": 1,
    "параноидальный": 2,
    "паршивый": 2,
    "пассивный": 1,
    "переполненный": 2,
    "пессимистический": 2,
    "печальный": 2,
    "побежденный": 3,
    "поверхностный": 2,
    "поврежденный": 3,
    "подавленный": 2,
    "поддельный": 3,
    "покинутый": 2,
    "покорный": 1,
    "порабощенный": 3,
    "потерянный": 2,
    "потерпевший": 2,
    "потребленный": 1,
    "презираемый": 2,
    "презренный": 3,
    "презрительный": 2,
    "прерванный": 1,
    "принудительный": 2,
    "психотический": 2,
    "пустынный": 1,
    "пьяный": 2,
    "равнодушный": 1,
    "развращенный": 3,
    "раздраженный": 2,
    "раздражительный": 2,
    "разочарованный": 2,
    "разочаровывающий": 3,
    "разрушенный": 3,
    "разрушительный": 2,
    "разъяренный": 3,
    "раненый": 2,
    "ревнивый": 2,
    "садистский": 2,
    "самоубийственный": 3,
    "саркастический": 1,
    "сварливый": 1,
    "сгоревший": 3,
    "сердитый": 2,
    "серый": 1,
    "скучающий": 1,
    "скучный": 1,
    "сломанный": 2,
    "смущенный": 1,
    "созерцательный": 1,
    "сомнительный": 2,
    "спорный": 2,
    "спровоцированный": 2,
    "спутанный": 2,
    "спущенный": 2,
    "стереотипный": 1,
    "стесненный": 1,
    "странный": 1,
    "страшный": 2,
    "сумасшедший": 2,
    "тихий": 1,
    "тормозящий": 2,
    "торопливый": 2,
    "тоскливый": 3,
    "требовательный": 2,
    "тревожный": 2,
    "трудный": 2,
    "трусливый": 2,
    "тупой": 1,
    "тщеславный": 2,
    "угнетенный": 2,
    "угрюмый": 2,
    "удаляемый": 2,
    "удрученный": 2,
    "ужасный": 3,
    "уклончивый": 2,
    "униженный": 3,
    "унылый": 3,
    "урезанный": 2,
    "фальшивый": 3,
    "хаотический": 2,
    "холодный": 1,
    "хрупкий": 1,
    "цепкий": 2,
    "циничный": 2,
    "чертовский": 2,
    "чрезмерный": 2,
    "чувствительный": 2,
    "эгоистичный": 2,
    "эгоцентричный": 3,
    "эксплуатируемый": 2,
    "эмансипированный": 2,
    "эмоциональный": 1,
    "яростный": 3
  }, negativeVerbs = {
    "беспокоить": 2,
    "бить": 2,
    "внушать": 2,
    "волноваться": 2,
    "высмеивать": 2,
    "грызть": 1,
    "диктовать": 2,
    "дребезжать": 1,
    "дрожать": 1,
    "дрогнуть": 2,
    "загнать": 2,
    "запугивать": 3,
    "запутаться": 2,
    "злоупотреблять": 2,
    "игнорировать": 1,
    "избегать": 1,
    "издеваться": 3,
    "изменять": 2,
    "командовать": 1,
    "лгать": 2,
    "лишить": 2,
    "манипулировать": 2,
    "молчать": 1,
    "надувать": 1,
    "ненавидеть": 3,
    "обвинять": 2,
    "обидеть": 2,
    "опорочить": 3,
    "освистать": 3,
    "отбрасывать": 1,
    "отвлекаться": 2,
    "отклонить": 2,
    "отрекаться": 3,
    "оттолкнуть": 2,
    "паниковать": 2,
    "перепутаться": 2,
    "подавить": 3,
    "подвергаться": 2,
    "пострадать": 2,
    "предавать": 3,
    "пренебрегать": 2,
    "препятствовать": 2,
    "преследовать": 2,
    "принижаться": 2,
    "приставать": 2,
    "прослушивать": 2,
    "разгромить": 2,
    "раздражаться": 2,
    "растаскивать": 2,
    "рисковать": 2,
    "ругать": 2,
    "сдуваться": 1,
    "смолчать": 2,
    "снизиться": 1,
    "сорвать": 1,
    "сожалеть": 2,
    "соизволить": 2,
    "солгать": 2,
    "сомневаться": 2,
    "споткнуться": 1,
    "столкнуться": 2,
    "страдать": 2,
    "стрелять": 3,
    "судить": 2,
    "толкнуть": 1,
    "убить": 3,
    "убивать": 3,
    "уговаривать": 1,
    "удалять": 2,
    "уклоняться": 2,
    "унижать": 3,
    "шантажировать": 2
  }, negativeWordsIncline = {
    "боль": 2,
    "вниз": 1,
    "горе": 3,
    "дно": 2,
    "мало": 1,
    "мучение": 2,
    "недовольство": 2,
    "плохо": 2,
    "противно": 3,
    "совестно": 2,
    "только": 1,
    "ужас": 3,
    "смерть": 3,
    "неодобрительно": 2,
    "разгром": 2,
    "отчаяние": 3
  }, exports.getNegativePhrasesRe = getNegativePhrasesRe = function() {
    return [ [ /[^а-яё]при\sотягчающих\sобстоятельствах[^а-яё]/ig, 2 ], [ /[^а-яё]ненависть\sк[^а-яё]/ig, 3 ], [ /[^а-яё]в\sубыток[^а-яё]/ig, 2 ], [ /[^а-яё]сыт[аы]?\sпо\sгорло[^а-яё]/ig, 3 ], [ /[^а-яё]заслужива[ею]т\sнаказания[^а-яё]/ig, 2 ], [ /[^а-яё]находящ(егося|ейся|емся|ихся)\sпод\sугрозой\sисчезновения[^а-яё]/ig, 3 ], [ /[^а-яё]в\sзаблуждение[^а-яё]/ig, 2 ], [ /[^а-яё]сбит[аы]?\sс\sтолку[^а-яё]/ig, 2 ], [ /[^а-яё]в\sужасе[^а-яё]/ig, 3 ], [ /[^а-яё]не\sрекоменд(ую|уем|уется|овал|овала|овали)[^а-яё]/ig, 2 ], [ /[^а-яё]не\sодобря(ю|ем|л|ла|ли|ется)[^а-яё]/ig, 2 ], [ /[^а-яё]пятно\sна[^а-яё]/ig, 2 ], [ /[^а-яё]в\sклетке[^а-яё]/ig, 1 ], [ /[^а-яё]неправильно\sпонял[аи]?[^а-яё]/ig, 2 ], [ /[^а-яё]вне\sпределов\sдосягаемости[^а-яё]/ig, 1 ], [ /[^а-яё]взял[аи]?\sна[^а-яё]/ig, 2 ], [ /[^а-яё]играл[аи]?\sс[^а-яё]/ig, 2 ], [ /[^а-яё]черный\sсписок[^а-яё]/ig, 3 ], [ /[^а-яё]возбужден[оы]\sуголовн(ое|ые)\sдел[оа][^а-яё]/ig, 8 ], [ /[^а-яё]жертв(|а|ы|ам|ами)[^а-яё]/ig, 3 ] ];
  }, exports.evaluateSentenceNeutrality = evaluateSentenceNeutrality = function(sentence) {
    var adj, adjArray, adjIndex, curWords, cur_index, ind, index, m, nr, resetCurIndex, vIndex, verb, words, wrd, _i, _j, _k, _len, _len2, _len3, _ref, _ref2;
    index = 0, cur_index = 0, words = [], curWords = [], _ref = getNegativePhrasesRe();
    for (_i = 0, _len = _ref.length; _i < _len; _i++) nr = _ref[_i], m = sentence.match(nr[0]), m && (m.map(function(wordsSequence) {
      return words.push(wordsSequence);
    }), index -= nr[1] * m.length);
    resetCurIndex = function() {
      if (cur_index) return index += cur_index, words.push(curWords), curWords = [], cur_index = 0;
    }, _ref2 = sentence.split(/\s/);
    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
      wrd = _ref2[_j];
      if (__indexOf.call(".,-—!?()[]", wrd) >= 0) {
        cur_index = -cur_index, resetCurIndex();
        continue;
      }
      ind = negativeWordsIncline[wrd.toLowerCase()];
      if (ind) curWords.push(wrd), cur_index = cur_index * ind || ind; else {
        adjArray = inclines.getInitialFormOfAdjective(wrd);
        if (!adjArray) verb = inclines.getVerbInfinitive(wrd), vIndex = negativeVerbs[verb], vIndex ? (curWords.push(wrd), cur_index = cur_index * vIndex || vIndex) : (cur_index = -cur_index, resetCurIndex()); else for (_k = 0, _len3 = adjArray.length; _k < _len3; _k++) {
          adj = adjArray[_k], adjIndex = negativeAdjectives[adj];
          if (adjIndex) {
            curWords.push(wrd), cur_index = cur_index * adjIndex || adjIndex;
            break;
          }
        }
      }
    }
    return resetCurIndex(-cur_index), [ index, words ];
  }, exports.postFilter = function(text, result) {
    var emoIndex, emoWords, i, index, overallIndex, s, _len, _ref, _ref2;
    emoIndex = [], overallIndex = 0, _ref = result.misc.sentences;
    for (i = 0, _len = _ref.length; i < _len; i++) s = _ref[i], _ref2 = evaluateSentenceNeutrality(s), index = _ref2[0], emoWords = _ref2[1], emoIndex.push([ index, emoWords ]), overallIndex += index;
    return result.feelings = {
      emoIndex: emoIndex,
      overallIndex: overallIndex,
      emoScore: overallIndex / result.counters.words_total || 1
    };
  };
}(exports, inclines);;